/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.xml.parser");

// Require the Clients
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
// Utilities
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

//Local widget
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.BlockingDefectsPopUp");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView");
dojo.require("jazz.app.context");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWISaveContext");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.OfflineInitializer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("jazz.ui.ResourceLink");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");

dojo.require("com.ibm.rqm.defects.web.client.internal.ResourceLinkService");
dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");
dojo.require("com.ibm.rqm.defects.web.helper.AutomationItemPicker");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.rqm.defects.web.client.internal.AutoIntegrationClient");
dojo.require("com.ibm.rqm.defects.web.helper.AutomationItemInstancePicker");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ExecutionAdminSettingsUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");

(function() {

var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var EWIMapper					= com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var ExecutionWorkItemClient 	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var UserClient 					= com.ibm.asq.common.web.client.internal.ContributorClient;
var TimeBoxClient				= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var Constants    				= com.ibm.rqm.planning.web.client.internal.Constants;
var Utility						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var PlanningUtility				= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ExecutionWorkItemTableView  = com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView;
var AlertDialog 				= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var DEFECT_URL                  = "#action=com.ibm.team.workitem.viewWorkItem&id=";
var GlobalEvents   				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BlockingDefectsPopUp		= com.ibm.rqm.execution.web.ui.internal.view.common.BlockingDefectsPopUp;
var ViewHeaderLayout            = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var EditorUtil                  = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ChangeRequestManager 		= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var ProgressDialog              = com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var Status                      = com.ibm.team.repository.web.foundation.Status;
var CmIntegrationClient 		= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;
var RelatedInfoPanel			= com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;
var GenerateEWISaveContext		= com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWISaveContext;
var PermissionsClient 			= com.ibm.asq.common.web.client.internal.PermissionsClient;
var ProgressUtility             = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;
var OfflineInitializer 			= com.ibm.rqm.execution.web.ui.internal.view.common.OfflineInitializer;
var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var MAX_EWI_FOR_RELATED_DEFECTS = 20;
var ExecutionPopUp				= com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp;
var ResourceLinkService			= com.ibm.rqm.defects.web.client.internal.ResourceLinkService;
var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
var AutomationItemPicker = com.ibm.rqm.defects.web.helper.AutomationItemPicker;
var ItemPickerUtil = com.ibm.rqm.defects.web.util.ItemPickerUtil;
var AutoIntegrationClient = com.ibm.rqm.defects.web.client.internal.AutoIntegrationClient;
var AutomationItemInstancePicker = com.ibm.rqm.defects.web.helper.AutomationItemInstancePicker;
var ExecutionAdminSettingsUtil	= com.ibm.rqm.planning.web.ui.internal.util.ExecutionAdminSettingsUtil;


dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList", [dijit._Widget, dijit._Templated,
						com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin, ExecutionAdminSettingsUtil],
		{
        templateString: '<div dojoAttachPoint="domNode"></div>',
		
		showArchived: false,
		plansReceived: 0,
		totalPlans: 0,
		contentIsVirtual: false,
        useTestPlanFilter: true,
        overrideRunOnOpenPref: false,
        tableId: null,
        
		constructor: function() {
            this.tableActions = [];
			this.catalog = null;
			this.ewis = null;
            this.relatedDefects = [];
			this.ewiSaveContextGroup = [];
			this.initPreferences();
		},
		
		//override RelatedInfoMixin methods
		getStaticRelatedInfo: function() {
			// This method is called only if this is a top level view in a tab and is selected.
			// It will not contribute to the related info area if it is embedded in a dialog or editor section.
			//
			if (!this._relatedInfo) {
				var relatedInfo = new RelatedInfoPanel();
				this._relatedInfo=relatedInfo;
				this._defectArea = relatedInfo.getInfoGroup(Constants.getMessage("labelBlockingDefects"), true);
				this._relatedDefectArea = relatedInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"), true);
			}
			this._hasRelatedInfoPane = true;
	        return this._relatedInfo;
	    },
	        
	    getStaticRelatedInfoId: function() {
	        return "com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList";
	    },
		
        getViewHeaderNode: function() {
            if (this._ewiTableViewer) {
                return this._ewiTableViewer.viewHeaderNode;
            }
        },

		postCreate: function() {		
			//if this will receive this.testCase
			if (this.testCase != null) {
				this._testCaseId = this.testCase.id;
			}
			this.initialize();
		},
		uninitialize: function(){
			if (this._relatedInfo){
				this._relatedInfo.destroyRecursive();
				this._relatedInfo = null;
			}
		},
		
		initialize: function(){
			Utility.isEnableAutomationItemColumnBySystemProperty(dojo.hitch(this, function(enabled){
				this.enableAutomationConsumer = enabled;
				this._preLoadCheck();			
	            if (this.showQueryFilters && this.parentController) {
	                this._showEWITable();
	            } else if (this._ewiTableViewer){
					this._ewiTableViewer.refresh(this.ewis, false);
				}
			}));
		},
		
		_preLoadCheck: function(){	
			//load EWIs based on parameters
			if (this.owner) {
				this._hasRelatedInfoPane = true;	
				//load EWIs for a specific Contributor
				this.queryTitle = Constants.getMessage("labelMyEWI");
				var args = {owner: this.owner};
				this._showEWITable();
				var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, args);							
			} else if (this.testCase) {
				//load EWIs for a specific Test Case
	            this.queryTitle = Constants.getMessage("labelMyEWI");
				this._showEWITable();
				var args = { 
				    testCaseItemId: this.testCase.versionableItemId,
					includeArchived: this.showArchived
				};
				args.includeArchived = this.testCase.archived;
				if(this.testCase.stateId)
					args.testcaseStateId  =  this.testCase.stateId;
				if(this.testCase.snapshotInfo && this.testCase.snapshotInfo.revision != null){
					args.testCaseRevision  =  this.testCase.snapshotInfo.revision;
					// snapshot of execution results are always archived. But snapshot for test cases are not archived
					args.includeArchived = true;
				}
	            var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
	            ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler,args);
         	} 
		 	else if(this.parentController){ // we get the parentController when in Execution perspective
		 	    // a parent constraint is specified. This is an embedded list and not
                // the top level query list.
		 	    if (this.parentItemIdArgName) {
                    this.queryTitle = this.name;
                    this._hasRelatedInfoPane = false;
                }
                else {
                    this._hasRelatedInfoPane = true;
                    //load ALL EWIs
                    this.queryTitle = this.name || Constants.getMessage("labelAllEWI");
                }
                if (!this.showQueryFilters) {
                    this._showEWITable();
                    var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
                    ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler);
                }
			}
			else{ // new test case creation so no EWIs
				this.queryTitle = Constants.getMessage("labelEWIs");
				this._showEWITable(null);
				this._setEWITableContent();
			}
			
			var resultStates = [];
			if(this.parentController && dojo.isFunction(this.parentController.getResultStatesHiddenExcluded)){
				resultStates= this.parentController.getResultStatesHiddenExcluded();
			}
			if(dojo.isArray(resultStates) && resultStates.length > 0){
				this._setResultStates(resultStates);
			}else{
				var registryResponseHandler = new ServiceResponseHandler(this, "_setResultStates", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient.getExecutionResultStates(registryResponseHandler, {
					includeHidden: false
				});
			}
		},
		_setResultStates:function(verdicts){
			this.verdicts = verdicts;
		},
        _showEWITable: function(name) {
			if(!this._ewiTableViewer){
	        	var args = {
                    ewiList: this,
                    // pass along the tableId if one is specified.
                    tableId: this.tableId,
                    page: this.page,
                    overrideRunOnOpenPref: this.overrideRunOnOpenPref,
                    showQueryFilters: this.showQueryFilters,
                    useTestPlanFilter: this.useTestPlanFilter,
	        		executionWorkItems: [],				
                    showInitLoadProgress: !this.showQueryFilters,
	        		executable: true,
	                queryName: name ? name : this.queryTitle,
	        		rowCheckListener: dojo.hitch(this, function(rowObject, state) {
                        this.toggleRunActions(rowObject, state);
                        this._updateRelatedInfo();
	                }),
	                actions: this.getTableActions(),
					parentSection: this.parentSection ? this.parentSection : null,
                    contentIsVirtual: this.contentIsVirtual,
                    filterQueryID: this.filterQueryID,
                    showExecStatus: this.showExecStatus,
                    showAspectView: this.showAspectView,
                    refreshCallback: dojo.hitch(this, "_updateRelatedInfo")
	        	};
				if(this.includeArchived == true){
					args.includeArchived = this.includeArchived;
				}
	            if (this.isEditorSection) {
	                args.showTestCase = this.showTestCase;
	                args.queryName = null;
	                args.editable = this.editable;
	            }
                if(this.showExplorer != undefined) {
                    args.showExplorer = this.showExplorer;
                }
                // pre-seeding the list with parent item name & id if they are specified
                // the list will be limiting the query to the parent item.
                if(this.parentItemIdArgName && this.parentVersionItemId) {
                    args.parentItemIdArgName = this.parentItemIdArgName;
                    args.parentVersionItemId = this.parentVersionItemId;
                }
                args.enableAutomationConsumer = this.enableAutomationConsumer;
	            this._ewiTableViewer = new ExecutionWorkItemTableView(args);
				if(!this.isEditorSection && !this.showQueryFilters)
					this._ewiTableViewer.setInProgress(Constants.getMessage("msgQueryTableList", args.queryName));
	            //display the table
	        	dojox.xml.parser.removeChildren(this.domNode);
    	    	this.domNode.appendChild(this._ewiTableViewer.domNode);	
        	}
        },
		
        // update action to update the page that is already in the selected tab in the front
        updatePage: function(actionArgs) {
            if (actionArgs.updateAction) {
                switch (actionArgs.updateAction) {
                    case "update-saved-query-selection":
                        var scope = actionArgs.sqScope;
                        var folder = actionArgs.sqFolder || null;
                        var itemId = actionArgs.sqItemId;
                        if (scope && itemId) {
                            this.updateSelectedSavedQuery(scope, folder, itemId);
                        }
                        break;
                    case "clear-filter-selection":
                        this.clearFilter();
                        break;
                    case "update-filters":
                        if ('testplanFilter' in actionArgs || 'milestoneFilter' in actionArgs) {
                            this.applyExternalFilters(actionArgs);
                        }
                        break;
                }
            }
        },

        applyExternalFilters: function(actionArgs){
            this.clearFilter();
            if (this._ewiTableViewer) {
                this._ewiTableViewer._applyExternalFilters(actionArgs);
            }
        },
        
        updateSelectedSavedQuery: function(scope, folder, itemId) {
            if (this._ewiTableViewer)
                this._ewiTableViewer.updateSelectedSavedQuery(scope, folder, itemId);
        },

        clearFilter: function() {
            if (this._ewiTableViewer)
                this._ewiTableViewer.clearFilter();
        },
        
        clearSelectedItems: function() {
        	if (this._ewiTableViewer)
        		this._ewiTableViewer.clearSelectedItems();
        },
    
		_dispatchDefectsManagerInitialized: function(initializedCallback, uninitializedCallback){
			ChangeRequestManager.getInstance().getServiceProviders(dojo.hitch(this, function(providers){
                if (providers != null && providers.length > 0){
					initializedCallback(providers);
				} else {
					uninitializedCallback();
				}
            }));
		},
      
	  	_setEWITableContent: function(ewis) {
			this.ewis = ewis ? ewis : [];
			
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelQueryAssociatedBlockingDefects"), dojo.hitch(this, function(monitor){
				var ewis = this.ewis;
				var itemIdOrUriArray = [];
				var len = ewis.length;
				for (var i = 0; i < len; i++) {
					itemIdOrUriArray.push(ewis[i].itemId);
				}
				var workItemIdentification = {
					linkType: CmIntegrationClient.EWI_BLOCKING_DEFECT,
					isExecutionResultRelated: false,
					itemIdOrUriArray: itemIdOrUriArray
				};
				var linkParams = {
					itemIdArray: itemIdOrUriArray,
					linkType: AutoIntegrationClient.TER_RUNS_ON_DEPLOYMENT
				};
				CmIntegrationClient.postAssociatedWorkItems(workItemIdentification, dojo.hitch(this, function(status, response){
					
					if (status.isOK()) {
						dojo.forEach(this.ewis, dojo.hitch(this, function(ewi){
							var defects = [];
							if (dojo.isArray(response)) {
								dojo.forEach(response, dojo.hitch(this, function(workItem){
									if (workItem.stateGroup != "closed") {
										workItem.isBlocking = true;
									}
									if (ewi.itemId == workItem.sourceItemId) {
										defects.push(workItem);
									}
								}));
							}
							ewi.defects = defects;
						}));
						this._ewiTableViewer.refresh(this.ewis, true, true);
						/*if (!this.isEditorSection) 
							this._ewiTableViewer.stopInProgress();*/
					}
					else 
						if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
							status.log();
						}
				}));
				
				AutoIntegrationClient.getReferencedAutoLinksInBatch(linkParams, dojo.hitch(this, function(status, result){
					monitor.done();
					if(status.isOK()){
						for(var step = 0; step < this.ewis.length; step++){
							if(result[step] && result[step].autoLinkReference){
								this.ewis[step].virtualService = result[step].autoLinkReference[0];
							}
						}
						this._ewiTableViewer.refresh(this.ewis, true, true);
						if (!this.isEditorSection) 
							this._ewiTableViewer.stopInProgress();
					}
					else 
						if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
							status.log();
						}
				}));
			}));
		
		},
		
		runCommitChangesViaProviderWithProgress: function(ewis, addedDefects, removedDefects){
			ProgressDialog.doRunWithProgress("", dojo.hitch(this, function(monitor){
				if(!monitor.isCancelRequested())
							this.commitChangesViaProvider(ewis, addedDefects, removedDefects, monitor);
			}), true);
		},
		
		commitChangesViaProvider: function(ewis, addedDefects, removedDefects, monitor){
			//batch create the back links to the added defects
			var associateDefectWithTERs = dojo.hitch(this, function(callback){
				/* In case there are many defects belonging to different providers, so separate to use different provider for update
				 *  Example of providers object: 
				 *	{
				 *		<provider uri>: {
				 *				url: <url>,
				 *				...,
				 *				defects: []			
				 *		}
				 *	}
				 */
				var providers = {};
				dojo.forEach(addedDefects, function(def){
					var provider = def.provider;
					if(provider){
						if(providers[provider.url]){
							providers[provider.url].defects.push(def);
						}else{
							provider.defects = [def];
							providers[provider.url] = provider;
						}
					}
				});
				var requestByProviderCounter = 0;
				for(var i in providers){
					requestByProviderCounter++;
				}
				
				for(var i in providers){
					var currentProvider = providers[i];
					currentProvider.doBlockingTestExecutionRecordInBatch(ewis, currentProvider.defects, dojo.hitch(this, function(){
						requestByProviderCounter--;
						//using monitor.isCancelRequested() to judge if the progress is canceled by user 
						if(requestByProviderCounter == 0 && !monitor.isCancelRequested()){
							//create the ter link to defects 
							postLinkToTERs(ewis, addedDefects, callback);
						}
					}),dojo.hitch(this, function(status, response){
						this._displayAlertDialog(status.getMessage() || response);
						monitor.done();
						console.debug("failed to create block test execution record back link");
					}));
				}
			});
			
			//Post local link to TER
			var postLinkToTERs = dojo.hitch(this, function(ewis, addedDefects, callback){
					var itemIds = [];
					var cmUris = [];
					var cmSummaries = [];
					dojo.forEach(ewis, function(ewi){
						itemIds.push(ewi.itemId);
					});
					dojo.forEach(addedDefects, function(def){
						cmUris.push(def.url || def.uri);
						cmSummaries.push(def.summary);
					});
					var linkParams = {
						itemIds: itemIds,
						cmUris: cmUris,
						cmSummaries: cmSummaries,
						cmIds: [],
						linkType: CmIntegrationClient.EWI_BLOCKING_DEFECT,
						isPostRequiredForArtifact: true,
						createRelatedLinks: true
					};
//						if(workItem.providerProjectKey){
//							linkParams.providerProjectKey = workItem.providerProjectKey;
//						}
					CmIntegrationClient.postNewLinkInBatch(linkParams, dojo.hitch(this, function(status){
						if(status.isOK()){
							if(!monitor.isCancelRequested()){
								if(callback){
									callback();
								}else{
									this._setEWITableContent(this.ewis);
									monitor.done();
								}
							}
						}else {
							this._displayAlertDialog(status.getMessage());
							monitor.done();
						}
	                }));
			});
			
			
            //remove blocking back link from defect
			var unassociateDefectWithTERs = dojo.hitch(this, function(){
				//prepare the providers object as in associateDefectWithTERs() method
					var providers = {};
					var removedDefectsWithProvider = [];
					var removedDefectsNoProvider = [];
					dojo.forEach(removedDefects, function(def){
						var provider = def.provider;
						if(provider){
							if(providers[provider.url]){
								providers[provider.url].defects.push(def);
							}else{
								provider.defects = [def];
								providers[provider.url] = provider;
							}
							removedDefectsWithProvider.push(def);
						} else {
							removedDefectsNoProvider.push(def);
						}
					});
					var requestByProviderCounter = 0;
					for(var i in providers){
						requestByProviderCounter++;
					}
					for(var i in providers){
						var currentProvider = providers[i];
						currentProvider.doUnBlockingTestExecutionRecordInBatch(ewis, currentProvider.defects, dojo.hitch(this, function(status, response){
							requestByProviderCounter--;
							if(requestByProviderCounter == 0 && !monitor.isCancelRequested()){
								//delete the blocking link from ter to defect
								deleteLinkToTERs(removedDefectsWithProvider);
							}
		                }), dojo.hitch(this, function(status, response){
							this._displayAlertDialog(status.getMessage() || response);
							monitor.done();
							console.debug("failed to remove block test execution record back link");
						}));
					}
					//To handle the case of unblocking defects that have a provider that is not among the currently configured providers
					// In such a case, need to throw up a dialog indicating back links won't be deleted.
					if(removedDefectsNoProvider.length > 0) {
						var args = {
						        'primaryTitle': Constants.getMessage("labelConfirmation"),
		                		'message': Constants.getMessage("msgCMBackLinksNotDeleted"),
		                		'yesCallback': dojo.hitch(this, function () {
									deleteLinkToTERs(removedDefectsNoProvider);
								}),
								'noCallback': dojo.hitch(this, function() {
									if(monitor) {
										monitor.done();
									}
								})
		            		};
		            		var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
		            		confirmDialog.open();
						
					}
			});

			//remote local blocking link to defect
			var deleteLinkToTERs = dojo.hitch(this, function(pRemovedDefects){
					var ewiItemIds = [];
					var defectURIs = [];
					dojo.forEach(ewis, function(ewi){
						ewiItemIds.push(ewi.itemId);
					});
					dojo.forEach(pRemovedDefects, function(def){
						defectURIs.push(def.uri || def.url);
					});
					var draftLinkParams= {
						defectURIs: defectURIs,
						ewiItemIds: ewiItemIds,
						isBlocked: false,
						isPostRequiredForArtifact: true
					};
					
					CmIntegrationClient.postBlockDefectInBatch(draftLinkParams, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
		                if (status.isOK()) {
							if(!monitor.isCancelRequested()){
								this._setEWITableContent(this.ewis);
								monitor.done();
							}
		                }
		                else 
		                    if (status.getSeverity() != Status.CANCEL) {
		                        status.log();
								this._displayAlertDialog(status.getMessage());
								monitor.done();
		                    }
		            }));
			});
			if(addedDefects.length){
				monitor.beginTask(Constants.getMessage("labelAssociateDefect"));
				if (removedDefects.length) {
					associateDefectWithTERs(dojo.hitch(this, function(){
				    	monitor.beginTask(Constants.getMessage("labelUnassociateDefect"));
						unassociateDefectWithTERs();
					}));
				} else {
					associateDefectWithTERs(null);
				}
			} else if (removedDefects.length) {
				monitor.beginTask(Constants.getMessage("labelUnassociateDefect"));
				unassociateDefectWithTERs();
			}
		},
				
        getTableActions: function() {    
            var actions = [];       
            var ewi_type = PermissionsClient.OP_EXECUTION_EWI;
            var ewi_perm = PermissionsClient.getStoredPermission(ewi_type);

            var _isEnabledMultiSelectNonEditCallback = dojo.hitch(this,function(selectionCount, archivedCount, snapshotCount){
                return !this._ewiTableViewer.inEditMode && archivedCount == 0 && snapshotCount == 0;
            });


            if (!ewi_perm || ewi_perm.edit) {
				actions.push({
                    rowAction: true,
                    isVisibleCallback: _isEnabledMultiSelectNonEditCallback,
	                actionId: "unblock",
                    label: Constants.getMessage("menuBlockingDefects"),
                    labelMultiple: Constants.getMessage("menuBlockingDefectsMultiple"),
	                actionHandler: dojo.hitch(this, "onUnBlock"),
	                iconClass: "change-blocked-defect-status-icon-image",
	                disabled: true
	            }); 
				actions.push({
					rowAction: true,
                    isVisibleCallback: dojo.hitch(this,function(selectionCount, archivedCount, snapshotCount){ 
                    					return !this._ewiTableViewer.inEditMode && archivedCount == 0 && snapshotCount == 0 
                    								&& this.enableAutomationConsumer; 
                    					}),
	                actionId: "manageVS",
                    label: Constants.getMessage("menuManageDeploymentService"),
                    labelMultiple: Constants.getMessage("menuManageDeploymentServicesMultiple"),
	                actionHandler: dojo.hitch(this, "onManageVirtualService"),
	                iconClass: "manage-virtual-services-icon-image",
	                disabled: true
			});
            } 
            if (this.tableActions) {
                actions = actions.concat(this.tableActions);
            }
            
            if (!this.showQueryFilters) {
                actions.push({
                    actionId: "refresh",
                    label: Constants.getMessage("labelRefreshEWI"),
                    actionHandler: dojo.hitch(this, "onRefresh"),
                    iconClass: "refresh-icon-image",
                    disabled: false
                });
            }
            return actions;
        },
		
		addEwiSaveContext: function(args){
			var saveContext = new GenerateEWISaveContext(args);
			this.ewiSaveContextGroup.push(saveContext);
		},
		
		addNewGeneratedEwis: function(newEwis){
			var ewiTableViewer = this._ewiTableViewer;
			this.ewis = this.ewis.concat(this._formatEwis(newEwis));
			ewiTableViewer.refresh(this.ewis, true);
        },
        
        hasGeneratedEwisToSave: function() {
        	return this.ewiSaveContextGroup && this.ewiSaveContextGroup.length > 0;
        },
		
		createGeneratedEwis: function(callback){
			if(this.ewiSaveContextGroup) {
				var ewiSaveContextGroup = this.ewiSaveContextGroup;
				var length = ewiSaveContextGroup.length;
				var counter = 0;
				if (length){
					for(var i = 0; i < length; i++){
						ewiSaveContextGroup[i].commit({
							callback: dojo.hitch(this, function(err){
								counter++;
                                if(err) {
                                    if(!this.errMsgs) {
                                        this.errMsgs = [];
                                    }
                                    this.errMsgs.push(err);
                                }
								if(counter == length) {
									this.ewiSaveContextGroup = [];
                                    var msgs = this.errMsgs ? this.errMsgs.join("</br>") : null;
									callback(msgs);
								}
							})
						});
					}
				} else {
					callback();
				}
			}
		},
		
		_formatEwis: function(generatedEwis){
			var formatedEwis = [];
			var length = generatedEwis.length;
			var time = new Date().getTime();
			for(var i = 0; i < length; i++){
				var ewi = generatedEwis[i];
				formatedEwis.push({
					isNew: true,
					config: {
						id: ewi.config.id,
						name: ewi.config.name
					},
					configId: ewi.testConfigId,
					configName: ewi.testConfigName,
					configuration:ewi.config.id,
					defects: [],
					id: ewi.id,
					itemId: null,
					modified: time,
					name: ewi.name,
					owner: ewi.owner,
					teamArea: ewi.teamArea,
					ownerName: ewi.owner.name,
					ownerUserId: ewi.owner.userId,
					risk: "",
					selectedScriptId: -1,
					stateId: null,
					testCase: null,
					testCaseId: ewi.testCaseId,
					testCaseName: ewi.testCaseName,
					testCaseVersionableItemId: null,
					weight: ewi.weight,
					estimate: ewi.estimate,
					executionPriority: ewi.executionPriority,
					testPlan: ewi.parentTestPlan,
					phase: ewi.testPhase,
                    categories: ewi.categories,
					customAttributes: ewi.customAttributes
				});
			}
			return formatedEwis;
		},
		
		
        _getSortedDefectList:function(defectList){
			if(defectList){
				defectList.sort(function(defect1,defect2){
					var id1 = parseInt(defect1.id, 10);
					var id2 = parseInt(defect2.id, 10);
					id1 = isNaN(id1) ? -1 : id1;
					id2 = isNaN(id2) ? -1 : id2;
					return id2-id1;  //if id2 is greater than id1 return positive 
				});
			}
            return defectList;
        },
		_fixDefectInfo:function(defects){
			var defectList = [];
			if(defects){
				var len = defects.length;
				for(var i=0;i<len;i++){
					if(defects[i].workItem){
		                var defect = defects[i].workItem;
		                var defectId = "";
		                var defectStatus = Constants.getMessage("labelUnknown");
						var defectStatusId = 1;
		                var defectSummary = "";
						var blocking = false;
						if (defect.attributes) {
							var len2 = defect.attributes.length;
			                for(var j=0;j<len2;j++){
								var attr = defect.attributes[j]; 
								switch (attr.key)
								{
									case "id":
										defectId = attr.value.id;
										break;
									case "summary":
										defectSummary = attr.value.content;
										break;
			                        case "internalState":
			                            defectStatus = attr.value.label;
										defectStatusId = parseInt(attr.value.id,10);
			                            break;
								}
							}
						}
						if(defectStatusId != 5 && defectStatusId != 3)//id 5 corresponds to Closed, 3 corresponds to resolved
							blocking = true;
						defectList.push({id:defectId,status:defectStatus,summary:defectSummary,statusId:defectStatusId,isBlocking:blocking});
					}else if(defects[i].id){
						if(defects[i].statusId && defects[i].statusId != 3 && defects[i].statusId != 5){
							defects[i].isBlocking = true;
						}
						defectList.push(defects[i]);
					}
				}
			}
			return defectList;
		},	 
		_updateRelatedInfo: function(){
			var ewis = this._ewiTableViewer.getSelectedEWIs();
			var ewiCount = ewis.length;
			if(this._relatedInfo && this._hasRelatedInfoPane == true){
				this._defectArea.clearActionsNode();
                this._relatedDefectArea.clearActionsNode();
            }
			
			ChangeRequestManager.getInstance().getServiceProviders(dojo.hitch(this, function(providers){
				var hasProvider = false;
				if (providers != null && providers.length > 0) {
					hasProvider = true;
				}
			if(ewiCount <= MAX_EWI_FOR_RELATED_DEFECTS) {
				if( this._relatedInfo && this._hasRelatedInfoPane == true) {
					this._defectArea.clearMessage();
					this._relatedDefectArea.clearMessage();
				}
			}
			if (ewiCount >= 1 && ewiCount <= MAX_EWI_FOR_RELATED_DEFECTS) {
				// update blocking defects
				var unSortedDefects = hasProvider ? this._getDefectsFromEwisViaProvider(ewis) : this._getDefectsFromEwis(ewis);
				var unSortedDefectsLen = unSortedDefects ? unSortedDefects.length : 0;
				this.blockingDefects = [];
				for (var i = 0; i < unSortedDefectsLen; i++) {
					var defect = unSortedDefects[i];
					if (defect.isBlocking) {
						this.blockingDefects.push(defect);
					}
				}
				this.blockingDefects = this._getSortedDefectList(this.blockingDefects);
				var blockingDefects = this.blockingDefects;
				if (blockingDefects && blockingDefects.length > 0 &&
				this._relatedInfo &&
				this._hasRelatedInfoPane == true) {
					//this will eventually grow too big. Limiting to last MAX_INFO_PANEL_DEFECTS
					var length = blockingDefects.length;
					if (length > Constants.MAX_INFO_PANEL_DEFECTS) {
						length = Constants.MAX_INFO_PANEL_DEFECTS;
					var messageArgs = {
						summary: Constants.getMessage("msgMaxDefectsInPanel", Constants.MAX_INFO_PANEL_DEFECTS, blockingDefects.length)
					};
						this._defectArea.showMessage(messageArgs);
					} else  {
						this._defectArea.clearMessage();
					}
					for (var j = 0; j < length; j++) {
						var defectText = this._truncateDefectLabel(blockingDefects[j]);
						var defectUrl = blockingDefects[j].uri ? blockingDefects[j].uri : (DEFECT_URL + blockingDefects[j].id);
						
						if (hasProvider) {
							var link = this._relatedInfo.addLink(Constants.getMessage("labelBlockingDefects"), "", defectUrl, null, true);
							var resourceLinkArgs = {
								uri: blockingDefects[j].uri,
								presentationUri: blockingDefects[j].uri,
								label: defectText
							};
							new jazz.ui.ResourceLink(resourceLinkArgs, link);
						} else {
							this._relatedInfo.addLink(Constants.getMessage("labelBlockingDefects"), defectText, defectUrl);
						}
					}
				}
				
				// update related defects
				if (hasProvider) {
					this._addRelatedExternalInfo();
				} else {
					this._addRelatedInfo();
				}
			} else if (ewiCount > MAX_EWI_FOR_RELATED_DEFECTS && this._relatedInfo && this._hasRelatedInfoPane == true) {
					var messageArgs = {
					summary: Constants.getMessage("msgMaxTERsSelected",MAX_EWI_FOR_RELATED_DEFECTS),
	            	details: Constants.getMessage("msgReferToReportForDetails")
				};	
					this._defectArea.showMessage(messageArgs);
					this._relatedDefectArea.showMessage(messageArgs);
				}
			
			}));		
		},
		
        _addRelatedInfo: function() {
            var ewis = this._ewiTableViewer.getSelectedEWIs();
            if (ewis.length >= 1) {
				var ewiUuids = [];
				var ewiStates = [];
				var len = ewis.length;
				for (var i = 0; i < len; i++) {
					ewiUuids.push(ewis[i].itemId);
					ewiStates.push(ewis[i].stateId);
				}
                var responseHandler = new ServiceResponseHandler(this, "_addrelatedDefectsInfo", "_getRelatedDefectsError");
                ExecutionWorkItemClient.getRelatedDefectsFromMultipleEWIs(responseHandler, {uuid_ewis: ewiUuids, ewiStateIds: ewiStates});
            }
        },
        
        _getRelatedDefectsError: function(errorObj){
            if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
                this._relatedDefectArea.clearActionsNode();
            }
			this._error(errorObj);
        },

        _addrelatedDefectsInfo: function(relatedDefectsArray) {
            if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
                this._relatedDefectArea.clearActionsNode();
            }
            if(!relatedDefectsArray) {
                return;
            }

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];
			var len = relatedDefectsArray.length;
			for (var i = 0; i < len; i++) {
                if (relatedDefectsArray[i].defectsByTestScript && dojo.isArray(relatedDefectsArray[i].defectsByTestScript)) {
					var len2 = relatedDefectsArray[i].defectsByTestScript.length;
                    for (var j = 0; j < len2; j++) {
						var workitemId = relatedDefectsArray[i].defectsByTestScript[j].workItem.itemId;
						allRelatedDefects[workitemId] = relatedDefectsArray[i].defectsByTestScript[j];
					}
				}
                if (relatedDefectsArray[i].defectsByTestCase && dojo.isArray(relatedDefectsArray[i].defectsByTestCase)) {
					var len3 = relatedDefectsArray[i].defectsByTestCase.length;
					for (var k = 0; k < len3; k++) {
						var workitemId = relatedDefectsArray[i].defectsByTestCase[k].workItem.itemId;
						allRelatedDefects[workitemId] = relatedDefectsArray[i].defectsByTestCase[k];
					}
				}
			}
            for (var key in allRelatedDefects) {
				defects.push(allRelatedDefects[key]);
			}

            // limit the number of display items
            var length = defects.length;
			var relatedDefectsDetails = [];
            for (var i = 0; i < length; i++) {
                // extract the attributes needed
                var defectAttr = defects[i].workItem.attributes;
                var id = null;
                var summary = null;
                var state = null;
				var len4 = defectAttr.length;
                for (var j = 0; j < len4; j++) {
                    switch (defectAttr[j].key) {
                        case "id":
                            id = defectAttr[j].value.id;
                            break;
                        case "summary":
                            summary = defectAttr[j].value.content;
                            break;
                        case "internalState":
                            state = defectAttr[j].value.label;
                            break;
                    }
                    if (id && summary && state) {
                        // break out if we get all attributes that we need
                        break;
                    }
                }

                // skip the defect if it is already one of the blocking defects
                if (this.blockingDefects && dojo.isArray(this.blockingDefects)) {
                    var skipAlreadyAdded = false;
					var blockingDefects = this.blockingDefects;
					var len = blockingDefects.length;
                    for (var k = 0; k < len; k++) {
                        if (blockingDefects[k].id == id) {
                            skipAlreadyAdded = true;
                            break;
                        }
                    }
                    if (skipAlreadyAdded) {
                        continue;
                    }
                }
                if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
	                if (this.relatedDefects.length > Constants.MAX_INFO_PANEL_DEFECTS) { 
	                    break;
					}
            	}
                this.relatedDefects.push(defects[i]);
				relatedDefectsDetails.push({
							summary:summary, 
							id:id, 
							state: state});
			}
			if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
				if (relatedDefectsDetails.length > Constants.MAX_INFO_PANEL_DEFECTS) {
					length = Constants.MAX_INFO_PANEL_DEFECTS;
					var messageArgs = {
						summary: Constants.getMessage("msgMaxDefectsInPanel", Constants.MAX_INFO_PANEL_DEFECTS, defects.length)
					};
					this._relatedDefectArea.showMessage(messageArgs);
				}
				else {
					length = relatedDefectsDetails.length;
					this._relatedDefectArea.clearMessage();
				}
			}
			
				for(var i=0; i< length; i++) {
					var summary = relatedDefectsDetails[i].summary;
					var id = relatedDefectsDetails[i].id;
					var state = relatedDefectsDetails[i].state;
                // add defect to the related defects panel
                if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
                    var defectText = "";
                    if (summary.length > 20) 
                        defectText = id + " : " + summary.substr(0, 15) + "... - " + state;
                    else 
                        defectText = id + " : " + summary + " - " + state;
                    var defectUrl = DEFECT_URL + id;
                    this._relatedInfo.addLink(Constants.getMessage("labelRelatedDefects"), defectText, defectUrl);
                }
            }
			this._addRelatedExternalInfo();
        }, 
		
		_addRelatedExternalInfo: function(){
			var ewis = this._ewiTableViewer.getSelectedEWIs();
            if (ewis.length >= 1) {
				var ewiItemIdArray = [];
				var len = ewis.length;
				for (var i = 0; i < len; i++) {
					var ewi = ewis[i];
					if(!ewi.isNew)
						ewiItemIdArray.push(ewi.itemId);
				}
                CmIntegrationClient.getReferencedDefectsFromMultipleEWIs({ewiItemIdArray: ewiItemIdArray}, dojo.hitch(this, function(status, result){
					if(status.isOK()){
						this._addRelatedExternalDefectsInfo(result);
					}else{
						this._getRelatedDefectsError(result);
					}
				}));
            }
		},
		
		_addRelatedExternalDefectsInfo: function(relatedDefectsArray){
            if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
			    this._relatedDefectArea.clearActionsNode();
            }
            if(!relatedDefectsArray) {
                return;
            }

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];
			var len = relatedDefectsArray.length;
			for (var i = 0; i < len; i++) {
				allRelatedDefects[relatedDefectsArray[i].uri] = relatedDefectsArray[i];
			}
            for (var key in allRelatedDefects) {
				defects.push(allRelatedDefects[key]);
			}

            // limit the number of display items
            var length = defects.length;
            for (var i = 0; i < length; i++) {
                // skip the defect if it is already one of the blocking defects
				var blockingDefects = this.blockingDefects;
                if (blockingDefects && dojo.isArray(blockingDefects)) {
                    var skipAlreadyAdded = false;
					var len2 = blockingDefects.length;
                    for (var k = 0; k < len2; k++) {
                        if (blockingDefects[k].uri == defects[i].uri) {
                            skipAlreadyAdded = true;
                            break;
                        }
                    }
                    if (skipAlreadyAdded) {
                        continue;
                    }
                }
				
                this.relatedDefects.push(defects[i]);
				if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
	                if (this.relatedDefects.length > Constants.MAX_INFO_PANEL_DEFECTS) { 
	                    break;
					}
            	}
				
			}
			var relatedDefectsLocal = this.relatedDefects;
			if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
				if (relatedDefectsLocal.length > Constants.MAX_INFO_PANEL_DEFECTS) {
					length = Constants.MAX_INFO_PANEL_DEFECTS;
					var messageArgs = {
						summary: Constants.getMessage("msgMaxDefectsInPanel", Constants.MAX_INFO_PANEL_DEFECTS, defects.length)
					};
					this._relatedDefectArea.showMessage(messageArgs);
				}
				else {
					length = relatedDefectsLocal.length;
					this._relatedDefectArea.clearMessage();
				}
			}
			
			for( var i=0; i < length; i++) {
				var relatedDefect = relatedDefectsLocal[i];
                // add defect to the related defects panel
                if (this._relatedInfo && (this._hasRelatedInfoPane == true) && !this.isEditorSection) {
				    var defectText = this._truncateDefectLabel(relatedDefect);
				    var link = this._relatedInfo.addLink(Constants.getMessage("labelRelatedDefects"), defectText, relatedDefect.uri, null, true);
				    var resourceLinkArgs= { 
						uri: relatedDefect.uri,
						presentationUri: relatedDefect.uri,
						label: ""
					};
				    new jazz.ui.ResourceLink(resourceLinkArgs, link);
                }
            }
		},    
        
		toggleRunActions: function(ewi, state) {
		    
		    if (!this._ewiTableViewer.executeOption) return; // do nothing if actionProvider in use
		    
            var showResume = state && Utility.isPaused(ewi ? ewi.currentResult : null);
			var selectedEWIs = this._ewiTableViewer.getSelectedEWIs();
			var selectedEWIsLength = selectedEWIs.length;
			if(selectedEWIsLength != 1){
				showResume = false;
				if(selectedEWIsLength > 0){
					// In Multiselection, enable only Offline Execution and 
					// execute without execution
					this._ewiTableViewer.offlineExecuteAction.set('disabled', false);
					this._ewiTableViewer.executeOption.set('disabled', true);
					this._ewiTableViewer.resumeAction.set('disabled', true);
					this._ewiTableViewer.runWithoutExecutionAction.set('disabled', false);
					this._ewiTableViewer.runWithOptionseAction.set('disabled', true);
				}
			}else{//In case of single TER selection
				this._ewiTableViewer.executeOption.set('disabled', false);
				this._ewiTableViewer.runWithoutExecutionAction.set('disabled', false);
				if (selectedEWIs[0].selectedScriptId != "-1") {
					var scripts = selectedEWIs[0].testCase.scripts;
					var len = scripts ? scripts.length : 0;
					for (var i = 0; i < len; i++) {
						if(scripts[i].versionableItemId == selectedEWIs[0].selectedScriptId){
							if(scripts[i].scriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual"){
								this._ewiTableViewer.offlineExecuteAction.set('disabled', false);
							}else{
								this._ewiTableViewer.offlineExecuteAction.set('disabled', true);
							}
						}
					}
					
					this._ewiTableViewer.runWithOptionseAction.set('disabled', false);
				}else{
					this._ewiTableViewer.offlineExecuteAction.set('disabled', true);
					this._ewiTableViewer.runWithOptionseAction.set('disabled', true);
				}
			}
			if(this._ewiTableViewer.resumeAction){
				if (showResume){
					this._ewiTableViewer.resumeAction.set('disabled', false);
				}else{
					this._ewiTableViewer.resumeAction.set('disabled', true);
				}
			}
					
		},
		
        getConfiguration: function(ewi) {
         if (ewi.configuration) {
				if (!ewi.config) {
					var self = this;
					var callbackObj = {
						success: function(config){
							self._createCatalog(ewi,config);
						},
						failure: function(e){
							self.error(e);
						}
					};
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
                    var config = new com.ibm.rational.test.lm.web.client.internal.config(); 
					config.retrieveConfigurationWithDetails(responseHandler, ewi.configuration);
				} else {
					this._createCatalog(ewi, ewi.config);
				}
         } else {
			ewi.configurationText = Constants.getMessage("labelNotConfig");
			this._ewiTableViewer.addConfigurationInfo(ewi.id, Constants.getMessage("labelNotConfig"));
         }			
		},
		
		_createCatalog: function(ewi,config){	
		   this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         //initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig(ewi,config);
					},
					failure: function(e){
						self._error(e);
					}
				};
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
			} else {
				this._setConfig(ewi,config);
			}
		},
		
		_setConfig: function(ewi,config){
			this._ewiTableViewer.addConfigurationInfo(ewi.id, config);
		},
		
		validateStateForExecution: function(testcase) {
			return true;
		},
		
		onExecute: function(updateVariables, channelId){
			if(this._isNewEWIChecked()){
				this._promptForSaveNewEWI();
				return;
			}
			//Only execute the first selected EWI.  Convert to Single Select table mode once available (See RQM WI: 1664)
			var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;						
         	if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIExe"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIExe"));
	            return;
         	}	
			var ewi = selectedEWIs[0];
			if(!this.validateStateForExecution(ewi.testCase)){
				return;
			}
			// check if this ewi is associated with automation plans. If so, show automation selection dialog
			var oslcVersion = "2.0";
            var ewiResourceUri = Utility._getEWIResourceUri(ewi);
            var __self = this;
			ResourceLinkService.getRunsOnDeploymentLink(oslcVersion, ResourceLinkService.TAG_EXECUTIONRECORD, ewiResourceUri, function(result){
				if(result && result.length>0){
					ResourceLinkService.getOSLCResouceContent(result[0].uri || result[0].url, function(status1, autoPlan){
					 	if (status1.isOK()) {
					 		var serviceProviderManager = Utility.getServiceProviderManager();
							serviceProviderManager.getServiceProviderByUrl(autoPlan.serviceProvider, function(serviceProvider){
								if(serviceProvider){							
									Utility.addSelectedAutomationItemInst(serviceProvider, result[0], function(resources, option){
						            	if(option == AutomationItemInstancePicker.NEW_INSTANCE){
						            		if(resources && resources.length>0){
						            			ProgressDialog.doRunWithProgress("", function(monitor){
			            							monitor.beginTask(DefectsUIUtil.getMessage("msgAboutToGetDeploymentForExecution"));					     
							            			ResourceLinkService.getAutomationResultByRequest(serviceProvider.servicesUrl,
							            				resources[0].url,
							            				function(status, autoResults){
														 	if (status.isOK()) {
														 		monitor.done();
																__self.selectedAutoResults = autoResults;												
																if(__self.selectedAutoResults && __self.selectedAutoResults.length>0){
																	PlanningUtility.checkAutomationResultCompleteness(__self.selectedAutoResults, 
																							  function(){
																							  		__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
																							  });					
																}
																else{
																	// auto result not available, ask user whether wish to continue without deployment
																	PlanningUtility.performErrorHandlingConfirmation(DefectsUIUtil.getMessage("msgNewAutoResultNotAvailable"),
																		function(){
																			__self.selectedAutoResults = [];												            					
											            					__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
																	    },
																	    this, null, null);
																}
															}
															else {
																monitor.done();										
																// auto result not available, ask user whether wish to continue without deployment
																PlanningUtility.performErrorHandlingConfirmation(DefectsUIUtil.getMessage("msgNewAutoResultNotAvailableWithError", status.getMessage()),
																	function(){
																		__self.selectedAutoResults = [];											            					
										            					__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
																    },
																    this, null, null);																			
															}
														});
		            							});
						            		}
						            		else
						            			__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
						            	}
						            	else if(option == AutomationItemInstancePicker.SELECT_EXISTING_INSTANCE){
							            	// pass automation results to adapter, which will be finally linked to test result
							            	__self.selectedAutoResults = resources;
							            	__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
						            	}
						            	else if(option == AutomationItemInstancePicker.CANCEL_SELECTION){
						            		// user canceled current execution, do nothing for now
						            	}
			            			});
								}
								else {
									// service provider unavailable, ask user whether wish to continue without deployment
									PlanningUtility.performErrorHandlingConfirmation(DefectsUIUtil.getMessage("msgProviderNotAvailableForTCERRun"),
														function(){
							            					__self.selectedAutoResults = [];
							            					__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
													    },
													    this, null, null);
								}
							});		
						}
						else {
        					// pre-linked auto plan no longer valid, show a confirmation with the error msg to ask user whether wish to clear it
							PlanningUtility.performErrorHandlingConfirmation(DefectsUIUtil.getMessage("msgAutoPlanNoLongerValid", status1.getMessage()),
												function(){		    
													// clear the automation plan from backend
										            ResourceLinkService.updateRunsOnDeploymentLink(oslcVersion, ResourceLinkService.TAG_EXECUTIONRECORD, ewiResourceUri, [], [], function(){
										            	// refresh ewi list
										            	__self._ewiTableViewer.refreshQuery();
										            	// resume execution
											            __self.selectedAutoResults = [];
											            __self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
										            });
											    },
											    this, null, null);
						}
					});
				}
				else
					__self.onExecutePostAutoSelection(ewi, updateVariables, channelId);
			});
			
			
				
		},
		
		onExecutePostAutoSelection: function(ewi, updateVariables, channelId) {
			var vScriptId = null;
			var isChannelsEnabled = this.isChannelEnabled();
			if(ewi.selectedScriptId && ewi.selectedScriptId != "-1")
				vScriptId = ewi.selectedScriptId;
         	if (vScriptId != null){
         		if(this.selectedAutoResults && this.selectedAutoResults.length > 0){
         			var param = {
						ewiItemId:ewi.itemId,
						owner: getAuthenticatedContributor().userId,
						isWebUI:true,
						autoResultsJson:this.selectedAutoResults
					};
					
					if(channelId && isChannelsEnabled){
						param.channelId = channelId;
					}
					var callback = {
						success:function(response){
								parent.location = Utility.startExecution(ewi.itemId, vScriptId,response.resultItemId,response.requestId,null,updateVariables);
						},
						error:function(err){
							self._displayAlertDialog(err.message);
						}
					};
					var responseHandler = new ServiceResponseHandler(callback, "success", "error");
					ExecutionWorkItemClient.postExecuteDTO(responseHandler, param);
	         	}
	         	else{
	         		if(isChannelsEnabled){
	         			parent.location = Utility.startExecution(ewi.itemId, vScriptId,null,null,null,updateVariables, channelId);
	         		}else{
	         			parent.location = Utility.startExecution(ewi.itemId, vScriptId,null,null,null,updateVariables);
	         		}
	         	}
         	}else{
				var param = {
						ewiItemId:ewi.itemId,
						owner: getAuthenticatedContributor().userId,
						isWebUI:true,
						isScriptLessExecution:true
				};
				if(channelId && isChannelsEnabled){
					param.channelId = channelId;
				}
				if(this.selectedAutoResults && this.selectedAutoResults.length > 0)
					param.autoResultsJson = this.selectedAutoResults;
				var self = this;
				var callback = {
					success:function(response){
							parent.location = Utility.getResultURI({ewiId: ewi.id, editable:true, requestId : response.requestId});
					},
					error:function(err){
						self._displayAlertDialog(err.message);
					}
				};
				var responseHandler = new ServiceResponseHandler(callback, "success", "error");
				ExecutionWorkItemClient.postExecuteDTO(responseHandler, param);
			}
		},
		
		onOfflineExecute: function(){
			var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;
         	if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIExe"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIExe"));
	            return;
         	}
			if(!this.validateForOfflineExecution(selectedEWIs))
				return;
			var selectedEWIsLength = selectedEWIs.length ? selectedEWIs.length : 0;
			var items = [];
			for(var i=0;i<selectedEWIsLength;i++){
				items.push({terItemId: selectedEWIs[i].itemId, scriptItemId :selectedEWIs[i].selectedScriptId});
			}	
			OfflineInitializer.postTestOffline(items);		
		},
		
		validateForOfflineExecution: function(selectedEWIs){
			var selectedEWIsLength = selectedEWIs ? selectedEWIs.length : 0;
			//Maximum 50 TERs can be selected for execution at one point
			if(selectedEWIsLength > 50){
				this._displayAlertDialog(Constants.getMessage("msgOfflineMultiTERSelectionExceededMaxLimit", selectedEWIsLength));
				return false;
			}
			//Validate script type to be Manual only.
			for(var j=0;j<selectedEWIsLength;j++){
				var selectedEWI = selectedEWIs[j];
			
				//For Each TER, check if the selected script is a Manual script only
				if(!selectedEWI.selectedScriptId || selectedEWI.selectedScriptId == "-1"){
					//If any of the selected scripts is None, disable offline
					//Show Alert for NONE Script
					this._displayAlertDialog(Constants.getMessage("msgOfflineMultiTERWithoutManualScript"));
					return false;
				}else{
				
					var scripts = selectedEWI.testCase.scripts;
					var len = scripts ? scripts.length : 0;
					for (var i = 0; i < len; i++) {
						var script = scripts[i]; 
						if(script.versionableItemId == selectedEWI.selectedScriptId){
							if(script.scriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
								//Offline will be enabled only for Manual script is selected for all TERs
								this._displayAlertDialog(Constants.getMessage("msgOfflineMultiTERWithoutManualScript"));
								return false;
							}	
						}
					}
				}
			}
			return true;
		},
		
		onRunWithOptions: function(){
			if(this._isNewEWIChecked()){
				this._promptForSaveNewEWI();
				return;
			}
			//Only execute the first selected EWI.  Convert to Single Select table mode once available (See RQM WI: 1664)
			var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;						
         	if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIExe"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIExe"));
	            return;
         	}	
			var ewi = selectedEWIs[0];
			if(!this.validateStateForExecution(ewi.testCase)){
				return;
			}
			if (ewi){
				var selectedScript = {
					scriptName : ewi.selectedScriptName,
					scriptItemId : ewi.selectedScriptId,
					datapoolItemId : ewi.selectedScriptDatapoolItemId};
				var execPopUp = new ExecutionPopUp();				
				var args = {
					currentEWI:ewi,
					testCase: ewi.testCase,
					defaultScript:ewi.defaultScript ? ewi.defaultScript : null,
					selectedScript:selectedScript,
					selectedConfig:ewi.config ? ewi.config : null,					
					runWithOptions:true,
					parent:this									
				};
				execPopUp.initialize(args);
			}			
		},
		
		onCreateResult: function(){
			if(this._isNewEWIChecked()){
				this._promptForSaveNewEWI();
				return;
			}
			var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;						
         	if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIExe"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIExe"));
	            return;
         	}	
			var ewi = selectedEWIs[0];
			if(!this.validateStateForExecution(ewi.testCase)){
				return;
			}
			var dialogArgs = {
						parentEditor: this, 
						okCallback: dojo.hitch(this, this._createQuickResult,ewi),
						verdictTypes:this.verdicts,
						bulkUpdateForTERs: true,
						channels: ewi.channels,
						dialogTitle:Constants.getMessage("labelCreateResult"),
						labelTopMessage:Constants.getMessage("labelSelectVerdict")
							
					};
			var datapoolItemId = ewi.selectedScriptDatapoolItemId;			
			if (datapoolItemId && datapoolItemId != "none") {
				dialogArgs.datapoolItemId = datapoolItemId;
				dialogArgs.teamArea = ewi.teamArea;
				if (ewi.selectedScriptRecordSelection && ewi.selectedScriptRecordSelection != "none") {
					dialogArgs.recordSelection = ewi.selectedScriptRecordSelection;
				}
			}	
			this.dia = new com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog(dialogArgs);
			this.dia.initialize();
		},
		
		_createQuickResult:function(ewi, args){
			var currentTime = new Date().getTime();
			var par = {
				ewiItemId:ewi.itemId,
				startTime:currentTime,
				endTime:currentTime,
				state:args.verdict,
				owner:getAuthenticatedContributor().userId
			};
			par.notes = args.notes;
			par.execResultCustomAttributesJson = args.execResultCustomAttributesJson; 
			par.sortableCategories = args.sortableCategories ;
			par.categories = args.categories ;
			par.pointsAttemptedPercent = args.pointsAttemptedPercent; 
			par.pointsBlockedPercent = args.pointsBlockedPercent ;
			par.pointsFailedPercent = args.pointsFailedPercent ;
			par.pointsInconclusivePercent = args.pointsInconclusivePercent;  
			par.pointsPassedPercent = args.pointsPassedPercent;
			par.pointsPermFailedPercent = args.pointsPermFailedPercent;  
			par.pointsDeferredPercent = args.pointsDeferredPercent;
			par.buildRecordItemId = args.buildUUID;
			par.channelId = args.channelId;
			if(args.datapoolRows && args.datapoolRows.length > 0){
				par.datapoolRows = args.datapoolRows;
			}
			
			var testScriptItemid = ewi.selectedScriptId;
			if (testScriptItemid != null && testScriptItemid != "-1") {
				par.scriptItemid= testScriptItemid;
			}
			var self = this;
			var callback = {
				ewiId:ewi.id,
				success:function(result){
					self.dia.floatingPane.close();
					var updatedEWIs = [];
					updatedEWIs.push(ewi);
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, updatedEWIs]);
					if(args.workItems && args.workItems.length > 0){
						// Use the Execution Record name for the result
						self.linkDefectsToExecutionResults([{itemId: result.resultItemId, name: ewi.name}], ewi, args.workItems);
					}
					setTimeout(dojo.hitch(this, function(){
						parent.location = Utility.getResultURI({ewiId:this.ewiId,resultItemId:result.resultItemId});
					}), 500);
				},
				error:function(err){
					self.dia.floatingPane.close();
					self._displayAlertDialog(err.message);
				}
			};
			var responseHandler = new ServiceResponseHandler(callback, "success", "error");			
			ExecutionWorkItemClient.postExecuteDTO(responseHandler, par);
			//need to disable the ok button after the return 
			setTimeout(dojo.hitch(this,function(){
				if(this.dia.floatingPane){
					this.dia.floatingPane.getOkButton().disabled = true;
				}
			}),10);
			//return false so dialog stays open
			return false;
		},

		onResume: function(){
			if(this._isNewEWIChecked()){
				this._promptForSaveNewEWI();
				return;
			}
	         //Only resume the first selected EWI.  Convert to Single Select table mode once available (See RQM WI: 1664)
	         var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;                 
	         if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIResume"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIResume"));
	            return;
	         }  
	         var ewi = selectedEWIs[0]; 
			 if (!Utility.isPaused(ewi ? ewi.currentResult : null)) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgEWInotResumable"));
				else 
					this._displayAlertDialog(Constants.getMessage("msgEWInotResumable"));	
	           	return;				
			 }      
	
			var vScriptId = ewi.currentResultScritpId ? ewi.currentResultScritpId : ewi.currentResult.scriptVersionableItemId;
			var resultId = ewi.currentResult.itemId;
			
	        if(vScriptId != null){
				parent.location = Utility.startExecution(ewi.itemId, vScriptId, resultId, ewi.currentRequestId);
			}else{
				parent.location = Utility.getResultURI({ewiId: ewi.id, resultItemId: resultId});
			}
			 			
		},
		
		_getResumeURL: function(ewiItemId, vScriptId, resultItemId){
			return Utility.startExecution(ewiItemId, vScriptId, resultItemId);
		},
		
		getList: function(){
			return this._list;
		},
		
		onRefresh: function(){
			this._ewiTableViewer.disableAction("refresh");
			this.initialize();
            this._updateRelatedInfo();
		},
		
		_afterUpdatingWorkitem: function(workitem){
			if (this.lastSavedEWI == workitem.id) {
				this._ewiTableViewer.updateEWI(workitem, true);
				if(this._ewiTableViewer.viewHeaderNode)
					this._ewiTableViewer.viewHeaderNode.setStatus(Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString()),
						ViewHeaderLayout.SUCCESS);
				else
					ProgressUtility.endTaskMonitor(this.monitorId);
			}
			else {
				this._ewiTableViewer.updateEWI(workitem, false);
			}
		},
			
		// handler on artifacts changed
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
	        // handle Test Execution Records
	        if (artifactType == Constants.TYPE_EWI) {
	            var ewiArray = [];
	            if ((changeType == GlobalEvents.ArtifactsAdded) || (changeType == GlobalEvents.ArtifactsUpdated) || (changeType == GlobalEvents.ArtifactsDeleted)) {
	                // update the config that is associated to the EWI
					var len = artifactArray.length;
					var owner = this.owner;
	                for (var i = 0; i < len; i++) {
	                	var artifact = artifactArray[i];
	                    if (owner) {
							if((artifact.owner.id && owner != artifact.owner.id)||
								(artifact.owner.userId && owner != artifact.owner.userId))
	                        // skip EWI if it is for "My EWI" page and the owner is not the current owner
	                        continue;
	                    }
	                    ewiArray.push(artifact);
	                    if (changeType != GlobalEvents.ArtifactsDeleted) {
							artifact.defects = this._fixDefectInfo(artifact.defects);
		                    this.getConfiguration(artifact);
		                }
	                }
	            }
	            if (this._ewiTableViewer) {
	                this._ewiTableViewer.onArtifactChanged(changeType, artifactType, ewiArray);
					this._updateRelatedInfo();
                    this.toggleRunActions(null, false); // disable resume action on artifact changed
                    this.clearSelectedItems();	// clear selected items on artifact changed
	            } else {
	                this.onRefresh();
				}
	        } else if ((artifactType == Constants.TYPE_SCRIPT) && ((changeType == GlobalEvents.ArtifactsDeleted))) {
            	// for test script only care about deletion
				this._preLoadCheck();
			}else if ((artifactType == Constants.TYPE_CASE) && ((changeType == GlobalEvents.ArtifactsUpdated))){
				this._ewiTableViewer.onArtifactChanged(changeType, artifactType, artifactArray);
			}else if(artifactType == Constants.TYPE_TER_CATEGORY){
				this._ewiTableViewer.onArtifactChanged(changeType, artifactType, artifactArray); 
			}
				
	    },
		
		_saveError:function(err){
			if(!this._ewiTableViewer.viewHeaderNode)
				ProgressUtility.endTaskMonitor(this.monitorId, err.message);
			else
				this._displayAlertDialog(err.message);
		},
		_getDefectsFromEwis:function(ewis){
			var defects = [];
			var temp = [];
			if(ewis.length == 1)
				return ewis[0].defects;
			var len = ewis.length;
			for(var i=0;i<len;i++){
				var ewiDefects = ewis[i].defects;
				var len2 = ewiDefects ? ewiDefects.length : 0;
				for(var j=0;j< len2;j++){
					//put each defect in its bucket and then check bucket count to find intersection
					var defectId =ewiDefects[j].id;
					if(temp[defectId])
						temp[defectId].count++;
					else{
						var defectStatus = ewiDefects[j].status;
						var defectSummary = ewiDefects[j].summary;
						var blocking = ewiDefects[j].isBlocking;
						temp[defectId] = {id:defectId,status:defectStatus,summary:defectSummary,isBlocking:blocking,count:1};
					}
				}
			}
			for (var defect in temp){
				if(temp[defect].count == ewis.length)
					defects.push({id:temp[defect].id,status:temp[defect].status,summary:temp[defect].summary,isBlocking:temp[defect].isBlocking});
			}
			return defects;
		},
		
		_getDefectsFromEwisViaProvider: function(ewis){
			var temp = [];
			var len = ewis.length;
			for(var i = 0; i < len; i++){
				var ewiDefects = ewis[i].defects;
				var len2 = ewiDefects ? ewiDefects.length : 0;
				for(var j = 0; j < len2; j++){
					if(temp[ewiDefects[j].uri] && ewiDefects[j].sourceItemId == ewis[i].itemId )
						temp[ewiDefects[j].uri].count++;
					else if (ewiDefects[j].sourceItemId == ewis[i].itemId){
						temp[ewiDefects[j].uri] = ewiDefects[j];
						temp[ewiDefects[j].uri].count = 1;
						temp[ewiDefects[j].uri].isBlocking = ewiDefects[j].isBlocking;
					}
				}
			}
			var defects = [];
			for (var defect in temp) {
				if(temp[defect].count == ewis.length)
					defects.push(temp[defect]);
			}
			return defects;
		},
		
		onUnBlock: function(){
			if(this._isNewEWIChecked()){
				this._promptForSaveNewEWI();
				return;
			}
            var HandleBlockingProc = dojo.hitch(this, function(allItems) {
                this.allItems = allItems;
    			this._dispatchDefectsManagerInitialized(dojo.hitch(this, function(providers){
    				this.onUnBlock1(providers);
    			}), dojo.hitch(this, function(){
    				this.onUnBlock2();
    			}));
            });
            // we might not have all data. Get virtual selected rows will determine
            // whether this is a select all and, if so, it will fetch all data for this action.
            // if there are deselected items from a select all, filter them by the item's id
            this._ewiTableViewer.getVirtualSelectedRows('id', HandleBlockingProc);
            
		},
		
		onUnBlock1: function(providers) {
			var ewis = this.allItems;

			var blockingdefectsPopUp = new BlockingDefectsPopUp({parentEditor: this});
			var args= {
				ewis: ewis,
				okCallback: dojo.hitch(this, function(ewis, addedDefects, removedDefects){
					this.runCommitChangesViaProviderWithProgress(ewis, addedDefects, removedDefects);
				}),
				cancelCallback: dojo.hitch(this, function(){
//					this._setEWITableContent(this.ewis);
				})
			};
			blockingdefectsPopUp.initialize(args);
		},
		
		onUnBlock2: function(){
			if(this._ewiTableViewer){
				var selectedItems = this.allItems || this._ewiTableViewer.getSelectedEWIs();
				var ewis = [];
				var len = selectedItems.length;
				for(var i=0;i<len;i++){
					var selectedItem = selectedItems[i];
                    var copyEwi = {id:selectedItem.id,stateId:selectedItem.stateId,itemId:selectedItem.itemId,testCase:selectedItem.testCase,defects:selectedItem.defects};
                    if(selectedItem.config)
                        copyEwi['configuration'] = selectedItem.config.id;
					ewis.push(copyEwi);
				}
				var defects = this._getDefectsFromEwis(selectedItems);
			    var blockingdefectsPopUp = new BlockingDefectsPopUp({parentEditor: this});
				var args= {
                    ewis:ewis,
					defects: defects,
					okCallback: dojo.hitch(this, function(ewis, addedDefects, removedDefects){
					this.runCommitChangesWithProgress(ewis, addedDefects, removedDefects);
					}),
					cancelCallback: dojo.hitch(this, this._onCancel),
					isClosable: true
				};
				blockingdefectsPopUp.initialize(args);
			}
		},
		onManageVirtualService: function()
		{
			var serviceProviderManager = Utility.getServiceProviderManager();
			serviceProviderManager.getCurrentServiceProvider(dojo.hitch(this, function(currentServiceProvider){
				var self = this;
			 	if (currentServiceProvider) {
				 	Utility.addSelectedAutomationItem(currentServiceProvider, function(resources){
						self._updateVirtualServices(resources);
					});
				}
				else {
	                // No service provider is configured.
					var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': DefectsUIUtil.getMessage("msgNoAutomationProvidersConfigured")});
	            	alertDialog.open();
	            }
			}));
		},
		_updateVirtualServices:function(results){
			if(results && results.length){
				var virtualService = results[0]
				var itemIds = [];
				var autoUris = [];
				var autoSummaries = [];
				var selectItems = this._ewiTableViewer.getSelectedEWIs();
				dojo.forEach(selectItems,function(item){
					itemIds.push(item.itemId);
					autoUris.push(virtualService.url);
					autoSummaries.push(virtualService.summary);
				});
				var linkParams = {
					itemIds: itemIds,
					autoUris: autoUris,
					autoSummaries: autoSummaries,
					linkType: AutoIntegrationClient.TER_RUNS_ON_DEPLOYMENT
				};
				this.postVSMonitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgUpdatingDSlinks"), 0, null);
				AutoIntegrationClient.postNewLinkInBatch(linkParams, dojo.hitch(this, function(status){
					if (status.isOK()) {
						ProgressUtility.endTaskMonitor(this.postVSMonitorId);
						this._ewiTableViewer.refreshQuery();
					}else{
						if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
							ProgressUtility.endTaskMonitor(this.postVSMonitorId, status.getMessage());
						}
					}
				}));
			}	
		},
		runCommitChangesWithProgress: function(ewis, addedDefects, removedDefects){
			ProgressDialog.doRunWithProgress("", dojo.hitch(this, function(monitor){
				if(!monitor.isCancelRequested())
							this.commitChangesWithoutProvider(ewis, addedDefects, removedDefects, monitor);
			}), true);
		},
		commitChangesWithoutProvider: function(ewis, addedDefects, removedDefects, monitor){
			//remote local blocking link to defect
			var deleteLinkToTERs = dojo.hitch(this, function(){
					var ewiItemIds = [];
					var defectURIs = [];
					dojo.forEach(ewis, function(ewi){
						ewiItemIds.push(ewi.itemId);
					});
					dojo.forEach(removedDefects, function(def){
						defectURIs.push(def.uri || def.url);
					});
					var draftLinkParams= {
						defectURIs: defectURIs,
						ewiItemIds: ewiItemIds,
						isBlocked: false,
						isPostRequiredForArtifact: true
					};
					
					CmIntegrationClient.postBlockDefectInBatch(draftLinkParams, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
		                if (status.isOK()) {
							if(!monitor.isCancelRequested()){
								this._setEWITableContent(this.ewis);
								monitor.done();
							}
		                }
		                else 
		                    if (status.getSeverity() != Status.CANCEL) {
		                        status.log();
								this._displayAlertDialog(status.getMessage());
								monitor.done();
		                    }
		            }));
			});
			if (removedDefects.length) {
				var args = {
				                'primaryTitle': Constants.getMessage("labelConfirmation"),
		                		'message': Constants.getMessage("msgCMBackLinksNotDeleted"),
		                		'yesCallback': dojo.hitch(this, function () {
									if(!monitor) {
										monitor.beginTask(Constants.getMessage("labelUnassociateDefect"));
									}
									deleteLinkToTERs();
								}),
								'noCallback': dojo.hitch(this, function() {
									if(monitor) {
										monitor.done();
									}
								})
		            		};
		            		var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
		            		confirmDialog.open();
			}
		},
		_onOkOld: function(selectedEWIs,addedDefectIds,removedDefectIds){
			if((addedDefectIds && addedDefectIds.length > 0)||(removedDefectIds && removedDefectIds.length>0)){
				var len = selectedEWIs.length;
				if (len && len > 0) {
                    var ids = [];
                    for (var i = 0; i < len; i++) {
                        ids.push(selectedEWIs[i].itemId);
                    }
                    var args = {
                        itemIds: ids,
                        addDefectIds: addedDefectIds,
                        removeDefectIds: removedDefectIds
                    };
                    var self = this;
                    var callbackObj = {
                        success: function(ewi){
                            ProgressUtility.endTaskMonitor(self.blockId);
                            // update the contents based on the ewi list content
                            if(self._ewiTableViewer.contentIsVirtual)
                                self._ewiTableViewer._invalidateQuery(); 
                            else 
                                self._preLoadCheck();                           
                            self._updateRelatedInfo();                            
                        },
                        failure: function(errorObj){
                            ProgressUtility.endTaskMonitor(self.blockId, errorObj.message);
                        }
                    };
                    this.blockId = ProgressUtility.beginTaskMonitor(Constants.getMessage("editBlockingDefects"), 0, null); 
                    var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
                    ExecutionWorkItemClient.postManageBlockingDefects(responseHandler, args);
                }
			}
		},
		
		_isBeingEdited:function(){
			return this._ewiTableViewer.getIsInEditMode();
		},
		
		_onCancel: function(){
			if(this._ewiTableViewer.contentIsVirtual)
				this._ewiTableViewer._invalidateQuery();
			else
				this._preLoadCheck();
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from EWIList#_error");
		},
		
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        },
		
		_promptForSaveNewEWI: function() {
			this._displayAlertDialog(Constants.getMessage("msgSaveTERs"));
		},
		
		_isNewEWIChecked: function(){
			var newEWIChecked = false;
			var ewis = this._ewiTableViewer.getSelectedEWIs();
			var length = ewis.length;
			for(var i = 0; i < length; i++){
				if(ewis[i].isNew){
					newEWIChecked = true;
					break;
				}
			}
			return newEWIChecked;	
        },
        
        // Expose our internal tableViewer's runQuery method. Call the internal 
        // tableViewer's runQuery with our set parent item constraints.
        runQuery: function() {
            if(this._ewiTableViewer && this._ewiTableViewer.runQuery) {
                if(this.parentItemIdArgName && this.parentVersionItemId) {
                    this._ewiTableViewer.parentItemIdArgName = this.parentItemIdArgName;
                    this._ewiTableViewer.parentVersionItemId = this.parentVersionItemId;
                    this._ewiTableViewer.runQuery();
                }
            }
        },
		
		/***
		 * Link Defects to Execution result
		 */
		
		linkDefectsToExecutionResults: function(resultSummaryDTOs, ewi, workitems){
			var self = this;
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
						monitor.beginTask(Constants.getMessage("labelAssociateDefect"));
						dojo.forEach(resultSummaryDTOs, function(r){
							// ewi data might come from single or bulk changes
							self._postLinkToExecutionResults(workitems, monitor, r.itemId, r.name, (ewi != null ? ewi : r.ewi));
						});	
						monitor.done();
			}));
		},
				
		_postLinkToExecutionResults: function(workItems, monitor, resultItemId, resultName, ewi){
			if (workItems.length > 0) {
				//Post local link to TER
				var i = 0;
				var workItem = null;
				var currentProvider = null;
				var postLinkToExecutionResult = dojo.hitch(this, function(monitor){
					if (i == workItems.length) {
						monitor.done();
						return;
					}else{
						workItem = workItems[i];
						currentProvider = workItem.provider;
						var linkParams = {
							itemId: resultItemId, 
							cmUri: workItem.url,
							summary: workItem.summary,
							linkType: CmIntegrationClient.RESULT_RELATEDTO_DEFECT,
							createRelatedLinks: true
						};
						if(workItem.providerProjectKey){
							linkParams.providerProjectKey = workItem.providerProjectKey;
						}
						CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
							i++;
							currentProvider.createBackLinks4AssociatingDefectsWithTestResult(
								resultItemId, 
								resultName, 
								null, 
								ewi.testCase.versionableItemId, 
								ewi.testCase.name, 
								(ewi.testPlan? ewi.testPlan.versionableItemId : null), 
								(ewi.testPlan ? ewi.testPlan.name : null), 		
								workItem.url, 
								workItem.summary, 
								null, 
								dojo.hitch(this, function(status){
									console.debug("defect back links created");
									postLinkToExecutionResult(monitor);
								}),	
								dojo.hitch(this, function(status, response){
									console.debug("failed to create execution result link");
									postLinkToExecutionResult(monitor);
									this._displayAlertDialog(Constants.getMessage("labelError"), status.getMessage() || response);
								})
							);
		                }));
					}
				});
				postLinkToExecutionResult(monitor);
			}
		},

		
		_truncateDefectLabel: function(defect){
			var defectText = "";
			var id = (defect.id && defect.id != "null" ? (defect.id+":"): "");
			var stateGroup = (defect.stateGroup && defect.stateGroup != "null" ? (" -- " + defect.stateGroup) : "");
			var summary = (defect.summary && defect.summary.indexOf(id) != -1 ? defect.summary.substr(id.length) : (!defect.summary || defect.summary == "" ? "Defect" : defect.summary));
			if(summary.length>10)
				defectText = id + summary.substr(0, 9) +"..." + stateGroup;
			else
				defectText = id + summary + stateGroup;
			return defectText;
		}
	}
);

})();
