/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.TestcaseExecutionRecordSummarySection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("dojox.xml.parser");
dojo.require("jazz.ui.Menu");
dojo.require("jazz.app.context");
// Clients Required
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.client.internal.TeamAreaClient");
// Utilities required
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.categories.CategoryEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("jazz.ui.ResourceLink");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.CategoryInputEdit");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormFieldGroup");
dojo.require("com.ibm.asq.common.web.client.internal.CompositeWebClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormDurationField");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CustomAttributesEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.TeamAreaSelector");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.defects.web.client.internal.ResourceLinkService");
dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");
dojo.require("com.ibm.rational.test.lm.web.client.internal.channel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowInitialization");
dojo.require("com.ibm.asq.common.web.client.internal.CompositeWebClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");

(function() { // module container

var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;					
var TeamAreaClient 					= com.ibm.asq.common.web.client.internal.TeamAreaClient;
var Utility						    = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var PlanningUtility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var PlanClient						= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var TimeBoxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var GlobalEvents                    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var TestPlanMapper					= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TestCaseTableView       		= com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RtlmUiUtil						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var CommonImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var CommonUtility                   = com.ibm.asq.common.web.ui.internal.util.Utility;
var TestPlanTableView       		= com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
var FormFieldGroup 					= com.ibm.asq.common.web.ui.internal.widgets.layout.FormFieldGroup;
var FormNumericField 				= com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField;
var FormDurationField				= com.ibm.asq.common.web.ui.internal.widgets.layout.FormDurationField;
var CustomAttributesEditor 			= com.ibm.asq.common.web.ui.internal.view.common.CustomAttributesEditor;
var DefectsUIUtil 					= com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
var CommonConstants  				= com.ibm.asq.common.web.client.internal.Constants;
var AbstractArtifactEditorSection 	= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var ConfirmationDialog      = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
var ResourceLinkService             = com.ibm.rqm.defects.web.client.internal.ResourceLinkService;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.extension.TestcaseExecutionRecordSummarySection", [
                   dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
    	templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/extension/ERSummarySection.html"),
        
		
		labelCategories: Constants.getMessage("labelCategories:"),
		labelChannel: Constants.getMessage("fieldLabelChannels"),
		
		//@Overriden from AbstractArtifactEditorSection
        initialize: function(isEsitable) {
        	this.ewi = this.getArtifact();
        	this.isSuite = this.getParentEditor().isSuite;
        	var colen = Constants.getMessage("labelColen");
        	this.unassigned = Constants.getMessage("labelUnassigned");
            this._TPLabel.innerHTML = Constants.getMessage("labelTestPlan") + colen;
            this._IterationLabel.innerHTML = Constants.getMessage("labelIteration") + colen;
            this.updateTitlesForEditor();
            this._configLabel1.innerHTML = Constants.getMessage("labelAvaiableConfiguration") + colen;
            this._weightLabel.innerHTML = Constants.getMessage("labelWeight") + colen;
			this._TC.innerHTML = Constants.getMessage("labelUnassigned");
			this._TP.innerHTML = Constants.getMessage("labelUnassigned");
			
			if (!this.isSuite) {
				this._virtualserviceLabel.innerHTML = Constants.getMessage("labelDeploymentItem") + colen;
				this._virtualservice.innerHTML = Constants.getMessage("labelUnassigned");
			}
			else{
				dojo.style(this._virtualserviceTR, "display", "none");
			}
			
			this._enableAutomationItemSelectionUIBySystemProperty(this.getParentEditor().getIsOSLCAutomationConsumerEnabled());
			
			var disabled = (!this.isEditable()) || (this.ewi ? true : false);
            
            this._browseTP = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                imgSrc: CommonImageCache.ADD_ICON_ENABLED,
                title: Constants.getMessage("labelSelectTestPlan"),
                onClick: dojo.hitch(this, "_browseTPClick")
            }, this._browseTP);
            dojo.attr(this._browseTP.focusNode, "aria-label",Constants.getMessage("labelSelectTestPlan"));
            this._browseTP.setDisabled(disabled);
            this._clearTP = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                imgSrc: CommonImageCache.CLEAR_FILTER_ENABLED,
                title: Constants.getMessage("lableClear"),
                onClick: dojo.hitch(this, "_clearTPClick")
            }, this._clearTP);
            dojo.attr(this._clearTP.focusNode, "aria-label",Constants.getMessage("lableClear"));
            this._clearTP.setDisabled(disabled);
			if (!this.isSuite) {
				this._editVS = new com.ibm.asq.common.web.ui.internal.widgets.Button({
					imgSrc: CommonImageCache.EDIT,
					title: Constants.getMessage("labelSelectDeploymentService"),
					onClick: dojo.hitch(this, "_selectVirtualService")
				}, this._editVS);
				dojo.attr(this._editVS.focusNode, "aria-label", Constants.getMessage("labelSelectDeploymentService"));
				this._editVS.setDisabled(!this.isEditable());
				this._clearVS = new com.ibm.asq.common.web.ui.internal.widgets.Button({
					imgSrc: CommonImageCache.CLEAR_FILTER_ENABLED,
					title: Constants.getMessage("lableClear"),
					onClick: dojo.hitch(this, "_clearVSClick")
				}, this._clearVS);
				dojo.attr(this._clearVS.focusNode, "aria-label", Constants.getMessage("lableClear"));
				this._clearVS.setDisabled(!this.isEditable());
			}
            this.connect(this._Iteration, "onchange", "_onChangeIteration");
            this.connect(this._configurations1, "onchange", "_onChange");
            this.connect(this._configurations1, "onchange", "_initUpdateChannelsLabel");
            this.connect(this._TS, "onchange", "_onChange");
            this.connect(this._weight, "onchange", "_onChange");
            
            this._browseTC = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                imgSrc: CommonImageCache.ADD_ICON_ENABLED,
                title: this._browseTC_Title || "",
                onClick: dojo.hitch(this, "_browseClick")
            }, this._browseTC);
            dojo.attr(this._browseTC.focusNode, "aria-label",this._browseTC_Title);
            this._browseTC.setDisabled(disabled);
            this._clearTC = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                imgSrc: CommonImageCache.CLEAR_FILTER_ENABLED,
                title: Constants.getMessage("lableClear"),
                onClick: dojo.hitch(this, "_clearClick")
            }, this._clearTC);     
            this.postCreateCompleted = true;       
            dojo.attr(this._clearTC.focusNode, "aria-label",Constants.getMessage("lableClear"));
            this._clearTC.setDisabled(disabled);
            
            var weightWidget = new FormNumericField({
                showFieldLabel: false,
				fieldLabel: Constants.getMessage("labelWeight"),
                isRequired: true,
                currentValue:this.ewi ? this.ewi.weight : 0,
                disabled: this.isReadOnly,
                maxValue: Constants.MAX_INT_VALUE_IN_HEX,
            	minValue: 1,
            	disabled: !this.isEditable()
            }); 
            if(this.weightWidget) {
                this.weightWidget.destroyRecursive();
            }
            dojox.xml.parser.removeChildren(this._weight);
            this.weightWidget = weightWidget;
            weightWidget.onValueChanged = dojo.hitch(this, "_onChange");
            weightWidget.setErrorMessage(Constants.getMessage("msgNumericWeightRequired"));
            weightWidget.setPromptMessage(Constants.getMessage("msgWeightRequired"));
			this._weight.appendChild(weightWidget.domNode);
			
            if(this.estimateWidget) {
                this.estimateWidget.destroyRecursive();
            }
			dojox.xml.parser.removeChildren(this._estimate);
			this.estimateWidget = new FormDurationField({
					fieldLabel: Constants.getMessage("labelEstimate"),
					showFieldLabel: false,
					useShortForm: false,
					isReadOnly: !this.isEditable(),
					isRequired: false,
					disabled: false,
					noValidationDisplay: false
				});
				
			this.estimateWidget.onValueChanged = dojo.hitch(this, "_onChange");
			this._estimate.appendChild(this.estimateWidget.domNode);
			
            if(this.timeSpentWidget) {
                this.timeSpentWidget.destroyRecursive();
            }
			dojox.xml.parser.removeChildren(this._timeSpent);
			this.timeSpentWidget = new FormDurationField({
					fieldLabel: Constants.getMessage("labelTimeSpent"),
					showFieldLabel: false,
					useShortForm: false,
					isReadOnly: !this.isEditable(),
					isRequired: false,
					disabled: false,
					noValidationDisplay: false
				});
			this.timeSpentWidget.onValueChanged = dojo.hitch(this, "_onChange");
			this._timeSpent.appendChild(this.timeSpentWidget.domNode);
			
			if(this.ewi){
				if(this.ewi.estimate >= 0){
					this.estimateWidget.setValue(this.ewi.estimate);
				}
				if(this.ewi.timeSpent >= 0){
					this.timeSpentWidget.setValue(this.ewi.timeSpent);
				}
				if (!this.isSuite) {
                    this._initVS();
                }
			}
			this._createCategoriesSection();
			this.allTestCases = [];
			this.resourceLinks = [];
            this.allPlans = [];
            this.testCases = [];
            this._projectAlias = CommonUtility.getCurrentProjectAreaAlias();
            this._initTP();
			
            this.getParentEditor().updateSaveable();
            if(!this.getParentEditor().isChannelEnabled()){
				this._channelNode.style.display = "none";	
			}
		},
        
        updateTitlesForEditor: function(){
			var colen = Constants.getMessage("labelColen");
			this._executeTCLabel.innerHTML = Constants.getMessage("labelTestCase")+colen;
			this._defaultTSLabel.innerHTML = Constants.getMessage("labelDefaultTS")+ colen;
			this._estimateLabel.innerHTML = Constants.getMessage("labelEstimate")+ colen;
			this._timeSpentLabel.innerHTML = Constants.getMessage("labelTimeSpent")+ colen;
			//this.detailSection.setCSHelpId("rqm_ter_detail.html");
			this._browseTC_Title = Constants.getMessage("labelSelectTestCase");
			if (dojo.isFunction(this._browseTC.set)) {
			    this._browseTC.set('title', this._browseTC_Title);
			}
		},
		
		_initTP: function(plans){
			var ewi = this.ewi;
			if(ewi){
				this._TPvalue = ewi.testPlan ? ewi.testPlan.id : "global";
				this._browseTP.set('disabled', true);
				this._clearTP.set('disabled', true);
				if (this._TPvalue != "global" && ewi.testPlan) {
					this._TP.innerHTML = CommonUtility.encodeHTMLTags(ewi.testPlan.name);
					this._setTPLink(ewi.testPlan);				
					this.allPlans.push(ewi.testPlan);
					if(this._compositeDTO && this._compositeDTO.allMinimalSavedConfigurations){
						this._setTPConfig(this._compositeDTO.allMinimalSavedConfigurations);	
					} else {
						var responseHandler = new ServiceResponseHandler(this, "_setTPConfig", "_error");
						PlanClient.getConfigurations(responseHandler, ewi.testPlan.versionableItemId);
					}
				}
				else {
					this._setTPConfig();
				}
			}else {
				this.allPlans = [];
				this._TPvalue = "global";
				this._initTC();
			}
		},		
		_setTPConfig: function(configs){
			if (configs) {
				var len = this.allPlans ? this.allPlans.length : 0;
				if(len != 0)
					this.allPlans[len - 1].configurations = configs;
			}
			this._updateTestCases();
			if(this.ewi && this.ewi.testPlan){
				if(this.artifactCompositeDTO){
					this._appendIterations(this.artifactCompositeDTO.relatedTestPhases);
				} else {
					var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
					TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {testPlanId:this.ewi.testPlan.versionableItemId});
				}
			}else{
				this._updateIterationCombo();
			}	
			this._initTC();
		},
		
		_appendIterations: function(iterations){			
			if(iterations && iterations.length > 0){
				var tempIterationPlanUUID  =  iterations[0].targetTestPlanUUID;
				var plan = null;
				var len2 = this.allPlans.length;
				for(var i=0;i<len2;i++){					
					if(this.allPlans[i].versionableItemId === tempIterationPlanUUID){
						plan =  this.allPlans[i];
						break;
					}	
				}
				if(plan.teamArea && plan.teamArea!=""){ //no need to check for inconsistencies(for now) if we have a team Area set
					plan.iterations =  iterations;
					this._updateIterationCombo();
				} else if (this.artifactCompositeDTO && !this.artifactCompositeDTO.isPlanRootIterationValid){ 
					//consistency is checked in server-side now
					plan.iterations = [];
					//this._header.setStatus(Constants.getMessage("titleWarning"), ViewHeaderLayout.WARNING, Constants.getMessage("labeldevLineNotMatch"));
				} else {
					//this code should be removed when we are fully sure that compositeDTO is 
					//always present, leaving it for now but should be removed soon
					var _self = this;
					this.currentPlanForAnalysis = plan;
					plan.analizeIterations = iterations;					
					var devliner = {
							success: function(lines){
					        	var len = lines.length;
								for(var i=0;i<len;i++){
									var devLine = lines[i];									
									if(devLine.projectTimeline){
										var args = {
												includeArchived: false,
												uuid:devLine.itemId
										};										
										var responseHandler = new ServiceResponseHandler(_self,"_validateSchedulesAgainstIterationsForUnnassignedTeamAreas", "_error");
										TeamAreaClient.getIterations(responseHandler, args);
										break;
									}
								}
								
					        },
					        error: function(e){
					        	_self.error(e);
					        }
					};
					var devlineResponseHandler = new ServiceResponseHandler(devliner, "success", "error");
	        		TeamAreaClient.getProjectDevelopmentLines(devlineResponseHandler);						
				}				
			} else {
				this._updateIterationCombo();
			}
			
		},
		
		isIterationValid: function(iterations, iterationItemId){
			var len = iterations?iterations.length:0;
			var found = false;
			for(var i =0;i<len;i++){
				var iteration = iterations[i];
				if(iteration.itemId == iterationItemId){
					found = true; 
					break;
				}
				if(iteration.iterations && iteration.iterations.length > 0 && this.isIterationValid(iteration.iterations, iterationItemId)){
					 found = true;
					 break;
				}
			}
			return found;
		},
		
		_validateSchedulesAgainstIterationsForUnnassignedTeamAreas: function(devLineIterations){
			var plan  = this.currentPlanForAnalysis;
			var found = this.isIterationValid(devLineIterations, plan.rootIteration);
			if(found){
				plan.iterations = plan.analizeIterations;	
			} else {
				plan.iterations = [];
				this.getParentEditor().getHeader().setStatus(Constants.getMessage("titleWarning"), ViewHeaderLayout.WARNING, Constants.getMessage("labeldevLineNotMatch"));
			}
			
			this._updateIterationCombo();			
			//delete unused memory
			delete plan.analizeIterations;
			delete this.currentPlanForAnalysis;
			
			
		},
		
		_initVS: function(){
			if (!this._isNew) {
				var resourceUri = this._getCurrentEWIResourceUri();
				ResourceLinkService.getRunsOnDeploymentLink("2.0", ResourceLinkService.TAG_EXECUTIONRECORD, resourceUri, dojo.hitch(this, function(link){
					if (link.length && link.length > 0) {
						this._setVS(link[0]);
					}
					else {
						if (this._virtualservice.innerHTML != Constants.getMessage("labelUnassigned")) {
							this._clearVSFunc();
						}
					}
				}));
			}
			
		},
		
		_initTC: function(testCases) {
			this.allTestCases = testCases ? testCases:[];
            if (this._compositeDTO) {
            	this._updateConfigurationCombo(this._compositeDTO.allMinimalSavedConfigurations);
            } else {
			var responseHandler= new ServiceResponseHandler(this, "_updateConfigurationCombo", "_error");
			var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
			cfg.getAllMinimal(responseHandler);
            }
		},
		_updateConfigurationCombo: function(configs){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this.configs = configs;
			this._fillConfigurationCombo(ewiData);
			this.initialized = true;
			if(ewiData == "global"){
				this.getParentEditor().updateSaveable();
                //this._endLoading();
				return;
			}
			//Start the init for TPlans to show Test cases and Iterations
            this._updateIterationCombo();
            //this._endLoading();
            if (this.getParentEditor().isNew()) {
            	this.getParentEditor().getHeader().setEditableTitleFocus();
            }
			this.getParentEditor().updateSaveable();
		},
		
		_fillConfigurationCombo:function(ewiData){
			dojox.xml.parser.removeChildren(this._configurations1);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			if(ewiData == "global"){
				option.selected = true;				
				this._configurations1.disabled = true;
			}
			SelectUtility.add( this._configurations1, option );
			if(this.configs){
				var configs = [];
				var planId = this._TPvalue;
				if(planId ==="global"){
					configs = this.configs;
				}else{
					var allPlans = this.allPlans;
					var len = allPlans.length;
					var thisConfigs = this.configs;
					var len2 = thisConfigs.length;
					for(var i=0;i<len;i++){
						var id = parseInt(planId, 10);
						var thePlan = allPlans[i];
						if(thePlan.id === id && thePlan.configurations){
							var len3 = thePlan.configurations.length||0;
							for(var k=0;k<len3;k++){
								for(var j=0;j<len2;j++){
									if(thisConfigs[j].id == thePlan.configurations[k] || thisConfigs[j].id == thePlan.configurations[k].id){
										configs.push(thisConfigs[j]);
									}
								}
							}
						}
					}
				}
				var sortedConfig = [];
				if(configs.length > 0){
					var len3 = configs.length;
			        for ( var i = 0; i < len3; i++ ) {
						sortedConfig.push(configs[i]);
			        }
					sortedConfig = sortedConfig.sort(function(c1, c2) {
			            var cSort1 = c1 && c1.name ? (c1.name).toLowerCase() : "";
			            var cSort2 = c2 && c2.name ? (c2.name).toLowerCase() : "";
			            if(cSort1 == cSort2){
							return 0;
						}else
							return cSort1 < cSort2 ? -1 : 1;//Ascending order
			        });
				}
				configs = sortedConfig;
				var len3 = configs.length;
				for(var i=0;i<len3;i++){
					var opt = new Option(configs[i].name, configs[i].id);
					if(ewiData != "" ){
						if(configs[i].id == ewiData){
							opt.selected = true;
							this._configurations1.disabled = true;
						}
					}
					SelectUtility.add( this._configurations1, opt );
				}
			}
			this._initUpdateChannelsLabel();
		},
		_updateIterationCombo: function(){
			var planId = this._TPvalue;
			dojox.xml.parser.removeChildren(this._Iteration);
			var opt = new Option (Constants.getMessage("labelUnassigned"), this.unassigned);
			SelectUtility.add( this._Iteration, opt );
			if(planId == "global"){
				opt.selected = true;
				this._Iteration.disabled = true;
				return;
			}
			this._Iteration.disabled = this.isReadOnly;
			var allPlans = this.allPlans;
			var len = allPlans.length;
			var ewi = this.ewi;
			for(var i=0;i<len;i++){
				var id = parseInt(planId, 10);
				if(allPlans[i].id === id){
					var planIterations = allPlans[i].iterations;
					var planIterationsLen = planIterations ? planIterations.length : 0;
					if(planIterationsLen || (ewi && ewi.testPlan && ewi.phase && ewi.phase.archived == true)){
						var ewiData = "";
						if(ewi && ewi.testPlan && ewi.testPlan.id === id && ewi.phase){
							ewiData = ewi.phase.name;
						}
						var len2 = planIterationsLen;
						for(var j=0;j<len2;j++){
							var opt = new Option(planIterations[j].name, planIterations[j].itemId);
							if((ewiData !== "" && ewiData === planIterations[j].name))  
								opt.selected = true;
							SelectUtility.add( this._Iteration, opt );
						}						
						if(ewiData !== "" &&  ewi.phase && ewi.phase.archived == true) {
							var opt = new Option(ewi.phase.name, ewi.phase.itemId);
							opt.selected = true;
							opt.disabled = true;
							SelectUtility.add( this._Iteration, opt );
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
		},
		_updateTestCases: function(){
			var planId = this._TPvalue;
			var disabled = (!this.isEditable()) || (this.ewi ? true : false);
			if (this.ewi) {
				if(this.ewi.currentResult || disabled){
					this._browseTP.set('disabled', true);
					this._clearTP.set('disabled', true);
				}else{
					this._browseTP.set('disabled', false);
					this._clearTP.set('disabled', false);
				}
				if(this.ewi.testCase){
					var testCase = this.ewi.testCase;
					if (this._tcResLink) {
						this._tcResLink.destroyRecursive(true);
					}
					// wrap the test case link with a rich hover resource
					var testCaseName = testCase.name || "";
					testCaseName = testCaseName + (testCase.snapshotInfo ? " (" + testCase.snapshotInfo.name + ")" : "");
                    this._tcResLink = new jazz.ui.ResourceLink({
                        label: CommonUtility.encodeHTMLTags(testCaseName),
                        retainLinkText: true,
                        uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_CASE, testCase.versionableItemId),
                        presentationUri: testCase.snapshotInfo ? PlanningUtility.getTestCaseURI(testCase.itemId, testCase.snapshotInfo.revision) :
										 PlanningUtility.getTestCaseURI(testCase.id)
                    }, this._TC);
					this.resourceLinks.push(this._tcResLink);
				}
				if (this.ewi.testCase) { 
					this._setTS(this.ewi.testCase.scripts,this.ewi.defaultScript);
				}
				this._browseTC.set('disabled', true);
				this._clearTC.set('disabled', true);
				return;
			}
			this._TC.innerHTML = Constants.getMessage("labelUnassigned");
			this._TCItemId = null;
			this._setTS();
			if (planId === "global") 
				this.testCases = this.allTestCases;
			else {
				var allPlans = this.allPlans;
				var len = this.allPlans.length;
				for (var i = 0; i < len; i++) {
					var id = parseInt(planId, 10);
					if (allPlans[i].id === id) {
						this.testCases = allPlans[i].testCases? allPlans[i].testCases:[];
						if (this.testCases.length === 0) {//test Case is required field
							//this._saveButton.setDisabled(true);
							return;
						}
						break;
					}
				}
			}
		},
		
		_getTestCaseVersionableItemId: function(testCaseItemId){
			if ( this.allTestCases !== null && this.allTestCases.length > 0 ){
				var allTestCases = this.allTestCases;
				var len = allTestCases.length;
				for(var i = 0; i< len; i++){
					if(allTestCases[i].id == testCaseItemId){
						return allTestCases[i].versionableItemId;
					}
				}
			}
		},
		
		_getTestPlanVersionableItemId: function(testPlanItemId){
			var allPlans=[];
			var len = 0;
			if(this.allPlans !== null ){
				allPlans = this.allPlans;
				len = allPlans.length;
			}
			if ( len > 0 ){
				for(var i = 0; i< len; i++){
					if(allPlans[i].id == testPlanItemId){
						return allPlans[i].versionableItemId;
					}
				}
			}
		},
		
		_getSelectedPlanItemId: function(){
			var selectedId = this._TPvalue;
			var itemId = "";
			var allPlans = this.allPlans;
			var len = allPlans.length;
			for (var i = 0; i < len; i++){
				var plan = allPlans[i];
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		onSelectTP: function(){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this._fillConfigurationCombo(ewiData);
			this._updateTestCases();
		},
		
		_onChangeIteration: function(){
			if(this.getParentEditor().isCreateTCERWithTSEREnabled())
			{
				var args = {
			            'primaryTitle': Constants.getMessage("labelConfirmation"),
			            'message': Constants.getMessage("msgTCERSynchWarning"),
			            'okCallback': dojo.hitch(this, "_onChange"),
			            'okCallbackData': null,
			            'okLabel': Constants.getMessage('labelOk'),
			            'cancelCallback': null,
			            'cancelCallbackData': null
			        };
			    var confirmDialog = new ConfirmationDialog(args);
			    confirmDialog.open();
			}
			else
			{
				this._onChange();
			}
		},
		
		_onChange: function() {
			this.getParentEditor().setDirty(true);
        },
		_clearClick: function(){			
			dojox.xml.parser.removeChildren(this._TCTD);
			var anchorTag = document.createElement("a");
			anchorTag.innerHTML = Constants.getMessage("labelUnassigned");
			anchorTag.setAttribute("class","name-entry");
			anchorTag.setAttribute("dojoattachpoint","_TC");			
			anchorTag.setAttribute("href","javascript:{}");
			this._TC = anchorTag; 
			this._TCTD.appendChild(anchorTag);		
			this._TCId = null;
			this._TCItemId = null;
			this._updateDefaultTestScriptCombo("");
			this._onChange();
		},
		_clearTPClick: function(){
			dojox.xml.parser.removeChildren(this._TPTD);
			var anchorTag = document.createElement("a");
			anchorTag.innerHTML = Constants.getMessage("labelUnassigned");
			anchorTag.setAttribute("href","javascript:{}");
			anchorTag.setAttribute("class","name-entry");
			anchorTag.setAttribute("dojoattachpoint","_TP");			
			this._TP =anchorTag; 
			this._TPTD.appendChild(anchorTag);			
			this._TPvalue = "global";
			this.onSelectTP();
			this._updateIterationCombo();
			this._onChange();
		},
		_clearVSClick:function(clicked){
			this._clearVSFunc();
			this.selectedAutoItem = [];
			this._onChange();
		},
		_clearVSFunc:function(){
			dojox.xml.parser.removeChildren(this._virtualserviceTD);
			var anchorTag = document.createElement("a");
			anchorTag.innerHTML = Constants.getMessage("labelUnassigned");
			anchorTag.setAttribute("href","javascript:{}");
			anchorTag.setAttribute("class","name-entry");
			anchorTag.setAttribute("dojoattachpoint","_virtualservice");			
			this._virtualservice =anchorTag; 
			this._virtualserviceTD.appendChild(anchorTag);
		},
		_browseTPClick:function(){
			var tableArgs = {
				plans: [],
                profile: Constants.TABLE_PROFILE_MINIMAL,
				isSingleSelect:true,
				contentIsVirtual: true,
                showQueryFilters: true,
				isInSection: true,
				showInitLoadProgress:true,
				minimalAction:true,
                isInPicker: true,
				showChildPlans:false
			};  
			if(this.ewi != null && this.ewi.testCase != null)
			{				
				tableArgs.parentItemIdArgName = "relatedTestPlanForTestCaseItemId";
				tableArgs.parentVersionItemId = this.ewi.testCase.itemId ;
			}
			this._TPlist = new TestPlanTableView(tableArgs);
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelSelectTestPlan"),
                okCallback: dojo.hitch(this, "_setTP"),
				_truncate: function() {},  //disable the Dialog's '_truncate'
			    zIndex: 998,  // need to change the zIndex to allow the table's filters to popup.
			    avoidResizeMax:dojo.isIE,
                forceZIndex: true	
            };                
            var _dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            _dialog.contentContainer.appendChild(this._TPlist.domNode);
			_dialog.open(false);
			_dialog.updatePosition();
			_dialog.getOkButton().disabled = false;
			this._TPdialog = _dialog;
		},
		_browseClick:function(){
			var planId = this._TPvalue;
			var tableArgs = {
				testCases: this.testCases,
                profile: Constants.TABLE_PROFILE_MINIMAL,
				isSingleSelect:true,
				contentIsVirtual: true,
                minimalAction:true,
                isInPicker: true,
                showQueryFilters: true,
                allowRowEdit: false
			};
            // add the parent test plan constrain on the query.
			if (planId != "global") {
                tableArgs.parentItemIdArgName = "constrainParentVTestPlan";
                tableArgs.parentVersionItemId = this._getSelectedPlanItemId();
            }else{
                //Clear Filter args ourself as widget caches them
				tableArgs.initFilterArgs = {includeArchived: false};
            }
           
				tableArgs.showInitLoadProgress = true;
			this._list = new TestCaseTableView(tableArgs);
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelSelectTestCase"),
                okCallback: dojo.hitch(this, "_setTC"),
                avoidResizeMax:dojo.isIE,
				_truncate: function() {},  //disable the Dialog's '_truncate'
			    zIndex: 998,  // need to change the zIndex to allow the table's filters to popup.
                forceZIndex: true	
            };                
            var _dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
	        var cshelp = new CSHelp({contextID: "rqm_add_test_cases.html"});
	        cshelp.setButtonLabel(Constants.getMessage("labelAddExistingCSHelp"));
            _dialog.setSecondaryTitleNode(cshelp.domNode);
            _dialog.contentContainer.appendChild(this._list.domNode);
			_dialog.open(false);
			_dialog.updatePosition();
			_dialog.getOkButton().disabled = false;
			this._dialog = _dialog;
		},
		
		_selectVirtualService:function(){
			var serviceProviderManager = Utility.getServiceProviderManager();
			
			if (this._virtualservice.innerHTML != Constants.getMessage("labelUnassigned") && this._vsLink) {
				ResourceLinkService.getOSLCResouceContent(this._vsLink, dojo.hitch(this, function(status, autoPlan){
					if (status.isOK()) {
						var self = this;
						serviceProviderManager.getServiceProviderByUrl(autoPlan.serviceProvider, function(serviceProvider){
							if (serviceProvider) {
								serviceProviderManager.setCurrentProvider(serviceProvider);
								self._selectVirtualServiceByCurrentProvider(serviceProviderManager);
							}
							else{
								self._selectVirtualServiceByCurrentProvider(serviceProviderManager);
							}
						});
					}
					else
					{
						this._selectVirtualServiceByCurrentProvider(serviceProviderManager);
					}
				}));
			}
			else{
				this._selectVirtualServiceByCurrentProvider(serviceProviderManager);
			} 
		},
		
		_selectVirtualServiceByCurrentProvider:function(serviceProviderManager){
			serviceProviderManager.getCurrentServiceProvider(dojo.hitch(this, function(currentServiceProvider){
				var self = this;
				if (currentServiceProvider) {
					Utility.addSelectedAutomationItem(currentServiceProvider, function(resources){
						if (resources && resources.length > 0) {
							// record selected automation item
							self.selectedAutoItem = resources;
							self.currentServiceProvider = currentServiceProvider;
							// show selected automation plan item in UI
							self._onChange();
							self._virtualservice.innerHTML = "";
							
							var virtualService = resources[0];
							
							self._setVS(virtualService);
							
						}
					});
				}
				else {
					// No service provider is configured.
					var alertDialog = new AlertDialog({
						'message': DefectsUIUtil.getMessage("msgNoAutomationProvidersConfigured")
					});
					alertDialog.open();
				}
			}));
		},
		
		_refreshTC:function(testcases){
			testcases = testcases?testcases:[];
			var planId = this._TPvalue;
			if (planId != "global") {
				var allPlans = this.allPlans;
				var len = allPlans.length;
				for (var i = 0; i < len; i++){
					if (allPlans[i].id == planId) {
						allPlans[i].testCases = testcases;
						break;
					}
				}
			}else 
				this.allTestCases = testcases;
			this.testCases = testcases;
			this._list.refresh(this.testCases);
		},
		_setTP:function(){
			var addedItems = this._TPlist.getSelectedItems();
			if (addedItems && addedItems.length > 0) {
				this._onChange();
				this._TPvalue = addedItems[0].id;
				this._TP.innerHTML = CommonUtility.encodeHTMLTags(addedItems[0].name);
				this._setTPLink(addedItems[0]);				
				var createEWISelf = this;
				var allPlans = this.allPlans;
				var len2 = allPlans.length;
				var found = false;
				for(var j=0;j<len2;j++){
					if (addedItems[0].id == allPlans[j].id) {
						found = true;
						break;
					}
				}
				if(!found){
					allPlans.push(addedItems[0]);
					allPlans[len2].iterations = [];
					allPlans[len2].testCases = [];
					var callbackObj = {
						index:len2,
						success: function(results){
							createEWISelf.allPlans[this.index].configurations = results;
							createEWISelf.onSelectTP();
						},
						failure: function(e){
							createEWISelf._error(e);
						}
					};
					var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
					PlanClient.getConfigurations(responseHandler2, addedItems[0].versionableItemId);
					var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
					TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {testPlanId:addedItems[0].versionableItemId});					
				}else{
					this._updateIterationCombo();
					this.onSelectTP();
				}
			}
		},
		
		_setTPLink: function(testPlan){
			if(testPlan.versionableItemId)
				this._TPItemId = testPlan.versionableItemId;
			else
				this._TPItemId = this._getTestPlanVersionableItemId(testPlan.id);
			if (this._tpResLink) {
				this._tpResLink.destroyRecursive(true);
			}

			var testPlanName = testPlan.name || "";
			testPlanName = testPlanName + (testPlan.snapshotInfo ? " (" + testPlan.snapshotInfo.name + ")" : "");
			// wrap the test case link with a rich hover resource
            this._tpResLink = new jazz.ui.ResourceLink({
                label: CommonUtility.encodeHTMLTags(testPlanName),
				retainLinkText: true,
                uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_PLAN, testPlan.versionableItemId),
                presentationUri: testPlan.snapshotInfo ? PlanningUtility.getTestPlanURI({uid : testPlan.itemId, revision : testPlan.snapshotInfo.revision}) :
										 PlanningUtility.getTestPlanURI({id: testPlan.id})
            }, this._TP);
			this.resourceLinks.push(this._tpResLink);
			
		},
		_setVS:function(virtualService){
			if(this._vsResLink){
				this._vsResLink.destroyRecursive(true);
			}
			this._vsLink = virtualService.uri || virtualService.url;
			this._vsResLink = new jazz.ui.ResourceLink({
				label: virtualService.summary,
				retainLinkText: true,
				uri: virtualService.uri || virtualService.url,
				presentationUri: virtualService.uri || virtualService.url
			}, this._virtualservice);
			this.resourceLinks.push(this._vsResLink);
		},
		_setTC:function(){
			var addedItems = this._list.getSelectedItems();
			if (addedItems && addedItems.length > 0) {
				this._onChange();
				this._TCId = addedItems[0].id;
				if(addedItems[0].versionableItemId)
					this._TCItemId = addedItems[0].versionableItemId;
				else
					this._TCItemId = this._getTestCaseVersionableItemId(addedItems[0].id);
				if (this._tcResLink) {
					this._tcResLink.destroyRecursive(true);
				}
				// wrap the test case link with a rich hover resource
                this._tcResLink = new jazz.ui.ResourceLink({
                    label: CommonUtility.encodeHTMLTags(addedItems[0].name || ""),
                    uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_CASE, addedItems[0].versionableItemId),
                    presentationUri: Utility.getTestCaseURI(addedItems[0].id)
                }, this._TC);
				this.resourceLinks.push(this._tcResLink);
				if(!this.getParentEditor().isPriorityAssignedByUser()){
					this.getParentEditor().setPriority(addedItems[0].priority);
				}
				if(this.weightWidget){
					this.weightWidget.clearValue();	// clear text and validation warning icon
					this.weightWidget.setValue(addedItems[0].weight);
				}
				if(this.estimateWidget && addedItems[0].estimate >= 0){
					this.estimateWidget.setValue(addedItems[0].estimate);
				}
				this._updateDefaultTestScriptCombo(this._TCItemId);
				if(CommonUtility.isIterationSupportActivated()){
					this.getParentEditor().teamAreaSelector.setSelected(addedItems[0].teamArea);
				}
				this._onChange();
			}
		},
		
		//@Overriden from AbstractArtifactEditorSection
        getHelpContextID: function(){
            return "rqm_ter_detail.html";
        },
        
		_updateDefaultTestScriptCombo: function(tcItemId){
			
			var responseHandler = new TestPlanMapper(this, "_setTS", "_error");
			var args = {versionedTestCaseItemId: tcItemId};
			if (args.versionedTestCaseItemId != "") {
				TestScriptClient.getTestCaseTestScripts(responseHandler, args);
			}	
			else{
				dojox.xml.parser.removeChildren(this._TS);
			}
		},
		_setTS: function(testscripts,defaultscript){
			this.allTestScripts = [];
			var allTestScripts = this.allTestScripts;
			dojox.xml.parser.removeChildren(this._TS);
			
			if(testscripts && testscripts.length>0){
				var len = testscripts.length;
				for(var i=0;i<len;i++){
					allTestScripts.push(testscripts[i]);
					var testscript = testscripts[i];
					var option = new Option(testscript.name, testscript.versionableItemId);
					if(defaultscript && defaultscript.versionableItemId == testscript.versionableItemId)
						option.selected = true;
					else if((!defaultscript) && (i === 0))
						option.selected = true;//Useful for new TER being created
					SelectUtility.add( this._TS, option );		
				}	
			}		
			var option = new Option(Constants.getMessage("labelNone"), -1);
			if(!defaultscript && this.ewi){
				option.selected = true;//Useful for existing TER so that correct info is shown
			}
			SelectUtility.add( this._TS, option );
			this._TS.disabled = !this.isEditable();
			
		},
		
		_handleCategoriesClick: function() {
			var artifactType = this.getParentEditor().artifactType;
            this._categoriesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.categories.CategoryEditor({
                artifactType: artifactType,
                typeName: (artifactType == Constants.MODEL_TYPE_TESTCASE_EXECUTION_RECORD) ? Constants.TYPE_EWI : Constants.TYPE_SER,
                onOKCompleted: dojo.hitch(this, "_updateCategories"),
                isDialog: true
            });
        },      
        
        _updateCategories: function() {
            // category changed, set a flag to invalidate the use of the compositeDTO's categories, they
            // are obsolete.
            this.getParentEditor().categoryModified = true;

            //refresh the category selection widget; refreshes the list
            if (this._categorySelect) {
                // remap the initial completed callback to realign the labels.
                this._categorySelect.onInitializeCompleted = dojo.hitch(this.formFieldGroup, 'alignLabels');
                this._categorySelect.refresh();
            }
        },
		
		_createCategoriesSection: function(){
			CommonUtility.destroyWidgetsFromNode(this.categoryNode);
            dojo.empty(this.categoryNode);
			var formFieldGroup = this.formFieldGroup = new FormFieldGroup();
            //category labels
            this.categoryNode.appendChild(this.formFieldGroup.domNode);
            var artifactType = this.getArtifactType();
			var recordType = (artifactType == Constants.MODEL_TYPE_TESTCASE_EXECUTION_RECORD) ? Constants.TYPE_EWI : Constants.TYPE_SER;
			var args = {
                label: Constants.getArtifactTypeMessage("labelManageCategories", recordType),
                onClick: dojo.hitch(this, "_handleCategoriesClick"),
                iconClass: "categories-icon-image",
                showLabel: false,
                tabIndex: 0
            };
            this._manageCategoriesActionButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(args);           
            this._manageCategoriesActionButton.set('disabled', !this.isEditable());            
            var groupStartRow = formFieldGroup.addContent({
                label: this.labelCategories, 
                labelClass: "section-attr-label", 
                content: this._manageCategoriesActionButton.domNode
            });
            
            this._categorySelect = new com.ibm.rqm.planning.web.ui.internal.view.construction.CategoryInputEdit({
                parent: this,
                useCompositeDTO: (this.getParentEditor().categoryModified == true) ? false : true,                
                fieldGroupStartRow: groupStartRow,
                fieldGroup: formFieldGroup,
                artifactType: artifactType,
                onChange: dojo.hitch(this, "_onChange"),
                selections: this.ewi ? this.ewi.categories : null,
				onInitializeCompleted: dojo.hitch(this, '_initCustomAttributeInputs'),
                selectDefaults: !this.ewi
            });
            this._categorySelect.setDisabled(!this.isEditable());
		},
		
		 _initCustomAttributeInputs: function() {
            var customAttribs = (this.ewi && this.ewi.customAttributes)? this.ewi.customAttributes: null;          
            var args = {
                parent: this,
                fieldGroup: this.formFieldGroup,
                onInitializeComplete: dojo.hitch(this.formFieldGroup, "alignLabels"),                
                scope: this.scope,
				onChange: dojo.hitch(this, "_onChange"),
				readOnly: !this.isEditable(),
                existingCustomAttributes: customAttribs
            };
            this.customAttrEditor = new CustomAttributesEditor(args);            
            this.initialized = true;                        
        },
        
        _initUpdateChannelsLabel: function(){
			var selectedEWI = this._getSelectedEWI();
			var channels = [];
			if(selectedEWI){
				//if EWI is present, get channels from it
				channels = selectedEWI.channels;
				this._fillChannelsLabel(channels);
			}else{
//				get config ID find the channels for that and render
				var configId = this._configurations1.value;
				if(configId != "global"){
					var responseHandler= new ServiceResponseHandler(this, "_fillChannelsForEnv", "_error");
					var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
					cfg.retrieveConfigurationWithDetails(responseHandler, configId);
				}else{
					//GET list of empty channels
					var responseHandler= new ServiceResponseHandler(this, "_fillChannelsLabel", "_error");
					var channelServ = new com.ibm.rational.test.lm.web.client.internal.channel();
					channelServ.getEmptyChannels(responseHandler);
				}
			}
		},
		
		_error: function(errorObj){
            this.getParentEditor()._error(errorObj);
		},
		
		_getSelectedEWI: function(){
			if(this.ewi)
				return this.ewi;
			return null;
		},
		
		_fillChannelsForEnv: function(config){
			this._fillChannelsLabel(config.channels);
		},
		
		_fillChannelsLabel: function(channels){
			channels = dojo.isArray(channels) ? channels : [];
			var len = channels.length;
			var channelNames = [Constants.UNASSIGNED_CHANNEL_NAME];
			for(var i=0 ; i<len ; i++){
				channelNames.push(channels[i].name);
			}
			this._channelValue.tabIndex= "0";
			this._channelValue.innerHTML = channelNames.join(", ");
		},
		
		getSelectedChannel: function(){
			var selectedChannel = this._channelValue.value;
			if(selectedChannel && selectedChannel != "-1"){
				return selectedChannel;
			}
			return null;
		},
		
       
		//@Overriden from AbstractArtifactEditorSection
        getActions: function(){
            return null;
        },
        
        //@Overridden from AbstractArtifactEditorSection --> disable 'remove' capability for Summary section          
        getHeaderContent: /* String || DOM Node */ function(isEditable) {
            return null;
        },        
		
		validate: function() {
			// weight
			if (this.weightWidget) {
	            if (!this.weightWidget.validate()) {
	            	var detailError = Constants.getMessage("msgInvalidField", Constants.getMessage("labelWeight"), Constants.getMessage("labelOnlyNonnegativeInteger"), this.getDisplayTitle());
	            	this.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
	            	return false;
    	        }
    	    }
			if(this.estimateWidget && this.estimateWidget.getHasError()){
				var detailError = Constants.getMessage("msgInvalidDuration", Constants.getMessage("labelEstimate"));
				this.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
                return false;
			}  
            
			//categories
			if (this._categorySelect) {
                var st = this._categorySelect.validate();
                if(!st.status) {
                    this.getParentEditor().setHeaderStatus(st.msg, Constants.HEADER_STATUS_WARNING, st.msg);
                    return false;
                }
			}
			if(this.customAttrEditor)	{
				 var st = this.customAttrEditor.validate();
                if(!st.status) {
                    this.getParentEditor().setHeaderStatus(st.msg, Constants.HEADER_STATUS_ERROR, st.msg);
                    return false;
                }
			}
			
			if (this._isNew && !this._TCItemId) {
                var detailError = this.getErrorMsgForMissingTCItemId();
				this.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
				if(!dojo.hasClass(this._TCTD, "box-validation-error"))
					dojo.addClass(this._TCTD, "box-validation-error");
				if(!dojo.hasClass(this._executeTCLabel, "label-validation-error")){
					dojo.addClass(this._executeTCLabel, "label-validation-error");
					dojo.removeClass(this._reqTCMark, "require-validation");
					dojo.addClass(this._reqTCMark, "label-validation-error");
				}
				return false;
			}else{
                this.getParentEditor().clearStatus();
				if(dojo.hasClass(this._TCTD, "box-validation-error"))
					dojo.removeClass(this._TCTD, "box-validation-error");
				if(dojo.hasClass(this._executeTCLabel, "label-validation-error")){
					dojo.removeClass(this._executeTCLabel, "label-validation-error");
					dojo.removeClass(this._reqTCMark, "label-validation-error");
					dojo.addClass(this._reqTCMark, "require-validation");
				}	
			}
			return true;
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getAttributes: function(){
            var attributes = {};
            //weight
            if(this.weightWidget) {
                attributes.weight = this.weightWidget.getValue();
            }
            
			
			var estimate = this.estimateWidget.getValue();
			if(estimate > CommonConstants.INVALID_DURATION){
				attributes.estimate = estimate;
			}
			
			var timeSpent = this.timeSpentWidget.getValue();
			if(timeSpent > CommonConstants.INVALID_DURATION){
				attributes.timeSpent = timeSpent;
			}			

            if (this._categorySelect) {
                var categories = this._categorySelect.getSelectedItemIds();
                if (categories && categories.length) {
                	attributes.categories = categories.join();
                }else{
                	attributes.categories = "";
				}
                var sortableItems = this._categorySelect.getSortableItemIds();
                if(sortableItems.length > 0) {
                	attributes.sortableCategories = sortableItems.join();
                }
            }
			
			if(this.customAttrEditor){
				attributes.customAttributesJson =  dojo.toJson(this.customAttrEditor.getAttributes());
			}
			
			var testConfig = this._configurations1.value;
			attributes.testCase = this._TCItemId;
			
			var testPlanItemId = this._getSelectedPlanItemId();
			var testPhase = this._Iteration.disabled ? null : (this._Iteration.value == this.unassigned ? this.unassigned : this._Iteration.value);
			
			if (this._TS.value != "" && this._TS.value != "-1") 
				attributes.defaultScript = this._TS.value;
			if(testConfig && testConfig != "global")
				attributes.testConfig = testConfig;
			if(testPlanItemId != "global"){
				attributes.testPlanItemId = testPlanItemId;
			}
			
			if(testPhase != ""){
				attributes.testPhase = testPhase;
			}
			
			
            return attributes;
        },
        
        getCurrentScriptId: function(){
        	return this._TS ? this._TS.value : "";
        },
        
        getAllTestScripts: function(){
        	return this.allTestScripts;
        },
        
        getAllTestPlans: function(){
        	return this.allPlans;
        },
        
        getCurrentTestPlan: function(){
        	return this._TPvalue;
        },
        
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
			var len = artifactArray.length;
			var allPlans = this.getAllTestPlans();
			if (artifactType == Constants.TYPE_PLAN) {
				var createEWISelf = this;
				if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
					for (var i = 0; i < len; i++) {
						var len2 = allPlans.length;
						for(var j=0;j<len2;j++){
							if(allPlans[j].id == artifactArray[i].id){
								if (changeType == GlobalEvents.ArtifactsUpdated) {
									allPlans.splice(j, 1, artifactArray[i]);
									var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
									TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {testPlanId: artifactArray[i].versionableItemId});
									var callbackObj = {
										index:j,
										success: function(results){
											createEWISelf.allPlans[this.index].configurations = results;
											createEWISelf.onSelectTP();
										},
										failure: function(e){
											createEWISelf._error(e);
										}
									};
									var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
									PlanClient.getConfigurations(responseHandler2, artifactArray[i].versionableItemId);
									break;
								}else{ 
									if(this._TPvalue == allPlans[j].id){
										this._TP.innerHTML = Constants.getMessage("labelUnassigned");
										this._TPvalue ="global";
										this._updateIterationCombo();
										this.onSelectTP();
									}
									allPlans.splice(j, 1);
									break;
								}
							}
						}
					}
					}
				if(changeType == GlobalEvents.ArtifactsUpdated)
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestPlansUpdated"), ViewHeaderLayout.INFO);
				else if (changeType == GlobalEvents.ArtifactsDeleted)
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestPlansDeleted"), ViewHeaderLayout.INFO);
			}else if (artifactType == Constants.TYPE_CASE){
				if (changeType == GlobalEvents.ArtifactsAdded) {
						this.allTestCases.concat(artifactArray);
				}else if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
					for (var i = 0; i < len; i++) {
						for(var j=0;j<this.allTestCases.length;j++){
							if (this.allTestCases[j].id == artifactArray[i].id) {
								if (changeType == GlobalEvents.ArtifactsUpdated) {
									this.allTestCases.splice(j, 1, artifactArray[i]);
								}else {
									this.allTestCases.splice(j, 1);
								}
							}
						}
						var len3 = allPlans.length;
						for(var m=0;m<len3;m++){
							if(allPlans[m].testCases){
								for(var n=0;n<allPlans[m].testCases.length;n++){
									if(allPlans[m].testCases[n].id == artifactArray[i].id){
										if(changeType == GlobalEvents.ArtifactsUpdated)
											allPlans[m].testCases.splice(n,1,artifactArray[i]);
										else
											allPlans[m].testCases.splice(n,1);
									}
								}
							}
							if (this._TPvalue == this.allPlans[m].id) {
								this.testCases = this.allPlans[m].testCases;
							}
						}
						if (this._tcResLink && this._tcResLink.label == artifactArray[i].name) {
							if(changeType == GlobalEvents.ArtifactsUpdated)
								this._setTS(artifactArray[i].scripts);
							else{
								this._TC.innerHTML = Constants.getMessage("labelUnassigned");
								this._setTS();
							}
						}
					}
				}
				if(changeType == GlobalEvents.ArtifactsUpdated)
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestCasesUpdated"), ViewHeaderLayout.INFO);
				else if (changeType == GlobalEvents.ArtifactsDeleted)
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestCasesDeleted"), ViewHeaderLayout.INFO);
				else if (changeType == GlobalEvents.ArtifactsAdded)
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestCasesAdded"), ViewHeaderLayout.INFO);	
			}if (artifactType == RtlmUiUtil.TYPE_CONFIG){
				var configs = this.configs;
				if(configs){
					if (changeType == GlobalEvents.ArtifactsAdded) {
						for (var i = 0; i < len; i++) {
							configs.push(artifactArray[i]);
						}
					}else{
						for (var i = 0; i < len; i++) {
							for(var j=0;j<configs.length;j++){
								if (artifactArray[i].id == configs[j].id) {
                            		if (changeType == GlobalEvents.ArtifactsUpdated) {
										configs.splice(j,1,artifactArray[i]);
									}else if (changeType == GlobalEvents.ArtifactsDeleted) {
										configs.splice(j,1);
									}
								}
							}
						}
					}
					this._fillConfigurationCombo();
					this.getParentEditor().getHeader().setStatus(Constants.getMessage("msgTestEnvironmentUpdated",ViewHeaderLayout.INFO));
				}
			}
			
		},
		
		//@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this._browseTP.setDisabled(true);
            this._clearTP.setDisabled(true);
            if (!this.isSuite) {				
				this._editVS.setDisabled(true);
				this._clearVS.setDisabled(true);
			}            
            this._browseTC.setDisabled(true);
            this._clearTC.setDisabled(true);
            this._configurations1.disabled = true;
            this.ewi = this.getArtifact();
            
            //update the runs on deployment link
            if(this.selectedAutoItem){
                var oslcVersion = "2.0";
                var ewiResourceUri = this._getCurrentEWIResourceUri();
                ResourceLinkService.updateRunsOnDeploymentLink(oslcVersion, ResourceLinkService.TAG_EXECUTIONRECORD, ewiResourceUri, this.selectedAutoItem, [], dojo.hitch(this, function(){
                }));
            }
        },
        
        _getCurrentEWIResourceUri: function(){
            if(this.ewi == null)
                return null;
                
            var projectAreaId = jazz.app.context.get().itemId;
            var resourceUri = dojo.getObject(Constants.PUBLIC_URL) + "oslc_qm/contexts/" + projectAreaId + this.getEWIResourcePrefix() + this.ewi.itemId;
            return resourceUri;
        },
        
        getEWIResourcePrefix: function(){
            return '/resources/com.ibm.rqm.execution.TestcaseExecutionRecord/';
        },
		
		_enableAutomationItemSelectionUIBySystemProperty: function(autoConsumerEnabled) {
	 		if(!autoConsumerEnabled){
		 		dojo.style(this._virtualserviceTR, "display", "none");			 		
	 		}
	    }
        
    });
    
})();
