/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * ExecutionLogView for Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ESignAuditTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionAuditContent");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.ESignOperationDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.HistoryPane");
dojo.require("com.ibm.asq.common.web.ui.internal.util.PrintHelper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.CategoriesSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.TeamAreaSelector");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.extension.ReviewSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.defects.web.client.BuildProviderManager");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.rqm.defects.web.helper.RemoteItemPicker");
dojo.require("com.ibm.rqm.defects.web.client.internal.ResourceLinkService");
dojo.require("com.ibm.rqm.defects.web.util.ArtifactURIUtil");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecVarsTableView");


(function(){ 
	
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ERGClient 						= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;	
	var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var Utility 						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var CommonUtility 					= com.ibm.asq.common.web.ui.internal.util.Utility;
	var TSIResultTableView				= com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView;
	var WeightSection					= com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection;
	var ExecutionAuditContent			= com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionAuditContent;
	var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var YesNoDialog                     = com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
    var AlertDialog                     = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var ERGMapper						= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper;
	var ESignatureDialog                = com.ibm.asq.common.web.ui.internal.widgets.ESignOperationDialog;
    var HistoryPane                     = com.ibm.rqm.planning.web.ui.internal.view.construction.HistoryPane;
	var PermissionsClient 				= com.ibm.asq.common.web.client.internal.PermissionsClient;
	var PrintHelper						= com.ibm.asq.common.web.ui.internal.util.PrintHelper;
	var ExecutionResultStates			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
	var Button							= com.ibm.asq.common.web.ui.internal.widgets.Button;
	var BuildUiUtil 					= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
	var CommonImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var Constants_getMessage			= Constants.getMessage;
	var TestCellUriUtil					= com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil;
	var WorkflowManager                 = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager;
	var ConstraintsUtil                 = com.ibm.rqm.planning.web.ui.internal.util.StateTransitionConstraintsUtil;
    var ConfirmationDialog              = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
	var PlanningUtility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var LabelLoading                    = Constants.getMessage("labelLoading");
    var ItemPickerUtil					= com.ibm.rqm.defects.web.util.ItemPickerUtil;
    var RemoteItemPicker 				= com.ibm.rqm.defects.web.helper.RemoteItemPicker;
    var ResourceLinkService 			= com.ibm.rqm.defects.web.client.internal.ResourceLinkService;
    var ArtifactURIUtil					= com.ibm.rqm.defects.web.util.ArtifactURIUtil;
    var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
    var DefectsUIUtil 					= com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
    var ContributorSelect 				= com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect;
    var ExecVarsTableView 				= com.ibm.rqm.planning.web.ui.internal.view.construction.ExecVarsTableView;

	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog", [dijit._Widget, dijit._Templated], {
		
		templateString: "<div class=\"com-ibm-rqm-test-execution-log\">"+
							"<div dojoType=\"com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout\" " +
							"    dojoAttachPoint=\"viewHeaderNode\" altContentMarkerEnabled=\"false\" splitAttributeArea=\"true\"" +
							"    historyActivated=\"true\" historyContentSelectedLabel=${historyLabel} " +
							"    historyContentDeselectedLabel=\"${historyLabel}\"" +
							"    mainContentSelectedLabel=\"${mainContentLabel}\"" +
							"    mainContentDeselectedLabel=\"${mainContentLabel}\">" +
							"<div dojoAttachPoint=\"_topSection\" class=\"top-section\"></div>"+
							"<div dojoAttachPoint=\"_testEnvironmentSection\"></div>"+
                            "<div dojoAttachPoint=\"categoriesContainer\"></div>"+
							"<div dojoAttachPoint=\"_weightSection\"></div>"+
							"<div dojoAttachPoint=\"_table\"></div>"+							
                            "<div dojoAttachPoint=\"_reviewContainer\"></div>"+
                            "<div dojoAttachPoint=\"_variablesContainer\"></div>"+
                            "<div dojoAttachPoint=\"_auditContainer\"></div>"+
                            "<div dojoAttachPoint=\"_esignAuditContainer\"></div>"+
						    "</div>"+
						"</div>",
						
		widgetsInTemplate: true,
		initialized: false,
		buildEdited: false,
		verdicts: [],
		historyLabel:Constants.getMessage("labelViewHistory"),	
		mainContentLabel:Constants.getMessage("labelResultsOverview"),
		labelCategories: Constants.getMessage("labelCategories"),
		labelPassed: Constants.getMessage("labelPassedStates"),
		labelFailed: Constants.getMessage("labelFailedStates"),
		labelBlocked: Constants.getMessage("labelBlocked"),
		labelInProgress: Constants.getMessage("labelInProgress"),
		labelInconclusive: Constants.getMessage("labelInconclusive"),
		labelincomplete: Constants.getMessage("labelincomplete"),
		labeldeferred: Constants.getMessage("labeldeferred"),
		labelpermFailed: Constants.getMessage("labelpermFailed"),		
		labelPartiallyBlocked:Constants.getMessage("labelPartiallyBlocked"),
		labelPaused:Constants.getMessage("labelPaused"),
		labelError:Constants.getMessage("labelError"),		
		
		constructor: function(){
			this.resourceLinks = [];
		},
		
		postCreate: function(){
			this._resultsInitialized = false;
			this._supportsArtifactSummary = true;
			this._supportsComprehensive  = false;
			this._supportsHistory = true;
			this._supportsTableSummary = false;
			this.allowSavingAfterBuildChange = false;
			this.pdfPrintType = "testsuitelog";
            this.connect(this.viewHeaderNode, "_selectHistoryContent", "_historySelected"); 
            this.connect(this.viewHeaderNode, "_selectMainContent", "_contentSelected");
			this.connect(this.viewHeaderNode, "onTitleEdited", "_onTitleChange");
			this.viewHeaderNode.useDualContents = true;
			
			this._loadWorkflow();

			//this._historySection.style.display="none";
			this._lockButton = this.viewHeaderNode.addLeftViewAction(Constants.getMessage("labelLock"), dojo.hitch(this, "_onLock"), null,  "lock-icon-image");  		
		},
		
		_loadWorkflow:function(){
			WorkflowManager.reloadWorkflows(dojo.hitch(this, "_loadConstraint"));
		},
		
		_loadConstraint:function(){
			ConstraintsUtil.loadConstraints(Constants.TYPE_SUITE_LOG, this.getTeamAreaItemId(),dojo.hitch(this, "_loadResultGroup"));
		},
		
		_loadResultGroup: function(){
            var args = {};
            if(this.suiteId){
                args.id = this.suiteId;
            }else if(this.itemId){
                args.itemId = this.itemId;
            }
			if(this.includeArchived){
				args.includeArchived = this.includeArchived;
			}
            args.includeCustomAttributes = true;
            args.includeResult = false;
            args.includeElements = false;
            args.includeFullResult = false;
            args.includeRequest = false;
            args.includeTestcase = false;
            args.resolveTestSuite = true;
            args.includeTestCaseCounts = true;
			args.includeArchived = true;
			args.resolveVariables = true;
            var responseHandler = new ERGMapper(this, "initialize", "_error");
            ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
		},

        _handleRefreshAction: function() {
            if (this.isDirty()) {
                var confirmDialog = new ConfirmationDialog({
                    message: Constants.getMessage("labelConfirmRefreshArtifact"),
                    primaryTitle: Constants.getMessage("labelConfirmation"),
                    okCallback: dojo.hitch(this, "_reloadEditor")
                });
                confirmDialog.open();
            }
            else {
                this._reloadEditor();
            }                        
        },

        _reloadEditor: function(){
            if (this.viewHeaderNode) 
                this.viewHeaderNode.clearStatus();
            this._setDirty(false);
            this._loadResultGroup();
        },
        		
		initialize: function(erGroup){
			if(erGroup && erGroup.length > 0){
				this.erGroup = erGroup[0];
				this.suiteId = erGroup[0].id;
			}
			this._stateValue = this.erGroup ? this.erGroup.workflowState : null;
            // clear the team & state info attribute. We need to recreate   
            this.teamAreaSelector = null;
            this._stateTxt = null;
            this.viewHeaderNode.clearInfoAttributes();
            this.viewHeaderNode.clearExtraInfoAttributes();
            if(!this._resultsInitialized){
				this._updateResultStates(this.parentController.getResultStates());
			}	
			this.fillDetails();
			// Get the build record information via OSLC request
			ResourceLinkService.getBuildRecordFromResult(ResourceLinkService.TAG_TSRESULT, ArtifactURIUtil.getTestSuiteResultURI(this.getVersionableItemId()), 
				dojo.hitch(this, function(buildInfo) {
					if(buildInfo) {
						this.setBuildLinkOnclick(buildInfo.uri);
						this.buildName = buildInfo.summary;
						this.buildValue.data = buildInfo.summary;
					} else {
						if(this.buildLink && this.buildLink.href)
							this.buildLink.removeAttribute("href");
						this.buildValue.data = this.buildName = Constants_getMessage("labelUnassigned");
					}
					if (this.buildLink) {
						this.buildLink.title = Constants_getMessage("labelBuild");
					}
				})
			);
			this._resultGroupLoaded = true;
			var title = this.erGroup.name;
			if (!this.erGroup.clonedForSnapshot && this.erGroup.archived && !this.erGroup.purged) {
				title = title + " (" + Constants.getMessage("labelDeleted") + ")";
			}
			this.viewHeaderNode.setTitleEditable(this.isEditable());
			this.viewHeaderNode.setTitle(title);
			if(!this.initialized){
				this.viewHeaderNode.setCSHelpId("rqm_suite_results_overview.html");
				this.viewHeaderNode.setIconClass("ewiresult-icon-48");
				this.viewHeaderNode.setTypeLabel(Constants.getMessage("labelTestSuite"));
				this.viewHeaderNode.setID(this.erGroup.id);
				var printMenu = PrintHelper.buildPrintMenu(
			        this, "_submitPrintJob", 
			        this._supportsArtifactSummary, this._supportsComprehensive, this._supportsHistory, this._supportsTableSummary, true);
    			
				this._pdfButton = this.viewHeaderNode.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "_submitPrintJob"), null, "pdf-icon-image", printMenu);
				this._pdfHistoryButton = this.viewHeaderNode.addLeftViewAction(Constants.getCommonMessage("printLabelHistory"), dojo.hitch(this, "_submitPrintJob", "history", "application/pdf", true), null, "pdf-icon-image");
				this._pdfHistoryButton.addClass("hidden"); //initially hidden
                this._refreshAction = this.viewHeaderNode.addLeftViewAction(Constants.getMessage("labelRefresh"), dojo.hitch(this, "_handleRefreshAction"), null, "refresh-icon-image");
				if(this._isPermitted()){
					this.cancelButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelCancel"), dojo.hitch(this, "onCancel"), null, null);
					this.saveButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
					this.saveButton.setDisabled(true);
					this.cancelButton.setDisabled(true);
				}
				this.initialized = true;
			}
            this._createLockUnlockButton();
			this._updateBrowserTitle();
            // update tab label
            var label = this._getTabLabel();
            dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, label, null]);
            
			if(CommonUtility.isIterationSupportActivated()){
				this.setTeamArea((this.erGroup && this.erGroup.teamArea)?this.erGroup.teamArea:null);
			}
			
			if (this._deferredInvalidStateNoticeHandler) {
				this._deferredInvalidStateNoticeHandler();
				this._deferredInvalidStateNoticeHandler = undefined;
			}
		},
		
		_submitPrintJob: function(printType, mimeType) {		    
			var historyArgs = {};
			if(printType && printType.indexOf("history")==0 && this._historyMainPanel){
				historyArgs = this._historyMainPanel.getCurrentHistoryParameters();
			}
            var artifactList = [PrintHelper.createArtifactObject(this.suiteId, null)];               
            PrintHelper.submitPrintJob(printType, this.pdfPrintType, artifactList, null, null, historyArgs, null, null);            
		},
		
		_updateResultStates: function(verdicts) {		
			var len = dojo.isArray(verdicts) ? verdicts.length : 0;			
			for(var i=0;i<len; i++) {
				if (verdicts[i].id == ExecutionResultStates.PASSED){
					if(verdicts[i].name != this.labelPassed){
						this.labelPassed = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.FAILED){
					if(verdicts[i].name != this.labelFailed){
						this.labelFailed = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.BLOCKED){
					if(verdicts[i].name != this.labelBlocked){
						this.labelBlocked = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.INCONCLUSIVE){
					if(verdicts[i].name != this.labelInconclusive){
						this.labelInconclusive = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.IN_PROGRESS){
					if(verdicts[i].name != this.labelInProgress){
						this.labelInProgress = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.DEFERRED){
					if(verdicts[i].name != this.labeldeferred){
						this.labeldeferred = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.PERM_FAILED){
					if(verdicts[i].name != this.labelpermFailed){
						this.labelpermFailed = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.ERROR){
					if(verdicts[i].name != this.labelError){
						this.labelError = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.PAUSED){
					if(verdicts[i].name != this.labelPaused){
						this.labelPaused = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.INCOMPLETE){
					if(verdicts[i].name != this.labelincomplete){
						this.labelincomplete = verdicts[i].name;
					}
				}else if (verdicts[i].id == ExecutionResultStates.PARTIALLY_BLOCKED){
					if(verdicts[i].name != this.labelPartiallyBlocked){
						this.labelPartiallyBlocked = verdicts[i].name;
					}
				}					
			}
			this._resultsInitialized = true;		
		},
		
		fillDetails: function(){
			var doc = document;
			var outerTable = doc.createElement('table');
			dojo.style(outerTable, "width", "100%");
					
			var addSingleRow = doc.createElement("tr");
			dojo.style(addSingleRow, "width", "100%");
            dojo.style(addSingleRow, "lineHeight", "1.5em");
			outerTable.appendChild(addSingleRow);
			
			var suiteDetailsCell = doc.createElement("td");
			dojo.style(suiteDetailsCell, {
	            'width': '50%',
	            'verticalAlign': 'top'	            
	        });
			addSingleRow.appendChild(suiteDetailsCell);	
			
			var countTestCasesCell = doc.createElement("td");
			dojo.style(countTestCasesCell, {
	            'width': '50%',
	            'verticalAlign': 'top'	            
	        });	
			addSingleRow.appendChild(countTestCasesCell);
			//add count Test cases details like test cases passed, failed..
			if(this.erGroup.countsTestCase){
				var countTestCasesTable = doc.createElement('table');
				countTestCasesCell.appendChild(countTestCasesTable);
				countTestCasesTable.width = "100%";
				this._constructCountTestCasesTable(countTestCasesTable);
			}
			//add Table for suite details
			var table = doc.createElement('table');
			suiteDetailsCell.appendChild(table);
			table.width = "100%";

			var tbody = doc.createElement('tbody');
			table.appendChild(tbody);
			//Verdict row
			var verdictRow = this._getEmptyRow(doc);
			verdictRow.width = "100%";
			tbody.appendChild(verdictRow);
			var verdictLabelCell = this._getEmptyCell(doc);
			verdictLabelCell.width = "45%";
			var verdictEmptyCell = this._getEmptyCell(doc);
			verdictEmptyCell.width = "5%";
			var verdictValueCell = this._getEmptyCell(doc);
			verdictValueCell.width = "50%";
			verdictRow.appendChild(verdictLabelCell);
			verdictRow.appendChild(verdictEmptyCell);
			verdictRow.appendChild(verdictValueCell);
			var verdictLabel = doc.createElement('label');
			verdictLabel.setAttribute("for","id-" + Constants.getMessage("labelOverallVerdict"));
			verdictLabel.innerHTML = Constants.getMessage("labelOverallVerdict")+Constants.getMessage("labelColen");
			this.verdictImg = doc.createElement('img');
			if (this.erGroup.state) {
			this.verdictImg.src = Utility.getImageForState(this.erGroup.state.id);
			this.verdictImg.alt = "";
			}
			verdictLabelCell.appendChild(verdictLabel);
			verdictEmptyCell.appendChild(this.verdictImg);
			if(!this.isEditable()){
				this.verdictValue = doc.createElement('label');
				this.verdictValue.setAttribute("id","id-" + Constants.getMessage("labelOverallVerdict"));
				this.verdictValue.innerHTML = this.erGroup.state ? this.erGroup.state.name : "";
				dojo.style(this.verdictValue, "fontWeight", "bold");
				verdictValueCell.appendChild(this.verdictValue);
			}else{
				this.verdictCombo = doc.createElement('select');
				this.verdictCombo.setAttribute("id","id-" + Constants.getMessage("labelOverallVerdict"));
				verdictValueCell.appendChild(this.verdictCombo);
				dojo.style(this.verdictCombo, "fontWeight", "bold");
				this._setResultStates(this.parentController.getResultStates());
				this.connect(this.verdictCombo, "onchange", this._updateVerdictIcon);
			}
			
			//StartTime row
			var startTimeRow = this._getEmptyRow(doc);
			startTimeRow.width = "100%";
			tbody.appendChild(startTimeRow);
			var stLabelCell = this._getEmptyCell(doc);
			stLabelCell.width = "45%";
			var stEmptyCell = this._getEmptyCell(doc);
			stEmptyCell.width = "5%";
			var stValueCell = this._getEmptyCell(doc);
			stValueCell.width = "50%";
			startTimeRow.appendChild(stLabelCell);
			startTimeRow.appendChild(stEmptyCell);
			startTimeRow.appendChild(stValueCell);
			var stLabel = doc.createTextNode(Constants.getMessage("labelStartTime")+Constants.getMessage("labelColen"));
			var stValue = doc.createTextNode(Utility._convertLongToDate(this.erGroup.startTime));
			stLabelCell.appendChild(stLabel);
			stValueCell.appendChild(stValue);
			
			//EndTime row
			var endTimeRow = this._getEmptyRow(doc);
			endTimeRow.width = "100%";
			tbody.appendChild(endTimeRow);
			var endLabelCell = this._getEmptyCell(doc);
			endLabelCell.width = "45%";
			var endEmptyCell = this._getEmptyCell(doc);
			endEmptyCell.width = "5%";
			var endValueCell = this._getEmptyCell(doc);
			endValueCell.width = "50%";
			endTimeRow.appendChild(endLabelCell);
			endTimeRow.appendChild(endEmptyCell);
			endTimeRow.appendChild(endValueCell);
			var endLabel = doc.createTextNode(Constants.getMessage("labelEndTime")+Constants.getMessage("labelColen"));
			endLabelCell.appendChild(endLabel);
			if (this.erGroup.endTime > 0) {
				var endValue = doc.createTextNode(Utility._convertLongToDate(this.erGroup.endTime));
				endValueCell.appendChild(endValue);
			}
			
			//Total Run Time row
			var totalTimeRow = this._getEmptyRow(doc);
			totalTimeRow.width = "100%";
			tbody.appendChild(totalTimeRow);
			var totalLabelCell = this._getEmptyCell(doc);
			totalLabelCell.width = "45%";
			var totalEmptyCell = this._getEmptyCell(doc);
			totalEmptyCell.width = "5%";
			var totalValueCell = this._getEmptyCell(doc);
			totalValueCell.width = "50%";
			totalTimeRow.appendChild(totalLabelCell);
			totalTimeRow.appendChild(totalEmptyCell);
			totalTimeRow.appendChild(totalValueCell);
			var totalLabel = doc.createTextNode(Constants.getMessage("labelTotalRunTime")+Constants.getMessage("labelColen"));
			var duration = this.erGroup.endTime - this.erGroup.startTime;
			var totalValue = doc.createTextNode(Utility.getTimeDifferenceInHrMinSec(duration > 0 ? duration : 0));
			totalLabelCell.appendChild(totalLabel);
			totalValueCell.appendChild(totalValue);
			
			//Mode row
			var modeRow = this._getEmptyRow(doc);
			modeRow.width = "100%";
			tbody.appendChild(modeRow);
			var modeLabelCell = this._getEmptyCell(doc);
			modeLabelCell.width = "45%";
			var modeEmptyCell = this._getEmptyCell(doc);
			modeEmptyCell.width = "5%";
			var modeValueCell = this._getEmptyCell(doc);
			modeValueCell.width = "50%";
			modeRow.appendChild(modeLabelCell);
			modeRow.appendChild(modeEmptyCell);
			modeRow.appendChild(modeValueCell);
			var modeLabel = doc.createElement('label');
			modeLabel.innerHTML = Constants.getMessage("labelExecutionMode")+Constants.getMessage("labelColen");
			var mode = this.erGroup.sequentialExecution ? Constants.getMessage("labelSequential") : Constants.getMessage("labelParallel");
			var modeValue = doc.createTextNode(mode);
			modeLabelCell.appendChild(modeLabel);
			modeValueCell.appendChild(modeValue);
			
			//Pass Variables Row
			var passVariablesRow = this._getEmptyRow(doc);
			passVariablesRow.width = "100%";
			tbody.appendChild(passVariablesRow);
			var passVariablesLabelCell = this._getEmptyCell(doc);
			passVariablesLabelCell.width = "45%";
			var passVariablesEmptyCell = this._getEmptyCell(doc);
			passVariablesEmptyCell.width = "5%";
			var passVariablesValueCell = this._getEmptyCell(doc);
			passVariablesValueCell.width = "50%";
			passVariablesRow.appendChild(passVariablesLabelCell);
			passVariablesRow.appendChild(passVariablesEmptyCell);
			passVariablesRow.appendChild(passVariablesValueCell);
			var passVariablesLabel = doc.createElement('label');
			passVariablesLabel.innerHTML = Constants.getMessage("labelExecVars")+Constants.getMessage("labelColen");
			var passVariables = this.erGroup.passVariables ? Constants.getMessage("labelVariablesPassedBetweenScripts") : Constants.getMessage("labelVariablesNotPassedBetweenScripts");
			var passVariablesValue = doc.createTextNode(passVariables);
			passVariablesLabelCell.appendChild(passVariablesLabel);
			passVariablesValueCell.appendChild(passVariablesValue);
			
			//HaltTest Row
			var haltOnFailureRow = this._getEmptyRow(doc);
			haltOnFailureRow.width = "100%";
			tbody.appendChild(haltOnFailureRow);
			var haltOnFailureLabelCell = this._getEmptyCell(doc);
			haltOnFailureLabelCell.width = "45%";
			var haltOnFailureEmptyCell = this._getEmptyCell(doc);
			haltOnFailureEmptyCell.width = "5%";
			var haltOnFailureValueCell = this._getEmptyCell(doc);
			haltOnFailureValueCell.width = "50%";
			haltOnFailureRow.appendChild(haltOnFailureLabelCell);
			haltOnFailureRow.appendChild(haltOnFailureEmptyCell);
			haltOnFailureRow.appendChild(haltOnFailureValueCell);
			var haltOnFailureLabel = doc.createElement('label');
			haltOnFailureLabel.innerHTML = Constants.getMessage("labelHaltOnFailure2")+Constants.getMessage("labelColen");
			var haltOnFailure = this.erGroup.haltOnFailure ? Constants.getMessage("labelYes") : Constants.getMessage("labelNo");
			var haltOnFailureValue = doc.createTextNode(haltOnFailure);
			haltOnFailureLabelCell.appendChild(haltOnFailureLabel);
			haltOnFailureValueCell.appendChild(haltOnFailureValue);
			
			//TestCell Row
			var cellRow = this._getEmptyRow(doc);
			cellRow.width = "100%";
			tbody.appendChild(cellRow);
			var cellLabelCell = this._getEmptyCell(doc);
			cellLabelCell.width = "45%";
			var cellEmptyCell = this._getEmptyCell(doc);
			cellEmptyCell.width = "5%";
			var cellValueCell = this._getEmptyCell(doc);
			cellValueCell.width = "50%";
			cellRow.appendChild(cellLabelCell);
			cellRow.appendChild(cellEmptyCell);
			cellRow.appendChild(cellValueCell);
			var cellLabel = doc.createElement('label');
			cellLabel.innerHTML = Constants.getMessage("labelTestCell")+Constants.getMessage("labelColen");
			var cellText = this.erGroup.testcellItemId ? this.erGroup.testcellName : Constants.getMessage("labelUnassigned");
			var cellAnchor = doc.createElement('a');
			var cellValue = "";
			if(this.erGroup.testcellItemId){
				cellAnchor.href = TestCellUriUtil.getEditTestCellURI(this.erGroup.testcellItemId);
				cellAnchor.appendChild(doc.createTextNode(cellText));
				cellValue = cellAnchor;
				
			}else{
				cellValue = doc.createTextNode(cellText);
			}
			cellLabelCell.appendChild(cellLabel);
			cellValueCell.appendChild(cellValue);
			
			//Test Plan
			var planRow = this._getEmptyRow(doc);
			planRow.width = "100%";
			tbody.appendChild(planRow);
			var planLabelCell = this._getEmptyCell(doc);
			planLabelCell.width = "45%";
			var planEmptyCell = this._getEmptyCell(doc);
			planEmptyCell.width = "5%";
			var planValueCell = this._getEmptyCell(doc);
			planValueCell.width = "50%";
			planRow.appendChild(planLabelCell);
			planRow.appendChild(planEmptyCell);
			planRow.appendChild(planValueCell);
			var planLabel = doc.createElement('label');
			planLabel.innerHTML = Constants.getMessage("labelTestPlan")+Constants.getMessage("labelColen");
			planLabelCell.appendChild(planLabel);
			var erg = this.erGroup;
			var testPlanName = CommonUtility.encodeHTMLTags(erg.testPlanName ? erg.testPlanName : "");
			if (this.erGroup.testPlanId) {
				this.planAnchor = doc.createElement('a');
				this.planAnchor.innerHTML = testPlanName;
				if(this.erGroup.testPlanVersionableItemId){
	                this._tpResLink = new jazz.ui.ResourceLink({
	                    label: testPlanName,
						retainLinkText: true,
	                    uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_PLAN, erg.testPlanVersionableItemId),
	                    presentationUri: erg.testPlanSnapshotRevision ? PlanningUtility.getTestPlanURI({uid : erg.testPlanItemId, revision : erg.testPlanSnapshotRevision}) :
										 PlanningUtility.getTestPlanURI({id: erg.testPlanId})
	                }, this.planAnchor);
	                this.resourceLinks.push(this._tpResLink);
				}else{
					this.planAnchor.href = Utility.getTestPlanURI({id:this.erGroup.testPlanId});					
				}
				this.planAnchor.title = Constants_getMessage("labelTestPlan");
				planValueCell.appendChild(this.planAnchor);				
			}else {
				var planValue = doc.createTextNode(testPlanName);
				planValueCell.appendChild(planValue);
			}
				
			//Build Record
			var buildRow = this._getEmptyRow(doc);
			buildRow.width = "100%";
			tbody.appendChild(buildRow);
			var buildLabelCell = this._getEmptyCell(doc);
			buildLabelCell.width = "45%";
			var buildEmptyCell = this._getEmptyCell(doc);
			buildEmptyCell.width = "5%";
			var buildValueCell = this._getEmptyCell(doc);
			buildValueCell.width = "50%";
			buildRow.appendChild(buildLabelCell);
			buildRow.appendChild(buildEmptyCell);
			buildRow.appendChild(buildValueCell);
			var buildLabel = doc.createElement('label');
			buildLabel.innerHTML = Constants.getMessage("labelBuild")+Constants.getMessage("labelColen");
			buildLabelCell.appendChild(buildLabel);
			
			this.buildName = Constants_getMessage("labelUnassigned");			
			this.buildValue = doc.createTextNode(this.buildName);
			this.buildItemId = null;
			
			if(this.buildLink){
				dojox.xml.parser.removeChildren(this.buildLink);
			}

			if(this.isEditable()){
				this.buildLink = document.createElement('a');
				this.buildLink.title = Constants.getMessage("labelBuild");					
				this.editBuildEvent2 = this.connect(this.buildLink, "onclick", "onBuildAddClick");
				this.editBuildEnterEvent2 = this.connect(this.buildLink, "onkeypress",dojo.hitch(this,this._onEnterBuildChange,"edit"));
				dojo.style(this.buildLink, "cursor", "pointer");
				this.buildLink.setAttribute("tabIndex", 0);
			}
			if(this.buildLink && this.buildLink.href)
				this.buildLink.removeAttribute("href");
		
			if(this.buildLink){
				this.buildLink.appendChild(this.buildValue);
				buildValueCell.appendChild(this.buildLink);
			}else{
				buildValueCell.appendChild(this.buildValue);
			}
			
			if(this.isEditable()){
				var emptyLabel = doc.createElement('label');
				emptyLabel.innerHTML = " ";
				buildValueCell.appendChild(emptyLabel);

                this.editImg = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                    imgSrc: CommonImageCache.EDIT,
                    title: Constants_getMessage("labelChangeAssociatedBuild"),
                    onClick: dojo.hitch(this, "onBuildAddClick")
                });
				this.editImg.focusNode.setAttribute("tabIndex", 0);
				buildValueCell.appendChild(this.editImg.domNode);
				
                this.clearImg = new com.ibm.asq.common.web.ui.internal.widgets.Button({
                    imgSrc: CommonImageCache.CLEAR_FILTER_ENABLED,
                    title: Constants_getMessage("labelClearAssociatedBuild"),
                    onClick: dojo.hitch(this, "_onBuildClearClick")
                });
                this.clearImg.focusNode.setAttribute("tabIndex", 0);
				buildValueCell.appendChild(this.clearImg.domNode);
			}
			
			//Test Phase
			var phaseRow = this._getEmptyRow(doc);
			phaseRow.width = "100%";
			tbody.appendChild(phaseRow);
			var phaseLabelCell = this._getEmptyCell(doc);
			phaseLabelCell.width = "45%";
			var phaseEmptyCell = this._getEmptyCell(doc);
			phaseEmptyCell.width = "5%";
			var phaseValueCell = this._getEmptyCell(doc);
			phaseValueCell.width = "50%";
			phaseRow.appendChild(phaseLabelCell);
			phaseRow.appendChild(phaseEmptyCell);
			phaseRow.appendChild(phaseValueCell);
			var phaseLabel = doc.createElement('label');
			phaseLabel.innerHTML = Constants.getMessage("labelIteration")+Constants.getMessage("labelColen");
			var phaseValue = doc.createTextNode(this.erGroup.phaseName?this.erGroup.phaseName:"");
			phaseLabelCell.appendChild(phaseLabel);
			phaseValueCell.appendChild(phaseValue);
			
			//Test Suite
			var suiteRow = this._getEmptyRow(doc);
			suiteRow.width = "100%";
			tbody.appendChild(suiteRow);
			var suiteLabelCell = this._getEmptyCell(doc);
			suiteLabelCell.width = "45%";
			var suiteEmptyCell = this._getEmptyCell(doc);
			suiteEmptyCell.width = "5%";
			var suiteValueCell = this._getEmptyCell(doc);
			suiteValueCell.width = "50%";
			suiteRow.appendChild(suiteLabelCell);
			suiteRow.appendChild(suiteEmptyCell);
			suiteRow.appendChild(suiteValueCell);
			var suiteLabel = doc.createElement('label');
			suiteLabel.innerHTML = Constants.getMessage("labelTestSuite") + Constants.getMessage("labelColen");
			suiteLabelCell.appendChild(suiteLabel);
			var testSuiteName = CommonUtility.encodeHTMLTags(erg.testSuiteName ? erg.testSuiteName : "");
			if (erg.testSuiteId) {
				this.suiteAnchor = doc.createElement('a');
				this.suiteAnchor.innerHTML = testSuiteName;
				if(erg.testSuiteVersionableItemId){
	                this._tsResLink = new jazz.ui.ResourceLink({
	                    label: testSuiteName,
						retainLinkText: true,
	                    uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_SUITE, this.erGroup.testSuiteVersionableItemId),
	                    presentationUri: erg.testSuiteSnapshotRevision ? PlanningUtility.getTestSuiteURI(erg.testSuiteVersionableItemId, erg.testSuiteSnapshotRevision) :
										 PlanningUtility.getTestSuiteURI(erg.testSuiteId)
	                }, this.suiteAnchor);
	                this.resourceLinks.push(this._tsResLink);
				}else{
					this.suiteAnchor.href = Utility.getTestSuiteURI(this.erGroup.testSuiteId);
				}
				this.suiteAnchor.title = Constants_getMessage("labelTestSuite");
				suiteValueCell.appendChild(this.suiteAnchor);				
			}else {
				var suiteValue = doc.createTextNode(testSuiteName);
				suiteValueCell.appendChild(suiteValue);
			}
			
			//TSER
			var tserRow = this._getEmptyRow(doc);
			tserRow.width = "100%";
			tbody.appendChild(tserRow);
			var tserLabelCell = this._getEmptyCell(doc);
			tserLabelCell.width = "45%";
			var tserEmptyCell = this._getEmptyCell(doc);
			tserEmptyCell.width = "5%";
			var tserValueCell = this._getEmptyCell(doc);
			tserValueCell.width = "50%";
			tserRow.appendChild(tserLabelCell);
			tserRow.appendChild(tserEmptyCell);
			tserRow.appendChild(tserValueCell);
			var tserLabel = doc.createElement('label');
			tserLabel.innerHTML = Constants.getMessage("labelSuiteExecutionRecord") + Constants.getMessage("labelColen");
			tserLabelCell.appendChild(tserLabel);
			var tserName = CommonUtility.encodeHTMLTags(erg.tserName ? erg.tserName : "");
			if (erg.tserId) {
				this.tserAnchor = doc.createElement('a');
				this.tserAnchor.innerHTML = tserName;
				
	                this._tserResLink = new jazz.ui.ResourceLink({
	                    label: tserName,
						retainLinkText: true,
	                    uri: CommonUtility.getQmResourceLinkUri(CommonUtility.TYPE_SUITE_RECORD, erg.tserItemId),
	                    presentationUri: Utility.getSERURI(erg.tserId, null, null)
	                }, this.tserAnchor);
	                this.resourceLinks.push(this._tserResLink);
				
				this.tserAnchor.title = Constants_getMessage("labelSuiteExecutionRecord");
				tserValueCell.appendChild(this.tserAnchor);				
			}else {
				var tserValue = doc.createTextNode(tserName);
				tserValueCell.appendChild(tserValue);
			}
			
			//TestEnvironment Section            
            this._createEnvironmentSection();
			
			//Weight
			var weightRow = this._getEmptyRow(doc);
			weightRow.width = "100%";
			table.appendChild(weightRow);
			var weightLabelCell = this._getEmptyCell(doc);
			weightLabelCell.width = "45%";
			var weightEmptyCell = this._getEmptyCell(doc);
			weightEmptyCell.width = "5%";
			var weightValueCell = this._getEmptyCell(doc);
			weightValueCell.width = "50%";
			weightRow.appendChild(weightLabelCell);
			weightRow.appendChild(weightEmptyCell);
			weightRow.appendChild(weightValueCell);
			var weightLabel = doc.createElement('label');
			weightLabel.innerHTML = Constants.getMessage("labelWeight")+Constants.getMessage("labelColen");
			this.weightValue = doc.createTextNode(this.erGroup.weight);
			weightLabelCell.appendChild(weightLabel);
			weightValueCell.appendChild(this.weightValue);
			
			if(this.isEditable()){
				var emptyLabel = doc.createElement('label');
				emptyLabel.innerHTML = " ";
				weightValueCell.appendChild(emptyLabel);	
				var pointLabel = doc.createElement('label');
				pointLabel.innerHTML = Constants.getMessage("labelPoints");
				weightValueCell.appendChild(pointLabel);
				var args = {
	                    label: Constants.getMessage("labelCalculateWeight"),
	                    onClick: dojo.hitch(this, "_handleCalculateWeightClick"),
	                    iconClass: "calculate-weight-icon",
	                    showLabel: false
	            };
	            this._calculateWeightActionButton = new Button(args);            
	            weightValueCell.appendChild(this._calculateWeightActionButton.domNode);
			}
			dojox.xml.parser.removeChildren(this._topSection);
			this._topSection.appendChild(outerTable);
			this._createWeightSection();
			this._createTable();
            
            // create the state/owner lines in the header info area
			if (!this._stateTxt) {
                this.setState(this.erGroup.workflowState);
			}
			//Originator
			var originator = this.erGroup ? (this.erGroup.originator ? this.erGroup.originator.name : Constants.getMessage("labelOriginatorNotRecorded")) : EditorUtil.getCurrentContributor().name;
			var originatorlabel = document.createElement("span");
            originatorlabel.innerHTML = Constants.getMessage("labeloriginatorLabel");
            this._originator = document.createTextNode(originator);
            this._originatorContainer = this.viewHeaderNode.addInfoAttribute(originatorlabel, this._originator);
			
			var ownerLabel = doc.createElement('label');
            ownerLabel.innerHTML = Constants.getMessage("labelOwner")+Constants.getMessage("labelColen");
            
            var ownerSpan = doc.createElement("span");
			var ownerItemId = this.erGroup.owner?this.erGroup.owner.itemId:null;
			this.ownerNode = new ContributorSelect({
				defaultValue: ownerItemId,
				hideAdminGuest: true,
				onValueChanged: dojo.hitch(this, "_onChange")
			});			
						
			ownerSpan.appendChild(this.ownerNode.domNode);
			            
            this.viewHeaderNode.appendToExistingInfoAttribute(this._originatorContainer, ownerLabel, ownerSpan);

			this._categorySection = new com.ibm.rqm.planning.web.ui.internal.view.construction.CategoriesSection({
				artifact: this.erGroup,
				parentEditor: this,
				artifactType: Constants.MODEL_TYPE_SUITE_LOG,
				typeName:Constants.TYPE_SUITE_LOG,
				scopeName: "TESTSUITE_RESULT",
				selectDefaults:this.erGroup && this.erGroup.categories != null? false : true,
				onChange:dojo.hitch(this,"_setDirty",true)
			});
			this._categorySection.initialize(this.isEditable());
			var categoryparams ={
				title: Constants.getMessage("labelCategories"),
				summary: this._categorySection.domNode,
				helpContextId: "rqm_execution_categories_help.html"
			};
			var section = this._createCollapsibleSection(categoryparams);
			dojox.xml.parser.removeChildren(this.categoriesContainer);
			this.categoriesContainer.appendChild(section.domNode);
			this._createExecutionAuditContent();
			this._updateReviewSection();
			this._createExecutionVariableSection();
			var teamArea = this.getTeamAreaItemId();
        	var isLockPreconditionEnabled = ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.ExecutionEsignLockChange, Constants.TYPE_SUITE_LOG, teamArea);
        	var isFormalReviewPreconditionEnabled = ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.ESignFormalReviewSuiteResults, Constants.TYPE_SUITE_LOG, teamArea);
            if (isLockPreconditionEnabled ||isFormalReviewPreconditionEnabled){
            	this._createESignAuditSection();
            }
		},
		_onChange: function(args)
		{
			this._setDirty(true);			
		},
		
		_createExecutionAuditContent: function(){
			var auditItems = [];
            if(this.erGroup && this.erGroup.historicalTestSuite){
                var colon = Constants.getMessage("labelColen");
            	if(this.erGroup.historicalTestPlan && this.erGroup.historicalTestPlan.workflowState){
            		auditItems.push({
						label: Constants.getMessage("labelTestPlanStateAtExecution") + colon, 
						value: WorkflowManager.getStateNameById(this.erGroup.historicalTestPlan.workflowState, Constants.TYPE_PLAN)
						});
                } else {
                    auditItems.push({
                        label: Constants.getMessage("labelTestPlanStateAtExecution") + colon, 
                        value: Constants.getMessage("labelNotFromPlan")
                        });
            	}
        		auditItems.push({
    					label: Constants.getMessage("labelTestSuiteStateAtExecution") + colon, 
    					value: WorkflowManager.getStateNameById(this.erGroup.historicalTestSuite.workflowState, Constants.TYPE_SUITE)
    					});
            }
            if (auditItems.length){
                this._auditWidget = new ExecutionAuditContent({items:auditItems, startTime:this.erGroup.startTime}); 
                var auditParams = {
                		title: Constants_getMessage("labelStateWhenRun"),
        				summary: this._auditWidget.domNode,
        				helpContextId: "rqm_execution_auditSection_help.html"
                };
                dojox.xml.parser.removeChildren(this._auditContainer);
                var section = this._createCollapsibleSection(auditParams,this._auditContainer);
                this._auditContainer.appendChild(section.domNode);
            }
		},
		
		_createESignAuditSection: function(){
			var esigns = this.erGroup && this.erGroup.eSignatureRecords ? this.erGroup.eSignatureRecords : []; 
        	this._esignAuditSection = new com.ibm.rqm.planning.web.ui.internal.view.table.ESignAuditTableView({eSignatureRecords : esigns});
        	var esignParams = {
            		title: Constants_getMessage("RQM-KEY-ESIGN-AUDIT-TITLE"),
    				summary: this._esignAuditSection.domNode,
    				helpContextId: null
            };
        	CommonUtility.destroyWidgetsFromNode(this._esignAuditContainer);
            dojox.xml.parser.removeChildren(this._esignAuditContainer);
        	var section = this._createCollapsibleSection(esignParams, this._esignAuditContainer);
        	this._esignAuditContainer.appendChild(section.domNode);
		},
		
		isSnapshot: function(){
			if(this.erGroup && this.erGroup.clonedForSnapshot){
				return true;
			}else{
				return false;
			}
		},
		
		isArchived: function() {
			if(this.erGroup && this.erGroup.archived){
				return true;
			}else{
				return false;
			}
		},
        
		_updateReviewSection: function(){
            this._reviewSection = new com.ibm.rqm.process.web.ui.internal.view.extension.ReviewSection({
                parentEditor: this,
                config: {id:"com.ibm.rqm.process.editor.section.review",
                         description:"RQM-KEY-PROC-REVIEW-DESC",
                         name:"RQM-KEY-PROC-REVIEW-TITLE"}
            });
            this._reviewSection.initialize(this._isPermitted());
            var reviewparams ={
                title: Constants_getMessage("labelFormalReview"),
                summary: this._reviewSection.domNode,
                helpContextId: this._reviewSection.getHelpContextID()
            };
            CommonUtility.destroyWidgetsFromNode(this._reviewContainer);
            dojox.xml.parser.removeChildren(this._reviewContainer);
            var section = this._createCollapsibleSection(reviewparams,this._reviewContainer);
            this._reviewContainer.appendChild(section.domNode);
		},
		
		_createExecutionVariableSection: function(){
			if (!this.execVarsTable) {
				dojox.xml.parser.removeChildren(this._variablesContainer);
				var content = this.erGroup.variableMap ? this.erGroup.variableMap : [];
				this.execVarsTable = new ExecVarsTableView({
					inSection: true,
					content: content,
					editable: false,
					showFilterControl:true
				});
				dojo.style(this.execVarsTable.topBorder, "display", "none");
				dojo.style(this.execVarsTable.bottomBorder, "display", "none");
				var execVarsParams = {
					title: Constants_getMessage("labelExecVars"),
					summary: this.execVarsTable.domNode,
					helpContextId: "rqm_execution_vars_help.html"
				};
				 var section = this._createCollapsibleSection(execVarsParams, this._variablesContainer);
				 this._variablesContainer.appendChild(section.domNode);
			}
		},
		
		_onEnterBuildChange: function(identifier,e){
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13) {
				if(identifier == "edit")
					this.onBuildAddClick();
				else
					this._onBuildClearClick();
			}
		},
		
		onBuildAddClick: function(){
            var serviceProviderManager = com.ibm.rqm.defects.web.client.BuildProviderManager.getInstance();
            
            // discover dialog uri
            serviceProviderManager.getCurrentServiceProvider(dojo.hitch(this, function(currentServiceProvider){
                if (currentServiceProvider) {
                    var buildResultSelectionDialog = currentServiceProvider.services.buildResultSelectDialog;
					this.buildOslcVersion = currentServiceProvider.getOSLCCoreVersion();
                    var selectionDialogUri = buildResultSelectionDialog.uri;
                    // select an item from the selection dialog
                    var self = this;
                    var params = {
                        dialogTitle: buildResultSelectionDialog.title,
                        secondaryTitle: buildResultSelectionDialog.label1,
                        pickerURL: selectionDialogUri,
                        height: buildResultSelectionDialog.height,
                        width: buildResultSelectionDialog.width,
                        isInPicker : true,
                        onOk: function(result){
            				var selectedItems = [];
            				if(self.buildOslcVersion == "2.0"){
            					selectedItems = ItemPickerUtil.parseV2(result);
            				}else if(self.buildOslcVersion == "1.0"){
            					selectedItems = ItemPickerUtil.parse(result);
            				}
                    		if(selectedItems && selectedItems[0]) {
	                    		self.selectedBuildRecord = selectedItems[0];
	                    		self.setBuildLinkOnclick(self.selectedBuildRecord.url);
	                    		self.buildLink.title = Constants_getMessage("labelBuild");
	            				self.buildValue.data= self.selectedBuildRecord.summary;
                    		}
                    		self._setDirty(true);
                    		self.buildEdited = true;
                        },
                        onClose: function(){
                        	console.debug("Closed");
                        }
                    };
					params.OSLCCoreVersion = this.buildOslcVersion;
                    new RemoteItemPicker(params);
                }
                else {
                    // NO Build service provider is configured.
					var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': DefectsUIUtil.getMessage("msgNoneBuildProvidersConfigured")});
            		alertDialog.open();
                }
            }));
			
		},
			
		_onBuildClearClick: function(){
			this.buildName = Constants_getMessage("labelUnassigned");	
			this.buildItemId = null;
			this.selectedBuildRecord = null;
			this.buildValue.data = this.buildName;
			
			if(this.buildLink){
				if(this.buildLink.href)
				 	this.buildLink.removeAttribute("href");
				if(this.editBuildEvent2){
	    			this.disconnect(this.editBuildEvent2);
	    			this.editBuildEvent2 = null;
				}
	    		if(this.editBuildEnterEvent2){
	    			this.disconnect(this.editBuildEnterEvent2);
	    			this.editBuildEnterEvent2 = null;
				}
				this.editBuildEvent2 = this.connect(this.buildLink, "onclick", "onBuildAddClick");
				this.editBuildEnterEvent2 = this.connect(this.buildLink, "onkeypress",dojo.hitch(this,this._onEnterBuildChange,"edit"));
				this._setDirty(true);
				this.buildEdited = true;
			}	
		},
		
		setBuildLinkOnclick: function(buildUri) {
			if(this.buildLink.href)
				this.buildLink.removeAttribute("href");
    		if(this.editBuildEvent2){
    			this.disconnect(this.editBuildEvent2);
    			this.editBuildEvent2 = null;
			}
    		if(this.editBuildEnterEvent2){
    			this.disconnect(this.editBuildEnterEvent2);
    			this.editBuildEnterEvent2 = null;
			}
    		
    		// Check if the build record is provided by self RQM. If so, add the onclick function.
    		// Otherwise set it as href (RTC/External provider link)
    		if(buildUri.indexOf(dojo.getObject(Constants.PUBLIC_URL)) >= 0) {
    			var redirectFunction = function() {
        			ResourceLinkService.redirectToWebURI(buildUri, function(buildId) {
        				return BuildUiUtil.getBuildRecordURI(buildId);
        			});
        		};
        		
        		this.editBuildEvent2 = this.connect(this.buildLink, "onclick", redirectFunction);
        		this.editBuildEnterEvent2 = this.connect(this.buildLink, "onkeypress",redirectFunction);
    		} else {
    			this.buildLink.href = buildUri;
    		}
		},
		
		_createEnvironmentSection: function(){
			var erg = this.erGroup;
			var args={
					parentController: this.parentController,
					ewi: erg,
					showEnvDetails: true	//Since we need to see the name and description in ERs
			};
			
			//Get the configuration value
			var results = [];
			if(erg.elements != null && dojo.isArray(erg.elements)){
				var len = erg.elements ? erg.elements.length: 0;
				
				for(var i=0; i < len; i++){
					var workitem = erg.elements[i].workitem;
					if (workitem != null) {
						results.push(workitem);
					}
				}
			}
			args.config = results.length > 0 ? results[0] : null;
			
			//Get channel names
			var channelNames = [];
			if(erg.channels != null && dojo.isArray(erg.channels))
			{
				var channelLen = erg.channels.length;
				for(var i=0; i<channelLen; i++)
				{
					channelNames.push(erg.channels[i].name);
				}				
			}
			args.channelName = channelNames.length > 0 ? channelNames.join(",") : Constants.UNASSIGNED_CHANNEL_NAME;
						
			dojo.empty(this._testEnvironmentSection);
			var envWidget=new com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer(args);
			var params ={
				title: Constants_getMessage("labelTestEnvironment"),
				summary: envWidget.domNode,
				helpContextId: "rqm_execution_environments_help.html"
			};
			var envSection = this._createCollapsibleSection(params);
			this._testEnvironmentSection.appendChild(envSection.domNode);
			
		},
		
		_createWeightSection: function(points){
			var erg = this.erGroup;
			if(!points){
			 	points = {	maxPoints: erg.weight, 
							pointsPassed: erg.pointsPassed, 
							pointsFailed: erg.pointsFailed, 
							pointsBlocked: erg.pointsBlocked, 
							pointsInconclusive:erg.pointsInconclusive,
							pointsPermFailed: erg.pointsPermFailed, 
							pointsDeferred:erg.pointsDeferred,
							pointsAttempted:erg.pointsAttempted
						};
			}
			points.callback = dojo.hitch(this,function(){
					this._setDirty(true);
				});
			if(!this.isEditable()) 
                points.isDisabled = true;
			points.header = this.viewHeaderNode;
			this.weightSection = new  WeightSection(points);
			var params ={
					title: Constants.getMessage("labelWeightDist"),
					summary: this.weightSection.domNode,
					helpContextId: "rqm_suite_weight_dist.html"
				};

			var resultWeightSection = this._createCollapsibleSection(params);
			dojox.xml.parser.removeChildren(this._weightSection);
			this._weightSection.appendChild(resultWeightSection.domNode);
		},
		
		_handleCalculateWeightClick:function(){
			var results = this.results;
			var length = results ? results.length : 0;
			var totalPointsPassed = 0;
			var totalPointsFailed = 0;
			var totalPointsBlocked = 0;
			var totalPointsInconclusive = 0;
			var totalPointsAttempted = 0;
			var totalPointsPermFailed = 0;
			var totalPointsDeferred = 0;
        	var totalWeight = 0;	        	
			if(length > 0){
        		for(var i=0;i<length;i++){
        			var result = results[i];
        			totalWeight += result.weight;
					totalPointsPassed += result.pointsPassed;
					totalPointsFailed += result.pointsFailed;
					totalPointsBlocked += result.pointsBlocked;
					totalPointsInconclusive += result.pointsInconclusive;
					totalPointsPermFailed += result.pointsPermFailed;
					totalPointsDeferred += result.pointsDeferred;
					totalPointsAttempted += result.pointsAttempted;
        		}
				var points = {	maxPoints: totalWeight,
							pointsPassed: totalPointsPassed, 
							pointsFailed: totalPointsFailed, 
							pointsBlocked: totalPointsBlocked, 
							pointsInconclusive: totalPointsInconclusive,
							pointsPermFailed: totalPointsPermFailed,
							pointsDeferred: totalPointsDeferred, 
							pointsAttempted: totalPointsAttempted
						};
				this._createWeightSection(points);
			}
        	this.weightValue.data = totalWeight;
			this._setDirty(true);
			
		},
		
		_createTable: function(){
			if(!this._TSIResultTableView){
				var args = {
					ergId: this.erGroup.id
				};
				this._TSIResultTableView = new TSIResultTableView(args);
				
				var params ={
					title: Constants.getMessage("labelResultDetails"),
					summary: this._TSIResultTableView.domNode,
					helpContextId: "rqm_test_suite.html"
				};

				var resultDetailsSection = this._createCollapsibleSection(params);
				this._table.appendChild(resultDetailsSection.domNode);
			}else
				this._TSIResultTableView.initRunQuery();
		},
		
		getProperty: function(element){
			var value = null;
			if(element){
				value = {
					ewiId: element.workitem.id,
					configName: element.ewiConfigurationName,
					configId: element.workitem.configuration,
					weight: element.workitem.weight
				};
			}
			return value;
		},
		
		_getEmptyRow: function(doc) {
			var row = doc.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(doc, span, align) {
			var cell = doc.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ) {
				cell.align = align;
			}
			return cell;
		},
		
		_appendRowToCountTestCasesTable: function(tbody,countLable,count){
		if(this._validateTestCaseResultCount(count)){
				var doc = document;
				var testCasesCountRow = this._getEmptyRow(doc);
				testCasesCountRow.width = "100%";
				tbody.appendChild(testCasesCountRow);
				var testCasesCountLabelCell = this._getEmptyCell(doc);
				testCasesCountLabelCell.width = "45%";
				var testCasesCountEmptyCell = this._getEmptyCell(doc);
				testCasesCountEmptyCell.width = "5%";
				var testCasesCountValueCell = this._getEmptyCell(doc);
				testCasesCountValueCell.width = "50%";
				testCasesCountRow.appendChild(testCasesCountLabelCell);
				testCasesCountRow.appendChild(testCasesCountEmptyCell);
				testCasesCountRow.appendChild(testCasesCountValueCell);
				var testCasesCountLabel = doc.createElement('label');
				testCasesCountLabel.innerHTML = countLable + Constants.getMessage("labelColen");
				var testCasesCountValue = doc.createTextNode(count);
				testCasesCountLabelCell.appendChild(testCasesCountLabel);
				testCasesCountValueCell.appendChild(testCasesCountValue);
			}			
		},
		
		_validateTestCaseResultCount: function(testCaseResultCount){		
			if(!isNaN(testCaseResultCount)){
				if(parseInt(testCaseResultCount,10) >= 0){
					return true;
				}
			}
			return false;
		},
		
		_constructCountTestCasesTable: function(table){
			var doc = document;
			if(this.erGroup.countsTestCase){
				var countsTestCase = this.erGroup.countsTestCase; 
				var tbody = doc.createElement('tbody');
				table.appendChild(tbody);
				
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelPassed),countsTestCase.passed);
				
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelFailed),countsTestCase.failed);
				
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates", this.labelBlocked),countsTestCase.blocked);
				
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates", this.labelInProgress),countsTestCase.inProgress);				
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates", this.labelInconclusive),countsTestCase.inconclusive);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelincomplete),countsTestCase.incomplete);				
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelError),countsTestCase.error);				
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelPartiallyBlocked),countsTestCase.partiallyBlocked);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelpermFailed),countsTestCase.permFailed);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labeldeferred),countsTestCase.deferred);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTestCasesStates",this.labelPaused),countsTestCase.paused);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelNotStartedValue", Constants.getMessage("labelTestCases")),countsTestCase.notStarted);
			
				this._appendRowToCountTestCasesTable(tbody,Constants.getMessage("labelTotalValue", Constants.getMessage("labelTestCases")),countsTestCase.total);
				
				
			}
		},
		
		_setResultStates: function(verdicts){	
			this.verdicts = [];
			var len=verdicts.length;
			var state= this.erGroup.state;
			for(var i=0;i<len; i++) {
				var verdict = verdicts[i];
				if (verdict.visible == true) {
					this.verdicts.push({name: verdict.name, id: verdict.id,visible:verdict.visible});
					SelectUtility.add(this.verdictCombo, new Option(verdict.name, verdict.id));
				} else if (state && verdict.id == state.id) {
					this.verdicts.push({name: verdict.name, id: verdict.id, disabled: true});
					var option = new Option(verdict.name, verdict.id);
					option.disabled = true;
					SelectUtility.add(this.verdictCombo, option);
				}
			}
			if (state) {
				SelectUtility.select(this.verdictCombo, state.id);
			}
		},

		_updateVerdictIcon: function(){
			this.verdictImg.src = Utility.getImageForState(this.verdictCombo.value);
			this._setDirty(true);
		},
		
		_createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.setCSHelpId(args.helpContextId);
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},
		
		_isPermitted:function(){
            if(!this.erg_type)
                this.erg_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_SUITE_RESULT;
            if(!this.erg_perm)
                this.erg_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(this.erg_type);
			if (this.erg_perm && !this.erg_perm.edit)
                return false;
			if(this.erGroup && (this.erGroup.archived || this.erGroup.clonedForSnapshot)){
				return false;
			}
            return true;
        },
		
		isEditable:function(){
			if(!this._isPermitted()){
				return false;
			}
			
			//If not initialized yet then sure, we're saveable.
			if (this.getStateValue() == null)
				return true;
				
			if (WorkflowManager.stateBelongsToApprovedOrRetired(this.erGroup.workflowState, Constants.TYPE_SUITE_LOG) 
					&& ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, Constants.TYPE_SUITE_LOG, this.getTeamAreaItemId())) {
				return false;
			}
			return true;
		},
		validate: function(params) {
			if (dojo.trim(params.name).length == 0){
				var detailError = Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelSuiteResult"));
				this.viewHeaderNode.setStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
				return false;
			}
			var points = null;
			switch(params.state){
				case ExecutionResultStates.PASSED: 
					points = params.pointsPassed;
					break;
				case ExecutionResultStates.FAILED: 
					points = params.pointsFailed;
					break;
				case ExecutionResultStates.INCONCLUSIVE: 
					points = params.pointsInconclusive;
					break;
				case ExecutionResultStates.BLOCKED: 
					points = params.pointsBlocked;
					break;
				case ExecutionResultStates.PARTIALLY_BLOCKED:
					points = params.pointsBlocked;
					break;
			}
			if(points == 0 && !this.allowSaving){
				var verdicts = this.verdicts;
				var verdictLength = verdicts.length;
				var verdictName = "";
				var pointName = "";
				for(var i=0;i<verdictLength;i++){
					if(verdicts[i].id == params.state){
						verdictName = verdicts[i].name; //Name can be customized using ADMIN properties so fetch it
						if(params.state == ExecutionResultStates.PARTIALLY_BLOCKED){
							for(var j=0;j<verdictLength;j++){
								if(verdicts[j].id == ExecutionResultStates.BLOCKED){
									pointName = verdicts[j].name; //Name can be customized using ADMIN properties so fetch it
									break; 
								}
							} 
						}else{
							pointName = verdictName;
						}
						break; 
					}
				}
				var args = {
				    'primaryTitle': Constants.getMessage("labelConfirmation"),
		            'message': Constants.getMessage("msgStatePointValueZero", verdictName, pointName),
		            'yesCallback': dojo.hitch(this, this._allowToSave),
		            'yesCallbackData': this,
		            'noCallback': null,
		            'noCallbackData': null
		        };
		        var confirmDialog = new YesNoDialog(args);
		        confirmDialog.open();
				return false;
			}
			if (this._categorySection) {
                var st =  this._categorySection.validate();
				if (!st.status) {
					this.viewHeaderNode.setStatus(st.msg, Constants.HEADER_STATUS_ERROR, st.msg);
					return false;
				}
			}
			return true;
		},
		
		_allowToSave: function(){
			this.allowSaving = true;
			this.onSave();
		},
		
		_buildRecordChangeConfirmation: function() {
			if(!this.allowSavingAfterBuildChange){			
				var prompt = Constants.getMessage("lableBuildChangeConfirmationDialog");
		        var args = {
		            'message': prompt,
		            'yesCallback': dojo.hitch(this, this._updateBuildRecord),
		            'yesCallbackData': this,
		            'noCallback': dojo.hitch(this, this._noUpdateToBuildRecord),
		            'noCallbackData': this
		        };
		        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
		        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
		        this.confirmDialog.open();
				return false;
			}
			return true;			
	    },
		
		_updateBuildRecord: function(){
			this.updateBuildInfoInER = true;
			this._allowToSaveAfterBuildChange();
		},
		
		_noUpdateToBuildRecord: function(){
			this.updateBuildInfoInER = false;
			this._allowToSaveAfterBuildChange();			
		},
		
		_allowToSaveAfterBuildChange: function(){
			this.allowSavingAfterBuildChange = true;
			this.onSave();
		},
		
        onSave: function(){ 
            var saveRequiresSignature = this._reviewSection ? this._reviewSection.saveRequiresSignature() : null;
            if (saveRequiresSignature) {
                new ESignatureDialog({
                    onSign: dojo.hitch(this, "_doSave"),
                    esignRequiredMessage: Constants.getMessage("msgEsignReview"),
                    esignConfigData: saveRequiresSignature
                });
            } else {
                this._doSave();
            }
        },
        
        _doSave: function(esignPassword, esignComment, esignReason, esignAction) {
        	var approvalDirty = this._reviewSection && this._reviewSection.isDirty();
        	var artifactDirty = this.isDirty();
           
            this._formalReviewError = null;
            this._artifactError = null;            
            this._resultGroupLoaded = false; // something is dirty
            
            if(artifactDirty){
            	var artifactSaveCallback = {                       
            			success: dojo.hitch(this, function() {                            
            				this._setSaveFinishedStatus();
            				this.saveFinished();
            			}),
            			error: dojo.hitch(this, function(error) {
            				this._artifactSaveStatus = error;
            				this._setSaveFinishedStatus();
            				this.saveFinished();
            			})
            	};
            	this._saveArtifact(artifactSaveCallback, esignPassword, esignComment, esignReason, esignAction);
            } else if(approvalDirty){           

            var approvalSaveCallback = {
                    success : dojo.hitch(this, function(data) {
                    	if (data.stateUpdated) {
    						this._reloadEditor();
    					}
                        this._updateReviewSection();
                        this._setSaveFinishedStatus();
                        }),
                    error : dojo.hitch(this, function(error) {
                        this._formalReviewError = error;
                        this._setSaveFinishedStatus();
                    })
                };
            this._saveFormalReview(approvalSaveCallback, esignPassword, esignComment, esignReason, esignAction);
            }                       
        },
		
		_saveArtifact: function(callback, esignPassword, esignComment, esignReason, esignAction){

		    var params = {};
			params.name = this.viewHeaderNode.getTitle();
			params.id = this.erGroup.id;
			params.stateId = this.erGroup.stateId;
			params.includeTestCaseCounts = true;
			params.includeCustomAttributes = true;
			
			if(this.isEditable()){
				params.state = this.verdictCombo.value;//OnSave will be enabled only if editable
				params.weight = this.weightValue.data;
				if(this.weightSection){
					var points = this.weightSection.getPoints();
					if (!points){
						return
					} else {
		               for (var element in points) 
		                  params[element] = points[element];
					}
				}
				
				if (this.buildEdited){
					if(!this._buildRecordChangeConfirmation()){
						return;
					}
					if(this.buildItemId){
						params.buildRecordItemId = this.buildItemId;
					}
				}
				
				if(!this.validate(params)){
					return;
				}
			
				var teamArea = this.getTeamAreaItemId();
	        	if(teamArea){
	        		params.teamArea = teamArea;
	        	}
				
				if(this.updateTeamArea){
					params.updateTeamArea = true; 
				}
				if (this._categorySection) {
					var attributes = this._categorySection.getAttributes();
					if(attributes)
						dojo.mixin(params, attributes);
				}
			}
			
			if (this._stateValue) {
				params.workflowState = this._stateValue;
			}
			params.workflowAction = this.getWorkflowActionApplied();
            var internalHandlerObj = {
                    success: dojo.hitch(this, function(item){                        
                    	this._saveArtifactComplete(item, callback);
                    }),
                    error: dojo.hitch(this, function(e)
                    {
                        this._saveArtifactError(e);
                        callback.error(e);
                    })
                };
            if(this._reviewSection && this._reviewSection.isDirty()){
            	var approvalOps = this._reviewSection.getFormattedJson();
				if(approvalOps){
					params.approvalJson = dojo.toJson(approvalOps);
					if(approvalOps.comment){
						params.approvalGeneralComment = approvalOps.comment;
					}
				}
            }
			this._resultGroupLoaded = true;
			params.resolveTestSuite = true;
            var selectedOwner = this.ownerNode.getValue();
            params.owner =  selectedOwner.itemId;
            var responseHandler = new ServiceResponseHandler(internalHandlerObj, "success", "error");
			ERGClient.postExecutionResultGroupDTO(responseHandler, params);
			this.setLastSaved(Constants.STATUS_SAVING);
		},
		
		_saveArtifactComplete: function(summaryDTO, callback){
            callback.success(); // start Formal Review save if pending
			this.updateTeamArea = false;
			if (summaryDTO.elements!=null) {
				var len=summaryDTO.elements.length ? summaryDTO.elements.length : 0;
				for(var i=0;i<len;i++){
					var element = summaryDTO.elements[i];
					element.workitem = {};
					element.workitem.id = element.ewiId;
					element.workitem.name = element.ewiName;
					element.workitem.itemId = element.ewiitemId;
					element.workitem.testCase = element.testCase;
					element.workitem.weight = element.ewiWeight;
					if(element.ewiDefaultScriptId){
						element.workitem.defaultScript = {};
						element.workitem.defaultScript.id = element.ewiDefaultScriptId;
						element.workitem.defaultScript.name = element.ewiDefaultScriptName;
						element.workitem.defaultScript.itemId = element.ewiDefaultScriptItemId;
						element.workitem.defaultScript.stateId = element.ewiDefaultScriptStateId;
						element.workitem.defaultScript.scriptType = {};
						element.workitem.defaultScript.scriptType.id = element.ewiDefaultScriptStateType;
					}else
						element.workitem.defaultScript = null;	
					element.workitem.stateId = element.ewiStateId;
					element.workitem.configuration = element.ewiConfigurationItemId;
					
					if(element.ewiPlanName){
						element.workitem.testPlan = {};
						element.workitem.testPlan.name = element.ewiPlanName;
						element.workitem.testPlan.id = element.ewiPlanId;
						element.workitem.testPlan.versionableItemId = element.ewiPlanVersionableItemId;
					}
					if(element.ewiPhaseName){
						element.workitem.phase = {};
						element.workitem.phase.name = element.ewiPhaseName;
						element.workitem.phase.itemId = element.ewiPhaseItemId;
					}
					if (this.buildEdited && this.updateBuildInfoInER){
						// Defect 76224: Adding Test Suite Result URI parameter so the notification can be sent to all other tabs except current
						var suiteUri = CommonUtility._getPlanningActionUri("showSuiteResult", {"id": this.suiteId});
						dojo.publish(GlobalEvents.ArtifactsUpdated, [ Constants.TYPE_EXE_LOG, [ element.result ], suiteUri ]);
					}
					
					delete element.ewiId;
					delete element.ewiName;
					delete element.ewiitemId;
					delete element.testCase;
					delete element.ewiDefaultScriptId;
					delete element.ewiDefaultScriptName;
					delete element.ewiDefaultScriptItemId;
					delete element.ewiDefaultScriptStateId;
					delete element.ewiDefaultScriptStateType;
					delete element.ewiConfigurationItemId;
					delete element.ewiStateId;
					delete element.ewiPhaseItemId;
					delete element.ewiPhaseName;
					delete element.ewiPlanVersionableItemId;
					delete element.ewiPlanName;
					delete element.ewiPlanId;
					delete element.ewiWeight;
				}	
			}
			var ergObj = summaryDTO;			
			this._actionApplied = null;
			this.allowSaving = false;
			this.allowSavingAfterBuildChange = false;
			this.buildEdited = false;
			this.artifactState = summaryDTO.workflowState;
			this._stateChanged = false;
			this._setSaveFinishedStatus();
			this.setActions();
			this.initialize([ergObj]);
		},
		
		saveFinished:function() {
			// Save the build record modifications via OSLC requests
			if(this.buildEdited) {
				ProgressDialog.doRunWithProgress(DefectsUIUtil.getMessage("msgUpdatingBuildLinks"), dojo.hitch(this, function(monitor){
					monitor.beginTask(DefectsUIUtil.getMessage("msgUpdateLocalBuildLinks"));
					var addedBuild = null;
					var removedBuild = null;
					if(this.selectedBuildRecord) { // A new build record has been selected
						addedBuild = [{uri:this.selectedBuildRecord.url, summary:this.selectedBuildRecord.summary}];
					} // The build record will be removed otherwise
					
					var testSuiteResultResourceURL = ArtifactURIUtil.getTestSuiteResultURI(this.getVersionableItemId());
					if(this.updateBuildInfoInER){
						testSuiteResultResourceURL += "?oslc.properties=rqm_qm:executedOnBuild,rqm_qm:hasTestResult{rqm_qm:executedOnBuild}";
					}
					
					ResourceLinkService.updateExecutedOnLink(this.buildOslcVersion, ResourceLinkService.TAG_TSRESULT, testSuiteResultResourceURL, 
							addedBuild, removedBuild, dojo.hitch(this, function(){
								monitor.done();
								this._loadResultGroup();
							}), dojo.hitch(this, function(){
								monitor.done();
							}));
				}));
			}
		},
		
		_saveArtifactError: function(status){
			this._saveError(status);
		},
		
		_setSaveFinishedStatus: function () {
            var errorMessage = null;
            var formalReviewMessage = this._formalReviewError;
            var artifactSaveStatus = this._artifactSaveStatus;
                                
            // approval, if still dirty it failed
            var isApprovalDirty  = this._reviewSection && this._reviewSection.isDirty();

            var artifactErrorMessage = artifactSaveStatus ? artifactSaveStatus.message : null;
                  
            if(artifactSaveStatus && formalReviewMessage){
                //both, artifact and approval  save caused errors
                errorMessage = artifactErrorMessage + "<br/>" + formalReviewMessage;
            } else if(artifactSaveStatus){ 
                //Approval was clean, but Artifact was not and save caused errors
                errorMessage = artifactErrorMessage;
            } else if(formalReviewMessage){
                //Artifact was clean, but Approval was not and save caused errors
                errorMessage = formalReviewMessage;
            }

            var error = {ok:false};
            if(errorMessage){
                error.message = errorMessage;
                if (isApprovalDirty){
                    // lets re-enable the buttons 
                    this.updateSaveable(true); 
                }
                this._saveError(error); 
                // lets reload constratints also
                var state = this.artifactState;
                ConstraintsUtil.loadConstraints(Constants.TYPE_SUITE_LOG, this.getTeamAreaItemId(), 
                        dojo.hitch(this, "_updateHeaderWithConstraints",  state));
            } else {
                if(this._reviewSection){
                    // lets refresh approval
                    this._reviewSection.initialize();
                }
                if (!this._resultGroupLoaded){
                    // if erg not reloaded because it has been saved
                    // we need to reload so not to get stale data error 
                    this._loadResultGroup();
                }
                this.saveButton.setDisabled(true);
                this.cancelButton.setDisabled(true);
                this._setDirty(false); 
                this.setLastSaved(Constants.STATUS_SUCCESS);
            }  
            //clean messages and flags from class context
            this._formalReviewError = null;
            this._artifactSaveStatus = null;
		},
		
        _saveError: function(status){
            if (status!=null && status.message!=null) {
                var re = /^\[(\d+)\]\s*:\s*/;
                status.message = status.message.replace(re, "");
            }
            this.setLastSaved(Constants.STATUS_FAILURE, status);
        },
		onCancel: function(){
			var self = this;
			var args = {
				primaryTitle: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self._setDirty(false);
                    self.viewHeaderNode.clearStatus();
					self.initialize(self.erGroup);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.open();
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
			if ((changeType != GlobalEvents.ArtifactsAdded)) {
                var ergElements = this.erGroup.elements;
				var changed = false;
				var artifactArrayLength=artifactArray.length;
				var ergElementsLength = ergElements ? ergElements.length : 0;
				for (var i = 0; i < artifactArrayLength; i++) {
					for(var j=0;j<ergElementsLength;j++){
						if (ergElements[j] && ergElements[j].result && ergElements[j].result.id == artifactArray[i].id) {
							if((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EXE_LOG)){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteDeleted"), ViewHeaderLayout.ERROR);
								changed = true;
							}
							if((changeType == GlobalEvents.ArtifactsUpdated) && (artifactType == Constants.TYPE_EXE_LOG)){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteUpdated"), ViewHeaderLayout.INFO);
								changed = true;
								
							}
							if((changeType == GlobalEvents.ArtifactsUpdated) && (artifactType == Constants.TYPE_EXE_LOG)){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteUpdated"), ViewHeaderLayout.INFO);
								changed = true;
								
							}		
                    	}else if((artifactArray[i].id == this.suiteId) && (artifactType == Constants.TYPE_SUITE_LOG)){
							if(changeType == GlobalEvents.ArtifactsUpdated){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteResultUpdated"), ViewHeaderLayout.INFO);
								changed = true;
							}
						}	
					}
                }
				if(changed && this.suiteId){
					var args = {id:this.suiteId, includeElements: false, includeResult: false, includeFullResult: false, includeRequest: false, includeTestcase: false, includeTestCaseCounts:true,resolveVariables:true}; //Fetch the ERG again, ERG result rolled up on update of ER
					var responseHandler = new ERGMapper(this, "initialize", "_error");
					ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
				}
            }
        },
		
		_onTitleChange: function() {
            this._setDirty(true);
        },
		
		setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
                                 
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getMessage("msgSaveArtifactError", this.getArtifactType());   
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1){
				if(detail_msg){
	               this.viewHeaderNode.setStatus(text, st_code, detail_msg);
				}else{
					this.viewHeaderNode.setStatus(text, st_code, null, error);
				}
            }else{
                this.viewHeaderNode.clearStatus();
			}
        },
		
		_setDirty:function(dirty){
            if (this.erGroup.locked) {
                if (dirty) {
                    var text = Constants.getMessage("msgEROfSuiteLocked");
                    this.viewHeaderNode.setStatus(text, ViewHeaderLayout.INFO, null);
                    this.cancelButton.setDisabled(false);
                }
            }
            else {
                this.dirty = dirty;
                if (this.saveButton) {
	                this.saveButton.setDisabled(!dirty);
                }
                if (this.cancelButton) {
	                this.cancelButton.setDisabled(!dirty);
                }
                var label = this._getTabLabel();
                dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, label, null, dirty]);
                if (dirty) 
                    this.setLastSaved(Constants.STATUS_DIRTY);
            }    
		},
		
		isDirty:function(){
			return this.dirty;
		},
		
		_error: function(errorObj){
			console.error("Error in Suite Execution Log"+ errorObj.message + " ");
		},
		
		refreshHistory: function()
        {           
            if(!this._historyMainPanel){                        
                this._historyMainPanel =  new HistoryPane(
                {                   
                    itemId: this.erGroup.itemId,
                    itemType: "ExecutionResultGroup",  
                    itemNameSpace: "com.ibm.rqm.execution"   
                });
                this.viewHeaderNode.historyContainerNode.appendChild(this._historyMainPanel.domNode);                
            }
           this._historyMainPanel.refreshHistory();
        },      
		_contentSelected: function(){
		  this.inherited('_contentSelected', arguments);
		  if(this.saveButton){
		      this.saveButton.setStyle("visibility","visible");
		  }
		  if (this._pdfHistoryButton) {
              this._pdfHistoryButton.addClass("hidden");
          }
          if(this._pdfButton){
              this._pdfButton.removeClass("hidden");
          }
		  if(this.cancelButton){      
              this.cancelButton.setStyle("visibility","visible");
		  }
		  this.viewHeaderNode.showInfoAttributesNode(true);

        },
        
        _historySelected: function() {   
            this.inherited('_historySelected', arguments);     
            if(this.saveButton){
                this.saveButton.setStyle("visibility","hidden");
            }
            if (this._pdfHistoryButton) {
                this._pdfHistoryButton.removeClass("hidden");
            }
            if(this._pdfButton){
                this._pdfButton.addClass("hidden");
            }
            if(this.cancelButton){      
                this.cancelButton.setStyle("visibility","hidden");
            }
			this.viewHeaderNode.showInfoAttributesNode(false);
			
            this.refreshHistory();
        },
        
        setState: function(state){
            var stateSpan = this._stateNode = dojo.create("div", {
                className: "attributes-entry-label",
                innerHTML: LabelLoading,
                style: {
                    display: "inline-block"
                }
            });
            var stateLabel = this._stateLabelNode = dojo.create("span", {
                innerHTML: Constants.getMessage("labelStateLabel"),
                title: ""
            });
            this._stateEntry = this.viewHeaderNode.addInfoAttribute(stateLabel, stateSpan);
            this._doSetState(state);
        },
        
        _doSetState: function(state) {
            var doc = document;
            
            //Error check.  If we try to set the state to null then fall back to the default state.
            //There was a bug with Chrome and IE that was causing null state.  This handles any more of those types of bugs
            if (state == null || state == "") {
                // Set the initialState using the customized workflow
                state = WorkflowManager.getInitialStateForArtifactType(Constants.TYPE_SUITE_LOG).id;
            }
            
            var actions = WorkflowManager.getActionsForState(state, Constants.TYPE_SUITE_LOG);         
            // If no actions are found, we have an artifact with a state 
            // that has been deleted or the workflow has been changed.
            if (!actions) {
                var originalState = state;
                state = WorkflowManager.getInitialStateForArtifactType(Constants.TYPE_SUITE_LOG).id;
                if (this.initialized) {
                    this._invalidStateHandler(originalState, state);
                } else {
                    this._deferredInvalidStateNoticeHandler = dojo.hitch(this, "_invalidStateHandler", originalState, state);
                }
            }
                
            this._stateValue = state;
            this.artifactState = state;
            
            this._state = WorkflowManager.getStateNameById(state, Constants.TYPE_SUITE_LOG);
                        
            // clear the temporary state node and start filling in the content
            this._stateNode.innerHTML = "";

            this._stateIcon = dojo.create("span", {
                className: "dijitInline",
                style: {
                    height: "16px",
                    width: "16px",
                    marginRight: "5px"
                }
            });
            this.updateWorkflowIconNode(this._stateIcon, WorkflowManager.getStateIconById(state, Constants.TYPE_SUITE_LOG));
            this._stateTxt = doc.createTextNode(this._state);
            
            var stateSpan = this._stateNode;
            stateSpan.appendChild(this._stateIcon);
            stateSpan.appendChild(this._stateTxt);
            stateSpan.setAttribute("title", "");
            stateSpan.setAttribute("tabindex","-1");

            // If not read only, create the change state action combo
            if (this._isPermitted()) {               
                stateSpan.setAttribute("id", "change-state");
                
                //Create the actions label
                var actionLabel = doc.createElement("label");
                actionLabel.setAttribute("for", "action-select");
                actionLabel.innerHTML = Constants.getMessage("LabelAction");
                actionLabel.className = "attributes-entry-label";
                
                var actionLabelLine = dojo.create('div', {
                    style: {
                        minWidth: '62px'
                    }
                });
                this._actionIcon = dojo.create("span", {
                    className: "dijitInline",
                    style: {
                        height: "16px",
                        width: "16px",
                        minWidth: "16px"
                    }
                });
                this.updateWorkflowIconNode(this._actionIcon, null, true);
                dojo.place(this._actionIcon, actionLabelLine);
                dojo.place(actionLabel, actionLabelLine);
                
                //Create the actions combo box
                this._action = doc.createElement("select");
                this._action.id = "action-select";
                this._action.name = "action-select";
                
                //Add the change handler.
                //The handler will need to update the state field and reload the combo box based on the actions available in the new current state
                this.connect(this._action, "onchange", "_onActionChange");
                
                //Add the combo box to the ui
                this.viewHeaderNode.appendToExistingInfoAttribute(this._stateEntry, actionLabelLine, this._action);
                this.setActions();
            }
            
            ConstraintsUtil.loadConstraints(Constants.TYPE_SUITE_LOG, this.getTeamAreaItemId(), 
                    dojo.hitch(this, "_updateHeaderWithConstraints",  state));
        },
        
        _updateHeaderWithConstraints: function(state){
            if (WorkflowManager.stateBelongsToApprovedOrRetired(state, Constants.TYPE_SUITE_LOG)) {
                if (ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.RestrictSave, Constants.TYPE_SUITE_LOG)) {
                    var header = this.viewHeaderNode;
                    if (header) {
                        header.setStatus(Constants.CONSTRAINT_WARNING, ViewHeaderLayout.WARNING, Constants.getMessage("labelConstraintDescription1"));
                    }
                }
            }
        },
        
        getStateValue: function() {
            return this._stateValue;
        },
        
		setActions: function(){
        	if (this._action) {
        		var actions = WorkflowManager.getActionsForState(this.getStateValue(), Constants.TYPE_SUITE_LOG);	
				
				var select = this._action;
				dojo.empty(select);
				
				// Add the select action prompt
				var option = dojo.create("option", {
					style: {
						color: "gray"
					},
					innerHTML: Constants.getMessage("labelChangeStateTitle"), 
					value: "NULL"
				});
				select.appendChild(option);
				
				dojo.forEach(actions, dojo.hitch(this, function(action) {
					var option = dojo.create("option", {
						innerHTML: action.name,
						value: action.id
					});
					select.appendChild(option);
				}));
				if (this._actionIcon) {
					this.updateWorkflowIconNode(this._actionIcon, null, true);
				}
			}
		},
		
		_invalidStateHandler: function(originalState, state) {
			this._setDirty(true);
			
	        var header = this.viewHeaderNode;
	        if (header) {
	        	header.setStatus(Constants.getMessage("labelInvalidStateUpdatedTitle"), ViewHeaderLayout.INFO, 
            			Constants.getMessage("labelInvalidStateUpdated", originalState, WorkflowManager.getStateNameById(state, Constants.TYPE_SUITE_LOG)));
	        }
		},
		
		setStateChanged: function(changed, action) {
			this._actionApplied = action;
			this._stateChanged = changed;
		},
		
		getStateChanged: function() {
			return this._stateChanged;
		},
		
		// Summary:
		//    If a workflow action has been applied, returns the
		//    action id.
		//
		getWorkflowActionApplied: function() {
			return this._actionApplied;
		},
		
		_onActionChange: function(){
			var currentState = this.artifactState, action = this._action.value;

			if (this._actionIcon) {
				this.updateWorkflowIconNode(this._actionIcon, WorkflowManager.getActionIconById(action, Constants.TYPE_SUITE_LOG), true);
			}

			//If the user selected the change state prompt then just return
			//This should not happen since we remove the state change prompt below
			if (action == "NULL") {
				return;
			}
			
			// Remember that we have changed state.
			// This used to help decide whether the save button should be enabled
			this.setStateChanged(true, action);
			
			this._setDirty(true);
			
			//If the action is to return to the previous state	
			var actionLen = this._action.length;
			if (action == currentState) {
				//Remove the "Return to State" Action				
				for (var i = 0; i < actionLen; i++)
					if (this._action.options[i].value == currentState) {
						this._action.remove(i);
						break;
					}				

				//add "select action" and select it
				var option = new Option(Constants.getMessage("labelChangeStateTitle"), "NULL");  
				option.style.color = "gray";
				SelectUtility.add(this._action, option);
				SelectUtility.select(this._action, "NULL");
				
				//Set the state to be the previous state
				this._stateValue = currentState;
				// Remove the action applied
				this._actionApplied = null;
			}else{  //A "real" action other than return to previous state
				// remove "select action" if needed
				for (var i = 0; i < actionLen; i++) {
					if (this._action.options[i].value == "NULL") {
						this._action.remove(i);
						break;
					}
				}
				
				// add "return to <last state>" if needed
				if (this._action.options[this._action.options.length - 1].value != currentState) {
					var option = new Option(Constants.getMessage("com.ibm.rqm.planning.common.return", 
							Constants.getMessage(WorkflowManager.getStateNameById(this._stateValue, Constants.TYPE_SUITE_LOG))), this._stateValue);
					SelectUtility.add(this._action, option);
				}				
				
				var action = WorkflowManager.getActionById(action, Constants.TYPE_SUITE_LOG);
				this._stateValue = action.state;
			}
 
			// Update next state
            this._stateTxt.nodeValue = WorkflowManager.getStateNameById(this._stateValue, Constants.TYPE_SUITE_LOG);
            this.updateWorkflowIconNode(this._stateIcon, WorkflowManager.getStateIconById(this._stateValue, Constants.TYPE_SUITE_LOG));
		},
		
		_updateBrowserTitle: function(){
			if (this.page){
				var name = this._getTabLabel();
				this.page.browserTitle =  name;
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	
			}
		},
		
		_getTabLabel: function() {
        	var label = Constants_getMessage("labelTestSuiteResultExecution", this.viewHeaderNode.getTitle());
			if(this.erGroup) {
				label = Constants.getCommonMessage("labelNameWithId", this.erGroup.id, label);
			}
			return label;
        },
        
        _createLockUnlockButton: function() {
        	this._lockButton.addClass("hidden");
        	// permission for suite result is included in execution result save    
        	var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_RESULT);          
            if (!permission)
            	return;            	
            	
            var lockPermitted = permission[PermissionsClient.ACTION_LOCK];
			var unlockPermitted = permission[PermissionsClient.ACTION_UNLOCK];
			
			if (lockPermitted || unlockPermitted) {
				if (!this.erGroup.locked) {
					if (lockPermitted) { // not locked and user may lock 
						this._lockButton.removeClass("hidden");
						this._lockButton.setLabel(Constants.getMessage("labelLock"));
					}
				}
				else {
					if (unlockPermitted) { // is locked and user may unlock
						this._lockButton.removeClass("hidden");
						this._lockButton.setLabel(Constants.getMessage("labelUnlock"));
						this.viewHeaderNode.setStatus(Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")), ViewHeaderLayout.INFO, 
                     				    Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")));
					}
					else { // locked and user may not unlock	
					// todo: display this is locked msg
						this.viewHeaderNode.setStatus(Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")), ViewHeaderLayout.INFO, 
                     				    Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")));
					}
				}
			}
			else { // user does not have permission
				if (this.erGroup.locked) {
				// todo: display this is locked msg
				this.viewHeaderNode.setStatus(Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")), ViewHeaderLayout.INFO, 
                     				    Constants.getMessage("msgLocked", Constants.getMessage("labelSuiteResult")));
				}
			}
        },
        
        _onLock: function() {
            if (this.isDirty()) {
                new AlertDialog({
                    message: Constants.getMessage("msgDirtyArtifact"),
                    primaryTitle: Constants.getMessage("labelAlert")
                }).open();
            } else {
                var teamArea = this.getTeamAreaItemId();
                if (ConstraintsUtil.isConstraintEnabled(ConstraintsUtil.ExecutionEsignLockChange, Constants.TYPE_SUITE_LOG, teamArea)) {
                    // get the config data for the E-Sign of Lock/Unlock
                    ConstraintsUtil.loadConfigurationData(ConstraintsUtil.ExecutionEsignLockChange, Constants.TYPE_SUITE_LOG,
                        ConstraintsUtil.ESignConfigElementId, /* isSaveOperation */ true, teamArea, dojo.hitch(this, "_showESignatureDialog"),
                        /* optional projectArea */ null, /* useCache */ null, /* blockUI */ true);
                } else {
                    this._doLock();
                }
            }
        },
        
        _showESignatureDialog: function(configData) {
            // prepare the config data to populate the E-Sign dialog
            var constraintConfigData = ConstraintsUtil.parseESignaureConfigurationData(configData);
            if (constraintConfigData) {
                var action = this.erGroup.locked ? Constants.getMessage("labelUnlocked") : Constants.getMessage("labelLocked");
                var approvalAction = [{ "action": action }];
                constraintConfigData.approvalActions = approvalAction;
            }
            new ESignatureDialog({
                onSign: dojo.hitch(this, "_doLock"),
                esignRequiredMessage: Constants.getMessage("msgEsignLock"),
                esignConfigData: constraintConfigData
            });
        },
        
        _doLock: function(esignPassword, esignComment, esignReason, esignAction) {
            //successful esig; lock the artifact
            var action = this.erGroup.locked ? "labelUnlockingArtifact" : "labelLockingArtifact";
            this.viewHeaderNode.setProgressStart(Constants.getMessage(action, Constants.getMessage("labelSuiteResult"))); 
            var serviceResponseHandler = new ERGMapper(this, "_lockSuccess", "_lockFailure");
            var args = {
                lock: !this.erGroup.locked,
                versionableItemId: this.erGroup.itemId
            };
            if (esignPassword) args.esignPassword = esignPassword; 
            if (esignComment) args.esignComment = esignComment;
            if (esignReason) args.esignReason = esignReason;
            if (esignAction) args.esignAction = esignAction;
            ERGClient.postLockERG(serviceResponseHandler, args);
        },
        
		setTeamArea: function(teamArea){
			if(!this.teamAreaSelector){
				if(CommonUtility.isIterationSupportActivated()){
		        	this.teamAreaSelector = new com.ibm.asq.common.web.ui.internal.widgets.TeamAreaSelector({ 
		        		teamAreaItemId:teamArea,
		        		onValueChanged:dojo.hitch(this, "onTeamAreaChanged")
		            });
		        	var label = document.createElement("label");			
		        	label.innerHTML = Constants.getMessage("fieldLabelTeamArea"); 
		        	label.setAttribute("for", this.teamAreaSelector.id);
					if(com.ibm.team.repository.web.client.init.InitializationData.get("teamarea.enabled")){
		        		this.viewHeaderNode.addInfoAttribute(label, this.teamAreaSelector.domNode);
						this.teamAreaSelector.setEditable(this.isEditable());
					}
				}
			}
            if (this._reviewSection){
                this._reviewSection.refreshConstraints(teamArea);                
            }
        },
                	
        onTeamAreaChanged:function(newValue){
			this.updateTeamArea = true;
        	this._setDirty(true);
        	ConstraintsUtil.loadConstraints(Constants.TYPE_SUITE_LOG, newValue);
            if (this._reviewSection){
                this._reviewSection.refreshConstraints(newValue);                
            }
        	
        	var action = PermissionsClient.ACTION_EDIT;
        	var args = {
        		operationId: PermissionsClient.OP_SUITE_RESULT,
        		processArea: this.getTeamAreaItemId(),
        		action: action
        	};
        	var handler = {
				success: dojo.hitch(this, function(permissions) {
					if (!permissions[action]) {
						this.viewHeaderNode.setStatus(Constants.getMessage("labelTeamAreaPermissionsNotGranted", this.getTeamAreaName()), 
								ViewHeaderLayout.WARNING);
						this._hasTeamAreaPermissionsError = true;
					} else if (this._hasTeamAreaPermissionsError) {
						this._hasTeamAreaPermissionsError = false;
						this.viewHeaderNode.clearStatus();
					}
				}),
				failure: dojo.hitch(this, function(error) {
					console.error("Unable to load permissions");
				})
			};
			
			var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        	PermissionsClient.checkPermissions(responseHandler, args);
        },
        
        getTeamAreaName: function() {
        	if (com.ibm.team.repository.web.client.init.InitializationData.get("teamarea.enabled") && this.teamAreaSelector) {
       			return this.teamAreaSelector.getSelectLabel();
        	} else {
        		return "";
        	}
        },
       
        getTeamAreaItemId:function(){
        	var val = null;
        	if(this.teamAreaSelector){
        		val = this.teamAreaSelector.getSelectValue(); 
        	}
        	return (val && val!="Unassigned")?val:null;  
        },
        
        _lockSuccess: function(newArtifact) {
            // Lock succesful
            this.viewHeaderNode.setProgressEnd();
            if (this.viewHeaderNode) {
                this.viewHeaderNode.clearStatus();
            }
        
            this.initialize(newArtifact);    
        },
                
        _lockFailure: function(e) {
            //locking server operation failed
            if (e.nestedError && e.nestedError.errorClass 
                    && e.nestedError.errorClass == "com.ibm.team.process.common.advice.TeamOperationCanceledException"){
                // remove the stacktrace blob that comes back for invalid e-sig
                e.nestedError = e.exception = e.errorClass = null;
            }
            this.viewHeaderNode.setProgressEnd();
            
            // Show the error
            this.setLastSaved(Constants.STATUS_FAILURE, e);
        },
		
		updateWorkflowIconNode: function(node, icon, isAction) {
			var newImg = null;
			if (icon) {
				newImg = dojo.create("img", {
					src: icon,
					alt: "",
					className: "attributes-entry-label",
					style: {
						height: "16px",
						width: "16px"
					}
				});
			} else {
				newImg = dojo.create("span", {
					alt: "",
					style: {
						height: "16px",
						width: "16px"
					}
				});
			}
			var style = dojo.style;
			if (isAction) {
				style(node, "float", "right");
			} else {
				style(node, "verticalAlign", "top");
				style(node, "clear", "both");
			}
			dojo.empty(node);
			node.appendChild(newImg);
		},
		/////////////////////
        // formal review
        _saveFormalReview: function(callback, esignPassword, esignComment, esignReason, esignAction) {
            if (this._reviewSection
                    && this._reviewSection.isDirty()) {
                var saveCallback = {
            		success : dojo.hitch(this, function(data) {
                        this.updateSaveable(false);
                        this._reviewSection._initialize();
                        callback.success(data);
                    }),
                    error : dojo.hitch(this, function(error) {
                        this._formalReviewError = error;
                        callback.error(error);
                        // refresh esign constraint
                        ConstraintsUtil.loadConstraints(Constants.TYPE_FORMAL_REVIEW, this.getTeamAreaItemId());
                    })
                };
                this.setLastSaved(Constants.STATUS_SAVING);
                this._reviewSection.internalFormalReviewSave(saveCallback, esignPassword, esignComment, esignReason, esignAction);
            }
         },
        
        /////////////////////
        // com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection
        // com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor
        getSaveContext: function () {
            return null;
        },
        getArtifact: function () { 
            return this.ergGroup;
        },
        getVersionableItemId: function () { 
            return this.erGroup.itemId;
        },
        isPrintView: function () {
            return false;
        },
        isSnapshot: function () { 
            return false;
        },            
        isRolePermitsEdit: function () { 
            return this.isEditable();
        },    
        getSelectedSection: function () { 
            return null;
        },
        setDirty: function (dirty /* bool */) { 
            this._setDirty(dirty);
        },
        registerApprovalSection: function (reviewSection) { 
            this.reviewSection = reviewSection;
        },
        updateSaveable: function (dirty /* bool */) {
            if (this.saveButton) {
                this.saveButton.setDisabled(!dirty);
            }
            if (this.cancelButton) {
                this.cancelButton.setDisabled(!dirty);
            }
            var label = this._getTabLabel();
            dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, label, null, dirty]);
            if (dirty) 
                this.setLastSaved(Constants.STATUS_DIRTY);
        },

        getArtifactSection : function(id) {
            return null;
        },
        getArtifactType : function() {
            return Constants.TYPE_SUITE_RESULT;
        },
        uninitialize: function(){
			var resLinks = this.resourceLinks;
			var len = resLinks.length;
			for(var i=0;i<len;i++){
				var resourceLink = resLinks[i]; 
				if(resourceLink){
					resourceLink.destroyRecursive();
				}
			}
			this.resourceLinks = [];
			if (this.teamAreaSelector) {
				this.teamAreaSelector.destroyRecursive();
			}
		}

	});
})();
