/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.QualityManagerApplication");

dojo.require("dojo.i18n");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.app._AjaxApplication");
dojo.require("jazz.core.RegistryFactory");
dojo.require("jazz.core.loader");
dojo.require("jazz.app._ComponentMenu");
dojo.require("jazz.app.context");			// CML: M8 change
dojo.require("jazz.app.internal.applicationAbout");
dojo.require("jazz.app.events");
dojo.require("net.jazz.ajax.contextRoot");

dojo.require("com.ibm.team.dashboard.web.ui.DashboardMini");
dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient");
dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.ui.internal.SystemAlertsWidget");
dojo.require("com.ibm.team.repository.web.ui.internal.about.AboutDialog");
dojo.require("com.ibm.team.app.web.internal.welcome.WelcomeUtil");
dojo.require("com.ibm.team.app.web.RepositoryApplication");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorRegistry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ActionBarRegistry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.QMPage");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");
dojo.require("com.ibm.asq.common.web.client.internal.ServerInfoClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

var _AjaxApplication       = jazz.app._AjaxApplication;
var RepositoryClient       = com.ibm.team.repository.web.client.internal.RepositoryClient;
var AdminClient 		   = com.ibm.team.repository.web.client.internal.AdminClient;
var ServerStatusClient	   = com.ibm.team.repository.web.client.internal.ServerStatusClient; 
var InitializationData     = com.ibm.team.repository.web.client.init.InitializationData;
var Session                = com.ibm.team.repository.web.client.session;
var PlatformUI			   = net.jazz.ajax.ui.PlatformUI;

var QMPage				   = com.ibm.rqm.planning.web.ui.internal.page.QMPage;
var NotAuthorized	   	   = com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized;
var DEFAULT_PROJECT_AREA   = "Quality Manager";
var Constants              = com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var PermissionsClient      = com.ibm.asq.common.web.client.internal.PermissionsClient;
var Utility                = com.ibm.asq.common.web.ui.internal.util.Utility;

var GlobalEvents           = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var PlanningUtil           = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var TimeBoxClient 		   = com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;

// keys for data retrieved from Jazz's InitializationData 
var INITIALIZER_KEY_CONFIG_PROPS = "com.ibm.team.repository.service.configPropertyInitializer";
var INITIALIZER_KEY_PROJECT_AREAS = "com.ibm.team.process.service.projectAreaWebUIInitializionData";
var INITIALIZER_KEY_CONTRIBUTOR = "com.ibm.team.repository.service.currentContributorInitializer";
var INITIALIZER_KEY_CAN_GRANT_PERMISSION = "com.ibm.team.repository.service.canGrantPermissionInitializer";

var SETUP_URI = "/setup";
var JazzAppMessages = dojo.i18n.getLocalization("jazz.app.internal", "ComponentMenuMessages");

function workbenchRootNode(){
	// summary:
	//		helper to get workbench root node
	return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

// After the page loads, the Jazz Ajax Framework instantiates the workbench
// implementation specified in the web bundle's plugin.xml file. After creating
// the workbench implementation instance it calls the implementation's 'init'
// method. Note that the init method must call the parent _Application class's
// 'start' method in order for the workbench to begin normal event processing
// (e.g. watching for changes in the 
// 
// In this example, the extender creates a few top-level UI elements.
dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.QualityManagerApplication", com.ibm.team.app.web.RepositoryApplication,
{
	name: Constants.getMessage("labelRQMFrontingTitle"),
    iconSmall: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/RQM_16.png"),
    iconLarge: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/RQM_31.png"),
    productTitleImg: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/Rational-Quality-Manager.png"),
    
    // default to show dashboard mini
    _showDashboardMini: true,
    
    // repository application's attr to auto load init data. We don't this here, disable the init load.
    autoRequestInitData: false,
    showAllProjectsPage: false,
    
	constructor: function(){
        // customize UI for RQM
        this.config.usePageRegistry = false;
        
        // don't ask the base class to insert the user/loginout widget,
        // We want to add it to our location in the banner
        // right buttons area. Otherwise, the base class would
        // always create it at the left most position.
        this.config.showLoginLogout = false;
        
        // the base class's constructor would populate the help & admin buttons.
        // but we need them to be at certain order. Clear the base class settings.
        // We'll add the right buttons later.
        this.config.buttons = [];
        
        this.setName(this.name);
        this.config.productTitleImg = this.productTitleImg;
        
        this.ui.set("productName", this.name);
        this.ui.set("bannerTitle", this.name);
        this.ui.set("productIcon", this.iconLarge.toString());

        var self = this;
		var callback = {
			success:function(status){
				//fetch initialization data 
				self.dbStatus = status; 
				var srh = new ServiceResponseHandler(self, "success", "_initFailure");
				RepositoryClient.getInitializationData(srh);
			},
			error:function(status){
				self.dbStatus = status;
				self._handleServerInBadState(status);
			}
		}
		var handler = new ServiceResponseHandler(callback, "success", "error");
		//need to use this to invoke the login dialog. 
		//Due to jazz bug 70579 any service call that forces the login dialog will be called twice 
		//and since the response from this service is the smallest (<1k), we can reduce the performance hit
		//if we call getInitializationData here then it returns about 100k of data twice
		ServerStatusClient.getDatabaseStatus(handler);		
        
        var root = document.getElementsByTagName("html")[0];
        root.setAttribute("lang", dojo.locale.split("-")[0]);
        
        // On IE, specifically set the tundra CSS link's media type 
        // to screen. If this CSS is sent to the print media on certain
        // RQM print views, it could crash IE. 
        if (dojo.isIE) {
            var links = document.getElementsByTagName("link");
            var len = links.length;
            for (var i = 0; i < len; i++) {
            	var link=links[i];
            	var href=link.href;
                if (href && href.indexOf("tundra") > -1) {
                    link.media = "screen";
                }
            }
        }
        // check if the uri is for showing the JTS All Projects page
        this._checkIfShowAllProjectsPage();
    },

	_initFailure: function(e) {
		//unable to load init data; show error widget (with error message if exists)
		console.error(this.declaredClass + ": unable to load initializationData due to --> " + e.message);
        var args = {};
		if (e && e.message) {
			args.middleText = e.message
		}
		this._loginNotAllowed(args);
	},
	
    // check if the uri is for showing the JTS All Projects page
    //
    _checkIfShowAllProjectsPage: function() {
        var path = location.pathname;
        var webPath = net.jazz.ajax._contextRoot + "/web"; //$NON-NLS
        var consolePath = net.jazz.ajax._contextRoot + "/web/console"; //$NON-NLS
        
        // all projects page does not have project context in the pathname
        if ((path == webPath) || (path == consolePath)) {
            // if no project area name appended, check the params in the hash
            var hash = location.hash;
            var params = hash.split('&');
            var args = {};
            dojo.forEach(params, function(param){
                var parts = param.split('=');
                if (parts[0] == '#action') {
                    args['action'] = parts[1];
                } else {
                    args[parts[0]] = parts[1];
                }
            });
            this.showAllProjectsPage = (args['action'] ==  "jazz.viewPage") && (args['id'] == "com.ibm.team.process.projectAreaList"); //$NON-NLS
        }
        
        if (!this.showAllProjectsPage) {
            // We don't redirect /web with HTTP to work around IE not keeping the hash in the URI which
            // redirect the All Projects page as if it is a QM project area page.  We redirect /web here
            // if needed when it is not the All Projects page.
            //
            if ((path.search(webPath) != -1) && (path.search(consolePath) == -1)) {
                // the path is /web and not /web/console, need to redirect
                var redirectPath = path.replace(webPath, consolePath);
                if (location.search) {
                    redirectPath += location.search;
                }
                if (location.hash) {
                    redirectPath += location.hash;
                }
                // set a global flag to indicate we're redirecting. We just called 
                // db server status and we can still catch that right when the browser
                // is being redirected. The respond handler would think it's a server
                // error due to status == 0 and put up a message. This global flag
                // communicates to the handler to ignore error status in this situation.
                GlobalEvents.QMAppIsReDirecting = true;
                location.href = redirectPath;
            }
        }
    },
    
	success: function(initData)
	{
		//set up all initialization data
        Session.init(initData);
		InitializationData._load(initData);
		
		// does the user have the rights to be trying this?
		var permissionsInitData = InitializationData.get(Constants.PERMISSIONS_INIT_DATA_KEY);
		// isLicensedForWebAccessError is only set if there is a license problem
		if (permissionsInitData && permissionsInitData.isLicensedForWebAccessError) {
			var args = {
					middleText: permissionsInitData.isLicensedForWebAccessError
			};
			var notAuth = new NotAuthorized(args);		
			notAuth._middleText.style.fontSize = "9pt";
			return;
		} else if (!permissionsInitData) {
			// a very unlikely condition but now what? 
			// just log it an carry on. the server will protect 
			console.error(this.declaredClass + ": unable to read permissionsInitData");
		}
		//is the current user an admin
        var canGrantInit = InitializationData.get(INITIALIZER_KEY_CAN_GRANT_PERMISSION);
		this._isJazzAdmin = canGrantInit && canGrantInit.canGrantPermission == true;  
		
		//set up current contributor object
        var contributorInitData = InitializationData.get(INITIALIZER_KEY_CONTRIBUTOR);
        if (contributorInitData != null) {
            var contributor = contributorInitData.currentContributor;
            dojo.setObject(Constants.AUTH_USER_OBJECT_ID, contributor);
            var userArgs = {
                name: contributor.name,
                admin: this._isJazzAdmin,
                userId: contributor.userId
            };
            if (!this.showAllProjectsPage) {
                // insert our contributing menu items to the user menu unless
                // it is showing the JTS All Projects page
                userArgs.menuItemsProvider = this._userMenuItemsProvider;
            }
            this.config.user = userArgs;
            this.config.showLoginLogout = true;
            var logoutUri = dojo.getObject("com.ibm.team.repository.web.logouturi");
            if (logoutUri) {
                this.config.logout = { href: logoutUri };
            }
        }
        else {
            //server is in a bad state; get server info to display message to user
			this._handleServerInBadState(this.dbStatus);
            return;
        }
        
        if (this.showAllProjectsPage) {
            // no need to do any more init if it is just to show the All Projects page
            jazz.app.context.set();  // won't use any menu for no project area context
            this._initAppUI();
            return;
        }

        this.hasCal = true;
		        
		if(this.ui && this.ui._bannerIconImg){//Get Banner Image to put ALT
			this.ui._bannerIconImg.alt = "RQM Banner Image"; //$NON-NLS
		}
		
        //store the configuration properties in global vars with corresponding names
        var configProperties = InitializationData.get(INITIALIZER_KEY_CONFIG_PROPS);
        for (var propName in configProperties) {
            var propVal = configProperties[propName];
            dojo.setObject(propName, propVal);
        }
		
        // continue only if project area is set
        if (this._setUserProjectAreas()) {
            //add the editor registry to the global dojo context 
            var editorRegistry = new com.ibm.rqm.planning.web.ui.internal.util.EditorRegistry();
            dojo.setObject(Constants.EDITOR_REGISTRY_OBJECT_ID, editorRegistry);
            
            //add the action menu registry to the global dojo context 
            var actionRegistry = new com.ibm.rqm.planning.web.ui.internal.util.ActionBarRegistry();
            dojo.setObject(Constants.ACTION_BAR_REGISTRY_OBJECT_ID, actionRegistry);
            
            this._fetchAndStoreTeamAreaPreferences();
        }
	},
	 //silently get the Team Area options
    _fetchAndStoreTeamAreaPreferences:function(callback){
        var self = this;
        
        var handlerObjTeamArea = {
        		success: function(response){         			        			
        			InitializationData._load({
        				"teamarea.enabled":(response == "true")?true: false
        			});           			        		
        		},
        		failure: function(e){
        			console.debug("CommonPreferenceClient: - Couldn't get Team Area Enabler Option");
        		}
        };
        var TA_handler = new ServiceResponseHandler(handlerObjTeamArea, "success", "failure");
        TimeBoxClient.getIsTeamAreaMultipleTimeLinesEnabled(TA_handler);
        
        var handlerObjLegacy = {
        		success: function(response){        	
        			InitializationData._load({
        				"phases.legacy.enabled":(response == "true")?false: true
        			});        			 		
        		},
        		failure: function(e){        			
        			console.debug("CommonPreferenceClient: - Couldn't get Team Area Enabler Option");
        		} 
        };
        var Legacy_handler = new ServiceResponseHandler(handlerObjLegacy, "success", "failure");
        TimeBoxClient.getIsNewIterationsEnabled(Legacy_handler);   
    },
	_handleServerInBadState: function(status) {
        var code = status ? (status.code ? status.code + ": " : (status.status ? "HTTP " + status.status + ": " : "")) : "";
		var message = status && status.message ? code + status.message : code + "Unknown";
        var msgKey = status && status.code ? "labelServerError" : "communicationError";
		console.error(message);
		var args = {
			upperText: Constants.getMessage(msgKey),
			middleText: message,
			lowerTextPreLink: null,
			lowerTextPostLink: null,			
			showIcon: false
		}
		if (this._isJazzAdmin) {
			args.lowerTextPreLink = Constants.getMessage("labelServerErrorAdmin1");
			args.lowerTextPostLink = Constants.getMessage("labelServerErrorAdmin2");
			args.linkText = Constants.getMessage("labelJazzAdminApp");
			args.linkOnClick = function() {
				document.location.href = net.jazz.ajax._contextRoot + "/admin" + document.location.search;
			}			
		} else {
			args.lowerText = Constants.getMessage("labelServerErrorContact");
		}
		var notAuth = new NotAuthorized(args);		
		notAuth._middleText.style.fontSize = "11pt";
	},
	
	_handleProductNotInitialized: function() {
		var args = {
			upperText: Constants.getMessage("msgServerNotInitialized"),
			middleText: Constants.getMessage("labelNoLicenseContact")
		};
		
		//determine if the user has the JazzAdmins role and can run the setup wizard
		if (this._isJazzAdmin) {
			args.middleText = "";
			args.lowerTextPreLink = Constants.getMessage("msgCanPerformSetup");
			args.lowerTextPostLink = ".";
			args.linkText = Constants.getMessage("msgCanPerformSetupLinkText");
			args.linkOnClick = function() {
				document.location.href = net.jazz.ajax._contextRoot + "/setup" + document.location.search;
			}
		}
		var notAuth = new NotAuthorized(args);
	},	
	
	_setUserProjectAreas: function() {
        //set user's allowed project areas      
        var projectsInitData = InitializationData.get(Constants.PERMISSIONS_INIT_DATA_KEY);
        var userProjectAreas = projectsInitData ? projectsInitData.userProjectAreas : [];
        dojo.setObject(Constants.USER_PROJECT_AREAS_OBJECT_ID, userProjectAreas);   
		
        if (!dojo.isArray(userProjectAreas) || userProjectAreas.length == 0) {
            // user doesn't belong to any project areas, show message
            var warningArgs = {
                upperText: Constants.getMessage('labelNoProjectAreas')
            };
            
            if (this._isJazzAdmin) {
                // for admin, override warning link to redirect to manage projects instead of return to login screen
                warningArgs.middleText = null;
                warningArgs.lowerTextPreLink = Constants.getMessage("labelGoToAllProjs1");
                warningArgs.lowerTextPostLink = Constants.getMessage("labelGoToAllProjs2");
                warningArgs.linkText = Constants.getMessage("labelGoToManageProjs");
                warningArgs.linkOnClick = dojo.hitch(this, function() {
                    this._redirectToManageProjectsPage();
                });
            }
            this._loginNotAllowed(warningArgs);
            return false;
        }
        
        //get desired project area from URL
		var path = location.pathname;
		var projectName = path.substring(path.lastIndexOf('/')+1); //$NON-NLS-1$
		
		//if no project area name appended
		if (projectName == 'console' || projectName == '') {
            this._determineProjectArea(userProjectAreas);
		} else {
	        var decodedName = decodeURIComponent(projectName);
	        decodedName = decodedName.replace(/%3F/g,"?"); //$NON-NLS-1$
	        
	        //find the desired project
	        var project = this._findIn(userProjectAreas, decodedName, "name");
	        if (project != null) {

                // TODO: need to set the attribute of the project ontext properly, weak it for now
                project.uri = net.jazz.ajax.contextRoot() + "/process/project-areas/" + project.itemId;
                
				//continue with initialization
				jazz.app.context.set( project );		// CML: M8 change
	            this._checkPermissions(project, false);
                return true;
	        } else {
                var projectAreasData = InitializationData.get(INITIALIZER_KEY_PROJECT_AREAS);
				var allProjectAreas = projectAreasData ? projectAreasData.projectAreas : null;
				project = allProjectAreas ? this._findIn(allProjectAreas, decodedName, "name") : null;
                var warningArgs = {
                    lowerTextPreLink: Constants.getMessage("labelGoToAllProjs1"),
                    lowerTextPostLink: Constants.getMessage("labelGoToAllProjs2"),
                    linkText: Constants.getMessage("labelGoToAllProjs"),
                    linkOnClick: dojo.hitch(this, function() {
                        this._redirectToAllProjectsPage();
                    })
                };
				
				//Note: Remove all script text from the decoded project area name in the warning messages to eliminate cross-site scripting (XSS) attacks.
		        var cleanedDecodedName = jazz.util.html.removeScript(decodedName);       
				
				if (project == null) {
                    if (allProjectAreas && dojo.isArray(allProjectAreas) && allProjectAreas.length > 0) {
                        //there is projects defined in the server but the one specified is invalid, not in the list
                        warningArgs.upperText = Constants.getMessage('labelInvalidProjectArea', cleanedDecodedName);
                        warningArgs.middleText = Constants.getMessage('labelVerifyInvalidProject');
                        
                    } else {
                        //not able to get the project list defined in the server, can be invalid project or user has no permission
                        warningArgs.upperText = Constants.getMessage('labelInaccessibleProjectArea', cleanedDecodedName);
                        warningArgs.middleText = Constants.getMessage('labelVerifyInaccessibleProject');
                    }
                    // use an alert icon instead of the default locked icon;
                    var icon = dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/detail_alert.png");
                    warningArgs.icon = icon;
				} else {
					//user is not allowed to log into the specified project area
					warningArgs.upperText = Constants.getMessage('labelUnauthProjectArea', cleanedDecodedName);
				}
                this._loginNotAllowed(warningArgs);
			}
		}
        return false;
    },
	
    _redirectToAllProjectsPage: function() {
        // redirect to JTS All Projects page
        var allProjectsPath = net.jazz.ajax._contextRoot + "/web"; //$NON-NLS
        allProjectsPath += "#action=jazz.viewPage&id=com.ibm.team.process.projectAreaList"; //$NON-NLS

        // set a global flag to indicate we're redirecting. We just called 
        // db server status and we can still catch that right when the browser
        // is being redirected. The respond handler would think it's a server
        // error due to status == 0 and put up a message. This global flag
        // communicates to the handler to ignore error status in this situation.
        GlobalEvents.QMAppIsReDirecting = true;
        window.location.href = allProjectsPath;
    },
        
    _redirectToManageProjectsPage: function(action) {
        // redirect to Manage Projects page
        var manageProjectsPath = net.jazz.ajax._contextRoot + "/admin"; //$NON-NLS
        manageProjectsPath += "#action=jazz.viewPage&id=com.ibm.team.process.ProjectAreaManagement"; //$NON-NLS
        GlobalEvents.QMAppIsReDirecting = true;
        window.location.href = manageProjectsPath;
    },
        
   /*
    *  Determine the appropriate behavior based on the fact that a project area
    *  was not specified on the URL.  There are 3 paths here:
    *   CONDITION                                       BEHAVIOR
    *   1. User belongs to 0 project areas              Show message indicating no project areas
    *   2. User belongs to exactly 1 project area       Redirect user to that project area
    *   3. User belongs to more than 1 project areas    Prompt user to choose, then redirect
    *   
    */
	_determineProjectArea: function(userProjectAreas) {
        if (userProjectAreas.length == 1) {
            //user belongs to exactly 1 project area, redirect to that PA
            this._redirect(userProjectAreas[0], false);
        } else {
            //user belongs to more than 1 project area
            this._redirectToAllProjectsPage();
        }		
	},
	
	_redirect: function(projectArea, setDefaultPA) {
		//TODO set new preferences here
		var redirectPath = net.jazz.ajax._contextRoot + "/web/console";
		if (projectArea) {
            // TODO: need to set the attribute of the project ontext properly, weak it for now
            projectArea.uri = net.jazz.ajax.contextRoot() + "/process/project-areas/" + projectArea.itemId;

			redirectPath += "/" + encodeURIComponent(projectArea.name);
			jazz.app.context.set( projectArea );		// CML: M8 change
		}
		if (location.search) {
			redirectPath +=  location.search;
		}
		if (location.hash) {
			redirectPath += location.hash;
		}
        // set a global flag to indicate we're redirecting. We just called 
        // db server status and we can still catch that right when the browser
        // is being redirected. The respond handler would think it's a server
        // error due to status == 0 and put up a message. This global flag
        // communicates to the handler to ignore error status in this situation.
		GlobalEvents.QMAppIsReDirecting = true;		
		location.href = redirectPath;
	},
	    
	_checkPermissions: function(projectArea, setDefaultPA)
	{
		//set the current PA to the PA selected by the user
		if (projectArea && projectArea.itemId) {
			dojo.setObject("com.ibm.team.process.web.projectArea", projectArea);
		}
		else {
			throw new Error(Constants.getMessage("msgMissingProjectArea", DEFAULT_PROJECT_AREA));
		}
		
		//this._loginNotAllowed();  //DEBUG ONLY
		var responseHandler = new ServiceResponseHandler(this, "_getCommonUserPreferences", "_initPermissionFailed");
		PermissionsClient.fetchAndStoreAllPermissions(responseHandler);
		
		//get isProjectAreaAdmin for the current project area
		var handler = {
			success: function(isAdmin){
				//boolean response from rest service comes back as string
				dojo.setObject(Constants.IS_PROJECT_AREA_ADMIN, (isAdmin == "true"));
			},
			failure: function(error){
				console.warn("Unable to determine if User is Project Area ADMIN.  Some functions may be disabled.");
				dojo.setObject(Constants.IS_PROJECT_AREA_ADMIN, false);
			}
		};
		var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
		PermissionsClient.checkIsProjectAreaAdmin(responseHandler);
		
		//WI 68194: get the Public URL to be used by the UI to create any OSLC link related to this server
		var publicURIhandler = {
			success: function(publicURL){
				// Set the public URL as a constant
				dojo.setObject(Constants.PUBLIC_URL, publicURL);
			},
			failure: function(error){
				console.warn("Unable to obtain the application's Public URL.  Some errors might occur during OSLC link creation.");
				dojo.setObject(Constants.PUBLIC_URL, location.protocol + '//' + location.host + net.jazz.ajax._contextRoot);
			}
		};
		var responsePublicURIHandler = new ServiceResponseHandler(publicURIhandler, "success", "failure");
		com.ibm.asq.common.web.client.internal.ServerInfoClient.getPublicURL(responsePublicURIHandler);
		
		//augment the contributor object with role information
        var contributorInitData = InitializationData.get(INITIALIZER_KEY_CONTRIBUTOR);
        if (contributorInitData != null) {
			var contributor = contributorInitData.currentContributor;
			var handler = {
				success: function(roleResponse){
					if (roleResponse && roleResponse.roles) {
						contributor.roles = roleResponse.roles;
					}
				},
				failure: function(e){
					console.warn(this.declaredClass + ": Unable to fetch role information --> " + e ? e.message : "Unknown"); //$NON-NLS$
				}
			}
			var srh = new ServiceResponseHandler(handler, "success", "failure");
			AdminClient.getUserRoles(srh);
		}
	},
    
    _getCommonUserPreferences: function()
    {
        var internalHandlerObj = {
            self: this,
            successPrefs: function(response) {
                // get the user preference for showing dashboard mini
                // It's stored in the action bar category.
                var key = Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key;
                var len = response ? response.length : 0;
                var actionBarPref = null;
                
                for(var i = 0; i < len; i++) {
                    var pref = response[i];
                    if(pref.key == key) {
                        actionBarPref = pref.value;
                    }
                }
                // if the value is pre 3.0, use the default value, which is to show.
                if(dojo.isObject(actionBarPref)) {
                    this.self._showDashboardMini = actionBarPref.showDashboardMini;
                }
                this.checkDone();
            },
			successInfo: function(response) {
				this.self._suppressWorkItems = response === "false";
				this.checkDone();
			},
            failure: function(e) {
                this.checkDone();
            },
			// only initialize the ui once both requests are done
			checkDone: function() {
				if (this.finished) this.self._initAppUI();
				else this.finished = true;
			}
        }
		// make both requests in parallel to improve load time
        var responseHandler = new ServiceResponseHandler(internalHandlerObj, "successPrefs", "failure");
        com.ibm.asq.common.web.client.internal.CommonPreferenceClient.fetchAndStoreUserPreferences(responseHandler);
		// we should be doing this in init data, but we don't know the project area there
        var responseHandler2 = new ServiceResponseHandler(internalHandlerObj, "successInfo", "failure");
		com.ibm.asq.common.web.client.internal.ServerInfoClient.getIsSelfLinkedProject(responseHandler2,{
			processArea: jazz.app.context.get().itemId
		});
    },	
	
    _loginNotAllowed: function(args) 
    {
//        console.debug(this.declaredClass + ": Can't log in due to license issue.");
		var notAuth = new NotAuthorized(args || {});
    },

    _initPermissionFailed: function() 
    {
        console.debug("Unable to fetch permission information.");
        this._getCommonUserPreferences();
    },
    
    _initAppUI: function()
    {
        // Popuplate the banner right area widgets. Add each one to the
        // buttons content in the order of which we want them to appears
        // We don't have to explicitly add/create the user's button. The
        // base class will auto insert the user action next to the last 
        // button, which is the help.
        var pa = dojo.getObject("com.ibm.team.process.web.projectArea");
        
        if (pa && pa.name) {
            this.ui.set("bannerTitle", pa.name);
        } else if (this.showAllProjectsPage) {
            // use "All Projects" for the banner title
            this.ui.set("bannerTitle", JazzAppMessages.allProjects);
            // hide the search box in the navbar
            dojo.style(this.ui._searchArea, "display", "none");
        }

        var adminDescr = {
            label: Constants.getMessage("labelAdmin"),
            className: "admin-menu",
            align: "right"
        };
        this.config.buttons.push(adminDescr);

        var serverMessages = InitializationData.get("com.ibm.team.repository.service.compatibility.util.serverMessages");
        var alertsArgs = { messages: [] };
        if (serverMessages && serverMessages.items && serverMessages.items.length) {
            alertsArgs.messages = serverMessages.items;
        }
        this.ui.set("info", new com.ibm.team.repository.web.ui.internal.SystemAlertsWidget(alertsArgs));
        
        // the help menu is the last content in the banner right area.
        this.config.buttons.push({
            label: Constants.getMessage("labelHelp"),
            className: "help-menu",
            align: "right",
            menuProvider: dojo.hitch(this, this._helpMenuProvider)
        });
        
        // add the dashboard mini to the drawer.   
        if (this._showDashboardMini) {
            this.ui.set("drawer", "com.ibm.team.dashboard.web.ui.DashboardMini");
        }
		
		// suppress the work item search if necessary
		if (this._suppressWorkItems) {
			dojo.setObject("com.ibm.team.repository.web.suppressedPages", {
				"com.ibm.rqm.planning.web.qualityManager": ["com.ibm.team.workitem"] 
			});
		}
        
        // set up project area switcher
        this.config.contextSwitcher = {
            adminUI: false,
            contexts: dojo.getObject("com.ibm.rqm.web.userProjectAreas"),
            currentContext: dojo.getObject("com.ibm.team.process.web.projectArea"),
            onChange: dojo.hitch(this, this._changeProjectAreas)
        };
		
        Constants.validateMessageBundle();
        dojo.addClass(dojo.body(), "com-ibm-rqm-web");
        dojo.addClass(dojo.body(), "rqm-print");
                
        var myQMPage = new QMPage({
            ui: this.ui,
            showAllProjectsPage: this.showAllProjectsPage
        });
        
        // delegate the admin menu provider to the global task bar
        // It's just that it has been holding the code for the admin
        // menu. Don't have to change it.
        adminDescr.menuProvider = dojo.hitch(myQMPage._globalTaskBar, "_adminMenuProvider");
       
        dojo.subscribe(GlobalEvents.ShowInfoCenterHelp, this, "_showInfoCtr");
        
        // yield to let the page paint first, before starting the app.
        setTimeout(dojo.hitch(this, "start"), 10);
        
        // track when user logged back in after a session timeout
        dojo.subscribe(jazz.app.events.LOGIN, this, "_onUserReauthenticated");
    },
    
    // handler after the user re-authenticated after a session timeout
    //
    _onUserReauthenticated: function(userId) {
        // clear the current E-Sig signer user id
        dojo.setObject(GlobalEvents.ESigSignerUserId, null);
    },
    
    _userMenuItemsProvider: function() {
        var prefMenuItem = {
            label: Constants.getMessage("labelMyQMPreferences"),
            onClick: function() {
                PlanningUtil.openPreferencesEditor();
            }
        };
        return prefMenuItem;
    },
    
    _helpMenuProvider: function() {
        var menu = new jazz.app._ComponentMenu();
        menu.addItemByArgs({
            label: Constants.getMessage("labelHelpContents"),
            icon: dojo.moduleUrl("jazz.app","graphics/JazzUI/icons/systemhelp.gif"),
            onClick: dojo.hitch(this, this._showInfoCtr)
        });

        menu.addItemByArgs({
            label: Constants.getMessage("labelAboutDialogTitle"),
            onClick: dojo.hitch(this, this._showAbout)
        });

        try {
            var welcomeLabel = Constants.getMessage("labelWelcome");
            var dfd = com.ibm.team.app.web.internal.welcome.WelcomeUtil.isWelcomeEnabled();
            dfd.addCallback(dojo.hitch(this, function(menu, welcomeLabel, enabled){
                if (enabled) {
                    menu.addItemByArgs({
                        label: welcomeLabel,
                        onClick: dojo.hitch(this, this._openWelcomePage)
                    });
                }
            }, menu, welcomeLabel));
        } catch (ex) {
            // skip this menu option for any exception encountered
            console.error(ex.message);
        }
        return menu;
    },
    
    _openWelcomePage: function(event) {
        location.href = "#action=com.ibm.team.app.viewWelcome";
    },

    _showInfoCtr: function(topicUri) {
        var infoCtrURL = dojo.getObject("com.ibm.team.repository.web.helpuri");
        if (!infoCtrURL) {
            alert(Constants.getMessage("msgFailedOpenInfoCenter"));
            
        } else {
            var infoCtrWindow = window.open(infoCtrURL);
            infoCtrWindow.focus();
        }
    },

    _showAbout: function() {
        var about = new com.ibm.team.repository.web.ui.internal.about.AboutDialog({});
    },

    _changeProjectAreas: function(contextObj) {
        this._redirect(contextObj);
    },

	failure: function(errorObj)
	{
		console.error(errorObj.message);
	},
	
	// functions for sorting pages	
	getCurrentWorkbenchID: function() {
		return net.jazz.ajax.ui.PlatformUI._getApplicationId();
	},

    _findIn: function(array, value, byProperty) {
        for (var i = 0; i < (dojo.isArray(array) ? array.length : 0); i++) {
			if (dojo.isObject(array[i]) && byProperty != null && array[i][byProperty] && array[i][byProperty] == value) {
				return array[i]; 		 	
			} else if (array[i] == value) {
				return array[i];
			}			
		}
		return null;
    }		
});
})();
