/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.tests.scheduler.time.TimespanIteratorTest");

dojo.require("com.ibm.team.apt.shared.client.internal.duration.Instant");
dojo.require("com.ibm.team.apt.shared.client.internal.duration.Timespan");
dojo.require("com.ibm.team.apt.shared.client.internal.scheduler.time.TimespanIterator");
dojo.require("com.ibm.team.apt.web.ui.tests.scheduler.time.AbstractWorktimeSchedulerTest");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");

(function() {
var team= com.ibm.team;
var apt= team.apt;
var internal= apt.shared.client.internal;
var duration= internal.duration;
var Instant= duration.Instant;
var Timespan= duration.Timespan;
var TimespanIterator= internal.scheduler.time.TimespanIterator;
var AbstractWorktimeSchedulerTest= apt.web.ui.tests.scheduler.time.AbstractWorktimeSchedulerTest;
var JSAssert= team.dev.jdojo.junit.script.JSAssert;

dojo.declare("com.ibm.team.apt.web.ui.tests.scheduler.time.TimespanIteratorTest", AbstractWorktimeSchedulerTest, {

	setUp: function() {
		this.inherited("setUp", arguments, []);
	},

	testSanitizingTimestampsDoesNotChangeOrderWhenInputIsNotOverlappingWhileCreatingObject: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/01"));
		var start3= Instant.fromDate(new Date("2014/07/01"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/11/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		timespans.push(new Timespan(start3, end3));
		var testObj= new TimespanIterator(timespans);
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(3, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start2, newTimespans[1].getStart());
		JSAssert.assertEquals(end2, newTimespans[1].getEnd());
		JSAssert.assertEquals(start3, newTimespans[2].getStart());
		JSAssert.assertEquals(end3, newTimespans[2].getEnd());
	},

	testTimespansSanitizeddWhenTheyOverlapWhileCreatingObject: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/01"));
		var end1= Instant.fromDate(new Date("2014/05/11"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(2, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals((Instant.fromDate(new Date("2014/05/11")).getTime()), newTimespans[1].getStart().getTime());
		JSAssert.assertEquals(end2, newTimespans[1].getEnd());
	},

	testSanitizingTimestampsDoesNotChangeOrderWhenInputIsNotOverlappingWhileAddingTimespanEntries: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/01"));
		var start3= Instant.fromDate(new Date("2014/07/01"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/11/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		testObj.add(new Timespan(start3, end3));
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(3, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start2, newTimespans[1].getStart());
		JSAssert.assertEquals(end2, newTimespans[1].getEnd());
		JSAssert.assertEquals(start3, newTimespans[2].getStart());
		JSAssert.assertEquals(end3, newTimespans[2].getEnd());
	},

	testTimespansAreSanitizedWhenTheyOverlapWhileAddingTimespanEntriesCase1: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/01"));
		var start3= Instant.fromDate(new Date("2014/06/24"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/11/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		testObj.add(new Timespan(start3, end3));
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(2, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start2, newTimespans[1].getStart());
		JSAssert.assertEquals(end3, newTimespans[1].getEnd());
	},

	testTimespansAreSanitizedWhenTheyOverlapWhileAddingTimespanEntriesCase2: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/01"));
		var start3= Instant.fromDate(new Date("2014/06/30"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/11/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		testObj.add(new Timespan(start3, end3));
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(2, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start2, newTimespans[1].getStart());
		JSAssert.assertEquals(end3, newTimespans[1].getEnd());
	},

	testTimespansAreSanitizedWhenTheyOverlapWhileAddingTimespanEntriesCase3: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/06/01"));
		var start3= Instant.fromDate(new Date("2014/05/12"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/06/29"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		testObj.add(new Timespan(start3, end3));
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(2, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start3, newTimespans[1].getStart());
		JSAssert.assertEquals(end2, newTimespans[1].getEnd());
	},

	testTimespansAreSanitizedWhenTheyOverlapWhileAddingTimespanEntriesCase4: function() {
		var timespans= [];
		var start1= Instant.fromDate(new Date("2014/03/01"));
		var start2= Instant.fromDate(new Date("2014/05/15"));
		var start3= Instant.fromDate(new Date("2014/05/01"));
		var end1= Instant.fromDate(new Date("2014/04/30"));
		var end2= Instant.fromDate(new Date("2014/06/30"));
		var end3= Instant.fromDate(new Date("2014/11/30"));
		timespans.push(new Timespan(start1, end1));
		timespans.push(new Timespan(start2, end2));
		var testObj= new TimespanIterator(timespans);
		testObj.add(new Timespan(start3, end3));
		var newTimespans= testObj.getTimespans();
		JSAssert.assertEquals(2, newTimespans.length);
		JSAssert.assertEquals(start1, newTimespans[0].getStart());
		JSAssert.assertEquals(end1, newTimespans[0].getEnd());
		JSAssert.assertEquals(start3, newTimespans[1].getStart());
		JSAssert.assertEquals(end3, newTimespans[1].getEnd());
	}
});

})();
