/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.PlanLinkCell");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.web.client.BidiUtil");
dojo.require("com.ibm.team.apt.web.client.util");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.GadgetUtility");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.PlanLinkColumns");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.PlanLinkElement");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.PlanLinksImagePool");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.RequirementCollectionElement");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.RequirementCollectionLinkTreeTwisite");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget");
dojo.require("jazz.ui.ResourceLink");

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var web= team.apt.web;
var client= web.client;
var BidiUtil= client.BidiUtil;
var util= client.util;
var internal= web.ui.internal;
var GadgetUtility= internal.common.viewer.plan.GadgetUtility;
var planlinks= internal.editor.items.planlinks;
var PlanLinkColumns= planlinks.PlanLinkColumns;
var PlanLinkElement= planlinks.PlanLinkElement;
var PlanLinksImagePool= planlinks.PlanLinksImagePool;
var RequirementCollectionElement= planlinks.RequirementCollectionElement;
var RequirementCollectionLinkTreeTwisite= planlinks.RequirementCollectionLinkTreeTwisite;
var CellGadget= team.rtc.foundation.web.ui.gridviewer.CellGadget;
var keys= dojo.keys;
var ResourceLink= jazz.ui.ResourceLink;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.apt.web.ui.internal.editor.items.planlinks.PlanLinkCell", CellGadget, {

	//fAttribute: null,

	//fResourceLink: null,

	//fTreeTwistie: null,

	//fPlanLinkElement: null,

	//fTextDir: null,

	//fOnDirectionChangeHandle: null,

	//fOnLabelChangeHandle: null,

	//fTextContainer: null,

	constructor: function(column, rowEntry, viewer, planEditor) {
		this.inherited(arguments, [column, rowEntry, viewer]);
		this.fAttribute= column.getLabel();
		this.fPlanLinkElement= this.fRowEntry.getElement();
		if (this.fPlanLinkElement instanceof RequirementCollectionElement) {
			this.fTreeTwistie= new RequirementCollectionLinkTreeTwisite(GadgetUtility.getTreeLevel(rowEntry, PlanLinkElement), rowEntry, viewer, planEditor);
		}
		if (this.fTextDir == null) 
			this.fTextDir= viewer.getBaseTextDir();
		if (this.fTextDir != null) {
			this.fOnDirectionChangeHandle= dojo.connect(this.fViewer, "publishTextDir", this, "_setBaseTextDir");
		}
	},

	doCreateCellContent: function(cellContainer) {
		var doc= dojo.doc;
		if (this.fAttribute.localeCompare(PlanLinkColumns.NAME.getLabel()) === 0) {
			var linkRef= this.fPlanLinkElement.getLinkURL();
			if (this.fPlanLinkElement.getLocalItemId() != null) {
				linkRef= util.getPlanViewURI(this.fPlanLinkElement.getLocalItemId(), null);
			}
			var linkContainer= dojo.create("div", {className: "linkContainer"}, cellContainer);
			this.fTextContainer= linkContainer;
			if (this.fTreeTwistie != null) {
				dojo.place(this.fTreeTwistie.createGadget(), linkContainer);
			}
			var anchor= doc.createElement("a");
			anchor.appendChild(doc.createTextNode(this.fPlanLinkElement.getLabel()));
			anchor.href= linkRef;
			var args= {};
			args.uri= this.fPlanLinkElement.getLinkURL();
			args.presentationUri= linkRef;
			args.label= jazz.util.html.escape(this.fPlanLinkElement.getLabel());
			var imageUrl= this.fPlanLinkElement.getIconURL();
			if (imageUrl == null || imageUrl.length === 0) {
				imageUrl= PlanLinksImagePool.REQUIREMENT.toUri();
			}
			var img= dojo.create("img", {src: imageUrl, className: "icon"}, linkContainer);
			args.iconNode= img;
			this.fResourceLink= new ResourceLink(args, anchor);
			dojo.connect(this.fResourceLink, "_applyTitle", this, "_setBaseTextDir");
			var linkNode= dojo.create("div", {className: "link"}, linkContainer);
			dojo.place(this.fResourceLink.domNode, linkNode);
			this._setBaseTextDir();
		} else if (this.fAttribute.localeCompare(PlanLinkColumns.COMMENTS.getLabel()) === 0) {
			var linkURL= this.fPlanLinkElement.getLinkURL();
			dojo.place(doc.createTextNode(linkURL), cellContainer);
		}
		cellContainer.removeAttribute("title");
	},

	onKeyDown: function(event) {
		if (this.fAttribute.localeCompare(PlanLinkColumns.NAME.getLabel()) === 0) {
			if (event.keyCode === keys.ENTER) {
				var planLinkElement= this.fRowEntry.getElement();
				var linkRef= planLinkElement.getLinkURL();
				if (planLinkElement.getLocalItemId() != null) {
					linkRef= util.getPlanViewURI(planLinkElement.getLocalItemId(), null);
				}
				window.location.replace(linkRef);
				event.preventDefault();
				return true;
			}
		}
		var viewEntryGadget= this.fViewer.getViewEntryGadget(this.fRowEntry);
		if (jdojo.implementsInterface(viewEntryGadget, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler")) {
			return viewEntryGadget.onKeyDown(event);
		}
		return false;
	},

	doDestroy: function() {
		if (this.fResourceLink != null) {
			if (this.fOnLabelChangeHandle != null) {
				dojo.disconnect(this.fOnLabelChangeHandle);
			}
			this.fResourceLink.destroy(false);
			this.fResourceLink= null;
		}
		if (this.fTreeTwistie != null) {
			this.fTreeTwistie.destroy();
			this.fTreeTwistie= null;
		}
		if (this.fOnDirectionChangeHandle != null) {
			dojo.disconnect(this.fOnDirectionChangeHandle);
		}
		this.inherited("doDestroy", arguments, []);
	},

	_setBaseTextDir: function() {
		this.fTextDir= this.fViewer.getBaseTextDir();
		var anchor= dojo.query("a", this.fTextContainer)[0];
		if (this.fTextDir === "ltr" || this.fTextDir === "rtl") {
			dojo.style(anchor, "direction", this.fTextDir);
			dojo.style(anchor, "unicodeBidi", "embed");
		} else if (this.fTextDir === "auto") {
			dojo.style(anchor, "direction", BidiUtil.getElementBaseTextDir(anchor));
			dojo.style(anchor, "unicodeBidi", "embed");
		} else {
			dojo.style(anchor, "direction", "");
			dojo.style(anchor, "unicodeBidi", "");
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true
	}
});

})();
