/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.parts.EstimateAndCorrectionAttributePart");

dojo.require("com.ibm.team.apt.api.common.ItemType");
dojo.require("com.ibm.team.apt.api.common.UIItemHandle");
dojo.require("com.ibm.team.apt.shared.client.internal.util.Future");
dojo.require("com.ibm.team.apt.web.ui.internal.common.util.ProjectDurationFormat");
dojo.require("com.ibm.team.apt.web.ui.internal.parts.AbstractAttributePart");
dojo.require("com.ibm.team.apt.web.ui.internal.parts.DurationUtil");
dojo.require("com.ibm.team.apt.web.ui.internal.parts.DurationWidget");
dojo.require("com.ibm.team.apt.web.ui.internal.parts.ProjectConfigurationUtil");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.parts", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.parts", "Messages");

var apt= com.ibm.team.apt;
var common= apt.api.common;
var ItemType= common.ItemType;
var UIItemHandle= common.UIItemHandle;
var Future= apt.shared.client.internal.util.Future;
var internal= apt.web.ui.internal;
var ProjectDurationFormat= internal.common.util.ProjectDurationFormat;
var parts= internal.parts;
var AbstractAttributePart= parts.AbstractAttributePart;
var DurationUtil= parts.DurationUtil;
var DurationWidget= parts.DurationWidget;
var ProjectConfigurationUtil= parts.ProjectConfigurationUtil;

var EstimateAndCorrectionAttributePart= dojo.declare("com.ibm.team.apt.web.ui.internal.parts.EstimateAndCorrectionAttributePart", AbstractAttributePart, {

	//fAttributeId: null,

	//fEstimate: null,

	//fEstimateWidget: null,

	//fCorrectedEstimate: null,

	//fCorrectedEstimateWidget: null,

	constructor: function(params) {
		this.fAttributeId= params.attributeId;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, "DurationAttributePart NarrowWidget com-ibm-team-apt-web-ui-internal-parts-EstimateAndCorrectionAttributePart");
		this.fEstimateWidget= new DurationWidget({useShortForm: true, ariaUnitLabel: Messages.EstimateAndCorrectionAttributePart_ESTIMATE_EDIT_UNIT, ariaInputLabel: Messages.EstimateAndCorrectionAttributePart_ESTIMATE_EDIT_LABEL, errorMessage: Messages.DurationWidget_MESSAGE_DEFAULT_INVALID_INPUT, statusIndicatorContainerClass: "StatusIconEstimateTextContainer2", callback: dojo.hitch(this, function(oldValue, newValue) {
			this.internalEstimateChanged(oldValue, newValue);
		})});
		dojo.addClass(this.fEstimateWidget.domNode, "EstimateWidget2");
		this.domNode.appendChild(this.fEstimateWidget.domNode);
		var div= dojo.create("div", {className: "EstimateCorrectionDiv2"}, this.domNode);
		var span= dojo.create("span", {className: "EstimateCorrectionSpan2"}, div);
		dojo.place(dojo.doc.createTextNode(Messages.EstimateAndCorrectionAttributePart_CORRECTION_ESTIMATE_LABEL), span);
		this.fCorrectedEstimateWidget= new DurationWidget({useShortForm: true, ariaUnitLabel: Messages.EstimateAndCorrectionAttributePart_CORRECTION_EDIT_UNIT, ariaInputLabel: Messages.EstimateAndCorrectionAttributePart_CORRECTION_EDIT_LABEL, errorMessage: Messages.DurationWidget_MESSAGE_DEFAULT_INVALID_INPUT, statusIndicatorContainerClass: "StatusIconEstimateTextContainer2", callback: dojo.hitch(this, function(oldValue, newValue) {
			this.internalCorrectedEstimateChanged(oldValue, newValue);
		}), correctionLabelElement: span});
		dojo.addClass(this.fCorrectedEstimateWidget.domNode, "CorrectedEstimateWidget2");
		div.appendChild(this.fCorrectedEstimateWidget.domNode);
		var future= new Future();
		future.setCallback(dojo.hitch(this, function(result) {
			this.withProjectConfiguration(result);
		}));
		future.setErrCallback(function(result) {
			console.error(result);
		});
		var projectArea= UIItemHandle.itemHandleFrom(ItemType.ProjectArea, this.fWorkingCopy.getProjectAreaItemId());
		ProjectConfigurationUtil.getInstance(projectArea).withProjectConfiguration(future);
	},

	destroy: function(preserveDom) {
		this.fEstimateWidget.destroy(preserveDom);
		this.fCorrectedEstimateWidget.destroy(preserveDom);
		this.inherited("destroy", arguments, [preserveDom]);
	},

	getValue: function() {
		return [this.fEstimate, this.fCorrectedEstimate];
	},

	setReadOnly: function(isReadOnly) {
		this.fEstimateWidget.setReadOnly(this.fEstimateWidget.isReadOnly() || isReadOnly);
		this.fCorrectedEstimateWidget.setReadOnly(isReadOnly);
	},

	estimateAttributeChanged: function(params) {
		this.fEstimate= this.getAttributeValue(this.getEstimatePath());
		this.fEstimateWidget.setValue(this.fEstimate);
	},

	correctedEstimateAttributeChanged: function(params) {
		this.fCorrectedEstimate= this.getAttributeValue(this.getCorrectedEstimatePath());
		this.fCorrectedEstimateWidget.setValue(this.fCorrectedEstimate);
		this.checkEstimateEnabled();
	},

	internalEstimateChanged: function(oldValue, newValue) {
		if (!DurationUtil.isEqual(oldValue, newValue)) {
			this.fEstimate= newValue;
			this.setAttributeValue(this.fAttributeId, this.getEstimatePath(), this.fEstimate);
		}
	},

	internalCorrectedEstimateChanged: function(oldValue, newValue) {
		if (!DurationUtil.isEqual(oldValue, newValue)) {
			this.fCorrectedEstimate= newValue;
			this.setAttributeValue(EstimateAndCorrectionAttributePart.CORRECTED_ESTIMATE_ATTRIBUTE_ID, this.getCorrectedEstimatePath(), this.fCorrectedEstimate);
			this.checkEstimateEnabled();
		}
	},

	withProjectConfiguration: function(projectConfiguration) {
		var durationFormat= new ProjectDurationFormat(projectConfiguration.getDurationConfiguration());
		this.fEstimateWidget.setDurationFormat(durationFormat);
		this.estimateAttributeChanged(null);
		this.fEstimateWidget.setReadOnly(false);
		this.attachListener(this.getEstimatePath().concat("id"), "estimateAttributeChanged");
		this.attachListener(this.getEstimatePath().concat("label"), "estimateAttributeChanged");
		this.attachListener(this.getEstimatePath(), "estimateAttributeChanged");
		this.fCorrectedEstimateWidget.setDurationFormat(durationFormat);
		this.correctedEstimateAttributeChanged(null);
		this.fCorrectedEstimateWidget.setReadOnly(false);
		this.attachListener(this.getCorrectedEstimatePath().concat("id"), "correctedEstimateAttributeChanged");
		this.attachListener(this.getCorrectedEstimatePath().concat("label"), "correctedEstimateAttributeChanged");
		this.attachListener(this.getCorrectedEstimatePath(), "correctedEstimateAttributeChanged");
		this.checkEstimateEnabled();
	},

	getEstimatePath: function() {
		return ["attributes", this.fAttributeId];
	},

	getCorrectedEstimatePath: function() {
		return ["attributes", EstimateAndCorrectionAttributePart.CORRECTED_ESTIMATE_ATTRIBUTE_ID];
	},

	checkEstimateEnabled: function() {
		this.fEstimateWidget.setReadOnly(DurationUtil.isSpecified(this.fCorrectedEstimate) || !DurationUtil.isValid(this.fCorrectedEstimate));
	}
});

EstimateAndCorrectionAttributePart.CORRECTED_ESTIMATE_ATTRIBUTE_ID= "correctedEstimate";

})();
