/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetTableViewer");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.rtc.foundation.api.common.Severity");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.util.DateUtil");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.util.NumberFormatUtil");
dojo.require("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetConstants");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.date");
dojo.require("dojo.i18n");
dojo.require("dojo.number");
dojo.require("dojox.uuid");
dojo.require("dojox.uuid.generateRandomUuid");
dojo.require("dojox.uuid.generateTimeBasedUuid");

dojo.requireLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

(function() {
var TimesheetMessages= dojo.i18n.getLocalization("com.ibm.team.tpt.web.ui.timesheet.internal.messages", "TimesheetMessages");

var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var Severity= team.rtc.foundation.api.common.Severity;
var internal= team.tpt.web.ui.timesheet.internal;
var util= internal.util;
var DateUtil= util.DateUtil;
var NumberFormatUtil= util.NumberFormatUtil;
var TimesheetConstants= internal.viewers.TimesheetConstants;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var number= dojo.number;
var uuid= dojox.uuid;

var TimesheetTableViewer= dojo.declare("com.ibm.team.tpt.web.ui.timesheet.internal.viewers.TimesheetTableViewer", [ _Widget, _Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.tpt.web.ui", "timesheet/internal/templates/TimesheetTableViewer.html"),

	constructor: function() {
		this.ftimesheetRecordPresent= false;
		this.fworkItemType= "";
		this.fTimesheetTableRowCount= 0;
		this.fRowIdtoUserIdMap= {};
		this.fOwnerNamesCache= {};
	},

	initializeTimesheetTableViewer: function(tableStyles, labelProvider, columnProvider, weekDate, timesheetEnrtyPartWidget) {
		this.ftableStyles= tableStyles;
		this.fcolumnProvider= columnProvider;
		this.fweekDate= weekDate;
		this.flabelProvider= labelProvider;
		this.ftimesheetEnrtyPartWidget= timesheetEnrtyPartWidget;
		for (var i= 0; i < this.ftableStyles.length; i++){
			dojo.addClass(this.__table, this.ftableStyles[i]);
		}
		this.createTimesheetTableHeader();
	},

	//ftimesheetEnrtyPartWidget: null,

	//fweekDate: null,

	//finput: null,

	//flabelProvider: null,

	//fcolumnProvider: null,

	//ftableStyles: null,

	//fuserDefinedTimeCodes: null,

	//fsavedTimeCodes: null,

	//ftimesheetRecordPresent: null,

	//fselectedTimeCode: null,

	//fworkItemType: null,

	//fTimesheetTableRowCount: null,

	//__tableBody: null,

	//__tableHeaderRowLine: null,

	//__tableHeaderRow: null,

	//__table: null,

	//ftInfoMessage: null,

	//fConnectHandle: null,

	//fConnectChangeHandle: null,

	setWorkItemType: function(workItemType) {
		this.fworkItemType= workItemType;
	},

	setWeekDate: function(weekDateVal) {
		this.fweekDate= weekDateVal;
		if (this.ftimesheetRecordPresent === false) {
			this.refresh();
		} else {
			this.refreshTimesheetTableforNewDate();
		}
	},

	getLabelProvider: function() {
		return this.flabelProvider;
	},

	getColumnProvider: function() {
		return this.fcolumnProvider;
	},

	setInput: function(timesheet) {
		this.finput= timesheet;
		this.refresh();
	},

	setTimeCodes: function(timeCodes) {
		this.fuserDefinedTimeCodes= timeCodes;
	},

	refresh: function() {
		if (this.finput != null) {
			if (this.__tableBody != null) {
				for (; this.__tableBody.hasChildNodes(); ){
					this.__tableBody.removeChild(this.__tableBody.firstChild);
				}
			}
			if (this.ftInfoMessage != null) {
				for (; this.ftInfoMessage.hasChildNodes(); ){
					this.ftInfoMessage.removeChild(this.ftInfoMessage.firstChild);
				}
			}
			this.createTimesheetRow(this.finput);
		}
	},

	destroy: function(param) {
		if (this.__tableBody != null) {
			var children= this.__tableBody.childNodes;
			for (var i= 0; i < children.length; i++){
				this.__tableBody.removeChild(children.item(i));
			}
		}
		if (this.ftInfoMessage != null) {
			var children1= this.ftInfoMessage.childNodes;
			for (var i= 0; i < children1.length; i++){
				this.ftInfoMessage.removeChild(children1.item(i));
			}
		}
		this.flabelProvider.destroy();
		dojo.disconnect(this.fConnectChangeHandle);
		dojo.disconnect(this.fConnectHandle);
		this.inherited("destroy", arguments, [param]);
	},

	createTimesheetTableHeader: function() {
		var columnProvider= this.getColumnProvider();
		var count= parseInt((String(columnProvider.getColumnCount())), 10);
		for (var index= 0; index < count; index++){
			var ftrowLine= window.document.createElement("th");
			this.__tableHeaderRowLine.appendChild(ftrowLine);
			var ftheaderColumn= window.document.createElement("td");
			var cssIndex= 0;
			if (index >= TimesheetConstants.WEEK_TOTAL_INDEX) {
				cssIndex= 2;
			} else if (index >= TimesheetConstants.SUNDAY_INDEX) {
				cssIndex= 1;
			}
			if (index === count - 1) {
				cssIndex= 0;
			}
			dojo.addClass(ftheaderColumn, "tptHeaderRowColumn" + cssIndex);
			var label= String(columnProvider.getLabel(index));
			ftheaderColumn.appendChild(window.document.createTextNode(label));
			this.__tableHeaderRow.appendChild(ftheaderColumn);
		}
	},

	createTimesheetRowId: function() {
		return TimesheetConstants.TIMESHEET_TABLE_ROW_ID + uuid.generateRandomUuid();
	},

	/**
	 * Creates a new time sheet table row
	 * @param timesheet
	 */
	addTimesheetRow: function() {
		if (this.ftimesheetRecordPresent === false) {
			if (this.__tableBody != null) {
				while(this.__tableBody.hasChildNodes()){
					this.__tableBody.removeChild(this.__tableBody.firstChild);
				}
			}
			if (this.ftInfoMessage != null) {
				while(this.ftInfoMessage.hasChildNodes()){
					this.ftInfoMessage.removeChild(this.ftInfoMessage.firstChild);
				}
			}
		}
		var newDTO= {};
		newDTO.timeCode= "";
		newDTO.timeSpent= 0;
		newDTO.startDate= "";
		newDTO.workType= "";
		newDTO.itemId= null;
		var ftResult= window.document.createElement("tr");
		var id= this.createTimesheetRowId();
		ftResult.id= id;
		var ftColumn= null;
		var ownerId= this.getCurrentUserId();
		if (!(ownerId in this.fOwnerNamesCache)) {
			this.fOwnerNamesCache[ownerId]= this.getCurrentUserName();
		}
		this.fRowIdtoUserIdMap[id]= ownerId;
		ftColumn= this.createTimesheetColumn_1(this.fOwnerNamesCache[ownerId], TimesheetConstants.OWNER_INDEX);
		ftResult.appendChild(ftColumn);
		ftColumn= this.createNewTimeCodeColumn(newDTO, TimesheetConstants.TIME_CODE_INDEX, this.getCurrentUserId(), id);
		if (ftColumn == null) {
			this.ftimesheetEnrtyPartWidget.handleError(TimesheetMessages.NO_TIMECODE_PRESENT, Severity.INFO);
			return ;
		}
		ftResult.appendChild(ftColumn);
		var currentDateIndex= 0;
		for (var i= TimesheetConstants.SUNDAY_INDEX; i <= TimesheetConstants.SATURDAY_INDEX; i++){
			var currentDateValue= this.fweekDate.getTime() + ((currentDateIndex) * this.getDaysInMillis(1));
			newDTO.startDate= DateUtil.normalizedFormatDate(new Date(currentDateValue));
			ftColumn= this.createTimesheetColumn(newDTO, i, id);
			ftResult.appendChild(ftColumn);
			currentDateIndex++;
		}
		ftColumn= this.createTimesheetColumn_1(TimesheetMessages.ZERO_HOURS, TimesheetConstants.WEEK_TOTAL_INDEX);
		ftResult.appendChild(ftColumn);
		var list= ftResult.childNodes;
		var timeCodeColumn= list.item(TimesheetConstants.TIME_CODE_INDEX);
		var timecode= this.fetchHTMLElementText(timeCodeColumn);
		var workItemTotalValue= this.finput.getWorkItemTotalForTimeCodeAndUser(timecode, this.getCurrentUserId()) + "";
		ftColumn= this.createTimesheetColumn_1(workItemTotalValue, TimesheetConstants.TOTAL_INDEX);
		ftResult.appendChild(ftColumn);
		ftColumn= this.createTimesheetColumn(null, TimesheetConstants.ACTIONS_INDEX, id);
		ftResult.appendChild(ftColumn);
		this.__tableBody.appendChild(ftResult);
		this.ftimesheetRecordPresent= true;
	},

	createNewTimeCodeColumn: function(timesheet, index, userId, rowId) {
		var alreadyExistingTimeCodes= this.alreadySelectedTimeCodes(rowId, userId);
		var result= window.document.createElement("td");
		dojo.addClass(result, "tptViewerColumn" + index);
		var isSelectValueFound= false;
		if (this.fuserDefinedTimeCodes != null) {
			var ftSelectElement= window.document.createElement("select");
			for (var i= 0; i < this.fuserDefinedTimeCodes.length; i++){
				var ftOptionElement= dojo.create("option", {id: "TimeCodeOption" + i});
				ftOptionElement.appendChild(dojo.doc.createTextNode(this.fuserDefinedTimeCodes[i]));
				if ((this.fuserDefinedTimeCodes[i] in alreadyExistingTimeCodes)) {
					ftOptionElement.selected= false;
				} else {
					if (!isSelectValueFound) {
						ftOptionElement.selected= true;
						ftSelectElement.value= ftOptionElement.value;
						timesheet.timeCode= ftOptionElement.value;
						isSelectValueFound= true;
					}
				}
				ftSelectElement.appendChild(ftOptionElement);
			}
			if (!isSelectValueFound) {
				return null;
			}
			if (dojo.isIE) {
				this.fConnectHandle= dojo.connect(ftSelectElement, 'mouseover', dojo.hitch(this, function(event) {
					this.validateTimeCodes(event);
				}));
			} else {
				this.fConnectHandle= dojo.connect(ftSelectElement, 'click', dojo.hitch(this, function(event) {
					this.validateTimeCodes(event);
				}));
			}
			this.fConnectChangeHandle= dojo.connect(ftSelectElement, 'change', dojo.hitch(this, function(event) {
				this.modifyExistingTimesheetDate(event);
			}));
			result.appendChild(ftSelectElement);
		} else {
			result.appendChild(window.document.createTextNode(TimesheetMessages.NO_TIMECODE_PRESENT));
		}
		return result;
	},

	modifyExistingTimesheetDate: function(event) {
		if (this.finput != null && this.fselectedTimeCode != null) {
			var timeCodeSelectElement= event.target;
			var timesheetEntries= this.finput.getAllTimesheetWithTimeCodes(this.fselectedTimeCode, this.getCurrentUserId());
			var newTimeCode= "";
			if (timeCodeSelectElement != null && timeCodeSelectElement.nodeName === "SELECT") {
				if (dojo.isIE) {
					var options= timeCodeSelectElement.options;
					var selectedOption= options.item(timeCodeSelectElement.selectedIndex);
					newTimeCode= selectedOption.value;
				} else {
					newTimeCode= timeCodeSelectElement.value;
				}
			}
			if (timesheetEntries != null && timesheetEntries.length > 0) {
				var sevenDaysAfterStartDate= new Date(this.fweekDate.getTime() + (this.getDaysInMillis(TimesheetConstants.TOTAL_DAYS)));
				for (var i= 0; i < timesheetEntries.length; i++){
					var timesheetEntry= timesheetEntries[i];
					var startDate= TimesheetTableViewer.getDTOStartDate(timesheetEntry);
					if (dojo.date.compare(startDate, this.fweekDate, "date") >= 0 && dojo.date.compare(startDate, sevenDaysAfterStartDate, "date") < 0) {
						timesheetEntry.timeCode= newTimeCode;
					}
				}
			}
			this.fselectedTimeCode= null;
		}
	},

	setSelectedTimeCode: function(selectedTimeCode) {
		this.fselectedTimeCode= selectedTimeCode;
	},

	validateTimeCodes: function(event) {
		var timeCodeSelectElement= event.target;
		var newTimeCode= "";
		if (timeCodeSelectElement.nodeName === "SELECT") {
			if (dojo.isIE) {
				var options= timeCodeSelectElement.options;
				var selectedOption= options.item(timeCodeSelectElement.selectedIndex);
				newTimeCode= selectedOption.value;
			} else {
				newTimeCode= timeCodeSelectElement.value;
			}
		}
		this.fselectedTimeCode= newTimeCode;
		var selectParentTDElement= timeCodeSelectElement.parentNode;
		var trElement= selectParentTDElement.parentNode;
		var rowId= trElement.id;
		var alreadySelectedValues= this.alreadySelectedTimeCodes(rowId, this.getCurrentUserId());
		var optionCollection= timeCodeSelectElement.options;
		if (optionCollection != null) {
			for (var i= 0; i < optionCollection.length; i++){
				var option= optionCollection.item(i);
				option.disabled= false;
				if ((option.value in alreadySelectedValues)) {
					option.setAttribute("disabled", "true");
				}
			}
		}
		dojo.stopEvent(event);
	},

	alreadySelectedTimeCodes: function(selectedRowId, loggedInUserId) {
		var alreadySelectedValues= {};
		if (this.__tableBody.hasChildNodes()) {
			var rows= this.__tableBody.childNodes;
			var rowUserId= null;
			var timeCode= null;
			for (var i= 0; i < rows.length; i++){
				var tableRow= rows.item(i);
				if (selectedRowId != null && tableRow.id === selectedRowId) 
					continue;
				var list= tableRow.childNodes;
				rowUserId= this.fRowIdtoUserIdMap[tableRow.id];
				if (rowUserId != null && rowUserId.localeCompare(loggedInUserId) === 0) {
					timeCode= this.fetchHTMLElementText(list.item(TimesheetConstants.TIME_CODE_INDEX));
					if (timeCode != null) {
						alreadySelectedValues[timeCode]= timeCode;
					}
				}
			}
		}
		return alreadySelectedValues;
	},

	fetchHTMLElementText: function(tdElement) {
		if (tdElement == null) 
			return null;
		var displayElement= tdElement.firstChild;
		if (displayElement == null) 
			return null;
		var timeCode= "";
		if (displayElement.nodeName === "SELECT") {
			if (dojo.isIE) {
				var options= displayElement.options;
				var selectedOption= options.item(displayElement.selectedIndex);
				timeCode= selectedOption.value;
				if ((timeCode == null) || (timeCode === "")) {
					timeCode= selectedOption.text;
				}
				return timeCode;
			} else {
				timeCode= displayElement.value;
				return timeCode;
			}
		} else {
			var textElement= tdElement.firstChild;
			timeCode= textElement.data;
			return timeCode;
		}
	},

	//fRowIdtoUserIdMap: null,

	/**
	 * Creates a time sheet table row 
	 * Fetches all the time codes and displays each time code as a row with corresponding time spent data for the week displayed
	 */
	createTimesheetRow: function(timesheet) {
		var allUsers= this.getUsersFromDTOs();
		var rowId= 0;
		if (allUsers == null || allUsers.length === 0) {
			this.ftInfoMessage.appendChild(window.document.createTextNode(TimesheetMessages.NO_TIMESHEET_RECORD_PRESENT));
			this.ftimesheetRecordPresent= false;
			return ;
		}
		var isRowAdded= false;
		var opt= {};
		var $subject= allUsers;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var user= $subject[$count];
			var timeCodes= this.getTimeCodes(timesheet, user);
			if (timeCodes == null || timeCodes.length === 0) {
				continue;
			}
			var validTimesheetDTOs= this.getWeekData(timeCodes, timesheet, user);
			var ftColumn= null;
			for (var timeCodeCount= 0; timeCodeCount < timeCodes.length; timeCodeCount++){
				var ftResult= window.document.createElement("tr");
				var id= this.createTimesheetRowId();
				ftResult.id= id;
				var timeCode= timeCodes[timeCodeCount];
				var validTimesheetDTO= validTimesheetDTOs[timeCode];
				if (validTimesheetDTO == null) {
					continue;
				}
				var weekTotal= 0;
				var owners= this.getUserFromDTOs1(validTimesheetDTO, true);
				this.refreshOwnerNames(owners);
				var ownerArray= (owners != null) ? jdojo.getProperties(owners) : null;
				var owner= null;
				if (ownerArray != null && ownerArray.length === 1) {
					owner= ownerArray[0];
				} else {
					owner= this.getCurrentUserId();
					this.fOwnerNamesCache[owner]= this.getCurrentUserName();
				}
				ftColumn= this.createTimesheetColumn_1(this.fOwnerNamesCache[owner], TimesheetConstants.OWNER_INDEX);
				ftResult.appendChild(ftColumn);
				this.fRowIdtoUserIdMap[id]= owner;
				rowId++;
				ftColumn= this.createTimesheetColumn_1(timeCodes[timeCodeCount], TimesheetConstants.TIME_CODE_INDEX);
				ftResult.appendChild(ftColumn);
				var isUnSaved= true;
				for (var i= TimesheetConstants.SUNDAY_INDEX, j= 0; i <= TimesheetConstants.SATURDAY_INDEX; i++, j++){
					if (validTimesheetDTO[j] != null) {
						var hoursSpent= validTimesheetDTO[j].timeSpent/(1000*60*60);
						if (owner != null && owner.localeCompare(this.getCurrentUserId()) === 0) {
							ftColumn= this.createTimesheetColumn(validTimesheetDTO[j], i, id);
						} else {
							ftColumn= this.createTimesheetColumn_2(number.format(hoursSpent, opt));
						}
						weekTotal+= hoursSpent;
						if (validTimesheetDTO[j].itemId != null) {
							isUnSaved= false;
						}
					} else {
						var newDTO= {};
						newDTO.timeCode= timeCode;
						newDTO.timeSpent= 0;
						newDTO.startDate= "";
						newDTO.workType= "";
						newDTO.itemId= null;
						var startDate= new Date();
						startDate= new Date(startDate.getTime() + ((j) * this.getDaysInMillis(1)));
						newDTO.startDate= DateUtil.normalizedFormatDate(startDate);
						if (owner != null && owner.localeCompare(this.getCurrentUserId()) === 0) {
							ftColumn= this.createTimesheetColumn(newDTO, i, id);
						} else {
							ftColumn= this.createTimesheetColumn_2("0");
						}
					}
					ftResult.appendChild(ftColumn);
				}
				ftColumn= this.createTimesheetColumn_1(number.format(weekTotal, opt), TimesheetConstants.WEEK_TOTAL_INDEX);
				ftResult.appendChild(ftColumn);
				if (owner == null || owner.localeCompare("") === 0) {
					owner= this.getCurrentUserId();
				}
				var wiTotal= number.format(this.finput.getWorkItemTotalForTimeCodeAndUser(timeCode, owner), opt);
				ftColumn= this.createTimesheetColumn_1(wiTotal, TimesheetConstants.TOTAL_INDEX);
				ftResult.appendChild(ftColumn);
				if (owner != null && owner.localeCompare(this.getCurrentUserId()) === 0) {
					ftColumn= this.createTimesheetColumn(null, TimesheetConstants.ACTIONS_INDEX, id);
				} else {
					var blankCell= window.document.createElement("span");
					ftColumn= this.createTimesheetColumnFor(blankCell);
				}
				ftResult.appendChild(ftColumn);
				this.__tableBody.appendChild(ftResult);
				this.ftimesheetRecordPresent= true;
				isRowAdded= true;
			}
		}
		if (isRowAdded === false) {
			this.ftimesheetRecordPresent= false;
			this.ftInfoMessage.appendChild(window.document.createTextNode(TimesheetMessages.NO_TIMESHEET_RECORD_PRESENT));
		}
	},

	//fOwnerNamesCache: null,

	refreshOwnerNames: function(newList) {
		var ownerIds= jdojo.getProperties(newList);
		var $subject2= ownerIds;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var owner= $subject2[$count2];
			if (!(owner in this.fOwnerNamesCache)) {
				this.fOwnerNamesCache[owner]= newList[owner];
			}
		}
	},

	getUserFromDTOs: function(tsEntries, strict) {
		var tempUser= null;
		var userMap= {};
		var $subject3= tsEntries;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var singleEntry= $subject3[$count3];
			if (singleEntry != null && singleEntry.creator != null) {
				tempUser= singleEntry.creator.userId;
				if (!(tempUser in userMap)) {
					userMap[tempUser]= singleEntry.creator.name;
				}
			} else if (strict === false) {
				userMap[this.getCurrentUserId()]= null;
			}
		}
		if (strict === true && jdojo.getProperties(userMap).length === 0) {
			userMap[this.getCurrentUserId()]= null;
		}
		return jdojo.getProperties(userMap);
	},

	getUserFromDTOs1: function(tsEntries, strict) {
		var tempUser= null;
		var userMap= {};
		var $subject4= tsEntries;
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var singleEntry= $subject4[$count4];
			if (singleEntry != null && singleEntry.creator != null) {
				tempUser= singleEntry.creator.userId;
				if (!(tempUser in userMap)) {
					userMap[tempUser]= singleEntry.creator.name;
				}
			} else if (strict === false) {
				userMap[this.getCurrentUserId()]= null;
			}
		}
		if (strict === true && jdojo.getProperties(userMap).length === 0) {
			userMap[this.getCurrentUserId()]= null;
		}
		return userMap;
	},

	getUsersFromDTOs: function() {
		return this.getUserFromDTOs(this.finput.getTimeSheetEntries(), false);
	},

	/**
	 * Just refresh the contents of the week  
	 * 1. Get the week date
	 * 2. Get all the time sheet data for the week for each time code and display
	 */
	refreshTimesheetTableforNewDate: function() {
		this.refresh();
	},

	getTimeCodes: function(timesheet, userId) {
		var timeCodes= {};
		var timesheetDTO= timesheet.getTimeSheetEntries();
		if (timesheetDTO != null) {
			for (var i= 0; i < timesheetDTO.length; i++){
				if (!(timesheetDTO[i].timeCode in timeCodes)) {
					if (timesheetDTO[i].creator != null && timesheetDTO[i].creator.userId.localeCompare(userId) === 0) {
						timeCodes[timesheetDTO[i].timeCode]= timesheetDTO[i].timeCode;
					} else if (this.getCurrentUserId().localeCompare(userId) === 0) {
						timeCodes[timesheetDTO[i].timeCode]= timesheetDTO[i].timeCode;
					}
				}
			}
		}
		this.fsavedTimeCodes= jdojo.getProperties(timeCodes);
		if (this.fsavedTimeCodes != null) {
			this.fsavedTimeCodes.sort(function(left, right) {
				var compareVal= left.localeCompare(right);
				if (compareVal > 0) {
					return 1;
				} else if (compareVal < 0) {
					return -1;
				}
				return 0;
			});
		}
		return this.fsavedTimeCodes;
	},

	createTimesheetColumn: function(timesheet, index, rowId) {
		var labelProvider= this.getLabelProvider();
		var ftContent= labelProvider.getColumn(timesheet, index, this, rowId);
		return this.createTimesheetColumnFor(ftContent);
	},

	createTimesheetColumnFor: function(columnElement) {
		var result= window.document.createElement("td");
		dojo.addClass(result, "tptViewerColumn" + "1");
		if (columnElement != null) {
			result.appendChild(columnElement);
		}
		return result;
	},

	createTimesheetColumn_1: function(value, index) {
		var result= window.document.createElement("td");
		var cssIndex= 0;
		if (index >= TimesheetConstants.WEEK_TOTAL_INDEX) {
			cssIndex= 2;
		}
		dojo.addClass(result, "tptViewerColumn" + cssIndex);
		result.appendChild(window.document.createTextNode(value));
		return result;
	},

	createTimesheetColumn_2: function(value) {
		var result= window.document.createElement("td");
		dojo.addClass(result, "tptViewerColumn3");
		result.appendChild(window.document.createTextNode(value));
		return result;
	},

	getWeekData: function(timeCodes, timesheet, userId) {
		var timesheetEntriesMap= {};
		if (timeCodes == null || timeCodes.length === 0 || timesheet == null) 
			return timesheetEntriesMap;
		var timesheetDTO= timesheet.getTimeSheetEntries();
		var sevenDaysAfterStartDate= new Date(this.fweekDate.getTime() + (this.getDaysInMillis(TimesheetConstants.TOTAL_DAYS)));
		var validTimeSheetEntries= null;
		for (var i= 0; i < timesheetDTO.length; i++){
			if (timesheetDTO[i].creator != null && timesheetDTO[i].creator.userId.localeCompare(userId) !== 0) {
				continue;
			}
			var startDate= TimesheetTableViewer.getDTOStartDate(timesheetDTO[i]);
			var timeCode= timesheetDTO[i].timeCode;
			if (dojo.date.compare(startDate, this.fweekDate, "date") >= 0 && dojo.date.compare(startDate, sevenDaysAfterStartDate, "date") < 0) {
				var index= this.getIndex(startDate);
				validTimeSheetEntries= timesheetEntriesMap[timeCode];
				if (validTimeSheetEntries != null) {
					validTimeSheetEntries[index]= timesheetDTO[i];
					timesheetEntriesMap[timeCode]= validTimeSheetEntries;
				} else {
					var newEntry= [null, null, null, null, null, null, null];
					newEntry[index]= timesheetDTO[i];
					timesheetEntriesMap[timeCode]= newEntry;
				}
			}
		}
		return timesheetEntriesMap;
	},

	getDaysInMillis: function(days) {
		return days * TimesheetConstants.HOURS_PER_DAY * 60 * 60 * 1000;
	},

	getIndex: function(startDate) {
		var startTime= startDate.getTime();
		var weekDateTime= this.fweekDate.getTime();
		var diff= startTime - weekDateTime;
		var index= (((diff / (this.getDaysInMillis(1))))|0);
		index+= diff % ((this.getDaysInMillis(1))) > 0 ? 1 : 0;
		return index;
	},

	handleChangeEvent: function(e, indx, rowId) {
		var inputField= e.target;
		var timeSpent= inputField.value;
		var timeSpentInHours= this.validateTimeSpent(timeSpent);
		if (timeSpentInHours === TimesheetConstants.INVALID_HOURS) {
			var val= inputField.getAttribute("preValue");
			inputField.value= val;
			if (dojo.hasClass(inputField, "tptinputerror")) {
				dojo.removeClass(inputField, "tptinputerror");
			}
			return ;
		}
		var timesheetTime= this.fweekDate.getTime() + (indx - 2) * this.getDaysInMillis(1);
		var timesheetStartDate= new Date(timesheetTime);
		var startDateString= DateUtil.normalizedFormatDate(timesheetStartDate);
		var tableRow= window.document.getElementById(rowId);
		var list= tableRow.childNodes;
		if (!this.preCheckUserAuthorization(rowId)) {
			return ;
		}
		var timeCodeColumn= list.item(TimesheetConstants.TIME_CODE_INDEX);
		var timeCode= this.fetchHTMLElementText(timeCodeColumn);
		if (this.finput != null) {
			var timesheetDTO= this.finput.getTimesheetEntryWithStartDateAndTimecode(startDateString, timeCode, this.getCurrentUserId());
			if (timesheetDTO != null) {
				timesheetDTO.timeSpent= Math.round(timeSpentInHours*1000*60*60);
				this.finput.updateWorkItemTimeSpent();
			} else {
				var isOwner= this.checkOwnerValidation(rowId);
				if (!isOwner) {
					this.ftimesheetEnrtyPartWidget.handleError(TimesheetMessages.ONLY_WI_OWNER, Severity.WARNING);
				}
				this.finput.addTimeSheetEntry(startDateString, timeSpentInHours, this.fworkItemType, timeCode, this.getCurrentUserId());
			}
			this.ftimesheetEnrtyPartWidget._handleSave();
		}
		var prevValue= inputField.getAttribute("preValue");
		var prevVal= 0;
		prevVal= NumberFormatUtil.parseHours(prevValue);
		if (isNaN(prevVal)) {
			prevVal= 0;
		}
		var rowContent= tableRow.childNodes;
		var weekTotalColumn= rowContent.item(TimesheetConstants.WEEK_TOTAL_INDEX);
		var weekTotalContent= weekTotalColumn.firstChild;
		var weekTotalVal= 0;
		var weekTotalValStr= weekTotalContent.data;
		weekTotalVal= NumberFormatUtil.parseHours(weekTotalValStr);
		if (isNaN(weekTotalVal)) {
			weekTotalVal= 0;
		}
		weekTotalVal= weekTotalVal + timeSpentInHours - prevVal;
		weekTotalContent.data= NumberFormatUtil.formatHours(weekTotalVal);
		var totalColumn= rowContent.item(TimesheetConstants.TOTAL_INDEX);
		var totalContent= totalColumn.firstChild;
		var totalVal= 0;
		var totalValStr= totalContent.data;
		totalVal= NumberFormatUtil.parseHours(totalValStr);
		if (isNaN(totalVal)) {
			totalVal= 0;
		}
		totalVal= totalVal + timeSpentInHours - prevVal;
		totalContent.data= NumberFormatUtil.formatHours(totalVal);
		inputField.setAttribute("preValue", inputField.value);
	},

	handleKeyUpEvent: function(e) {
		if (e.keyCode === 13) 
			return ;
		var inputField= e.target;
		var timeSpentInHours= inputField.value === "" ? 0 : this.validateTimeSpent(inputField.value);
		if (timeSpentInHours === TimesheetConstants.INVALID_HOURS) {
			if (!dojo.hasClass(inputField, "tptinputerror")) {
				dojo.addClass(inputField, "tptinputerror");
			}
			dojo.stopEvent(e);
		} else {
			if (dojo.hasClass(inputField, "tptinputerror")) {
				dojo.removeClass(inputField, "tptinputerror");
			}
		}
	},

	handleStartEditEvent: function(e) {
		var inputField= e.target;
		var val= inputField.value;
		var spanElement= inputField.parentNode;
		var tdElement= spanElement.parentNode;
		if (!dojo.hasClass(tdElement, "inputEdit")) {
			dojo.addClass(tdElement, "inputEdit");
		}
		inputField.select();
	},

	handleFinishEdit: function(e) {
		var inputField= e.target;
		var spanElement= inputField.parentNode;
		var tdElement= spanElement.parentNode;
		if (dojo.hasClass(tdElement, "inputEdit")) {
			dojo.removeClass(tdElement, "inputEdit");
		}
	},

	validateTimeSpent: function(value) {
		var hrsSpent= NumberFormatUtil.parseHours(value);
		if (isNaN(hrsSpent)) {
			return TimesheetConstants.INVALID_HOURS;
		}
		if (hrsSpent > TimesheetConstants.MAX_HOURS_PER_DAY || hrsSpent < TimesheetConstants.MIN_HOURS_PER_DAY) {
			return TimesheetConstants.INVALID_HOURS;
		}
		return hrsSpent;
	},

	deleteRow: function(rowId) {
		var tableRow= window.document.getElementById(rowId);
		var list= tableRow.childNodes;
		if (!this.preCheckUserAuthorization(rowId)) {
			return ;
		}
		var timeCode= this.fetchHTMLElementText(list.item(TimesheetConstants.TIME_CODE_INDEX));
		if (timeCode !== "" && timeCode != null) {
			var dtos= this.finput.getAllTimesheetWithTimeCodes(timeCode, this.getCurrentUserId());
			if (dtos != null && dtos.length > 0) {
				var length= dtos.length;
				var sevenDaysAfterStartDate= new Date(this.fweekDate.getTime() + (this.getDaysInMillis(TimesheetConstants.TOTAL_DAYS)));
				for (var i= 0; i < length; i++){
					var startDate= TimesheetTableViewer.getDTOStartDate(dtos[i]);
					if (dojo.date.compare(startDate, this.fweekDate, "date") >= 0 && dojo.date.compare(startDate, sevenDaysAfterStartDate, "date") < 0) {
						this.finput.removeTimeSheetEntry(dtos[i]);
					}
				}
				this.ftimesheetEnrtyPartWidget._handleSave();
			}
		}
		var table= tableRow.parentNode;
		table.removeChild(tableRow);
		if (!table.hasChildNodes()) {
			this.ftInfoMessage.appendChild(window.document.createTextNode(TimesheetMessages.NO_TIMESHEET_RECORD_PRESENT));
			this.ftimesheetRecordPresent= false;
		}
	},

	preCheckUserAuthorization: function(rowId) {
		var rowUserId= this.fRowIdtoUserIdMap[rowId];
		if (rowUserId == null || this.getCurrentUserId().localeCompare(rowUserId) !== 0) {
			this.ftimesheetEnrtyPartWidget.handleError(TimesheetMessages.INVALID_USER, Severity.ERROR);
			return false;
		}
		return true;
	},

	checkOwnerValidation: function(rowId) {
		var rowUserId= this.fRowIdtoUserIdMap[rowId];
		if (rowUserId == null || rowUserId.localeCompare(this.ftimesheetEnrtyPartWidget.getCurrentWIOwner()) !== 0) {
			return false;
		}
		return true;
	},

	getCurrentUserId: function() {
		return com.ibm.team.repository.web.client.session.getAuthenticatedContributor().userId;
	},

	getCurrentUserName: function() {
		return com.ibm.team.repository.web.client.session.getAuthenticatedContributor().name;
	}
});

TimesheetTableViewer.getDTOStartDate= function(dto) {
	return DateUtil.createNormalizedDate(dto.startDate);
};

})();
