/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.process.tests.ui.internal.page.models._TypeModelTests");

dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSTestCase");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._TypeModel");

(function() {
var team= com.ibm.team;
var script= team.dev.jdojo.junit.script;
var JSAssert= script.JSAssert;
var JSTestCase= script.JSTestCase;
var _TypeModel= team.workitem.web.process.ui.internal.page.models._TypeModel;

var _TypeModelTests= dojo.declare("com.ibm.team.workitem.web.process.tests.ui.internal.page.models._TypeModelTests", JSTestCase, {

	testSameCustomAttributeIsNotAddedMoreOnceToTypeModelAttributeDefinitions: function() {
		var testObj= this.aTypeModel();
		testObj.addCustomAttribute(_TypeModelTests.DEFECT, this.aWorkItemAttribute(_TypeModelTests.FOO, _TypeModelTests.BAR));
		testObj.addCustomAttribute(_TypeModelTests.TASK, this.aWorkItemAttribute(_TypeModelTests.FOO, _TypeModelTests.BAR));
		var attributeDefinitions= dojo.fromJson(testObj.getTypesPostData())["attributeDefinitions"];
		JSAssert.assertEquals(1, attributeDefinitions.length);
	},

	testDifferentCustomAttributesAreAddedToTypeModelAttributeDefinitions: function() {
		var testObj= this.aTypeModel();
		testObj.addCustomAttribute(_TypeModelTests.DEFECT, this.aWorkItemAttribute(_TypeModelTests.FOO, _TypeModelTests.BAR));
		testObj.addCustomAttribute(_TypeModelTests.TASK, this.aWorkItemAttribute(_TypeModelTests.BAR, _TypeModelTests.FOO));
		var attributeDefinitions= dojo.fromJson(testObj.getTypesPostData())["attributeDefinitions"];
		JSAssert.assertEquals(2, attributeDefinitions.length);
	},

	aTypeModel: function() {
		var aTypeModel= new _TypeModel();
		aTypeModel["workItemConfig"]= {};
		aTypeModel.addType(this.aWorkItemType(_TypeModelTests.DEFECT, _TypeModelTests.DEFECT, _TypeModelTests.DEFECT));
		aTypeModel.addType(this.aWorkItemType(_TypeModelTests.TASK, _TypeModelTests.TASK, _TypeModelTests.TASK));
		return aTypeModel;
	},

	aWorkItemType: function(category, name, id) {
		var aType= {category: category, name: name, id: id, icon: _TypeModelTests.EMPTY_STRING, iconUrl: _TypeModelTests.EMPTY_STRING, dimmedIcon: _TypeModelTests.EMPTY_STRING, workflowId: _TypeModelTests.EMPTY_STRING, aliases: null};
		return aType;
	},

	aWorkItemAttribute: function(id, typeId) {
		return {id: id, stringIdentifier: id, name: id, typeId: typeId, typeName: typeId, isEnumeration: false};
	}
});

_TypeModelTests.EMPTY_STRING= "";
_TypeModelTests.DEFECT= "Defect";
_TypeModelTests.TASK= "Task";
_TypeModelTests.FOO= "foo";
_TypeModelTests.BAR= "bar";

})();
