/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.tests.cache.internal.QueryProxyTest");

dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSTestCase");
dojo.require("com.ibm.team.workitem.web.cache.internal.QueryProxy");
dojo.require("com.ibm.team.workitem.web.client.internal.query.QueryDescriptor");

(function() {
var team= com.ibm.team;
var script= team.dev.jdojo.junit.script;
var JSAssert= script.JSAssert;
var JSTestCase= script.JSTestCase;
var web= team.workitem.web;
var QueryProxy= web.cache.internal.QueryProxy;
var QueryDescriptor= web.client.internal.query.QueryDescriptor;

var QueryProxyTest= dojo.declare("com.ibm.team.workitem.web.tests.cache.internal.QueryProxyTest", JSTestCase, {

	testSupportsOrderingForSavedQueryReturnsTrue: function() {
		var descriptor= this.aQuery().setItemIdVal("").setIsSaved(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertTrue(testObject.supportsOrdering());
	},

	testSupportsOrderingForSearchQueryReturnsTrue: function() {
		var descriptor= this.aQuery().setItemIdVal("").setIsSearchQuery(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertTrue(testObject.supportsOrdering());
	},

	testSupportsOrderingForTemplateQueryReturnsTrue: function() {
		var descriptor= this.aQuery().setItemIdVal("").setIsTemplateQuery(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertTrue(testObject.supportsOrdering());
	},

	testSupportsOrderingForSimilarityQueryReturnsTrue: function() {
		var descriptor= this.aQuery().setItemIdVal("").setIsSimilarityQuery(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertTrue(testObject.supportsOrdering());
	},

	testSupportsOrderingForEditedQueryReturnsFalse: function() {
		var descriptor= this.aQuery().setItemIdVal("").setIsBeingEdited(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertFalse(testObject.supportsOrdering());
	},

	testSupportsOrderingForNewQueryReturnsFalse: function() {
		var descriptor= this.aQuery().setIsNew(true);
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertFalse(testObject.supportsOrdering());
	},

	testSupportsOrderingForQueryWithEmptyItemIdReturnsFalse: function() {
		var descriptor= this.aQuery().setItemIdVal("");
		var testObject= new QueryProxyTestClass(this.aParms(descriptor));
		JSAssert.assertFalse(testObject.supportsOrdering());
	},

	testSupportsOrderingForQueryWithNewQueryActionReturnsFalse: function() {
		var testObject= new QueryProxyTestClass(this.aParms(this.aQuery()));
		testObject.setQueryUrl(QueryProxyTest.NEW_QUERY_ACTION);
		JSAssert.assertFalse(testObject.supportsOrdering());
	},

	aQuery: function() {
		return new TestQueryDescriptor();
	},

	aParms: function(descriptor) {
		var parms= {};
		parms.query= descriptor;
		return parms;
	}
});
/**
 * A {@link QueryProxy} subclass which provides test access to fields
 */
var QueryProxyTestClass= dojo.declare("com.ibm.team.workitem.web.tests.cache.internal.QueryProxyTest.QueryProxyTestClass", QueryProxy, {

	constructor: function(params) {
	},

	setQueryUrl: function(url) {
		this._queryUrl= url;
		return this;
	}
});
/**
 * A test {@link QueryDescriptor} implementation. This allows us to inject state into the
 * query object for easy testing.
 */
var TestQueryDescriptor= dojo.declare("com.ibm.team.workitem.web.tests.cache.internal.QueryProxyTest.TestQueryDescriptor", QueryDescriptor, {

	//fItemId: null,

	constructor: function() {
		this.inherited(arguments, []);
	},

	setIsSearchQuery: function(value) {
		this._isSearchQuery= value;
		return this;
	},

	setIsTemplateQuery: function(value) {
		this._isTemplateQuery= value;
		return this;
	},

	setIsSimilarityQuery: function(value) {
		this._isSimilarityQuery= value;
		return this;
	},

	setIsSaved: function(value) {
		this._isSaved= value;
		return this;
	},

	setIsNew: function(value) {
		this.setNew(value);
		return this;
	},

	setIsBeingEdited: function(value) {
		this._isBeingEdited= value;
		return this;
	},

	setItemIdVal: function(id) {
		this.fItemId= id;
		return this;
	},

	getItemId: function() {
		return this.fItemId;
	}
});

QueryProxyTest.NEW_QUERY_ACTION= "action=com.ibm.team.workitem.newQuery";

})();
