/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.tests.mvvm.model.providers.ContributorDataProviderTest");

dojo.require("com.ibm.team.dev.jdojo.jsmock.JSMock");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSTestCase");
dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
dojo.require("com.ibm.team.workitem.web.client.internal.Attribute");
dojo.require("com.ibm.team.workitem.web.mvvm.model.providers.ContributorDataProvider");

(function() {
var team= com.ibm.team;
var jdojo= team.dev.jdojo;
var JSMock= jdojo.jsmock.JSMock;
var script= jdojo.junit.script;
var JSAssert= script.JSAssert;
var JSTestCase= script.JSTestCase;
var AdminClient= team.repository.web.client.internal.AdminClient;
var web= team.workitem.web;
var Attribute= web.client.internal.Attribute;
var ContributorDataProvider= web.mvvm.model.providers.ContributorDataProvider;

dojo.declare("com.ibm.team.workitem.web.tests.mvvm.model.providers.ContributorDataProviderTest", JSTestCase, {

	//archivedUser: null,

	//nonArchivedUser: null,

	//unassignedUser: null,

	//contributorAttribute: null,

	constructor: function() {
		this.archivedUser= {};
		this.nonArchivedUser= {};
		this.unassignedUser= {};
		this.contributorAttribute= new Attribute({nullValue: this.unassignedUser});
	},

	setUp: function() {
		this.inherited("setUp", arguments, []);
		this.archivedUser.userId= this.archivedUser.name= "archived";
		this.archivedUser.itemId= "archived";
		this.archivedUser.archived= true;
		this.nonArchivedUser.userId= this.nonArchivedUser.name= "nonArchived";
		this.nonArchivedUser.itemId= "nonArchived";
		this.nonArchivedUser.archived= false;
		this.unassignedUser.userId= this.unassignedUser.name= "unassignedUser";
		this.unassignedUser.itemId= "unassignedUser";
		this.unassignedUser.archived= false;
		this._setUpServiceMock();
	},

	testProviderWithDefaultParametersDoesNotIncludeUnassignedAndArchivedContributors: function() {
		var testObject= new ContributorDataProvider(this.contributorAttribute);
		var values= testObject.getValues({});
		values.then(dojo.hitch(this, function(object) {
			JSAssert.assertEquals(1, object.length);
			JSAssert.assertEquals(this.nonArchivedUser.userId, object[0].getUserId());
			return object;
		}));
		JSAssert.assertTrue(values.isResolved());
	},

	testProviderWithIncludeArchivedParametersIncludesAndArchivedContributors: function() {
		var testObject= new ContributorDataProvider(this.contributorAttribute);
		var values= testObject.getValues({includeArchived: true});
		values.then(dojo.hitch(this, function(object) {
			JSAssert.assertEquals(2, object.length);
			JSAssert.assertEquals(this.nonArchivedUser.userId, object[0].getUserId());
			JSAssert.assertEquals(this.archivedUser.userId, object[1].getUserId());
			return object;
		}));
		JSAssert.assertTrue(values.isResolved());
	},

	testProviderWithIncludeUnassignedParametersIncludesAndArchivedContributors: function() {
		var testObject= new ContributorDataProvider(this.contributorAttribute);
		var values= testObject.getValues({includeUnassigned: true});
		values.then(dojo.hitch(this, function(object) {
			JSAssert.assertEquals(2, object.length);
			JSAssert.assertEquals(this.nonArchivedUser.userId, object[0].getUserId());
			JSAssert.assertEquals(this.unassignedUser.userId, object[1].getUserId());
			return object;
		}));
		JSAssert.assertTrue(values.isResolved());
	},

	_setUpServiceMock: function() {
		var defaultOptions= {};
		JSMock.doAnswer(dojo.hitch(this, function(invocationOnMock) {
			var result= {};
			result.count= 1;
			result.elements= [this.nonArchivedUser];
			invocationOnMock()[1].doCallback(result);
			return result;
		})).whenStatic(AdminClient, "getContributors", {hideArchivedUsers: !defaultOptions.includeArchived, hideAdminGuest: !defaultOptions.includeAdminGuest, hideUnassigned: !defaultOptions.includeUnassigned, pageSize: 250, searchTerm: defaultOptions.searchTerm, sortBy: "name"}, com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
		var includeArchivedOptions= {includeArchived: true};
		JSMock.doAnswer(dojo.hitch(this, function(invocationOnMock) {
			var result= {};
			result.count= 2;
			result.elements= [this.nonArchivedUser, this.archivedUser];
			invocationOnMock()[1].doCallback(result);
			return result;
		})).whenStatic(AdminClient, "getContributors", {hideArchivedUsers: !includeArchivedOptions.includeArchived, hideAdminGuest: !includeArchivedOptions.includeAdminGuest, hideUnassigned: !includeArchivedOptions.includeUnassigned, pageSize: 250, searchTerm: defaultOptions.searchTerm, sortBy: "name"}, com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
		var includeUnassignedOptions= {includeUnassigned: true};
		JSMock.doAnswer(dojo.hitch(this, function(invocationOnMock) {
			var result= {};
			result.count= 2;
			result.elements= [this.nonArchivedUser, this.unassignedUser];
			invocationOnMock()[1].doCallback(result);
			return result;
		})).whenStatic(AdminClient, "getContributors", {hideArchivedUsers: !includeUnassignedOptions.includeArchived, hideAdminGuest: !includeUnassignedOptions.includeAdminGuest, hideUnassigned: !includeUnassignedOptions.includeUnassigned, pageSize: 250, searchTerm: defaultOptions.searchTerm, sortBy: "name"}, com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
	}
});

})();
