/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2006, 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.client.internal.query.QueryDescriptor"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.query.ParameterVariableCollector"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.query.SortCriteria"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.query.Term"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.query.UIItem"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var query= com.ibm.team.workitem.web.client.internal.query;
var ParameterVariableCollector= query.ParameterVariableCollector;
var SortCriteria= query.SortCriteria;
var Term= query.Term;
var UIItem= query.UIItem;

var QueryDescriptor= dojo.declare("com.ibm.team.workitem.web.client.internal.query.QueryDescriptor", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	//_cacheItemId: null,

	//_itemId: null,

	//_name: null,

	//_description: null,

	//_projectAreaId: null,

	//_stateId: null,

	//_csvExportLink: null,

	//_htmlExportLink: null,

	//_owner: null,

	//_term: null,

	//_currentCount: null,

	//_columns: null,

	//_sorting: null,

	//_sortCriterias: null,

	//_teamAreaAssociations: null,

	//_userAssociations: null,

	//_isEditable: null,

	//_isSaved: null,

	//_isSearchQuery: null,

	//_isTemplateQuery: null,

	//_isSimilarityQuery: null,

	//_isBeingEdited: null,

	//isNew: null,

	//_parameterValues: null,

	constructor: function() {
		this._currentCount= 1;
	},

	setItemId: function(itemId) {
		this._itemId= itemId;
	},

	getItemId: function() {
		if (this._itemId == null || this._itemId === "") { //$NON-NLS-1$
			if (this._term != null) {
				var exp= this._term.getFirstSimilarityExpression();
				if (exp != null) {
					return exp.getItemId();
				} else {
					var exps= this._term.getAttributeExpressions();
					if (exps != null && exps.length > 0 && exps[0].getAttributeId() === "all") { //$NON-NLS-1$
						var values= exps[0].getValues();
						if (values != null && values.length > 0) {
							var id= values[0].getId();
							if (id != null) {
								return "Search:" + id; //$NON-NLS-1$
							}
						}
					}
					if (this.getCacheItemId() != null) {
						return this.getCacheItemId();
					}
					if (this.getName() != null) {
						return this.getName();
					}
				}
			}
		}
		return this._itemId;
	},

	setName: function(name) {
		this._name= name;
	},

	getName: function() {
		return this._name;
	},

	getDescription: function() {
		return this._description;
	},

	setStateId: function(stateId) {
		this._stateId= stateId;
	},

	getStateId: function() {
		return this._stateId;
	},

	isEditable: function() {
		return this._isEditable;
	},

	setTerm: function(term) {
		this._term= term;
	},

	getTerm: function() {
		return this._term;
	},

	getOwner: function() {
		return this._owner;
	},

	setProjectArea: function(projectAreaId) {
		this._projectAreaId= projectAreaId;
	},

	getProjectArea: function() {
		return this._projectAreaId;
	},

	supportsCsvExport: function() {
		return this._csvExportLink != null;
	},

	supportsHtmlExport: function() {
		return this._htmlExportLink != null;
	},

	getCsvExportLink: function(queryRun) {
		return this.addParametersToUrl(this._csvExportLink, queryRun);
	},

	getHtmlExportLink: function(queryRun) {
		return this.addParametersToUrl(this._htmlExportLink, queryRun);
	},

	getUserAssociations: function() {
		return this._userAssociations;
	},

	getTeamAreaAssociations: function() {
		return this._teamAreaAssociations;
	},

	/**
	 * This method only returns values if this queryDescriptor is not editable.
	 * Also, sort order set by {@link #setSortCriterias(SortCriteria[])} are not
	 * considered here!
	 * 
	 * @deprecated use {@link #getSortCriterias()}.
	 */
	getSorting: function() {
		return this._sorting;
	},

	getSortCriterias: function() {
		return this._sortCriterias;
	},

	setSortCriterias: function(order) {
		this._sortCriterias= order;
	},

	hasSortCriteria: function() {
		var sorting= this.getSortCriterias();
		return (sorting != null && sorting.length > 0);
	},

	getColumns: function() {
		return this._columns;
	},

	getCurrentCount: function() {
		return this._currentCount;
	},

	addParametersToUrl: function(url, run) {
		if (url == null) 
			return null;
		if (this._parameterValues != null) {
			var paramValues= encodeURIComponent(this._parameterValues.serialize(true));
			url+= "&" + QueryDescriptor.PARAMETER_VALUES_PROPERTY + "=" + paramValues; //$NON-NLS-1$ //$NON-NLS-2$
		}
		if (run != null && run.getFilterAttribute() != null && run.getFilterValue() != null) {
			url+= ("&filterAttribute=" + encodeURIComponent(run.getFilterAttribute()) + "&filterValue=" + encodeURIComponent(run.getFilterValue())); //$NON-NLS-1$ //$NON-NLS-2$
		}
		return url;
	},

	createQueryDTO: function() {
		var result= {};
		if (this._name != null) 
			result.name= this._name;
		if (this._description != null) 
			result.description= this._description;
		if (this._itemId != null) 
			result.itemId= this._itemId;
		if (this._term != null) 
			result.expression= this._term.createExpressionDTOs();
		if (this._owner != null) 
			result.owner= this._owner.createDTO();
		if (this._csvExportLink != null) 
			result.csvExportLink= this._csvExportLink;
		if (this._htmlExportLink != null) 
			result.htmlExportLink= this._htmlExportLink;
		if (this._currentCount !== -1) 
			result.currentCount= this._currentCount;
		result.isEditable= this._isEditable;
		if (this._projectAreaId != null) 
			result.projectAreaItemId= this._projectAreaId;
		return result;
	},

	createEditableQueryDTO: function() {
		var result= {};
		if (this._name != null) 
			result.name= this._name;
		if (this._description != null) 
			result.description= this._description;
		if (this._itemId != null) 
			result.itemId= this._itemId;
		if (this._stateId != null) 
			result.stateId= this._stateId;
		if (this._term != null) 
			result.expression= this._term.createDTO();
		if (this._owner != null) 
			result.creator= this._owner.createDTO();
		if (this._stateId != null) 
			result.stateId= this._stateId;
		if (this._columns != null) 
			result.columns= this._columns;
		if (this._sorting != null) 
			result.sorting= this._sorting;
		if (this._teamAreaAssociations != null) 
			result.teamAreaAssociations= this._teamAreaAssociations;
		if (this._userAssociations != null) 
			result.userAssociations= this._userAssociations;
		if (this._csvExportLink != null) 
			result.csvExportLink= this._csvExportLink;
		if (this._htmlExportLink != null) 
			result.htmlExportLink= this._htmlExportLink;
		if (this._projectAreaId != null) 
			result.projectAreaItemId= this._projectAreaId;
		return result;
	},

	hasParameterVariables: function() {
		return jdojo.getProperties(this._findParameterVariables(true)).length > 0;
	},

	setParameterValues: function(parameterValues) {
		this._parameterValues= parameterValues;
	},

	getParameterValues: function() {
		return this._parameterValues;
	},

	hasUnresolvedVariables: function() {
		return jdojo.getProperties(this._findParameterVariables(false)).length > 0;
	},

	getUnresolvedVariables: function() {
		return this._findParameterVariables(false);
	},

	serialize: function() {
		var dto= this.createEditableQueryDTO();
		return dojo.toJson(dto, false);
	},

	_findParameterVariables: function(includeResolved) {
		if (this._term != null) {
			var collector= new ParameterVariableCollector();
			collector.visitTerm(this._term);
			var result;
			if (includeResolved || this._parameterValues == null) {
				result= collector.getParameterVariables();
			} else {
				result= {};
				var variables= collector.getParameterVariables();
				var $subject3= jdojo.getProperties(variables);
				var $length3= $subject3.length;
				for (var $count3= 0; $count3 < $length3; $count3++){
					var curName= $subject3[$count3];
					if (!this._parameterValues.hasVariableValue(curName)) {
						result[curName]= variables[curName];
					}
				}
			}
			return result;
		}
		return {};
	},

	getCacheItemId: function() {
		if (this._cacheItemId != null) {
			return this._cacheItemId;
		}
		return this._itemId;
	},

	setCacheItemId: function(_cacheItemId) {
		this._cacheItemId= _cacheItemId;
	},

	getIsNew: function() {
		return this.isNew;
	},

	setNew: function(isNew) {
		this.isNew= isNew;
	}
});

QueryDescriptor.PARAMETER_VALUES_PROPERTY= "jsonParameterValues"; //$NON-NLS-1$
QueryDescriptor.createFromQueryDTO= function(dto) {
	if (dto == null) 
		return null;
	var result= new QueryDescriptor();
	result._itemId= dto.itemId;
	result._name= dto.name;
	result._description= dto.description;
	result._isEditable= dto.isEditable;
	if (dto.csvExportLink != null) 
		result._csvExportLink= dto.csvExportLink;
	if (dto.htmlExportLink != null) 
		result._htmlExportLink= dto.htmlExportLink;
	if (dto.expression != null) 
		result._term= Term.createFromExpressionDTOs(dto.expression);
	if (dto.owner != null) 
		result._owner= UIItem.createFromDTO(dto.owner);
	if (dto["currentCount"] != null)  //$NON-NLS-1$
		result._currentCount= dto.currentCount;
	if (dto.projectAreaItemId != null) 
		result._projectAreaId= dto.projectAreaItemId;
	if (dto.sortCriterias != null) {
		var criterias= [];
		var $subject= dto.sortCriterias;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var sortCriteriaDTO= $subject[$count];
			criterias.push(SortCriteria.createFromDto(sortCriteriaDTO));
		}
		result._sortCriterias= criterias;
	}
	return result;
};
QueryDescriptor.createFromEditableQueryDTO= function(dto) {
	if (dto == null) 
		return null;
	var result= new QueryDescriptor();
	result._itemId= dto.itemId;
	result._name= dto.name;
	result._description= dto.description;
	result._isEditable= true;
	if (dto.stateId != null) 
		result._stateId= dto.stateId;
	if (dto.expression != null) 
		result._term= Term.createFromDTO(dto.expression);
	if (dto.creator != null) 
		result._owner= UIItem.createFromDTO(dto.creator);
	if (dto.columns != null) 
		result._columns= dto.columns;
	if (dto.teamAreaAssociations != null) 
		result._teamAreaAssociations= dto.teamAreaAssociations;
	if (dto.userAssociations != null) 
		result._userAssociations= dto.userAssociations;
	if (dto.csvExportLink != null) 
		result._csvExportLink= dto.csvExportLink;
	if (dto.htmlExportLink != null) 
		result._htmlExportLink= dto.htmlExportLink;
	if (dto.projectAreaItemId != null) 
		result._projectAreaId= dto.projectAreaItemId;
	if (dto.sorting != null) {
		result._sorting= dto.sorting;
		var criterias= [];
		var $subject2= dto.sorting;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var sortOrderDTO= $subject2[$count2];
			criterias.push(SortCriteria.createWithLabel(sortOrderDTO.id, sortOrderDTO.ascending, sortOrderDTO.label));
		}
		result._sortCriterias= criterias;
	}
	return result;
};
QueryDescriptor.createFromTerm= function(term) {
	if (term == null) 
		return null;
	var result= new QueryDescriptor();
	result._term= term;
	return result;
};
QueryDescriptor.deserialize= function(json) {
	var dto= eval("(" + json + ")"); //$NON-NLS-1$ //$NON-NLS-2$
	return QueryDescriptor.createFromEditableQueryDTO(dto);
};

})();
