/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.internal.model.types.ContributorAttributeType"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.shared.common.Contributor"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.types.AbstractItemAttributeType"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.types.ItemAttributeType"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.types.LegacyModelBinding"); //$NON-NLS-1$

(function() {
var workitem= com.ibm.team.workitem;
var Contributor= workitem.shared.common.Contributor;
var types= workitem.web.internal.model.types;
var AbstractItemAttributeType= types.AbstractItemAttributeType;
var ItemAttributeType= types.ItemAttributeType;
var ItemLabelProvider= ItemAttributeType.ItemLabelProvider;
var ItemResolver= ItemAttributeType.ItemResolver;
var LegacyModelBinding= types.LegacyModelBinding;

dojo.declare("com.ibm.team.workitem.web.internal.model.types.ContributorAttributeType", AbstractItemAttributeType, { //$NON-NLS-1$

	constructor: function(typeId) {
		this.inherited(arguments, [typeId, new ItemLabelProvider(), new ItemResolver(), new ContributorBinding(true)]);
	}
});
var ContributorBinding= dojo.declare("com.ibm.team.workitem.web.internal.model.types.ContributorAttributeType.ContributorBinding", LegacyModelBinding, { //$NON-NLS-1$

	//_useUTIItemDTO: null,

	constructor: function(useUTIItemDTO) {
		this.inherited(arguments, []);
		this._useUTIItemDTO= useUTIItemDTO;
	},

	fromLegacy: function(proxyValue) {
		var contributorValue= proxyValue;
		if (contributorValue.itemId != null) {
			var contributor= new Contributor(contributorValue.itemId, contributorValue.name);
			if (contributorValue.userId != null) {
				contributor.setUserId(contributorValue.userId);
			}
			if (contributorValue.locationUri != null) {
				contributor.setLocationUri(contributorValue.locationUri);
			}
			if (contributorValue.webUri != null) {
				contributor.setWebUri(contributorValue.webUri);
			}
			contributor.setArchived(!!contributorValue.archived);
			return contributor;
		} else {
			var contributorUiItem= proxyValue;
			if (contributorUiItem.id != null) {
				var contributor= new Contributor(contributorUiItem.id, contributorUiItem.label);
				return contributor;
			}
		}
		console.debug("[Value Conversion]: could not interpret " + proxyValue + " as a contributor. Returning as empty contributor."); //$NON-NLS-1$ //$NON-NLS-2$
		return new Contributor("", ""); //$NON-NLS-1$ //$NON-NLS-2$
	},

	toLegacy: function(modelValue) {
		if (this._useUTIItemDTO) {
			var uiItemDTO= {};
			var contributor= modelValue;
			uiItemDTO.id= contributor.getItemId();
			uiItemDTO.label= contributor.getLabel();
			return uiItemDTO;
		} else {
			var dto= {};
			var contributor= modelValue;
			dto.itemId= contributor.getItemId();
			dto.name= contributor.getLabel();
			if (dto.userId != null) {
				contributor.setUserId(dto.userId);
			}
			if (dto.locationUri != null) {
				contributor.setLocationUri(dto.locationUri);
			}
			if (dto.webUri != null) {
				contributor.setWebUri(dto.webUri);
			}
			return dto;
		}
	},

	toLegacyId: function(modelValue) {
		if (this._useUTIItemDTO) {
			return this.inherited("toLegacyId", arguments, [modelValue]); //$NON-NLS-1$
		} else {
			return this.toLegacy(modelValue).itemId;
		}
	}
});
dojo.declare("com.ibm.team.workitem.web.internal.model.types.ContributorAttributeType.SubscriberAttributeType", AbstractItemAttributeType, { //$NON-NLS-1$

	constructor: function(typeId) {
		this.inherited(arguments, [typeId, new ItemLabelProvider(), new ItemResolver(), new ContributorBinding(false)]);
	}
});

})();
