/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.mvvm.model.WorkItemWorkingCopy"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojox.util.ArrayList"); //$NON-NLS-1$
dojo.require("com.ibm.jdojox.util.Collections"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.Status"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Flags"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.AttributeListenerHandle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.PresentationEndpointVisibility"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.WorkItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.links.LinksProxyListener"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.links.WorkItemReferences"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.internal.model.types.ListAttributeType"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.ProjectConfigurationRegistry"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.links.LinkCommands"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.links.WorkItemEndpoints"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.links.WorkItemLinkTypes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.links.reference.IReferenceFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.types.AttributeTypes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.mvvm.model.AttributeModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.mvvm.model.LegacyWorkItemWrapper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.itempicker.PickerDelegate"); //$NON-NLS-1$
dojo.require("dojo.Deferred"); //$NON-NLS-1$

(function() {
var lang= com.ibm.jdojo.lang;
var JavaScriptException= lang.JavaScriptException;
var jdojo= lang.Runtime;
var util= com.ibm.jdojox.util;
var ArrayList= util.ArrayList;
var Collections= util.Collections;
var team= com.ibm.team;
var foundation= team.rtc.foundation;
var Status= foundation.api.common.Status;
var Flags= foundation.web.ui.util.Flags;
var web= team.workitem.web;
var internal= web.client.internal;
var AttributeListenerHandle= internal.AttributeListenerHandle;
var PresentationEndpointVisibility= internal.PresentationEndpointVisibility;
var WorkItemAttributes= internal.WorkItemAttributes;
var model2= web.internal.model;
var WorkItem= model2.WorkItem;
var links= model2.links;
var LinksProxyListener= links.LinksProxyListener;
var WorkItemReferences= links.WorkItemReferences;
var ListAttributeType= model2.types.ListAttributeType;
var model3= web.model;
var ProjectConfigurationRegistry= model3.ProjectConfigurationRegistry;
var links2= model3.links;
var LinkCommands= links2.LinkCommands;
var WorkItemEndpoints= links2.WorkItemEndpoints;
var WorkItemLinkTypes= links2.WorkItemLinkTypes;
var IReferenceFactory= links2.reference.IReferenceFactory;
var AttributeTypes= model3.types.AttributeTypes;
var model4= web.mvvm.model;
var AttributeModel= model4.AttributeModel;
var LegacyWorkItemWrapper= model4.LegacyWorkItemWrapper;
var internal2= web.ui.internal;
var EventTopics= internal2.page.EventTopics;
var PickerDelegate= internal2.view.editor.itempicker.PickerDelegate;

dojo.declare("com.ibm.team.workitem.web.mvvm.model.WorkItemWorkingCopy", LegacyWorkItemWrapper, { //$NON-NLS-1$

	//_attributeModels: null,

	//_workItemReferences: null,

	//_newWorkItemModel: null,

	constructor: function(workItemProxy) {
		this.inherited(arguments, [workItemProxy]);
		this._attributeModels= {};
		this._workItemReferences= this.own(new WorkItemReferences());
		this._newWorkItemModel= Flags.useNewLinking();
		if (this._newWorkItemModel) {
			var projectLinkTypes= this.getLinkTypes().then(dojo.hitch(this, function(object) {
				this._setEditableLinkTypes(object);
				return object;
			}));
			this.own(new LinksProxyListener(this._proxy, this._workItemReferences, projectLinkTypes));
		}
	},

	/**
	 * Adapting API to use {@link WorkItemReferences}
	 * 
	 * @return
	 */
	newWorkItemModel: function() {
		return this._newWorkItemModel;
	},

	getWorkItemReferences: function() {
		return this._workItemReferences;
	},

	_getLinkCommands: function(allCommands) {
		if (this._newWorkItemModel) {
			this._getLinkTypeSaveCommands(allCommands, WorkItemLinkTypes.TIME_SHEET_ENTRY);
			LinkCommands.mergeLinkCommands(this._workItemReferences, allCommands);
			return allCommands;
		} else {
			return this.inherited("_getLinkCommands", arguments, [allCommands]); //$NON-NLS-1$
		}
	},

	getLinkTypes: function() {
		return ProjectConfigurationRegistry.getInstance().getConfiguration(this.getProjectAreaItemId()).getLinkTypes();
	},

	getScriptSourceWorkItem: function() {
		return this._legacyWorkItem;
	},

	isNew: function() {
		return this._proxy.isNewWorkItem();
	},

	isReadOnly: function(attributeId) {
		var isParams= {attributeId: attributeId};
		var isDynamicReadOnlyValue= this._proxy.isAttributeDynamicallyReadOnly(isParams);
		return isDynamicReadOnlyValue != null ? isDynamicReadOnlyValue : false;
	},

	isRequired: function(attributeId) {
		return this._proxy.getIsRequired(attributeId);
	},

	/**
	 * @deprecated Do not use. Use {@link #getAttributeModel(String)} directly
	 */
	registerAttributeModel: function(params) {
		if (params.attributeId == null) {
			throw new JavaScriptException("Attribute ID is a required entry in the model parameters"); //$NON-NLS-1$
		}
		var attributeModel= this._attributeModels[params.attributeId];
		if (attributeModel == null) {
			params.workItem= this;
			var attr= this.getAttribute(params.attributeId);
			if ((params.attributeLabel != null && params.attributeTypeId != null) || attr != null) {
				params.attributeLabel= params.attributeLabel != null ? params.attributeLabel : attr.getLabel();
				params.attributeTypeId= params.attributeTypeId != null ? params.attributeTypeId : attr.getAttributeTypeId();
			}
			attributeModel= new AttributeModel(params);
			this._attributeModels[params.attributeId]= attributeModel;
		}
		return attributeModel;
	},

	getAttributeModel: function(attributeId) {
		if (!(attributeId in this._attributeModels)) {
			var attr= this.getAttribute(attributeId);
			if (attr != null) {
				var params= {workItem: this, attributeId: attributeId, attributeLabel: attr.getLabel(), attributeTypeId: attr.getAttributeTypeId()};
				var attributeModel= new AttributeModel(params);
				this._attributeModels[attributeId]= attributeModel;
			}
		}
		return this._attributeModels[attributeId];
	},

	setValue: function(attributeId, modelValue) {
		return this._setValueForProxy(this.getAttribute(attributeId), modelValue);
	},

	getValue: function(attributeId) {
		return this._getValueFromProxy(this.getAttribute(attributeId));
	},

	_setValueForProxy: function(attribute, modelValue) {
		var attributeType= AttributeTypes.getAttributeType(attribute.getAttributeTypeId());
		if (attributeType != null) {
			var nullValue= AttributeTypes.toValue(attributeType, attribute.getNullValue());
			return this._doSetValue(attribute.getIdentifier(), attributeType, modelValue, nullValue);
		}
		this._logModelNotMigrated(attribute.getAttributeTypeId(), modelValue);
		this._setProxyValue(attribute.getIdentifier(), modelValue);
		return true;
	},

	_doSetValue: function(attributeId, attributeType, value, nullValue) {
		if (!attributeType.compareValue(value, this._doGetValue(attributeId, attributeType, nullValue))) {
			this._setProxyValue(attributeId, AttributeTypes.toLegacyValue(attributeType, value));
			return true;
		}
		return false;
	},

	updateDependentAttributeValue: function(dependentAttributeId) {
		if (this.getAttributeModel(dependentAttributeId) == null) {
			this.updateValue(dependentAttributeId);
		}
	},

	_getValueFromProxy: function(attribute) {
		var proxyValue= this._getProxyValue(attribute.getIdentifier());
		var attributeType= AttributeTypes.getAttributeType(attribute.getAttributeTypeId());
		if (attributeType != null) {
			var nullValue= AttributeTypes.toValue(attributeType, attribute.getNullValue());
			return this._doGetValue(attribute.getIdentifier(), attributeType, nullValue);
		}
		this._logModelNotMigrated(attribute.getAttributeTypeId(), proxyValue);
		return proxyValue;
	},

	_doGetValue: function(attributeId, attributeType, nullValue) {
		return AttributeTypes.toValue2(attributeType, this._getProxyValue(attributeId), nullValue);
	},

	validate: function(attributeId) {
		var attribute= this.getAttribute(attributeId);
		if (attribute != null) {
			return attribute.validate(this._legacyWorkItem);
		}
		return null;
	},

	validateValue: function(attributeId, responseHandler) {
		var attribute= this.getAttribute(attributeId);
		if (attribute != null) {
			attribute.validateValue(this._legacyWorkItem, responseHandler);
		} else {
			responseHandler.doCallback(Status.OK_STATUS);
		}
	},

	hasValueSet: function(attributeId) {
		var attribute= this.getAttribute(attributeId);
		return attribute != null && attribute.hasValueSet();
	},

	getAttributeValueSet: function(attributeId, params) {
		var deferredResult= (new (require("dojo/Deferred"))); //$NON-NLS-1$
		var deferred= this._proxy._valueSets.getValueSet(attributeId, params);
		deferred.then(dojo.hitch(this, function(values) {
			var attributeModel= this.getAttributeModel(attributeId);
			var attributeType= null;
			var nullValue;
			if (attributeModel == null) {
				var attribute= this.getAttribute(attributeId);
				attributeType= AttributeTypes.getAttributeType(attribute.getAttributeTypeId());
				if (attributeType == null) {
					this._logModelNotMigrated(attributeId, values);
					deferredResult.resolve(Collections.emptyList());
				}
				nullValue= AttributeTypes.toValue(attributeType, attribute.getNullValue());
			} else {
				attributeType= attributeModel.getAttributeType();
				nullValue= attributeModel.getNullValue();
			}
			var valueType;
			if (attributeType instanceof ListAttributeType) {
				valueType= attributeType.getBaseType();
			} else {
				valueType= attributeType;
			}
			var list= new ArrayList(dojo.map(values, function(element, index, array) {
				return AttributeTypes.toValue2(valueType, element, nullValue);
			}));
			deferredResult.resolve(list);
			return values;
		}), function(error) {
			deferredResult.reject(error);
			return error;
		});
		return deferredResult;
	},

	getBuiltInAttributes: function() {
		var result= {};
		var attributeMap= this._proxy.getAttributeMap();
		var $subject= jdojo.getProperties(attributeMap);
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var attributeKey= $subject[$count];
			var attributeId= attributeMap[attributeKey].getIdentifier();
			if (dojo.indexOf(WorkItemAttributes.BUILT_IN, attributeId) !== -1) {
				result[attributeId]= this.getAttribute(attributeId);
			}
		}
		return result;
	},

	getCustomAttributes: function() {
		var result= {};
		var attributeMap= this._proxy.getAttributeMap();
		var $subject2= jdojo.getProperties(attributeMap);
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var attributeKey= $subject2[$count2];
			var attributeId= attributeMap[attributeKey].getIdentifier();
			if (dojo.indexOf(WorkItemAttributes.BUILT_IN, attributeId) === -1) {
				result[attributeId]= this.getAttribute(attributeId);
			}
		}
		return result;
	},

	/**
	 * @deprecated use WorkItemReferences instead
	 */
	addWorkItemLink: function(linkDescriptor, target) {
		var linksPath= ["linkTypes", linkDescriptor.getLinkTypeId(), "linkDTOs"]; //$NON-NLS-1$ //$NON-NLS-2$
		var getLinkValueArgs= {};
		getLinkValueArgs.path= linksPath;
		getLinkValueArgs.isSource= linkDescriptor.isSource();
		getLinkValueArgs.defaultValue= [];
		var values= this._proxy.getValue(getLinkValueArgs);
		values= values != null ? values : [];
		var targetId= target.getValue(WorkItemAttributes.ID);
		var newLink= { _isNew: true, id: targetId };
		newLink.comment= target.getValue(WorkItemAttributes.ID) + ": " + target.getValue(WorkItemAttributes.SUMMARY).getContent(); //$NON-NLS-1$
		newLink.itemId= target.getWorkItemItemId();
		var targetDto= {};
		targetDto.attributes= [{key: "id", value: targetId}]; //$NON-NLS-1$
		newLink.target= targetDto;
		values.push(newLink);
		var addLinkArgs= {};
		addLinkArgs.path= linksPath;
		addLinkArgs.caller= this;
		addLinkArgs.value= values;
		this._proxy.setValue(addLinkArgs);
	},

	getPresentationEndpointVisibility: function() {
		return new PresentationEndpointVisibility(this._proxy);
	},

	addDependencyChangedListener: function(attributeId, listener) {
		return dojo.hitch(new AttributeListenerHandle(this._proxy, ["attributes", attributeId], "onDependencyChange", listener), 'destroy'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	},

	addAttributeChangedListener: function(attributeId, listener) {
		return dojo.hitch(new AttributeListenerHandle(this._proxy, ["attributes", attributeId], "onchange", listener), 'destroy'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	},

	addPreSaveListener: function(listener) {
		var subscribeHandle= dojo.subscribe(EventTopics.WORKITEM_ABOUT_TO_SAVE, this, dojo.hitch(this, function( /*, args... */ ) {
			var args= Array.prototype.slice.call(arguments, 0);
			var event= args[0];
			if (event.workItemProxy === this._proxy) {
				listener();
			}
		}));
		return function() {
			dojo.unsubscribe(subscribeHandle);
		};
	},

	getAffiliatedContributors: function() {
		var contributorModel= this.getAttributeModel(WorkItemAttributes.CREATOR);
		var nullContributor;
		if (contributorModel == null) {
			var attribute= this.getAttribute(WorkItemAttributes.CREATOR);
			var attributeType= AttributeTypes.getAttributeType(attribute.getAttributeTypeId());
			nullContributor= AttributeTypes.toValue(attributeType, attribute.getNullValue());
		} else {
			nullContributor= contributorModel.getNullValue();
		}
		var contributorTypes= [WorkItemAttributes.OWNER, WorkItemAttributes.CREATOR, WorkItemAttributes.RESOLVER];
		var allContributors= new ArrayList();
		dojo.forEach(contributorTypes, dojo.hitch(this, function(contributorAttributeId, index, contributorTypes) {
			var contributor= this.getValue(contributorAttributeId);
			if (contributor != null && nullContributor.getItemId() !== contributor.getItemId() && !allContributors.contains(contributor)) {
				allContributors.add(contributor);
			}
		}));
		var workItemComments= this.getValue(WorkItemAttributes.COMMENTS);
		for (var $it= workItemComments.iterator(); $it.hasNext();) {
			var comment= $it.next();
			if (!allContributors.contains(comment.getCreator())) {
				allContributors.add(comment.getCreator());
			}
		}
		var subscribers= this.getValue(WorkItemAttributes.SUBSCRITPIONS);
		if (subscribers != null) {
			for (var $it2= subscribers.iterator(); $it2.hasNext();) {
				var subscriber= $it2.next();
				if (!allContributors.contains(subscriber)) {
					allContributors.add(subscriber);
				}
			}
		}
		return allContributors;
	},

	asWorkItem: function() {
		var result= new WorkItem(this.getWorkItemItemId());
		result.setValue(WorkItemAttributes.ID, this.getValue(WorkItemAttributes.ID));
		result.setValue(WorkItemAttributes.SUMMARY, this.getValue(WorkItemAttributes.SUMMARY));
		result.setUrl(this.getUrl());
		return result;
	},

	_logModelNotMigrated: function(attributeId, value) {
		console.log("[DEBUG]: " + attributeId + " has not been migrated to MVVM framework. Object to migrate: "); //$NON-NLS-1$ //$NON-NLS-2$
		console.debug(value);
	},

	destroy: function() {
		var $subject3= jdojo.getValues(this._attributeModels);
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var model= $subject3[$count3];
			model.destroy();
		}
		this._attributeModels= {};
		this.inherited("destroy", arguments, []); //$NON-NLS-1$
	},

	openWorkItemSelectionDialogForAddingDuplicateOfLink: function() {
		if (this._workItemReferences.isResolved()) {
			var context= {id: "com.ibm.team.workitem.web.ui.internal.editor.itempicker.SelectWorkitemPicker", useModel: true}; //$NON-NLS-1$
			new PickerDelegate().openDialog(context, dojo.hitch(this, function(targetWorkItems) {
				this._workItemReferences.add(WorkItemEndpoints.DUPLICATE_OF_WORK_ITEM, IReferenceFactory.getInstance().createWorkItemReference(targetWorkItems[0]));
			}));
		}
	}
});

})();
