/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.mvvm.model.providers.ContributorDataProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.client.internal.AdminClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.types.AttributeTypes"); //$NON-NLS-1$
dojo.require("dojo.Deferred"); //$NON-NLS-1$

(function() {
var team= com.ibm.team;
var web= team.repository.web;
var AdminClient= web.client.internal.AdminClient;
var ServiceResponseHandler= web.transport.ServiceResponseHandler;
var AttributeTypes= team.workitem.web.model.types.AttributeTypes;

dojo.declare("com.ibm.team.workitem.web.mvvm.model.providers.ContributorDataProvider", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	//_queriedContributor: null,

	//_contributorAttribute: null,

	constructor: function(contributorAttribute) {
		this._queriedContributor= {};
		this._contributorAttribute= contributorAttribute;
	},

	getValues: function(o) {
		var options= o;
		if ((options.searchTerm in this._queriedContributor)) {
			return this._queriedContributor[options.searchTerm];
		}
		var result= (new (require("dojo/Deferred"))); //$NON-NLS-1$
		this._queriedContributor[options.searchTerm]= result;
		var params= {hideArchivedUsers: !options.includeArchived, hideAdminGuest: !options.includeAdminGuest, hideUnassigned: !options.includeUnassigned, pageSize: 250, searchTerm: options.searchTerm, sortBy: "name"}; //$NON-NLS-1$
		AdminClient.getContributors(params, new ServiceResponseHandler({'onSuccess': dojo.hitch(this, function(contributors) {
			if (contributors.count === 0 || contributors.elements == null) {
				result.resolve([]);
				return ;
			}
			var deferredResult= [];
			var nullValue= AttributeTypes.toValue(AttributeTypes.CONTRIBUTOR_TYPE, this._contributorAttribute.getNullValue());
			var $subject= contributors.elements;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var contributorDto= $subject[$count];
				deferredResult.push(AttributeTypes.toValue2(AttributeTypes.CONTRIBUTOR_TYPE, contributorDto, nullValue));
			}
			result.resolve(deferredResult);
		}), 'onFailure': function(error) {
			result.reject(new Error(error.message));
		}}, 'onSuccess', 'onFailure')); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		result.then(dojo.hitch(this, function(object) {
			delete this._queriedContributor[options.searchTerm];
			return object;
		}), dojo.hitch(this, function(object) {
			delete this._queriedContributor[options.searchTerm];
			return object;
		}));
		return result;
	},

	$interfaces: {
		'com.ibm.team.workitem.web.mvvm.model.providers.IFilteredDataProvider': true //$NON-NLS-1$
	}
});

})();
