                                                                                                        @PROCESS MPARM('DSPRWA00');
 @PROCESS F(I)
 INLINE(MAX)
 TITLE('DSPRWA00 - DATABASE RECOVERY - ADD EXIT');
 @process override env(z/OS) machine(zSeries) optimize(ADV,64)
                  storemotion inline(MAX) assert(blockreorder);

 ?DSPSTART RECEIVES(DFSBRLSB)
                   Options(Codenum(4))
                   Fixes(
                        );
 @eject;
 /********************************************************************/
 /*                                                                  */
 /* MODULE NAME:  DSPRWA00                                           */
 /*                                                                  */
 /* DESCRIPTIVE NAME:  Database Recovery Recover Add Exit            */
 /*                                                                  */
 /*                                                                  */
 /************************************************************@SCPYRT*/
 /*                                                                  */
 /*    IBM Confidential                                              */
 /*                                                                  */
 /*    OCO Source Materials                                          */
 /*                                                                  */
 /*    5635-A04                                                      */
 /*                                                                  */
 /*        Copyright IBM Corp. 1974,1998                             */
 /*                                                                  */
 /*    The source code for this program is not published or other-   */
 /*    wise divested of its trade secrets, irrespective of what has  */
 /*    been deposited with the U.S. Copyright Office.                */
 /*                                                                  */
 /************************************************************@ECPYRT*/
 /*                                                                  */
 /*                                                                  */
 /* STATUS:  IMS Version 10 Release 1 - See Change Activity          */
 /*                                                                  */
 /* FUNCTION:                                                        */
 /*   This module processes the Database Recovery Add Exit.          */
 /*                                                                  */
 /*     - This exit is invoked in support Database Recovery          */
 /*       RECOVER ADD command. DBRC is passed a list of either       */
 /*       databases, areas, database data sets, database groups,     */
 /*       database data set groups, or change accumulation groups.   */
 /*       DBRC returns a list of the database data sets and areas    */
 /*       which make up the possible groups, and status for each     */
 /*       one. The status includes whether known to DBRC or not,     */
 /*       whether recoverable or non-recoverable, for areas whether  */
 /*       or not there are any adss defined, and whether they are    */
 /*       currently authorized (and the authorizing SSIDs).          */
 /*                                                                  */
 /*                                                                  */
 /*                                                                  */
 /* NOTES:                                                           */
 /*   DEPENDENCIES:  IMS 10.1                                        */
 /*   RESTRICTIONS:  None                                            */
 /*   REGISTER CONVENTIONS:  Refer to DSPDREG macro expansion        */
 /*   PATCH LABEL:  Patch area is generated by the compiler          */
 /*                                                                  */
 /* MODULE TYPE:  PROCEDURE                                          */
 /*   PROCESSOR:  PL/X-370                                           */
 /*   MODULE SIZE:  See Assembler Listing                            */
 /*   ATTRIBUTES:  Reentrant                                         */
 /*                                                                  */
 /* ENTRY POINT:  DSPRWA00 Procedure                                 */
 /*   PURPOSE:  Main entry point of this module                      */
 /*   LINKAGE:  Called by module DSPCRTR0                            */
 /*                                                                  */
 /* INPUT:                                                           */
 /*                                                                  */
 /*   SYMBOLIC NAME: DFSBRLSB                                        */
 /*   DESCRIPTION: Parameter list passed by IMS with the following   */
 /*                required parameters:                              */
 /*                                                                  */
 /*                - BRLBF2 - Exit to be invoked                     */
 /*                      = BRLBF2RA : Recover Add Exit               */
 /*                                                                  */
 /*                - BRLBRVRA - Ptr to an input list containing      */
 /*                             the names to be resolved.            */
 /*                                                                  */
 /*   SYMBOLIC NAME:  R5                                             */
 /*   DESCRIPTION:  Address of DSPGDB                                */
 /*                                                                  */
 /* OUTPUT:                                                          */
 /*                                                                  */
 /*   SYMBOLIC NAME: DSPGDB                                          */
 /*   DESCRIPTION: DBRC Global Data Block                            */
 /*                                                                  */
 /*                - rqbRETAR - Address of the list of resolved      */
 /*                             DBDSs and Areas as mapped by the     */
 /*                             DFSRWAO macro. This address is moved */
 /*                             by the Router (DSPCRTR0) to the      */
 /*                             DFSBRLSB and is returned to the      */
 /*                             caller in the field BRLBFDBK.        */
 /*                                                                  */
 /*   SYMBOLIC NAME: DFSBRLSB                                        */
 /*   DESCRIPTION: Parameter list passed by IMS on input.            */
 /*                                                                  */
 /*                - BRLBFDBK - Address of the list of resolved      */
 /*                             DBDSs and Areas as mapped by the     */
 /*                             DFSRWAO macro.                       */
 /*                  The router will copy the address to the brlsb   */
 /*                  (brlbfdbk).  This address is copied into the    */
 /*                  field specified by the FEEDBACK= keyword in the */
 /*                  DSPRWRV call.  Storage for this list is gotten  */
 /*                  by DBRC.  It will be freed by a subsequent call */
 /*                  to the DBRC free routine.                       */
 /*                                                                  */
 /* EXIT-NORMAL: return to caller with one of the following          */
 /*              return codes in register 15:                        */
 /*                                                                  */
 /*               '00' - Successful call                             */
 /*               '12' - Severe error                                */
 /*               '44' - Internal DBRC error                         */
 /*               '48' - An invalid parameter is found               */
 /*                                                                  */
 /*                                                                  */
 /* EXIT-ERROR: none                                                 */
 /*                                                                  */
 /* EXTERNAL REFERENCES:                                             */
 /*   ROUTINES:                                                      */
 /*     DSPURI00 - RECON I/O routine                                 */
 /*                                                                  */
 /*   DATA-AREAS:                                                    */
 /*     DFSBRLSB - parameter list from IMS                           */
 /*                                                                  */
 /*   CONTROL BLOCKS:                                                */
 /*     REFERENCED:                                                  */
 /*       DSPGDB    -  DBRC Global Data Block                        */
 /*                                                                  */
 /* TABLES:  none                                                    */
 /*                                                                  */
 /* MACROS:                                                          */
 /*   DSPROPEN  -  open the RECON data set                           */
 /*   DSPRCLOS  -  close the RECON data set                          */
 /*   DSPRINCL  -  include RECON records                             */
 /*   DSPRLOCT  -  locate a RECON record                             */
 /*   DSPDREG   -  register declarations                             */
 /*   DSPDBGL   -  DB Group list                                     */
 /*                                                                  */
 /* CHANGE ACTIVITY:                                                 */
 /*  PTM#     Date   Rel  Coder  Reason                              */
 /* -------- ------ ----- ----- ------------------------------------ */
 /*          011707 V10R1  VKL  V10 cleanup                          */
 /* PK37513  011707 V10R1  LES  Add support for OUTPUT(ICRCA)        */
 /* PK82881  032409 V11R1  LES  Fix DBDS GRP when a DBGRP.           */
 /* PK80920  041806 V11R1  SAG  Recompile for DSPLSTOR change        */
 /*                                                                  */
 /********************************************************************/
 @eject;
 @logic;
 This Exit is for Database Recovery and is called by the commands
 RECOVER START, RECOVER REMOVE and DISPLAY RECOVERY. Input
 is standard DBRC DFSBRLSB. The BRLSB points to an input list RWAI
 (mapped by DFSRWAI), and an output list RWCR (mapped by DFSRWCR).
 The input list RWAI is a list of either:
 - Database Names
 - Database Datset Names
 - AREA Names
 - Database Dataset Group Names
 - Database Group Names
 - Change Accumulation Group Names
 The exit resolves all the group names to their individual database
 dataset names. For all the DBDSs thus passed as input, the exit:
 - verifies it is registered in RECON
 - shows if the DB/AREA is currently Authorized
 - if an AREA, shows if there are any available ADSs
 - shows if the DB is Nonrecoverable
 The resulting list of all the DBDSs/AREAs is returned to IMS in an
 RWCR.

 For a RECOVER ADD command, a list of all Subsystems (SSIDs) is also
 returned for every DB/AREA that is authorized. This SSID list is not
 returned for a RECOVER REMOVE or /DISPLAY RECOVERY command. IMS
 maintains a Recovery List of all the DBDSs/AREAs being recovered
 made up from all the valid DBDSs/AREAs returned on the RECOVER ADD
 command.

 A separate list may also be returned of all parts (the input names)
 which are not known to DBRC. A special case exists for DB Groups.
 A DB Group can contain AREA names besides just database names. Without
 knowing the DBD name for the AREA, DBRC would have to search all AREAs
 under all Fast Path DB records looking for a match. Instead, the exit
 returns yet another list of all names in a DB Group which are not found
 in RECON as a DB record. IMS searches it's blocks to determine if any
 of these names are valid AREAs. IMS builds a new input list of the
 valid AREA names it finds and reinvokes this exit with the new list.

 RECOVER REMOVE and /DISPLAY RECOVERY calls this exit only to resolve
 group names to the individual DBDSs/AREAs.

 This exit is invoked by the DSPRSU macro.


 This module reads the appropriate record for each name in the input
 list ultimatly reading each DBDS or AREA AUTH record that the list
 resolves to. For each DBDS/AREA AUTH record, a block is built which
 contains the information that will eventually be used to build the
 final output list. These blocks are all chained. There is one chain
 for all the blocks built, another chain of just blocks representing
 DBDS records, a third chain of all the blocks for AREA AUTH records,
 a fourth chain of blocks which represent input names which were not
 found in RECON, and a final chain of blocks representing names within
 DB Groups which were not found in RECON (these may be valid AREA
 names).

 After all input names have been processed, the size of the output list
 is calculated, storage obtained for the output list, and the chains
 are run to build the output list returned to IMS.

 Storage requests are managed by the Class StorMan (see DSPLSTOR). A
 new Class (Record) is defined to manage all the blocks built for the
 records read. The Record Class obtains a large amount of storage, then
 the blocks that are built are taken from the large amount. The Record
 Class uses the StorMan Class for it's storage requests, and manages
 the large block allocations.

 @endlogic;
 @eject;
    /*  Include the required structures                              */
 @space(1);
   ! The following 2 statements set extra checking for the
   ! MVS STORAGE Macro
   %Declare Storage_Ckaddr Char Ext;
   %Storage_Ckaddr = 'Yes';
   ?dfsbrlsb id(RVU);
   ?dsprincl rcdtypes(DB,DBDSGRP,CAGRP,DBDS,AAUTH);
   ?dspdreg;
   %incls='NO';
   %include syslib(dspgdb);
   %include syslib(dspIrcar);
   %include syslib(dfsrwai);          ! Input Block
   %include syslib(dfsrwcr);          ! Output Block
   %include syslib(dsplstor);         ! DBRC Storage Manager
   %include syslib(dtrparms);         ! DBRC Tarce Parameter List
   gen code ( COPY BPE64NOP ) optacross;

   /******************************************************************/
   /*  Local constant declarations                                   */
   /******************************************************************/
   dcl NULLPTR ptr(31) Constant(0);     /* null pointer              */
   dcl GSAMOrg Char(1) Constant('10'X); /* GSAM DB Organization      */
   dcl ON  bit(1) constant('1'b);       /*                           */
   dcl OFF bit(1) constant('0'b);       /*                           */
                                        /*                           */
   /******************************************************************/
   /*  Return codes                                                  */
   /******************************************************************/
   dcl NOT_FOUND       fixed constant(4);  /* record not found       */
   dcl Terminate_error fixed constant(16); /* terminate due to error */
   dcl RCODE0   fixed constant( 0);    /* successfull completion     */
   dcl RCODE12  fixed constant(12);    /* severe error               */
   dcl RCODE44  fixed constant(44);    /* internal dbrc error        */
   dcl RCODE48  fixed constant(48);    /* invalid parameter found    */
                                       /*                            */
   /******************************************************************/
   /*  Local variable declarations                                   */
   /******************************************************************/
   dcl NoDBDS         Bit(1);
7  dcl Quit           Bit(1);              /* quit loop      @KZ30225*/
7  dcl doing_haldbolr Bit(1);              /* HALDB OLR db   @KZ30225*/
7  dcl doing_2ndolr   Bit(1);              /* 2nd OLR copy   @KZ30225*/
7  dcl found_olr      Bit(1);              /* OLR copy found @KZ30225*/
   dcl GrpRecPtr ptr ExplicitInitial(0);
   dcl rc       fixed ExplicitInitial(RCODE0); /* Return Code        */
   dcl (i, k)   fixed;                 /* loop index                 */
   dcl RCode    fixed ExplicitInitial(RCODE0);
   dcl grprec_lngth fixed ExplicitInitial(0);
   dcl lenslst  fixed ExplicitInitial(0);
   dcl lenrwcr  fixed ExplicitInitial(0);
   dcl lennoent fixed ExplicitInitial(0);
   dcl Noentctr fixed ExplicitInitial(0);

7  dcl 1 dbid_name char(length(Ircdbds)),                     !@KZ30225
7        3  dbid_name_dbd char(length(Ircdbd)),               !@KZ30225
7        3  dbid_name_ddn char(length(Ircddn));               !@KZ30225

7 @eject;                                                     !@KZ30225
   Declare MyStor IsA(StorMan) ExplicitInitial(InitStor(MyStor));

   DeclareClass Record Internal;

   !*************************************************************
   !
   !    Record Class Definition
   !
   !       This is the class definition for a record manager.
   !       There are methods defined to initialize a record
   !       manager object, add records, query if a DB record
   !       exists, and destroy the object.
   !
   !    Methods:
   !
   !       InitBlock(record_object_name, storage_object_name)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Storage_Object_Name - The instantiated object name of the
   !                                Class StorMan.
   !
   !          This method initializes the object and must be invoked
   !          prior to any other methods.
   !
   !          The method returns the following codes:
   !
   !            0        - Initialization successful.
   !            4        - StorMan has not been initialized
   !            8        - GetStor Failure, could not get storage
   !            12       - Initialization has already been done
   !
   !       AddRecord(record_object_name, storage_object_name)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Storage_Object_Name - The instantiated object name of the
   !                                Class StorMan.
   !
   !          This method adds a block to the chain obtaining
   !          information from the DBRC RECON record pointed to
   !          by IRCRECRD (the last record located). There is a
   !          chain of all records, and separate ones for DB, DBDSs,
   !          and Area Auth records.
   !
   !          The method returns the following codes:
   !
   !            0        - Record successfully added to the chain
   !                       RWA_RecordPtr contains the address of the
   !                       RecordBlk that was added.
   !            4        - GetARecord Failure, could not get a record
   !            8        - No DB record exists for the DBDS to be added
   !            12       - Invalid record type, not a DB, DBDS or AAUTH
   !
   !       AddNoEnt(record_object_name, storage_object_name,
   !                       dbdname, reason)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Storage_Object_Name - The instantiated object name of the
   !                                Class StorMan.
   !
   !          Dbdname - A 16 character field containg the DBD/DDN name.
   !
   !          Reason - A Fixed(8) constant to indicate the reason
   !                        for the entry.
   !
   !          This method adds a block to the chain about an input
   !          name that is not known to DBRC. The Record_Blk is also
   !          added to the No Entry chain.
   !
   !          The method returns the following codes:
   !
   !            0        - Record successfully added to the chain
   !            4        - GetARecord Failure, could not get a record
   !          The NOENT reasons are defined in DFSRWCR
   !
   !
   !       GetARecord(record_object_name, storage_object_name, size)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Storage_Object_Name - The instantiated object name of the
   !                                Class StorMan.
   !
   !          Size - A fixed(31) variable containg the size in bytes
   !                 of the Record_Blk needed.
   !
   !          This method obtains a Record_Blk of the specified size.
   !          The Record_Blk is obtained from the first BlockHdr
   !          containing sufficient storage. If necessary a new
   !          BlockHdr is gotten to satisfy the request. The Class
   !          StorMan is used if a new BlockHdr is required.
   !          RWA_RecordPtr is set with the address of the block
   !          acquired.
   !
   !          The method returns the following codes:
   !
   !            0        - Request sucessful.
   !                       RWA_RecordPtr contains the address
   !                       of the Record_Blk obtained.
   !            4        - GetStor Failure, could not get storage
   !            8        - Request for zero storage
   !
   !       ReturnBlock(record_object_name, storage_object_name)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Storage_Object_Name - The instantiated object name of the
   !                                Class StorMan.
   !
   !          This method returns all storage obtained by the object,
   !          and sets the object to a not initialized state.
   !
   !          The method returns the following code:
   !
   !            0        - All storage sucessfully freed and the
   !                       instantiated object set to a not
   !                       initialized state.
   !
   !       IsThereDB(record_object_name, database_name)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Database_Name - A DBD name
   !
   !          This method searches the chain of DB records and
   !          returns a '1'B if the DBD name is found. Otherwise
   !          a '0'B is returned.
   !
   !          If the DBD name is found, RWA_RecordPtr contains the
   !          address of the Record_Blk for the DBD.
   !
   !       IsThereAAUTH(record_object_name, area_name)
   !
   !          Record_Object_Name - The instantiated object name of the
   !                               Class Record.
   !
   !          Area_Name - An Area name.
   !
   !          This method searches the chain of AAUTH records and
   !          returns a '1'B if the AREA name is found. Otherwise
   !          a '0'B is returned.
   !
   !          If the AREA name is found, RWA_RecordPtr contains the
   !          address of the Record_Blk for the AREA.
   !
   !
   !    Example of Usage:
   !
   !       %Include  Syslib(DSPLSTOR)       !
   !       Declare MyStorMan IsA(StorMan)   ! Instantiate an object
   !       If InitStor(MyStorMan) = 0 then  ! Initialize the object
   !         Do
   !           If GetStor(MyStorMan,        ! Get some storage
   !                      Calc_Lngth,
   !                      MyStorPtr) = 0 then
   !             ! Do something
   !           If GetStor(MyStorMan,
   !                      Some_length,
   !                      MyStorPtr,
   !                      SubPool7,         ! Subpool other than 0
   !                      *,                ! Location omitted
   !                      StorDoNotFree) then ! Do not free
   !             ! Do something Else
   !           Call ReturnStor(MyStorMan)     ! Returns all storage
   !                                          ! except that with
   !                                          ! StorDoNotFree.
   !         End
   !
   !
   !*****************************************************************

     Declare  1 Record_Blk Based(RWA_RecordPtr) Public,
                3  RWA_Next_Record ptr,
                3  RWA_Next_Of_Type ptr,
                3  RWA_DBRec_ptr ptr,
                3  RWA_Type Char(Length(KEYRTYPE)),
                3  RWA_Flags Bit(8),
                  5 RWA_FF   Bit(1),
                  5 RWA_NR   Bit(1),
                  5 RWA_Authed Bit(1),
                  5 RWA_NoADS Bit(1),
                  5 RWA_MADS Bit(1),
7                 5 RWA_OLR  Bit(1),          ! HALDB OLR copie@KZ30225
8                 5 RWA_Part Bit(1),          ! DB partition   @PQ85442
                  5 *        Bit(1),
                3  RWA_Flag2 Bit(8),                          !@PK09734
                  5 RWA_dbordbds Bit(1),      ! 0 = A-J DBDSs active
                                              ! 1 = M-V DBDS   @PK09734
                  5 RWA_dbmvdbds Bit(1),      ! 0 = no M-V DBDSs
                                              ! 1 = M-V DBDS   @PK09734
                  5 *        Bit(6),          ! spares         @PK09734
                3 *                  Char(1),
                3  RWA_NumberOfSSIDs Fixed(15),
1               3  RWA_DSID Fixed(16),
                3  RWA_DSORG Bit(8),
                3  RWA_DBORG Char(1),
                3  RWA_Status Fixed(8),
                3  RWA_DBID,
                  5  RWA_DBDName Char(Length(KEYDBD)),
                  5  RWA_DDName  Char(Length(KEYDDN)),
                3  RWA_DSName  Char(Length(DSPDSHRC.DSHDSN)),
                3  RWA_ADDN    Char(Length(KEYDDN)),
                3  RWA_SSIDs(*) Char(Length(DBSSNAME));

     Declare 1 BlockHdr Based(RWA_BlkPtr) Private,
               3 BlkEyeC Char(8),
               3 BlkNext Ptr,
               3 BlkPrev Ptr,
               3 BlkSize Fixed,
               3 BlkNextAvail Ptr,
               3 BlkSizeRemaining Fixed,
               3 BlkStorage Char(*);

     Declare BlkDefaultSize Fixed Constant(4096);
     Declare BlkEyeCatcher Char(8) Constant('RWABLOCK');

     Declare RWA_BlkPtr         Auto Private Ptr   ScopeInitial(0);
     Declare RWA_RecordPtr      Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_FirstBlk       Auto Private Ptr   Scopeinitial(0);
     Declare RWA_LastBlk        Auto Private Ptr   ScopeInitial(0);
     Declare RWA_FirstRec       Auto Private Ptr   ScopeInitial(0);
     Declare RWA_LastRec        Auto Private Ptr   ScopeInitial(0);
     Declare RWA_FirstDB        Auto Private Ptr   ScopeInitial(0);
     Declare RWA_LastDB         Auto Private Ptr   ScopeInitial(0);
     Declare RWA_FirstDBDS      Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_LastDBDS       Auto Private Ptr   ScopeInitial(0);
     Declare RWA_FirstAAUTH     Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_LastAAUTH      Auto Private Ptr   ScopeInitial(0);
     Declare RWA_First_Noent    Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_Last_Noent     Auto Private Ptr   ScopeInitial(0);
     Declare RWA_First_NotInGrp Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_Last_NotInGrp  Auto Private Ptr   ScopeInitial(0);
     Declare RWA_DBPtr          Auto Public  Ptr   ScopeInitial(0);
     Declare RWA_NumOfDBDSs     Auto Public  Fixed ScopeInitial(0);
     Declare RWA_NumOfSSIDs     Auto Public  Fixed ScopeInitial(0);
     Declare RWA_NumOfNoent     Auto Public  Fixed ScopeInitial(0);

     Declare 1 RWA_SavedAreaRecov Auto Public Like(DSPDSHRC.DSHFIXED)
                                                   ScopeInitial('0'B);
     Declare RWA_InitBlockLastReturnCode  Auto Private Fixed
                                                   ScopeInitial(0);
     Declare RWA_AddRecordLastReturnCode  Auto Private Fixed
                                                   ScopeInitial(0);
     Declare RWA_AddNoEntLastReturnCode   Auto Private Fixed
                                                   ScopeInitial(0);
     Declare RWA_GetARecordLastReturnCode Auto Private Fixed
                                                   ScopeInitial(0);

     Declare InitBlock Entry(IsA(Record),
                             IsA(StorMan))
                           Returns(Fixed);

     Declare ReturnBlock Entry(IsA(Record),
                             IsA(StorMan));

     Declare AddRecord Entry(IsA(Record),
                             IsA(Storman))
                           Returns(Fixed);

     Declare AddNoEnt  Entry(IsA(Record),
                             IsA(Storman),
                             Char(Length(RWA_DBID)),
                             Fixed(8))
                           Returns(Fixed);

     Declare IsThereDB Entry(IsA(Record),
                             Char(8))
                           Returns(Bit(1));

     Declare IsThereAAUTH Entry(IsA(Record),
                             Char(8))
                           Returns(Bit(1));

     Declare GetARecord Entry(IsA(Record),
                              IsA(Storman),
                              Fixed)
                           Returns(Fixed);

     Declare TraceIt Entry();

 @eject;

     !
     ! InitBlock Procedure:
     !
     !    This method initializes the Class Record. An initial,
     !    default size block is obtained, initialized and
     !    chained off the anchor points.
     !
     !   Return Code:   0  - Initialization successful.
     !                  4  - StorMan has not been initialized
     !                  8  - GetStor Failure, could not get storage
     !                  12 - Initialization has already been done
     !

     InitBlock: Procedure(InitRcd, StorObj)
                        Returns(Fixed);

       Declare InitRcd IsA(Record);
       Declare StorObj IsA(StorMan);
       Declare InitRCode Fixed ScopeInitial(0);
       Declare InitStorNotInit_Failure Fixed Constant(4);
       Declare InitGetStor_Failure Fixed Constant(8);
       Declare InitAlreadyDone_Failure Fixed Constant(12);

       ! If the StorMan Class is in an initialized state, and
       ! the Record Class has not been initialized, call GetStor
       ! to obtain the first block of storage.

       If StorMan.Initialized then
         If (Record.RWA_FirstBlk = 0) &
            (Record.RWA_LastBlk = 0) then
           If GetStor(StorObj,
                      BlkDefaultSize,
                      Record.RWA_BlkPtr) = 0 then
             Do;
               ! Chain this block off the anchor
               Record.RWA_FirstBlk = Record.RWA_BlkPtr;
               Record.RWA_LastBlk  = Record.RWA_BlkPtr;
               ! Initialize the block
               Record.BlkEyeC      = Record.BlkEyeCatcher;
               Record.BlkNext = 0;
               Record.BlkPrev = 0;
               Record.BlkSize = Record.BlkDefaultSize;
               Record.BlkNextAvail = ADDR(Record.BlkStorage);
               Record.BlkSizeRemaining = Record.BlkSize -
                                           OFFSET(Record.BlkStorage);
               ! As storage is used from the block, BlkNextAvail is
               ! updated by adding the size used, while
               ! BlkSizeRemaining is updated by subtracting the size
               ! used.
             End;
           Else
             InitRCode = InitGetStor_Failure;
         Else
           InitRCode = InitAlreadyDone_Failure;
       Else
         InitRCode = InitStorNotInit_Failure;

       RWA_InitBlockLastReturnCode = InitRCode;
       Return(InitRCode);
     End InitBlock;

 @eject;

     !
     ! ReturnBlock Procedure:
     !
     !    This (destructor) method frees all the storage obtained.
     !
     !   Return Code:   0  - Sucessful completion.
     !

     ReturnBlock: Procedure(RtnRcd, RtnStorObj);

       Declare RtnRcd IsA(Record);
       Declare RtnStorObj IsA(StorMan);

       Call ReturnStor(RtnStorObj);
       Return Code(0);

     End ReturnBlock;

 @eject;

     !
     ! IsThereDB Procedure:
     !
     !    This method runs the DB chain to determine if a DB
     !    record already exists. If the DB is found, a '1'B is
     !    returned, and RWA_DBPtr contains the address of the
     !    DB record. Otherwise, a '0'B is returned.
     !
     !   Return Code:   None
     !

     IsThereDB: Procedure(IsSelf, IsDBName)
                        Returns(Bit(1));

       Declare IsSelf IsA(Record);
       Declare IsDBName Char(8);
       Declare IsFound Bit(1);

       IsFound = '0'B;
       Do RWA_DBPtr = RWA_FirstDB
                      Repeat RWA_DBPtr->RWA_Next_of_Type
                      While ((RWA_DBPtr ¬= 0) &
                             (RWA_DBPtr->RWA_DBDName ¬= IsDBName));
         If RWA_DBPtr->RWA_DBDName = IsDBName then
           IsFound = '1'B;
       End;

       Return(IsFound);

     End IsThereDB;

 @eject;

     ! IsThereAAUTH Procedure:
     !
     !    This method runs the AAUTH chain to determine if an AAUTH
     !    record already exists. If the AREA is found, a '1'B is
     !    returned, and RWA_DBPtr contains the address of the
     !    AAUTH record. Otherwise, a '0'B is returned.
     !
     !   Return Code:   None
     !

     IsThereAAUTH: Procedure(IsSelf, IsAREAName)
                        Returns(Bit(1));

       Declare IsSelf IsA(Record);
       Declare IsAREAName Char(8);
       Declare IsFound Bit(1);

       IsFound = '0'B;
       Do RWA_DBPtr = RWA_FirstAAUTH
                      Repeat RWA_DBPtr->RWA_Next_of_Type
                      While ((RWA_DBPtr ¬= 0) &
                             (RWA_DBPtr->RWA_DDName ¬= IsAREAName));
         If RWA_DBPtr->RWA_DDName = IsAREAName then
           IsFound = '1'B;
       End;

       Return(IsFound);

     End IsThereAAUTH;

 @eject;

     !
     ! GetARecord Procedure:
     !
     !    This method gets a Record_Blk and returns a pointer to
     !    the block obtained.
     !
     !   Return Code:   0  - All OK
     !                  4  - Failure on GetStore
     !                  8  - Request for Zero Storage
     !

     GetARecord: Procedure(GetRcd, MoreStor, GetSize) Class(Record)
                        Returns(Fixed);


       Declare GetRcd IsA(Record);
       Declare MoreStor IsA(StorMan);
       Declare GetSize Fixed;

       Declare GetRCode Fixed;
       Declare BlockSize Fixed;
       Declare GET_NoStor   Fixed Constant(4);
       Declare GET_ZeroRqst Fixed Constant(8);

       GetRCode = 0;

       If GetSize ¬= 0 then
         Do;
           ! Now search through the blocks to find one with the
           ! available space needed (see the Class Description
           ! for details on how storage and blocks are managed).
           Do Record.RWA_BlkPtr = Record.RWA_FirstBlk
                           Repeat Record.BlkNext
                           While(Record.RWA_BlkPtr ¬= 0 &
                             Record.BlkSizeRemaining < GetSize);
           End;
           If Record.RWA_BlkPtr = 0 then
             Do;
               ! No block with enough space found. Get a new one.
               ! The Class StorMan is used to manage obtaining and
               ! returning storage.
               BlockSize = MAX(Record.BlkDefaultSize,
                            GetSize + OFFSET(Record.BlkStorage));
               If GetStor(MoreStor, BlockSize,
                              Record.RWA_BlkPtr) = 0 then
                 Do;
                   ! Add the block just obtained to the chain of
                   ! storage blocks.
                   Record.BlkEyeC = Record.BlkEyeCatcher;
                   Record.BlkNext = 0;
                   Record.BlkPrev = Record.RWA_LastBlk;
                   Record.BlkSize = BlockSize;
                   Record.BlkNextAvail = ADDR(Record.BlkStorage);
                   Record.BlkSizeRemaining = BlkSize -
                                       OFFSET(Record.BlkStorage);
                   Record.RWA_LastBlk->Record.BlkNext =
                                               Record.RWA_BlkPtr;
                   Record.RWA_LastBlk = Record.RWA_BlkPtr;
                 End;
               Else
                 GetRCode = GET_NoStor;
             End;
           If GetRCode = 0 then
             Do;
               Record.RWA_RecordPtr = Record.BlkNextAvail;
               ! Update the Block info
               Record.BlkNextAvail = Record.BlkNextAvail + GetSize;
               Record.BlkSizeRemaining =
                                 Record.BlkSizeRemaining - GetSize;
             End;
         End;
       Else
         GetRCode = GET_ZeroRqst;

       RWA_GetARecordLastReturnCode = GetRCode;
       Return(GetRCode);

     End GetARecord;

   End  DeclareClass;

 @eject;

   Declare MyRecord IsA(Record);

   Declare Open_RECON Entry() Returns(Fixed) Options(Inline(YES));

 @eject;

 RC = 0;
4If brlbdrrs | brlbdrre | brlbdrrv then
   Call DSPRWV00(DFSBRLSB)  Retcode(RC);
 Else
   Do;
     Initialize
                MyStor,
                GrpRecPtr,
                RWA_SavedAreaRecov,
                grprec_lngth,
                lenslst,
                lenrwcr,
                RCode;

 @eject;

     !
     ! OPEN the RECON datasets. Fail execution if an error.
     !

     If Open_RECON() = 0 then        /* Error opening RECON?         */
       If Record.InitBlock(MyRecord, MyStor) = 0 then
         Do;
           If brlbdrai then
             Do;
               rfy rwai based(brlbdr2b);

               select(rwai_type);
                 when(rwai_type_database)
                   Do i = 1 to rwai_num
                        While (RCode < Terminate_Error);
                     ! Check for DB defined but no DBDSs
                     NoDBDS = On;
                     call dbrec(rwai_db_name(i)) retcode(RCode);
                     If ((RCode = 0) & (NoDBDS = ON)) then
                       If ADDNoEnt(MyRecord, MyStor, rwai_db(i),
                               rwcrnoentnodbds) ¬= 0 then
                         RCode = Terminate_Error;
                       Else;
                     Else
                       If RCode = NOT_FOUND then
                         If ADDNoEnt(MyRecord, MyStor, rwai_db(i),
                                 rwcrnoentnotfound) ¬= 0 then
                           RCode = Terminate_Error;
                         Else;
                       Else
                         If RCode > NOT_FOUND then
                           RCode = Terminate_Error;
                   End;
                 when(rwai_type_area)
                   Do i = 1 to rwai_num
                        While (RCode < Terminate_Error);
                     If ¬IsThereAAUTH(MyRecord,
                                      rwai_area_ddn_name(i)) then
                       Do;
                         ?dsprloct direct rcdtyp(DBDS)
                                   dbid(rwai_area_name(i)) rc(RCode);
                         If (RCode = 0) &
                            (IRCRECRD->DSPDSHRC.DSHFPath) then
                           RWA_SavedAreaRecov = IRCRECRD->
                                DSPDSHRC(1:Length(RWA_SavedAreaRecov));
                         If RCode ¬= prab_retry_rc then       ! UPPA1RS
                           ?dsprloct direct rcdtyp(AAUTH)
                                     dbid(rwai_area_name(i)) rc(RCode);
                           If RCode = 0 then
                             If AddRecord(MyRecord, MyStor) ¬= 0 then
                               RCode = Terminate_Error;
                             Else;
                           Else
                             If RCode = NOT_FOUND then
                               If ADDNoEnt(MyRecord,
                                           MyStor,
                                           rwai_area_name(i),
                                       rwcrnoentnotfound) ¬= 0 then
                                 RCode = Terminate_Error;
                               Else;
                             Else
                               RCode = Terminate_Error;
                       End;
                   End;
                 when(rwai_type_dbds)
                   Do i = 1 to rwai_num
                        While(RCode < Terminate_Error);
7                    doing_haldbolr = OFF;                    !@KZ30225
7                    doing_2ndolr   = OFF;                    !@KZ30225
7                    found_olr      = OFF;                    !@KZ30225
                     If ¬IsThereDB(MyRecord, rwai_dbds_dbd_name(i)) then
                       Do;
                         ?dsprloct direct rcdtyp(DB)
                                   dbn(rwai_dbds_dbd_name(i))
                                   rc(RCode);
                         Rfy DSPDBHRC Based(IRCRECRD);
7                        If RCode = 0 & ¬DBDFPath then do;    !@KZ30225
7                          /******************************************/
7                          /* If DB is OLR capable then may need to  */
7                          /* find both A-J & M-V DS if they exist.  */
7                          /******************************************/
7                          If dbolrcap then                   !@KZ30225
7                            doing_haldbolr = ON; !OLR ds exist@KZ30225
                           If AddRecord(MyRecord, MyStor) ¬= 0 then
                             RCode = Terminate_Error;
7                        End;                                 !@KZ30225
                         Else
                           If RCode > NOT_FOUND then
                             RCode = Terminate_Error;
                           Else
                             If ADDNoEnt(MyRecord, MyStor,
                                         rwai_dbds_name(i),
                                     rwcrnoentnotfound) ¬= 0 then
                               RCode = Terminate_error;
                             Else
                               RCode = NOT_FOUND;
                         Rfy DSPDBHRC Based;
                       End;
7                    /************************************************/
7                    /* If HALDB OLR then retrieve DBDS information  */
7                    /* for both the A-J and M-V DBDS copies. If not */
7                    /* HALDB OLR then only return the DBDS listed   */
7                    /* in the RWAI.                                 */
7                    /************************************************/
7                    If RCode = 0 then do;                    !@KZ30225
7                      Quit = OFF;                            !@KZ30225
7                      Do while(¬Quit); ! loop til time to quit@KZ30225
7                        If ¬doing_2ndolr then do;            !@KZ30225
7                          dbid_name = rwai_dbds_name(i);     !@KZ30225
7                          if ¬doing_haldbolr then            !@KZ30225
7                            Quit = ON;          ! exit loop   @KZ30225
7                        End;                                 !@KZ30225
7                        Else do;       ! get 2nd olr ds copy  @KZ30225
7                          dbid_name_ddn =                    !@KZ30225
7                            GetOLRCopy(rwai_dbds_dd_name(i));!@KZ30225
7                          Quit = ON;            ! exit loop   @KZ30225
7                        End;                                 !@KZ30225
                         ?dsprloct direct rcdtyp(DBDS)
7                                  dbid(dbid_name)            !@KZ30225
                                   rc(RCode);
                         Rfy DSPDSHRC Based(IRCRECRD);
                         If (RCode = 0) & (¬DSPDSHRC.DSHFPath) &
                               (DSPDSHRC.DSHDBORG ¬= GSAMOrg) &
                               (¬DSPDSHRC.DSHPIndx) &
7                              (¬DSPDSHRC.DSHPILE) then do;   !@KZ30225
7                          If AddRecord(MyRecord, MyStor) ¬= 0 then do;
7                            RCode = Terminate_Error;
7                            Quit = ON;                       !@KZ30225
7                          End;                               !@KZ30225
7                          Else                               !@KZ30225
7                            /****************************************/
7                            /* If retrieving OLR records and no     */
7                            /* errors then indicate at least one    */
7                            /* OLR copy was found.                  */
7                            /****************************************/
7                            If doing_haldbolr then           !@KZ30225
7                              found_olr = ON; ! OLR copy found@KZ30225
7                        End;                                 !@KZ30225
                         Else
                           If (RCode = NOT_FOUND) |
7                             (RCode = 0 & DSPDSHRC.DSHFPath) then do;
7                            /****************************************/
7                            /* If a non OLR record is not found or  */
7                            /* it's an OLR capable DB but the DBDS  */
7                            /* copies are not found, then call      */
7                            /* ADDNoEnt.                            */
7                            /****************************************/
7                            If ¬doing_haldbolr |             !@KZ30225
7                               (¬found_olr &                 !@KZ30225
7                                doing_2ndolr) then do;       !@KZ30225
7                              If ADDNoEnt(MyRecord, MyStor,  !@KZ30225
                                         rwai_dbds_name(i),
                                     rwcrnoentnotfound) ¬= 0 then
7                                RCode = Terminate_Error;     !@KZ30225
7                              Quit = ON;                     !@KZ30225
7                            End;                             !@KZ30225
7                          End;                               !@KZ30225
                           Else
7                            If (RCode = 0) &                 !@KZ30225
7                               (DSPDSHRC.DSHDBORG = GSAMOrg) then do;
                               If ADDNoEnt(MyRecord, MyStor,
                                           rwai_dbds_name(i),
7                                      rwcrnoentgsam) ¬= 0 then do;
                                 RCode = Terminate_Error;
7                                Quit = ON;                   !@KZ30225
7                              End;                           !@KZ30225
7                            End;                             !@KZ30225
                             Else
                               If ((RCode = 0) &
                                   ((DSPDSHRC.DSHPIndx) |
7                                   (DSPDSHRC.DSHPILE))) then do;
                                 If ADDNoEnt(MyRecord, MyStor,
                                             rwai_dbds_name(i),
                                         rwcrnoentpile) ¬= 0 then do;
                                   RCode = Terminate_Error;
7                                  Quit = ON;                 !@KZ30225
7                                End;                         !@KZ30225
7                              End;                           !@KZ30225
7                              Else do;                       !@KZ30225
                                 RCode = Terminate_Error;
7                                Quit = ON;                   !@KZ30225
7                              End;                           !@KZ30225
7                        If doing_haldbolr then ! doing OLR    @KZ30225
7                          doing_2ndolr = ON;   ! get 2nd OLR DSKZ30225
                         Rfy DSPDSHRC Based;
7                      End;  /* Do While(¬Quit) */            !@KZ30225
7                    End;                                     !@KZ30225
                   End;
                 when(rwai_type_dbgrp)
                   do i = 1 to rwai_num
                      While(RCode < Terminate_Error);
                     ?dsprloct direct rcdtyp(DBDSGRP)
                              grpname(rwai_dbdsgrp(i))
                              rc(RCode);
                     If RCode = 0 then
                       Do;
                         If Irclngth > grprec_lngth then
                           RCode = GetStor(MyStor,Irclngth,GrpRecPtr);
                         If RCode = 0 then
                           Do;
                             ?dspmvcl toa(GrpRecPtr)
                                      tol(Irclngth)
                                      fra(Ircrecrd)
                                      frl(Irclngth);
                             grprec_lngth = max(grprec_lngth,Irclngth);
                             rfy dspdgrc based(GrpRecPtr);
                             do k = 1 to dgdbdno
                                While(RCode < Terminate_Error);
                               call dbrec(dgdbd(k)) retcode(RCode);
                               If RCode = NOT_FOUND then
                                 If AddNoEnt(MyRecord,
                                             MyStor,
                                             dgdbds(k),
                                         rwcrnoentposarea) ¬= 0 then
                                   RCode = Terminate_error;
                                 Else;
                               If RCode > NOT_FOUND then
                                 RCode = Terminate_Error;
                             End;
                           End;
                         Else            ! GetStor Failure
                           RCode = Terminate_Error;
                       End;              ! End RC0 on Locate
                     Else
                       Do;
                         If RCode = NOT_FOUND then
                           If ADDNoEnt(MyRecord, MyStor,
                                       rwai_dbdsgrp(i),
                                   rwcrnoentnotfound) ¬= 0 then
                             RCode = Terminate_Error;
                           Else;
                         Else
                           RCode = Terminate_Error;
                       End;
                   End;
                 when(rwai_type_dbdsgrp)
                   do i = 1 to rwai_num
                      While (RCode < Terminate_Error);
                     ?dsprloct direct rcdtyp(DBDSGRP)
                              grpname(rwai_dbdsgrp_name(i))
                              rc(RCode);
                     If RCode = 0 then
                       Do;
                         ! Make sure this is a DBDS Group      @PK82881
                         If ircrecrd->dgdbdsgrp then         ! @PK82881
                           Do;                               ! @PK82881
                             If Irclngth > grprec_lngth then
                               RCode = GetStor(
                                       MyStor,Irclngth,GrpRecPtr);
                             If RCode = 0 then
                               Do;
                                 ?dspmvcl toa(GrpRecPtr)
                                          tol(Irclngth)
                                          fra(Ircrecrd)
                                          frl(Irclngth);
                                 grprec_lngth =
                                        max(grprec_lngth,Irclngth);
                                 rfy dspdgrc based(GrpRecPtr);
                                 do k = 1 to dgdbdno
                                    While (RCode < Terminate_Error);
                                   call grouprec(dgdbds(k))
                                             retcode(RCode);
                                 End;
                               End;
                           End;                              ! @PK82881
                         Else                                ! @PK82881
                           If ircrecrd->dgdbgrp then         ! @PK82881
                             Do;                             ! @PK82881
                               ! This is a DATA GROUP        ! @PK82881
                               If ADDNoEnt(MyRecord, MyStor, ! @PK82881
                                           rwai_dbdsgrp(i),  ! @PK82881
                                      rwcrnoentdbgrp) ¬= 0 then
                                 RCode = Terminate_Error;    ! @PK82881
                               Else;                         ! @PK82881
                             End;                            ! @PK82881
                           Else                              ! @PK82881
                             If ircrecrd->dgrcvgrp then      ! @PK82881
                               Do;                           ! @PK82881
                                 ! This is a RECOV Group     ! @PK82881
                                 If ADDNoEnt(MyRecord, MyStor,
                                             rwai_dbdsgrp(i),! @PK82881
                                        rwcrnoentrcvgrp) ¬= 0 then
                                   RCode = Terminate_Error;  ! @PK82881
                                 Else;                       ! @PK82881
                               End;                          ! @PK82881
                       End;                                  ! @PK82881
                     Else
                       If RCode = NOT_FOUND then
                         If ADDNoEnt(MyRecord, MyStor,
                                     rwai_dbdsgrp(i),
                                rwcrnoentnotfound) ¬= 0 then
                           RCode = Terminate_Error;
                         Else;
                       Else
                         RCode = Terminate_Error;
                   End;
                 when(rwai_type_cagrp)
                   do i = 1 to rwai_num
                      While (RCode < Terminate_Error);
                     ?dsprloct direct rcdtyp(CAGRP)
                               grpname(rwai_cagrp(i)) rc(RCode);
                     If RCode = 0 then
                       Do;
                         If Irclngth > grprec_lngth then
                           RCode = GetStor(MyStor,Irclngth,GrpRecPtr);
                         If RCode = 0 then
                           Do;
                             ?dspmvcl toa(GrpRecPtr)
                                      tol(Irclngth)
                                      fra(Ircrecrd)
                                      frl(Irclngth);
                             grprec_lngth = max(grprec_lngth,Irclngth);
                             rfy dspcagrc based(GrpRecPtr);
                             do k= 1 to cagdbdno
                                While (RCode < Terminate_Error);
                               call grouprec(cagdbds(k)) retcode(RCode);
                             End;
                             rfy dspcagrc based;
                           End;
                       End;
                     Else
                       If RCode = NOT_FOUND then
                         If AddNoent(MyRecord, MyStor,
                                     rwai_cagrp(i),
                               rwcrnoentnotfound) ¬= 0 then
                           RCode = Terminate_Error;
                         Else;
                       Else
                         RCode = Terminate_Error;
                   End;
                 when(rwai_type_rcvgrp)
                   do i = 1 to rwai_num
                      While(RCode < Terminate_Error);
                     ?dsprloct direct rcdtyp(DBDSGRP)
                              grpname(rwai_rcvgrp(i))
                              rc(RCode);
                     If ((RCode = 0) & (ircrecrd->DGRCVGRP= ON)) then
                       Do;
                         If Irclngth > grprec_lngth then
                           RCode = GetStor(MyStor,Irclngth,GrpRecPtr);
                         If RCode = 0 then
                           Do;
                             ?dspmvcl toa(GrpRecPtr)
                                      tol(Irclngth)
                                      fra(Ircrecrd)
                                      frl(Irclngth);
                             grprec_lngth = max(grprec_lngth,Irclngth);
                             rfy dspdgrc based(GrpRecPtr);
                             do k = 1 to dgdbdno
                                While(RCode < Terminate_Error);
                               If dgddn(k) = ''B then
                                 call dbrec(dgdbd(k)) retcode(RCode);
                               Else
                                 Call GroupRec(dgdbds(k))
                                              RetCode(RCode);
                               If ((RCode = NOT_FOUND) &
                                   (dgddn(k) = ''B)) then
                                 If AddNoEnt(MyRecord, MyStor,
                                       dgdbds(k),
                                       rwcrnoentposarea) ¬= 0 then
                                   RCode = Terminate_error;
                                 Else;
                               If RCode > NOT_FOUND then
                                 RCode = Terminate_Error;
                             End;
                           End;
                         Else            ! GetStor Failure
                           RCode = Terminate_Error;
                       End;              ! End RC0 on Locate
                     Else
                       If RCode = NOT_FOUND then             ! @PK82881
                         If ADDNoEnt(MyRecord, MyStor,
                                     rwai_rcvgrp(i),
                                 rwcrnoentnotfound) ¬= 0 then
                           RCode = Terminate_Error;
                         Else;
                       Else                                  ! @PK82881
                         If (Rcode = 0) then                 ! @PK82881
                           If ircrecrd->dgdbdsgrp then       ! @PK82881
                             Do;                             ! @PK82881
                               ! This is a DATA GROUP        ! @PK82881
                               If ADDNoEnt(MyRecord, MyStor,
                                           rwai_dbdsgrp(i),  ! @PK82881
                                      rwcrnoentdbdsgrp) ¬= 0 then
                                 RCode = Terminate_Error;    ! @PK82881
                               Else;                         ! @PK82881
                             End;                            ! @PK82881
                           Else                              ! @PK82881
                             If ircrecrd->dgdbgrp then       ! @PK82881
                               Do;                           ! @PK82881
                                 ! This is a RECOV Group     ! @PK82881
                                 If ADDNoEnt(MyRecord, MyStor,
                                              rwai_dbdsgrp(i),
                                        rwcrnoentdbgrp) ¬= 0 then
                                   RCode = Terminate_Error;  ! @PK82881
                                 Else;                       ! @PK82881
                               End;                          ! @PK82881
                             Else                            ! @PK82881
                               RCode = Terminate_Error;      ! @PK82881
                   End;

                 Otherwise
                   rc = RCODE48;
               End;
             End;

           Else
             If brlbdrcr then
               Do i = 1 to brlbdr2b->rwcr_num
                  while (prab_retry_ind = 0);                 ! UPPA1RS
                 Rfy rwcr based(brlbdr2b);
                 If rwcr_ff(i) then
                   Do;
                     If ¬IsThereDB(MyRecord, rwcr_dbd_name(i)) then
                       Do;
                         ?dsprloct direct rcdtyp(DB)
                                   dbn(rwcr_dbd_name(i))
                                   rc(RCode);
                         Rfy DSPDBHRC Based(IRCRECRD);
                         If (RCode = 0) then
                           If AddRecord(MyRecord, MyStor) ¬= 0 then
                             RCode = Terminate_Error;
                           Else;
                         Else
                           If RCode > NOT_FOUND then
                             RCode = Terminate_Error;
                           Else
                             If ADDNoEnt(MyRecord, MyStor,
                                         rwcr_db_name(i),
                                     rwcrnoentnotfound) ¬= 0 then
                               RCode = Terminate_error;
                             Else
                               RCode = NOT_FOUND;
                         Rfy DSPDBHRC Based;
                       End;
                     If RCode = 0 then
                       Do;
                         ?dsprloct direct rcdtyp(DBDS)
                                   dbid(rwcr_db_name(i))
                                   rc(RCode);
                         Rfy DSPDSHRC Based(IRCRECRD);
                         If (RCode = 0) then
                           If AddRecord(MyRecord, MyStor) ¬= 0 then
                             RCode = Terminate_Error;
                           Else;
                         Else
                           If (RCode = NOT_FOUND) then
                             If ADDNoEnt(MyRecord, MyStor,
                                         rwcr_db_name(i),
                                   rwcrnoentnotfound) ¬= 0 then
                               RCode = Terminate_Error;
                             Else;
                           Else
                             RCode = Terminate_Error;
                         Rfy DSPDSHRC Based;
                       End;
                   End;
                 Else
                   Do;
                     If ¬IsThereAAUTH(MyRecord,
                                      rwcr_dd_name(i)) then
                       Do;
                         ?dsprloct direct rcdtyp(DBDS)
                                   dbid(rwcr_db_name(i)) rc(RCode);
                         If (RCode = 0) &
                            (IRCRECRD->DSPDSHRC.DSHFPath) then
                           RWA_SavedAreaRecov = IRCRECRD->
                                DSPDSHRC(1:Length(RWA_SavedAreaRecov));
                         If RCode ¬= prab_retry_rc then       ! UPPA1RS
                           ?dsprloct direct rcdtyp(AAUTH)
                                     dbid(rwcr_db_name(i)) rc(RCode);
                           If RCode = 0 then
                             If AddRecord(MyRecord, MyStor) ¬= 0 then
                               RCode = Terminate_Error;
                             Else;
                           Else
                             If RCode = NOT_FOUND then
                               If ADDNoEnt(MyRecord,
                                           MyStor,
                                           rwcr_db_name(i),
                                     rwcrnoentnotfound) ¬= 0 then
                                 RCode = Terminate_Error;
                               Else;
                             Else
                               RCode = Terminate_Error;
                       End;
                   End;
                 Rfy rwcr based;
               End;
             Else
               Rcode = Terminate_Error;
           If rc = RCODE0 then
            If prab_retry_ind = 0 then  ! no retry-able error  @UPPA1RS
             call BLDLST retcode(RCode);


           /********************************************************/
           /*                                                      */
           /* Close RECON                                          */
           /*                                                      */
           /********************************************************/
           ?dsprclos rc(RCode);
           If RCode ¬= RCODE0 then     /* Error closing RECON?     */
             RC = RCODE44;             /* yes, internal DBRC error */

         End;                   ! End InitStor OK
       Else
         RC = RCODE12;

     Else
       RC = RCode44;

     If RC ¬= RCODE0 then
       Do;
         If prab_retry_ind = 0 then /* No retry-able error   @UPPA1RS*/
           Call TraceIt;
         If rqbretar¬=0 & (lenslst ¬= 0 | lenrwcr ¬= 0) then
           Do;
             Declare (Stor_Ptr, Next_Ptr) Ptr;
             /********************************************************/
             /* Ensure storage GETMAIN'd for the DB list is freed    */
             /* if a problem occurred during processing.             */
             /********************************************************/
             Do Stor_Ptr = rqbRETAR
                Repeat Next_Ptr
                While (Stor_Ptr ¬= 0);
                Next_Ptr = Stor_Ptr->RWCR_Hdr.DBRFB_Next;

                ?STORAGE (RELEASE) ADDR(Stor_Ptr->rwcr)
                     LENGTH(Stor_Ptr->RWCR_Hdr.DBRFB_Length)
                     COND(NO);
             End;

             rqbRETAR = 0;
           End;
       End;

     call ReturnBlock(MyRecord, MyStor);

   End;
 Return code(RC);


 @eject;

   DBREC: procedure(database_name);
     /****************************************************************/
     /* PROCEDURE NAME: DBREC                                        */
     /*                                                              */
     /* FUNCTION:  This routine locates a DB record and all the      */
     /*            DBDS records under the DB. All records located    */
     /*                                                              */
     /*   Return Code - 0 All OK                                     */
     /*               - 4 DB Record Not Found in RECON.              */
     /*               - 8 Error Occurred Preventing Success          */
     /****************************************************************/

     dcl database_name char(8);
     dcl doing_fastpath bit(1);
     dcl doing_partition bit(1);
     dcl quit           bit(1);
*    dcl database_end   bit(1);
     dcl 1 dbid_name char(length(Ircdbds)),
           3  dbid_name_dbd char(length(Ircdbd)),
           3  dbid_name_ddn char(length(Ircddn));
*    dcl 1 part_name char(length(Ircdbds)),
*          3  part_name_dbd char(length(Ircdbd)),
*          3  part_name_ddn char(length(Ircddn));
     dcl 1 GSAMDBD,
           3 gsamdbd_dbd char(length(Ircdbd)),
           3 gsamdbd_ddn char(length(Ircddn));

     gsamdbd_dbd = database_name;
     gsamdbd_ddn = ' ';
     doing_fastpath = OFF;
*    doing_partition = OFF;
     If ¬IsThereDB(MyRecord, dbid_name_dbd) then
       Do;
         ?dsprloct direct rcdtyp(DB) dbn(database_name) rc(RCode);
         If RCode = 0 then
           Do;
*            ! -------------------------------------------------------
*            !  Save the DB record unless it is a DLIP master DB.
*            !  If it is, the DB record for each partition will
*            !  be saved when it is retrieved.
*            ! -------------------------------------------------------
*            If ¬ircrecrd->dbddlip
              & AddRecord(MyRecord, MyStor) ¬= 0 then
               RCode = Terminate_Error;
             Else
               If Ircrecrd->dbdfpath then
                 doing_fastpath = ON;
*              Else If Ircrecrd->dbddlip then do;
*                doing_partition = ON;
*                part_name = ircrecrd->keydbds;
*              End;
           End;
         Else
           If RCode > NOT_FOUND then
             RCode = Terminate_Error;
       End;
     Else
       Doing_FastPath = ¬RWA_FF;
*  ! -----------------------------------------------------------------
*  !  This loop is performed once for a FF or FP database,
*  !  or once for each partition of a DLIP database
*  ! -----------------------------------------------------------------
*  database_end = OFF;
*  Do while (¬database_end & ¬prab_retry_ind);   /* DB loop   @UPPA1RS*/
                           /* Exit loop when retry-able error @UPPA1RS*/
*    ! ---------------------------------------------------------------
*    !  Process each partition of a DLIP DB
*    ! ---------------------------------------------------------------
*    If doing_partition then Do;
*      ?dsprloct class next rcdtyp(PART)     ! Get first/next
*                dbid(part_name) rc(RCode);  ! partition record
*      If (RCode = 0) then Do;
*        part_name = ircrecrd->keydbds;
*        dbid_name = ''b;
*        dbid_name_dbd = part_name_ddn;      ! Get partition DB name
*        ?dsprloct direct rcdtyp(DB) dbn(dbid_name) rc(RCode);
*        If RCode ¬= 0 then Do;
*/*>>>>>Activate the following code after integration with M7C>>>
*          dcl no_part_c char(  )
*                constant('No DB record for partition ')
*            , 1 No_part
*            ,   3 * char(length(no_part_c))
*            ,   3 name char(8)
*            ¢
*          no_part = no_part_c¢
*          no_part.name = dbid_name_dbd¢
*          ?dspstop diag(no_part) noabend nodump¢
*<<<<<<End of Code Bypass<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
*          RCode = Terminate_Error;
*        End;
*        Else If AddRecord(MyRecord, MyStor) ¬= 0 then
*          RCode = Terminate_Error;
*      End;
*      Else Do;
*        database_end = ON;
*        if (RCode ¬= NOT_FOUND) then
*          RCode = Terminate_Error;
*      End;
*    End;
*    ! ---------------------------------------------------------------
*    !  Process an FF or FP database
*    ! ---------------------------------------------------------------
*    Else
*      database_end = ON;
     If RCode = 0 then
       Do;                         ! DB retrieval OK
         Quit = OFF;
         Do while(¬Quit);          ! DBDS loop
*          dbid_name = Ircrecrd->keydbds;
           If doing_fastpath then
             Do;
               ?dsprloct class next rcdtyp(DBDS)
                         dbid(dbid_name) rc(RCode);
               If (RCode = 0) & (IRCRECRD->DSPDSHRC.DSHFPath) then
                 Do;
                   NoDBDS = OFF;
                   RWA_SavedAreaRecov = IRCRECRD->
                        DSPDSHRC(1:Length(RWA_SavedAreaRecov));
                   ?dsprloct class next rcdtyp(AAUTH)
                             dbid(dbid_name) rc(RCode);
                 End;
             End;
           Else
             ?dsprloct class next rcdtyp(DBDS)
                       dbid(dbid_name) rc(RCode);
*          If (RCode ¬= 0) | (Ircrecrd->keydbd ¬= dbid_name_dbd) then
             Do;
               Quit = ON;
               If RCode > NOT_FOUND then
                 RCode = Terminate_Error;
               Else
                 RCode = 0;
             End;
           Else
*           Do;
              NoDBDS = OFF;
              ! Check for GSAM first
              If Ircrecrd->dspdshrc.dshdborg = GSAMOrg then
                Do;
                  Quit = ON;
                  If (rwai_type = rwai_type_database) then
                    If ADDNoEnt(MyRecord, MyStor, GSAMDBD,
                            rwcrnoentgsam) ¬= 0 then
                      Do;
                        Quit = ON;
                        RCode = Terminate_Error;
                      End;
                    Else;
                  Else;
                End;
              Else
*              ! --------------------------------------------------
*              !  Save the DBDS record unless a DLIP index or ILE
*              ! ----------------------------------------------------
*              If (¬Ircrecrd->dspdshrc.dshpile
*                 &¬Ircrecrd->dspdshrc.dshpindx) then
*                If (AddRecord(MyRecord, MyStor)) ¬= 0 then
                   Do;
                     Quit = ON;
                     RCode = Terminate_Error;
                   End;
*                Else;
*           End;
         End;                     !  DBDS loop
       End;                       ! DB retrieval OK
*      Else If (RCode = NOT_FOUND & doing_partition) then
*        RCode = 0;
*    End;                         ! DB loop

     Return Code(RCode);

   End  DBREC;


 @eject;
   GROUPREC: procedure(grpname);
     /****************************************************************/
     /* PROCEDURE NAME: GROUPREC                                     */
     /*                                                              */
     /* FUNCTION:  This routine is called to add a member from a     */
     /*            group to the chain.                               */
     /****************************************************************/
7    dcl Quit           bit(1);       ! quit loop              @KZ30225
7    dcl doing_haldbolr bit(1);       ! HALDB OLR db           @KZ30225
7    dcl doing_2ndolr   bit(1);       ! 2nd OLR copy           @KZ30225
7    dcl found_olr      bit(1);       ! indicate if copy found @KZ30225
     dcl 1 Grpname,
           3 gdbpart char(8),
           3 gddnpart char(8);

7    dcl 1 dbid_name char(length(Ircdbds)),                   !@KZ30225
7          3  dbid_name_dbd char(length(Ircdbd)),             !@KZ30225
7          3  dbid_name_ddn char(length(Ircddn));             !@KZ30225

     RCode = 0;
7    Quit           = OFF;                                    !@KZ30225
7    doing_haldbolr = OFF;                                    !@KZ30225
7    doing_2ndolr   = OFF;                                    !@KZ30225
7    found_olr      = OFF;                                    !@KZ30225
     If ¬IsThereDB(MyRecord, gdbpart) then
       Do;
         ?dsprloct direct rcdtyp(DB) dbn(gdbpart) rc(RCode);
7        If RCode = 0 then do;                                !@KZ30225
7          /**********************************************************/
7          /* If DB is OLR capable then may need to find both A-J &  */
7          /* M-V DS if they exist.                                  */
7          /**********************************************************/
7          If IRCRECRD->dbolrcap then           ! OLR capable  @KZ30225
7            doing_haldbolr = ON;               ! HALDB PartDB @KZ30225
           If AddRecord(MyRecord, MyStor) ¬= 0 then
             RCode = Terminate_Error;
7        End;                                                 !@KZ30225
         Else
           If RCode > NOT_FOUND then
             RCode = Terminate_Error;
       End;
7    /****************************************************************/
7    /* If HALDB OLR then retrieve DBDS information for both the     */
7    /* A-J and M-V DBDS copies. If not HALDB OLR then only return   */
7    /* DBDS that was passed to this procedure (GRPNAME).            */
7    /****************************************************************/
7    If RCode = 0 then do;                                    !@KZ30225
7      Do While(¬Quit);             ! loop until time to quit  @KZ30225
7        If RWA_DBPtr->RWA_FF then do;                        !@KZ30225
7          If ¬doing_2ndolr then do;! if not on then normal    @KZ30225
7            dbid_name = Grpname;   !  processing              @KZ30225
7            if ¬doing_haldbolr then! If not OLR cap then done @KZ30225
7              Quit = ON;           ! exit loop                @KZ30225
7          End;                                               !@KZ30225
7          Else do;                 ! get 2nd olr ds copy      @KZ30225
7            dbid_name_ddn =                                  !@KZ30225
7                GetOLRCopy(gddnpart);                        !@KZ30225
7            Quit = ON;             ! exit loop                @KZ30225
7          End;                                               !@KZ30225
7          ?dsprloct direct rcdtyp(DBDS) dbid(dbid_name) rc(RCode);
7        End;                                                 !@KZ30225
         Else
           Do;
             ?dsprloct direct rcdtyp(DBDS) dbid(Grpname) rc(RCode);
             If RCode = 0 then
               RWA_SavedAreaRecov = IRCRECRD->
                      DSPDSHRC(1:Length(RWA_SavedAreaRecov));
             If Rcode ¬= prab_retry_rc then                   !@UPPA1RS
               ?dsprloct direct rcdtyp(AAUTH) dbid(Grpname) rc(RCode);
7            Quit = ON;                                       !@KZ30225
           End;
7        If (RCode = 0) &                                     !@KZ30225
7           (¬IRCRECRD->DSPDSHRC.DSHPIndx) &                  !@KZ30225
7           (¬IRCRECRD->DSPDSHRC.DSHPILE) then do;            !@KZ30225
7          If AddRecord(MyRecord, MyStor) ¬= 0 then do;       !@KZ30225
             RCode = Terminate_Error;
7            Quit = ON;                                       !@KZ30225
7          End;                                               !@KZ30225
7          Else                                               !@KZ30225
7            /********************************************************/
7            /* If retrieving OLR records and no errors then         */
7            /* indicate at least one OLR copy was found.            */
7            /********************************************************/
7            If doing_haldbolr then                           !@KZ30225
7              found_olr = ON;      ! OLR copy found          !@KZ30225
7        End;                                                 !@KZ30225
7        Else do;                                             !@KZ30225
7          If RCode > NOT_FOUND then do;                      !@KZ30225
             RCode = Terminate_Error;
7            Quit = ON;                                       !@KZ30225
7          End;                                               !@KZ30225
7          Else                                               !@KZ30225
7            If RCode = NOT_FOUND & ! not found                @KZ30225
7               doing_2ndolr &      ! done prcessing 2nd copy  @KZ30225
7               found_olr then      ! found at least one copy  @KZ30225
7              RCode = 0;                                     !@KZ30225
7        End;                                                 !@KZ30225
7        If doing_haldbolr then     ! doing OLR                @KZ30225
7          doing_2ndolr = ON;       ! get 2nd OLR DS           @KZ30225
7      End;  /* Do While(¬Quit) */                            !@KZ30225
7    End;                                                     !@KZ30225
     return code(RCode);

   End  GROUPREC;


 @eject;
   BLDLST: procedure;
     /****************************************************************/
     /* PROCEDURE NAME: BLDLST                                       */
     /*                                                              */
     /* FUNCTION:  This routine builds the parameter list that       */
     /*            is returned to IMS using the rqbRETAR interface.  */
     /****************************************************************/

     dcl ssidlst_ptr ptr ScopeInitial(0);
     dcl noentlst_ptr ptr ScopeInitial(0);
     dcl (RecordCtr, SSIDCtr) fixed;
2    dcl maxarea fixed constant(255);
     !
     ! Do necessary initialization
     !
     RCode = RCode0;

     lenslst = 0;
     If RWA_NumOfSSIDs ¬= 0 & rwai_cmd_add = ON then
       lenslst = length(rwcr_ssid_fixed) +
                 (RWA_NumOfSSIDs * length(rwcr_ssids));
     lenrwcr = length(rwcr_fixed) +
               (RWA_NumOfDBDSs * length(rwcr_entry));
     If RWA_NumOfNoent ¬= 0 then
       lennoent = length(rwcr_noent_fixed) +
                  (RWA_NumOfNoent * length(rwcr_noent_list));
     Else
       lennoent = 0;

     If ((GetStor
         (MyStor,lenrwcr,rqbRETAR,*,*,StorDoNotFree)) = 0) &
     ((lenslst = 0) | (GetStor
         (MyStor,lenslst,ssidlst_ptr,*,*,StorDoNotFree)) = 0) &
     ((lennoent = 0) | (GetStor
         (MyStor,lennoent,noentlst_ptr,*,*,StorDoNotFree)) = 0) then
       Do;

         rfy rwcr based(rqbretar);

         ! Fill in RWCR_FIXED
         rwcr_hdr.dbrfb_length = lenrwcr;
         rwcr_hdr.dbrfb_subpool = 0;
         rwcr_hdr.dbrfb_next = 0;
         rwcr_hdr.dbrfb_eyecatcher = rwcreyec;
         rwcr_num = RWA_NumOfDBDSs;
6        rwcr_dbrcrel = gdbcurr;         ! save dbrc rel level @KZ10111

         rfy rwcr_ssidlst based(ssidlst_ptr);
         if RWA_NumOfSSIDs ¬= 0 & rwai_cmd_add = ON then
           Do;
             rwcr_hdr.dbrfb_next = ssidlst_ptr;
             ! Fill in SSID_FIXED
             rwcr_ssid_hdr.dbrfb_length = lenslst;
             rwcr_ssid_hdr.dbrfb_subpool = 0;
             rwcr_ssid_hdr.dbrfb_next = 0;
             rwcr_ssid_hdr.dbrfb_eyecatcher = ssidlsteyec;
             rwcr_ssid_num = RWA_NumOfSSIDs;
           End;

         rfy rwcr_noent based(noentlst_ptr);
         if lennoent ¬= 0 then
           Do;
             if ssidlst_ptr = 0 then
               rwcr_hdr.dbrfb_next = noentlst_ptr;
             else
               rwcr_ssid_hdr.dbrfb_next = noentlst_ptr;
             ! Fill in NOENT_FIXED
             rwcr_noent_hdr.dbrfb_length = lennoent;
             rwcr_noent_hdr.dbrfb_subpool = 0;
             rwcr_noent_hdr.dbrfb_next = 0;
             rwcr_noent_hdr.dbrfb_eyecatcher = noenteyec;
             rwcr_noent_num = RWA_NumOfNoent;
           End;

         RecordCtr = 0;
         SSIDCtr = 0;
         do RWA_RecordPtr = RWA_FirstDBDS
                            repeat RWA_Next_Of_Type
                            while(RWA_RecordPtr ¬= 0);
           RecordCtr = RecordCtr + 1;
           rwcr_dbd_name(RecordCtr) = RWA_DBDName;
           rwcr_dd_name(RecordCtr) = RWA_DDName;
           rwcr_alloc_ddname(RecordCtr) = RWA_ADDN;
           rwcr_dsname(RecordCtr) = RWA_DSName;
           rwcr_ff(RecordCtr) = RWA_FF;
8          rwcr_part(RecordCtr) = RWA_Part;   ! DB partition   @PQ85442
           rwcr_dbordbds(RecordCtr) = RWA_dbordbds;          ! @PK09734
           rwcr_dbmvdbds(RecordCtr) = RWA_dbmvdbds;          ! @PK09734
2          if RWA_DSID > MAXAREA then
2              rwcr_dsid(RecordCtr) = MAXAREA;
2          else
2              rwcr_dsid(RecordCtr) = RWA_DSID;
2          rwcr_v8_dsid(RecordCtr) = RWA_DSID;
           rwcr_dsorg(RecordCtr) = RWA_DSORG;
           rwcr_dborg(RecordCtr) = RWA_DBORG;
5          /**********************************************************/
5          /* Situations may exist where a RECON data set contains a */
5          /*  FP Area that does not indicate DSHDSORG=DSHVSAM. This */
5          /*  was caused by an old bug that was fixed before IMS    */
5          /*  V3R1 however, old RECONS may still contain this flaw. */
5          /* This check will ensure that if the data set is FP then */
5          /*  RWCR_VSAM gets turned on.                             */
5          /**********************************************************/
5          if ¬RWA_FF then               ! if Fast Path        @PQ77787
5            rwcr_vsam(RecordCtr) = ON;  !  turn it on manually@PQ77787
           rwcr_MADS(RecordCtr) = RWA_MADS;
           rwcr_non_recoverable(RecordCtr) = RWA_NR;
7          rwcr_olr(RecordCtr) = RWA_OLR;         ! HALDB OLR dsKZ30225
           rwcr_first_ssid(RecordCtr) = 0;
           rwcr_last_ssid(RecordCtr) = 0;
           If RWA_NumberOfSSIDs ¬= 0 & rwai_cmd_add = ON then
             do;
               rwcr_first_ssid(RecordCtr) = SSIDCtr + 1;

               rwcr_authorized(RecordCtr) = ON;
               do k = 1 to RWA_NumberOfSSIDs;
                 rwcr_ssids(SSIDCtr+1) = RWA_SSIDs(k);
                 SSIDCtr = SSIDCtr + 1;
               End;
               rwcr_last_ssid(RecordCtr) = SSIDCtr;
             End;
         End;
         do RWA_RecordPtr = RWA_FirstAAUTH
                            repeat RWA_Next_Of_Type
                            while(RWA_RecordPtr ¬= 0);
           RecordCtr = RecordCtr + 1;
           rwcr_dbd_name(RecordCtr) = RWA_DBDName;
           rwcr_dd_name(RecordCtr) = RWA_DDName;
           rwcr_alloc_ddname(RecordCtr) = RWA_ADDN;
           rwcr_dsname(RecordCtr) = RWA_DSName;
2          if RWA_DSID > MAXAREA then
2              rwcr_dsid(RecordCtr) = MAXAREA;
2          else
2              rwcr_dsid(RecordCtr) = RWA_DSID;
2          rwcr_v8_dsid(RecordCtr) = RWA_DSID;
           rwcr_dsorg(RecordCtr) = RWA_DSORG;
           rwcr_dborg(RecordCtr) = RWA_DBORG;
           rwcr_ff(RecordCtr) = RWA_FF;
8          rwcr_part(RecordCtr) = RWA_Part;   ! DB partition   @PQ85442
5          /**********************************************************/
5          /* Situations may exist where a RECON data set contains a */
5          /*  FP Area that does not indicate DSHDSORG=DSHVSAM. This */
5          /*  was caused by an old bug that was fixed before IMS    */
5          /*  V3R1 however, old RECONS may still contain this flaw. */
5          /* While looping through the AAUTH chain (all FP), ensure */
5          /*  that RWCR_VSAM gets turned on.                        */
5          /**********************************************************/
5          rwcr_vsam(RecordCtr) = ON;    ! Turn it on manually @PQ77787
           rwcr_MADS(RecordCtr) = RWA_MADS;
           rwcr_non_recoverable(RecordCtr) = RWA_NR;
           rwcr_first_ssid(RecordCtr) = 0;
           rwcr_last_ssid(RecordCtr) = 0;
           If RWA_NumberOfSSIDs ¬= 0 & rwai_cmd_add = ON then
             do;
               rwcr_first_ssid(RecordCtr) = SSIDCtr + 1;
               rwcr_authorized(RecordCtr) = ON;
               do k = 1 to RWA_NumberOfSSIDs;
                 rwcr_ssids(SSIDCtr+1) = RWA_SSIDs(k);
                 SSIDCtr = SSIDCtr + 1;
               End;
               rwcr_last_ssid(RecordCtr) = SSIDCtr;
             End;
         End;
         !
         ! If there are any No Entries
         !
         Noentctr = 0;
         If lennoent ¬= 0 then
           Do RWA_RecordPtr = RWA_First_Noent
                              repeat RWA_Next_Of_Type
                              while(RWA_RecordPtr ¬= 0);
             Noentctr = Noentctr + 1;
             If RWA_Status ¬= rwcrnoentposarea then
               rwcr_noent_name(Noentctr) = RWA_DBID;
             Else
               rwcr_noent_name2(Noentctr) = RWA_DBDNAME;
             rwcr_noent_status(Noentctr) = RWA_Status;
           End;
       End;
     Else                         ! Could not obtain storage
       RCode = RCode12;
     return code(RCode);
   End  BLDLST;

 @eject;

  !
  ! AddRecord Procedure:
  !
  !    This method builds a Record_Blk and adds it to the Record
  !    chain. Further, a separate chain is maintained each for DB,
  !    DBDS and Area Auth records. Information is obtained from the
  !    RECON record pointed to by IRCRECRD (the currently located
  !    RECON record).
  !
  !   Return Code:   0  - All OK
  !                  4  - GetARecord Failure
  !                  8  - DBDS Record To Be Added, No DB Exists
  !                 12  - Called With Invalid Record Type
  !

  AddRecord: Procedure(AddRcd, AddStor) Class(Record)
                     Returns(Fixed);


    Declare AddRcd IsA(Record);
    Declare AddStor IsA(StorMan);
    Declare AddRCode Fixed;

    Declare Found Bit(1);
    Declare TempDBRecPtr Ptr;
    Declare AddRecCtr Fixed;

    Declare Size_Needed Fixed;

    Declare ADD_GetAREC_Bad   Fixed Constant(4);
    Declare ADD_NoDBRec       Fixed Constant(8);
    Declare ADD_InvldRec      Fixed Constant(12);

    Rfy DSPKEYRC based(Ircrecrd);
    Rfy DSPDSHRC Based(Ircrecrd);
    Rfy DSPDBHRC Based(Ircrecrd);


    AddRCode = 0;

    !----------------------------------------------------------@PK37513
    ! The AddRecord method is changed in support of the OUTPUT(ICRCA)
    ! option. When ICRCA is specified, the recovery list member must
    ! belong to a CA group. If a DBDS record is being added and
    ! ICRCA has been specified, the DBDS is added to the NOENT list
    ! instead if it does not belong to a CA group.
    !----------------------------------------------------------@PK37513
    If (rwai_cmd_rcvtoica) &                                  !@PK37513
       (
        (keyrtype = RCDDBDS & DSPDSHRC.DSHGRPNM = ''B) |
        (keyrtype = RCDAAUTH & RWA_SavedAreaRecov.DSHGRPNM = ''B)
        )  then
      If ADDNoEnt(AddRcd,                                     !@PK37513
                  AddStor,                                    !@PK37513
                  DSHDBDS,                                    !@PK37513
                  rwcrnoenticrca) ¬= 0 then                   !@PK37513
        AddRCode = Terminate_Error;                           !@PK37513
      Else;                                                   !@PK37513
    Else                                                      !@PK37513
      Do;             ! Not rwai_cmd_rcvtioca                  @PK37513

    ! If this is a DB, DBDS or AAUTH record, check to see if it is
    ! already on the chain. This is possible because a DBDS/AREA
    ! can belong to more than one group, except for CA groups.

    Found = OFF;
    ! If DB record, search DB chain
    If keyrtype = RCDDB then
      RWA_RecordPtr = Record.RWA_FirstDB;
    Else
      ! If DBDS record, search DBDS chain
      If keyrtype = RCDDBDS then
        RWA_RecordPtr = Record.RWA_FirstDBDS;
      Else
        ! Must be AAUTH record, search AAUTH chain
        RWA_RecordPtr = Record.RWA_FirstAAUTH;

    ! Now search the chain to see if the record is already there.

    Do RWA_RecordPtr = RWA_RecordPtr
                       Repeat Record.RWA_Next_Of_Type
                       While ((RWA_RecordPtr ¬= 0) &
                              (Found = OFF));
      If keydbd = Record.RWA_DBDName then
        If keyrtype = RCDDB then
          Found = ON;       ! DB rcd and matches one on chain
        Else                ! Must be a DBDS or AAUTH record
          If keyddn = Record.RWA_DDName then
            Found = ON;     ! DBDS/AAUTH and a match
          Else;             ! DDN does not match
      Else;                 ! DBD does not match
    End;

    If ¬Found then
      Do;
        ! This is a new record and needs to be added to the chain.
        ! First, determine the size that is needed which varies
        ! by whether the DB/AAUTH is authorized and to how many
        ! SSIDs. For a DB or AAUTH record, the number of SSIDs is
        ! taken from the RECON record. For a DBDS, we search the
        ! chain for the DB record (it must already exist) to find
        ! the number of SSIDs.
        TempDBRecPtr = 0;         ! This will point to the DB if needed
        Size_Needed = 0;
        If keyrtype = RCDDB | keyrtype = RCDAAUTH then
          Do;
            Size_Needed = OFFSET(Record.RWA_SSIDs) +
                          DBSSNUM * Length(Record.RWA_SSIDs);
          End;
        ! If this is a DBDS record, ensure the DB record is
        ! on the chain and use it to find the number of SSIDs.
        If keyrtype = RCDDBDS then
          Do;
            ! Search the DB chain for the matching DB record.
            Do RWA_RecordPtr = Record.RWA_FirstDB
                               Repeat Record.RWA_Next_Of_Type
                               While(keydbd ¬= Record.RWA_DBDName);
            End;
            If RWA_RecordPtr ¬= 0 then
              Do;
                ! Matching DB record was found. Use it to determine
                ! the size needed, and save the pointer to the DB
                ! for later use.
                Size_Needed = OFFSET(Record.RWA_SSIDs) +
                             (Record.RWA_NumberOfSSIDs *
                              Length(Record.RWA_SSIDs));
                TempDBRecPtr = RWA_RecordPtr;
              End;
            Else
              ADDRCode = ADD_NoDBRec;
          End;

        If Size_Needed ¬= 0 then
          If GetARecord(AddRcd, AddStor, Size_Needed) = 0 then
            ! Record.RWA_RecordPtr now points at the record
            ! obtained.
            Do;
              ! Finally, build the record
              If Record.RWA_FirstRec = 0 then
                Record.RWA_FirstRec = Record.RWA_RecordPtr;
              If Record.RWA_LastRec ¬= 0 then
                Record.RWA_LastRec->Record.RWA_Next_Record =
                                               Record.RWA_RecordPtr;
              Record.RWA_LastRec = Record.RWA_RecordPtr;
              RWA_Next_Record = 0;
              RWA_Type = keyrtype;
              Select(Keyrtype);
                When(RCDDB)
                  Do;
                    If RWA_FirstDB = 0 then
                      RWA_FirstDB = RWA_RecordPtr;
                    If RWA_LastDB ¬= 0 then
                      RWA_LastDB->RWA_Next_of_Type = RWA_RecordPtr;
                    RWA_LastDB = RWA_RecordPtr;
                    RWA_DBPtr  = RWA_RecordPtr;
                    RWA_DBDName = DBDBD;
                    RWA_NumberOfSSIDs = DBSSNUM;
                    If RWA_NumberOfSSIDs ¬= 0 then
                      Do;
                        RWA_Authed = '1'B;
                        Do AddRecCtr = 1 to RWA_NumberOfSSIDs;
                          RWA_SSIDs(AddRecCtr) = DBSSNAME(AddRecCtr);
                        End;
                      End;
7                   RWA_OLR = dbolrcap;                       !@KZ30225
                    RWA_dbordbds = dbordbds;                  !@PK09734
                    RWA_dbmvdbds = dbmvdbds;                  !@PK09734
                    If dbdfpath then
                      RWA_FF = '0'B;
                    Else
                      RWA_FF = '1'B;
                  End;
                When(RCDAAUTH)
                  Do;
                    If RWA_FirstAAUTH = 0 then
                      RWA_FirstAAUTH = RWA_RecordPtr;
                    If RWA_LastAAUTH ¬= 0 then
                      RWA_LastAAUTH->RWA_Next_of_Type = RWA_RecordPtr;
                    RWA_LastAAUTH = RWA_RecordPtr;
                    RWA_DBDName = DBDBD;
                    RWA_DDName = DBAREA;
                    If RWA_SavedAreaRecov.DSHNOADS = 0 then
                      Do;
                        RWA_NoADS = '1'B;
                        RWA_ADDN = ' ';
                        RWA_DSName = ' ';
                      End;
                    Else do;                                  !@PK19909
                      /***********************************************/
                      /* Search for 1st available ADS entry.         */
                      /* If there is none then use 1st in the list.  */
                      /***********************************************/
                      RWA_ADDN   = RWA_SavedAreaRecov.DSHADSDD(1);
                      RWA_DSName = RWA_SavedAreaRecov.DSHADSDN(1);
                      If RWA_SavedAreaRecov.DSHAVADS ¬= 0 then do;
                        Do i = 1 to RWA_SavedAreaRecov.DSHNOADS
                           Until(RWA_SavedAreaRecov.DSHADSAV(i));
                          If RWA_SavedAreaRecov.DSHADSAV(i) then do;
                            RWA_ADDN =                        !@PK19909
                              RWA_SavedAreaRecov.DSHADSDD(i); !@PK19909
                            RWA_DSName =                      !@PK19909
                              RWA_SavedAreaRecov.DSHADSDN(i); !@PK19909
                          End;                                !@PK19909
                        End;                                  !@PK19909
                      End;                                    !@PK19909
                    End;
                    RWA_NumberOfSSIDs = DBSSNUM;
                    RWA_NumOfDBDSs = RWA_NumOfDBDSs + 1;
                    If RWA_NumberOfSSIDs ¬= 0 then
                      Do;
                        RWA_NumOfSSIDs = RWA_NumOfSSIDS +
                                         RWA_NumberOfSSIDs;
                        RWA_Authed = '1'B;
                        Do AddRecCtr = 1 to RWA_NumberOfSSIDs;
                          RWA_SSIDs(AddRecCtr) = DBSSNAME(AddRecCtr);
                        End;
                      End;
                    RWA_FF = '0'B;
8                   RWA_Part = OFF;           ! DB partition   @PQ85442
                    RWA_dbordbds = OFF;       ! default        @PK09734
                    RWA_dbmvdbds = OFF;       ! no M-V DBDS    @PK09734
                    RWA_DSID = RWA_SavedAreaRecov.DSHDSID;
                    RWA_DSORG = RWA_SavedAreaRecov.DSHDSORG;
                    RWA_DBORG = RWA_SavedAreaRecov.DSHDBORG;
                  End;
                When(RCDDBDS)
                  Do;
                    If RWA_FirstDBDS = 0 then
                      RWA_FirstDBDS = RWA_RecordPtr;
                    If RWA_LastDBDS ¬= 0 then
                      RWA_LastDBDS->RWA_Next_of_Type = RWA_RecordPtr;
                    RWA_LastDBDS = RWA_RecordPtr;
                    RWA_DBDName = DSHDBD;
                    RWA_DDName = DSHDDN;
                    RWA_DSName = DSPDSHRC.DSHDSN;
                    RWA_ADDN = DSHDDN;
                    RWA_DBRec_Ptr = TempDBRecPtr;
                    RWA_NumberOfSSIDs = TempDBRecPtr->
                                            RWA_NumberOfSSIDs;
                    RWA_NumOfDBDSs = RWA_NumOfDBDSs + 1;
                    If RWA_NumberOfSSIDs ¬= 0 then
                      Do;
                        RWA_NumOfSSIDs = RWA_NumOfSSIDS +
                                         RWA_NumberOfSSIDs;
                        RWA_Authed = '1'B;
                        Do AddRecCtr = 1 to RWA_NumberOfSSIDs;
                          RWA_SSIDs(AddRecCtr) = TempDBRecPtr->
                                                 RWA_SSIDs(AddRecCtr);
                        End;
                      End;
                    RWA_FF = '1'B;
7                   RWA_OLR = TempDBRecPtr->RWA_OLR; ! OLR DS? @KZ30225
                    ! Set active DBDSs and if M-V DBDSs exist from
                    ! the partition db record                  @PK09734
                    RWA_DBORDBDS = TempDBRecPtr->RWA_DBORDBDS;!@PK09734
                    RWA_DBMVDBDS = TempDBRecPtr->RWA_DBMVDBDS;!@PK09734
8                   RWA_Part = DSPDSHRC.DSHPart; ! DB partition@PQ85442
                    RWA_DSID = DSPDSHRC.DSHDSID;
                    RWA_DSORG = DSPDSHRC.DSHDSORG;
                    RWA_DBORG = DSPDSHRC.DSHDBORG;
                  End;
                Otherwise
                  ! At this point the RECON record is neither a
                  ! DB, DBDS or AAUTH. That situation is detected
                  ! earlier, however because Size_Needed would
                  ! have remained at 0, so the code should never
                  ! get here. Set a unique error code here and
                  ! return.
                  AddRCode = Add_InvldRec;
                End;              ! End Select Group
              End;
            Else
              ! This point is reached when RWA_BlkPtr is 0 meaning
              ! no available block could be had. This should only
              ! occur if we have used up all available storage. Set
              ! an error code and return.
              AddRCode = Add_GetAREC_Bad;
        Else
          ! At this point, either the DB record was not found on
          ! the chain, or we are trying to add a block for a record
          ! that is not a DB, DBDS or AAUTH. Both situations are
          ! detected by Size_Needed remaining at 0 and both should
          ! not occur. Set an error code and return.
          AddRCode = Add_NoDBRec; ! No DB Record on Chain
      End;
    Else;                         ! Record Already On Chain

    RWA_AddRecordLastReturnCode = AddRCode;

    End;             ! End not rwai_cmd_rcvtioca               @PK37513

    Return(AddRCode);

    Rfy DSPKEYRC Based;
    Rfy DSPDSHRC Based;
    Rfy DSPDBHRC Based;

  End AddRecord;

 @eject;

  !
  ! AddNoEnt Procedure:
  !
  !    This method builds a Record_Blk for command parts which
  !    do not exist. The Record_Blk is added to the chain, and
  !    also added to the NoEnt chain.
  !
  !   Return Code:   0  - All OK
  !                  4  - GetARecord Failure
  !

  AddNoEnt: Procedure(ANERcd, ANEStor, ANEName, ANEStat) Class(Record)
                    Returns(Fixed);


    Declare ANERcd IsA(Record);
    Declare ANEStor IsA(StorMan);
    Declare 1  ANEName,
              3 ANEdbd Char(Length(RWA_DBDName)),
              3 ANEddn Char(Length(RWA_DDName));
    Declare ANEStat Fixed(8);
    Declare ANERCode Fixed;

    Declare ANEFound Bit(1);

    Declare ANE_GetAREC_Bad  Fixed Constant(4);

    ANERCode = 0;

    ANEFound = OFF;
    ! Now search the chain to see if the record is already there.

    Do RWA_RecordPtr = RWA_First_NoEnt
                       Repeat Record.RWA_Next_Of_Type
                       While ((RWA_RecordPtr ¬= 0) &
                              (ANEFound = OFF));
      If ANEName = Record.RWA_DBID then
        ANEFound = ON;      ! Match
      Else;                 ! No match
    End;

    If ¬ANEFound then
      If GetARecord(ANERcd, ANEStor, Offset(RWA_SSIDs)) = 0 then
        ! Record.RWA_RecordPtr now points at the record
        ! obtained.
        Do;
          ! Finally, build the record
          If Record.RWA_FirstRec = 0 then
            Record.RWA_FirstRec = Record.RWA_RecordPtr;
          If Record.RWA_LastRec ¬= 0 then
            Record.RWA_LastRec->Record.RWA_Next_Record =
                                           Record.RWA_RecordPtr;
          Record.RWA_LastRec = Record.RWA_RecordPtr;
          RWA_Next_Record = 0;
          RWA_Type = 0;
          If RWA_First_Noent = 0 then
            RWA_First_Noent = RWA_RecordPtr;
          If RWA_Last_Noent ¬= 0 then
            RWA_Last_Noent->RWA_Next_of_Type = RWA_RecordPtr;
          RWA_Last_Noent = RWA_RecordPtr;
          RWA_DBID = ANEName;
          RWA_NumOfNoent = RWA_NumOfNoent + 1;
          RWA_Status = ANEStat;
        End;
      Else                        ! Could not get a record
        ANERCode = ANE_GetAREC_Bad;
    Else;                         ! Record Already On Chain

    RWA_AddNoEntLastReturnCode = ANERCode;
    Return(ANERCode);

  End AddNoEnt;

 @eject;

  !
  ! TraceIt Procedure:
  !
  !    This subroutine creates a DBRC trace record. It is called
  !    whenever a return to IMS is made with a non-zero return
  !    code.
  !
  !

  TraceIt: Procedure   Class(Record);


    Declare 1 Trace_Area,
              3 Trace_Word(16) Char(4);
    Declare TraceParms CHAR(LENGTH(DTRPARMS)) BDY(Word);

    Rfy DTRPARMS Based(ADDR(TraceParms));

    Trace_Word(1) = RWA_InitBlockLastReturnCode;
    Trace_Word(2) = RWA_AddRecordLastReturnCode;
    Trace_Word(3) = RWA_AddNoEntLastReturnCode;
    Trace_Word(4) = RWA_GetARecordLastReturnCode;






    ?DTRACE ID('RWA00-01')
            PARM(DTRPARMS)
            EXPAND(YES)
            AREA(ADDR(Trace_Area))
            BLOCK(ADDR(DFSBRLSB));
    Return Code(0);
    Rfy DTRPARMS Based;

  End TraceIt;

 @eject;

 Open_RECON: Procedure Returns(Fixed);

   Declare Open_RCode Fixed;

   ?DSPROPEN RC(Open_RCode);
   Return(Open_RCode);

 End  Open_RECON;

7@eject;                                                      !@KZ30225
7 /*******************************************************************/
7 /* PROCEDURE NAME: GetOLRCopy                                      */
7 /*                                                                 */
7 /* FUNCTION:  This routine is called for an OLR data set (A-J      */
7 /*            or M-V) and returns the partner data set DDN         */
7 /*            (opposite DDN suffix).                               */
7 /*                                                                 */
7 /* Input:     DDN of original OLR data set.                        */
7 /* Output:    DDN of partner OLR data set.                         */
7 /*******************************************************************/
7 GetOLRCopy: Procedure(FirstDDN) Returns(char(8));           !@KZ30225
7   Dcl FirstDDN char(8);                 ! original DDN       @KZ30225
7   Dcl CopyDDN  char(8);                 ! OLR copy DDN       @KZ30225
7   Dcl i        fixed;                                       !@KZ30225
7   Dcl lastchar fixed;                   ! last char of DDN   @KZ30225
7   Dcl maxsuf   fixed constant(10);                          !@KZ30225

7   Dcl AJsuffix(maxsuf) char(1) static local                 !@KZ30225
7           Initial('A','B','C','D','E','F','G','H','I','J'); !@KZ30225
7   Dcl MVsuffix(maxsuf) char(1) static local                 !@KZ30225
7           Initial('M','N','O','P','Q','R','S','T','U','V'); !@KZ30225

7   CopyDDN = FirstDDN;                   ! initialize OLR copy@KZ30225
7   Do lastchar = 8 to 1 by -1            ! find last character@KZ30225
7      while(FirstDDN(lastchar) = '');                        !@KZ30225
7   End;                                                      !@KZ30225
7   Do i = 1 to maxsuf                    ! see if A-J copy    @KZ30225
7      while(FirstDDN(lastchar) ¬= AJsuffix(i));              !@KZ30225
7   End;                                                      !@KZ30225
7   If i <= maxsuf then                   ! If A-J copy then   @KZ30225
7     CopyDDN(lastchar) = MVsuffix(i);    !  use M-V suffix    @KZ30225
7   Else do;                              ! If not A-J copy    @KZ30225
7     Do i = 1 to maxsuf                  !  then M-V copy     @KZ30225
7        while(FirstDDN(lastchar) ¬= MVsuffix(i));            !@KZ30225
7     End;                                                    !@KZ30225
7     CopyDDN(lastchar) = AJsuffix(i);    ! use A-J suffix     @KZ30225
7   End;                                                      !@KZ30225

7   Return(CopyDDN);                                          !@KZ30225
7 End  GetOLRCopy;                                            !@KZ30225

 @eject;

 ?epilog;
 End DSPRWA00;