 /*********************************************************************/
 /*  MKQ0418  Modulkurzbezeichnung                                    */
 /*                                                                   */
 /*   PROJEKT:               KOMPASS-KFZ                              */
 /*                                                                   */
 /*   UNTERPROJEKT:          ZUGRIFF AUF GRUNDLAGENTABELLEN           */
 /*                                                                   */
 /*   PROGRAMMIERER:         R. Hingkeldey                            */
 /*                                                                   */
 /*   ERSTELLUNGSDATUM:      25.03.1996                               */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /*   PGM-FUNKTION:                                                   */
 /*                                                                   */
 /*   Das Modul MKQ0418 dient zum Lesen des Faktors fuer die Regional-*/
 /*   klasse zur neuen Tarifierung aus der Tabelle TBKF_REG_KL_FAKT.  */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*   18.11.1996   Tuning des SQL-Zugriffs mit Hilfe der Decimal-Da-  */
 /*   HINGKELDEY   tentypen von DB2.                                  */
 /*                                                                   */
 /*   AENDERUNGEN:  ST.BRANDT                                         */
 /*   11.04.1996    STUKTUR_NAME_0418, VERSION_0418 eingefuegt        */
 /*                 in PLAUSIPARM.                                    */
 /*                                                                   */
 /*********************************************************************/
 /*********************************************************************/
 /*                S Y S T E M I N C L U D E S                        */
 /*********************************************************************/
 #include <stdio.h>                   /* Ein-/ Ausgabe              */
 #include <string.h>                  /* String-Funktionen          */
 #include <stdlib.h>                  /* Stdlib-Funktionen          */
 #include <decimal.h>                 /* Decimal-Datentypen         */
 /*********************************************************************/
 /*                S Q L  -  C O N T R O L   A R E A                  */
 /*********************************************************************/
 EXEC SQL INCLUDE SQLCA;
 /*********************************************************************/
 /*             S Y S T E M  -  D E F I N I T I O N                   */
 /*********************************************************************/
 #include "XKQ0000C"
 #include "CICSBATC"
 /*********************************************************************/
 /*                     D E F A U L T S                               */
 /*********************************************************************/
 /*********************************************************************/
 /*                U E B E R G A B E - B E R E I C H                  */
 /*********************************************************************/
 #include "XKQ0418C"
 /*********************************************************************/
 /*                T A B E L L E N  -  D E F I N I T I O N            */
 /*********************************************************************/
 /*********************************************************************/
 /*                   L O K A L E     D A T E N                       */
 /*********************************************************************/
 /*-------------------------------------------------------------------*/
 /* KONSTANTEN                                                        */
 /*-------------------------------------------------------------------*/

 /*********************************************************************/
 /*                      D B 2   -   H O S T V A R I A B L E N        */
 /*********************************************************************/
 EXEC SQL BEGIN DECLARE SECTION;
   char     wkz_tmp[4];
   char     typkl_grp_tmp[3];
   decimal(3,0)   rkl_tmp;
   decimal(15,0)  leist_schl_tmp;
   char     tarif_tmp[7];
   char     mandant_tmp[2];
   decimal(5,3)   faktor_tmp;
 EXEC SQL END DECLARE SECTION;
 /*********************************************************************/
 /*                      D B 2   -   C U R S O R                      */
 /*********************************************************************/
 /*********************************************************************/
 /*   VORWäRTSDEKLARATION DER FUNKTIONEN                              */
 /*********************************************************************/
  void  abbruch_mkq0418(), db2_mkq0418(), grundwerte_mkq0418(),
        plausi_parm_mkq0418(),verarbeitung_mkq0418();
 /*********************************************************************/
 /*   GLOBALE VARIABLE                                                */
 /*********************************************************************/
  P_XKQ0418 pxkq0418;
  char      retcode[5];
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
  #ifdef __QV_CICS__
  void main (pxkq0418)
  {
  /********************************************************************/
  /* Laden Commarea                                                   */
  /********************************************************************/
      EXEC CICS ADDRESS COMMAREA (pxkq0418);
  /********************************************************************/
  /* Aufruf MKQ0418                                                   */
  /********************************************************************/
      aufruf_0418(&pxkq0418);

      EXEC CICS RETURN ;
  }
  #else
  void MKQ0418 (pxkq0418)
  {
      aufruf_0418(&pxkq0418);
      return;
  }
  #endif
  /********************************************************************/
  /*                    S  T  E  U  E  R  U  N  G                     */
  /********************************************************************/
 int  aufruf_0418(P_XKQ0418 *pxkq0418tmp)
 {
  pxkq0418 = *pxkq0418tmp;
                                            /*------------------------*/
                                            /* VOREINSTELLUNGEN       */
                                            /*------------------------*/
  grundwerte_mkq0418();
                                            /*------------------------*/
                                            /* PR!FEN EINGABEDATEN    */
                                            /*------------------------*/
  plausi_parm_mkq0418();

  if (strncmp(retcode, "    ",sizeof(retcode)-1))
    abbruch_mkq0418();
                                            /*------------------------*/
                                            /* STEUERUNG IO-ZUGRIFF   */
                                            /*------------------------*/
  else
    verarbeitung_mkq0418();

    return (RC_OK);
 }

  /********************************************************************/
  /*                I N T E R N E    P R O Z E D U R E N              */
  /********************************************************************/
  /********************************************************************/
  /* ABBRUCH_MKQ0418        : ABBRUCH DES PROGRAMMS                   */
  /* DB2_MKQ0418            : SAMMLUNG DER DB2-SQL DATENBANKZUGRIFFE  */
  /* GRUNDWERTE_MKQ0418     : INITIALISIERUNGEN                       */
  /* PLAUSI_PARM_MKQ0418    : PRUEFEN DER EINGABEDATEN                */
  /* VERARBEITUNG_MKQ0418   : ANWENDUNGSSPEZIFISCHE VERARBEITUNG      */
  /********************************************************************/

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: A B B R U C H                                  */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - BEHANDLUNG VON UNERWARTETEN FEHLERN                            */
  /********************************************************************/
 void abbruch_mkq0418 () {
   psqlca kfsqlca = pxkq0418->P_SQLCA;
                                            /*------------------------*/
                                            /* SETZEN STEUERBEREICH   */
                                            /*------------------------*/
   memcpy(pxkq0418->STEUER.fmodul,"MKQ0418 ",
          sizeof(pxkq0418->STEUER.fmodul)-1);
   memcpy(pxkq0418->STEUER.fmodul_retcode,
          pxkq0418->STEUER.retcode,
          sizeof(pxkq0418->STEUER.fmodul_retcode)-1);
                                            /*------------------------*/
                                            /* UEBERTRAGEN SPA        */
                                            /*------------------------*/
   if (atoi(retcode) == 200)
     kfsqlca = &sqlca;

   memcpy(pxkq0418->STEUER.retcode,retcode,
          sizeof(pxkq0418->STEUER.retcode)-1);
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: D B 2                                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - SAMMLUNG DER INTERNEN DB2-SQL DATENBANKZUGRIFFE:               */
  /*   01 : TBKF_REG_KL_FAKT  LESEN Faktor fuer Regionalklasse        */
  /********************************************************************/
 void db2_mkq0418 (int nr)
 {
   if ( nr == 1 )
   {
   /*******************************************************************/
   /*  01 : TBKF_REG_KL_FAKT  LESEN TBKF_REG_KL_FAKT                  */
   /*******************************************************************/
     EXEC SQL
       SELECT
              FAKTOR
       INTO
              :faktor_tmp
       FROM
              TBKF_REG_KL_FAKT
       WHERE
              WKZ         =    :wkz_tmp
       AND
              TYPKL_GRP   =    :typkl_grp_tmp
       AND
              RKL         =    :rkl_tmp
       AND
              LEIST_SCHL  =    :leist_schl_tmp
       AND
              TARIF       =    :tarif_tmp
       AND
              MANDANT     =    :mandant_tmp
     ;

     if (SQLCODE == SQL_OK)
       strcpy(retcode,"0000");
     else
     {
       if (SQLCODE == SQL_NICHT_GEFUNDEN)
       {
         strcpy(retcode,"0100");
         pxkq0418->STEUER.fmodul_sqlcallnr =  nr;
         memcpy(pxkq0418->STEUER.fmodul_retcode,
                retcode,
                sizeof(pxkq0418->STEUER.fmodul_retcode)-1);
         memcpy(pxkq0418->STEUER.fmodul,
                "MKQ0418 ",
                sizeof(pxkq0418->STEUER.fmodul)-1);
       }
       else
       {
         strcpy(retcode,"0200");
         pxkq0418->STEUER.fmodul_sqlcallnr = nr;
         abbruch_mkq0418();
       }
     }
   }
                                            /*------------------------*/
                                            /* UNGUELTIGER AUFRUF DB2 */
                                            /*------------------------*/
   else
   {
     strcpy(retcode,"0199");
     abbruch_mkq0418();
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: G R U N D W E R T E                            */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG:                                     */
  /* - INITIALISIEREN VON FELDERN                                     */
  /********************************************************************/
 void grundwerte_mkq0418() {
                                            /*------------------------*/
                                            /* LOESCHEN STEUERBEREICH */
                                            /*------------------------*/
    memcpy(retcode,"    ",
           sizeof(pxkq0418->STEUER.retcode)-1);
    memset(pxkq0418->STEUER.hinweis,0,
           sizeof(pxkq0418->STEUER.hinweis)-1);
    memset(pxkq0418->STEUER.fmodul,0,
           sizeof(pxkq0418->STEUER.fmodul)-1);
    memset(pxkq0418->STEUER.fmodul_retcode,0,
           sizeof(pxkq0418->STEUER.fmodul_retcode)-1);
    pxkq0418->STEUER.fmodul_sqlcallnr = 0;
                                            /*------------------------*/
                                            /* LOESCHEN AUSGABE       */
                                            /*------------------------*/
    pxkq0418->AUSGABE.faktor = 0;

 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: P L A U S I _ P A R M                          */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /* - PRUEFUNGEN DER EINGABEDATEN                                    */
  /********************************************************************/
 void plausi_parm_mkq0418 () {
   char struk_name_tmp[9];
   char version_tmp[5];
   char ende_tmp[5];

   memset(struk_name_tmp,0,sizeof(struk_name_tmp));
   memset(version_tmp,0,sizeof(version_tmp));
   memset(ende_tmp,0,sizeof(ende_tmp));
                                            /*------------------------*/
                                            /* PRUEFEN VERSION        */
                                            /*------------------------*/
   memcpy(pxkq0418->IDENT.struktur_name,__STRUKTUR_NAME_0418,
          sizeof(pxkq0418->IDENT.struktur_name)-1);
   memcpy(pxkq0418->IDENT.version,__VERSION_0418,
          sizeof(pxkq0418->IDENT.version)-1);
   memcpy(pxkq0418->ende,__ENDE,
          sizeof(pxkq0418->ende)-1);

   memcpy(struk_name_tmp,pxkq0418->IDENT.struktur_name,
          sizeof(pxkq0418->IDENT.struktur_name)-1);
   memcpy(version_tmp,pxkq0418->IDENT.version,
          sizeof(pxkq0418->IDENT.version)-1);
   memcpy(ende_tmp,pxkq0418->ende,
          sizeof(pxkq0418->ende)-1);
   if (       strcmp(struk_name_tmp,"XKQ0418 ")
       ??!??! strcmp(version_tmp,"0001")
       ??!??! strcmp(ende_tmp,"ENDE"))
   {
     strcpy(pxkq0418->STEUER.retcode,"0001");
     return;
   }
 }

  /********************************************************************/
  /*                                                                  */
  /*    UNTERPROGRAMM: V E R A R B E I T U N G                        */
  /*                                                                  */
  /********************************************************************/
  /* KURZE FUNKTIONSBESCHREIBUNG                                      */
  /*  - ANWENDUNGSSPEZIFISCHE VERARBEITUNG                            */
  /********************************************************************/
 void verarbeitung_mkq0418 () {
                                            /*------------------------*/
                                            /* LESEN TBKF_REG_KL_FAKT */
                                            /*------------------------*/
   //memcpy(rkl_tmp,pxkq0418->EINGABE.rkl,
   //       sizeof(pxkq0418->EINGABE.rkl)-1);
   memcpy(wkz_tmp,pxkq0418->EINGABE.wkz,
          sizeof(pxkq0418->EINGABE.wkz)-1);
   memcpy(typkl_grp_tmp,pxkq0418->EINGABE.typkl_grp,
          sizeof(pxkq0418->EINGABE.typkl_grp)-1);
   leist_schl_tmp = pxkq0418->EINGABE.leist_schl;
   rkl_tmp = pxkq0418->EINGABE.rkl;
   memcpy(tarif_tmp,pxkq0418->EINGABE.tarif,
          sizeof(pxkq0418->EINGABE.tarif)-1);
   memcpy(mandant_tmp,pxkq0418->EINGABE.mandant,
          sizeof(pxkq0418->EINGABE.mandant)-1);
   db2_mkq0418(1);
   if (SQLCODE == SQL_NICHT_GEFUNDEN)
     memcpy(pxkq0418->STEUER.retcode,
            retcode,
            sizeof(pxkq0418->STEUER.retcode)-1);
   if (SQLCODE == SQL_OK)
   {
     memcpy(pxkq0418->STEUER.retcode,
            retcode,
            sizeof(pxkq0418->STEUER.retcode)-1);
     pxkq0418->AUSGABE.faktor       =  faktor_tmp;
   }
 }

  /********************************************************************/
  /* ENDE MKQ0418                                                     */
  /********************************************************************/
