BOA2.9 IDENTIFICATION DIVISION.
       PROGRAM-ID.  GTUWM300.
      ******************************************************************
      *                                                                *
      *                                                                *
      *   PROCEDURA : GLOBAL  FUND                                     *
      *                                                                *
      *   FUNCTION  : CALCOLO E CONTABILIZZAZIONE RIMBORSI             *
      *               PARZIALI O TOTALI,DIVIDENDI,CEDOLE.              *
      *                                                                *
      *   TYPE      : BATCH                                            *
      *                                                                *
      *   NAME      : GFUWM300                                         *
      *                                                                *
      *   LANGUAGE  : COBOL                                            *
      *                                                                *
      *   MODULES   : ........ -                                       *
      *                                                                *
      *   INPUT     : SELAO-TBSMO-TBPSA-TBIST-TBTIT-TBCED-             *
      *               TBLGS-TBCCC-TBENT-TBPAE-TBCAU-TBPTI-             *
      *               TIBCAM- TBDIV -TBSVM                             *
      *                                                                *
      *   OUTPUT    : SMLQ0 - SMLQ1 - SMO0- S3000-S3001-S3003          *
014696*                     - SMLQ1 - ELIMINATA LA SCRITTURA           *
      *               TBPSA-TBIST-TBTIT-                               *
      *                                                                *
      *   BIND NAME : .........                                        *
      *                                                                *
      *   AUTHOR    : ENGINEERING                                      *
      *                                                                *
      *   REVISIONI : 27/09/99 - AGGIORNAMENTO DEL PROGRESSIVO PER     *
      *                          L'ISTITUTO A FINE ELABORAZIONE        *
      *                                                                *
      *               28/09/99 - CORREZIONE DEL CALCOLO DEL RATEO PER  *
      *                          UN TITOLO CON PRO-RATA LUNGO.         *
      *                          IL NUOVO CALCOLO DEL RATEO VIENE FATTO*
      *                          SU BASE 365 PER IL PERIODO CHE VA     *
      *                          DALLA DATA DI EMISSIONE ALLA IPOTETICA*
      *                          SCADENZA IMMEDIATA E SU BASE 366 PER  *
      *                          IL PERIODO REGOLARE.                  *
      *                          FONTANA-PACE                          *
      *                                                                *
      *               08/11/99 - CORREZIONI PER LA CORRETTA VALORIZZ.  *
      *                          DEI CAMPI DI INPUT DELLA CONV-EURO.   *
      *                          ORNATO - BOSCO.                       *
      ******************************************************************
090499* IMPLEMENTAZIONE NUOVE BASI CALCOLO RATEI                       *
      ******************************************************************
      * 050399     MODIFICHE PER MODULARIZZAZIONE
      *
      ******************************************************************
      * 290199     REVISIONE APPLICAZIONE DECR.LEGISLATIVO 1/4/96 N. 239
      *            (ART.12 COMMA 1)
      ******************************************************************
      * 160299     ACQUISIZIONE <BASE DI CALCOLO> PRE-RECONVENTION DA
      *            TABELLA TBTIT PIUTTOSTO CHE DA TBSVM
      ******************************************************************
      * 230699     MODIFICA PER EVITARE EVENTUALI ERRORI UTILIZZANDO LA
      *            BOPGDATE
      ******************************************************************
030699* 030699     GESTIONE TOTALIZZATORI PER CAPITAL GAIN
      ******************************************************************
300699* 030699     GESTIONE TOTALIZZATORI PER CAPITAL GAIN
270999*            CORRETTO AGGIORNAMENTO ULT-PRG-MOV
      ******************************************************************
221099* 221099     ERRORE LOAD TBSMO
271099*            CORREZIONE SU CALCOLO-VALUTA
      ******************************************************************
221199* AUMENTATA DIMENSIONE TABELLE
      ******************************************************************
011299* MIGLIORATI COMMENTI IN CASO DI BLOCCO LINEA
      ******************************************************************
171299* DUPLICAZIONE MOVIMENTI DI LIQ. IN CASO DI DISTRIB.DIV.
      ******************************************************************
291299* IN FASE DI RIMBORSO IL PROGR.DI SMO E DIVERSO DA QUELLO DI MLQ
      ******************************************************************
030100* NEL RECORD DI MLQ NON VENIVA VALORIZZATO IL CAMPO
030100*    S-MLQ0-FLG-TIT-CTT
      ******************************************************************
070100* IMPORTO POSITIVO PER RITENUTA FISCALE
      ******************************************************************
200100* N.365
200100* PER TITOLI TEL QUEL NON CALCOLA LA RITENUTA SULLO SCARTO EMIS
      ******************************************************************
280100* N.385
280100* IL VALORE DELLA RITENUTA FISCALE   VIENE CTV 2 VOLTE
      ******************************************************************
310100* LA VALUTA DEI MOVIMENTI PER RITENUTA FISCALE PER TITOLI ITALIANI
310100* VIENE IMPOSTATA COME L'ULTIMO GIORNO LAVORATIVO DEL MESE.
310100* STESSA COSA NEL CASO DI SCARTO IN INSERIMENTO LIQUIDITA'.
      ******************************************************************
000512* X STACCO CEDOLA NON VENGONO MOVIMENTATI I TOTALIZZATORI CORRETTI
000512* FORTUNATAMENTE, NON VENIVANO MAI INSERITI NEL FLUSSO STOT IN
000512* QUANTO GLI IMPORTI SU CUI TOTALIZZAVA NON ERANO MOVIMENTATI
000512* CORRETTAMENTE.
      ******************************************************************
000516* PER STACCO CEDOLA O SCARTO EMISSIONE PER RIMBORSO PARZIALE O
000516* TOTALE LA LIQUIDITA GENERATA DEVE CONFLUIRE NEL C/C NELLA
000516* DIVISA INDICATA NEL CAMPO DIVISA DI REGOLAMENTO DELLA TABELLA
000516* LINEA-GESTORE - TBLGS - E NON SEMPRE NELLA DIVISA DELLA LINEA.
000516* INFATTI SE IL CAMPO "GESTIONE CONTO UNICO" SEMPRE DELLA TBLGS
000516* HA VALORE "N", LA LIQUIDITA VA GENERATA PER IL C/C NELLA DIVISA
000516* DI REGOLAMENTO CHE PUO ESSERE QUELLA DEL TITOLO O DELLA LINEA.
000516* SE IL VALORE DEL CAMPO "GESTIONE CONTO UNICO" E "S", LA
000516* LIQUIDITA VA GENERATA PER IL C/C NELLA DIVISA DELLA LINEA(FONDO)
      ******************************************************************
000436* ERRATA TOTALIZZAZIONE TITOLO SE NEGOZIATO DA PI  GESTORI.
000436* IN QUESTO CASO NON CALCOLA BENE IL VALORE DEL TITOLO IN
000436* PORTAFOGLIO ALLA DATA DI ELABORAZIONE.
      ******************************************************************
000540* IL TASSO RITENUTA OPERATA IN STACCO CEDOLA, E'  SEMPRE QUELLO
000540* RELATIVO A FONDO PENSIONE, ANCHE PER I FONDI COMUNI.
      ******************************************************************
000663* 03/05/00 - SCOZZARO
000663* IL CALCOLO DEL DIVIDENDO DEVE ESSERE FATTO SUL  VALORE DEL
000663* TITOLO IN PORTAFOGLIO ALLA DATA OPERAZIONE E QUINDI NON
000663* DEPURANDO IL VALORE DEI MOVIMENTI CON VALUTA SUCCESSIVA.
      ******************************************************************
000666* 04/05/00 - SCOZZARO
000666* IL TASSO RITENUTA OPERATA IN STACCO DIVIDENDO E SEMPRE QUELLO
000666* RELATIVO A FONDO PENSIONE, ANCHE PER I FONDI COMUNI.
      ******************************************************************
000688* 08/05/2000 - SE VALORE NOMINALE TITOLO E' ZERO  STAMPAVA RIGHE
000688*              NON SIGNIFICATIVE (INT2-0, RIGA4-0)
      ******************************************************************
000689* 11/05/2000 - SE PREZZO RIMBORSO è UGUALE A PREZZO DI EMISSIONE
000689*              IL TITOLO NON DEVE ESSERE RIPORTATO NEL TABULATO
000689*              S3000 (SCARTO EMISSIONE)
      ******************************************************************
000690* 17/05/2000 - PER TITOLO NON ESENTE E ALIQ. R.F. = 0, NON DEVE
000690*              AGGIORNARE TOTALIZZATORE IMPONIBILI STACCO CEDOLA O
000690*              SCARTO EMISSIONE AL FINE DI DETERMINARE L'IMPOSTA
000690*              SOSTITUTIVA SUL RISULTATO LORDO DI GESTIONE.(568)
      ******************************************************************
2.0.4 * 19/05/2000 - RILASCIO RELEASE
      ******************************************************************
000308* 23/05/2000 - IL CALCOLO DEI DIVIDENDI VENIVA FATTO UTILIZZANDO
000308*              3 DECIMALI INVECE CHE 4.
      ******************************************************************
000714* 25/05/2000 - INTEGRA LA 690. VANNO SOMMATI ANCHE I TITOLI ESENTI
      ******************************************************************
000704* 25/05/2000 - SE TITOLO HA INDICAZIONE FISSATA DI ESENZIONE O
      *              NON ESENZIONE, NON NE VERIFICA LE ALTRE
      *              CARATTERISTICHE
      ******************************************************************
000717* 29/05/2000 - PER FONDO PENSIONE, SE GESTIONE CONTO UNICO è "NO",
      *              RICERCA C/C ORDINARIO NELLA DIVISA INDICATA
      *              PER STACCO CEDOLA PER LA LINEA INVECE CHE PER IL
      *              GESTORE, PROVOCANDO BLOCCO CON RC=5.
      *              INOLTRE, QUALORA TROVAVA IL C/C NELLA DIVISA CORRETTA
      *              ANCHE PER LA LINEA, NON ANDAVA IN BLOCCO MA
      *              UTILIZZAVA IL NUMERO DEL C/C DELLA LINEA ANCHE PER IL
      *              MOVIMENTO A LIVELLO DI GESTORE (STACCO CEDOLA-SCI)
      ******************************************************************
000726* 31/05/2000 - PER NUMERO TITOLI IN PORTAFOGLIO SUPERIORE A 1000,
      *              IL PROGRAMMA VA IN LOOP PER INSUFFICIENTE DIMENSIONE
      *              DELL'INDICE DI ELABORAZIONE TABELLA.
      ******************************************************************
000745* 09/06/00 - SE DIVISA FONDO E' LIRA, LA RITENUTA FISCALE DEVE
      *            ESSERE ESPOSTA SENZA I DECIMALI
      *****************************************************************
FS1606* 16/06/2000 - INTEGRA LA 690 + LA 714.
      ******************************************************************
000762* 19/06/2000 - NUOVA NORMATIVA: PER TITOLI NAZIONALITA' ESTERA LA
      *              DATA VALUTA DEVE ESSERE ULTIMO GIORNO LAVORATIVO
      *              DEL MESE (A PARTIRE DAL 01/07/2000).  SCOZZARO
      ******************************************************************
000781* 27/06/00 - ERRORE SOLO PER GFUWM330 - IN PRESENZA DI PIU VENDITE
      *            IL CALCOLO DEL DEDUCIBILE NE TENEVA CONTO SEMPRE DI
      * SCOZZARO   TUTTE INVECE CHE SOLAMENTE DI QUELLE DEL GIORNO.
      * PACE       QUESTO PROVOCAVA UN IMPORTO IMPONIBILE SEMPRE ZERO
      *            IN QUANTO IL DEDUCIBILE CALCOLATO ERA SEMPRE MAGGIORE
      *            DEL MATURATO E QUINDI VENIVA FORZATO UGUALE.
000961* 20/09/2000 - SE AUTOMATISMO IN DIVISA TITOLO E LA DIVISA TITOLO
      *              E' IN ALLORA VIENE INTERESSATO IL C/C EURO
      ******************************************************************
000870* 06/08/00 - INIBIZIONE DELLA CONTABILIZZAZIONE AUTOMATICA      *
      *            DELLA LIQUIDITA' IN FASE DI RIMBORSO PER           *
      *            GLI STRUTTURATI " REVERSE CONVERTIBILE "           *
      *****************************************************************
001053* 16/11/00 - NUOVA TASSAZIONE F.P. PRODUZIONE DEI TOTALIZZATORI *
      *            RELATIVI AI REDDITI ESENTI ANALOGAMENTE AI F.C.    *
      *            SCOZZARO - FONTANA   VER. *- 3.0.0 -*              *
      *****************************************************************
002040* SCOZZARO - GESTIONE FISCALITA' FONDI IMMOBILIARI              *
      ******************************************************************
001130** RISOLTO ABEND PER OVERFLOW MEMORIA                          **
      *****************************************************************
002248* SCOZZARO - ERRATA VALORIZZAZIONE TOTALIZZATORE 568 PER FONDI  *
002248*            PENSIONE E TITOLO SOGGETTO A RITENUTA CON R.F. = 0 *
      ******************************************************************
002483* CONOSCENTI - LICATA                                            *
002483* I RIMBORSI NON AVVENGONO CON VALUTA CORRETTA QUANDO IL         *
002483* RIMBORSO ACCADE IN UN GIORNO FESTIVO                           *
002483*                                VER - 3.0.2                     *
002483* AZZERAMENTO PSA-CTV-QTA-EFF
      ******************************************************************
002966* NEL CASO DI STACCO DIVIVDENDI IL VALORE NOMINALE RIPORTATO
      * SUI MOVIMENTI NON E' CORRETTO; MANCANO LE OPERAZIONI CON VALUTA
      * FUTURA
      *****************************************************************
003092* FONTANA - BONSIGNORE
      * REALIZZATA ROUTINE DI CONTROLLO PER I FONDI PENSIONE E I FONDI
      * CHIUSI CHE VERIFICA CHE I TITOLI IN PORTAFOGLIO HANNO GIA'
      * STACCATO LA CEDOLA, DISTRIBUITO I DIVIDENDI O RIMBORSATO IN
      * DATA PRECEDENTE ALLA DATA DI ELABORAZIONE, MA SUCCESSIVA ALLA
      * ULTIMA DATA ELABORATA PER IL FONDO.
      *                                    VER - 3.0.3
      *****************************************************************
003263* IL FLAG WS-PERS-R-COD-OK NON VIENE INIZIALIZZATO ALLA FINE DEI*
      * CONTROLLI                                                     *
      *****************************************************************
003291* VENGONO RIMBORSATI PARZIALMENTE TITOLI CON DATA PROSSIMO      *
      * RIMBORSO NON ANCORA MATURA                                    *
      * FONTANA     VER. *3.0.4 -*                                    *
      *****************************************************************
003321* SE PER LA STESSA DATA VENGONO ELABORATI DIVERSI FONDI CHE     *
      * HANNO IN PORTAFOGLIO UNO STESSO TITOLO, PER IL PRIMO FONDO IL *
      * TITOLO VIENE REGOLARMENTE RIMBORSATO MENTRE PER GLI ALTRI IL  *
      * RIMBORSO VIENE ELABORATO ALLA DATA SUCCESSIVA                 *
      * VER. *- 3.0.5 -*                                              *
      *****************************************************************
005717* NEL CASO DI RIMBORSO PARZIALE, TOTALE E STACCO DIVIDENDI,
005717* VA AGGIORNATA LA DATA DI EFFETTIVO RIMBORSO E LA DATA EFFETTIVO
005717* DIVIDENDO ANCHE SULLO STORICO VALORI MOVBILIARI SE LA DATA
005717* DECORRENZA TITOLO SULLA TBTIT E' SUCCESSIVA A DATA ELABORAZIONE.
005717* INOLTRE PRIMA DI EFFETTUARE L'AGGIORNAMENTO IN TBTIT OCCORRE
005717* RILEGGERE LA RIGA DA MODIFICARE PER EVITARE CHE VENGANO
005717* SPORCATI I CAMPI DELL'ANAGRAFICA.
005717* ADRIGNOLO   VERS. 3.1
      *****************************************************************
002214*   CREAZIONE DI UN FLUSSO (SDME) PER POPOLARE LA TABELLA TBDME *
      *   SCRITTURA DEI RECORD 1 E 2 SUL FLUSSO SDME                  *
      *   RICHIAMO PERFORM SU COPY                                    *
      ******************************************************************
002642*   VERSIONE 4.0.0                                               *
      *   NUOVA GESTIONE BLOCCO DELLA RETE BATCH.                      *
      *   ELABORAZIONE PROGRAMMI SENZA INTERRUZIONE PER ISTITUTI       *
      *   CON PERSONALIZZAZIONE.                                       *
      ******************************************************************
003572*   VERSIONE 3.1.0                                               *
      *   MODIFICHE PER IL NAVIGATORE TABULATI                         *
      ******************************************************************
005177* ELIMINATO TABULATO GFUSLOGER                                   *
      * FONTANA  VER. *- 4.0.1 -*                                      *
      ******************************************************************
005456* ADEGUAMENTO PER ELABORAZIONE/SCARTO DELLE POSIZIONI SHORT      *
      *          VER. *- 4.0.2 -*                                      *
      ******************************************************************
006044* CALCOLO DELLA DATA VALUTA STACCO CEDOLA COME DATA SCADENZA     *
      * PIU' UN GIORNO (LAVORATIVO O FESTIVO)                          *
      *          VER. *- 4.0.3 -*                                      *
      ******************************************************************
006026* MOVIMENTI CON CAUSALE 'PCE' 'PCI' PER FONDO PENSIONE SU CONTO  *
      * CORRENTE DEL GESTORE.                                          *
      * ELIMINATI INTERVENTI EFFETTUATI CON LA 6044                    *
      *                               VER. *- 4.0.4 -*                 *
      ******************************************************************
006136* INIZIALIZZAZIONE DEI CAMPI A LIVELLO '77' AL FINE DI EVITARE
006136* 'DATA-EXCEPTION' DURANTE L'ESECUZIONE DEL PROGRAMMA
006136*
006136* LO MENZO - ADRIGNOLO                            VER. - 4.0.5 -
      ******************************************************************
006390* GESTIONE TITOLI OBBLIGAZIONARI CON POOL/INFLACTION FACTOR
      *                                                 VER. - 4.0.6 -
      ******************************************************************
006664*          LO CASCIO - PIRRONE                                   *
006664*  -4.0.7- RESE INVISIBILI DISPLAY NON SIGNIFICATIVE             *
006664******************************************************************
007180* PER UN DETERMINATO FONDO UN TITOLO VIENE RIMBORSATO IN OGNI    *
      * GIORNATA DI LAVORAZIONE SUCCESSIVA ALLA SCADENZA DEL TITOLO    *
      * FONTANA  VER. *- 4.0.8 -*                                      *
      ******************************************************************
007240* IL MODULO RICHIEDE LA PRESENZA DI CALENDARI DI BORSA FUTURI    *
      * FONTANA  VER. *- 4.0.9 -*                                      *
      ******************************************************************
007518* IL TABULATO DI DETTAGLIO DEL CALCOLO DELL'IMPOSTA PER RITENUTA *
      * SU STACCO CEDOLA RIPORTA UN TOTALE RATEO DEDUCIBILE NEGATIVO E *
      * QUINDI ERRATO                                                  *
      * FONTANA  VER. *- 4.0.10 -*                                     *
      ******************************************************************
007521* GESTIRE LA LETTURA DEL CONTO CORRENTE A LIVELLO DI LINEA E IL  *
      * BLOCCO FONDO SE ATTIVATA LA GESTIONE DEL CONTO UNICO           *
      * MIRAGLIA  VER. *- 4.0.11 -*                                    *
      ******************************************************************
008106* GESTIONE DEI RIMBORSI PARZIALI :PERS. 105.                     *
      * LICATA   VER. *- 4.0.12 -*                                     *
      ******************************************************************
008366* VIENE ERRONEAMENTE EFFETTUATO LO STACCO CEDOLA PER TITOLI IN   *
      * PORTAFOGLIO NON CORRETTAMENTE DEPURATI DAI MOVIMENTI DI COMPRA-*
      * VENDITA CON VALUTA FUTURA.                                     *
      *          VER. *- 4.0.13 -*                                     *
      ******************************************************************
008615* ALCUNI FONDI VENGONO BLOCCATI PER ASSENZA, NON VERITIERA, DI   *
      * RELAZIONE LINEA GESTORE                                        *
      *          VER. *- 4.0.14 -*                                     *
      ******************************************************************
008559*NUOVA GESTIONE DEI RIMBORSI PARZIALI :                          *
      * LA RITENUTA FISCALE VA MOLTIPLICATA PER IL FATTORE DI RIDUZIONE*
      * AUMENTATA LA DIMENSIONE DEL CAMPO MC35-PESO                    *
      *          VER. *- 4.0.15 -*                                     *
      ******************************************************************
008730*NUOVA GESTIONE DEI RIMBORSI PARZIALI :                          *
      * VIENE VERIICATO IL TIPO DI RIMBORSO DA APPLICARE AL TITOLO
      *          VER. *- 4.0.16 -*                                     *
      ******************************************************************
008998* CORRETTA RICERCA DELLA PERSONALIZZAZIONE 105                   *
      *          VER. *- 4.0.17 -*                                     *
      ******************************************************************
009006* IL CALCOLO DEL RIMBORSO PARZIALE COL METODO DELL'INVARIENZA    *
      * VIENE ESEGUITO, ERRONEAMENTE, NON CONSIDERANDO LA DIFFERENZA   *
      * TRA LE ULTIME DUE PERCENTUALI E PARTENDO DA UN NOMINALE GIA'   *
      * DECURTATO DALLA PERCENTUALE DI RIMBORSO                        *
      *          VER. *- 4.0.18 -*                                     *
      ******************************************************************
008918* NEL CASO IN CUI UNA OBBLIGAZIONE ESCA DAL PORTAFOGLIO CON UN   *
      * MOVIMENTO DI VENDITA CON VALUTA PARI A DATA RIMBORSO, LO STAC- *
      * CO CEDOLA NON VA EFFETTUATO.                                   *
      *          VER. *- 4.0.19 -*                                     *
      ******************************************************************
009120* NEL  CASO DI RIMBORSO PARZIALE, IL PAESE DEL MOVIMENTO DI      *
      * COMPRAVENDITA CHE DECURTA LA POSIZIONE CON LA QUANTITA'RIMBORSA*
      * TA, DEV'ESSERE VALORIZZATO CON QUELLO DEL MOVIMENTO PIU'RECENTE*
      * FISCELLA VER. *- 4.0.20 -*                                     *
      ******************************************************************
009560* IMPLEMENTATO CONTROLLO IN FASE DI DIAGNOSTICO PREVENTIVO PER   *
      * EVITARE CHE LA PROCEDURA SI BLOCCHI PER ASSENZA DI CALENDARIO  *
      * FONTANA - BONSIGNORE                VER. *- 4.1.0 -*           *
      ******************************************************************
009725* - PERS.116 - VENDITA ALLO SCOPERTO PER FONDI NON SPECULATIVI   *
      * LUPO     VER. *- 4.1.1 -*                                      *
      ******************************************************************
010173* LO STACCO DELL'ULTIMA CEDOLA DI UN TITOLO AVVIENE SOLO NEL CASO*
      * DI RIMBORSO GESTITO IN AUTOMATICO DA GLOBAL                    *
      *          VER. *- 4.1.2 -*                                      *
      ******************************************************************
010122* ADEGUAMENTI LEGATI ALLA GESTIONE DELLA FISCALITA' PER I FONDI  *
      * IMMOBILIARI            *- VER. 4.1.3-*                         *
      ******************************************************************
011326* CALCOLO E CONTABILIZZAZIONE CEDOLE:                            *
      * LA DATA VALUTA DEL MOV DI LIQUIDITA PRODOTTO DEVE ESSERE PARI  *
      * AL PRIMO GIORNO DI BORSA APERTA MAGGIORE O UGUALE ALLA DATA    *
      * SCADENZA DELLA CEDOLA        *- VER. 4.1.4-*                   *
      ******************************************************************
011527* NEL CASO IN CUI UNA OBBLIGAZIONE ESCA DAL PORTAFOGLIO CON UN   *
      * MOVIMENTO DI VENDITA CON VALUTA PARI A DATA RIMBORSO,          *
      * IL MOVIMENTO DI STACCO CEDOLA VA PRODOTTO. ABOLIRE QUINDI GLI  *
      * INTERVENTI EFFETTUATI CON LA SEGNALAZIONE 8918 E 10173         *
      *                              *- VER. 4.1.5 -*                  *
      ******************************************************************
012019* CALCOLO E CONTABILIZZAZIONE CEDOLE:                            *
      * LA DATA VALUTA DEL MOV DI LIQUIDITA PRODOTTO DEVE ESSERE PARI  *
      * AL PRIMO GIORNO DI BORSA APERTA MAGGIORE O UGUALE ALLA DATA    *
      * SCADENZA DELLA CEDOLA + 1 GIORNO
      *                                  *- VER. 4.1.6 -*
      ******************************************************************
012093* STACCO CEDOLA:                                                 *
      * LO STACCO NON VA EFFETTUATO PER I TITOLI PRESENTI IN PORTAFOGLIO
      * SOLO COME SOTTOSTANTI AI PCT IN QUANTO LA POSIZIONE IN TAL     *
      * CASO E'NULLA                     *- VER. 4.1.7 -*
      ******************************************************************
012922* IL PRESTITO CHE SCADE IN DATA STACCO CEDOLA NON VA CONSIDERATO
      *                                  *- VER. 4.1.8 -*
      ******************************************************************
012740* ADEGUAMENTO DEL PRODOTTO ALLO SCENARIO NORMATIVO INTRODOTTO DAL
012740* NUOVO PROVVEDIMENTO BANCA D' ITALIA.
012740* AGGIUNTO NUVA COLONNA IN TBSMO (SMO-COD-DVS-MOV).
012740*                  VER. 5.0
      ******************************************************************
014146* VIENE VALORIZZATO PRIMA DELLA GESTIONE DEL BLOCCO FONDO
014146* IL CAMPO WSN-SKB-PGM
014146*                  VER. 5.0.1
      ******************************************************************
016248* CORRETTO CALCOLO SCARTO DI EMISSIONE: A CAUSA DELLA MANCATA
016248* INIZIALIZZAZIONE A ROTTURA TITOLO DI ALCUNI CAMPI DI APPOGGIO
016248* SCARTO DEDUCIBILE E IMPONIBILE RIPORTAVANO IL TOTALE DEL TITOLO
016248* ESAMINATO PRECEDENTEMENTE
016248*                  VER. 5.0.2
      ******************************************************************
016226* CORRETTO IL CALCOLO DEL VALORE NOMINALE IN CASO DI RIMBORSO    *
016226* PARZIALE CON IL METODO DELL'INVARIANZA DEL NOMINALE            *
016226*                  VER. 5.0.3
      ******************************************************************
016938* LA RICERCA DELLA RELAZIONE LINEA/GESTORE VA EFFETTUATA PER IL  *
      * GESTORE CHE HA IL TITOLO IN PORTAFOGLIO.                       *
      * CORRETTA LA VALORIZZAZIONE DEL C/C SUL MOVIMENTO DI LIQUIDITà  *
      * RELATIVO AL PRESTITO IN CASO DI INSERIMENTO SUL CONTO CORRENTE *
      * DEL GESTORE                                                    *
      *                                       *- VER. 5.0.4  -*        *
      ******************************************************************
014711* RAZIONALIZZAZIONE RETE BATCH - RETTIFICA GESTIONE BLOCCO       *
014693* RAZIONALIZZAZIONE RETE BATCH - GESTIONE PRG. A LIVELLO DI LINEA*
014711* VERSIONE *- 6.0.0                                              *
014711******************************************************************
014696* OTTIMIZZAZIONE GESTIONE TABELLARE CON ELIMINAZIONE AZZERAMENTO *
014696* ELIMINATA LA SCRITTURA DEL FILE SMLQ1                          *
014696* INSERITA LA SELECT 6 DI TBELA PER PRENDERE LA DATA ULTIMA ELAB.*
014696* ELIMINATA LA CHIAMATA AL MODULO GFUWMC10 ED INSERITO CONTROLLO *
014696* DELLE DATE CON IF                                              *
014696* MODIFICATO CURSORE 4 DI TBCED  METTENDO CONTROLLO SCADENZA     *
014696* CEDOLA >= DATA ULTIMA ELABORATA                                *
014696* SPOSTATA LETTURA TBAPE A LIVELLO LINEA E NON PER SINGOLO TITOLO*
014696* OTTIMIZZAZIONE IMPOSTAZIONI CAMPI CHIAVE PER ERRORE DB2        *
014696* VERSIONE *- 6.0.0                                              *
014696******************************************************************
018541*RISOLTA ANOMALIA -310 PER MANACATA VALORIZZAZIONE CODICE GESTORE*
018541*VERSIONE *- 6.0.1                                               *
018541******************************************************************
018605*CORRETTA SEGNALAZIONE 18541 PER ERRATA VALORIZZAZIONE DEL CODICE*
018605*GESTORE - INIZIALIZZATE AREE SCRITTURA FLUSSO MOVIMENTI PER     *
018605*EVITARE ABEND ASRA *- 6.0.2                                     *
018605******************************************************************
018644* CORRETTA GESTIONE PRESTITI NEL CALCOLO CEDOLA -
018644* VENGONO PRESI SOLO QUELLI CON DATA ATTIVAZIONE NON SUPERIORE
018644* ALLA SCADENZA CEDOLA CORRENTE - 6.0.3
      ******************************************************************
018796* MODIFICA PER DUPLICAZIONE PROGRESSIVO MOVIMENTO
018796*                               - 6.0.4
      ******************************************************************
018880* - IN CASO DI STACCO DIVIDENDO VA CONSIDERATA UNA POSIZIONE     *
018880*   AGGIORNATA AL GIORNO PRECEDENTE PER CUI I MOVIMENTI DA DEPURA*
018880*   RE DAL PTF SONO QUELLI CON DATA OPERAZIONE >= DATA DIVIDENDO *
018880* - GESTIONE STACCO DIVIDENDO ANCHE PER GLI OICR                 *
018880*                          VER. - 6.0.5                          *
      ******************************************************************
05258G* - APPLICAZIONE TASSO DI INFLAZIONE DEL GIORNO                  *
05258G* - ELIMINAZIONE PREDOMINIO DELLA PERS. 105 SULLA 91             *
05258G*                          VER. - 6.0.6                          *
      ******************************************************************
06280G* - STACCO DIVIDENDO,RIMBORSO E STACCO CEDOLA VENGONO EFFETTUATI *
06280G*   SE DATA EVENTO <= DATA LAVORAZIONE E DATA EVENTO > ULTIMA DATA
06280G*   ELABORATA - NON VENGONO PIU' CONTROLLATE LE DATE EFFETTIVO   *
06280G*   STACCO O RIMBORSO                                            *
06280G*                          VER. - 6.0.7                          *
      ******************************************************************
06352G* - RICERCA CONTO ORDINARIO IN DIVISA E SE NON TROVATO RICERCA   *
06352G*   IN DIVISA FONDO                                              *
06352G*                          VER. - 6.0.8                          *
      ******************************************************************
07433G* RISOLTA ANOMALIA CHE COMPORTAVA REPLICAZIONE DI MOVIMENTI DI   *
      * LIQUIDITA SET(SCARTO EMISSIONE) PER TUTTI I TITOLI SUCCESSIVI  *
      * A QUELLO PER IL QUALE IL MOVIMENTO VENIVA PRODOTTO             *
      *                                       *- VER. 6.0.9  -*        *
      ******************************************************************
15209G* CORRETTA INIZIALIZZAZIONE FLAG DI DETERMINAZIONE DELL'INFLATION*
15209G* FACTOR                                                         *
15209G*                                       *- VER. 6.0.10 -*        *
      ******************************************************************
20515G* CALCOLO DEI DIRITTI ESENTI COME SOMMATORIA DELLA DIFFERENZA TRA*
      * RATEO A T E RATEO A T-1                                        *
      *                          VER. - BOA2.0_1                       *
      ******************************************************************
21720G* INIBIZIONE STACCO CEDOLA E ESECUZIONE RIMBORSI PER TITOLI IN   *
      * DEFAULT E STAMPA TABULATO GFUS3003                             *
      *                          VER. - BOA2.0_2                       *
      ******************************************************************
17302G* GESTIONE PERSONALIZZAZIONE 507 - AGGIUNTA CATEGORIA CONTO      *
      * VER. BOA 2.0.3                                                 *
      ******************************************************************
23000G* RIMOSSO BLOCCO DEL FONDO IN PRESENZA DI OPERAZIONI DI 'RECALL' *
      * DI QUANTITA' BLOCCATE PER PRESTITO TITOLI                      *
      * VER. BOA 2.0.4                                                 *
      ******************************************************************
21575G* GESTIONE CONFLITTO INTERESSI PERSONE FISICHE   VER. BOA2.5
      ******************************************************************
24391G* CORRETTA REGISTRAZIONE CATEGORIA C/C                           *
24391G* VER. BOA 2.6                                                   *
      ******************************************************************
24417G* LETTURA TABELLA RELAZIONE FONDI/GESTORE SOLO SE QTA IN PTF     *
      * > DI ZERO                  VER. BOA 2.7                        *
      ******************************************************************
25611G* TAX REFORM DEL 31/12/2011  :                                   *
      * IL RATEO CEDOLARE VA CALCOLATO PER IL PERIODO PRECEDENTE AL    *
      * 31.12.2011 CON LA VECCHIA TASSAZIONE, PER IL 2012 AL 20%
      **                                REL.BOA2.8                    **
      ******************************************************************
05847R* AUMENTATA LA DIMENSIONE DEL VETTORE TAB-ELE-PSA-GES
      **                                REL.BOA2.9                    **
      ******************************************************************
16332R* RISOLTO BLOCCO FONDO IN CASO DI PRESENZA DI OPERAZIONI DEI     *
      * PRESTITO TITOLI SU UNA POSIZIONE DI PORTAFOGLIO CHIUSA PER     *
      * TRADE DATE.                                                    *
      *                              VER. BOA 3.1                      *
      ******************************************************************
       ENVIRONMENT DIVISION.

       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-390.
      *SOURCE-COMPUTER. IBM-390 WITH DEBUGGING MODE.
       OBJECT-COMPUTER. INTEL-80486.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.

       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

      *--------------*
      *---- INPUT----*
      *--------------*
           COPY GTUBELAO.

      *--------------*
      *---- OUTPUT---*
      *--------------*
           COPY GTUBMLQ0.
           COPY GTUBSMO0.
           COPY GTUBMLQ1.
           COPY GTUB3000.
           COPY GTUB3001.
21720G     COPY GTUB3003.
005177*    COPY GTUBLOGE.
030699     COPY GTUBTOT0.
002214     COPY GTUBDME.

       DATA DIVISION .
       FILE SECTION .

      *-----------------------------------------------*
      *---- TRACCIATO RECORD DEI FILE DI INPUT--------*
      *-----------------------------------------------*

      *-----------------------------------------------*
      *---- TRACCIATO RECORD DEI FILE DI OUTPUT-------*
      *-----------------------------------------------*
           COPY GTUFMLQ0.
           COPY GTUFMLQ1.
           COPY GTUFSMO0.
           COPY GTUF3000.
           COPY GTUF3001.
21720G     COPY GTUF3003.
005177*    COPY GTUDLOGE.
005177*    COPY GTUALOGE.
030699     COPY GTUFTOT0.
002214     COPY GTUFDME.
014696*    COPY GTUFELAO.
014696     EXEC SQL INCLUDE GTUFELAO END-EXEC.
      *                                                                *
       WORKING-STORAGE SECTION.
      ******************************************************************
      *                                                                *
      *        W O R K I N G - S T O R A G E   S E C T I O N           *
      *        ---------------------------------------------           *
      ******************************************************************
      *
       01  DATA-ESCL-ESTERI           PIC  9(8) VALUE 19920910.
       01  DATA-ESCL-ITALIA           PIC  9(8) VALUE 19961231.

009120* CAMPO DI COMODO PER DESCRIZIONE PAESE
009120 01 WS-S-SMO0-COD-PAE-NGZ      PIC S9(3)V COMP-3 VALUE ZEROES.
014696 01 WS-PRESENZA-105-APE        PIC X     VALUE SPACES.

018880* SWITCH PER L'IDENTIFICAZIONE DEI DIVIDENDI
018880 01 SW-DVD                     PIC X     VALUE SPACES.
018880    88 DIVIDENDO                         VALUE 'S'   .

      *--------                     --------*
      *-------- VARIABILI DI LAVORO --------*
      *--------                     --------*
050399 01 WS-COMO.

050399*------------------------------------
050399*------ SOSTITUZIONE CAMPI :
050399*------------------------------------
050399*------   INDICE     CON   PGM-IND-CA
050399*------   PGM-IND3   CON   PGM-IND-CV
050399*------------------------------------
050399*  03 INDICE                     PIC 9(3).
050399*  03 PGM-IND3                   PIC 9(3).

MODTP *000726 03 PGM-IND1                   PIC 9(3).
000726   03 PGM-IND1                   PIC 9(6).
         03 PGM-IND4                   PIC 9(6).
         03 PGM-IND                    PIC 9(6).
001130*  03 PGM-IND-A                  PIC 9(3).
001130   03 PGM-IND-A                  PIC 9(6).
001130*  03 PGM-IND2-A                 PIC 9(3).
001130   03 PGM-IND2-A                 PIC 9(6).
         03 PGM-NUM-GG                 PIC 9(7).
MODTP *  03 WS-COD-TIT                 PIC X(12).
014696   03 WS-COD-TIT-COM             PIC X(12).
014696   03 PGM-GES-ELE                PIC 9(6).
014696   03 PGM-TIT-ELE                PIC 9(6).
050399   03 WS-ESENTE-1                PIC 9   VALUE 0.
050399   03 WS-ESENTE-0                PIC 9   VALUE 0.
         03 OLD-COD-TIT                PIC X(12).
         03 OLD-COD-DVS                PIC X(3).
         03 OLD-COD-DVS-IPS            PIC X(3).
         03 WS-S-ELA-COD-IST           PIC X(5).
         03 WS-S-ELA-COD-SOC-IST       PIC S9(5)V COMP-3.
MIGR     03 WS-S-ELA-COD-FON           PIC X(2).
         03 WS-S-ELA-COD-LIN       PIC S9(2)V COMP-3.
25611G   03 WS-RATEO-NEW           PIC S9(10)V9(8)  COMP-3.
25611G   03 WS-RATEO-TOTALE        PIC S9(10)V9(8)  COMP-3.
25611G   03 WS-RATEO-PARZIALE      PIC S9(10)V9(8)  COMP-3.
25611G   03 PGM-RIT-FIS-PRE        PIC  S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  WS-DATA-DEC           PIC  9(08)   VALUE ZEROES.
25611G   03  WS-DATA-LAZ           PIC  9(08)   VALUE ZEROES.
25611G   03  WS-RIT-PARZIALE       PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  WS-RIT-TOTALE         PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  WS-RIT-NEW            PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  WS-DEDUC-POS          PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  WS-DEDUC-PRE          PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  PGM-DEDUC-PRE         PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  PGM-DEDUC-POS         PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  PGM-RAT-VEND-PRE      PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
25611G   03  PGM-RAT-VEND-POS      PIC S9(15)V9(3) COMP-3 VALUE ZEROES.
002642*  03 WS-EOF                     PIC 9.
         03 WS-LETT                    PIC 9.
         03 ELABORA                    PIC 9.
         03 COMODO-DATA-ROV            PIC  9(8).
         03 COM-LGS-FLG-CED-DVS        PIC X.
         03 COM-LGS-FLG-RIM-DVS        PIC X.
         03 COM-LGS-FLG-DIS-DVD        PIC X.
FS       03 COM-LGS-FLG-DVS            PIC X.
MODTP    03 COM-CCC-COD-IST            PIC X(5).
MODTP    03 COM-CCC-COD-SOC-IST        PIC S9(5)V COMP-3.
MIGR     03 COM-CCC-COD-FON            PIC X(2).
MODTP    03 COM-CCC-COD-LIN            PIC S9(2)V COMP-3.
MODTP    03 COM-CCC-COD-DVS            PIC X(3).
MODTP    03 COM-CCC-TIP-CCC            PIC X(1).
MODTP    03 COM-CCC-COD-FIL            PIC X(5).
MODTP    03 COM-CCC-NUM-CCC            PIC S9(10)V COMP-3.
17302G   03 COM-CCC-CAT                PIC X(5).
000717   03 COM-LIV-CCC                PIC X(1) VALUE 'L'.
000717   03 GES-CCC-COD-DVS            PIC X(3).
000717   03 GES-CCC-TIP-CCC            PIC X(1).
000717   03 GES-CCC-COD-FIL            PIC X(5).
000717   03 GES-CCC-NUM-CCC            PIC S9(10)V COMP-3.
17302G   03 GES-CCC-CAT                PIC X(5).
MODTP    03 COM-CCC-IPS-COD-IST        PIC X(5).
MODTP    03 COM-CCC-IPS-COD-SOC-IST    PIC S9(5)V COMP-3.
MIGR     03 COM-CCC-IPS-COD-FON        PIC X(2).
MODTP    03 COM-CCC-IPS-COD-LIN        PIC S9(2)V COMP-3.
MODTP    03 COM-CCC-IPS-COD-DVS        PIC X(3).
MODTP    03 COM-CCC-IPS-TIP-CCC        PIC X(1).
MODTP    03 COM-CCC-IPS-COD-FIL        PIC X(5).
MODTP    03 COM-CCC-IPS-NUM-CCC        PIC S9(10)V COMP-3.
17302G   03 COM-CCC-IPS-CAT            PIC X(5).
MODTP    03 WS-TIP-CCC                 PIC X(1).
MODTP    03 WS-COD-FIL                 PIC X(5).
MODTP    03 WS-NUM-CCC                 PIC S9(10)V COMP-3.
17302G   03 WS-CAT-CCC                 PIC X(5).
         03 COM-FND-DIV-FLG-LIT           PIC X.
         03 COM-FND-DIV-IPS-COD-DVS       PIC X(3).
         03 COM-TIT-DIV-FLG-LIT           PIC X.
         03 COM-TIT-DIV-FLG-DVS-IN        PIC X.
         03 COM-TIT-DIV-COD-DVS           PIC X(3).
         03 COM-TIT-DIV-DSC               PIC X(30).
21720G   03 FLG-TST-3                  PIC 9.
         03 WS-LETTURA-PTI             PIC 9.
         03 WS-LETFINE                 PIC 9.
         03 WS-FINE-RIGHE              PIC 9.
         03 WS-FINE-SMO                PIC 9.
         03 WS-TIT-COD-DVS             PIC X(3).
         03 DATA-RIMBORSO              PIC X(10).
         03 STM-TIP-MOV                PIC X.
         03 WS-DATA-LIMITE             PIC 9(8).
005717   03 WS-DAT-DEC                 PIC 9(8).
         03 WS-PSA-COD-GES             PIC S9(5)V COMP-3.
050399   03 WS-COMODO                  PIC S9(15)V9(3) COMP-3.
         03 PGM-COMODO                 PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-VENDITA            PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-VENDITA-SE         PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-OBBL-SE         PIC S9(15)V9(3) COMP-3.
         03 PGM-RATEO-VEND-SE       PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-VENDITA-RF         PIC S9(15)V9(3) COMP-3.
         03 PGM-IMPONIB-CNV            PIC S9(15)V9(3) COMP-3.
         03 PGM-IMPONIB1-CNV            PIC S9(15)V9(3) COMP-3.
         03 PGM-RITENUTA-FISCALE-CNV   PIC S9(15)V9(3) COMP-3.
         03 PGM-CEDOL                  PIC S9(15)V9(3) COMP-3.
         03 PGM-DISAG                  PIC S9(15)V9(3) COMP-3.
         03 PGM-TOT-QTA                PIC S9(15)V9(3) COMP-3.
         03 PGM-TOT-DISAG              PIC S9(15)V9(3) COMP-3.
25611G   03 NEW-SCART-PRE             PIC  S9(15)V9(3) COMP-3.
25611G   03 NEW-SCART-VEN-PRE         PIC  S9(15)V9(3) COMP-3.
25611G   03 NEW-SCART-POS             PIC  S9(15)V9(3) COMP-3.
25611G   03 NEW-SCART-VEN-POS         PIC  S9(15)V9(3) COMP-3.
25611G   03 WS-SCART-PRE              PIC  S9(15)V9(3) COMP-3.
25611G   03 WS-IMPONIBILE              PIC  S9(15)V9(3).
25611G   03 WS-IMPONIBILE-PRE          PIC  S9(15)V9(3).
25611G   03 WS-IMPONIBILE-POS          PIC  S9(15)V9(3).
25611G   03 PGM-GG-MAT-PRE             PIC  9(5).
         03 PGM-RATEO-VEND             PIC S9(15)V9(3) COMP-3.
         03 PGM-RATEO-VEND-PARZ        PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-OBBL               PIC S9(15)V9(3) COMP-3.
         03 PGM-QTA-OLD                PIC S9(15)V9(3) COMP-3.
         03 PGM-RATEO-VEND-RF          PIC S9(15)V9(3) COMP-3.
         03 WS-PRG-MOV                 PIC S9(12)V COMP-3.
         03 WS-NAZ-TITOLO              PIC X.
         03 VALORE-NOMINALE            PIC S9(15)V9(3) COMP-3.
         03 VALORE-NOMINALE-GES        PIC S9(15)V9(3) COMP-3.
         03 NUMERO-AZIONI              PIC S9(15)V9(3) COMP-3.
         03 WS-CEDOLA-PRESTITO         PIC S9(15)V9(3) COMP-3.
         03 WS-IMPORTO-CEDOLA          PIC S9(15)V9(3) COMP-3.
MODTP    03 WS-CAMBIO                  PIC S9(9)V9(9) COMP-3.
         03 WK-IMP-CED-EST             PIC S9(15)V9(3) COMP-3.
         03 WS-IMP-CED-EST-CNV         PIC S9(15)V9(3) COMP-3.
000308*  03 WS-IMPORTO-DIVIDENDO       PIC S9(15)V9(3) COMP-3.
000308   03 WS-IMPORTO-DIVIDENDO       PIC S9(14)V9(4) COMP-3.
         03 WS-IMPORTO-RATEO           PIC S9(15)V9(3) COMP-3.
         03 WS-TOT-NMN-PRESTITO        PIC S9(15)V9(3) COMP-3.
         03 WS-TOT-CED-PRESTITO        PIC S9(15)V9(3) COMP-3.
         03 VALORE-RIMBORSO            PIC S9(15)V9(3) COMP-3.
MODTP    03 VALORE-RIMBORSO-GES        PIC S9(15)V9(3) COMP-3.
         03 WS-COD-DVS                 PIC X(3).
         03 WS-COD-DVS-FLG-DVS-IN      PIC X.
         03 WS-COD-DVS-FLG-LIT         PIC X.
         03 WS-COD-CAU                 PIC X(3).
         03 WS-DATA-VLT                PIC X(10).
014696   03 WS-DAT-ULT-ELAB            PIC X(10).
014696   03 WS-DAT-ULT-ELAB-8          PIC X(08).
         03 WS-DATA                    PIC 9(8).
         03 WS-STACCO-CEDOLA           PIC X.
         03 COM-DATA                   PIC X(10).
         03 WS-TIP-DSP                 PIC X.
         03 WS-VAL-NMN                 PIC S9(15)V9(3) COMP-3.
         03 WS-IMP                     PIC S9(15)V9(3) COMP-3.
         03 WS-COM-IMP                 PIC S9(15)V9(3) COMP-3.
         03 RATEO-MATURATO             PIC S9(15)V9(3) COMP-3.
         03 RATEO-DEDUCIBILE           PIC S9(15)V9(3) COMP-3.
         03 PGM-TOT-DISAGG              PIC S9(15)V9(3) COMP-3.
         03 PGM-COM-IMP1                PIC S9(15)V9(3) COMP-3.
         03 PGM-COM-IMP                 PIC S9(15)V9(3) COMP-3.
         03 PGM-COM-IMP-OLD             PIC S9(15)V9(3) COMP-3.
         03 PGM-IMPONIB                 PIC S9(15)V9(3) COMP-3.
         03 PGM-IMPONIB1                PIC S9(15)V9(3) COMP-3.
         03 WS-CALC-DISAG              PIC S9(15)V9(3) COMP-3.
         03 PGM-AGGI-DISAG              PIC S9(15)V9(3) COMP-3.
         03 PGM-AGGI-DISAG-CNV               PIC S9(15)V9(3) COMP-3.
         03 PGM-AGGI-DISAG-LINEA-CNV    PIC S9(15)V9(3) COMP-3.
         03 WS-COM2-QNT-VAL-NMN        PIC S9(15)V9(3) COMP-3.
         03 WS-COM1-QNT-VAL-NMN        PIC S9(15)V9(3) COMP-3.
         03 WS-IMP-CED-EST             PIC S9(15)V9(3) COMP-3.
25611G   03 WS-IMP-CED-EST-PRE         PIC S9(15)V9(3) COMP-3.
25611G   03 WS-IMP-CED-EST-POS         PIC S9(15)V9(3) COMP-3.
         03 WS-TOT-DEDUC               PIC S9(15)V9(3) COMP-3.
         03 PGM-TOT-DEDUC              PIC S9(15)V9(3) COMP-3.
         03 WS-GG-VITA                 PIC 9(5).
         03 NUM-GG                     PIC 9(5).
         03 GG-BASE                    PIC 9(5).
         03 WS-GG-MATURATI             PIC S9(15)V9(3)  COMP-3.
030699*  03 PGM-DIETIMO                PIC S9(15)V9(3) COMP-3.
030699   03 PGM-DIETIMO                PIC S9(09)V9(9) COMP-3.
050399*  03 WS-RITENUTA-FISCALE        PIC S9(15)V9(3) COMP-3.
050399*  03 TOT-RITENUTA-FISCALE-LINEA  PIC S9(15)V9(3) COMP-3.
         03 TOT-RITENUTA-FISCALE        PIC S9(15)V9(3) COMP-3.
         03 TOT-RITENUTA-FISCALE-LINEA-CNV  PIC S9(15)V9(3) COMP-3.
018644   03 WS-DAT-ATT                  PIC 9(8) VALUE ZEROES.
         03 WS-COM1-DATA                PIC 9(8).
         03 WS-COM2-DATA                PIC 9(8).
         03 WS-COM3-DATA                PIC 9(8).
         03 WS-COM4-DATA                PIC 9(8).
         03 WS-COM5-DATA                PIC 9(8).
         03 COM-CCC                     PIC X(100) .
290199   03 DT-APPLICAZIONE             PIC X(10).
290199   03 WS-SW-ESCI                  PIC 9 .
290199   03 WS-SCD                      PIC 9(8).
290199   03 WS-DEC                      PIC 9(8).
290199   03 WSX-DATA-8.
290199      05 WSX-DATA-8-GG            PIC 9(2).
290199      05 WSX-DATA-8-MM            PIC 9(2).
290199      05 WSX-DATA-8-SSAA          PIC 9(4).
001053   03 WS-DAT-LAZ-8                PIC 9(8).

005456   03 FLG-PSE-QTA-VAL-NMN-RE      PIC X(1).
006390   03 WS-RIT-FIS                  PIC S9(15)V9(3) COMP-3.
006390   03 WS-ABIL-PERS-91             PIC X     VALUE SPACES.
008106   03 WS-ABIL-PERS-105            PIC X     VALUE SPACES.
009725   03 WS-ABIL-PERS-116            PIC X     VALUE SPACES.
006390   03 WS-TROVA-FPI                PIC X     VALUE SPACES.
006390   03 WS-P-I-FACTOR               PIC S9(9)V9(9)  VALUE ZEROES.
006390   03 WS-COM-IMP-F                PIC S9(15)V9(3) VALUE ZEROES.
006390   03 WS-TOT-DISAG-F              PIC S9(15)V9(3) VALUE ZEROES.
006390   03 WS-COM-IMP1-F               PIC S9(15)V9(3) VALUE ZEROES.
006390   03 WS-IMPONIB1-F               PIC S9(15)V9(3) VALUE ZEROES.
006390   03 WS-AGGI-DISAG-F             PIC S9(15)V9(3) VALUE ZEROES.
006390   03 WS-FLG-TBFPI                PIC X     VALUE 'N'.
006390   03 WS-FLG-PRIMA-TST-0          PIC X     VALUE 'N'.
006390   03 WS-FLG-PRIMA-TST-1          PIC X     VALUE 'N'.
006390   03 WS-CAMBIO-F                 PIC S9(9)V9(9) VALUE ZEROES.
006390   03 WSN-TAS                     PIC S9(2)V9(2) VALUE ZEROES.
008106   03 WS-QTA-TOTALE-F             PIC S9(15)V9(3) VALUE ZEROES.
008106   03 WS-TIPO-OPE                 PIC X(01)      VALUE SPACES.

006136*77  PGM-GG-MAT          PIC 9(5).
006136 77  PGM-GG-MAT          PIC 9(5)                VALUE ZEROES.
006136*77  PGM-GG-MAT-OLD      PIC 9(5).
006136 77  PGM-GG-MAT-OLD      PIC 9(5)                VALUE ZEROES.
006136*77  PGM-GG-MAT-NEW      PIC 9(5).
006136 77  PGM-GG-MAT-NEW      PIC 9(5)                VALUE ZEROES.
       77  WS-NOME-PGM         PIC X(8)                VALUE 'GFUWM300'.
030699*77  PGM-DIETIMO-NEW     PIC S9(6)V9(7).
030699*77  PGM-DIETIMO-NEW     PIC S9(9)V9(9).
280799 77  PGM-DIETIMO-NEW     PIC S9(9)V9(9)          VALUE ZEROES.
006136*77  PGM-GG-VITA         PIC 9(5).
006136 77  PGM-GG-VITA         PIC 9(5)                VALUE ZEROES.
006136*77  PGM-GG-VITA-RES     PIC 9(5).
006136 77  PGM-GG-VITA-RES     PIC 9(5)                VALUE ZEROES.
006136*77  PGM-DIFF            PIC S9(15)V9(3) COMP-3.
006136 77  PGM-DIFF            PIC S9(15)V9(3) COMP-3  VALUE ZEROES.
006136*77  WS-STAMPA-RIP       PIC 9.
006136 77  WS-STAMPA-RIP       PIC 9                   VALUE ZEROES.
3092   77  WS-GIORNI           PIC 9(02)               VALUE ZEROES.
3092   77  WS-FLG-PAE          PIC 9(02)               VALUE ZEROES.
3092   77  FL-EXIT             PIC 9                   VALUE ZEROES.
3092   77  SW-FINE             PIC 9                   VALUE ZEROES.
006136*77  WS-DAT-COM          PIC 9(8).
006136*77  WS-DAT-COM1         PIC 9(8).
006136*77  WS-DAT-COM2         PIC 9(8).
006136*77  WS-DAT-COM3         PIC 9(8).
006136*77  WS-DAT-COM4         PIC 9(8).
006136*77  WS-DAT-COM5         PIC 9(8).
006136*77  WS-DAT-COM6         PIC 9(8).
006136*77  WS-DAT-COM7         PIC 9(8).
006136 77  WS-DAT-COM          PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM1         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM2         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM3         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM4         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM5         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM6         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM7         PIC 9(8)                VALUE ZEROES.
25611G 77  WS-DAT-COM8         PIC 9(8)                VALUE ZEROES.
008918 77  WS-DAT-COM10X       PIC X(10)               VALUE SPACES.
010173 77  WS-DAT-COM20X       PIC X(10)               VALUE SPACES.
006136* 030699 77  WS-DAT-COM9         PIC 9(8).
006136* 030699 77  WS-DAT-COM10        PIC 9(8).
006136 77  WS-DAT-COM9         PIC 9(8)                VALUE ZEROES.
006136 77  WS-DAT-COM10        PIC 9(8)                VALUE ZEROES.
006026 77  WS-FLG-IND4         PIC X(1)                VALUE SPACES.

030699 77  PGM-GG-PRE                 PIC  S9(06)      VALUE ZEROES.
030699 77  PGM-GG-POS1                PIC  S9(06)      VALUE ZEROES.
030699 77  PGM-GG-POS2                PIC  S9(06)      VALUE ZEROES.
030699 77  PGM-SCART-PRE              PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-POS              PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-PRE-DAY          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-POS-DAY          PIC  S9(15)V9(3) VALUE ZEROES.
000781 77  PGM-SCART-PRE-VEND-DAY     PIC  S9(15)V9(3) VALUE ZEROES.
000781 77  PGM-SCART-POS-VEND-DAY     PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-TAS-RIT-FIS            PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-IMP-TOT          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-RATEO-IMP-TOT          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-IMP-RIT          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-RATEO-IMP-RIT          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-IMP-PRE      PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-IMP-POS      PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-IMP-PRE-FON      PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-IMP-POS-FON      PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-PRE          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-POS          PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-POS1         PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-SCART-MAT-POS2         PIC  S9(15)V9(3) VALUE ZEROES.
030699 77  PGM-COM-VENDITA            PIC  S9(15)V9(3) VALUE ZEROES.
006136* 000745 77  COM-IMP-LIT                PIC  S9(15).
006136 77  COM-IMP-LIT                PIC  S9(15)      VALUE ZEROES.
006136* 000745 77  COM-IMP-DVS                PIC  S9(15)V9(3).
006136 77  COM-IMP-DVS                PIC  S9(15)V9(3) VALUE ZEROES.
006136*77  W-ENGIDB-RC                PIC  +9(3).
006136 77  W-ENGIDB-RC                PIC  +9(3)       VALUE ZEROES.
20515G 77  WS-ABIL-PERS-521           PIC  X           VALUE SPACES.

      *------------------------------------------------------
050399*     TABELLA PER CALCOLO CEDOLA ACQUISTI
050399*01 TAB-ACQUISTI-RF.
050399* 05 TAB-EL-MOV-RF             OCCURS 100 TIMES.
050399*  10 TAB-TIT-RF               PIC X(012).
050399*  10 TAB-DT-VAL-RF            PIC X(10).
050399*  10 TAB-PROGR-RF             PIC 9(007).
050399*  10 TAB-NUM-GG-RF            PIC 9(003).
050399*  10 TAB-BASE-GG-RF           PIC 9(003).
050399*  10 TAB-NOM-RF               PIC 9(015)V9(003).
      *------------------------------------------------------
050399*     TABELLA PER CALCOLO CEDOLA ACQUISTI
050399 01  TAB-ACQUIST.
221199*    05 TAB-EL-MOV    OCCURS 100 TIMES.
221199*001130    05 TAB-EL-MOV    OCCURS 500 TIMES.
001130     05 TAB-EL-MOV    OCCURS 5000 TIMES.
050399       10 TAB-TIT     PIC X(12).
050399       10 TAB-DT-VAL  PIC X(10).
050399       10 TAB-PROGR   PIC S9(12)V COMP-3.
050399       10 TAB-NUM-GG  PIC 9(5).
050399       10 TAB-BASE-GG PIC 9(5).
050399       10 TAB-NOM     PIC S9(15)V9(3).
050399       10 TAB-FONDO   PIC S9(2)V COMP-3.
25611G       10 TAB-NUM-X   PIC 9(5).
25611G       10 TAB-BAS-X   PIC 9(5).
      *
      * TABELLA PER CALCOLO SCARTO DI EMISSIONE
      *
       01 TAB-ACQUISTI-SE.
221199* 05 TAB-EL-MOV-SE              OCCURS 100 TIMES.
221199*001130  05 TAB-EL-MOV-SE              OCCURS 500 TIMES.
001130  05 TAB-EL-MOV-SE              OCCURS 5000 TIMES.
         10 TAB-NUM-GG-SE             PIC 9(007).
         10 TAB-NUM-GG-OLD-SE         PIC 9(007).
         10 TAB-NOM-SE                PIC S9(015)V9(003).
030699   10 TAB-VLT-SE                PIC X(10).

      * TABELLA PSA
       01 TAB-PSA.
          05 TAB-ELE-PSA                OCCURS 10000 TIMES.
             10 TAB-PSA-COD-TIT           PIC X(12).
             10 TAB-PSA-QTA-TOT           PIC S9(15)V9(3).
MODTP *5847R  05 TAB-ELE-PSA-GES            OCCURS 30000 TIMES.
05847R    05 TAB-ELE-PSA-GES            OCCURS 35000 TIMES.
MODTP        10 TAB-PSA-GES-COD-GES           PIC 9(5).
MODTP        10 TAB-PSA-GES-COD-TIT           PIC X(12).
MODTP        10 TAB-PSA-GES-QTA-TOT           PIC S9(15)V9(3).
MODTP        10 TAB-PSA-GES-QTA-DEP           PIC S9(15)V9(3).

      * DEFINISCO I CAMPI DI COMODO PER LA STAMPA

       01 WS-STAMPA.
        03 RATEO1                    PIC X.
        03 SCARTO0                   PIC X.
        03 TOTALI-ST0                PIC X.
        03 TOTALI-ST1                PIC X.
050399* 03 S-RIGHE1                  PIC 9(3).
050399* 03 S-RIGHE0                  PIC 9(3).
050399  03 CTR-RIGHE-1               PIC 9(3).
050399  03 CTR-RIGHE-0               PIC 9(3).
21720G  03 CTR-RIGHE-3               PIC 9(3).
        03 ST0-SPAZIO                PIC 9.
        03 ST1-SPAZIO                PIC 9.
21720G  03 ST3-SPAZIO                PIC 9.
050399* 03 FLG-TESTATA-ST0           PIC 9.
050399* 03 FLG-TESTATA-ST1           PIC 9.
050399  03 WS-FLG-TST-0              PIC X   VALUE SPACES.
050399  03 WS-FLG-TST-1              PIC X   VALUE SPACES.
21720G  03 WS-FLG-TST-3              PIC X   VALUE SPACES.
050399* 03 S-NUM-PAG0                PIC 9(4).
050399* 03 S-NUM-PAG1                PIC 9(4).
050399  03 WS-NUM-PAG-0              PIC 9(4).
050399  03 WS-NUM-PAG-1              PIC 9(4).
21720G  03 WS-NUM-PAG-3              PIC 9(4).

      * DEFINISCO I CAMPI DI COMODO PER LA STAMPA
003572*
003572*01 GFUASTAM0.
003572* 05 DTA-STM0                 PIC X(133).
003572* 05 WK-TXT-STM-0.
003572*  10 COD-IST-STM0            PIC 9(5).
003572*  10 SOC-IST-STM0            PIC 9(5).
MIGR72*  10 COD-FON-STM0            PIC X(2).
003572*  10 COD-LIN-STM0            PIC 9(2).
003572*  10 COD-GES-STM0            PIC 9(5).
003572*  10 NOM-PGM-STM0            PIC X(8).
003572*  10 NOM-ESM-STM0            PIC X(8).
003572*  10 DAT-PRG-STM0            PIC 9(8).
003572*  10 DAT-ELA-STM0            PIC 9(8).
003572*  10 NUM-RIG-STM-0           PIC 9(8).
003572*  10 NUM-TAB-STM0            PIC 9(5).
003572*  10 FLG-STM0                PIC X(1).
003572*  10 FILLER                  PIC X(19).
003572*01 WK-STM-DSC-0              PIC X(60).
003572*
003572*01 GFUASTAM1.
003572* 05 DTA-STM1                 PIC X(133).
003572* 05 WK-TXT-STM-1.
003572*  10 COD-IST-STM1            PIC 9(5).
003572*  10 SOC-IST-STM1            PIC 9(5).
MIGR72*  10 COD-FON-STM1            PIC X(2).
003572*  10 COD-LIN-STM1            PIC 9(2).
003572*  10 COD-GES-STM1            PIC 9(5).
003572*  10 NOM-PGM-STM1            PIC X(8).
003572*  10 NOM-ESM-STM1            PIC X(8).
003572*  10 DAT-PRG-STM1            PIC 9(8).
003572*  10 DAT-ELA-STM1            PIC 9(8).
003572*  10 NUM-RIG-STM-1           PIC 9(8).
003572*  10 NUM-TAB-STM1            PIC 9(5).
003572*  10 FLG-STM1                PIC X(1).
003572*  10 FILLER                  PIC X(19).
003572*01 WK-STM-DSC-1              PIC X(60).

21720G 01 GFUASTAM3.
21720G  05 DTA-STM3                 PIC X(133).
21720G  05 WK-TXT-STM3.
21720G   10 COD-IST-STM3            PIC 9(5).
21720G   10 SOC-IST-STM3            PIC 9(5).
21720G   10 COD-FON-STM3            PIC X(2).
21720G   10 COD-LIN-STM3            PIC 9(2).
21720G   10 COD-GES-STM3            PIC 9(5).
21720G   10 NOM-PGM-STM3.
21720G      20 FILLER               PIC X.
21720G      20 COD-VER-STM3         PIC X.
21720G      20 KEY-DA-RIC-STM3      PIC X(006).
21720G   10 NOM-ESM-STM3            PIC X(8).
21720G   10 DAT-PRG-STM3            PIC 9(8).
21720G   10 DAT-ELA-STM3            PIC 9(8).
21720G   10 NUM-RIG-STM3            PIC 9(8).
21720G   10 NUM-TAB-STM3            PIC 9(5).
21720G   10 FLG-STM3                PIC X(1).
21720G      10 COD-MSG-STM3         PIC X(008).
21720G      10 COD-TOT-RIC-STM3     PIC X(003).
21720G      10 FLG-ALE-STM3         PIC X(001).
21720G      10 FLG-TST-STM3         PIC X(001).
21720G      10 KEY-RIC-STM3         PIC X(006).
21720G 01 WK-STM-DSC-3              PIC X(60).
      *
21720G* AREE RECORD PER LA STAMPA
21720G 01 RIGA-GEN-2.
21720G  03 FILLER                   PIC X(01) VALUE SPACES.
21720G  03 FILLER                   PIC X(08) VALUE 'FONDO : '.
21720G  03 COD-FONDO-2              PIC X(02) VALUE SPACES.
21720G  03 FILLER                   PIC X(01) VALUE SPACE.
21720G  03 DES-FONDO-2              PIC X(30) VALUE SPACES.
21720G  03 FILLER                   PIC X(03) VALUE SPACES.
21720G  03 FILLER                   PIC X(08) VALUE 'LINEA : '.
21720G  03 COD-LINEA-2              PIC 9(02) VALUE ZEROES.
21720G  03 FILLER                   PIC X(01) VALUE SPACE.
21720G  03 DES-LINEA-2              PIC X(30) VALUE SPACES.
21720G*
21720G 01 RIGA-INT2.
21720G  03 FILLER                   PIC X(01) VALUE SPACES.
21720G  03 FILLER                   PIC X(12) VALUE 'CODICE ISIN '.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 FILLER                   PIC X(12) VALUE 'COD. TITOLO '.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 FILLER                   PIC X(30) VALUE
21720G                            'DESCRIZIONE                   '.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 FILLER                   PIC X(23) VALUE
21720G                            '               QUANTITA'.
21720G*
21720G 01 RIGA-DETTAGLIO-2.
21720G  03 FILLER                   PIC X(01) VALUE SPACE.
21720G  03 COD-ISIN-2               PIC X(12) VALUE ZEROES.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 COD-TIT-2                PIC X(12) VALUE ZEROES.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 DSC-TIT-2                PIC X(30) VALUE SPACES.
21720G  03 FILLER                   PIC X(02) VALUE SPACES.
21720G  03 CTV-PSA-2                PIC ZZZ.ZZZ.ZZZ.ZZZ.ZZ9,999.
      *
       01 RIGO-FINALE.
        03 FILLER                   PIC X(132) VALUE ALL '-'.

       01  FINE-PAG.
           03 FILLER               PIC  X(132) VALUE ALL '-'.
3092  *-------- AREE COMODO PER RICERCA DATA BORSA -----*
3092   01 COM-DATA-BORSA.
3092     02 COMGG              PIC 9(2).
3092     02 COMMM              PIC 9(2).
3092     02 COMSSAA            PIC 9(4).

3092   01  WS-DAT-EFF-PIU1.
3092     02 GG-P             PIC 99.
3092     02 FILLER           PIC X VALUE '.'.
3092     02 MM-P             PIC 99.
3092     02 FILLER           PIC X VALUE '.'.
3092     02 SSAA-P           PIC 9999.
3092  *--------- FINE AREE X DATA BORSA --------*

011326 01 WK-GIORNI-BORSA .
011326  05  WK-GIORNI        OCCURS 31 PIC X .
011326 01 IND-BORSA          PIC 9(2).

      *-------- AREE WS DI DATI GENERALI--------*
      *--------                         --------*
160299*    COPY GTUATIT1.
           EXEC SQL INCLUDE GTGIRC END-EXEC.

      *----         GFUS3001                    ----*
050399     EXEC SQL INCLUDE  GTUATACE END-EXEC.

      *----         GFUS3000                    ----*
050399     EXEC SQL INCLUDE  GTUATASC END-EXEC.

      *----   COPY W-S CAMPI VARI X  SCARTO EMISS./CEDOLA  ----*
050399     EXEC SQL INCLUDE  GTUASCCE END-EXEC.

      *----   COPY W-S CAMPI X  NAVIGATORE TABULATI   ----*
003572     EXEC SQL INCLUDE  GTUANVTA END-EXEC.

      *----   COPY W-S CAMPI X  CALL AL PROGRAMMA GFUWMC16 ----*
005456     EXEC SQL INCLUDE GTUWPSE  END-EXEC.
      *----   COPY W-S CAMPI X  CALL AL PROGRAMMA GFUWMC35 ----*
008106     EXEC SQL INCLUDE GTUAMC35 END-EXEC.
008730     EXEC SQL INCLUDE GTUAMC36 END-EXEC.
05258G     EXEC SQL INCLUDE GTUAQTZI  END-EXEC.

3092  ******************************************************************
3092  *   AREA  DI  COMODO PER PASSAGGIO DATI A ROUTINE ESTERNA
3092  ******************************************************************
3092       EXEC SQL INCLUDE GTUADTEF  END-EXEC.
      *---------------------------------------------*
      *------- TRACCIATI TABELLE UTILIZZATE --------*
      *-------                              --------*

           EXEC SQL INCLUDE  GTSMO  END-EXEC.
3092       EXEC SQL INCLUDE  GTCAL  END-EXEC.
3092       EXEC SQL INCLUDE  GTNMN  END-EXEC.
           EXEC SQL INCLUDE  GTSTM  END-EXEC.
           EXEC SQL INCLUDE  GTSEE  END-EXEC.
           EXEC SQL INCLUDE  GTTIT  END-EXEC.
           EXEC SQL INCLUDE  GTMLQ  END-EXEC.
           EXEC SQL INCLUDE  GTLIN  END-EXEC.
           EXEC SQL INCLUDE  GTPSA  END-EXEC.
           EXEC SQL INCLUDE  GTIST  END-EXEC.
           EXEC SQL INCLUDE  GTELA  END-EXEC.
           EXEC SQL INCLUDE  GTLGS  END-EXEC.
           EXEC SQL INCLUDE  GTCCC  END-EXEC.
           EXEC SQL INCLUDE  GTENT  END-EXEC.
           EXEC SQL INCLUDE  GTDIV  END-EXEC.
           EXEC SQL INCLUDE  GTPAE  END-EXEC.
           EXEC SQL INCLUDE  GTCAU  END-EXEC.
           EXEC SQL INCLUDE  GTFND  END-EXEC.
           EXEC SQL INCLUDE  GTPTI  END-EXEC.
           EXEC SQL INCLUDE  GTCAM  END-EXEC.
           EXEC SQL INCLUDE  GTCED  END-EXEC.
           EXEC SQL INCLUDE  GTSVM  END-EXEC.
002090     EXEC SQL INCLUDE  GTMER  END-EXEC.
006390     EXEC SQL INCLUDE  GTFPI  END-EXEC.
008730     EXEC SQL INCLUDE  GTAPE  END-EXEC.
05258G     EXEC SQL INCLUDE  GTQTZ  END-EXEC.
      **********************************************
      ***** MEMBRI SQL *****************************
      **********************************************
014696*    EXEC SQL INCLUDE GTUASTND  END-EXEC.
014696     EXEC SQL INCLUDE GTUAKSTD  END-EXEC.
           EXEC SQL INCLUDE GTUAANEE  END-EXEC.
           EXEC SQL INCLUDE GTUAANVM  END-EXEC.
           EXEC SQL INCLUDE GTUACEEU  END-EXEC.
           EXEC SQL INCLUDE GTUAIMEU  END-EXEC.
      *    EXEC SQL INCLUDE GTUARACE  END-EXEC.
           EXEC SQL INCLUDE GTUATEST  END-EXEC.
3092  *14696 EXEC SQL INCLUDE GTUACHMX  END-EXEC.
014696     EXEC SQL INCLUDE GTUACHMX  END-EXEC.
3092       EXEC SQL INCLUDE GTUADTBO  END-EXEC.
           EXEC SQL INCLUDE GTWGDATE  END-EXEC.
           EXEC SQL INCLUDE GTUAFSMO  END-EXEC.
           EXEC SQL INCLUDE GTUASTAM  END-EXEC.
           EXEC SQL INCLUDE GTUAPRIO  END-EXEC.
           EXEC SQL INCLUDE GTUABLOC  END-EXEC.
           EXEC SQL INCLUDE GTUAABEN  END-EXEC.
014696*    EXEC SQL INCLUDE GTUAKEY   END-EXEC.
           EXEC SQL INCLUDE GTUACAMB  END-EXEC.
           EXEC SQL INCLUDE GTUACAUS  END-EXEC.
005177*    EXEC SQL INCLUDE GTUWLOGE  END-EXEC.
130499     EXEC SQL INCLUDE GTUACLGG  END-EXEC.
      ********************************************
MODTP      EXEC SQL INCLUDE GTPSADC4  END-EXEC.
           EXEC SQL INCLUDE GTPSADC5  END-EXEC.
3092       EXEC SQL INCLUDE GTCEDDC4  END-EXEC.
           EXEC SQL INCLUDE SQLCA     END-EXEC.
           EXEC SQL INCLUDE GTUTBERR  END-EXEC.
           EXEC SQL INCLUDE GTDIVDC2  END-EXEC.
           EXEC SQL INCLUDE GTSVMDC1  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMODCI  END-EXEC.
           EXEC SQL INCLUDE GTPTIDC1  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMODCJ  END-EXEC.
           EXEC SQL INCLUDE GTSMODC1  END-EXEC.
           EXEC SQL INCLUDE GTSMODC6  END-EXEC.
           EXEC SQL INCLUDE GTSEEDC1  END-EXEC.
           EXEC SQL INCLUDE GTELADC5  END-EXEC.
002642     EXEC SQL INCLUDE GTAPERS1  END-EXEC.
009120     EXEC SQL INCLUDE GTSMODCD  END-EXEC.
018880     EXEC SQL INCLUDE GTSMODAH  END-EXEC.

005456*-- COPY NECESSARIA PER LA VERIFICA DELLA PERS. 84 --*
005456     EXEC SQL INCLUDE GTUASPEC  END-EXEC.

014693     EXEC SQL INCLUDE GTAULTMO  END-EXEC.
05258G     EXEC SQL INCLUDE GTUAP105  END-EXEC.

       LINKAGE SECTION.
       PROCEDURE DIVISION.
      *****************************************************************
      ***                         M  A  I  N                        ***
      *****************************************************************
       MAIN-LINE.

      *--- OPERAZIONI INIZIALI --------*
           PERFORM U-A10-OPERAZIONI-INIZIALI
           THRU    U-A10-OPERAZIONI-INIZIALI-EXIT.

      *--- ELABORAZIONE----*

      D    DISPLAY 'INIZIO U-A20-ELABORAZIONE'.
           PERFORM U-A20-ELABORAZIONE
           THRU    U-A20-ELABORAZIONE-EXIT.
      *-
      D    DISPLAY 'TRATTAMENTO-LINEE'.
002642*    PERFORM U-A50-TRATTAMENTO-LINEE
      *    THRU    U-A50-TRATTAMENTO-LINEE-EXIT UNTIL WS-FL = 1
002642*    THRU    U-A50-TRATTAMENTO-LINEE-EXIT UNTIL WS-EOF = 1
002642*                                      OR SW-USC-X-BLOCCO = 'SI'.
002642     PERFORM UNTIL WS-FLG-END-SELAO = 1
002642                OR SW-USC-X-BLOCCO = 'SI'
002642        PERFORM U-A50-TRATTAMENTO-LINEE
002642        THRU    U-A50-TRATTAMENTO-LINEE-EXIT
002642        IF WS-ABIL-BLOCCO-8 = 'S'
002642           MOVE SPACES         TO SW-USC-X-BLOCCO
002642        END-IF
002642        PERFORM U-A20-ELABORAZIONE
002642        THRU    U-A20-ELABORAZIONE-EXIT
002642     END-PERFORM.
002642
006390*-- SE SONO PRESENTI CEDOLE CON POOL/INFLACTION FACTOR
006390*-- STAMPA RIGA DI NOTA APPLICAZIONE FATTORE
006390*15209G    IF WS-ABIL-PERS-91 = 'S' AND WS-FLG-TBFPI = 'S'
15209G     IF WS-ABIL-PERS-91 = 'S' AND WS-FLG-PRIMA-TST-0 = 'S'
006390        PERFORM STAMPA-NOTA-0 THRU STAMPA-NOTA-0-EXIT
006390     END-IF.

270999*--- AGGIORNA ULTIMO PROGRESSIVO
270999*014693 PERFORM ISTITUTO THRU ISTITUTO-EXIT.
      *
014693     MOVE WS-PRG-MOV TO WS-PRG-MOV-LIN
014693     PERFORM X01-AGGIORNA-PRG-MOV
014693        THRU X01-AGGIORNA-PRG-MOV-EXIT
      *
014693     PERFORM X02-AGGIORNA-TBLIN
014693        THRU X02-AGGIORNA-TBLIN-EXIT.
014711*---
014711*--- GESTIONE BLOCCO FONDO
014711*---
014711     PERFORM X110-UPD-TBELA-BLC                                   02410000
014711        THRU X110-UPD-TBELA-BLC-EXIT.
014711*-
      *--- CHIUSURA ARCHIVI ---*
           PERFORM CHIUSURA-ARCHIVI
           THRU    CHIUSURA-ARCHIVI-EXIT.
      *
      *-------------------------------------------------------------
      *---- SE VERIFICATASI CONDIZIONE DI BLOCCO FONDO/LINEA,ALLORA
      *---- IMPOSTA 'RETURN CODE = 5'.
      *-------------------------------------------------------------
           IF SW-USC-X-BLOCCO = 'SI'
           THEN
               MOVE  5    TO RETURN-CODE
           END-IF.

      *---OPERAZIONI FINALI----------*
           DISPLAY 'FINE ELABORAZIONE GFUWM300 '.
      *
       MAIN-LINE-EXIT.
           EXIT.
           STOP RUN.
      *****************************************************************
      ***                 OPERAZIONI INIZIALI                       ***
      *****************************************************************
       U-A10-OPERAZIONI-INIZIALI.
      *
006664     DISPLAY 'INIZIO ELABORAZIONE'.
           MOVE 'GFUWM300' TO WSN-SKB-PGM.

      *--- ACQUISIZIONE DATA DAL SISTEMA ---*
           PERFORM U-X01-ACQ-DAT-ELAB
           THRU    U-X01-ACQ-DAT-ELAB-EXIT.

      *--- INIZIALIZZAZIONE ---*
           PERFORM U-B10-INIZ-AREE-VARIE
           THRU    U-B10-INIZ-AREE-VARIE-EXIT.

      *---  APERTURA ARCHIVI -----*
            PERFORM U-B20-OPEN-FILE
            THRU    U-B20-OPEN-FILE-EXIT.

      D     DISPLAY 'OPERAZIONI-INIZ-EXIT'.
       U-A10-OPERAZIONI-INIZIALI-EXIT.
           EXIT.
      *****************************************************************
      ***                      INIZIALIZZAZIONE                     ***
      *****************************************************************
       U-B10-INIZ-AREE-VARIE.
      *
050399     INITIALIZE              WS-COMO.
           INITIALIZE              WS-STAMPA.
  3092     INITIALIZE              WS-PERS-R.
005456     INITIALIZE              WS-PERS-C10.
003572     INITIALIZE              GFUASTAM0.
003572     INITIALIZE              GFUASTAM1.
21720G     INITIALIZE              GFUASTAM3.
003572     INITIALIZE              WK-TXT-STM-0
003572     INITIALIZE              WK-TXT-STM-1.
050399     INITIALIZE              WK-STM-DSC-0.
050399     INITIALIZE              WK-STM-DSC-1.
21720G     INITIALIZE              WK-STM-DSC-3.
05258G     INITIALIZE              DCLTBQTZ    .
014696*    INITIALIZE              DCLTBPSA.
014696*    INITIALIZE              DCLTBENT.
014696*    INITIALIZE              DCLTBSEE.
014696*    INITIALIZE              DCLTBSMO.
014696*    INITIALIZE              DCLTBMLQ.
014696*    INITIALIZE              DCLTBIST.
014696*    INITIALIZE              DCLTBELA.
014696*    INITIALIZE              DCLTBLGS.
014696*    INITIALIZE              DCLTBCCC.
014696*    INITIALIZE              DCLTBENT.
014696*    INITIALIZE              DCLTBPAE.
014696*    INITIALIZE              DCLTBCAU.
014696*    INITIALIZE              DCLTBFND.
014696*    INITIALIZE              DCLTBPTI.
014696*    INITIALIZE              DCLTBCAM.
014696*    INITIALIZE              DCLTBCED.
014696*    INITIALIZE              DCLTBDIV.
014696*    INITIALIZE              DCLTBTIT.
014696*    INITIALIZE              DCLTBSVM.

050399     MOVE 0 TO WS-COMODO.
050399     MOVE 0 TO WS-NUM-PAG-0
050399               WS-NUM-PAG-1
21720G               WS-NUM-PAG-3.

3092       MOVE  0  TO WS-FLG-PAE.
050399*    MOVE 1 TO INDICE.
014696*    --------------------------------------------
014696*    LE TABELLE CHE SEGUONO NON VENGONO AZZERATE
014696*    IL RIEMPIMENTO E LA RICERCA AVVIENE DENTRO LA
014696*              COPY  GTUSCASC
014696*    --------------------------------------------
050399*14696 MOVE 1 TO PGM-IND-CA.
050399*    PERFORM INIZ-TAB-RF THRU INIZ-TAB-RF-EXIT
050399*14696 PERFORM INIZ-TAB    THRU INIZ-TAB-EXIT
221199*001130VARYING PGM-IND-CA FROM 1 BY 1 UNTIL (PGM-IND-CA > 500 ).
001130*14696 VARYING PGM-IND-CA FROM 1 BY 1 UNTIL (PGM-IND-CA > 5000).
221199*    VARYING PGM-IND-CA FROM 1 BY 1 UNTIL (PGM-IND-CA > 100 ).

014696*    MOVE 1 TO PGM-IND-A.
014696*    PERFORM INIZ-TAB-SE THRU INIZ-TAB-SE-EXIT
221199*001130  VARYING PGM-IND-A FROM 1 BY 1 UNTIL (PGM-IND-A > 500 ).
001130*14696 VARYING PGM-IND-A FROM 1 BY 1 UNTIL (PGM-IND-A > 5000).
221199*    VARYING PGM-IND-A FROM 1 BY 1 UNTIL (PGM-IND-A > 100 ).
           MOVE 0 TO PGM-IND-A
                     PGM-IND-CA
                     CTR-RIGHE-1
                     CTR-RIGHE-0
21720G               CTR-RIGHE-3
MODTP                COM-CCC-COD-IST
221298               PGM-TOT-DEDUC
MODTP                COM-CCC-COD-SOC-IST
MODTP                COM-CCC-COD-FON
MODTP                COM-CCC-COD-LIN
MODTP                COM-CCC-COD-DVS
MODTP                COM-CCC-TIP-CCC
MODTP                COM-CCC-COD-FIL
MODTP                COM-CCC-NUM-CCC
MODTP                COM-CCC-IPS-COD-IST
MODTP                COM-CCC-IPS-COD-SOC-IST
MODTP                COM-CCC-IPS-COD-FON
MODTP                COM-CCC-IPS-COD-LIN
MODTP                COM-CCC-IPS-COD-DVS
MODTP                COM-CCC-IPS-TIP-CCC
MODTP                COM-CCC-IPS-COD-FIL
MODTP                COM-CCC-IPS-NUM-CCC
24391G               COM-CCC-IPS-CAT
17302G               COM-CCC-CAT.
008730*14696INITIALIZE AREA-MC35.
008730*14696INITIALIZE AREA-MC36.
      *
       U-B10-INIZ-AREE-VARIE-EXIT.
           EXIT.
      ****************************************************************
       INIZ-TAB.
      *
           MOVE SPACE TO TAB-TIT(PGM-IND-CA).
           MOVE SPACE TO TAB-DT-VAL(PGM-IND-CA).
           MOVE 0 TO TAB-PROGR(PGM-IND-CA).
           MOVE 0 TO TAB-NUM-GG(PGM-IND-CA).
           MOVE 0 TO TAB-BASE-GG(PGM-IND-CA).
           MOVE 0 TO TAB-NOM(PGM-IND-CA).
050399     MOVE 0 TO TAB-FONDO(PGM-IND-CA).
      *
       INIZ-TAB-EXIT.
            EXIT.
      *****************************************************************
       INIZ-TAB-SE.
      *
           MOVE 0 TO TAB-NUM-GG-SE(PGM-IND-A).
           MOVE 0 TO TAB-NOM-SE(PGM-IND-A).
      *
       INIZ-TAB-SE-EXIT.
            EXIT.
      ****************************************************************
      ***                     APERTURA ARCHIVI                      ***
      *****************************************************************
       U-B20-OPEN-FILE.
      *
      *---- APERTURA FILE DI INPUT---*
           OPEN INPUT SELAO.

      *----- APERTURA FILE DI OUTPUT----*
           OPEN OUTPUT SMLQ0.
014696*    OPEN OUTPUT SMLQ1.
           OPEN OUTPUT SMO0.
           OPEN OUTPUT S3000.
           OPEN OUTPUT S3001.
21720G     OPEN OUTPUT S3003.
030699     OPEN OUTPUT STOT0.
002214     OPEN OUTPUT SDME.
005177*    PERFORM X01-OPEN-LOGER
005177*    THRU    X01-OPEN-LOGER-EX.
018605     INITIALIZE              REC-SMLQ0.
018605     INITIALIZE              REC-SMO0.
      *
       U-B20-OPEN-FILE-EXIT.
           EXIT.
      ****************************************************************
      *       ROUTINE DI LETTURA DATA SOLARE                        *
      ****************************************************************
       U-X01-ACQ-DAT-ELAB.
      *
           PERFORM Y99-DAT-SOL THRU Y99-DAT-SOL-EX.
      *
       U-X01-ACQ-DAT-ELAB-EXIT.
           EXIT .
      ******************************************************************
      *        INIZIO ELABORAZIONE                                    **
      ******************************************************************
       U-A20-ELABORAZIONE.
006664D    DISPLAY ' LETTURA DEL RECORD DI SELAO'.
002642*    READ SELAO AT END
002642*      MOVE 1 TO WS-EOF.
002642*--- LETTURA SELAO CON SCARTO BLOCCO FONDO 8
002642     PERFORM B37-READ-SELAO
002642        THRU B37-READ-SELAO-EXIT.
      *
       U-A20-ELABORAZIONE-EXIT.
           EXIT.
      ***************************************************************
      *           CICLO DI LETTURA DI SELAO                         *
      ***************************************************************
       U-A60-LEGGI.
      *
      D    DISPLAY 'U-A60-LEGGI'.
      D    DISPLAY 'FLG DI SELAO  = ' S-ELA-FLG-ELA.
      D    DISPLAY 'S-ELA-COD-IST  ' S-ELA-COD-IST
      D    DISPLAY 'S-ELA-COD-SOC-IST  ' S-ELA-COD-SOC-IST
      D    DISPLAY 'S-ELA-COD-FON  ' S-ELA-COD-FON
      D    DISPLAY 'S-ELA-COD-LIN ' S-ELA-COD-LIN
      D    DISPLAY 'IST-COD-IST  ' IST-COD-IST
      *
      *  ROTTURA DI CHIAVE ISTITUTO  ESEGUE LA ROUTINE ISTITUTO
      *    PER REPERIRE  IL PROGRESSIVO MOVIMENTO
014696     MOVE S-ELA-COD-IST        TO WS-COD-ISTX
014696     MOVE S-ELA-COD-SOC-IST    TO WS-COD-SOC-ISTN
014696     MOVE S-ELA-COD-FON        TO WS-COD-FONN
014696     MOVE S-ELA-COD-LIN        TO WS-COD-LINN

            IF S-ELA-COD-IST NOT = IST-COD-IST OF DCLTBIST
270999*        MOVE S-ELA-COD-IST TO IST-COD-IST

014693*        PERFORM ISTITUTO THRU ISTITUTO-EXIT

270999         MOVE S-ELA-COD-IST    TO IST-COD-IST
270999* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
270999         MOVE 'TBISTSL1'       TO WSN-SKB-COPY
270999         MOVE  'Y01-SEL-TBIST' TO WSN-SKB-LABEL
270999         MOVE 'TBIST'          TO WSN-SKB-TABELLA
270999         MOVE 'SELECT'         TO WSN-SKB-FUNZIONE
270999*14696   INITIALIZE WS-IMPO-FONDO
270999*14696   MOVE IST-COD-IST TO WS-COD-ISTX
270999*14696   PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES           TO WSN-SKB-CHIAVE-DATI
270999         STRING WS-KEY-BANCA
270999         DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
270999         PERFORM Y01-SEL-TBIST THRU Y01-SEL-TBIST-EXIT

270999         IF ENGIRC-NOTF-ENDFILE
270999            PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
270999         END-IF
002642*
002642*--- VERIFICA ABILITAZIONE BLOCCO FONDO
002642        MOVE SPACES            TO SW-USC-X-BLOCCO
002642        PERFORM VERIFICA-ABIL-BLOCCO-8
002642           THRU VERIFICA-ABIL-BLOCCO-8-EXIT

270999*14693   MOVE IST-PRG-ULT-MOV  OF DCLTBIST TO WS-PRG-MOV

      * RICHIAMO LA ROUTINE PRIORITA' DI STAMPA PER ENTRAMBI I TABULATI
               PERFORM PRIORITA-S3001
               THRU    PRIORITA-S3001-EXIT
               PERFORM PRIORITA-S3000
               THRU    PRIORITA-S3000-EXIT
21720G         PERFORM PRIORITA-S3003
21720G         THRU    PRIORITA-S3003-EXIT

      * PRIORITA' DEL FILE SEGNALAZIONE
005177*       INITIALIZE GFUALOGE
005177*       MOVE IST-COD-IST TO CG-COD-IST-LOGE
005177*       PERFORM X01-LETT-STM-LOGE
005177*       THRU    X01-LETT-STM-LOGE-EX

              MOVE IST-COD-IST TO CG-CEREUR-COD-IST
              PERFORM X01-CERCA-EURO THRU X01-CERCA-EURO-EXIT
              MOVE CG-CEREUR-COD-EUR TO CG-CONEUR-COD-EUR

              MOVE IST-DAT-RIF-CNV OF DCLTBIST
                                           TO CG-CONEUR-DAT-RIF-CNV
            END-IF.
      * A ROTTURA DI CHIAVE FONDO  SEL SU TBFND
      *   PER DETERMINARE FND-COD-DVS

            IF   S-ELA-COD-IST     NOT =  FND-COD-IST OF DCLTBFND     OR
                 S-ELA-COD-SOC-IST NOT =  FND-COD-SOC-IST OF DCLTBFND OR
                 S-ELA-COD-FON     NOT =  FND-COD-FON OF DCLTBFND

               MOVE S-ELA-COD-IST        TO FND-COD-IST     OF DCLTBFND
               MOVE S-ELA-COD-SOC-IST    TO FND-COD-SOC-IST OF DCLTBFND
               MOVE S-ELA-COD-FON        TO FND-COD-FON     OF DCLTBFND

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
               MOVE ' TBFNDSL1 '      TO WSN-SKB-COPY
               MOVE ' Y01-SEL-TBFND ' TO WSN-SKB-LABEL
               MOVE ' TBFND '         TO WSN-SKB-TABELLA
               MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
014696*        INITIALIZE WS-IMPO-FONDO
014696*        MOVE  FND-COD-IST      TO WS-COD-SOC-ISTX
014696*        MOVE  FND-COD-SOC-IST  TO WS-COD-SOC-ISTN
014696*        MOVE  FND-COD-FON      TO WS-COD-FONN
014696*        PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES           TO WSN-SKB-CHIAVE-DATI
               STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
               DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

               PERFORM Y01-SEL-TBFND THRU  Y01-SEL-TBFND-EXIT

               IF ENGIRC-NOTF-ENDFILE
                 PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
               END-IF

014696         MOVE S-ELA-DAT-ULT-ELA(7:4) TO WS-DAT-ULT-ELAB-8 (1:4)
014696         MOVE S-ELA-DAT-ULT-ELA(4:2) TO WS-DAT-ULT-ELAB-8 (5:2)
014696         MOVE S-ELA-DAT-ULT-ELA(1:2) TO WS-DAT-ULT-ELAB-8 (7:2)
014696
014696D    DISPLAY 'S-ELA-COD-SOC-IST =' S-ELA-COD-SOC-IST
014696D    DISPLAY 'S-ELA-COD-FON     =' S-ELA-COD-FON
014696D    DISPLAY 'S-ELA-COD-LIN     =' S-ELA-COD-LIN
014696D    DISPLAY 'S-ELA-DAT-ULT-ELA =' S-ELA-DAT-ULT-ELA
014696
005456         MOVE 'N' TO CG-SPEC-ABIL-VEN-SCO
005456         PERFORM VERIFICA-ABILITAZIONE-84
005456            THRU VERIFICA-ABILITAZIONE-84-EXIT
009725         MOVE 'N' TO WS-ABIL-PERS-116
009725         PERFORM VERIFICA-ABILITAZIONE-116
009725            THRU VERIFICA-ABILITAZIONE-116-EXIT

                 MOVE S-ELA-COD-IST  TO DIV-COD-IST OF DCLTBDIV
                 MOVE FND-COD-DVS OF DCLTBFND
                                     TO DIV-COD-DVS OF DCLTBDIV
      * SELECT SU TBDIV
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*          MOVE ' TBDIVSL1 '      TO WSN-SKB-COPY
014696*          MOVE ' Y01-SEL-TBDIV ' TO WSN-SKB-LABEL
014696*          MOVE ' TBDIV '         TO WSN-SKB-TABELLA
014696*          MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
014696*          INITIALIZE WS-IMPO-FONDO
014696*          MOVE  DIV-COD-IST      TO WS-COD-ISTX
014696*          MOVE  DIV-COD-DVS      TO WS-COD-DVSX
014696*          PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*          STRING WS-KEY-BANCA    WS-KEY-DIVISA
014696*           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
014696*
014696* NON OCCORRE IMPOSTARE CAMPI DI ERRORE  - SELECT MODIFICATA
                 PERFORM Y01-SEL-TBDIV THRU  Y01-SEL-TBDIV-EXIT

                 IF ENGIRC-NOTF-ENDFILE
                   MOVE 'B0015'           TO CG-BLOCFON-MOTIVO
                   MOVE 'SELECT'          TO CG-BLOCFON-NOTE
                   MOVE 'LETTURA DIVISA FONDO       '
                                      TO CG-BLOCFON-FASE
                   MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
                   MOVE S-ELA-COD-IST       TO CG-BLOCFON-COD-IST
                   MOVE S-ELA-COD-SOC-IST   TO CG-BLOCFON-COD-SOC-IST
                   MOVE S-ELA-COD-FON       TO CG-BLOCFON-COD-FON
                   MOVE S-ELA-DAT-LAZ          TO CG-BLOCFON-DAT-LAZ
                   PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
                 END-IF
                 MOVE DIV-FLG-LIT           TO COM-FND-DIV-FLG-LIT
                 MOVE DIV-FLG-DVS-IN        TO COM-FND-DIV-FLG-DVS-IN
                 MOVE DIV-COD-DVS           TO COM-FND-DIV-COD-DVS

                 MOVE S-ELA-COD-IST  TO DIV-COD-IST OF DCLTBDIV
                 MOVE FND-COD-DVS-IPS OF DCLTBFND
                                     TO DIV-COD-DVS OF DCLTBDIV
      * SELECT SU TBDIV
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*          MOVE ' TBDIVSL1 '      TO WSN-SKB-COPY
014696*          MOVE ' Y01-SEL-TBDIV ' TO WSN-SKB-LABEL
014696*          MOVE ' TBDIV '         TO WSN-SKB-TABELLA
014696*          MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
014696*          INITIALIZE WS-IMPO-FONDO
014696*          MOVE  DIV-COD-IST      TO WS-COD-ISTX
014696*          MOVE  DIV-COD-DVS      TO WS-COD-DVSX
014696*          PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*          STRING WS-KEY-BANCA    WS-KEY-DIVISA
014696*           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

                 PERFORM Y01-SEL-TBDIV THRU  Y01-SEL-TBDIV-EXIT

                 IF ENGIRC-NOTF-ENDFILE
                   MOVE 'B0015'           TO CG-BLOCFON-MOTIVO
                   MOVE 'SELECT'          TO CG-BLOCFON-NOTE
                   MOVE 'LETTURA DIVISA FONDO       '
                                      TO CG-BLOCFON-FASE
                   MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
                   MOVE S-ELA-COD-IST       TO CG-BLOCFON-COD-IST
                   MOVE S-ELA-COD-SOC-IST   TO CG-BLOCFON-COD-SOC-IST
                   MOVE S-ELA-COD-FON       TO CG-BLOCFON-COD-FON
                   MOVE S-ELA-DAT-LAZ          TO CG-BLOCFON-DAT-LAZ
                   PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
                 END-IF
                 MOVE DIV-FLG-LIT        TO COM-FND-DIV-IPS-FLG-LIT
                 MOVE DIV-FLG-DVS-IN     TO COM-FND-DIV-IPS-FLG-DVS-IN
                 MOVE DIV-COD-DVS        TO COM-FND-DIV-IPS-COD-DVS
            END-IF.

      * A ROTTURA DI CHIAVE LINEA  SEL SU TBLIN
      *   PER DETERMINARE LIN-DSC
            IF   S-ELA-COD-IST     NOT = LIN-COD-IST     OF DCLTBLIN OR
                 S-ELA-COD-SOC-IST NOT = LIN-COD-SOC-IST OF DCLTBLIN OR
                 S-ELA-COD-FON     NOT = LIN-COD-FON     OF DCLTBLIN OR
                 S-ELA-COD-LIN     NOT = LIN-COD-LIN     OF DCLTBLIN

               MOVE S-ELA-COD-IST        TO LIN-COD-IST     OF DCLTBLIN
               MOVE S-ELA-COD-SOC-IST    TO LIN-COD-SOC-IST OF DCLTBLIN
               MOVE S-ELA-COD-FON        TO LIN-COD-FON     OF DCLTBLIN
               MOVE S-ELA-COD-LIN        TO LIN-COD-LIN     OF DCLTBLIN

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
               MOVE ' TBLINSL1 '      TO WSN-SKB-COPY
               MOVE ' Y01-SEL-TBLIN ' TO WSN-SKB-LABEL
               MOVE ' TBLIN '         TO WSN-SKB-TABELLA
               MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
014696*        INITIALIZE WS-IMPO-FONDO
014696*        MOVE  LIN-COD-LIN      TO WS-COD-ISTX
014696*        MOVE  LIN-COD-SOC-IST  TO WS-COD-SOC-ISTN
014696*        MOVE  LIN-COD-FON      TO WS-COD-FONN
014696*        MOVE  LIN-COD-LIN      TO WS-COD-LINN
014696*        PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES            TO WSN-SKB-CHIAVE-DATI
               STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
               DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

               PERFORM Y01-SEL-TBLIN THRU  Y01-SEL-TBLIN-EXIT

               IF ENGIRC-NOTF-ENDFILE
                 PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
               END-IF
21720G         MOVE 'S' TO WS-FLG-TST-3
      * PASSO ALLA ROUTINE IL PROGRESSIVO DELLA LINEA GIà ELABORATA
014693         MOVE WS-PRG-MOV    TO WS-PRG-MOV-LIN
014693         PERFORM X01-AGGIORNA-PRG-MOV
014693            THRU X01-AGGIORNA-PRG-MOV-EXIT
      *
014693         PERFORM X01-TROVA-PRG-MOV
014693            THRU X01-TROVA-PRG-MOV-EXIT
      *
      * RICEVO DALLA ROUTINE IL PROGRESSIVO DISPONIBILE DELLA LINEA
      * DA ELABORARE
014693         MOVE WS-PRG-MOV-LIN    TO WS-PRG-MOV

006390*--- VERIFICA ABILITAZIONE GESTIONE POOL/INFLACTION
006390         PERFORM VERIFICA-ABILITAZIONE-91
006390            THRU VERIFICA-ABILITAZIONE-91-EXIT
008106         PERFORM VERIFICA-ABILITAZIONE-105
008106            THRU VERIFICA-ABILITAZIONE-105-EXIT
014696           PERFORM VERIFICA-105-APE
014696              THRU VERIFICA-105-APE-EXIT
            END-IF.

001053     MOVE S-ELA-DAT-LAZ  (1:2)  TO WS-DAT-LAZ-8 (7:2).
001053     MOVE S-ELA-DAT-LAZ  (4:2)  TO WS-DAT-LAZ-8 (5:2).
001053     MOVE S-ELA-DAT-LAZ  (7:4)  TO WS-DAT-LAZ-8 (1:4).

      *-----VALORIZZAZIONE DELLA TABELLA TBPSA-----*
            PERFORM U-A70-VAL-TAB THRU U-A70-VAL-TAB-EXIT
002642*     IF SW-USC-X-BLOCCO = 'SI'
002642*       GO TO U-A60-LEGGI-EXIT
002642*     END-IF.

           MOVE S-ELA-COD-IST      TO WS-S-ELA-COD-IST.
           MOVE S-ELA-COD-SOC-IST  TO WS-S-ELA-COD-SOC-IST.
           MOVE S-ELA-COD-FON      TO WS-S-ELA-COD-FON.
           MOVE S-ELA-COD-LIN      TO WS-S-ELA-COD-LIN.

050399*    MOVE 0     TO FLG-TESTATA-ST0.
050399*    MOVE 0     TO FLG-TESTATA-ST1.
050399     MOVE 'S'   TO WS-FLG-TST-0.
050399     MOVE 'S'   TO WS-FLG-TST-1.
      *
       U-A60-LEGGI-EXIT.
           EXIT.
      ******************************************************************
      * TRATTAMENTO LINEE   ------  LEGGO IL FILE SELAO              **
      ******************************************************************
       U-A50-TRATTAMENTO-LINEE.
      *
000512* --> AZZERAMENTO TOTALIZZATORI PER LINEA
000512     MOVE ZEROES TO PGM-SCART-IMP-TOT
000512                    PGM-RATEO-IMP-TOT
000512                    PGM-SCART-IMP-RIT
000512                    PGM-RATEO-IMP-RIT.
      D    DISPLAY 'U-A50-TRATTAMENTO-LINEE'.
           PERFORM U-A60-LEGGI THRU U-A60-LEGGI-EXIT.
011298*    UNTIL (WS-EOF = 1  OR SW-USC-X-BLOCCO = 'SI').

030699*000512--> AZZERAMENTO TOTALIZZATORI PER LINEA
030699*000512
030699*000512     MOVE ZEROES TO PGM-SCART-IMP-TOT
030699*000512                    PGM-RATEO-IMP-TOT
030699*000512                    PGM-SCART-IMP-RIT
030699*000512                    PGM-RATEO-IMP-RIT.

           IF  SW-USC-X-BLOCCO NOT = 'SI'

030699       IF FND-TIP-FON OF DCLTBFND = 'P'
002040*10122 OR (FND-TIP-FON = 'C' AND FND-FLG-FND-IMM = 'S')
                PERFORM STAMPA-TOTALI
                THRU    STAMPA-TOTALI-EXIT
190799*      ELSE
190799*         PERFORM U-GF12-STAMPA-TOTALI-FC
190799*            THRU U-GF12-STAMPA-TOTALI-FC-EXIT
030699       END-IF

030699*--> GESTIONE TOTALIZZATORI PER CAPITAL GAIN
030699       IF SW-USC-X-BLOCCO NOT = 'SI'
030699          PERFORM U-GF01-AGG-TOTALIZ
030699             THRU U-GF01-AGG-TOTALIZ-EXIT
030699       END-IF
030699*
      * FINE   CONTROLLO STATO DATA ELABORAZIONE
002642*      PERFORM U-A20-ELABORAZIONE THRU U-A20-ELABORAZIONE-EXIT
           END-IF.
      *
       U-A50-TRATTAMENTO-LINEE-EXIT.
           EXIT.
      ****************************************************************
       U-A70-VAL-TAB.
016938D    DISPLAY 'U-A70-VAL-TAB'.
      *--- SCORRE L'ARCHIVIO PORTAFOGLIO MOVIMENTI

           MOVE S-ELA-COD-IST     TO PSA-COD-IST OF DCLTBPSA.
           MOVE S-ELA-COD-SOC-IST TO PSA-COD-SOC-IST OF DCLTBPSA.
           MOVE S-ELA-COD-FON     TO PSA-COD-FON OF DCLTBPSA.
           MOVE S-ELA-COD-LIN     TO PSA-COD-LIN OF DCLTBPSA.

      *-- IMPOSTA CAMPI PER EVENTUALE ERRORE BLOCCANTE   --*
      *--          NELL'ACCESSO AL DB2                   --*
           MOVE 'TBPSAOC5'            TO WSN-SKB-COPY.
           MOVE 'Y05-OPEN-CUR5-TBPSA' TO WSN-SKB-LABEL.
           MOVE 'OPEN '               TO WSN-SKB-FUNZIONE.
           MOVE 'TBPSA'               TO WSN-SKB-TABELLA.
014696*    INITIALIZE WS-IMPO-FONDO.
014696*    MOVE  PSA-COD-IST          TO WS-COD-ISTX.
014696*    MOVE  PSA-COD-SOC-IST      TO WS-COD-SOC-ISTN.
014696*    MOVE  PSA-COD-FON          TO WS-COD-FONN.
014696*    MOVE  PSA-COD-LIN          TO WS-COD-LINN.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES                TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
                  WS-KEY-LINEA
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

           PERFORM Y05-OPEN-CUR5-TBPSA
           THRU    Y05-OPEN-CUR5-TBPSA-EXIT.

      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE 'TBPSAFC5'              TO WSN-SKB-COPY.
           MOVE 'Y06-FETCH-CUR5-TBPSA ' TO WSN-SKB-LABEL.
           MOVE 'TBPSA'                 TO WSN-SKB-TABELLA .
           MOVE 'FETCH CURSOR '         TO WSN-SKB-FUNZIONE .
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT .
014696*    STRING WS-KEY-SOC-IST  WS-KEY-FONDO
014696*    WS-KEY-LINEA
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

      D    DISPLAY 'LETTURA FUORI CICLO DI TBPSA'
           PERFORM Y06-FETCH-CUR5-TBPSA
           THRU    Y06-FETCH-CUR5-TBPSA-EXIT.

           IF ENGIRC-NOTF-ENDFILE
      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
             MOVE ' TBPSACL5 '             TO WSN-SKB-COPY
             MOVE ' Y07-CLOSE-CUR5-TBPSA ' TO WSN-SKB-LABEL
             MOVE ' TBPSA '                TO WSN-SKB-TABELLA
             MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE
014696*      INITIALIZE WS-IMPO-FONDO
014696*      MOVE  PSA-COD-IST             TO WS-COD-ISTX
014696*      MOVE  PSA-COD-SOC-IST         TO WS-COD-SOC-ISTN
014696*      MOVE  PSA-COD-FON             TO WS-COD-FONN
014696*      MOVE  PSA-COD-LIN             TO WS-COD-LINN
014696*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*      STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
014696*      WS-KEY-LINEA
014696*      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

             PERFORM Y07-CLOSE-CUR5-TBPSA
                THRU Y07-CLOSE-CUR5-TBPSA-EXIT
             GO TO U-A70-VAL-TAB-EXIT
           END-IF.
      *----------------------------------------------------*
014696*    SI TOGLIE L'AZZERAMENTO DELLE TABELLE(TAB-PSA)
014696*-------------- INIZIO MODIFICA ---------------------*
014696*    PERFORM
014696*    VARYING PGM-IND FROM 1 BY 1 UNTIL (PGM-IND > 10000)
014696*              MOVE SPACES     TO TAB-PSA-COD-TIT (PGM-IND)
014696*              MOVE ZEROES     TO TAB-PSA-QTA-TOT (PGM-IND)
014696*    END-PERFORM.
MODTP *14696 PERFORM
MODTP *14696 VARYING PGM-IND FROM 1 BY 1 UNTIL (PGM-IND > 30000)
MODTP *14696         MOVE SPACES     TO TAB-PSA-GES-COD-TIT (PGM-IND)
MODTP *14696         MOVE ZEROES     TO TAB-PSA-GES-QTA-TOT (PGM-IND)
MODTP *14696                            TAB-PSA-GES-COD-DEP (PGM-IND)
111198*14696                            TAB-PSA-GES-QTA-DEP (PGM-IND)
MODTP *14696                            TAB-PSA-GES-COD-GES (PGM-IND)
MODTP *14696 END-PERFORM.
014696*---------------- FINE MODIFICA ---------------------*
           MOVE ZEROES TO PGM-IND PGM-IND4
                          PGM-TOT-RIT-FIS-LINEA
                          PGM-TOT-DEDUC
030699                    PGM-SCART-PRE
030699                    PGM-SCART-POS
030699                    PGM-SCART-PRE-DAY
030699                    PGM-SCART-POS-DAY
000781                    PGM-SCART-PRE-VEND-DAY
000781                    PGM-SCART-POS-VEND-DAY
111199                    PGM-TOT-DISAG-LIN-PRE
111199                    PGM-TOT-DISAG-LIN-FC
                          PGM-TOT-DISAG-LINEA.
      *                   PGM-TOT-CEDOL-LINEA
      *                   PGM-TOT-DISAG-LINEA.

014696*     OCCORRE PER CONTROLLARE LA ROTTURA DEL TITOLO
014696*     NEL CARICAMENTO DELLA TABELLA
014696      MOVE SPACES         TO WS-COD-TIT-COM.
      * SI PONGONO IN TABELLA I TITOLI
            PERFORM U-A80-LEGGI THRU U-A80-LEGGI-EXIT
            UNTIL  ENGIRC-NOTF-ENDFILE.
014696*     SI MEMORIZZANO GLI INDICI DEGLI ELEMENTI CARICATI
014696*     NELLE TABELLE PER LA RICERCA SUCCESSIVA
014696      MOVE PGM-IND        TO PGM-TIT-ELE.
014696      MOVE PGM-IND4       TO PGM-GES-ELE.

      D     DISPLAY 'FINE LETTURA DI TBPSA '.

            PERFORM U-A90-TRATTA-TITOLI THRU U-A90-TRATTA-TITOLI-EXIT
014696*      VARYING PGM-IND4 FROM 1 BY 1 UNTIL (PGM-IND4 > 10000 OR
014696*           TAB-PSA-COD-TIT (PGM-IND4) = SPACES
014696       VARYING PGM-IND4 FROM 1 BY 1 UNTIL (PGM-IND4 > PGM-TIT-ELE
                                         OR  SW-USC-X-BLOCCO = 'SI').

      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
             MOVE ' TBPSACL5 '             TO WSN-SKB-COPY.
             MOVE ' Y07-CLOSE-CUR5-TBPSA ' TO WSN-SKB-LABEL.
             MOVE ' TBPSA '                TO WSN-SKB-TABELLA.
             MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE.
014696*      INITIALIZE WS-IMPO-FONDO.
014696*      MOVE  PSA-COD-IST            TO WS-COD-ISTX.
014696*      MOVE  PSA-COD-SOC-IST        TO WS-COD-SOC-ISTN.
014696*      MOVE  PSA-COD-FON            TO WS-COD-FONN.
014696*      MOVE  PSA-COD-LIN            TO WS-COD-LINN.
014696*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696       MOVE SPACES                  TO WSN-SKB-CHIAVE-DATI
             STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
             WS-KEY-LINEA
             DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

      D      DISPLAY 'FINE LETTURA DI TBPSA'.
      *
             PERFORM Y07-CLOSE-CUR5-TBPSA
                THRU Y07-CLOSE-CUR5-TBPSA-EXIT.
      *
       U-A70-VAL-TAB-EXIT.
           EXIT.
      **************************************************************
      *------- CICLO DI LETTURA DI TBPSA---                        *
      **************************************************************
       U-A80-LEGGI.
      *
016938D    DISPLAY 'U-A80-LEGGI'.
016938D    DISPLAY 'PSA-COD-IST'     PSA-COD-IST
016938D    DISPLAY 'PSA-COD-SOC-IST' PSA-COD-SOC-IST
016938D    DISPLAY 'PSA-COD-FON'     PSA-COD-FON
016938D    DISPLAY 'PSA-COD-LIN'     PSA-COD-LIN
016938D    DISPLAY 'PSA-COD-GES'     PSA-COD-GES
016938D    DISPLAY 'PSA-COD-TIT'     PSA-COD-TIT
016938D    DISPLAY 'PSA-QTA-TOT'     PSA-QTA-TOT
005456*-- SE E' PRESENTE L'ABILITAZ. 84 SI ESEGUE LA CALL AL PGM
005456*-- GFUWMC16 PER EFFETTUARE LA SELECT SU TBPSE
005456     IF CG-SPEC-ABIL-VEN-SCO = 'S'
009725        OR WS-ABIL-PERS-116  = 'S'
005456        PERFORM PREPARA-AREA-PSE
005456           THRU PREPARA-AREA-PSE-EXIT
005456        PERFORM CALL-C016 THRU CALL-C016-EXIT
005456        IF WS-PERS-R-OPE = 'N'
005456           MOVE 'N' TO FLG-PSE-QTA-VAL-NMN-RE
005456        ELSE
005456           MOVE 'P' TO FLG-PSE-QTA-VAL-NMN-RE
005456        END-IF
005456        INITIALIZE WS-PERS-R
005456     END-IF.
005456
005456*-- SE E' PRESENTE L'ABILITAZ. 84 E LA QUANTITA' E' NEGATIVA
005456*-- (POSIZIONE SHORT) SCARTA IL TITOLO
005456*009725     IF CG-SPEC-ABIL-VEN-SCO = 'N'   OR
005456*009725       (CG-SPEC-ABIL-VEN-SCO = 'S'
005456*009725        AND FLG-PSE-QTA-VAL-NMN-RE = 'P' )
009725     IF (CG-SPEC-ABIL-VEN-SCO   = 'N'  AND
009725         WS-ABIL-PERS-116       = 'N' ) OR
009725         FLG-PSE-QTA-VAL-NMN-RE = 'P'

MODTP *       IF WS-COD-TIT NOT = PSA-COD-TIT
MODTP *014696 IF TAB-PSA-COD-TIT (PGM-IND) NOT = PSA-COD-TIT
014696        IF WS-COD-TIT-COM NOT = PSA-COD-TIT
014696           MOVE PSA-COD-TIT       TO WS-COD-TIT-COM
                 ADD 1                  TO PGM-IND
                 MOVE PSA-COD-TIT       TO TAB-PSA-COD-TIT (PGM-IND)
MODTP *                                    WS-COD-TIT
                 MOVE PSA-QTA-TOT       TO TAB-PSA-QTA-TOT (PGM-IND)
              ELSE
                 ADD  PSA-QTA-TOT     TO TAB-PSA-QTA-TOT (PGM-IND)
              END-IF
      D       DISPLAY 'TAB-LIN TITOLO  ' PSA-COD-TIT
      D       DISPLAY 'TAB-LIN INDICE  ' PGM-IND
      D       DISPLAY 'TAB-LIN QTA     ' PSA-QTA-TOT

MODTP         ADD  1                  TO PGM-IND4
MODTP         MOVE PSA-COD-TIT        TO TAB-PSA-GES-COD-TIT (PGM-IND4)
MODTP         MOVE PSA-COD-GES        TO TAB-PSA-GES-COD-GES (PGM-IND4)
MODTP         MOVE PSA-QTA-TOT        TO TAB-PSA-GES-QTA-TOT (PGM-IND4)

005456     END-IF.

      D    DISPLAY 'TAB-GES GESTORE ' PSA-COD-GES.
      D    DISPLAY 'TAB-GES TITOLO  ' PSA-COD-TIT.
      D    DISPLAY 'TAB-GES INDICE  ' PGM-IND4.
      D    DISPLAY 'TAB-GES QTA     ' PSA-QTA-TOT.

      *-- IMPOSTA CAMPI PER EVENTUALE ERRORE BLOCCANTE   --*
      *--          NELL'ACCESSO AL DB2                   --*
           MOVE 'TBPSAFC5'                  TO WSN-SKB-COPY.
           MOVE 'Y06-FETCH-CUR5-TBPSA'      TO WSN-SKB-LABEL.
           MOVE 'FETCH'                     TO WSN-SKB-FUNZIONE.
           MOVE 'TBPSA'                     TO WSN-SKB-TABELLA.
014696*    INITIALIZE WS-IMPO-FONDO.
014696*    MOVE PSA-COD-IST OF DCLTBPSA     TO WS-COD-ISTX.
014696*    MOVE PSA-COD-SOC-IST OF DCLTBPSA TO WS-COD-SOC-ISTN.
014696*    MOVE PSA-COD-FON OF DCLTBPSA     TO WS-COD-FONN.
014696*    MOVE PSA-COD-LIN OF DCLTBPSA     TO WS-COD-LINN.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES                  TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA
                       WS-KEY-SOC-IST
                       WS-KEY-FONDO
                       WS-KEY-LINEA
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *
           PERFORM Y06-FETCH-CUR5-TBPSA
           THRU    Y06-FETCH-CUR5-TBPSA-EXIT.
      *
       U-A80-LEGGI-EXIT.
           EXIT.
      **************************************************************
       U-A90-TRATTA-TITOLI.
      *
      D    DISPLAY 'TRATTA TITOLI ' TAB-PSA-COD-TIT (PGM-IND4).
      D    DISPLAY 'INDICE        ' PGM-IND4.
      *
016248     MOVE ZEROES            TO PGM-TOT-QTA
016248                               PGM-QTA-OLD
016248                               PGM-TOT-DISAG
25611G                               NEW-SCART-PRE
25611G                               NEW-SCART-VEN-PRE
25611G                               NEW-SCART-POS
25611G                               NEW-SCART-VEN-POS
25611G                               WS-SCART-PRE
016248                               PGM-SCART-PRE
016248                               PGM-SCART-POS
016248                               PGM-SCART-MAT-PRE
016248                               PGM-SCART-MAT-POS.

15209G     MOVE ZEROES TO WS-P-I-FACTOR.
15209G     MOVE 'N'    TO WS-TROVA-FPI .
15209G     MOVE SPACE  TO WS-FLG-TBFPI .

           MOVE SPACE TO WS-STACCO-CEDOLA.
018880*    INIZIALIZZAZIONE SWITCH DI GESTIONE DIVIDENDI
018880     MOVE SPACE TO SW-DVD.
MODTP      MOVE S-ELA-COD-IST            TO CG-LETAVM-KEY-COD-IST.
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                         TO CG-LETAVM-KEY-COD-TIT-UIC.
           MOVE S-ELA-DAT-LAZ            TO CG-LETAVM-KEY-DAT-RIF.
      *
      D    DISPLAY ' LETTURA ANAGRAFICA TITOLI'.
      D    DISPLAY 'COD-TIT = ' TAB-PSA-COD-TIT (PGM-IND4).
      D    DISPLAY 'COD-IST = ' PSA-COD-IST.
      D    DISPLAY 'DAT-RIF = ' S-ELA-DAT-LAZ.
      *
           PERFORM X01-LETT-ANVM THRU X01-LETT-ANVM-EXIT.

           IF CG-LETAVM-CODERR NOT = SPACE
              MOVE 'B0010'         TO CG-BLOCFON-MOTIVO
011299*       MOVE 'SELECT'        TO CG-BLOCFON-NOTE
011299        MOVE CG-LETAVM-KEY-COD-TIT-UIC
011299                             TO CG-BLOCFON-NOTE
              MOVE 'CALCOLO E TOT. RIMBORSI , CEDOLE'
                                   TO CG-BLOCFON-FASE
              MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
              MOVE PSA-COD-IST     TO CG-BLOCFON-COD-IST
              MOVE PSA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
              MOVE PSA-COD-FON     TO CG-BLOCFON-COD-FON
              MOVE PSA-COD-LIN     TO CG-BLOCFON-COD-LIN
              MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146        MOVE 'GFUWM300' TO WSN-SKB-PGM
              PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
              MOVE 'SI' TO SW-USC-X-BLOCCO
              GO TO U-A90-TRATTA-TITOLI-EXIT
           END-IF.
160299*
160299*    MOVE DCLTBTIT                  TO REC-STIT1.
160299*    MOVE S-ELA-COD-IST             TO CG-LETAVM-KEY-COD-IST.
160299*    MOVE TAB-PSA-COD-TIT (PGM-IND4)
160299*                                   TO CG-LETAVM-KEY-COD-TIT-UIC.
160299*    MOVE S-TIT1-DAT-REC            TO CG-LETAVM-KEY-DAT-RIF.
160299*    PERFORM X01-LETT-ANVM THRU X01-LETT-ANVM-EXIT.
160299*
160299*    IF CG-LETAVM-CODERR NOT = SPACES
160299*         MOVE S-TIT1-BAS-CLC       TO COM-OLD-BAS-CLC
160299*    ELSE
160299*         MOVE TIT-BAS-CLC          TO COM-OLD-BAS-CLC
160299*    END-IF.
160299*    MOVE REC-STIT1                 TO DCLTBTIT.

           PERFORM VER-NAZION-TITOLO THRU VER-NAZION-TITOLO-EXIT.
           IF  SW-USC-X-BLOCCO = 'SI'
             GO TO U-A90-TRATTA-TITOLI-EXIT
           END-IF.

      **----- ACCESSO A LINEA/GESTORE------------------------------     *

             IF  S-ELA-COD-IST     NOT = LGS-COD-IST     OF DCLTBLGS OR
                 S-ELA-COD-SOC-IST NOT = LGS-COD-SOC-IST OF DCLTBLGS OR
                 S-ELA-COD-FON     NOT = LGS-COD-FON     OF DCLTBLGS OR
                 S-ELA-COD-LIN     NOT = LGS-COD-LIN     OF DCLTBLGS

                 MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
                 MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
                 MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
                 MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
                 MOVE 0                 TO LGS-COD-GES OF DCLTBLGS

      D          DISPLAY '.....S-ELA-COD-IST '     S-ELA-COD-IST
      D          DISPLAY '.....S-ELA-COD-SOC-IST'  S-ELA-COD-SOC-IST
      D          DISPLAY '.....S-ELA-COD-FON '     S-ELA-COD-FON
      D          DISPLAY '.....S-ELA-COD-LIN '     S-ELA-COD-LIN
      D          DISPLAY '.......LGS-COD-GES '       LGS-COD-GES


      * ----------------- SELECT SU TBLGS ----------------------*
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
                 MOVE 'TBLGSL1'       TO WSN-SKB-COPY
                 MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
                 MOVE 'TBLGS'         TO WSN-SKB-TABELLA
                 MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
014696*          INITIALIZE WS-IMPO-FONDO
                 MOVE LGS-COD-GES         TO WS-COD-GESN
014696*          MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
014696*          MOVE LGS-COD-FON         TO WS-COD-FONN
014696*          MOVE LGS-COD-LIN         TO WS-COD-LINN
014696*          PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*          STRING WS-KEY-SOC-IST   WS-KEY-FONDO
014696           MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
014696           STRING WS-KEY-BANCA
014696                  WS-KEY-SOC-IST   WS-KEY-FONDO
                        WS-KEY-LINEA     WS-KEY-GESTORE
                 DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

                 PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT

                 IF ENGIRC-NOTF-ENDFILE
                    MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
                    MOVE 'SELECT'        TO CG-BLOCFON-NOTE
                    MOVE 'CALCOLO E TOT. RIMBORSI , CEDOLE'
                                      TO CG-BLOCFON-FASE
                    MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
                    MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
                    MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
                    MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
                    MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
                    MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146              MOVE 'GFUWM300' TO WSN-SKB-PGM
                    PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
                    MOVE 'SI' TO SW-USC-X-BLOCCO
                    GO TO U-A90-TRATTA-TITOLI-EXIT
                 END-IF
                 MOVE  LGS-FLG-CED-DVS TO COM-LGS-FLG-CED-DVS
MODTP            MOVE  LGS-FLG-DIS-DVD TO COM-LGS-FLG-DIS-DVD
MODTP            MOVE  LGS-FLG-RIM-DVS TO COM-LGS-FLG-RIM-DVS
             END-IF.
      *
MODTP        IF  S-ELA-COD-IST     NOT = COM-CCC-IPS-COD-IST         OR
MODTP            S-ELA-COD-SOC-IST NOT = COM-CCC-IPS-COD-SOC-IST     OR
MODTP            S-ELA-COD-FON     NOT = COM-CCC-IPS-COD-FON         OR
MODTP            S-ELA-COD-LIN     NOT = COM-CCC-IPS-COD-LIN         OR
MODTP            FND-COD-DVS-IPS   NOT = COM-CCC-IPS-COD-DVS
MODTP           MOVE FND-COD-DVS-IPS   TO WS-COD-DVS
070199          MOVE ZERO   TO CCC-COD-GES OF DCLTBCCC
MODTP           PERFORM LETTURA-C-C-ORDINARIO
MODTP           THRU    LETTURA-C-C-ORDINARIO-EXIT
      D         DISPLAY '** LETTURA C/C ORD -0- SW-BLOK' SW-USC-X-BLOCCO
MODTP           IF SW-USC-X-BLOCCO = 'SI'
014146             MOVE 'GFUWM300' TO WSN-SKB-PGM
007521             PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
MODTP                 GO TO U-A90-TRATTA-TITOLI-EXIT
MODTP           END-IF
MODTP
020300*         MOVE CCC-COD-IST     OF DCLTBCCC TO COM-CCC-IPS-NUM-CCC
020300          MOVE CCC-COD-IST     OF DCLTBCCC TO COM-CCC-IPS-COD-IST
MODTP           MOVE CCC-COD-SOC-IST OF DCLTBCCC TO
MODTP                                   COM-CCC-IPS-COD-SOC-IST
MODTP           MOVE CCC-COD-FON     OF DCLTBCCC TO COM-CCC-IPS-COD-FON
MODTP           MOVE CCC-COD-LIN     OF DCLTBCCC TO COM-CCC-IPS-COD-LIN
MODTP           MOVE CCC-COD-DVS     OF DCLTBCCC TO COM-CCC-IPS-COD-DVS
MODTP           MOVE CCC-TIP-CCC     OF DCLTBCCC TO COM-CCC-IPS-TIP-CCC
MODTP           MOVE CCC-COD-FIL     OF DCLTBCCC TO COM-CCC-IPS-COD-FIL
MODTP           MOVE CCC-NUM-CCC     OF DCLTBCCC TO COM-CCC-IPS-NUM-CCC
17302G*24391G   MOVE CCC-CAT         OF DCLTBCCC TO COM-CCC-CAT
24391G          MOVE CCC-CAT         OF DCLTBCCC TO COM-CCC-IPS-CAT
MODTP        END-IF.

      *  SE SI TRATTA DI OBBLIGAZIONE :
             IF TIT-TIP-TIT OF DCLTBTIT = 1
21720GD        DISPLAY 'DEFAULT TITOLO = ' TIT-COD-BRS
21720G        IF TIT-COD-BRS = 1
21720G          PERFORM GEST-STAMPA-DEFAULT
21720G             THRU GEST-STAMPA-DEFAULT-EXIT
21720G        ELSE
      D        DISPLAY 'OBBLIGAZIONE'
008730*VERIFICO IL TIPO DI RIMBORSO PER IL TITOLO
008730         PERFORM VERIFICA-RIMBORSO
008730            THRU VERIFICA-RIMBORSO-EXIT
               IF TIT-COR     OF DCLTBTIT = 'S'
      D           DISPLAY 'STACCO-CEDOLA'

050399           MOVE 'GFUWM300'       TO CG-STPTES-NOM-PGM
                 PERFORM STACCO-CEDOLA THRU STACCO-CEDOLA-EXIT
                 IF SW-USC-X-BLOCCO = 'SI'
                      GO TO U-A90-TRATTA-TITOLI-EXIT
                 END-IF
               END-IF
008106*    EFFETTUO L'ACCESSO PER REPERIRE LE DATE DI RIMBORSO
008106         MOVE 'A'   TO  WS-TIPO-OPE
008106         PERFORM CALL-GFUWMC35
008106            THRU CALL-GFUWMC35-EXIT
008106*8730    IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730         IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106            MOVE MC35-DAT-EFF-RIM   TO TIT-DAT-EFF-RIM
008106            IF MC35-AZIONE = 'P'
008106               MOVE 'P' TO TIT-FLG-TIP-RIM
008106               MOVE MC35-DAT-RIM-O  TO TIT-DAT-SUC-RIM
008106            ELSE
008106               MOVE 'T' TO TIT-FLG-TIP-RIM
008106               MOVE MC35-DAT-RIM-O  TO TIT-DAT-RIM
008106            END-IF
008106         END-IF

      D        DISPLAY 'RIMBORSO-PARZIALE'
               PERFORM RIMBORSO-PARZIALE
               THRU RIMBORSO-PARZIALE-EXIT
               IF SW-USC-X-BLOCCO = 'SI'
                 GO TO U-A90-TRATTA-TITOLI-EXIT
               END-IF

      D        DISPLAY 'RIMBORSO TOTALE'
      D        DISPLAY 'TIT-COD-TIT    '   TIT-COD-TIT
      D        DISPLAY 'TIT-DAT-EFF-RIM '  TIT-DAT-EFF-RIM
               PERFORM  RIMBORSO-TOTALE THRU RIMBORSO-TOTALE-EXIT
               IF SW-USC-X-BLOCCO = 'SI'
                 GO TO U-A90-TRATTA-TITOLI-EXIT
               END-IF
      D        DISPLAY 'FINE RIMBORSO TOTALE'

190799*        IF FND-TIP-FON OF DCLTBFND = 'C'
190799*           PERFORM U-GF12-STAMPA-TOTALI-FC
190799*              THRU U-GF12-STAMPA-TOTALI-FC-EXIT
190799*        END-IF
21720G        END-IF
             END-IF.

      * SE SI TRATTA DI AZIONE :
018880*      IF TIT-TIP-TIT OF DCLTBTIT = 2
018880*         DISPLAY ' AZIONE'
018880       IF TIT-TIP-TIT = (2 OR 4 OR 5)
018880          MOVE 'S'          TO SW-DVD
018880D         DISPLAY 'TIT-TIP-TIT: ' TIT-TIP-TIT
      D         DISPLAY 'TIT-COD-TIT ' TIT-COD-TIT
      D         DISPLAY 'DISTRIBUZ-DIVIDENDI'
                PERFORM DISTRIBUZIONE-DIVIDENDI
                THRU    DISTRIBUZIONE-DIVIDENDI-EXIT
                IF SW-USC-X-BLOCCO = 'SI'
                   GO TO  U-A90-TRATTA-TITOLI-EXIT
                END-IF
             END-IF.

FS    *  SE SI TRATTA DI ALTRI TITOLI :
FS           IF TIT-TIP-TIT OF DCLTBTIT = 3
FS    D        DISPLAY 'ALTRI TITOLI'
FS    D        DISPLAY 'RIMBORSO TOTALE'
FS             PERFORM  RIMBORSO-TOTALE THRU RIMBORSO-TOTALE-EXIT
FS             IF SW-USC-X-BLOCCO = 'SI'
FS               GO TO U-A90-TRATTA-TITOLI-EXIT
FS             END-IF
FS    D        DISPLAY 'FINE RIMBORSO TOTALE'
FS           END-IF.

      *  AGGIORNAMENTO PORTAFOGLIO ROUTINE UPDD-TBPSA
MODTP *
MODTP * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
MODTP *      MOVE 'TBPSAUP1'         TO WSN-SKB-COPY.
MODTP *      MOVE 'Y02-UPD-TBPSA'    TO WSN-SKB-LABEL.
MODTP *      MOVE 'TBPSA'            TO WSN-SKB-TABELLA.
MODTP *      MOVE 'UPDATE'           TO WSN-SKB-FUNZIONE.
MODTP *      INITIALIZE WS-IMPO-FONDO.
MODTP *      MOVE  PSA-COD-IST       TO WS-COD-ISTX.
MODTP *      MOVE  PSA-COD-SOC-IST   TO WS-COD-SOC-ISTN
MODTP *      MOVE  PSA-COD-FON       TO WS-COD-FONN
MODTP *      MOVE  PSA-COD-LIN       TO WS-COD-LINN
MODTP *      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
MODTP *      STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
MODTP *      WS-KEY-LINEA
MODTP *      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
MODTP *
MODTP *      DISPLAY 'UPDATE SU TBPSA'
MODTP *      PERFORM Y02-UPD-TBPSA THRU Y02-UPD-TBPSA-EXIT.
25611G       MOVE ZEROES      TO PGM-TOT-DEDUC.
25611G       MOVE ZEROES      TO PGM-DEDUC-POS.
25611G       MOVE ZEROES      TO PGM-DEDUC-PRE.
      D    DISPLAY 'U-A90-TRATTA-TITOLI-EXIT'.
      *
       U-A90-TRATTA-TITOLI-EXIT.
           EXIT.
      *****************************************************************
      **             ROUTINE ISTITUTO.                              ***
      *****************************************************************
       ISTITUTO.
      D    DISPLAY 'ROUTINE ISTITUTO '.
014693*    IF (IST-COD-IST OF DCLTBIST NOT = SPACE  AND
014693*        WS-PRG-MOV NOT = IST-PRG-ULT-MOV OF DCLTBIST)
014693*      MOVE WS-PRG-MOV TO IST-PRG-ULT-MOV OF DCLTBIST

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014693*      MOVE ' TBISTUP1 '  TO WSN-SKB-COPY
014693*      MOVE ' Y02-UPD-TBIST ' TO WSN-SKB-LABEL
014693*      MOVE ' TBIST ' TO WSN-SKB-TABELLA
014693*      MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
014693*      INITIALIZE WS-IMPO-FONDO
014693*      MOVE IST-COD-IST TO WS-COD-ISTX
014693*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014693*      STRING WS-KEY-BANCA
014693*      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
014693*      PERFORM Y02-UPD-TBIST THRU Y02-UPD-TBIST-EXIT
014693*    END-IF.

270999*    MOVE S-ELA-COD-IST TO IST-COD-IST.
270999* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
270999*    MOVE 'TBISTSL1'           TO WSN-SKB-COPY .
270999*    MOVE  'Y01-SEL-TBIST'     TO WSN-SKB-LABEL .
270999*    MOVE 'TBIST'              TO WSN-SKB-TABELLA .
270999*    MOVE 'SELECT'             TO WSN-SKB-FUNZIONE.
270999*    INITIALIZE WS-IMPO-FONDO.
270999*    MOVE IST-COD-IST TO WS-COD-ISTX.
270999*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
270999*    STRING WS-KEY-BANCA
270999*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI .
270999*    PERFORM Y01-SEL-TBIST THRU Y01-SEL-TBIST-EXIT .

270999*    IF ENGIRC-NOTF-ENDFILE
270999*       PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
270999*    END-IF

270999*    MOVE IST-PRG-ULT-MOV  OF DCLTBIST TO WS-PRG-MOV.

      D    DISPLAY 'FINE-ISTITUTO'.
       ISTITUTO-EXIT.
           EXIT.
      *****************************************************************
      *      ROUTINE DI LETTURA SUL C-C ORDINARIO DEL GESTORE         *
      *****************************************************************
       LETTURA-C-C-ORDINARIO.
      D    DISPLAY 'LETTURA C/C ORDINARIO '.
      *
           MOVE S-ELA-COD-IST     TO CCC-COD-IST     OF DCLTBCCC.
           MOVE S-ELA-COD-SOC-IST TO CCC-COD-SOC-IST OF DCLTBCCC.
           MOVE S-ELA-COD-FON     TO CCC-COD-FON     OF DCLTBCCC.
           MOVE S-ELA-COD-LIN     TO CCC-COD-LIN     OF DCLTBCCC.
           MOVE WS-COD-DVS        TO CCC-COD-DVS     OF DCLTBCCC.
MODTP *    MOVE  0                TO CCC-COD-GES     OF DCLTBCCC.
           MOVE 'A'               TO CCC-TIP-CCC     OF DCLTBCCC.
           MOVE  0                TO CCC-COD-CTP     OF DCLTBCCC.

      D    DISPLAY 'CCC-COD-IST = ' CCC-COD-IST.
      D    DISPLAY 'CCC-COD-SOC-IST = ' CCC-COD-SOC-IST.
      D    DISPLAY 'CCC-COD-FON     = ' CCC-COD-FON.
      D    DISPLAY 'CCC-COD-LIN     = ' CCC-COD-LIN.
      D    DISPLAY 'CCC-COD-GES     = ' CCC-COD-GES.
      D    DISPLAY 'CCC-COD-DVS     = ' CCC-COD-DVS.
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE 'SELECT'              TO WSN-SKB-COPY.
           MOVE 'Y01-SEL2-TBCCC'      TO WSN-SKB-LABEL.
           MOVE 'TBCCC'               TO WSN-SKB-TABELLA.
           MOVE 'TBCCCSL2'            TO WSN-SKB-FUNZIONE.
014696*    INITIALIZE WS-IMPO-FONDO.
014696*    MOVE  CCC-COD-SOC-IST      TO WS-COD-SOC-ISTN.
014696*    MOVE  CCC-COD-IST          TO WS-COD-ISTX.
014696*    MOVE  CCC-COD-FON          TO WS-COD-FONN.
014696*    MOVE  CCC-COD-LIN          TO WS-COD-LINN.
           MOVE  CCC-COD-GES          TO WS-COD-GESN.
           MOVE  CCC-COD-DVS          TO WS-COD-DVSX.
           MOVE  CCC-TIP-CCC          TO WS-TIP-CCCX.
           MOVE  CCC-COD-CTP          TO WS-COD-CTPN.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES                TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
           WS-KEY-LINEA  WS-KEY-GESTORE
           WS-KEY-DIVISA WS-KEY-TIP-CCC  WS-KEY-CTP
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

*TEST D    DISPLAY '** CCC-COD-IST           --> ' CCC-COD-IST
*TEST D    DISPLAY '** CCC-COD-SOC-IST       --> ' CCC-COD-SOC-IST
*TEST D    DISPLAY '** CCC-COD-FON           --> ' CCC-COD-FON
*TEST D    DISPLAY '** CCC-COD-LIN           --> ' CCC-COD-LIN
*TEST D    DISPLAY '** CCC-COD-DVS           --> ' CCC-COD-DVS
*TEST D    DISPLAY '** CCC-TIP-CCC           --> ' CCC-TIP-CCC
*TEST D    DISPLAY '** CCC-COD-CTP           --> ' CCC-COD-CTP
           PERFORM Y01-SEL2-TBCCC
           THRU    Y01-SEL2-TBCCC-EXIT.

6352G      IF ENGIRC-NOTF-ENDFILE
6352G        MOVE FND-COD-DVS        TO CCC-COD-DVS
6352G        PERFORM Y01-SEL2-TBCCC
6352G           THRU Y01-SEL2-TBCCC-EXIT
6352G      END-IF.

           IF ENGIRC-NOTF-ENDFILE
*TEST D    DISPLAY '** ENGIRC-NOTF-ENDFILE **'
011299*        MOVE 'B0002'         TO CG-BLOCFON-MOTIVO
011299*        MOVE 'SELECT'        TO CG-BLOCFON-NOTE
011299         MOVE 'B0011'         TO CG-BLOCFON-MOTIVO
011299         STRING 'GEST.: '     WS-COD-GESN
011299                ' DIVISA: '   WS-COD-DVSX
011299                ' T.CONTO: '  WS-TIP-CCCX
011299                ' CONTROP.: ' WS-COD-CTPN
011299         DELIMITED BY SIZE INTO CG-BLOCFON-NOTE
014146*        STRING 'STACCO SU TIT.' TIT-COD-TIT
014146         STRING 'TITOLO:' TIT-COD-TIT
               DELIMITED BY SIZE INTO CG-BLOCFON-FASE
               MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
               MOVE CCC-COD-IST     TO CG-BLOCFON-COD-IST
               MOVE CCC-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
               MOVE CCC-COD-FON     TO CG-BLOCFON-COD-FON
               MOVE CCC-COD-LIN     TO CG-BLOCFON-COD-LIN
               MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ

007521*        PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
               MOVE 'SI' TO SW-USC-X-BLOCCO
               GO TO LETTURA-C-C-ORDINARIO-EXIT
             END-IF.

      D     DISPLAY 'FINE LETTURA C/C'.
      *
       LETTURA-C-C-ORDINARIO-EXIT.
           EXIT.
      **************************************************************
      **   ROUTINE OPERAZIONI DI COMPRAVENDITA DA ESCLUDERE       **
      ***************************************************************
       COMPRAVENDITA.
006664D    DISPLAY ' COMPRAVENDITA DA ESCLUDERE'.
      *
008366     PERFORM  VARYING PGM-IND1 FROM 1 BY 1
008366*             UNTIL (PGM-IND1 > 30000)
014696              UNTIL (PGM-IND1 > PGM-GES-ELE)
008366        MOVE ZEROES TO TAB-PSA-GES-QTA-DEP (PGM-IND1)
008366     END-PERFORM.
      *
           MOVE TAB-PSA-QTA-TOT (PGM-IND4)   TO VALORE-NOMINALE.
      D    DISPLAY 'VAL-NOM ' VALORE-NOMINALE.
      D    DISPLAY 'SMO-VLT ' SMO-VLT.

           MOVE S-ELA-COD-IST         TO SMO-COD-IST OF DCLTBSMO.
           MOVE S-ELA-COD-SOC-IST TO SMO-COD-SOC-IST OF DCLTBSMO.
           MOVE S-ELA-COD-FON         TO SMO-COD-FON OF DCLTBSMO.
           MOVE S-ELA-COD-LIN         TO SMO-COD-LIN OF DCLTBSMO.
           MOVE 'T'                   TO SMO-FLG-TIT-CTT OF DCLTBSMO.
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                      TO SMO-COD-TIT OF DCLTBSMO.

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE 'TBSMOOC6'             TO WSN-SKB-COPY .
           MOVE 'Y05-OPEN-CUR6-TBSMO ' TO WSN-SKB-LABEL .
           MOVE 'TBSMO'                TO WSN-SKB-TABELLA .
           MOVE 'OPEN CURSOR'          TO WSN-SKB-FUNZIONE .
014696*    INITIALIZE WS-IMPO-FONDO.
014696*    MOVE  SMO-COD-IST            TO WS-COD-ISTX .
014696*    MOVE  SMO-COD-SOC-IST       TO WS-COD-SOC-ISTN .
014696*    MOVE  SMO-COD-FON           TO WS-COD-FONN .
014696*    MOVE  SMO-COD-LIN           TO WS-COD-LINN .
           MOVE  SMO-FLG-TIT-CTT       TO WS-TIP-CTTX.
           MOVE  SMO-COD-TIT           TO WS-COD-TITX
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES                 TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
            WS-KEY-LINEA  WS-KEY-TITOLO  WS-KEY-TIP-CTT
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

           PERFORM Y05-OPEN-CUR6-TBSMO
           THRU    Y05-OPEN-CUR6-TBSMO-EXIT.

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE ' TBSMOFC6 '  TO WSN-SKB-COPY .
           MOVE ' Y06-FETCH-CUR6-TBSMO ' TO WSN-SKB-LABEL .
           MOVE ' TBSMO' TO WSN-SKB-TABELLA .
           MOVE ' FETCH CURSOR '        TO WSN-SKB-FUNZIONE .
014696*    INITIALIZE WS-IMPO-FONDO.
014696*    MOVE  SMO-COD-IST            TO WS-COD-ISTX .
014696*    MOVE  SMO-COD-SOC-IST        TO WS-COD-SOC-ISTN .
014696*    MOVE  SMO-COD-FON            TO WS-COD-FONN .
014696*    MOVE  SMO-COD-LIN            TO WS-COD-LINN .
014696*    MOVE  SMO-FLG-TIT-CTT        TO WS-TIP-CTTX.
014696*    MOVE  SMO-COD-TIT            TO WS-COD-TITX
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*    STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA   WS-KEY-TITOLO WS-KEY-TIP-CTT
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

           PERFORM Y06-FETCH-CUR6-TBSMO
           THRU    Y06-FETCH-CUR6-TBSMO-EXIT.

           IF ENGIRC-NOTF-ENDFILE
      *     IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
             MOVE 'TBSMOCL6'             TO WSN-SKB-COPY
             MOVE 'Y07-CLOSE-CUR6-TBSMO ' TO WSN-SKB-LABEL
             MOVE 'TBSMO'                 TO WSN-SKB-TABELLA
             MOVE 'CLOSE CURSOR'          TO WSN-SKB-FUNZIONE
014696*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*      STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*      WS-KEY-LINEA   WS-KEY-TITOLO WS-KEY-TIP-CTT
014696*      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

             PERFORM Y07-CLOSE-CUR6-TBSMO
             THRU    Y07-CLOSE-CUR6-TBSMO-EXIT
             GO TO COMPRAVENDITA-EXIT
           END-IF.

      * CERCA DATI GESTORE
MODTP *436 PERFORM
MODTP *436 VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000 OR
MODTP *436 ( TAB-PSA-GES-COD-TIT (PGM-IND1) = TAB-PSA-COD-TIT (PGM-IND4)
MODTP *436 AND TAB-PSA-GES-COD-GES (PGM-IND1) = SMO-COD-GES )
MODTP *436 END-PERFORM.
MODTP *436 IF PGM-IND1 > 30000
MODTP *436     MOVE 'B0015'           TO CG-BLOCFON-MOTIVO
MODTP *436     MOVE 'TABELL'          TO CG-BLOCFON-NOTE
MODTP *436     MOVE 'RICERCA POSIZIONE PORTAF. GESTORE'
MODTP *436                            TO CG-BLOCFON-FASE
MODTP *436     MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
MODTP *436     MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
MODTP *436     MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
MODTP *436     MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
MODTP *436     MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
MODTP *436     MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
MODTP *436     PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
MODTP *436     MOVE 'SI' TO SW-USC-X-BLOCCO
MODTP *436     GO TO  COMPRAVENDITA-EXIT
MODTP *436 END-IF.
      * LETTURA DI TBSMO PER DEPURAZIONE SALDO
           PERFORM DEPURA-SMO THRU DEPURA-SMO-EXIT
           UNTIL  ENGIRC-NOTF-ENDFILE.

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE 'TBSMOCL6'              TO WSN-SKB-COPY .
           MOVE 'Y07-CLOSE-CUR6-TBSMO ' TO WSN-SKB-LABEL .
           MOVE 'TBSMO'                 TO WSN-SKB-TABELLA .
           MOVE 'CLOSE CURSOR'          TO WSN-SKB-FUNZIONE .
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*    STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA  WS-KEY-TITOLO WS-KEY-TIP-CTT
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI .

           PERFORM Y07-CLOSE-CUR6-TBSMO
           THRU    Y07-CLOSE-CUR6-TBSMO-EXIT.

006664D    DISPLAY 'FINE COMPRAVENDITA DA ESCLUDERE'.
      *
       COMPRAVENDITA-EXIT.
           EXIT.
018880******************************************************************
018880**   ROUTINE OPERAZIONI DI COMPRAVENDITA DA ESCLUDERE IN CASO DI**
018880**   DISTRIBUZIONE DIVIDENDI                                    **
018880******************************************************************
018880 COMPRAVENDITA-DVD.
      *
018880D    DISPLAY ' COMPRAVENDITA DA ESCLUDERE X DIVIDENDI'.
018880
018880     PERFORM  VARYING PGM-IND1 FROM 1 BY 1
018880              UNTIL (PGM-IND1 > PGM-GES-ELE)
018880        MOVE ZEROES TO TAB-PSA-GES-QTA-DEP (PGM-IND1)
018880     END-PERFORM.
018880*
018880     MOVE TAB-PSA-QTA-TOT (PGM-IND4)   TO VALORE-NOMINALE.
018880D    DISPLAY 'VAL-NOM DVD ' VALORE-NOMINALE.
018880D    DISPLAY 'TIT-DAT-DVD ' TIT-DAT-DVD.
018880
018880     MOVE S-ELA-COD-IST              TO SMO-COD-IST    .
018880     MOVE S-ELA-COD-SOC-IST          TO SMO-COD-SOC-IST.
018880     MOVE S-ELA-COD-FON              TO SMO-COD-FON    .
018880     MOVE S-ELA-COD-LIN              TO SMO-COD-LIN    .
018880     MOVE 'T'                        TO SMO-FLG-TIT-CTT.
018880     MOVE TAB-PSA-COD-TIT (PGM-IND4) TO SMO-COD-TIT    .
018880     MOVE TIT-DAT-DVD                TO SMO-DAT-OPE    .
018880
018880* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
018880     MOVE 'GFSMOAAH'              TO WSN-SKB-COPY .
018880     MOVE 'Y05-OPEN-CURAH-TBSMO ' TO WSN-SKB-LABEL .
018880     MOVE 'TBSMO'                 TO WSN-SKB-TABELLA .
018880     MOVE 'OPEN CURSOR'           TO WSN-SKB-FUNZIONE .
018880     MOVE  SMO-FLG-TIT-CTT        TO WS-TIP-CTTX.
018880     MOVE  SMO-COD-TIT            TO WS-COD-TITX
018880     MOVE SPACES                  TO WSN-SKB-CHIAVE-DATI
018880     STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
018880      WS-KEY-LINEA  WS-KEY-TITOLO  WS-KEY-TIP-CTT
018880     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
018880
018880     PERFORM Y05-OPEN-CURAH-TBSMO
018880     THRU    Y05-OPEN-CURAH-TBSMO-EXIT.
018880
018880* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
018880     MOVE ' GFSMOAAH '              TO WSN-SKB-COPY .
018880     MOVE ' Y06-FETCH-CURAH-TBSMO ' TO WSN-SKB-LABEL .
018880     MOVE ' TBSMO'                  TO WSN-SKB-TABELLA .
018880     MOVE ' FETCH CURSOR '          TO WSN-SKB-FUNZIONE .
018880
018880     IF ENGIRC-NORMAL
018880        PERFORM Y06-FETCH-CURAH-TBSMO
018880        THRU    Y06-FETCH-CURAH-TBSMO-EXIT
018880     END-IF.
018880
018880* LETTURA DI TBSMO PER DEPURAZIONE SALDO
018880     PERFORM DEPURA-SMO THRU DEPURA-SMO-EXIT
018880     UNTIL  ENGIRC-NOTF-ENDFILE.
018880
018880* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
018880     MOVE 'GFSMOAAH'               TO WSN-SKB-COPY .
018880     MOVE 'Y07-CLOSE-CURAH-TBSMO ' TO WSN-SKB-LABEL .
018880     MOVE 'TBSMO'                  TO WSN-SKB-TABELLA .
018880     MOVE 'CLOSE CURSOR'           TO WSN-SKB-FUNZIONE .
018880
018880     PERFORM Y07-CLOSE-CURAH-TBSMO
018880     THRU    Y07-CLOSE-CURAH-TBSMO-EXIT.
018880
018880D    DISPLAY 'FINE COMPRAVENDITA DA ESCLUDERE X DIVIDENDI'.
      *
018880 COMPRAVENDITA-DVD-EXIT.
018880     EXIT.
      *-------------------------------------------------------------*
      * ESAME DEI MOVIMENTI SUCCESSIVI ALLA SCADENZA DELLA CEDOLA   *
      * PER OTTENERE IL SALDO DEPURATO DALLE OPERAZIONI PROSSIME
      *------------------------------------------------------------ *
       DEPURA-SMO.
      D    DISPLAY 'CICLO PER DEPURAZIONE SALDO ' SMO-VLT OF DCLTBSMO.

      * CERCA DATI GESTORE
000436     PERFORM
000436*14696  VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000 OR
014696     VARYING PGM-IND1 FROM PGM-IND4 BY 1
014696                      UNTIL PGM-IND1 > PGM-GES-ELE OR
000436     ( TAB-PSA-GES-COD-TIT (PGM-IND1) = TAB-PSA-COD-TIT (PGM-IND4)
000436     AND TAB-PSA-GES-COD-GES (PGM-IND1) = SMO-COD-GES )
014696     OR  TAB-PSA-GES-COD-TIT (PGM-IND1)   >
014696                                        TAB-PSA-COD-TIT (PGM-IND4)
000436     END-PERFORM.
000436*14696 IF PGM-IND1 > 30000
014696     IF PGM-IND1 > PGM-GES-ELE
000436         MOVE 'B0015'           TO CG-BLOCFON-MOTIVO
000436         MOVE 'TABELL'          TO CG-BLOCFON-NOTE
000436         MOVE 'RICERCA POSIZIONE PORTAF. GESTORE'
000436                                TO CG-BLOCFON-FASE
000436         MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
000436         MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
000436         MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
000436         MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
000436         MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
000436         MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
000436         PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
000436         MOVE 'SI' TO SW-USC-X-BLOCCO
000436     ELSE
012093       IF ( SMO-STI-MOV NOT = 'P' AND
012093            SMO-STI-MOV NOT = 'T' )
               IF  (SMO-TIP-MOV OF DCLTBSMO = 'A' OR
                    SMO-TIP-MOV OF DCLTBSMO = 'B')
                 COMPUTE VALORE-NOMINALE = VALORE-NOMINALE -
                         (SMO-QTA-VAL-NMN OF DCLTBSMO )
MODTP            COMPUTE TAB-PSA-GES-QTA-DEP (PGM-IND1) =
MODTP                               TAB-PSA-GES-QTA-DEP (PGM-IND1) -
MODTP                               SMO-QTA-VAL-NMN OF DCLTBSMO
               END-IF

               IF  (SMO-TIP-MOV OF DCLTBSMO = 'V'  OR
                    SMO-TIP-MOV OF DCLTBSMO = 'T')
                  COMPUTE VALORE-NOMINALE = VALORE-NOMINALE +
                       (SMO-QTA-VAL-NMN OF DCLTBSMO)
MODTP             COMPUTE TAB-PSA-GES-QTA-DEP (PGM-IND1) =
MODTP                               TAB-PSA-GES-QTA-DEP (PGM-IND1) +
MODTP                               SMO-QTA-VAL-NMN OF DCLTBSMO
               END-IF
012093       END-IF
000436     END-IF.
      *
      D    DISPLAY 'QUANTITA GESTORE DEPURATA - INDICE '
      D    DISPLAY TAB-PSA-GES-QTA-DEP(PGM-IND1) PGM-IND1
      D    DISPLAY 'GESTORE TROVATO ' TAB-PSA-GES-COD-GES(PGM-IND1)
      D    DISPLAY 'IMPORTO SMO     ' SMO-QTA-VAL-NMN

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*     MOVE ' TBSMOFC6 '  TO WSN-SKB-COPY.
014696*     MOVE ' Y06-FETCH-CUR6-TBSMO ' TO WSN-SKB-LABEL .
014696*     MOVE ' TBSMO' TO WSN-SKB-TABELLA.
014696*     MOVE ' FETCH CURSOR ' TO    WSN-SKB-FUNZIONE.
014696*     INITIALIZE WS-IMPO-FONDO .
014696*     MOVE  SMO-COD-IST         TO WS-COD-ISTX.
014696*     MOVE  SMO-COD-SOC-IST     TO WS-COD-SOC-ISTN.
014696*     MOVE  SMO-COD-FON         TO WS-COD-FONN.
014696*     MOVE  SMO-COD-LIN         TO WS-COD-LINN.
014696*     MOVE  SMO-FLG-TIT-CTT     TO WS-TIP-CTTX.
014696*     MOVE  SMO-COD-TIT         TO WS-COD-TITX.
014696*     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*     STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA   WS-KEY-TITOLO WS-KEY-TIP-CTT
014696*     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *
018880      IF DIVIDENDO
018880         PERFORM Y06-FETCH-CURAH-TBSMO
018880         THRU    Y06-FETCH-CURAH-TBSMO-EXIT
018880      ELSE
               PERFORM Y06-FETCH-CUR6-TBSMO
               THRU    Y06-FETCH-CUR6-TBSMO-EXIT
018880      END-IF.
      *
       DEPURA-SMO-EXIT.
           EXIT.
      ***************************************************************
      *          ROUTINE DI CALCOLO PRESTITI SU TITOLO            *
      ****************************************************************
       CALCOLO-PRESTITI.
      *
      D    DISPLAY ' CALCOLO PRESTITI'.

           MOVE S-ELA-COD-IST TO PTI-COD-IST OF DCLTBPTI.
           MOVE S-ELA-COD-SOC-IST TO PTI-COD-SOC-IST OF DCLTBPTI.
           MOVE S-ELA-COD-FON TO PTI-COD-FON OF DCLTBPTI.
           MOVE S-ELA-COD-LIN TO PTI-COD-LIN OF DCLTBPTI.
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                        TO PTI-COD-TIT OF DCLTBPTI.
           MOVE 'P'                     TO PTI-FLG-TIP-BLC OF DCLTBPTI.
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE ' TBPTIOC1 '            TO WSN-SKB-COPY .
           MOVE ' Y05-OPEN-CUR1-TBPTI ' TO WSN-SKB-LABEL .
           MOVE ' TBPTI'                TO WSN-SKB-TABELLA .
           MOVE ' OPEN CURSOR '         TO WSN-SKB-FUNZIONE .
014696*    INITIALIZE WS-IMPO-FONDO .
014696*    MOVE  PTI-COD-IST        TO WS-COD-ISTX .
014696*    MOVE  PTI-COD-SOC-IST    TO WS-COD-SOC-ISTN .
014696*    MOVE  PTI-COD-FON        TO WS-COD-FONN .
014696*    MOVE  PTI-COD-LIN        TO WS-COD-LINN .
           MOVE  PTI-COD-TIT        TO WS-COD-TITX .
           MOVE  'P'                TO WS-TIP-BLCX .
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT .
014696     MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
                  WS-KEY-TITOLO  WS-KEY-BLOCCO
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI .

016938D    DISPLAY 'PTI-COD-IST        ' PTI-COD-IST
016938D    DISPLAY 'PTI-COD-SOC-IST    ' PTI-COD-SOC-IST
016938D    DISPLAY 'PTI-COD-FON        ' PTI-COD-FON
016938D    DISPLAY 'PTI-COD-LIN        ' PTI-COD-LIN
016938D    DISPLAY 'PTI-COD-TIT        ' PTI-COD-TIT
           PERFORM Y05-OPEN-CUR1-TBPTI THRU Y05-OPEN-CUR1-TBPTI-EXIT.

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE ' TBPTIFC1 '             TO WSN-SKB-COPY .
           MOVE ' Y06-FETCH-CUR1-TBPTI ' TO WSN-SKB-LABEL .
           MOVE ' TBPTI'                 TO WSN-SKB-TABELLA .
           MOVE ' FETCH CURSOR '         TO WSN-SKB-FUNZIONE .
014696*    INITIALIZE WS-IMPO-FONDO .
014696*    MOVE  PTI-COD-IST        TO WS-COD-ISTX .
014696*    MOVE  PTI-COD-SOC-IST    TO WS-COD-SOC-ISTN .
014696*    MOVE  PTI-COD-FON        TO WS-COD-FONN .
014696*    MOVE  PTI-COD-LIN        TO WS-COD-LINN .
014696*    MOVE  PTI-COD-TIT        TO WS-COD-TITX .
014696*    MOVE  'P'                TO WS-TIP-BLCX .
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT .
014696*    STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*    WS-KEY-GESTORE WS-KEY-TITOLO  WS-KEY-BLOCCO
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI .

           PERFORM Y06-FETCH-CUR1-TBPTI
           THRU    Y06-FETCH-CUR1-TBPTI-EXIT.

      D    DISPLAY 'FETCH SU PTI '.
           IF ENGIRC-NOTF-ENDFILE
      D       DISPLAY 'NON HA TROVATO'
      *   IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
             MOVE ' TBPTICL1 '             TO WSN-SKB-COPY
             MOVE ' Y07-CLOSE-CUR1-TBPTI ' TO WSN-SKB-LABEL
             MOVE ' TBPTI'                 TO WSN-SKB-TABELLA
             MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE
014696*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*      STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*      WS-KEY-TITOLO  WS-KEY-BLOCCO
014696*      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

             PERFORM Y07-CLOSE-CUR1-TBPTI
             THRU    Y07-CLOSE-CUR1-TBPTI-EXIT
             GO TO CALCOLO-PRESTITI-EXIT
           END-IF.

           PERFORM LETTURA-PTI  THRU LETTURA-PTI-EXIT
           UNTIL ENGIRC-NOTF-ENDFILE

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE ' TBPTICL1 '            TO WSN-SKB-COPY .
           MOVE ' Y07-CLOSE-CUR1-TBPTI ' TO WSN-SKB-LABEL .
           MOVE ' TBPTI'                 TO WSN-SKB-TABELLA .
           MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE .
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT .
014696*    STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*    WS-KEY-TITOLO  WS-KEY-BLOCCO
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI .

           PERFORM Y07-CLOSE-CUR1-TBPTI
           THRU Y07-CLOSE-CUR1-TBPTI-EXIT.

      D    DISPLAY ' CALCOLO PRESTITI FINE'.
      *
        CALCOLO-PRESTITI-EXIT.
           EXIT.
      *--------------------------------------------------------------*
      *             CICLO DI LETTURA DI PTI                          *
      *--------------------------------------------------------------*
       LETTURA-PTI.
      *
      D    DISPLAY 'LETTURA PTI'.

           MOVE PTI-DAT-SCD (7:4)   TO WS-COM1-DATA (1:4).
           MOVE PTI-DAT-SCD (4:2)   TO WS-COM1-DATA (5:2).
           MOVE PTI-DAT-SCD (1:2)   TO WS-COM1-DATA (7:2).

           MOVE CED-DAT-SCD (7:4)   TO WS-COM2-DATA (1:4).
           MOVE CED-DAT-SCD (4:2)   TO WS-COM2-DATA (5:2).
           MOVE CED-DAT-SCD (1:2)   TO WS-COM2-DATA (7:2).

018644     MOVE PTI-DAT-ATT (7:4)   TO WS-DAT-ATT  (1:4).
018644     MOVE PTI-DAT-ATT (4:2)   TO WS-DAT-ATT  (5:2).
018644     MOVE PTI-DAT-ATT (1:2)   TO WS-DAT-ATT  (7:2).

      * SE LA DATA DI SCADENZA DEL PRESTITO > DELLA DATA
      * DI SCADENZA DELLA CEDOLA  ELABORO
018644* E LA DATA ATTIVAZIONE PRESTITO NON è SUPERIORE ALLA DATA
018644* DI SCADENZA DELLA CEDOLA
016938D    DISPLAY 'WS-COM1-DATA,DATA-SCAD ' WS-COM1-DATA
016938D    DISPLAY 'WS-COM2-DATA,CED-DATA-SCAD ' WS-COM2-DATA
016938D    DISPLAY 'WS-DAT-ATT   ' WS-DAT-ATT
012922*    IF WS-COM1-DATA NOT < WS-COM2-DATA
012922     IF WS-COM1-DATA > WS-COM2-DATA
018644     AND WS-DAT-ATT NOT > WS-COM2-DATA
23000G     AND PTI-FLG-TIP-PRE = 'A'
018644D     DISPLAY 'PRENDO IL PRESTITO '
            IF ((PTI-ALI-FIS OF DCLTBPTI)  NOT = 0  AND
               (PTI-ALI-FIS OF DCLTBPTI) NOT = (TIT-TAS-RIT-FIS
                                                OF DCLTBTIT))
               COMPUTE WS-CEDOLA-PRESTITO =
                         PTI-QTA-VAL-NMN OF DCLTBPTI *
                        (CED-TAS / 100) *
                        ((100 - (PTI-ALI-FIS OF DCLTBPTI)) / 100 )
            ELSE
               COMPUTE WS-CEDOLA-PRESTITO =
                         PTI-QTA-VAL-NMN OF DCLTBPTI  *
                        (CED-TAS / 100 ) *
                        ((100 - (TIT-TAS-RIT-FIS OF DCLTBTIT)) / 100 )
            END-IF
            COMPUTE WS-TOT-NMN-PRESTITO = WS-TOT-NMN-PRESTITO +
                               (PTI-QTA-VAL-NMN OF DCLTBPTI)
            COMPUTE WS-TOT-CED-PRESTITO = WS-TOT-CED-PRESTITO +
                             (WS-CEDOLA-PRESTITO)
           END-IF.

      ** IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*     MOVE 'TBPTIFC1'              TO WSN-SKB-COPY.
014696*     MOVE 'Y06-FETCH-CUR1-TBPTI ' TO WSN-SKB-LABEL.
014696*     MOVE 'TBPTI'                 TO WSN-SKB-TABELLA.
014696*     MOVE 'FETCH CURSOR'          TO WSN-SKB-FUNZIONE.
014696*     INITIALIZE WS-IMPO-FONDO .
014696*     MOVE  SMO-COD-IST        TO WS-COD-ISTX.
014696*     MOVE  SMO-COD-SOC-IST    TO WS-COD-SOC-ISTN .
014696*     MOVE  SMO-COD-FON        TO WS-COD-FONN.
014696*     MOVE  SMO-COD-LIN        TO WS-COD-LINN.
014696*     MOVE  SMO-COD-TIT        TO WS-COD-TITX.
014696*     MOVE  'P'                TO WS-TIP-BLCX.
014696*     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*     STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA WS-KEY-TITOLO  WS-KEY-BLOCCO
014696*     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

            PERFORM Y06-FETCH-CUR1-TBPTI
            THRU    Y06-FETCH-CUR1-TBPTI-EXIT.

      *    IF ENGIRC-NOTF-ENDFILE
      *      MOVE 1 TO WS-LETTURA-PTI
      *    END-IF.
      *
       LETTURA-PTI-EXIT .
           EXIT .
      ***********************************************************++
      *           ROUTINE DI TRATTAMENTO PRESTITI                 *
      *************************************************************
       TRATTAMENTO-PRESTITI.
      *
      D    DISPLAY 'TRATTAMENTO-PRESTITI'.
      D    DISPLAY 'CED-DAT-SCD ' CED-DAT-SCD
           MOVE 0 TO WS-TOT-NMN-PRESTITO
           MOVE 0 TO WS-TOT-CED-PRESTITO
           PERFORM CALCOLO-PRESTITI
           THRU CALCOLO-PRESTITI-EXIT .
      D    DISPLAY ' FINE CALCOLO-PRESTITI'.
      D    DISPLAY 'VAL-NOMINALE = ' VALORE-NOMINALE.
      D    DISPLAY 'NMN-PRESTITO = ' WS-TOT-NMN-PRESTITO.

           IF WS-TOT-NMN-PRESTITO > VALORE-NOMINALE
      * ERRORE BLOCCO LINEA
               MOVE 'B0054'           TO CG-BLOCFON-MOTIVO
FS    *        MOVE 'PRESTITO > VALORE NOMINALE TITOLO'
FS    *                                         TO CG-BLOCFON-NOTE
FS             STRING 'PRESTITO > VALORE NOMINALE TITOLO - '
FS                    TIT-COD-TIT
FS             DELIMITED BY SIZE INTO CG-BLOCFON-NOTE
               MOVE 'TRATTAMENTO PRESTITI STACCO CEDOLE'
                                      TO CG-BLOCFON-FASE
               MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
               MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
               MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
               MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
               MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
               MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
               PERFORM X01-BLOC-FON   THRU X01-BLOC-FON-EXIT
               MOVE 'SI' TO SW-USC-X-BLOCCO
               GO TO  TRATTAMENTO-PRESTITI-EXIT
           ELSE
               COMPUTE VALORE-NOMINALE = VALORE-NOMINALE -
                                         WS-TOT-NMN-PRESTITO
           END-IF.
      *
           IF WS-TOT-NMN-PRESTITO NOT = 0
016938        PERFORM VARYING PGM-IND1 FROM 1 BY 1 UNTIL
016938*5847R  PGM-IND1 > 30000
05847R        PGM-IND1 > 35000
016938        OR TAB-PSA-GES-COD-TIT(PGM-IND1) = SPACES
016938        OR (TAB-PSA-GES-COD-TIT(PGM-IND1) =
016938            TAB-PSA-COD-TIT(PGM-IND4) AND
016938            TAB-PSA-GES-QTA-TOT(PGM-IND1) NOT = ZEROES)
016938        END-PERFORM
016938        PERFORM CERCA-LINEA-GESTORE
016938        THRU    CERCA-LINEA-GESTORE-EXIT
FS            MOVE COM-LGS-FLG-CED-DVS TO COM-LGS-FLG-DVS

000717*6026 MOVE 'L' TO COM-LIV-CCC
006026      MOVE 'G' TO COM-LIV-CCC

291099      PERFORM CONTO-CORRENTE-LINEA
291099      THRU    CONTO-CORRENTE-LINEA-EXIT

006026      MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
      D     DISPLAY '---> WS-COD-DVS........' WS-COD-DVS
      D     DISPLAY '---> LGS-FLG-CED-DVS...' LGS-FLG-CED-DVS

006026      MOVE LGS-FLG-CED-DVS     TO COM-LGS-FLG-DVS
006026
006026*16938MOVE 'S'                 TO WS-FLG-IND4
006026D     DISPLAY 'CONTO-CORRENTE-GESTORE'
006026      PERFORM CONTO-CORRENTE-GESTORE
006026      THRU    CONTO-CORRENTE-GESTORE-EXIT
006026
006026      MOVE WS-COD-DVS          TO COM-CCC-COD-DVS
      D     DISPLAY '---> WS-COD-DVS...' WS-COD-DVS

006026
006026      IF SW-USC-X-BLOCCO = 'SI'
006026         GO TO TRATTAMENTO-PRESTITI-EXIT
006026      END-IF

            IF TIT-TIP-TIT = 1
      D        DISPLAY 'SCRITTURA-LIQ-CED'
               PERFORM  SCRITTURA-LIQ-CED
               THRU    SCRITTURA-LIQ-CED-EXIT
               IF SW-USC-X-BLOCCO = 'SI'
                  GO TO TRATTAMENTO-PRESTITI-EXIT
               END-IF
            END-IF
            IF TIT-TIP-TIT = 2
               MOVE VALORE-NOMINALE TO NUMERO-AZIONI
      D        DISPLAY 'SCRITTURA-PRESTITO'
               PERFORM SCRITTURA-PRESTITO-TIT
               THRU   SCRITTURA-PRESTITO-TIT-EXIT
               IF SW-USC-X-BLOCCO = 'SI'
                  GO TO TRATTAMENTO-PRESTITI-EXIT
               END-IF
             END-IF
           END-IF.
      *
       TRATTAMENTO-PRESTITI-EXIT .
           EXIT .
      ***********************************************************
      *       ROUTINE VALORIZZAZIONE LIQUIDITA'                 *
      ***********************************************************
       VAL-LIQUIDITA-SMLQ0.
      *
      D     DISPLAY 'VAL-LIQUIDITA-SMLQ0'.
250599      ADD 1 TO WS-PRG-MOV.
070199*    MOVE S-ELA-COD-IST           TO S-MLQ0-COD-IST.
070199*    MOVE S-ELA-COD-SOC-IST       TO S-MLQ0-COD-SOC-IST.
070199*    MOVE S-ELA-COD-FON           TO S-MLQ0-COD-FON.
070199*    MOVE S-ELA-COD-LIN           TO S-MLQ0-COD-LIN.
070199     MOVE CCC-COD-IST             TO S-MLQ0-COD-IST.
070199     MOVE CCC-COD-SOC-IST         TO S-MLQ0-COD-SOC-IST.
070199     MOVE CCC-COD-FON             TO S-MLQ0-COD-FON.
070199     MOVE CCC-COD-LIN             TO S-MLQ0-COD-LIN.
           MOVE TAB-PSA-COD-TIT (PGM-IND4) TO S-MLQ0-COD-TIT .
           MOVE WS-COD-DVS              TO S-MLQ0-COD-DVS.
      D    DISPLAY '--->     WS-COD-DVS  ' WS-COD-DVS.
      D    DISPLAY '--->     CCC-COD-DVS ' CCC-COD-DVS.
           MOVE WS-COD-CAU              TO S-MLQ0-COD-CAU.
MODTP      MOVE WS-NUM-CCC              TO S-MLQ0-NUM-CCC.
MODTP      MOVE WS-COD-FIL              TO S-MLQ0-COD-FIL.
MODTP      MOVE WS-TIP-CCC              TO S-MLQ0-TIP-CCC.
17302G     MOVE WS-CAT-CCC              TO S-MLQ0-CAT.
           MOVE WS-DATA-VLT             TO S-MLQ0-VLT.
           MOVE S-ELA-DAT-LAZ           TO S-MLQ0-DAT-OPE.
           MOVE WS-TIP-DSP              TO S-MLQ0-TIP-DSP.
           MOVE WS-PRG-MOV              TO S-MLQ0-PRG.
030100     MOVE 'T'                     TO S-MLQ0-FLG-TIT-CTT.
070199*    MOVE 0                       TO S-MLQ0-COD-CTP.
070199     MOVE CCC-COD-CTP OF DCLTBCCC TO S-MLQ0-COD-CTP.
080299*    MOVE 0                       TO S-MLQ0-DAT-RGL.
080299     MOVE '01.01.0001'            TO S-MLQ0-DAT-RGL.
           MOVE 0                       TO S-MLQ0-PRZ.
           MOVE 'A'                     TO S-MLQ0-FLG-TIP-INS.
           MOVE 'O'                     TO S-MLQ0-FLG-STS.
           MOVE 0                       TO S-MLQ0-PRG-COL.
           MOVE WS-VAL-NMN              TO S-MLQ0-QTA-VAL-NMN.
           MOVE WS-IMP                  TO S-MLQ0-IMP.
           MOVE 0                       TO S-MLQ0-IMP-QUO .
      *
       VAL-LIQUIDITA-SMLQ0-EXIT .
           EXIT .
      **************************************************************
       VAL-LIQUIDITA-SMLQ1.
      *
016938D    DISPLAY 'VAL-LIQUIDITA-SMLQ1'.
291299*    ADD 1 TO WS-PRG-MOV.
070199*    MOVE S-ELA-COD-IST           TO S-MLQ1-COD-IST.
070199*    MOVE S-ELA-COD-SOC-IST       TO S-MLQ1-COD-SOC-IST.
070199*    MOVE S-ELA-COD-FON           TO S-MLQ1-COD-FON.
070199*    MOVE S-ELA-COD-LIN           TO S-MLQ1-COD-LIN.
070199     MOVE CCC-COD-IST             TO S-MLQ1-COD-IST.
070199     MOVE CCC-COD-SOC-IST         TO S-MLQ1-COD-SOC-IST.
070199     MOVE CCC-COD-FON             TO S-MLQ1-COD-FON.
070199     MOVE CCC-COD-LIN             TO S-MLQ1-COD-LIN.
           MOVE TAB-PSA-COD-TIT (PGM-IND4) TO S-MLQ1-COD-TIT .
           MOVE WS-COD-DVS              TO S-MLQ1-COD-DVS.
           MOVE WS-COD-CAU              TO S-MLQ1-COD-CAU.
MODTP      MOVE WS-NUM-CCC              TO S-MLQ1-NUM-CCC.
MODTP      MOVE WS-COD-FIL              TO S-MLQ1-COD-FIL.
17302G     MOVE WS-CAT-CCC              TO S-MLQ1-CAT.
MODTP      MOVE WS-TIP-CCC              TO S-MLQ1-TIP-CCC.
           MOVE WS-DATA-VLT             TO S-MLQ1-VLT.
           MOVE S-ELA-DAT-LAZ           TO S-MLQ1-DAT-OPE.
           MOVE WS-TIP-DSP              TO S-MLQ1-TIP-DSP.
           MOVE WS-PRG-MOV              TO S-MLQ1-PRG.
070199*    MOVE 0                       TO S-MLQ1-COD-CTP.
070199     MOVE CCC-COD-CTP OF DCLTBCCC TO S-MLQ1-COD-CTP.
080299*    MOVE 0                       TO S-MLQ1-DAT-RGL.
080299     MOVE '01.01.0001'            TO S-MLQ1-DAT-RGL.
           MOVE 0                       TO S-MLQ1-PRZ.
           MOVE 'A'                     TO S-MLQ1-FLG-TIP-INS.
           MOVE 'O'                     TO S-MLQ1-FLG-STS.
           MOVE 0                       TO S-MLQ1-PRG-COL.
           MOVE WS-VAL-NMN              TO S-MLQ1-QTA-VAL-NMN.
           MOVE WS-IMP                  TO S-MLQ1-IMP.
           MOVE 0                       TO S-MLQ1-IMP-QUO .
      *
       VAL-LIQUIDITA-SMLQ1-EXIT .
           EXIT .
      **************************************************************
      *             ROUTINE DI LETTURA CAUSALE                   *
      **************************************************************
       LETTURA-CAUSALE.
      *
           MOVE S-ELA-COD-IST                 TO CG-LETCAU-COD-IST.
           MOVE S-ELA-COD-SOC-IST             TO CG-LETCAU-COD-SOC-IST.
           MOVE S-ELA-COD-FON                 TO CG-LETCAU-COD-FON.
           MOVE S-ELA-COD-LIN                 TO CG-LETCAU-COD-LIN.
MODTP *    MOVE PSA-COD-GES   TO CG-LETCAU-COD-GES.
           MOVE WS-COD-CAU                    TO CG-LETCAU-COD-CAU.
      D    DISPLAY ' LETT-CAUS'.
      D    DISPLAY 'COD-IST = ' CG-LETCAU-COD-IST.
      D    DISPLAY 'COD-SOC-IST = ' CG-LETCAU-COD-SOC-IST.
      D    DISPLAY 'COD-FON     = ' CG-LETCAU-COD-FON.
      D    DISPLAY 'COD-LIN     = ' CG-LETCAU-COD-LIN.
      D    DISPLAY 'COD-GES     = ' CG-LETCAU-COD-GES.
      D    DISPLAY 'COD-CAU     = ' CG-LETCAU-COD-CAU.
           PERFORM X01-LETT-CAUS THRU X01-LETT-CAUS-EXIT.

           IF CG-LETCAU-CODERR NOT = SPACE
      * ERRORE BLOCCO LINEA
MODTP          MOVE ZEROES            TO CG-LETCAU-COD-GES
MODTP          PERFORM X01-LETT-CAUS THRU X01-LETT-CAUS-EXIT
MODTP          IF CG-LETCAU-CODERR NOT = SPACE
                  MOVE 'B0026'           TO CG-BLOCFON-MOTIVO
                  MOVE 'SELECT'          TO CG-BLOCFON-NOTE
                  MOVE 'CALCOLO E TOT. RIMBORSI , CEDOLE'
                                      TO CG-BLOCFON-FASE
                  MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
                  MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
                  MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
                  MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
                  MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
                  MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146            MOVE 'GFUWM300' TO WSN-SKB-PGM
                  PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
                  MOVE 'SI' TO SW-USC-X-BLOCCO
                  GO TO LETTURA-CAUSALE-EXIT
MODTP          END-IF
           END-IF.

           MOVE CAU-TIP-DSP OF DCLTBCAU TO WS-TIP-DSP.
      *
       LETTURA-CAUSALE-EXIT .
           EXIT .
      ************************************************************
      *        ROUTINE DI SCRITTURA IN LIQUIDITA'               *
      *        CEDOLE  SU PRESTITO TITOLO                       *
      ************************************************************
       SCRITTURA-LIQ-CED.
      *
016938D    DISPLAY 'SCRITTURA-LIQ-CED'.
           IF WS-NAZ-TITOLO = 'I'
            MOVE 'PCI' TO WS-COD-CAU
           ELSE
            MOVE 'PCE' TO WS-COD-CAU
           END-IF.
           MOVE WS-COD-CAU TO CAU-COD-CAU OF DCLTBCAU.
           MOVE WS-TOT-NMN-PRESTITO  TO WS-VAL-NMN.
           MOVE WS-TOT-CED-PRESTITO  TO WS-IMP.
016938D    DISPLAY 'LGS-FLG-CCC ' LGS-FLG-CCC
      *
006026     IF LGS-FLG-CCC = 'S'
MODTP          MOVE ZEROES              TO S-MLQ0-COD-GES
MODTP *14696   MOVE ZEROES              TO S-MLQ1-COD-GES
016938         MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC
016938         MOVE COM-CCC-COD-FIL     TO WS-COD-FIL
17302G         MOVE COM-CCC-CAT         TO WS-CAT-CCC
016938         MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC
016938         MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
006026     ELSE
006026*16938   MOVE TAB-PSA-GES-COD-GES (PGM-IND4) TO  S-MLQ0-COD-GES
006026*16938   MOVE TAB-PSA-GES-COD-GES (PGM-IND4) TO  S-MLQ1-COD-GES
006026*14696   MOVE TAB-PSA-GES-COD-GES (PGM-IND4) TO  S-MLQ1-COD-GES
016938         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO  S-MLQ0-COD-GES
016938         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO  S-MLQ1-COD-GES
016938         MOVE GES-CCC-NUM-CCC     TO WS-NUM-CCC
016938         MOVE GES-CCC-COD-FIL     TO WS-COD-FIL
17302G         MOVE GES-CCC-CAT         TO WS-CAT-CCC
016938         MOVE GES-CCC-TIP-CCC     TO WS-TIP-CCC
016938         MOVE GES-CCC-COD-DVS     TO WS-COD-DVS
006026     END-IF
MODTP?*16938MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC.
MODTP?*16938MOVE COM-CCC-COD-FIL     TO WS-COD-FIL.
MODTP?*16938MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC.
MODTP?*16938MOVE COM-CCC-COD-DVS     TO WS-COD-DVS.

014696*    PERFORM VAL-LIQUIDITA-SMLQ0
014696*    THRU    VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1
014696*    THRU VAL-LIQUIDITA-SMLQ1-EXIT.
MODTP      MOVE ZEROES                        TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
            GO TO SCRITTURA-LIQ-CED-EXIT
           END-IF .

           IF CAU-FLG-LIQ = 'S'

250599*     ADD 1 TO WS-PRG-MOV
270599D        DISPLAY 'SCRITTURA LIQ STACCO TIT PREST   '
014696         PERFORM VAL-LIQUIDITA-SMLQ0
014696            THRU VAL-LIQUIDITA-SMLQ0-EXIT
               WRITE REC-SMLQ0
018605         INITIALIZE              REC-SMLQ0
014696*    ELSE
014696*       PERFORM VAL-LIQUIDITA-SMLQ1
014696*          THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*       WRITE REC-SMLQ1
           END-IF.
      *
       SCRITTURA-LIQ-CED-EXIT .
           EXIT .
MODTP *************************************************************
MODTP *         ROUTINE DI CALCOLO IMPORTO CEDOLA                 *
      **************************************************************
      *          ROUTINE DI SCRITTURA  CEDOLA                    *
      **************************************************************
       SCRITTURA-CEDOLA.
      *
291099*    IF COM-LGS-FLG-CED-DVS = 'F'

            MOVE S-ELA-COD-IST           TO DIV-COD-IST OF DCLTBDIV
            MOVE   COM-TIT-DIV-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-PNZ

291099*     MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*     MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
291099      MOVE  WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
291099      MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
            MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
            MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
            MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
            MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
            MOVE WS-IMPORTO-CEDOLA   TO CG-CONEUR-IMP-INP
            MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
291099      MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*     MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
            MOVE 0                   TO CG-CONEUR-TAS-UNO
            MOVE 0                   TO CG-CONEUR-TAS-DUE
006664D          DISPLAY 'TITOLO ' TIT-COD-TIT
      D          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
            PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

            IF CG-CONEUR-CODERR NOT = SPACE
014146          MOVE 'GFUWM300' TO WSN-SKB-PGM
                PERFORM X01-BLOCCO-IMEU
                THRU    X01-BLOCCO-IMEU-EXIT
                GO TO SCRITTURA-CEDOLA-EXIT
            END-IF

            MOVE CG-CONEUR-IMP-OUT TO WS-IMPORTO-CEDOLA.

291099*    END-IF.

000512* TOTALIZZA IMPORTO CEDOLA SU TOTALIZZATORE RATEO (STACCO CEDOLA)
000512*    DISPLAY 'IMPORTO CEDOLA IN DVS FONDO ' WS-IMPORTO-CEDOLA.
000512*    ADD WS-IMPORTO-CEDOLA TO PGM-RATEO-IMP-TOT.
000512*    DISPLAY 'PGM-RATEO-IMP-TOT ' PGM-RATEO-IMP-TOT

           IF WS-NAZ-TITOLO = 'E'
            MOVE 'SCE' TO WS-COD-CAU
           ELSE
            MOVE 'SCI' TO WS-COD-CAU
           END-IF.

      D    DISPLAY 'LETTURA-CAUS IN SCRITTURA-CEDOLA'.
MODTP      MOVE CCC-COD-GES                   TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
            GO TO SCRITTURA-CEDOLA-EXIT
           END-IF.
           MOVE VALORE-NOMINALE-GES TO WS-VAL-NMN.
           MOVE WS-IMPORTO-CEDOLA TO WS-IMP.

05258G*    APPLICAZIONE DEL COEFFICIENTE IN CIRCOLAZIONE
05258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
05258G        COMPUTE WS-IMP = WS-IMP * MC35-PESO
05258G        COMPUTE WS-VAL-NMN  = WS-VAL-NMN * MC35-PESO
05258G     END-IF.

05258G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
006390     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
006390        COMPUTE WS-IMP = WS-IMP * WS-P-I-FACTOR
006390     END-IF.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730*5258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106*5258G        COMPUTE WS-IMP = WS-IMP * MC35-PESO
008106*5258G        COMPUTE WS-VAL-NMN  = WS-VAL-NMN * MC35-PESO
008106*5258G     END-IF.

MODTP      MOVE CCC-COD-GES             TO S-MLQ0-COD-GES
MODTP *14696                               S-MLQ1-COD-GES.
000717     IF LGS-FLG-CCC = 'S'
MODTP?        MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC
MODTP?        MOVE COM-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE COM-CCC-CAT         TO WS-CAT-CCC
MODTP?        MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC
MODTP?        MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
000717     ELSE
000717        MOVE GES-CCC-NUM-CCC     TO WS-NUM-CCC
000717        MOVE GES-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE GES-CCC-CAT         TO WS-CAT-CCC
000717        MOVE GES-CCC-TIP-CCC     TO WS-TIP-CCC
000717        MOVE GES-CCC-COD-DVS     TO WS-COD-DVS
000717     END-IF.

070199     IF LGS-FLG-CCC = 'S'
070199        MOVE ZERO TO S-MLQ0-COD-GES
070199*14696               S-MLQ1-COD-GES
070199     ELSE
070199        MOVE TAB-PSA-GES-COD-GES(PGM-IND1) TO S-MLQ0-COD-GES
070199*14696                                        S-MLQ1-COD-GES
070199     END-IF.
014696*    PERFORM VAL-LIQUIDITA-SMLQ0
014696*    THRU  VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1
014696*    THRU    VAL-LIQUIDITA-SMLQ1-EXIT.

           IF CAU-FLG-LIQ OF DCLTBCAU = 'S'
250599*            ADD 1 TO WS-PRG-MOV
270599D        DISPLAY 'SCRITTURA LIQ STACCO   '
014696         PERFORM VAL-LIQUIDITA-SMLQ0
014696            THRU VAL-LIQUIDITA-SMLQ0-EXIT
               WRITE REC-SMLQ0
018605         INITIALIZE              REC-SMLQ0
014696*    ELSE
014696*        PERFORM VAL-LIQUIDITA-SMLQ1
014696*           THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*        WRITE  REC-SMLQ1
           END-IF.
           MOVE ZEROES           TO WS-IMPORTO-CEDOLA.
      *
       SCRITTURA-CEDOLA-EXIT.
           EXIT .
      **************************************************************
      *             ROUTINE CALCOLO RITENUTA FISCALE               *
      ***************************************************************
       RITENUTA-FISCALE.
      *
280999*--- INCREMENTA LA SCADENZA CEDOLA DI 1 GIORNO
280999*
280999     MOVE CED-DAT-SCD OF DCLTBCED (1:2) TO GDATE-DIN1 (1:2).
280999     MOVE CED-DAT-SCD OF DCLTBCED (4:2) TO GDATE-DIN1 (3:2).
280999     MOVE CED-DAT-SCD OF DCLTBCED (7:4) TO GDATE-DIN1 (5:4).
280999     MOVE '1'                           TO GDATE-SIN1OTT.
280999     MOVE '0'                           TO GDATE-SIN1ROV.
280999     MOVE 'IN'                          TO GDATE-CFUN.
280999     MOVE 1                             TO GDATE-NGIO-N.
  "        PERFORM  U-X01-GEST-BOPGDATE THRU U-X01-GEST-BOPGDATE-EXIT.
  "        IF GDATE-STC NOT = '0'
  "           MOVE 'B0037'           TO CG-BLOCFON-MOTIVO
  "           MOVE 'INCREM.SCAD'     TO CG-BLOCFON-NOTE
  "           MOVE 'RITENUTA FISCALE CEDOLA'
  "                                  TO CG-BLOCFON-FASE
  "           MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
  "           MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
  "           MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
  "           MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
  "           MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
  "           MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
014146        MOVE 'GFUWM300' TO WSN-SKB-PGM
  "           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
  "           MOVE 'SI' TO SW-USC-X-BLOCCO
  "           GO TO RITENUTA-FISCALE-EXIT
  "        ELSE
  "           MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-FIN(1:2)
  "           MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-FIN(4:2)
  "           MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-FIN(7:4)
  "           MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-RIF(1:2)
  "           MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-RIF(4:2)
  "           MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-RIF(7:4)
280999     END-IF.
280999     MOVE CED-DAT-DEC       TO CG-CLGG-DAT-INI.
280999     MOVE TIT-FRQ-GOD-CED   TO CG-CLGG-FRQ-GOD-CED.
280999     MOVE TIT-BAS-CLC       TO CG-CLGG-BAS-CLC.
280999     MOVE VALORE-NOMINALE   TO CG-CLGG-IMP-NOM.
280999     MOVE TIT-RIT-FON       TO CG-CLGG-RIT-FON.
280999     MOVE TIT-DAT-EMS       TO CG-CLGG-DAT-EMS.
280999     MOVE CED-TAS           TO CG-CLGG-TAS.
280999     PERFORM X01-CLGG
280999     THRU    X01-CLGG-EXIT.
      D    DISPLAY 'IMPORTO CEDOLA DOPO X01-CLGG ' CG-CLGG-RAT.

280999     IF CG-CLGG-STS = '0'
280999        MOVE CG-CLGG-RAT         TO WS-IMPORTO-CEDOLA
280999     ELSE
280999        MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
280999        MOVE SPACES               TO WSN-SKB-LABEL
280999        MOVE SPACES               TO WSN-SKB-TABELLA
280999        MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
014696        MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
280999*14696  INITIALIZE WS-IMPO-FONDO
280999        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
280999     END-IF.
280999*    COMPUTE  WS-IMPORTO-CEDOLA = VALORE-NOMINALE *
280999*                                    CED-TAS OF DCLTBCED / 100.
           COMPUTE  WS-IMP-CED-EST = WS-IMPORTO-CEDOLA -
                                      WS-TOT-DEDUC .
      D    DISPLAY 'IMPORTO CEDOLA ESTINTA ' WS-IMP-CED-EST.
      D    DISPLAY 'IMPORTO CEDOLA         ' WS-IMPORTO-CEDOLA
      D    DISPLAY 'TOTALE DEDUCIBILE      ' WS-TOT-DEDUC.
           MOVE WS-IMP-CED-EST TO WK-IMP-CED-EST .

           MOVE COM-TIT-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-PNZ.

           MOVE COM-FND-DIV-IPS-FLG-DVS-IN   TO CG-CONEUR-FLG-DVS-ARR
                                                 COM-FLG-DVS-IN.
           MOVE COM-FND-DIV-IPS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
                                                COM-FLG-LIT.
           MOVE FND-COD-DVS-IPS             TO COM-COD-DVS.

           MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST.
           MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST .
           MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON .
           MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM .
           MOVE WS-IMP-CED-EST      TO CG-CONEUR-IMP-INP.
           MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ .
           MOVE FND-COD-DVS-IPS     TO CG-CONEUR-COD-DVS-ARR .
           MOVE 0                   TO CG-CONEUR-TAS-UNO .
           MOVE 0                   TO CG-CONEUR-TAS-DUE .
006664D          DISPLAY 'TITOLO ' TIT-COD-TIT
      D          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
           PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.

           IF CG-CONEUR-CODERR NOT = SPACE
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
               PERFORM X01-BLOCCO-IMEU
               THRU    X01-BLOCCO-IMEU-EXIT
               GO TO RITENUTA-FISCALE-EXIT
           END-IF.
           MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST.
221099     IF WS-ESENTE-0 = 0
221099*    IF WS-ESENTE-0 NOT = 2 AND NOT = 3
002040*10122  IF FND-FLG-FND-IMM = 'S'
002040*10122     COMPUTE PGM-RIT-FIS ROUNDED = (WS-IMP-CED-EST *
002040*10122                               (TIT-RIT-FIS-PRE / 100 ))
002040*10122  ELSE
000540           IF FND-TIP-FON = 'C'
001053             OR (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 > 20001231)
000540              COMPUTE PGM-RIT-FIS ROUNDED = (WS-IMP-CED-EST *
000540                                (TIT-RIT-FIS-POS / 100 ))
000540           ELSE
                    COMPUTE PGM-RIT-FIS ROUNDED = (WS-IMP-CED-EST *
                                      (TIT-TAS-RIT-FIS / 100 ))
000540           END-IF
002040*10122  END-IF
140499     ELSE
140499           MOVE ZEROES            TO PGM-RIT-FIS
140499     END-IF.

           COMPUTE PGM-TOT-RIT-FIS-LINEA =
                   PGM-TOT-RIT-FIS-LINEA + PGM-RIT-FIS          .

000540     MOVE WK-IMP-CED-EST TO WS-IMP-CED-EST.

006664D    DISPLAY 'TOT-RIT-FIS  ' PGM-TOT-RIT-FIS-LINEA
           MOVE 'RFT' TO WS-COD-CAU.
           MOVE VALORE-NOMINALE           TO WS-VAL-NMN.
           MOVE PGM-RIT-FIS               TO WS-IMP.
05258G*    APPLICAZIONE DEL COEFFICIENTE IN CIRCOLAZIONE
05258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
05258G        COMPUTE WS-IMP = WS-IMP * MC35-PESO
05258G        COMPUTE WS-VAL-NMN  = WS-VAL-NMN * MC35-PESO
05258G     END-IF.

05258G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
006390     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
006390        COMPUTE WS-IMP = WS-IMP * WS-P-I-FACTOR
006390     END-IF.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730*5258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106*5258G        COMPUTE WS-IMP = WS-IMP * MC35-PESO
008106*5258G        COMPUTE WS-VAL-NMN  = WS-VAL-NMN * MC35-PESO
008106*5258G     END-IF.

070100     COMPUTE WS-IMP = WS-IMP * -1.
MODTP      MOVE ZEROES                    TO CG-LETCAU-COD-GES.
      D    DISPLAY 'LETTURA CAUSALE  '  WS-COD-CAU
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
             GO TO RITENUTA-FISCALE-EXIT
           END-IF.
           IF PGM-RIT-FIS NOT = 0
MODTP        MOVE ZEROES                  TO S-MLQ0-COD-GES
MODTP *14696 MOVE ZEROES                  TO S-MLQ1-COD-GES
MODTP        MOVE COM-CCC-IPS-NUM-CCC     TO WS-NUM-CCC
MODTP        MOVE COM-CCC-IPS-COD-FIL     TO WS-COD-FIL
17302G       MOVE COM-CCC-IPS-CAT         TO WS-CAT-CCC
MODTP        MOVE COM-CCC-IPS-TIP-CCC     TO WS-TIP-CCC
MODTP        MOVE COM-CCC-IPS-COD-DVS     TO WS-COD-DVS

000762       MOVE S-ELA-DAT-LAZ (1: 2)    TO WS-DAT-COM3 (7: 2)
000762       MOVE S-ELA-DAT-LAZ (4: 2)    TO WS-DAT-COM3 (5: 2)
000762       MOVE S-ELA-DAT-LAZ (7: 4)    TO WS-DAT-COM3 (1: 4)
310100* SE IL TITOLO E' ITALIANO LA VALUTA DEVE ESSERE POSTA PARI
310100* ALL'ULTIMO GIORNO LAVORATIVO DEL MESE.
000762* (NUOVA NORMATIVA: DAL 01/07/2000 ANCHE I TITOLI ESTERI)
310100       IF WS-NAZ-TITOLO = 'I'
000762          OR WS-DAT-COM3 > 20000630
006664D    DISPLAY 'TITOLO ITALIANO, VALUTA A FINE MESE '
006664D    DISPLAY 'VALUTA ATTUALE ' WS-DATA-VLT
310100          MOVE WS-DATA-VLT(1:2) TO GDATE-DIN1 (1:2)
310100          MOVE WS-DATA-VLT(4:2) TO GDATE-DIN1 (3:2)
310100          MOVE WS-DATA-VLT(7:4) TO GDATE-DIN1 (5:4)
310100          MOVE '1'     TO GDATE-SIN1OTT
310100          MOVE '0'     TO GDATE-SIN1ROV
310100          MOVE 'UM'    TO GDATE-CFUN
310100          PERFORM U-X01-GEST-BOPGDATE
310100          THRU    U-X01-GEST-BOPGDATE-EXIT
006664D    DISPLAY 'VALUTA FINE MESE ' GDATE-DEFF
310100          IF GDATE-STC NOT = '0'
310100             MOVE 'B0037'        TO CG-BLOCFON-MOTIVO
310100             MOVE 'INCREM.SCAD'  TO CG-BLOCFON-NOTE
310100             MOVE 'VALUTA PER TITOLI ITALIANI'
310100                                    TO CG-BLOCFON-FASE
310100             MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
310100             MOVE S-ELA-COD-IST  TO CG-BLOCFON-COD-IST
310100             MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
310100             MOVE S-ELA-COD-FON  TO CG-BLOCFON-COD-FON
310100             MOVE S-ELA-COD-LIN  TO CG-BLOCFON-COD-LIN
310100             MOVE S-ELA-DAT-LAZ  TO CG-BLOCFON-DAT-LAZ
014146             MOVE 'GFUWM300' TO WSN-SKB-PGM
310100             PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
310100             MOVE 'SI' TO SW-USC-X-BLOCCO
310100             GO TO RITENUTA-FISCALE-EXIT
310100          ELSE
310100             MOVE GDATE-DEFF(1:2) TO WS-DATA-VLT(1:2)
310100             MOVE GDATE-DEFF(3:2) TO WS-DATA-VLT(4:2)
310100             MOVE GDATE-DEFF(5:4) TO WS-DATA-VLT(7:4)
310100          END-IF
310100       END-IF
      D      DISPLAY ' PRE VALORIZZA LIQUIDITA'
014696*      PERFORM VAL-LIQUIDITA-SMLQ0
014696*      THRU    VAL-LIQUIDITA-SMLQ0-EXIT
014696*      PERFORM VAL-LIQUIDITA-SMLQ1
014696*      THRU    VAL-LIQUIDITA-SMLQ1-EXIT

      D       DISPLAY 'REC-SMLQ0 '
             IF CAU-FLG-LIQ = 'S'
250599*        ADD 1 TO WS-PRG-MOV
270599D        DISPLAY 'SCRITTURA LIQ RIT FIS '
014696         PERFORM VAL-LIQUIDITA-SMLQ0
014696            THRU VAL-LIQUIDITA-SMLQ0-EXIT
               WRITE REC-SMLQ0
018605         INITIALIZE              REC-SMLQ0
014696*      ELSE
014696*        PERFORM VAL-LIQUIDITA-SMLQ1
014696*           THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*        WRITE REC-SMLQ1
             END-IF
           END-IF.
000512*
05258G*    APPLICAZIONE DEL COEFFICIENTE IN CIRCOLAZIONE
05258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
05258G        COMPUTE PGM-RIT-FIS = PGM-RIT-FIS * MC35-PESO
05258G     END-IF.

05258G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
006390     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
006390        COMPUTE PGM-RIT-FIS = PGM-RIT-FIS * WS-P-I-FACTOR
006390     END-IF.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730*5258G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106*5258G        COMPUTE PGM-RIT-FIS = PGM-RIT-FIS * MC35-PESO
008106*5258G     END-IF.

000512* TOTALIZZA RITENUTA FISCALE CEDOLA SU TOTALIZZATORE RITENUTE
000512     ADD PGM-RIT-FIS TO PGM-RATEO-IMP-RIT.
002214*************************************************************
002214*** SCRITTURA DEI RECORD 2 SUL FLUSSO SDME ******************
002214*************************************************************
002214     IF PGM-RIT-FIS NOT = ZERO
002214              PERFORM SDME-RECORD-TIPO-2
002214                 THRU SDME-RECORD-TIPO-2-EXIT
002214     END-IF.
002214*************************************************************
000512D    DISPLAY 'PGM-RATEO-IMP-RIT ' PGM-RATEO-IMP-RIT.
000512*
       RITENUTA-FISCALE-EXIT.
            EXIT.
25611G**************************************************************
25611G*             ROUTINE CALCOLO RITENUTA FISCALE               *
25611G***************************************************************
25611G RITENUTA-FISCALE-NEW.
25611G*
25611G*--- INCREMENTA LA SCADENZA CEDOLA DI 1 GIORNO
25611G*
25611G     MOVE CED-DAT-SCD OF DCLTBCED (1:2) TO GDATE-DIN1 (1:2).
25611G     MOVE CED-DAT-SCD OF DCLTBCED (4:2) TO GDATE-DIN1 (3:2).
25611G     MOVE CED-DAT-SCD OF DCLTBCED (7:4) TO GDATE-DIN1 (5:4).
25611G     MOVE '1'                           TO GDATE-SIN1OTT.
25611G     MOVE '0'                           TO GDATE-SIN1ROV.
25611G     MOVE 'IN'                          TO GDATE-CFUN.
25611G     MOVE 1                             TO GDATE-NGIO-N.
25611G     PERFORM  U-X01-GEST-BOPGDATE THRU U-X01-GEST-BOPGDATE-EXIT.
25611G     IF GDATE-STC NOT = '0'
25611G        MOVE 'B0037'           TO CG-BLOCFON-MOTIVO
25611G        MOVE 'INCREM.SCAD'     TO CG-BLOCFON-NOTE
25611G        MOVE 'RITENUTA FISCALE CEDOLA'
25611G                               TO CG-BLOCFON-FASE
25611G        MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
25611G        MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
25611G        MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
25611G        MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
25611G        MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
25611G        MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
25611G        MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G        PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
25611G        MOVE 'SI' TO SW-USC-X-BLOCCO
25611G        GO TO RITENUTA-FISCALE-NEW-EXIT
25611G     ELSE
25611G        MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-FIN(1:2)
25611G        MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-FIN(4:2)
25611G        MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-FIN(7:4)
25611G        MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-RIF(1:2)
25611G        MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-RIF(4:2)
25611G        MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-RIF(7:4)
25611G     END-IF.
25611G     MOVE CED-DAT-DEC       TO CG-CLGG-DAT-INI.
25611G     MOVE TIT-FRQ-GOD-CED   TO CG-CLGG-FRQ-GOD-CED.
25611G     MOVE TIT-BAS-CLC       TO CG-CLGG-BAS-CLC.
25611G     MOVE VALORE-NOMINALE   TO CG-CLGG-IMP-NOM.
25611G     MOVE TIT-RIT-FON       TO CG-CLGG-RIT-FON.
25611G     MOVE TIT-DAT-EMS       TO CG-CLGG-DAT-EMS.
25611G     MOVE CED-TAS           TO CG-CLGG-TAS.
25611G     PERFORM X01-CLGG
25611G     THRU    X01-CLGG-EXIT.
25611GD    DISPLAY 'IMPORTO CEDOLA DOPO X01-CLGG ' CG-CLGG-RAT.
25611G
25611G     IF CG-CLGG-STS = '0'
25611G        MOVE CG-CLGG-RAT         TO WS-IMPORTO-CEDOLA
25611G     ELSE
25611G        MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
25611G        MOVE SPACES               TO WSN-SKB-LABEL
25611G        MOVE SPACES               TO WSN-SKB-TABELLA
25611G        MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
25611G        MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
25611G        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
25611G     END-IF.
25611G*******************************************************
25611G* CALCOLO DELLA RITENUTA CON LA DOPPIA TAX
25611G     COMPUTE WS-RATEO-TOTALE = WS-IMPORTO-CEDOLA
25611G* CALCOLO RATEO PARZIALE FINO AL 31.12.2011
25611G*    IF WS-DATA-DEC < 20111027     OR
25611G*       WS-DATA-LAZ < 20111027
25611G     IF WS-DATA-DEC < 20120101     OR
25611G        WS-DATA-LAZ < 20120101
25611GD       DISPLAY 'CALCOLA RATEO PARZIALE '
25611G        MOVE '31.12.2011'          TO CG-CLGG-DAT-RIF
25611G*       MOVE '26.10.2011'          TO CG-CLGG-DAT-RIF
25611G        PERFORM X01-CLGG
25611G        THRU    X01-CLGG-EXIT
25611GD       DISPLAY '*********** CLGG **********'
25611GD       DISPLAY 'TIT ' CED-COD-TIT
25611GD       DISPLAY 'DEC ' CG-CLGG-DAT-INI
25611GD       DISPLAY 'SCD ' CG-CLGG-DAT-FIN
25611GD       DISPLAY 'ELA ' CG-CLGG-DAT-RIF
25611GD       DISPLAY 'NOM ' CG-CLGG-IMP-NOM
25611GD       DISPLAY 'TAS ' CG-CLGG-TAS
25611GD       DISPLAY 'BAS ' CG-CLGG-BAS-CLC
25611GD       DISPLAY 'GG1 ' CG-CLGG-GG-MAT
25611GD       DISPLAY 'GG2 ' CG-CLGG-GG-TOT
25611GD       DISPLAY 'RAT ' CG-CLGG-RAT
25611G        IF CG-CLGG-STS = '0'
25611G           MOVE CG-CLGG-RAT         TO WS-RATEO-PARZIALE
25611G        ELSE
25611G           MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
25611G           MOVE SPACES               TO WSN-SKB-LABEL
25611G           MOVE SPACES               TO WSN-SKB-TABELLA
25611G           MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
25611G           MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
25611G           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
25611G        END-IF
25611GD       DISPLAY 'WS-IMPORTO-CEDOLA PARZ' WS-RATEO-PARZIALE
25611G     END-IF.
25611G     MOVE ZEROES TO WS-TOT-DEDUC.
25611G* CALCOLO RATEO DI PERTINENZA 2012
25611G      COMPUTE WS-RATEO-NEW = WS-RATEO-TOTALE - WS-RATEO-PARZIALE
25611GD     DISPLAY ' RATEO PERIODO NEW  ' WS-RATEO-NEW
25611G      COMPUTE WS-IMPORTO-CEDOLA = WS-RATEO-NEW + WS-RATEO-PARZIALE
25611GD     DISPLAY ' WS-IMPORTO-CEDOLA ' WS-IMPORTO-CEDOLA
25611G*CALCOLO DEDUCIBILE
25611GD     DISPLAY ' DEDUCIBILE PRE      ' PGM-DEDUC-PRE
25611GD     DISPLAY ' DEDUCIBILE POS      ' PGM-DEDUC-POS
25611G      COMPUTE WS-TOT-DEDUC = PGM-DEDUC-POS + PGM-DEDUC-PRE
25611GD     DISPLAY ' TOTALE DEDUCIBILE   ' WS-TOT-DEDUC
25611GD     DISPLAY ' CEDOLA PRE - DEDUC  '
25611G      COMPUTE WS-IMP-CED-EST-PRE = WS-RATEO-PARZIALE -
25611G                                        PGM-DEDUC-PRE
25611GD     DISPLAY ' WS-IMP-CED-EST-PRE ' WS-IMP-CED-EST-PRE
25611G      COMPUTE WS-IMP-CED-EST-POS = WS-RATEO-NEW   -
25611G                                        PGM-DEDUC-POS
25611GD     DISPLAY ' WS-IMP-CED-EST-POS ' WS-IMP-CED-EST-POS
25611G
25611G      COMPUTE WS-IMP-CED-EST = WS-IMP-CED-EST-POS +
25611G                            WS-IMP-CED-EST-PRE
25611GD     DISPLAY ' WS-IMP-CED-EST     ' WS-IMP-CED-EST
25611GD     DISPLAY ' ALIQUOTA PERIODO OLD -FIS-PRE 'TIT-RIT-FIS-PRE
25611G*********************************************************
25611GD    DISPLAY 'IMPORTO CEDOLA ESTINTA ' WS-IMP-CED-EST.
25611GD    DISPLAY 'IMPORTO CEDOLA         ' WS-IMPORTO-CEDOLA
25611GD    DISPLAY 'TOTALE DEDUCIBILE      ' WS-TOT-DEDUC.
25611G     MOVE WS-IMP-CED-EST TO WK-IMP-CED-EST .
25611G
25611G     MOVE COM-TIT-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-PNZ.
25611G
25611G     MOVE COM-FND-DIV-IPS-FLG-DVS-IN   TO CG-CONEUR-FLG-DVS-ARR
25611G                                           COM-FLG-DVS-IN.
25611G     MOVE COM-FND-DIV-IPS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
25611G                                          COM-FLG-LIT.
25611G     MOVE FND-COD-DVS-IPS             TO COM-COD-DVS.
25611G
25611G     MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST.
25611G     MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST .
25611G     MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON .
25611G     MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM .
25611G     MOVE WS-IMP-CED-EST      TO CG-CONEUR-IMP-INP.
25611G     MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ .
25611G     MOVE FND-COD-DVS-IPS     TO CG-CONEUR-COD-DVS-ARR .
25611G     MOVE 0                   TO CG-CONEUR-TAS-UNO .
25611G     MOVE 0                   TO CG-CONEUR-TAS-DUE .
25611GD          DISPLAY 'TITOLO ' TIT-COD-TIT
25611GD          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
25611G     PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.
25611G
25611G     IF CG-CONEUR-CODERR NOT = SPACE
25611G         MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G         PERFORM X01-BLOCCO-IMEU
25611G         THRU    X01-BLOCCO-IMEU-EXIT
25611G         GO TO RITENUTA-FISCALE-NEW-EXIT
25611G     END-IF.
25611G     MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST.
25611G* CONVERTO CEDOLA ESTINTA PRE
25611G     MOVE WS-IMP-CED-EST-PRE  TO CG-CONEUR-IMP-INP.
25611G     MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ .
25611G     MOVE FND-COD-DVS-IPS     TO CG-CONEUR-COD-DVS-ARR .
25611G     MOVE 0                   TO CG-CONEUR-TAS-UNO .
25611G     MOVE 0                   TO CG-CONEUR-TAS-DUE .
25611GD          DISPLAY 'TITOLO ' TIT-COD-TIT
25611GD          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
25611G     PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.
25611G
25611G     IF CG-CONEUR-CODERR NOT = SPACE
25611G         MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G         PERFORM X01-BLOCCO-IMEU
25611G         THRU    X01-BLOCCO-IMEU-EXIT
25611G         GO TO RITENUTA-FISCALE-NEW-EXIT
25611G     END-IF.
25611G     MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST-PRE.
25611G* CONVERTO CEDOLA ESTINTA POS
25611G     MOVE WS-IMP-CED-EST-POS  TO CG-CONEUR-IMP-INP.
25611G     MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ .
25611G     MOVE FND-COD-DVS-IPS     TO CG-CONEUR-COD-DVS-ARR .
25611G     MOVE 0                   TO CG-CONEUR-TAS-UNO .
25611G     MOVE 0                   TO CG-CONEUR-TAS-DUE .
25611GD          DISPLAY 'TITOLO ' TIT-COD-TIT
25611GD          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
25611G     PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.
25611G
25611G     IF CG-CONEUR-CODERR NOT = SPACE
25611G         MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G         PERFORM X01-BLOCCO-IMEU
25611G         THRU    X01-BLOCCO-IMEU-EXIT
25611G         GO TO RITENUTA-FISCALE-NEW-EXIT
25611G     END-IF.
25611G     MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST-POS.
25611G
25611G     IF WS-ESENTE-0 = 0
25611GD             DISPLAY ' CALCOLO RITENUTA NUOVO PERIODO'
25611G              COMPUTE PGM-RIT-FIS ROUNDED = (WS-IMP-CED-EST-POS *
25611G                                (TIT-RIT-FIS-POS / 100 ))
25611GD            DISPLAY ' PGM-RIT-FIS POS  ' PGM-RIT-FIS
25611G             COMPUTE PGM-RIT-FIS-PRE ROUNDED =
25611G                         (WS-IMP-CED-EST-PRE *
25611G                                 TIT-RIT-FIS-PRE / 100 )
25611GD            DISPLAY ' PGM-RIT-FIS PRE  ' PGM-RIT-FIS-PRE
25611G
25611G     ELSE
25611G           MOVE ZEROES            TO PGM-RIT-FIS
25611G     END-IF.
25611G     COMPUTE PGM-RIT-FIS = PGM-RIT-FIS + PGM-RIT-FIS-PRE
25611GD            DISPLAY ' TOTALE RITENUTA  ' PGM-RIT-FIS
25611G     COMPUTE PGM-TOT-RIT-FIS-LINEA =
25611G             PGM-TOT-RIT-FIS-LINEA + PGM-RIT-FIS
25611G
25611G     MOVE WK-IMP-CED-EST TO WS-IMP-CED-EST.
25611G
25611GD    DISPLAY 'TOT-RIT-FIS  ' PGM-TOT-RIT-FIS-LINEA
25611G     MOVE 'RFT' TO WS-COD-CAU.
25611G     MOVE VALORE-NOMINALE           TO WS-VAL-NMN.
25611G     MOVE PGM-RIT-FIS               TO WS-IMP.
25611G*    APPLICAZIONE DEL COEFFICIENTE IN CIRCOLAZIONE
25611G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
25611G        COMPUTE WS-IMP = WS-IMP * MC35-PESO
25611G        COMPUTE WS-VAL-NMN  = WS-VAL-NMN * MC35-PESO
25611G     END-IF.
25611G
25611G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
25611G     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
25611G        COMPUTE WS-IMP = WS-IMP * WS-P-I-FACTOR
25611G     END-IF.
25611G
25611G
25611G     COMPUTE WS-IMP = WS-IMP * -1.
25611G     MOVE ZEROES                    TO CG-LETCAU-COD-GES.
25611GD    DISPLAY 'LETTURA CAUSALE  '  WS-COD-CAU
25611G     PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
25611G     IF SW-USC-X-BLOCCO = 'SI'
25611G       GO TO RITENUTA-FISCALE-NEW-EXIT
25611G     END-IF.
25611G     IF PGM-RIT-FIS NOT = 0
25611G       MOVE ZEROES                  TO S-MLQ0-COD-GES
25611G       MOVE COM-CCC-IPS-NUM-CCC     TO WS-NUM-CCC
25611G       MOVE COM-CCC-IPS-COD-FIL     TO WS-COD-FIL
25611G       MOVE COM-CCC-IPS-CAT         TO WS-CAT-CCC
25611G       MOVE COM-CCC-IPS-TIP-CCC     TO WS-TIP-CCC
25611G       MOVE COM-CCC-IPS-COD-DVS     TO WS-COD-DVS
25611G
25611G       MOVE S-ELA-DAT-LAZ (1: 2)    TO WS-DAT-COM3 (7: 2)
25611G       MOVE S-ELA-DAT-LAZ (4: 2)    TO WS-DAT-COM3 (5: 2)
25611G       MOVE S-ELA-DAT-LAZ (7: 4)    TO WS-DAT-COM3 (1: 4)
25611G* SE IL TITOLO E' ITALIANO LA VALUTA DEVE ESSERE POSTA PARI
25611G* ALL'ULTIMO GIORNO LAVORATIVO DEL MESE.
25611G* (NUOVA NORMATIVA: DAL 01/07/2000 ANCHE I TITOLI ESTERI)
25611G       IF WS-NAZ-TITOLO = 'I'
25611G          OR WS-DAT-COM3 > 20000630
25611GD    DISPLAY 'TITOLO ITALIANO, VALUTA A FINE MESE '
25611GD    DISPLAY 'VALUTA ATTUALE ' WS-DATA-VLT
25611G          MOVE WS-DATA-VLT(1:2) TO GDATE-DIN1 (1:2)
25611G          MOVE WS-DATA-VLT(4:2) TO GDATE-DIN1 (3:2)
25611G          MOVE WS-DATA-VLT(7:4) TO GDATE-DIN1 (5:4)
25611G          MOVE '1'     TO GDATE-SIN1OTT
25611G          MOVE '0'     TO GDATE-SIN1ROV
25611G          MOVE 'UM'    TO GDATE-CFUN
25611G          PERFORM U-X01-GEST-BOPGDATE
25611G          THRU    U-X01-GEST-BOPGDATE-EXIT
25611GD    DISPLAY 'VALUTA FINE MESE ' GDATE-DEFF
25611G          IF GDATE-STC NOT = '0'
25611G             MOVE 'B0037'        TO CG-BLOCFON-MOTIVO
25611G             MOVE 'INCREM.SCAD'  TO CG-BLOCFON-NOTE
25611G             MOVE 'VALUTA PER TITOLI ITALIANI'
25611G                                    TO CG-BLOCFON-FASE
25611G             MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
25611G             MOVE S-ELA-COD-IST  TO CG-BLOCFON-COD-IST
25611G             MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
25611G             MOVE S-ELA-COD-FON  TO CG-BLOCFON-COD-FON
25611G             MOVE S-ELA-COD-LIN  TO CG-BLOCFON-COD-LIN
25611G             MOVE S-ELA-DAT-LAZ  TO CG-BLOCFON-DAT-LAZ
25611G             MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G             PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
25611G             MOVE 'SI' TO SW-USC-X-BLOCCO
25611G             GO TO RITENUTA-FISCALE-NEW-EXIT
25611G          ELSE
25611G             MOVE GDATE-DEFF(1:2) TO WS-DATA-VLT(1:2)
25611G             MOVE GDATE-DEFF(3:2) TO WS-DATA-VLT(4:2)
25611G             MOVE GDATE-DEFF(5:4) TO WS-DATA-VLT(7:4)
25611G          END-IF
25611G       END-IF
25611GD      DISPLAY ' PRE VALORIZZA LIQUIDITA'
25611GD       DISPLAY 'REC-SMLQ0 '
25611G       IF CAU-FLG-LIQ = 'S'
25611GD        DISPLAY 'SCRITTURA LIQ RIT FIS '
25611G         PERFORM VAL-LIQUIDITA-SMLQ0
25611G            THRU VAL-LIQUIDITA-SMLQ0-EXIT
25611G         WRITE REC-SMLQ0
25611G         INITIALIZE              REC-SMLQ0
25611G       END-IF
25611G     END-IF.
25611G*
25611G*    APPLICAZIONE DEL COEFFICIENTE IN CIRCOLAZIONE
25611G     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
25611G        COMPUTE PGM-RIT-FIS = PGM-RIT-FIS * MC35-PESO
25611G     END-IF.
25611G
25611G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
25611G     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
25611G        COMPUTE PGM-RIT-FIS = PGM-RIT-FIS * WS-P-I-FACTOR
25611G     END-IF.
25611G
25611G* TOTALIZZA RITENUTA FISCALE CEDOLA SU TOTALIZZATORE RITENUTE
25611G     ADD PGM-RIT-FIS TO PGM-RATEO-IMP-RIT.
25611G*************************************************************
25611G*** SCRITTURA DEI RECORD 2 SUL FLUSSO SDME ******************
25611G*************************************************************
25611G     IF PGM-RIT-FIS NOT = ZERO
25611G              PERFORM SDME-RECORD-TIPO-2
25611G                 THRU SDME-RECORD-TIPO-2-EXIT
25611G     END-IF.
256114*************************************************************
25611GD    DISPLAY 'PGM-RATEO-IMP-RIT ' PGM-RATEO-IMP-RIT.
25611G*
25611G RITENUTA-FISCALE-NEW-EXIT.
25611G      EXIT.
120399*******************************************************************
120399*  ROUTINE DETTAGLIO                                              *
120399*******************************************************************
120399*STAMPA-DETTAGLIO-ST1.                                            *
120399*--->  VIENE SOSTITUITA DA U-ST20-GEST-DETTAGLIO-0                *
                                                                        *
      ********************************************************
      *  STAMPA I TOTALI X LINEA
      *-------------------------------------------------------
150399*  NOTA : 'U-ST01-TOTALI-LINEA-0'    IN COPY 'GFUSSTCE'
150399*         'U-ST02-TOTALI-LINEA-1'    IN COPY 'GFUSSTSC'
      ********************************************************
       STAMPA-TOTALI.

      * CONTROLLO IL FLG : SE HA STAMPATO ALMENO UNA RIGA

050399*    IF  TOTALI-ST1 = 'S'
050399     IF  TOTALI-ST0 = 'S'

050399*        PERFORM  TOTALI-S3001
050399*        THRU     TOTALI-S3001-EXIT
050399        MOVE COM-FND-DIV-IPS-FLG-DVS-IN TO
050399             COMODO-FND-DIV-FLG-DVS-IN
050399        IF COM-FND-DIV-IPS-FLG-DVS-IN = 'S'
050399          MOVE COM-FND-DIV-IPS-FLG-DVS-IN TO COM-FLG-DVS-IN
050399          MOVE COM-FND-DIV-IPS-FLG-LIT    TO COM-FLG-LIT
050399          MOVE FND-COD-DVS-IPS            TO COM-COD-DVS
050399        END-IF
050399         PERFORM  U-ST01-TOTALI-LINEA-0
050399         THRU     U-ST01-TOTALI-LINEA-0-EXIT

050399*        MOVE SPACE TO TOTALI-ST1
050399         MOVE SPACE TO TOTALI-ST0
            END-IF.

050399*      IF  TOTALI-ST0 = 'S'
050399       IF  TOTALI-ST1 = 'S'
050399*         PERFORM TOTALI-S3000
050399*         THRU    TOTALI-S3000-EXIT
050399        MOVE    COM-FND-DIV-IPS-FLG-DVS-IN      TO
050399                COMODO-FND-DIV-FLG-DVS-IN
050399        IF      COM-FND-DIV-IPS-FLG-DVS-IN = 'S'
050399                MOVE    COM-FND-DIV-IPS-FLG-DVS-IN      TO
050399                        COM-FLG-DVS-IN
050399                MOVE    COM-FND-DIV-IPS-FLG-LIT         TO
050399                        COM-FLG-LIT
050399                MOVE    FND-COD-DVS-IPS                 TO
050399                        COM-COD-DVS
050399        END-IF
050399          PERFORM  U-ST02-TOTALI-LINEA-1
050399          THRU     U-ST02-TOTALI-LINEA-1-EXIT

050399*         MOVE SPACE TO TOTALI-ST1
050399          MOVE SPACE TO TOTALI-ST0
             END-IF.
      *
       STAMPA-TOTALI-EXIT.
           EXIT.
      ****************************************************************
      *         ROUTINE MOVIMENTI DI COMPRAVENDITA                   *
      ****************************************************************
       MOVIMENTI-DI-COMP.
      D    DISPLAY 'ESAME MOVIMENTI DI COMPRAVENDITA'.
      *    MOVE SMO-QTA-VAL-NMN OF DCLTBSMO TO PGM-QTA-VENDITA.
      *
050399     MOVE 1                 TO WS-FLG-CLC.
050399     MOVE CED-DAT-SCD       TO DATA-CASCCE.
050399     MOVE TAB-PSA-COD-TIT(PGM-IND4) TO
050399          COMODO-SMO-COD-TIT.
      *
030699     MOVE ZEROES            TO PGM-TOT-QTA.

050399     PERFORM U-GF05-ELABORA-VALUTE
           THRU    U-GF05-ELABORA-VALUTE-EXIT.

           MOVE PGM-TOT-DEDUC TO WS-TOT-DEDUC.

      D     DISPLAY 'FINE MOV-DI-COMP'.
      *
       MOVIMENTI-DI-COMP-EXIT.
           EXIT.
      *****************************************************************
      *           ROUTINE DI CALCOLO VALUTA PER MOV LIQUIDITA'       *
      ****************************************************************
       CALCOLO-VALUTA.
      *
271099      MOVE COM-DATA    (1:2)    TO WS-DATA-VLT (1:2).
271099      MOVE '.'                  TO WS-DATA-VLT (3:1).
271099      MOVE COM-DATA    (4:2)    TO WS-DATA-VLT (4:2).
271099      MOVE '.'                  TO WS-DATA-VLT (6:1).
271099      MOVE COM-DATA    (7:4)    TO WS-DATA-VLT (7:4).
      *
271099*     IF WS-NAZ-TITOLO = 'E'
271099*
271099*      DISPLAY 'NAZ-TIT = ' WS-NAZ-TITOLO
271099*      MOVE COM-DATA (1:2) TO WS-DATA (1:2)
271099*      MOVE COM-DATA (4:2) TO WS-DATA (3:2)
271099*      MOVE COM-DATA (7:4) TO WS-DATA (5:4)
271099*      DISPLAY 'WS-DATA = ' WS-DATA
271099* RICHIAMO LA ROUTINE CHE INCREMENTA I GIORNI
271099*      MOVE 'IN'         TO GDATE-CFUN
271099*      MOVE WS-DATA      TO GDATE-DIN1
271099*      MOVE IST-GRN-AVA-DAT OF DCLTBIST TO GDATE-NGIO-N
271099*      MOVE '1'          TO GDATE-SIN1OTT
230699*      MOVE '0'          TO GDATE-SIN1ROV
271099*      DISPLAY 'IST-GRN-DAT  = ' GDATE-NGIO
271099*      INITIALIZE    WSN-SKB-CAMPI
271099*      MOVE 'BOXGDATE'           TO WSN-SKB-COPY
271099*      MOVE 'U-X01-GEST-BOPG'     TO WSN-SKB-LABEL
271099*      MOVE SPACE                 TO WSN-SKB-TABELLA
271099*      MOVE 'VALUTA'              TO WSN-SKB-FUNZIONE

271099*      PERFORM U-X01-GEST-BOPGDATE
271099*      THRU    U-X01-GEST-BOPGDATE-EXIT

271099* SPOSTO LA DATA DI RITORNO RETTIFICATA PER EFFETTO DEI GG FEST.
271099*      IF GDATE-STC = '0'
271099*        DISPLAY ' OK. DATA = ' GDATE-DLAV

271099*       MOVE GDATE-DLAV  (1:2)    TO  WS-DATA-VLT (1:2)
271099*       MOVE '.'                  TO  WS-DATA-VLT (3:1)
271099*       MOVE GDATE-DLAV  (3:2)    TO WS-DATA-VLT (4:2)
271099*       MOVE '.'                  TO  WS-DATA-VLT (6:1)
271099*       MOVE GDATE-DLAV  (5:4)    TO WS-DATA-VLT (7:4)
271099*      ELSE

271099*       PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
271099*      END-IF

271099*    ELSE
271099*      DISPLAY ' TITOLO NAZ'

271099*      MOVE COM-DATA (1:2) TO WS-DATA (1:2)
271099*      MOVE COM-DATA (4:2) TO WS-DATA (3:2)
271099*      MOVE COM-DATA (7:4) TO WS-DATA (5:4)

271099* RICHIAMO LA ROUTINE CHE INCREMENTA I GIORNI
271099*      MOVE 'IN'         TO GDATE-CFUN
271099*      MOVE WS-DATA      TO GDATE-DIN1
271099*      MOVE 0            TO GDATE-NGIO-N
271099*      MOVE '1'          TO GDATE-SIN1OTT
230699*      MOVE '0'          TO GDATE-SIN1ROV

271099*      INITIALIZE    WSN-SKB-CAMPI
271099*      MOVE 'BOXGDATE'           TO WSN-SKB-COPY
271099*      MOVE 'U-X01-GEST-BOPG'     TO WSN-SKB-LABEL
271099*      MOVE SPACE                 TO WSN-SKB-TABELLA
271099*      MOVE 'CALCOLA-VALUTA'      TO WSN-SKB-FUNZIONE

271099*      PERFORM U-X01-GEST-BOPGDATE
271099*      THRU    U-X01-GEST-BOPGDATE-EXIT

271099* SPOSTO LA DATA DI RITORNO RETTIFICATA PER EFFETTO DEI GG FEST.
271099*      IF GDATE-STC = '0'
271099*       DISPLAY 'OK'
271099*       MOVE GDATE-DLAV  (1:2)    TO  WS-DATA-VLT (1:2)
271099*       MOVE '.'                   TO WS-DATA-VLT (3:1)
271099*       MOVE GDATE-DLAV  (3:2)    TO WS-DATA-VLT (4:2)
271099*       MOVE '.'                   TO WS-DATA-VLT (6:1)
271099*       MOVE GDATE-DLAV  (5:4)    TO WS-DATA-VLT (7:4)
271099*      ELSE
271099*       PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
271099*      END-IF
271099*    END-IF.
006664D    DISPLAY 'FINE CALCOLO-VALUTA'.
       CALCOLO-VALUTA-EXIT.
           EXIT.
      *
291099 CONTO-CORRENTE-LINEA.
016938D      DISPLAY 'CONTO-CORRENTE-LINEA'
291099* FS   IF COM-LGS-FLG-CED-DVS  = 'F'
FS           IF COM-LGS-FLG-DVS = 'F'
291099          MOVE FND-COD-DVS OF DCLTBFND  TO WS-COD-DVS
291099          MOVE COM-FND-DIV-FLG-DVS-IN   TO WS-COD-DVS-FLG-DVS-IN
291099          MOVE COM-FND-DIV-FLG-LIT      TO WS-COD-DVS-FLG-LIT
291099       ELSE
000961*         IF COM-TIT-DIV-FLG-DVS-IN = 'S' AND
000961*            COM-FND-DIV-FLG-DVS-IN = 'E'
000961*            MOVE FND-COD-DVS            TO WS-COD-DVS
000961*            MOVE COM-FND-DIV-FLG-DVS-IN TO WS-COD-DVS-FLG-DVS-IN
000961*            MOVE COM-FND-DIV-FLG-LIT    TO WS-COD-DVS-FLG-LIT
000961          IF COM-TIT-DIV-FLG-DVS-IN = 'S'
000961             MOVE CG-CEREUR-COD-EUR      TO WS-COD-DVS
000961             MOVE 'E'                    TO WS-COD-DVS-FLG-DVS-IN
000961             MOVE 'N'                    TO WS-COD-DVS-FLG-LIT
291099          ELSE
291099             MOVE COM-TIT-DIV-FLG-DVS-IN TO WS-COD-DVS-FLG-DVS-IN
291099             MOVE COM-TIT-DIV-FLG-LIT    TO WS-COD-DVS-FLG-LIT
291099
291099             MOVE TIT-COD-DVS OF DCLTBTIT  TO WS-COD-DVS
291099          END-IF
291099       END-IF.
      *
291099       IF  S-ELA-COD-IST     NOT = COM-CCC-COD-IST             OR
291099           S-ELA-COD-SOC-IST NOT = COM-CCC-COD-SOC-IST         OR
291099           S-ELA-COD-FON     NOT = COM-CCC-COD-FON             OR
291099           S-ELA-COD-LIN     NOT = COM-CCC-COD-LIN             OR
291099           WS-COD-DVS        NOT = COM-CCC-COD-DVS
291099           MOVE ZERO TO CCC-COD-GES OF DCLTBCCC
291099           PERFORM LETTURA-C-C-ORDINARIO
291099           THRU    LETTURA-C-C-ORDINARIO-EXIT
      D         DISPLAY '** LETTURA C/C ORD -1- SW-BLOK' SW-USC-X-BLOCCO
291099           IF SW-USC-X-BLOCCO = 'SI'
000717              IF COM-LIV-CCC     = 'G'  AND
000717                 LGS-FLG-CCC     = 'N'

000717                 MOVE SPACES TO SW-USC-X-BLOCCO
007521              ELSE
014146                 MOVE 'GFUWM300' TO WSN-SKB-PGM
007521                 PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
000717              END-IF
291099              GO TO CONTO-CORRENTE-LINEA-EXIT
291099           END-IF
291099
020300           MOVE CCC-COD-IST     OF DCLTBCCC TO COM-CCC-COD-IST
020300*          MOVE CCC-COD-IST     OF DCLTBCCC TO COM-CCC-NUM-CCC
291099           MOVE CCC-COD-SOC-IST OF DCLTBCCC TO COM-CCC-COD-SOC-IST
291099           MOVE CCC-COD-FON     OF DCLTBCCC TO COM-CCC-COD-FON
291099           MOVE CCC-COD-LIN     OF DCLTBCCC TO COM-CCC-COD-LIN
291099           MOVE CCC-COD-DVS     OF DCLTBCCC TO COM-CCC-COD-DVS
291099           MOVE CCC-TIP-CCC     OF DCLTBCCC TO COM-CCC-TIP-CCC
291099           MOVE CCC-COD-FIL     OF DCLTBCCC TO COM-CCC-COD-FIL
291099           MOVE CCC-NUM-CCC     OF DCLTBCCC TO COM-CCC-NUM-CCC
17302G           MOVE CCC-CAT         OF DCLTBCCC TO COM-CCC-CAT
291099       END-IF.
      *
291099 CONTO-CORRENTE-LINEA-EXIT.
291099       EXIT.
      *
291099 CONTO-CORRENTE-GESTORE.
      *
      D       DISPLAY 'CONTO-CORRENTE-GESTORE'
291099        IF LGS-FLG-CCC = 'S'
291099             MOVE ZERO TO CCC-COD-GES OF DCLTBCCC
291099        ELSE
006026*16938    IF WS-FLG-IND4 = 'S'
006026*16938       MOVE SPACES TO WS-FLG-IND4
006026*16938       MOVE TAB-PSA-GES-COD-GES (PGM-IND4) TO
006026*16938                                 CCC-COD-GES OF DCLTBCCC
006026*16938    ELSE
291099             MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
291099                                       CCC-COD-GES OF DCLTBCCC
006026*16938    END-IF
000516* FS         IF LGS-FLG-CED-DVS  = 'F'
006664* FS            DISPLAY'COM-LGS-FLG-DVS  = ' COM-LGS-FLG-DVS
FS                 IF COM-LGS-FLG-DVS  = 'F'
000516                MOVE FND-COD-DVS OF DCLTBFND   TO WS-COD-DVS
000516                MOVE COM-FND-DIV-FLG-DVS-IN    TO
000516                                             WS-COD-DVS-FLG-DVS-IN
000516                MOVE COM-FND-DIV-FLG-LIT       TO
000516                                             WS-COD-DVS-FLG-LIT
000516             ELSE
000516*961            IF COM-TIT-DIV-FLG-DVS-IN = 'S' AND
000516*961               COM-FND-DIV-FLG-DVS-IN = 'E'
000516*961               MOVE FND-COD-DVS             TO WS-COD-DVS
000516*961               MOVE COM-FND-DIV-FLG-DVS-IN  TO
000516*961                                         WS-COD-DVS-FLG-DVS-IN
000516*961               MOVE COM-FND-DIV-FLG-LIT     TO
000516*961                                         WS-COD-DVS-FLG-LIT
000961                IF COM-TIT-DIV-FLG-DVS-IN = 'S'
000961                   MOVE CG-CEREUR-COD-EUR TO WS-COD-DVS
000961                   MOVE 'E'               TO
000961                                            WS-COD-DVS-FLG-DVS-IN
000961                   MOVE 'N'               TO
000961                                            WS-COD-DVS-FLG-LIT
000516                ELSE
000516                   MOVE COM-TIT-DIV-FLG-DVS-IN  TO
000516                                             WS-COD-DVS-FLG-DVS-IN
000516                   MOVE COM-TIT-DIV-FLG-LIT     TO
000516                                             WS-COD-DVS-FLG-LIT
000516
000516                   MOVE TIT-COD-DVS OF DCLTBTIT TO WS-COD-DVS
000516                END-IF
000516             END-IF
291099        END-IF

291099        PERFORM LETTURA-C-C-ORDINARIO
291099        THRU    LETTURA-C-C-ORDINARIO-EXIT.
      D       DISPLAY '** LETTURA C/C ORD -2- SW-BLOK' SW-USC-X-BLOCCO.
007521        IF SW-USC-X-BLOCCO = 'SI'
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
007521           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
007521           GO TO CONTO-CORRENTE-GESTORE-EXIT
007521        END-IF.
000717        IF LGS-FLG-CCC = 'N'
000717           MOVE CCC-COD-DVS     OF DCLTBCCC TO GES-CCC-COD-DVS
000717           MOVE CCC-TIP-CCC     OF DCLTBCCC TO GES-CCC-TIP-CCC
000717           MOVE CCC-COD-FIL     OF DCLTBCCC TO GES-CCC-COD-FIL
000717           MOVE CCC-NUM-CCC     OF DCLTBCCC TO GES-CCC-NUM-CCC
17302G           MOVE CCC-CAT         OF DCLTBCCC TO GES-CCC-CAT
000717        END-IF.
      *
291099 CONTO-CORRENTE-GESTORE-EXIT.
291099       EXIT.
      *****************************************************************
      *                  ROUTINE  STACCO-CEDOLA                       *
      *****************************************************************
       STACCO-CEDOLA.
      D    DISPLAY 'SONO A STACCO CEDOLA'
           MOVE ZERO TO FL-EXIT.
003263*5456MOVE SPACES TO WS-PERS-R-COD-OK.
005456*6280GMOVE SPACES TO WS-PERS-C10-COD-OK.

           MOVE S-ELA-COD-IST           TO CED-COD-IST    OF DCLTBCED.
      D    DISPLAY 'TAB-PSA-COD-TIT  '  TAB-PSA-COD-TIT (PGM-IND4)
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                        TO CED-COD-TIT     OF DCLTBCED.
           MOVE S-ELA-DAT-LAZ           TO CED-DAT-SCD     OF DCLTBCED.
           MOVE S-ELA-DAT-LAZ           TO CED-DAT-DEC     OF DCLTBCED.
           MOVE S-ELA-DAT-LAZ           TO CED-DAT-EFF-CED OF DCLTBCED.
014696     MOVE S-ELA-DAT-ULT-ELA       TO WS-DAT-ULT-ELAB.
      D    DISPLAY 'CED-DAT-SCD ' CED-DAT-SCD
      D    DISPLAY 'CED-DAT-DEC ' CED-DAT-DEC
      D    DISPLAY 'CED-DAT-EFF-CED ' CED-DAT-EFF-CED
014696D    DISPLAY 'WS-DAT-ULT-ELAB ' WS-DAT-ULT-ELAB

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE 'TBCEDOC4'            TO WSN-SKB-COPY .
           MOVE 'Y05-OPEN-CUR4-TBCED' TO WSN-SKB-LABEL .
           MOVE 'TBCED'               TO WSN-SKB-TABELLA.
           MOVE 'OPEN CUR4'           TO WSN-SKB-FUNZIONE.
014696*    INITIALIZE WS-IMPO-FONDO .
014696*    MOVE  CED-COD-IST          TO WS-COD-ISTX .
           MOVE  CED-COD-TIT          TO WS-COD-TITX.
           MOVE  CED-DAT-SCD          TO WS-DAT-SCDX.
           MOVE  CED-DAT-EFF-CED      TO WS-DAT-EFFX.
014693*    MOVE  CED-DAT-DEC          TO WS-DAT-DECX.
014696     MOVE  S-ELA-DAT-ULT-ELA    TO WS-DAT-DECX.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696     MOVE SPACES                TO WSN-SKB-CHIAVE-DATI.
           STRING WS-KEY-BANCA WS-KEY-TITOLO  WS-KEY-DAT-SCD
           WS-KEY-DAT-EFF  WS-KEY-DAT-DEC
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

           PERFORM Y05-OPEN-CUR4-TBCED
           THRU    Y05-OPEN-CUR4-TBCED-EXIT.

      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*    MOVE 'TBCEDFC4'              TO WSN-SKB-COPY .
014696*    MOVE 'Y06-FETCH-CUR4-TBCED' TO WSN-SKB-LABEL .
014696*    MOVE 'TBCED'                 TO WSN-SKB-TABELLA.
014696*    MOVE 'FETCH CUR4'            TO WSN-SKB-FUNZIONE.
014696*    INITIALIZE WS-IMPO-FONDO .
014696*    MOVE  CED-COD-IST          TO WS-COD-ISTX .
014696*    MOVE  CED-COD-TIT          TO WS-COD-TITX.
014696*    MOVE  CED-DAT-SCD          TO WS-DAT-SCDX.
014696*    MOVE  CED-DAT-EFF-CED      TO WS-DAT-EFFX.
014696*    MOVE  CED-DAT-DEC          TO WS-DAT-DECX.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*    STRING WS-KEY-BANCA WS-KEY-TITOLO  WS-KEY-DAT-SCD
014696*    WS-KEY-DAT-EFF  WS-KEY-DAT-DEC
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

3092  ****************************************************************
      * DA QUA IN POI SONO STATI SPOSTATI DEI PEZZI PER CONSENTIRE DI
      * LEGGERE TUTTE LE CEDOLE E EFFETTUATE LE RELATIVE OPERAZIONI
      * LA ROUTINE ORIGINARIA E' STATA ASTERISCATA CON SEGN.3092
      ****************************************************************
      D    DISPLAY 'PRIMA DI TBCED E CTL CEDOLE'

3092       PERFORM LEGGI-TBCED-E-CTL-CEDOLE
3092       THRU    LEGGI-TBCED-E-CTL-CEDOLE-EXIT
3092       UNTIL   FL-EXIT = 1.

      D    DISPLAY 'SONO USCITO DAL CICLO'

      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           MOVE ' TBCEDCL4 '            TO WSN-SKB-COPY.
           MOVE ' Y07-CLOSE-CUR4-TBCED' TO WSN-SKB-LABEL.
           MOVE ' TBCED'                TO WSN-SKB-TABELLA.
           MOVE ' CLOSE-CUR4'           TO WSN-SKB-FUNZIONE.
014696*    PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*    STRING WS-KEY-BANCA WS-KEY-TITOLO
014696*    WS-KEY-DAT-SCD WS-KEY-DAT-EFF
014696*    DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *
           PERFORM Y07-CLOSE-CUR4-TBCED
           THRU    Y07-CLOSE-CUR4-TBCED-EXIT.
      *
       STACCO-CEDOLA-EXIT.
           EXIT.
3092  ******************************************************************
      * LEGGI-TBCED-E-CTL-CEDOLE
      *
      * ROUTINE CREATA CON SEGN.3092 PER CONSENTIRE DI ESEGUIRE TUTTE
      * LE OPERAZIONI RELATIVE ALLO STACCO CEDOLE PER OGNI CEDOLA
      ******************************************************************
3092   LEGGI-TBCED-E-CTL-CEDOLE.
3092  D    DISPLAY 'LEGGI-TBCED-E-CTL-CEDOLE'.
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696     MOVE 'TBCEDFC4'              TO WSN-SKB-COPY .
014696     MOVE 'Y06-FETCH-CUR4-TBCED' TO WSN-SKB-LABEL .
014696     MOVE 'TBCED'                 TO WSN-SKB-TABELLA.
014696     MOVE 'FETCH CUR4'            TO WSN-SKB-FUNZIONE.
014696     MOVE  CED-DAT-SCD          TO WS-DAT-SCDX.
014696     MOVE  CED-DAT-EFF-CED      TO WS-DAT-EFFX.
014696     MOVE  CED-DAT-DEC          TO WS-DAT-DECX.
014696     MOVE SPACES                TO WSN-SKB-CHIAVE-DATI.
014696     STRING WS-KEY-BANCA WS-KEY-TITOLO  WS-KEY-DAT-SCD
014696     WS-KEY-DAT-EFF  WS-KEY-DAT-DEC
014696     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

3092       PERFORM Y06-FETCH-CUR4-TBCED
3092       THRU    Y06-FETCH-CUR4-TBCED-EXIT.

3092       IF ENGIRC-NORMAL
006390*-- SE E' PRESENTE L'ABIL. 91 ACCEDE ALLA TABELLA FATTORI POOL
006390*-- INFLACTION PER VEDERE SE ESISTE IL RECORD CORRISPONDENTE
006390*-- ALLA CEDOLA
006390*014696 IF WS-ABIL-PERS-91 = 'S'
006390*014696    PERFORM LETTURA-TBFPI THRU LETTURA-TBFPI-EXIT
006390*014696 END-IF
006390*014696 IF WS-TROVA-FPI = 'S'
006390*014696    MOVE 'S' TO WS-FLG-TBFPI
006390*014696 END-IF
06280G        MOVE 'S' TO WS-STACCO-CEDOLA
3092  *6280G  PERFORM CTL-DATA-STACCO THRU CTL-DATA-STACCO-EXIT
3092  *5456   IF WS-PERS-R-COD-OK = 'S' OR
005456*6280G  IF WS-PERS-C10-COD-OK = 'S' OR
3092  *6280G     CED-DAT-EFF-CED = '01.01.0001'
      D          DISPLAY 'VADO A OPERAZIONI STACCO-CEDOLA'
014696           IF WS-ABIL-PERS-91 = 'S'
15209G*
05258G*15209G       MOVE 'N'                    TO WS-TROVA-FPI
05258G*15209G       MOVE ZEROES                 TO WS-P-I-FACTOR
014696              PERFORM LETTURA-TBFPI THRU LETTURA-TBFPI-EXIT
05258G              IF FPI-TIP-VLD = ('C' OR 'E')
05258G*             LETTURA DEL COEFFICIENTE DI INFLAZIONE DEL GIORNO
05258G                 PERFORM LETTURA-TBQTZ
05258G                    THRU LETTURA-TBQTZ-EXIT
05258G              END-IF
014696           END-IF
014696           IF WS-TROVA-FPI = 'S'
014696              MOVE 'S' TO WS-FLG-TBFPI
014696           END-IF
3092             PERFORM OPERAZIONI-STACCO-CEDOLA
3092             THRU    OPERAZIONI-STACCO-CEDOLA-EXIT
003263*5456      MOVE SPACES TO WS-PERS-R-COD-OK
 05456*6280G     MOVE SPACES TO WS-PERS-C10-COD-OK
      D          DISPLAY 'TORNO DA OPERAZIONI STACCO-CEDOLA'
3092  *6280G  END-IF
3092       ELSE
3092          MOVE 1 TO FL-EXIT
3092       END-IF.
      *
3092   LEGGI-TBCED-E-CTL-CEDOLE-EXIT.
3092       EXIT.
3092  ****************************************************************
3092  * CONTROLLA SE DATA EFFETTIVO STACCO VALORIZZATA
3092  ****************************************************************
3092  *  SE ESISTE ALMENO UNA CEDOLA DA STACCARE DEVE CONTROLLARE
3092  *  ANCHE SE LA DATA DI EFFETTIVO STACCO E' VALORIZZATA PRIMA
3092  *  DI PROCEDERE CON LE ALTRE OPERAZIONI
3092  ****************************************************************
06280G*  NON SI VERIFICA PIU' LA DATA STACCO IN QUANTO SONO VARIATE
06280G*  LE CONDIZIONI DEL CURSORE SU TBCED PER CUI NON E'PIU'NECESSARIO
06280G****************************************************************
3092  *6280G CTL-DATA-STACCO.
06280G*      D     DISPLAY 'ESISTE LA CEDOLA'
06280G*      D     DISPLAY 'DECORRENZA ' CED-DAT-DEC OF DCLTBCED
06280G*      D     DISPLAY 'SCADENZA   ' CED-DAT-SCD OF DCLTBCED
06280G*      D     DISPLAY 'CED-DAT-EFF' CED-DAT-EFF-CED OF DCLTBCED
06280G*            MOVE 'S' TO WS-STACCO-CEDOLA.

3092  *6280GIF CED-DAT-EFF-CED NOT = '01.01.0001'
06280G*        DISPLAY 'DENTRO IF CED-DAT-EFF-CED' CED-DAT-EFF-CED
3092  *5456    MOVE CED-DAT-EFF-CED      TO WS-PERS-R-DAT-EVE
005456*14696   MOVE CED-DAT-EFF-CED      TO WS-PERS-C10-DAT-EVE
      *D        DISPLAY 'WS-PERS-C10-DAT-EVE' WS-PERS-C10-DAT-EVE
3092  *14696   PERFORM U-GFC10-CALL-TBELA
3092  *14696   THRU    U-GFC10-CALL-TBELA-EXIT
014696*       CALL GFC10 SOSTITUITA CON CONTROLLO DATE
014696*6280G   MOVE CED-DAT-EFF-CED (7:4) TO WS-COM3-DATA (1:4)
014696*6280G   MOVE CED-DAT-EFF-CED (4:2) TO WS-COM3-DATA (5:2)
014696*6280G   MOVE CED-DAT-EFF-CED (1:2) TO WS-COM3-DATA (7:2)
014696*6280G   MOVE S-ELA-DAT-LAZ (7:4)   TO WS-COM2-DATA (1:4)
014696*6280G   MOVE S-ELA-DAT-LAZ (4:2)   TO WS-COM2-DATA (5:2)
014696*6280G   MOVE S-ELA-DAT-LAZ (1:2)   TO WS-COM2-DATA (7:2)
014696*6280G   IF (WS-COM3-DATA > WS-DAT-ULT-ELAB-8 AND
014696*6280G       WS-COM3-DATA NOT > WS-COM2-DATA)
014696*6280G       MOVE 'S' TO WS-PERS-C10-COD-OK
014696*6280G   END-IF
014696*6280G   DISPLAY 'WS-PERS-C10-COD-OK  ' WS-PERS-C10-COD-OK
014696*6280G   DISPLAY 'CED-DAT-EFF-CED     ' WS-COM3-DATA
014696*6280G   DISPLAY 'S-ELA-DAT-LAZ       ' WS-COM2-DATA
014696*6280G   DISPLAY 'WS-DAT-ULT-ELAB-8   ' WS-DAT-ULT-ELAB-8
3092  *6280GEND-IF.
3092  *6280G CTL-DATA-STACCO-EXIT.
      *6280G     EXIT.
3092  *****************************************************************
3092  *  OPERAZIONI-STACCO-CEDOLA
3092  *****************************************************************
3092  * QUESTO BLOCCO DI OPERAZIONI ERA DENTRO ROUTINE STACCO-CEDOLA
3092  * E STATO SPOSTATO A CAUSA SEGNALAZIONE 3092 PER CONSENTIRE
3092  * DI ESTRARRE TUTTE LE CEDOLE E NON UNA SOLA COME ACCADEVA
3092  *****************************************************************
3092   OPERAZIONI-STACCO-CEDOLA.
      *
3092  D    DISPLAY 'OPERAZIONI-STACCO-CEDOLA'.
000704     MOVE 0 TO WS-ESENTE-0, WS-ESENTE-1
000704     PERFORM DETERMINA-ESENZIONE THRU DETERMINA-ESENZIONE-EXIT

008106     MOVE 'S'   TO  WS-TIPO-OPE.
008106     PERFORM CALL-GFUWMC35
008106        THRU CALL-GFUWMC35-EXIT

           MOVE CED-DAT-SCD           TO SMO-VLT OF DCLTBSMO
           PERFORM COMPRAVENDITA THRU COMPRAVENDITA-EXIT
      *
      D    DISPLAY 'VALORE NOMINALE ' VALORE-NOMINALE

           IF VALORE-NOMINALE > 0
050399*        PERFORM INTESTAZIONE-S3001
050399*        THRU    INTESTAZIONE-S3001-EXIT
050399       PERFORM U-ST20-GEST-DETTAGLIO-0
050399       THRU    U-ST20-GEST-DETTAGLIO-0-EXIT
             PERFORM MOVIMENTI-DI-COMP THRU MOVIMENTI-DI-COMP-EXIT
           END-IF

270599*     MOVE CED-DAT-SCD OF DCLTBCED TO COM-DATA
011326      MOVE CED-DAT-SCD OF DCLTBCED TO COM-DATA
006044*     MOVE S-ELA-DAT-LAZ TO COM-DATA
006026* 011326   MOVE S-ELA-DAT-LAZ TO COM-DATA

012019      PERFORM INCREMENTA-SCD-1G
012019         THRU INCREMENTA-SCD-1G-EXIT

011326      PERFORM CERCA-PRIMO-GIORNO-BORSA
011326         THRU CERCA-PRIMO-GIORNO-BORSA-EXIT

006044*-- DETERMINA LA DATA VALUTA COME DATA SCADENZA CEDOLA PIU'
006044*-- UN GIORNO
006044*6026 MOVE CED-DAT-SCD OF DCLTBCED TO COM-DATA
      D     DISPLAY 'COM-DATA ' COM-DATA
006044*6026 PERFORM INCREMENTA-SCD-1G
006044*6026    THRU INCREMENTA-SCD-1G-EXIT

      D     DISPLAY 'COM-DATA PIU UN GIORNO' COM-DATA
      D     DISPLAY 'CALCOLO VALUTA'

            PERFORM CALCOLO-VALUTA
            THRU  CALCOLO-VALUTA-EXIT

006026*16938DISPLAY 'CERCA-LINEA-GESTORE'
006026*16938
006026*16938PERFORM CERCA-LINEA-GESTORE
006026*16938THRU    CERCA-LINEA-GESTORE-EXIT
006026*16938IF  SW-USC-X-BLOCCO = 'SI'
006026*16938   GO TO OPERAZIONI-STACCO-CEDOLA-EXIT
006026*16938END-IF

      D     DISPLAY 'TRATTAMENTO-PRESTITI'

16332R*     PERFORM TRATTAMENTO-PRESTITI
16332R*     THRU   TRATTAMENTO-PRESTITI-EXIT
            IF  SW-USC-X-BLOCCO = 'SI'
002642*        GO TO STACCO-CEDOLA-EXIT
002642         GO TO OPERAZIONI-STACCO-CEDOLA-EXIT
            END-IF
      D     DISPLAY 'PRE IMPORTO CEDOLA  1'
      D     DISPLAY ' WS-DAT-DEC ' WS-DATA-DEC
25611G      MOVE CED-DAT-DEC (1:2)  TO WS-DATA-DEC(7:2)
25611G      MOVE CED-DAT-DEC (4:2)  TO WS-DATA-DEC(5:2)
25611G      MOVE CED-DAT-DEC (7:4)  TO WS-DATA-DEC(1:4)
25611G      MOVE S-ELA-DAT-LAZ (1:2) TO WS-DATA-LAZ(7:2)
25611G      MOVE S-ELA-DAT-LAZ (4:2) TO WS-DATA-LAZ(5:2)
25611G      MOVE S-ELA-DAT-LAZ (7:4) TO WS-DATA-LAZ(1:4)
      D     DISPLAY ' WS-DAT-DEC ' WS-DATA-DEC
      D     DISPLAY ' WS-DATA-LAZ ' WS-DATA-LAZ
25611G*     PERFORM CALCOLO-IMPORTO-CEDOLA
25611G*       THRU CALCOLO-IMPORTO-CEDOLA-EXIT
25611G*     IF WS-DATA-DEC > 20111026     OR
25611G*        WS-DATA-LAZ < 20111027
25611G      IF WS-DATA-DEC > 20111231     OR
25611G         WS-DATA-LAZ < 20120101
25611G         PERFORM CALCOLO-IMPORTO-CEDOLA
25611G            THRU CALCOLO-IMPORTO-CEDOLA-EXIT
25611G      ELSE
25611G         IF TIT-RIT-FON > 0
25611G            PERFORM CLC-IMPORTO-CEDOLA-NEW
25611G               THRU CLC-IMPORTO-CEDOLA-NEW-EXIT
25611G         ELSE
25611G            PERFORM  CALCOLO-IMPORTO-CEDOLA
25611G               THRU  CALCOLO-IMPORTO-CEDOLA-EXIT
25611G         END-IF
25611G      END-IF
              IF SW-USC-X-BLOCCO = 'SI'
002642*         GO TO  STACCO-CEDOLA-EXIT
002642          GO TO OPERAZIONI-STACCO-CEDOLA-EXIT
              END-IF
            IF VALORE-NOMINALE NOT = 0
006664D       DISPLAY 'RITENUTA FISCALE IN STACCO-CEDOLA'
25611G*       PERFORM RITENUTA-FISCALE
25611G*       THRU    RITENUTA-FISCALE-EXIT
25611G*       IF WS-DATA-DEC > 20111026     OR
25611G*          WS-DATA-LAZ < 20111027
25611G        IF WS-DATA-DEC > 20111231     OR
25611G           WS-DATA-LAZ < 20120101
25611G           PERFORM RITENUTA-FISCALE
25611G              THRU RITENUTA-FISCALE-EXIT
25611G        ELSE
25611G           PERFORM RITENUTA-FISCALE-NEW
25611G              THRU RITENUTA-FISCALE-NEW-EXIT
25611G        END-IF
              IF SW-USC-X-BLOCCO = 'SI'
002642*         GO TO  STACCO-CEDOLA-EXIT
002642          GO TO OPERAZIONI-STACCO-CEDOLA-EXIT
              END-IF
            END-IF

006664D     DISPLAY 'IMPORTO NOMINALE IN DIVISA FONDO ' WST-IMPONIB

000688      IF VALORE-NOMINALE > 0
               PERFORM STAMPA-RATEO-S3001
               THRU    STAMPA-RATEO-S3001-EXIT
000688      END-IF

      *3092 IF ( CED-DAT-EFF-CED = '01.01.0001')
3092  *5456 IF WS-PERS-R-COD-OK = 'S' OR
005456*6280GIF WS-PERS-C10-COD-OK = 'S' OR
3092  *6280G   CED-DAT-EFF-CED = '01.01.0001'
06280G      IF CED-DAT-EFF-CED = '01.01.0001'
3092           MOVE CED-DAT-SCD(7:4) TO COMSSAA
3092           MOVE CED-DAT-SCD(4:2) TO COMMM
3092           MOVE CED-DAT-SCD(1:2) TO COMGG
      D        DISPLAY ' VADO A CERCA-DATA-BORSA'
3092           PERFORM CERCA-DATA-BORSA
3092           THRU CERCA-DATA-BORSA-EXIT
      D        DISPLAY ' TORNO DA CERCA-DATA-BORSA'

3092  ***************************************************************
      *  MUOVI LA DATA DI BORSA E I CAMPI NELLA CHIAVE PRIMA DELLA
      *  UPDATE
      ***************************************************************
006044*6026    IF TIT-DAT-RIM = S-ELA-DAT-LAZ
006044*6026       MOVE S-ELA-DAT-LAZ TO CED-DAT-EFF-CED
006044*6026    ELSE
3092           MOVE WS-DAT-EFF-PIU1 TO CED-DAT-EFF-CED OF DCLTBCED
006044*6026    END-IF
3092           MOVE CED-COD-IST     TO CED-COD-IST     OF DCLTBCED
3092           MOVE CED-COD-TIT     TO CED-COD-TIT     OF DCLTBCED
3092           MOVE CED-DAT-DEC     TO CED-DAT-DEC     OF DCLTBCED

      D     DISPLAY 'CED-DAT-EFF-CED' CED-DAT-EFF-CED

      *3092    MOVE S-ELA-DAT-LAZ TO CED-DAT-EFF-CED OF DCLTBCED
      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
               MOVE ' TBCEDUP4 '  TO WSN-SKB-COPY
               MOVE ' Y02-UPD-TBCED ' TO WSN-SKB-LABEL
               MOVE ' TBCED' TO WSN-SKB-TABELLA
               MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
014696*        INITIALIZE WS-IMPO-FONDO
014696*        MOVE  CED-COD-IST         TO    WS-COD-ISTX
               MOVE  CED-COD-TIT         TO    WS-COD-TITX
               MOVE  CED-DAT-SCD         TO    WS-DAT-SCDX
               MOVE  CED-DAT-EFF-CED     TO    WS-DAT-EFFX
014696*        PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
               STRING WS-KEY-BANCA WS-KEY-TITOLO
               WS-KEY-DAT-SCD WS-KEY-DAT-EFF
               DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

      D        DISPLAY 'VADO A UPD TBCED'
      D        DISPLAY 'CED TAS  ' CED-TAS
      D        DISPLAY 'CED DAT SCD  ' CED-DAT-SCD
      D        DISPLAY 'CED DAT EFF CED ' CED-DAT-EFF-CED
      D        DISPLAY 'CED COD IST     ' CED-COD-IST
      D        DISPLAY 'CED COD TIT     ' CED-COD-TIT
      D        DISPLAY 'CED DAT DEC     ' CED-DAT-DEC

               PERFORM Y02-UPD-TBCED THRU Y02-UPD-TBCED-EXIT
      D        DISPLAY 'ENGIDB-RC'   ENGIDB-RC
           END-IF.
      *    END-IF.
      *
3092   OPERAZIONI-STACCO-CEDOLA-EXIT.
3092       EXIT.
      *****************************************************************
      * VECCHIA ROUTINE  STACCO-CEDOLA ASTERISCATA CON SEGNALAZIONE   *
      * 3092
      *****************************************************************
      *3092STACCO-CEDOLA.
      *
      *3092 MOVE S-ELA-COD-IST   TO CED-COD-IST    OF DCLTBCED.
      *3092 MOVE TAB-PSA-COD-TIT (PGM-IND4)
      *3092                      TO CED-COD-TIT     OF DCLTBCED.
      *3092 MOVE S-ELA-DAT-LAZ   TO CED-DAT-SCD     OF DCLTBCED.
      *3092 MOVE S-ELA-DAT-LAZ   TO CED-DAT-DEC     OF DCLTBCED.
      *3092 MOVE S-ELA-DAT-LAZ   TO CED-DAT-EFF-CED OF DCLTBCED.
      *3092
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
      *3092 MOVE 'TBCEDOC4'       TO WSN-SKB-COPY .
      *3092 MOVE 'Y05-OPEN-CUR4-TBCED' TO WSN-SKB-LABEL .
      *3092 MOVE 'TBCED'               TO WSN-SKB-TABELLA.
      *3092 MOVE 'OPEN CUR4'           TO WSN-SKB-FUNZIONE.
      *3092 INITIALIZE WS-IMPO-FONDO .
      *3092     MOVE  CED-COD-IST          TO WS-COD-ISTX .
      *3092     MOVE  CED-COD-TIT          TO WS-COD-TITX.
      *3092     MOVE  CED-DAT-SCD          TO WS-DAT-SCDX.
      *3092     MOVE  CED-DAT-EFF-CED      TO WS-DAT-EFFX.
      *3092     MOVE  CED-DAT-DEC          TO WS-DAT-DECX.
      *3092     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
      *3092     STRING WS-KEY-BANCA WS-KEY-TITOLO  WS-KEY-DAT-SCD
      *3092     WS-KEY-DAT-EFF  WS-KEY-DAT-DEC
      *3092     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *3092
      *3092     PERFORM Y05-OPEN-CUR4-TBCED
      *3092     THRU    Y05-OPEN-CUR4-TBCED-EXIT.
      *3092
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
      *3092     MOVE 'TBCEDFC4'              TO WSN-SKB-COPY .
      *3092     MOVE 'Y06-FETCH-CUR4-TBCED' TO WSN-SKB-LABEL .
      *3092     MOVE 'TBCED'                 TO WSN-SKB-TABELLA.
      *3092     MOVE 'FETCH CUR4'            TO WSN-SKB-FUNZIONE.
      *3092     INITIALIZE WS-IMPO-FONDO .
      *3092     MOVE  CED-COD-IST          TO WS-COD-ISTX .
      *3092     MOVE  CED-COD-TIT          TO WS-COD-TITX.
      *3092     MOVE  CED-DAT-SCD          TO WS-DAT-SCDX.
      *3092     MOVE  CED-DAT-EFF-CED      TO WS-DAT-EFFX.
      *3092     MOVE  CED-DAT-DEC          TO WS-DAT-DECX.
      *3092     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
      *3092     STRING WS-KEY-BANCA WS-KEY-TITOLO  WS-KEY-DAT-SCD
      *3092     WS-KEY-DAT-EFF  WS-KEY-DAT-DEC
      *3092     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *3092
      *3092     PERFORM Y06-FETCH-CUR4-TBCED
      *3092     THRU    Y06-FETCH-CUR4-TBCED-EXIT.
      *3092
      *3092     IF ENGIRC-NORMAL
      *3092
      *  SE ESTISE ALMENO UNA CEDOLA DA STACCARE
      *3092 D     DISPLAY 'ESISTE ALMENO UNA CEDOLA'
      *3092 D     DISPLAY 'DECORRENZA ' CED-DAT-DEC OF DCLTBCED
      *3092 D     DISPLAY 'SCADENZA   ' CED-DAT-SCD OF DCLTBCED
      *3092      MOVE 'S' TO WS-STACCO-CEDOLA
      *3092
000704*3092      MOVE 0 TO WS-ESENTE-0, WS-ESENTE-1
000704*3092  PERFORM DETERMINA-ESENZIONE THRU DETERMINA-ESENZIONE-EXIT
      *3092
      *3092 MOVE CED-DAT-SCD           TO SMO-VLT OF DCLTBSMO
      *3092 PERFORM COMPRAVENDITA THRU COMPRAVENDITA-EXIT
      *3092
      *3092 D     DISPLAY 'VALORE NOMINALE ' VALORE-NOMINALE
      *3092
      *3092 IF VALORE-NOMINALE > 0
      * GIA' ASTERISCATE DALLA SEGN.050399 *******************
050399*3092    PERFORM INTESTAZIONE-S3001 *
050399*3092    THRU    INTESTAZIONE-S3001-EXIT *
      ********************************************************
050399*3092    PERFORM U-ST20-GEST-DETTAGLIO-0
050399*3092    THRU    U-ST20-GEST-DETTAGLIO-0-EXIT
      *3092    PERFORM MOVIMENTI-DI-COMP THRU MOVIMENTI-DI-COMP-EXIT
      *3092 END-IF
      *3092
270599*     MOVE CED-DAT-SCD OF DCLTBCED TO COM-DATA
      *3092 MOVE S-ELA-DAT-LAZ TO COM-DATA
      *3092
      *3092 D     DISPLAY 'COM-DATA ' COM-DATA
      *3092 D     DISPLAY 'CALCOLO VALUTA'
      *3092
      *3092      PERFORM CALCOLO-VALUTA
      *3092      THRU  CALCOLO-VALUTA-EXIT
      *3092
      *3092 D     DISPLAY 'TRATTAMENTO-PRESTITI'
      *3092
      *3092      PERFORM TRATTAMENTO-PRESTITI
      *3092      THRU   TRATTAMENTO-PRESTITI-EXIT
      *3092      IF  SW-USC-X-BLOCCO = 'SI'
      *3092         GO TO STACCO-CEDOLA-EXIT
      *3092      END-IF
      *3092      PERFORM CALCOLO-IMPORTO-CEDOLA
      *3092      THRU CALCOLO-IMPORTO-CEDOLA-EXIT
      *3092        IF SW-USC-X-BLOCCO = 'SI'
      *3092          GO TO  STACCO-CEDOLA-EXIT
      *3092        END-IF
      *3092      IF VALORE-NOMINALE NOT = 0
      *3092        DISPLAY 'RITENUTA FISCALE IN STACCO-CEDOLA'
      *3092
      *3092        PERFORM RITENUTA-FISCALE
      *3092        THRU    RITENUTA-FISCALE-EXIT
      *3092        IF SW-USC-X-BLOCCO = 'SI'
      *3092          GO TO  STACCO-CEDOLA-EXIT
      *3092        END-IF
      *3092      END-IF
      *3092
      *3092    DISPLAY 'IMPORTO NOMINALE IN DIVISA FONDO ' WST-IMPONIB
      *3092
000688*3092      IF VALORE-NOMINALE > 0
      *3092         PERFORM STAMPA-RATEO-S3001
      *3092         THRU    STAMPA-RATEO-S3001-EXIT
000688*3092      END-IF
      *3092
      *3092      IF ( CED-DAT-EFF-CED = '01.01.0001')
      *3092         MOVE S-ELA-DAT-LAZ TO CED-DAT-EFF-CED OF DCLTBCED
      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
      *3092         MOVE ' TBCEDUP4 '  TO WSN-SKB-COPY
      *3092         MOVE ' Y02-UPD-TBCED ' TO WSN-SKB-LABEL
      *3092         MOVE ' TBCED' TO WSN-SKB-TABELLA
      *3092         MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
      *3092         INITIALIZE WS-IMPO-FONDO
      *3092         MOVE  CED-COD-IST         TO    WS-COD-ISTX
      *3092         MOVE  CED-COD-TIT         TO    WS-COD-TITX
      *3092         MOVE  CED-DAT-SCD         TO    WS-DAT-SCDX
      *3092         MOVE  CED-DAT-EFF-CED     TO    WS-DAT-EFFX
      *3092         PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
      *3092         STRING WS-KEY-BANCA WS-KEY-TITOLO
      *3092         WS-KEY-DAT-SCD WS-KEY-DAT-EFF
      *3092         DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
      *3092
      *3092         PERFORM Y02-UPD-TBCED THRU Y02-UPD-TBCED-EXIT
      *3092
      *3092      END-IF
      *3092     END-IF.
      *3092
      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
      *3092     MOVE ' TBCEDCL4 '            TO WSN-SKB-COPY.
      *3092     MOVE ' Y07-CLOSE-CUR4-TBCED' TO WSN-SKB-LABEL.
      *3092     MOVE ' TBCED'                TO WSN-SKB-TABELLA.
      *3092     MOVE ' CLOSE-CUR4'           TO WSN-SKB-FUNZIONE.
      *3092     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
      *3092     STRING WS-KEY-BANCA WS-KEY-TITOLO
      *3092     WS-KEY-DAT-SCD WS-KEY-DAT-EFF
      *3092     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
      *3092
      *3092     PERFORM Y07-CLOSE-CUR4-TBCED
      *3092     THRU    Y07-CLOSE-CUR4-TBCED-EXIT.
      *3092
      *3092     DISPLAY ' FINE STACCO CEDOLA'.
      *3092
      *3092 STACCO-CEDOLA-EXIT.
      *3092     EXIT.
      **********************************************************
      *            CALCOLO IMPORTO CEDOLA
      *********************************************************
       CALCOLO-IMPORTO-CEDOLA.
      *
016938D    DISPLAY 'VALORE-NOMINALE X CEDOLA' VALORE-NOMINALE
270599     MOVE ZEROES             TO VALORE-NOMINALE-GES
270599                                WS-IMPORTO-CEDOLA.
MODTP *14696 PERFORM
MODTP *14696 VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000
221298*14696  OR TAB-PSA-GES-COD-TIT(PGM-IND1) = SPACES
014696     PERFORM
014696     VARYING PGM-IND1 FROM PGM-IND4 BY 1
014696                                  UNTIL PGM-IND1 > PGM-GES-ELE
014696     OR TAB-PSA-GES-COD-TIT(PGM-IND1) > TAB-PSA-COD-TIT(PGM-IND4)
014696*
014696* LA TABELLA è ORDINATA X CODICE QUIND è INUTILE VERIFICARLA TUTTA
014696*
MODTP      IF TAB-PSA-GES-COD-TIT(PGM-IND1) = TAB-PSA-COD-TIT(PGM-IND4)
006664D       DISPLAY ' CALCOLO-IMPORTO-CEDOLA'
270599D       DISPLAY ' SCRITTURA CEDOLA '
270599D       DISPLAY ' TITOLO           ' TAB-PSA-GES-COD-TIT(PGM-IND1)
270599D       DISPLAY ' INDICE           ' PGM-IND1
016938D       DISPLAY ' GESTORE          ' TAB-PSA-GES-COD-GES(PGM-IND1)
MODTP         COMPUTE VALORE-NOMINALE-GES =
MODTP                               (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
MODTP                                TAB-PSA-GES-QTA-DEP(PGM-IND1))
016938D       DISPLAY 'TAB-PSA-GES-QTA-TOT '
016938D                TAB-PSA-GES-QTA-TOT(PGM-IND1)
016938D       DISPLAY 'TAB-PSA-GES-QTA-DEP '
016938D                TAB-PSA-GES-QTA-DEP(PGM-IND1)
016938D       DISPLAY 'VALORE-NOMINALE-GES ' VALORE-NOMINALE-GES
280999*-----  INCREMENTA LA SCADENZA CEDOLA DI 1 GIORNO
280999*
280999        MOVE CED-DAT-SCD OF DCLTBCED (1:2) TO GDATE-DIN1 (1:2)
280999        MOVE CED-DAT-SCD OF DCLTBCED (4:2) TO GDATE-DIN1 (3:2)
280999        MOVE CED-DAT-SCD OF DCLTBCED (7:4) TO GDATE-DIN1 (5:4)
280999        MOVE '1'                           TO GDATE-SIN1OTT
280999        MOVE '0'                           TO GDATE-SIN1ROV
280999        MOVE 'IN'                          TO GDATE-CFUN
280999        MOVE 1                             TO GDATE-NGIO-N
  "           PERFORM  U-X01-GEST-BOPGDATE
  "           THRU U-X01-GEST-BOPGDATE-EXIT
  "           IF GDATE-STC NOT = '0'
  "              MOVE 'B0037'           TO CG-BLOCFON-MOTIVO
  "              MOVE 'INCREM.SCAD'     TO CG-BLOCFON-NOTE
  "              MOVE 'RITENUTA FISCALE CEDOLA'
  "                                     TO CG-BLOCFON-FASE
  "              MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
  "              MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
  "              MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
  "              MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
  "              MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
  "              MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
  "              PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
  "              MOVE 'SI' TO SW-USC-X-BLOCCO
  "              GO TO CALCOLO-IMPORTO-CEDOLA-EXIT
  "           ELSE
  "              MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-FIN(1:2)
  "              MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-FIN(4:2)
  "              MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-FIN(7:4)
  "              MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-RIF(1:2)
  "              MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-RIF(4:2)
  "              MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-RIF(7:4)
280999        END-IF

011527* VENGONO ANNULLATE LE MODIFICHE DELLE SEGN. 8918 E 10173
011527*008918        MOVE TIT-DAT-RIM(1:2) TO WS-DAT-COM10X (1:2)
011527*008918        MOVE TIT-DAT-RIM(4:2) TO WS-DAT-COM10X (4:2)
011527*008918        MOVE TIT-DAT-RIM(7:4) TO WS-DAT-COM10X (7:4)
011527*010173        MOVE CG-CLGG-DAT-FIN  TO WS-DAT-COM20X
011527*010173    MOVE '.'  TO WS-DAT-COM20X (3:1) WS-DAT-COM10X (3:1)
011527*010173    MOVE '.'  TO WS-DAT-COM20X (6:1) WS-DAT-COM10X (6:1)
      D       DISPLAY 'CG-CLGG-DAT-FIN ' CG-CLGG-DAT-FIN
      D       DISPLAY 'WS-DAT-COM10X   ' WS-DAT-COM10X
      D       DISPLAY 'WS-DAT-COM20X   ' WS-DAT-COM20X
      D       DISPLAY 'VALORE PTF  '  TAB-PSA-GES-QTA-TOT(PGM-IND1)
011527*008918*10173  IF CG-CLGG-DAT-FIN = WS-DAT-COM10X AND
011527*010173        IF WS-DAT-COM20X   = WS-DAT-COM10X AND
011527*008918           TAB-PSA-GES-QTA-TOT(PGM-IND1) = ZERO
011527*008918           MOVE ZEROES TO VALORE-NOMINALE-GES
011527*008918        END-IF
280999        MOVE CED-DAT-DEC           TO CG-CLGG-DAT-INI
280999        MOVE TIT-FRQ-GOD-CED       TO CG-CLGG-FRQ-GOD-CED
280999        MOVE TIT-BAS-CLC           TO CG-CLGG-BAS-CLC
280999        MOVE VALORE-NOMINALE-GES   TO CG-CLGG-IMP-NOM
280999        MOVE TIT-RIT-FON           TO CG-CLGG-RIT-FON
280999        MOVE TIT-DAT-EMS           TO CG-CLGG-DAT-EMS
280999        MOVE CED-TAS               TO CG-CLGG-TAS
280999        PERFORM X01-CLGG
280999        THRU    X01-CLGG-EXIT
      D       DISPLAY '*********** CLGG **********'
      D       DISPLAY 'TIT ' CED-COD-TIT
      D       DISPLAY 'DEC ' CG-CLGG-DAT-INI
      D       DISPLAY 'SCD ' CG-CLGG-DAT-FIN
      D       DISPLAY 'ELA ' CG-CLGG-DAT-RIF
      D       DISPLAY 'NOM ' CG-CLGG-IMP-NOM
      D       DISPLAY 'TAS ' CG-CLGG-TAS
      D       DISPLAY 'BAS ' CG-CLGG-BAS-CLC
      D       DISPLAY 'GG1 ' CG-CLGG-GG-MAT
      D       DISPLAY 'GG2 ' CG-CLGG-GG-TOT
      D       DISPLAY 'RAT ' CG-CLGG-RAT
280999        IF CG-CLGG-STS = '0'
280999           MOVE CG-CLGG-RAT         TO WS-IMPORTO-CEDOLA
280999        ELSE
280999           MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
280999           MOVE SPACES               TO WSN-SKB-LABEL
280999           MOVE SPACES               TO WSN-SKB-TABELLA
280999           MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
014696           MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
280999*14696     INITIALIZE WS-IMPO-FONDO
280999           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
280999        END-IF
      D       DISPLAY 'WS-IMPORTO-CEDOLA  A  ' WS-IMPORTO-CEDOLA
280999*       COMPUTE WS-IMPORTO-CEDOLA = VALORE-NOMINALE-GES *
280999*                                (CED-TAS OF DCLTBCED / 100 )
006026*    LA LETTURA DELLA TBLGS VIENE SPOSTATA ALL'INTERNO DELLA
006026*    PERFORM 'CERCA-LINEA-GESTORE'
006026*
006026*       MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
006026*       MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
006026*       MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
006026*       MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
006026*70199  MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
006026*                                 LGS-COD-GES OF DCLTBLGS
006026*
006026* ----------------- SELECT SU  TBLGS ----------------------*
006026* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
006026*       MOVE 'TBLGSL1'       TO WSN-SKB-COPY
006026*       MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
006026*       MOVE 'TBLGS'         TO WSN-SKB-TABELLA
006026*       MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
006026*       INITIALIZE WS-IMPO-FONDO
006026*       MOVE LGS-COD-GES         TO WS-COD-GESN
006026*       MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
006026*       MOVE LGS-COD-FON         TO WS-COD-FONN
006026*       MOVE LGS-COD-LIN         TO WS-COD-LINN
006026*       PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
006026*       STRING WS-KEY-SOC-IST   WS-KEY-FONDO
006026*       WS-KEY-LINEA   WS-KEY-GESTORE
006026*       DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
006026*
006026*       PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT
006026*
006026*       IF ENGIRC-NOTF-ENDFILE
006026*             MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
006026*             MOVE 'SELECT'        TO CG-BLOCFON-NOTE
006026*             MOVE 'CALCOLO CEDOLA                  '
006026*                               TO CG-BLOCFON-FASE
006026*             MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
006026*             MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
006026*             MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
006026*             MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
006026*             MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
006026*             MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
006026*             PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
006026*             MOVE 'SI' TO SW-USC-X-BLOCCO
006026*             GO TO CALCOLO-IMPORTO-CEDOLA-EXIT
006026*       END-IF
006026*-----------------------------------------------------
291099*       IF LGS-FLG-CCC = 'S'
291099*            MOVE ZERO TO CCC-COD-GES OF DCLTBCCC
291099*       ELSE
291099*            MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
291099*                                      CCC-COD-GES OF DCLTBCCC
291099*       END-IF
291099*       PERFORM LETTURA-C-C-ORDINARIO
291099*       THRU    LETTURA-C-C-ORDINARIO-EXIT
291099*       IF SW-USC-X-BLOCCO = 'SI'
291099*          GO TO CALCOLO-IMPORTO-CEDOLA-EXIT

MODTP       END-IF
            IF  WS-IMPORTO-CEDOLA NOT = 0
016938          PERFORM CERCA-LINEA-GESTORE
016938          THRU    CERCA-LINEA-GESTORE-EXIT
FS              MOVE COM-LGS-FLG-CED-DVS TO COM-LGS-FLG-DVS
000717          MOVE 'G' TO COM-LIV-CCC

      D           DISPLAY ' PRE LETTURA C/C'
291099          PERFORM CONTO-CORRENTE-LINEA
291099          THRU    CONTO-CORRENTE-LINEA-EXIT
291099          MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
291099                                       CCC-COD-GES     OF DCLTBCCC
291099          MOVE COM-CCC-COD-DVS     TO  WS-COD-DVS

000717          MOVE LGS-FLG-CED-DVS     TO COM-LGS-FLG-DVS
291099          PERFORM CONTO-CORRENTE-GESTORE
291099          THRU    CONTO-CORRENTE-GESTORE-EXIT
000516          MOVE WS-COD-DVS       TO COM-CCC-COD-DVS

291099          IF SW-USC-X-BLOCCO = 'SI'
291099             GO TO CALCOLO-IMPORTO-CEDOLA-EXIT
291099          END-IF
      D         DISPLAY 'IMPORTO-CEDOL = ' WS-IMPORTO-CEDOLA
      D         DISPLAY 'SCRITTURA-CEDOLA IN STACCO-CEDOLA'
                PERFORM SCRITTURA-CEDOLA
                THRU    SCRITTURA-CEDOLA-EXIT
                IF SW-USC-X-BLOCCO = 'SI'
MODTP              GO TO CALCOLO-IMPORTO-CEDOLA-EXIT
                END-IF
            END-IF
MODTP       END-PERFORM.
016938D    DISPLAY 'VALORE-NOMINALE ' VALORE-NOMINALE.
      D    DISPLAY 'FINE CALCOLO IMPORTO CEDOLA  '.
      *
       CALCOLO-IMPORTO-CEDOLA-EXIT.
           EXIT.
      **********************************************************
      *            CALCOLO IMPORTO CEDOLA NEW
      *********************************************************
25611G CLC-IMPORTO-CEDOLA-NEW.
25611GD       DISPLAY 'CALCOLO-IMPORTO-CEDOLA-NEW'.
25611G*
25611G     MOVE ZEROES TO WS-RATEO-TOTALE WS-RATEO-PARZIALE.
25611G     MOVE ZEROES TO WS-RATEO-NEW.
25611GD    DISPLAY 'VALORE-NOMINALE X CEDOLA' VALORE-NOMINALE
25611G     MOVE ZEROES             TO VALORE-NOMINALE-GES
25611G                                WS-IMPORTO-CEDOLA.
25611G     PERFORM
25611G     VARYING PGM-IND1 FROM PGM-IND4 BY 1
25611G                                  UNTIL PGM-IND1 > PGM-GES-ELE
25611G     OR TAB-PSA-GES-COD-TIT(PGM-IND1) > TAB-PSA-COD-TIT(PGM-IND4)
25611G     IF TAB-PSA-GES-COD-TIT(PGM-IND1) = TAB-PSA-COD-TIT(PGM-IND4)
25611GD       DISPLAY ' CALCOLO-IMPORTO-CEDOLA'
25611GD       DISPLAY ' SCRITTURA CEDOLA '
25611GD       DISPLAY ' TITOLO           ' TAB-PSA-GES-COD-TIT(PGM-IND1)
25611GD       DISPLAY ' INDICE           ' PGM-IND1
25611GD       DISPLAY ' GESTORE          ' TAB-PSA-GES-COD-GES(PGM-IND1)
25611G        COMPUTE VALORE-NOMINALE-GES =
25611G                              (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
25611G                               TAB-PSA-GES-QTA-DEP(PGM-IND1))
25611GD       DISPLAY 'TAB-PSA-GES-QTA-TOT '
25611GD                TAB-PSA-GES-QTA-TOT(PGM-IND1)
25611GD       DISPLAY 'TAB-PSA-GES-QTA-DEP '
25611GD                TAB-PSA-GES-QTA-DEP(PGM-IND1)
25611GD       DISPLAY 'VALORE-NOMINALE-GES ' VALORE-NOMINALE-GES
25611G*-----  INCREMENTA LA SCADENZA CEDOLA DI 1 GIORNO
25611G*
25611G        MOVE CED-DAT-SCD OF DCLTBCED (1:2) TO GDATE-DIN1 (1:2)
25611G        MOVE CED-DAT-SCD OF DCLTBCED (4:2) TO GDATE-DIN1 (3:2)
25611G        MOVE CED-DAT-SCD OF DCLTBCED (7:4) TO GDATE-DIN1 (5:4)
25611G        MOVE '1'                           TO GDATE-SIN1OTT
25611G        MOVE '0'                           TO GDATE-SIN1ROV
25611G        MOVE 'IN'                          TO GDATE-CFUN
25611G        MOVE 1                             TO GDATE-NGIO-N
25611G        PERFORM  U-X01-GEST-BOPGDATE
25611G        THRU U-X01-GEST-BOPGDATE-EXIT
25611G        IF GDATE-STC NOT = '0'
25611G           MOVE 'B0037'           TO CG-BLOCFON-MOTIVO
25611G           MOVE 'INCREM.SCAD'     TO CG-BLOCFON-NOTE
25611G           MOVE 'RITENUTA FISCALE CEDOLA'
25611G                                  TO CG-BLOCFON-FASE
25611G           MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
25611G           MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
25611G           MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
25611G           MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
25611G           MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
25611G           MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
25611G           MOVE 'GFUWM300' TO WSN-SKB-PGM
25611G           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
25611G           MOVE 'SI' TO SW-USC-X-BLOCCO
25611G           GO TO CLC-IMPORTO-CEDOLA-NEW-EXIT
25611G        ELSE
25611G           MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-FIN(1:2)
25611G           MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-FIN(4:2)
25611G           MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-FIN(7:4)
25611G           MOVE GDATE-DEFF(1:2)   TO CG-CLGG-DAT-RIF(1:2)
25611G           MOVE GDATE-DEFF(3:2)   TO CG-CLGG-DAT-RIF(4:2)
25611G           MOVE GDATE-DEFF(5:4)   TO CG-CLGG-DAT-RIF(7:4)
25611G        END-IF
25611G
25611GD       DISPLAY 'CG-CLGG-DAT-FIN ' CG-CLGG-DAT-FIN
25611GD       DISPLAY 'WS-DAT-COM10X   ' WS-DAT-COM10X
25611GD       DISPLAY 'WS-DAT-COM20X   ' WS-DAT-COM20X
25611GD       DISPLAY 'VALORE PTF  '  TAB-PSA-GES-QTA-TOT(PGM-IND1)
25611GD       DISPLAY 'CALCOLA RATEO TOTALE '
25611G        MOVE CED-DAT-DEC           TO CG-CLGG-DAT-INI
25611G        MOVE TIT-FRQ-GOD-CED       TO CG-CLGG-FRQ-GOD-CED
25611G        MOVE TIT-BAS-CLC           TO CG-CLGG-BAS-CLC
25611G        MOVE VALORE-NOMINALE-GES   TO CG-CLGG-IMP-NOM
25611G        MOVE ZEROES                TO CG-CLGG-RIT-FON
25611G        MOVE TIT-DAT-EMS           TO CG-CLGG-DAT-EMS
25611G        MOVE CED-TAS               TO CG-CLGG-TAS
25611G        PERFORM X01-CLGG
25611G        THRU    X01-CLGG-EXIT
25611GD       DISPLAY '*********** CLGG **********'
25611GD       DISPLAY 'TIT ' CED-COD-TIT
25611GD       DISPLAY 'DEC ' CG-CLGG-DAT-INI
25611GD       DISPLAY 'SCD ' CG-CLGG-DAT-FIN
25611GD       DISPLAY 'ELA ' CG-CLGG-DAT-RIF
25611GD       DISPLAY 'NOM ' CG-CLGG-IMP-NOM
25611GD       DISPLAY 'TAS ' CG-CLGG-TAS
25611GD       DISPLAY 'BAS ' CG-CLGG-BAS-CLC
25611GD       DISPLAY 'GG1 ' CG-CLGG-GG-MAT
25611GD       DISPLAY 'GG2 ' CG-CLGG-GG-TOT
25611GD       DISPLAY 'RAT ' CG-CLGG-RAT
25611G        IF CG-CLGG-STS = '0'
25611G           MOVE CG-CLGG-RAT         TO WS-RATEO-TOTALE
25611G        ELSE
25611G           MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
25611G           MOVE SPACES               TO WSN-SKB-LABEL
25611G           MOVE SPACES               TO WSN-SKB-TABELLA
25611G           MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
25611G           MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
25611G           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
25611G        END-IF
25611GD       DISPLAY 'WS-IMPORTO-CEDOLA  X  ' WS-RATEO-TOTALE
25611GD       DISPLAY 'CALCOLA RATEO PARZIALE '
25611G        MOVE CED-DAT-DEC           TO CG-CLGG-DAT-INI
25611G        MOVE TIT-FRQ-GOD-CED       TO CG-CLGG-FRQ-GOD-CED
25611G        MOVE TIT-BAS-CLC           TO CG-CLGG-BAS-CLC
25611G        MOVE VALORE-NOMINALE-GES   TO CG-CLGG-IMP-NOM
25611G        MOVE ZEROES                TO CG-CLGG-RIT-FON
25611G        MOVE TIT-DAT-EMS           TO CG-CLGG-DAT-EMS
25611G        MOVE CED-TAS               TO CG-CLGG-TAS
25611G        MOVE '31.12.2011'          TO CG-CLGG-DAT-RIF
25611G*       MOVE '26.10.2011'          TO CG-CLGG-DAT-RIF
25611G        PERFORM X01-CLGG
25611G        THRU    X01-CLGG-EXIT
25611GD       DISPLAY '*********** CLGG **********'
25611GD       DISPLAY 'TIT ' CED-COD-TIT
25611GD       DISPLAY 'DEC ' CG-CLGG-DAT-INI
25611GD       DISPLAY 'SCD ' CG-CLGG-DAT-FIN
25611GD       DISPLAY 'ELA ' CG-CLGG-DAT-RIF
25611GD       DISPLAY 'NOM ' CG-CLGG-IMP-NOM
25611GD       DISPLAY 'TAS ' CG-CLGG-TAS
25611GD       DISPLAY 'BAS ' CG-CLGG-BAS-CLC
25611GD       DISPLAY 'GG1 ' CG-CLGG-GG-MAT
25611GD       DISPLAY 'GG2 ' CG-CLGG-GG-TOT
25611GD       DISPLAY 'RAT ' CG-CLGG-RAT
25611G        IF CG-CLGG-STS = '0'
25611G           MOVE CG-CLGG-RAT         TO WS-RATEO-PARZIALE
25611G        ELSE
25611G           MOVE 'GFUSCLGG'           TO WSN-SKB-COPY
25611G           MOVE SPACES               TO WSN-SKB-LABEL
25611G           MOVE SPACES               TO WSN-SKB-TABELLA
25611G           MOVE 'CLC RATEO'          TO WSN-SKB-FUNZIONE
25611G           MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
25611G           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
25611G        END-IF
25611GD       DISPLAY 'WS-IMPORTO-CEDOLA PARZ' WS-RATEO-PARZIALE
25611G      END-IF
25611G* CALCOLO RATEO DI PERTINENZA 2012
25611G      COMPUTE WS-RATEO-NEW = WS-RATEO-TOTALE - WS-RATEO-PARZIALE
25611GD     DISPLAY ' RATEO PERIODO NEW  ' WS-RATEO-NEW
25611G*TASSAZIONE RATEO NEW
25611GD     DISPLAY ' ALIQUOTA PERIODO NUOVO TIT-RIT-FON ' TIT-RIT-FON
25611G      COMPUTE WS-RATEO-NEW = WS-RATEO-NEW - ( WS-RATEO-NEW *
25611G                                       TIT-RIT-FON / 100 )
25611GD     DISPLAY ' WS-RATEO-NEW    ' WS-RATEO-NEW
25611G
25611GD     DISPLAY ' ALIQUOTA PERIODO OLD -FIS-PRE 'TIT-RIT-FIS-PRE
25611G*TASSAZIONE RATEO PARZIALE
25611G      COMPUTE WS-RATEO-PARZIALE = WS-RATEO-PARZIALE -
25611G             (WS-RATEO-PARZIALE * TIT-RIT-FIS-PRE / 100 )
25611GD     DISPLAY ' WS-RATEO-PARZIALE ' WS-RATEO-PARZIALE
25611G      COMPUTE WS-IMPORTO-CEDOLA = WS-RATEO-NEW + WS-RATEO-PARZIALE
25611GD     DISPLAY ' RATEO COMPLESSIVO SOMMA ' WS-IMPORTO-CEDOLA
25611G      IF  WS-IMPORTO-CEDOLA NOT = 0
25611G          PERFORM CERCA-LINEA-GESTORE
25611G          THRU    CERCA-LINEA-GESTORE-EXIT
25611G          MOVE COM-LGS-FLG-CED-DVS TO COM-LGS-FLG-DVS
25611G          MOVE 'G' TO COM-LIV-CCC
25611G
25611GD           DISPLAY ' PRE LETTURA C/C'
25611G          PERFORM CONTO-CORRENTE-LINEA
25611G          THRU    CONTO-CORRENTE-LINEA-EXIT
25611G          MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
25611G                                       CCC-COD-GES     OF DCLTBCCC
25611G          MOVE COM-CCC-COD-DVS     TO  WS-COD-DVS
25611G
25611G          MOVE LGS-FLG-CED-DVS     TO COM-LGS-FLG-DVS
25611G          PERFORM CONTO-CORRENTE-GESTORE
25611G          THRU    CONTO-CORRENTE-GESTORE-EXIT
25611G          MOVE WS-COD-DVS       TO COM-CCC-COD-DVS
25611G
25611G          IF SW-USC-X-BLOCCO = 'SI'
25611G             GO TO CLC-IMPORTO-CEDOLA-NEW-EXIT
25611G          END-IF
25611GD         DISPLAY 'IMPORTO-CEDOL = ' WS-IMPORTO-CEDOLA
25611GD         DISPLAY 'SCRITTURA-CEDOLA IN STACCO-CEDOLA'
25611G          PERFORM SCRITTURA-CEDOLA
25611G          THRU    SCRITTURA-CEDOLA-EXIT
25611G          IF SW-USC-X-BLOCCO = 'SI'
25611G             GO TO CLC-IMPORTO-CEDOLA-NEW-EXIT
25611G          END-IF
25611G      END-IF
25611G      END-PERFORM.
25611GD    DISPLAY 'VALORE-NOMINALE ' VALORE-NOMINALE.
25611GD    DISPLAY 'FINE CALCOLO IMPORTO CEDOLA  '.
25611G*
25611G CLC-IMPORTO-CEDOLA-NEW-EXIT.
25611G     EXIT.
      **********************************************************
      *               DISTRIBUZIONE-DIVIDENDI.
      *********************************************************
       DISTRIBUZIONE-DIVIDENDI.
06280GD    DISPLAY 'DISTRIBUZIONE DIVIDENDI'
003263*5456 MOVE SPACES TO WS-PERS-R-COD-OK.
005456*6280GMOVE SPACES TO WS-PERS-C10-COD-OK.

           MOVE TIT-DAT-DVD   (7:4) TO WS-COM2-DATA (1:4).
           MOVE TIT-DAT-DVD   (4:2) TO WS-COM2-DATA (5:2).
           MOVE TIT-DAT-DVD   (1:2) TO WS-COM2-DATA (7:2).
           MOVE S-ELA-DAT-LAZ (7:4) TO WS-COM1-DATA (1:4).
           MOVE S-ELA-DAT-LAZ (4:2) TO WS-COM1-DATA (5:2).
           MOVE S-ELA-DAT-LAZ (1:2) TO WS-COM1-DATA (7:2).

014696     MOVE TIT-DAT-EFF-DVD (7:4) TO WS-COM3-DATA (1:4).
014696     MOVE TIT-DAT-EFF-DVD (4:2) TO WS-COM3-DATA (5:2).
014696     MOVE TIT-DAT-EFF-DVD (1:2) TO WS-COM3-DATA (7:2).
014696
014696D    DISPLAY 'WS-PERS-C10-COD-OK  ' WS-PERS-C10-COD-OK
014696D    DISPLAY 'TIT-DAT-EFF-DVD     ' WS-COM3-DATA
014696D    DISPLAY 'S-ELA-DAT-LAZ       ' WS-COM1-DATA
014696D    DISPLAY 'WS-DAT-ULT-ELAB-8   ' WS-DAT-ULT-ELAB-8
014696
      D    DISPLAY 'TIT-DAT-DVD =  '  TIT-DAT-DVD.
06280G*    IF (WS-COM2-DATA NOT > WS-COM1-DATA ) AND
06280G*              (TIT-DVD OF DCLTBTIT > 0 )
      *3092 IF (TIT-DAT-EFF-DVD OF DCLTBTIT = '01.01.0001 ') OR
      *3092   (TIT-DAT-EFF-DVD OF DCLTBTIT = S-ELA-DAT-LAZ)
3092  *6280GIF (TIT-DAT-EFF-DVD OF DCLTBTIT NOT = '01.01.0001 ')

06280G*       DISPLAY 'SONO VERIFICATE LE CONDIZIONI'
3092  *5456    MOVE TIT-DAT-EFF-DVD  TO WS-PERS-R-DAT-EVE
005456*14696   MOVE TIT-DAT-EFF-DVD  TO WS-PERS-C10-DAT-EVE
      *14696  DISPLAY 'WS-PERS-C10-DAT-EVE' WS-PERS-C10-DAT-EVE
3092  *14696  PERFORM U-GFC10-CALL-TBELA
3092  *14696  THRU    U-GFC10-CALL-TBELA-EXIT
014696*       CALL GFC10 SOSTITUITA CON CONTROLLO DATE
014696*6280G  IF (WS-COM3-DATA > WS-DAT-ULT-ELAB-8 AND
014696*6280G       WS-COM3-DATA NOT > WS-COM1-DATA)
014696*6280G     MOVE 'S' TO WS-PERS-C10-COD-OK
014696*6280G  END-IF
014696*6280G   DISPLAY 'WS-PERS-C10-COD-OK  ' WS-PERS-C10-COD-OK
014696*6280G   DISPLAY 'TIT-DAT-EFF-DVD     ' WS-COM3-DATA
014696*6280G   DISPLAY 'S-ELA-DAT-LAZ       ' WS-COM1-DATA
014696*6280G   DISPLAY 'WS-DAT-ULT-ELAB-8   ' WS-DAT-ULT-ELAB-8
      *6280GEND-IF

06280G* SE DATA STACCO DIVIDENDO <= DATA LAVORAZIONE
06280G*  E DATA STACCO DIVIDENDO > ULTIMA DATA LAVORATA
06280G*  E DIVIDENDO VALORIZZATO
06280G     IF  WS-COM2-DATA <= WS-COM1-DATA
06280G     AND WS-COM2-DATA > WS-DAT-ULT-ELAB-8
06280G     AND TIT-DVD OF DCLTBTIT > 0
3092  *5456 IF WS-PERS-R-COD-OK = 'S' OR
005456*6280GIF WS-PERS-C10-COD-OK = 'S' OR
3092  *6280G   TIT-DAT-EFF-DVD = '01.01.0001'
018880*        MOVE TIT-DAT-DVD           TO SMO-VLT OF DCLTBSMO
018880*        PERFORM COMPRAVENDITA THRU COMPRAVENDITA-EXIT
018880         PERFORM COMPRAVENDITA-DVD
018880            THRU COMPRAVENDITA-DVD-EXIT
271099*        MOVE TIT-DAT-DVD OF DCLTBTIT TO COM-DATA
271099         MOVE TIT-DAT-PAG-DVD OF DCLTBTIT TO COM-DATA

      D        DISPLAY 'CALCOLO-VALUTA'

               PERFORM CALCOLO-VALUTA
               THRU    CALCOLO-VALUTA-EXIT

      *        PERFORM TRATTAMENTO-PRESTITI
      *        THRU    TRATTAMENTO-PRESTITI-EXIT
      *        IF SW-USC-X-BLOCCO = 'SI'
      *           GO TO DISTRIBUZIONE-DIVIDENDI-EXIT
      *        END-IF

      D        DISPLAY 'CALCOLO-IMPORTO-DIVIDENDO'
               PERFORM CALCOLO-IMPORTO-DIVIDENDO
               THRU    CALCOLO-IMPORTO-DIVIDENDO-EXIT
               IF SW-USC-X-BLOCCO = 'SI'
                  GO TO DISTRIBUZIONE-DIVIDENDI-EXIT
               END-IF

               IF (TIT-DAT-EFF-DVD = '01.01.0001' )
006664D            DISPLAY 'TIT-EFF-DVD = ' TIT-DAT-EFF-DVD
005717*            LEGGO LA RIGA SU TBTIT
005717             PERFORM LEGGI-TBTIT
005717             THRU    LEGGI-TBTIT-EXIT
                   MOVE S-ELA-DAT-LAZ TO TIT-DAT-EFF-DVD OF DCLTBTIT

      * * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
                   MOVE ' TBTITUP1 '  TO WSN-SKB-COPY
                   MOVE ' Y02-UPD-TBTIT ' TO WSN-SKB-LABEL
                   MOVE ' TBTIT' TO WSN-SKB-TABELLA
                   MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
014696*            INITIALIZE WS-IMPO-FONDO
014696*            MOVE  TIT-COD-IST         TO    WS-COD-ISTX
014696*            MOVE  TIT-COD-TIT         TO    WS-COD-TITX
014696*            PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*            STRING WS-KEY-BANCA WS-KEY-TITOLO
014696*            DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
                   PERFORM Y02-UPD-TBTIT THRU Y02-UPD-TBTIT-EXIT
005717* SE DATA DECORRENZA LETTA SU TBTIT E' < DI DATA ELABORAZIONE
005717* DEVO AGGIORNARE LA DATA EFFETTIVO RIMBORSO ANCHE SU TBSVM
006664*005717             DISPLAY 'WS-DAT-LAZ-8 ' WS-DAT-LAZ-8
006664*005717             DISPLAY 'WS-DAT-DEC   ' WS-DAT-DEC
005717             IF WS-DAT-LAZ-8 < WS-DAT-DEC
006664*005717                  DISPLAY 'AGGIORNO SVM '
005717              PERFORM LEGGI-TBSVM
005717              THRU    LEGGI-TBSVM-EXIT
005717              IF ENGIRC-NORMAL
005717                MOVE S-ELA-DAT-LAZ TO SVM-DAT-EFF-DVD
005717                PERFORM AGGIORNA-TBSVM
005717                THRU    AGGIORNA-TBSVM-EXIT
005717              END-IF
005717              PERFORM CLOSE-TBSVM
005717              THRU    CLOSE-TBSVM-EXIT
005717             END-IF
               END-IF
06280G*     END-IF
           END-IF.
006664D    DISPLAY ' DISTRIBUZIONE-DIVIDENDI-FINE'.
      *
       DISTRIBUZIONE-DIVIDENDI-EXIT.
           EXIT.
      **********************************************************
      *            CALCOLO IMPORTO DIVIDENDO
      *********************************************************
       CALCOLO-IMPORTO-DIVIDENDO.
      D    DISPLAY 'CALCOLO-IMPORTO-DIVIDENDO'.
      *
270599     MOVE ZEROES                TO VALORE-NOMINALE-GES
270599                                   WS-IMPORTO-DIVIDENDO.
      D    DISPLAY '*****PGM-IND4 ' PGM-IND4
MODTP *14696 PERFORM
MODTP *14696 VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000
221298*14696 OR TAB-PSA-GES-COD-TIT(PGM-IND1) = SPACES
014696     PERFORM
014696     VARYING PGM-IND1 FROM PGM-IND4 BY 1
014696                                  UNTIL PGM-IND1 > PGM-GES-ELE
014696     OR TAB-PSA-GES-COD-TIT(PGM-IND1) >
014696        TAB-PSA-COD-TIT(PGM-IND4)
014696*
014696* LA TABELLA è IN ORDINE INUTILE ANALIZZARLA TUTTA
014696*
      D    DISPLAY '** COD-TIT 2 ' TAB-PSA-COD-TIT(PGM-IND4)
MODTP      IF TAB-PSA-GES-COD-TIT(PGM-IND1) = TAB-PSA-COD-TIT(PGM-IND4)
      D       DISPLAY '** DENTRO '
000663*018880  MOVE TAB-PSA-GES-QTA-TOT(PGM-IND1) TO VALORE-NOMINALE-GES
MODTP * 000663COMPUTE VALORE-NOMINALE-GES =
MODTP * 000663                      (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
MODTP * 000663                       TAB-PSA-GES-QTA-DEP(PGM-IND1))
018880        COMPUTE VALORE-NOMINALE-GES =
018880                      (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
018880                       TAB-PSA-GES-QTA-DEP(PGM-IND1))
000666        IF FND-TIP-FON = 'C'
002040*10122     IF FND-FLG-FND-IMM = 'S'
002040*10122        COMPUTE WS-IMPORTO-DIVIDENDO =
002040*10122                       (TIT-DVD OF DCLTBTIT) *
002040*10122                        VALORE-NOMINALE-GES *  (100 -
002040*10122                        TIT-RIT-FIS-PRE OF DCLTBTIT ) / 100
002040*10122     ELSE
000666              COMPUTE WS-IMPORTO-DIVIDENDO =
000666                             (TIT-DVD OF DCLTBTIT) *
000666                              VALORE-NOMINALE-GES *  (100 -
000666                              TIT-RIT-FIS-POS OF DCLTBTIT ) / 100
002040*10122    END-IF
000666        ELSE
              COMPUTE WS-IMPORTO-DIVIDENDO = (TIT-DVD OF DCLTBTIT) *
                  VALORE-NOMINALE-GES *  (100 -
                          TIT-TAS-RIT-FIS OF DCLTBTIT ) / 100
000666        END-IF
      *
24417G        IF WS-IMPORTO-DIVIDENDO NOT = ZERO
MODTP          MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
MODTP               CCC-COD-GES OF DCLTBCCC
MODTP          MOVE COM-CCC-COD-DVS   TO  WS-COD-DVS

               MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
               MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
               MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
               MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
070199         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
                                        LGS-COD-GES OF DCLTBLGS
      * ----------------- SELECT SU  TBLGS ----------------------*
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
               MOVE 'TBLGSL1'       TO WSN-SKB-COPY
               MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
               MOVE 'TBLGS'         TO WSN-SKB-TABELLA
               MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
014696*        INITIALIZE WS-IMPO-FONDO
               MOVE LGS-COD-GES         TO WS-COD-GESN
014696*        MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
014696*        MOVE LGS-COD-FON         TO WS-COD-FONN
014696*        MOVE LGS-COD-LIN         TO WS-COD-LINN
014696*        PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
014696*        STRING WS-KEY-SOC-IST   WS-KEY-FONDO
014696         STRING WS-KEY-BANCA
014696                WS-KEY-SOC-IST   WS-KEY-FONDO
                      WS-KEY-LINEA     WS-KEY-GESTORE
               DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

               PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT

               IF ENGIRC-NOTF-ENDFILE
                 MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
                 MOVE 'SELECT'        TO CG-BLOCFON-NOTE
                 MOVE 'CALCOLO-IMPORTO-DIVIDENDO'
                                      TO CG-BLOCFON-FASE
                 MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
                 MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
                 MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
                 MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
                 MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
                 MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
                 PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
                 MOVE 'SI' TO SW-USC-X-BLOCCO
                 GO TO CALCOLO-IMPORTO-DIVIDENDO-EXIT
               END-IF
24417G        END-IF
171299*    END-IF
      *
              IF  WS-IMPORTO-DIVIDENDO NOT = 0
      D           DISPLAY '** INS-MLQ'
FS                MOVE COM-LGS-FLG-DIS-DVD TO COM-LGS-FLG-DVS
000717            MOVE 'G' TO COM-LIV-CCC

291099            PERFORM CONTO-CORRENTE-LINEA
291099            THRU    CONTO-CORRENTE-LINEA-EXIT
291099            IF SW-USC-X-BLOCCO = 'SI'
002642*              GO TO DISTRIBUZIONE-DIVIDENDI-EXIT
002642               GO TO CALCOLO-IMPORTO-DIVIDENDO-EXIT
291099            END-IF
MODTP             MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
MODTP                                   CCC-COD-GES OF DCLTBCCC
MODTP             MOVE COM-CCC-COD-DVS     TO  WS-COD-DVS

000717            MOVE LGS-FLG-DIS-DVD     TO  COM-LGS-FLG-DVS
291099            PERFORM CONTO-CORRENTE-GESTORE
291099            THRU    CONTO-CORRENTE-GESTORE-EXIT
000516            MOVE WS-COD-DVS       TO COM-CCC-COD-DVS

291099            IF SW-USC-X-BLOCCO = 'SI'
002642*              GO TO DISTRIBUZIONE-DIVIDENDI-EXIT
002642               GO TO CALCOLO-IMPORTO-DIVIDENDO-EXIT
291099            END-IF
      D           DISPLAY 'SCRITTURA DIVIDENDI'
                  PERFORM SCRITTURA-DIVIDENDI
                  THRU    SCRITTURA-DIVIDENDI-EXIT
                  IF SW-USC-X-BLOCCO = 'SI'
002642*              GO TO DISTRIBUZIONE-DIVIDENDI-EXIT
002642               GO TO CALCOLO-IMPORTO-DIVIDENDO-EXIT
                  END-IF
              END-IF
171299     END-IF
MODTP      END-PERFORM.
      *
       CALCOLO-IMPORTO-DIVIDENDO-EXIT.
           EXIT.
      *************************************************************
      *    ROUTINE SCRITTURA DIVIDENDI IN LIQUIDITA'             *
      ************************************************************
       SCRITTURA-DIVIDENDI.
      D    DISPLAY 'SCRITTURA-DIVIDENDI'.
291099*    IF COM-LGS-FLG-DIS-DVD = 'F'
            MOVE S-ELA-COD-IST           TO DIV-COD-IST OF DCLTBDIV
            MOVE   COM-TIT-DIV-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-PNZ

291099*     MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*     MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
291099      MOVE  WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
291099      MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
            MOVE S-ELA-COD-IST        TO CG-CONEUR-COD-IST
            MOVE S-ELA-COD-SOC-IST    TO CG-CONEUR-COD-SOC-IST
            MOVE S-ELA-COD-FON        TO CG-CONEUR-COD-FON
            MOVE S-ELA-DAT-LAZ        TO CG-CONEUR-DAT-RIL-CAM
            MOVE WS-IMPORTO-DIVIDENDO TO CG-CONEUR-IMP-INP
            MOVE TIT-COD-DVS          TO CG-CONEUR-COD-DVS-PNZ
291099      MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*     MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
            MOVE 0                    TO CG-CONEUR-TAS-UNO
            MOVE 0                    TO CG-CONEUR-TAS-DUE
      D          DISPLAY 'TITOLO ' TIT-COD-TIT
      D          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
            PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT
      *
            IF CG-CONEUR-CODERR NOT = SPACE
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
               PERFORM X01-BLOCCO-IMEU
               THRU    X01-BLOCCO-IMEU-EXIT
               GO TO SCRITTURA-DIVIDENDI-EXIT
            END-IF

            MOVE CG-CONEUR-IMP-OUT TO WS-IMPORTO-DIVIDENDO.

291099*    END-IF.

           IF WS-NAZ-TITOLO = 'E'
             MOVE 'DVE' TO WS-COD-CAU
           ELSE
             MOVE 'DVI' TO WS-COD-CAU
           END-IF.

MODTP       MOVE CCC-COD-GES                   TO CG-LETCAU-COD-GES.
            PERFORM LETTURA-CAUSALE
            THRU    LETTURA-CAUSALE-EXIT.
            IF SW-USC-X-BLOCCO = 'SI'
             GO TO SCRITTURA-DIVIDENDI-EXIT
            END-IF.
002966*     MOVE VALORE-NOMINALE TO WS-VAL-NMN.
002966      MOVE VALORE-NOMINALE-GES  TO WS-VAL-NMN.
000308*     MOVE WS-IMPORTO-DIVIDENDO TO WS-IMP.
000308      COMPUTE WS-IMP ROUNDED = WS-IMPORTO-DIVIDENDO.
006664D     DISPLAY 'IMPORTO DVD ' WS-IMP.

MODTP       MOVE CCC-COD-GES             TO S-MLQ0-COD-GES
MODTP *14696                                S-MLQ1-COD-GES.
000717     IF LGS-FLG-CCC = 'S'
MODTP?        MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC
MODTP?        MOVE COM-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE COM-CCC-CAT         TO WS-CAT-CCC
MODTP?        MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC
MODTP?        MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
000717     ELSE
000717        MOVE GES-CCC-NUM-CCC     TO WS-NUM-CCC
000717        MOVE GES-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE GES-CCC-CAT         TO WS-CAT-CCC
000717        MOVE GES-CCC-TIP-CCC     TO WS-TIP-CCC
000717        MOVE GES-CCC-COD-DVS     TO WS-COD-DVS
000717     END-IF.

070199      IF LGS-FLG-CCC = 'S'
070199        MOVE ZERO TO S-MLQ0-COD-GES
070199*14696               S-MLQ1-COD-GES
070199      END-IF.
014696*     PERFORM VAL-LIQUIDITA-SMLQ0
014696*     THRU    VAL-LIQUIDITA-SMLQ0-EXIT.
014696*     PERFORM VAL-LIQUIDITA-SMLQ1
014696*     THRU    VAL-LIQUIDITA-SMLQ1-EXIT.

            IF CAU-FLG-LIQ = 'S'
250599*       ADD 1 TO WS-PRG-MOV
270599D        DISPLAY 'SCRITTURA LIQ DIVID '
014696         PERFORM VAL-LIQUIDITA-SMLQ0
014696            THRU VAL-LIQUIDITA-SMLQ0-EXIT
               WRITE REC-SMLQ0
018605         INITIALIZE              REC-SMLQ0
014696*     ELSE
014696*       PERFORM VAL-LIQUIDITA-SMLQ1
014696*          THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*       WRITE REC-SMLQ1
            END-IF.
      *
       SCRITTURA-DIVIDENDI-EXIT.
           EXIT.
      *******************************************************************
      *  ROUTINE SCRITTURA IN LIQUIDITA' DIVIDENDI SU PRESTITO TIT.   *
      *****************************************************************
       SCRITTURA-PRESTITO-TIT.
      *
           IF WS-NAZ-TITOLO = 'I'
             MOVE 'PDI' TO WS-COD-CAU
           ELSE
             MOVE  'PDE' TO  WS-COD-CAU
           END-IF.

           MOVE WS-COD-CAU TO CAU-COD-CAU OF DCLTBCAU.
           MOVE WS-TOT-NMN-PRESTITO TO WS-VAL-NMN.
           MOVE WS-TOT-CED-PRESTITO TO WS-IMP.

MODTP      MOVE ZEROES                  TO S-MLQ0-COD-GES.
MODTP *14696 MOVE ZEROES                  TO S-MLQ1-COD-GES.
MODTP?     MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC.
MODTP?     MOVE COM-CCC-COD-FIL     TO WS-COD-FIL.
17302G     MOVE COM-CCC-CAT         TO WS-CAT-CCC.
MODTP?     MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC.
MODTP?     MOVE COM-CCC-COD-DVS     TO WS-COD-DVS.

014696*    PERFORM VAL-LIQUIDITA-SMLQ0
014696*    THRU    VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1
014696*    THRU   VAL-LIQUIDITA-SMLQ1-EXIT.

MODTP      MOVE ZEROES                        TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
            GO TO SCRITTURA-PRESTITO-TIT-EXIT
           END-IF.

           IF CAU-FLG-LIQ OF DCLTBCAU = 'S'
250599*      ADD 1 TO WS-PRG-MOV
270599D       DISPLAY 'SCRITTURA LIQ PRES TIT '
014696        PERFORM VAL-LIQUIDITA-SMLQ0
014696           THRU VAL-LIQUIDITA-SMLQ0-EXIT
              WRITE REC-SMLQ0
018605        INITIALIZE              REC-SMLQ0
014696*    ELSE
014696*      PERFORM VAL-LIQUIDITA-SMLQ1
014696*         THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*      WRITE REC-SMLQ1
           END-IF.
      *
       SCRITTURA-PRESTITO-TIT-EXIT.
           EXIT.
      *************************************************
      *        ROUTINE RIMBORSO  TOTALE               *
      *************************************************
       RIMBORSO-TOTALE.
      *
      D    DISPLAY 'DENTRO RIMBORSO TOTALE'
      D    DISPLAY 'TIT-FLG-TIP-RIM  ' TIT-FLG-TIP-RIM
      D    DISPLAY 'TIT-COD--TIT '  TIT-COD-TIT
003263*5456MOVE SPACES TO WS-PERS-R-COD-OK.
005456*6280GMOVE SPACES TO WS-PERS-C10-COD-OK.
      * ------A ROTTURA  ACCESSO A C/C-----
           IF TIT-FLG-TIP-RIM = 'T'
      D       DISPLAY ' DENTRO IF - DATA EFF. RIMB ' TIT-DAT-EFF-RIM
014696        MOVE S-ELA-DAT-LAZ (7:4)   TO WS-COM2-DATA (1:4)
014696        MOVE S-ELA-DAT-LAZ (4:2)   TO WS-COM2-DATA (5:2)
014696        MOVE S-ELA-DAT-LAZ (1:2)   TO WS-COM2-DATA (7:2)
014696D       DISPLAY 'DATA LAVORAZ.'    WS-COM2-DATA
3092  *6280G  IF TIT-DAT-EFF-RIM NOT = '01.01.0001'
014696*6280G     MOVE TIT-DAT-EFF-RIM (7:4) TO WS-COM3-DATA (1:4)
014696*6280G     MOVE TIT-DAT-EFF-RIM (4:2) TO WS-COM3-DATA (5:2)
014696*6280G     MOVE TIT-DAT-EFF-RIM (1:2) TO WS-COM3-DATA (7:2)
      *6280G     DISPLAY 'DENTRO IF RIMBORSO-TOTALE' TIT-DAT-RIM
3092  *5456      MOVE TIT-DAT-EFF-RIM     TO WS-PERS-R-DAT-EVE
005456*14696     MOVE TIT-DAT-EFF-RIM     TO WS-PERS-C10-DAT-EVE
014696*D          DISPLAY 'WS-PERS-C10-DAT-EVE' WS-PERS-C10-DAT-EVE
3092  *14696     PERFORM U-GFC10-CALL-TBELA
3092  *14696     THRU    U-GFC10-CALL-TBELA-EXIT
014696*       CALL GFC10 SOSTITUITA CON CONTROLLO DATE
014696*6280G  IF (WS-COM3-DATA > WS-DAT-ULT-ELAB-8 AND
014696*6280G       WS-COM3-DATA NOT > WS-COM2-DATA)
014696*6280G     MOVE 'S' TO WS-PERS-C10-COD-OK
014696*6280G  END-IF
014696*6280G   DISPLAY 'WS-PERS-C10-COD-OK  ' WS-PERS-C10-COD-OK
014696*6280G   DISPLAY 'TIT-DAT-EFF-RIM     ' WS-COM3-DATA
014696*6280G   DISPLAY 'S-ELA-DAT-LAZ       ' WS-COM2-DATA
014696*6280G   DISPLAY 'WS-DAT-ULT-ELAB-8   ' WS-DAT-ULT-ELAB-8
014696*6280G   DISPLAY 'TIT-COD-TIT        = ' TIT-COD-TIT
3092  *6280G  END-IF
3092
            MOVE TIT-DAT-RIM (7:4)     TO WS-COM1-DATA (1:4)
            MOVE TIT-DAT-RIM (4:2)     TO WS-COM1-DATA (5:2)
            MOVE TIT-DAT-RIM (1:2)     TO WS-COM1-DATA (7:2)

      D     DISPLAY 'DATA RIMBORSO'    WS-COM1-DATA

014696*     MOVE S-ELA-DAT-LAZ (7:4)   TO WS-COM2-DATA (1:4)
014696*     MOVE S-ELA-DAT-LAZ (4:2)   TO WS-COM2-DATA (5:2)
014696*     MOVE S-ELA-DAT-LAZ (1:2)   TO WS-COM2-DATA (7:2)

014696*D     DISPLAY 'DATA LAVORAZ.'    WS-COM2-DATA
      ***********************************************************
      * IF SOSTITUITA DALLA SEGN.3092                           *
      * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
FS0610*3092 IF (WS-COM1-DATA NOT = 0                   AND
FS0610*3092     WS-COM1-DATA NOT > WS-COM2-DATA)
FS0610*3092 IF  TIT-DAT-RIM NOT = '01.01.0001'         AND
FS0610*3092    (TIT-DAT-EFF-RIM = '01.01.0001'   OR
FS0610*3092     TIT-DAT-EFF-RIM = S-ELA-DAT-LAZ)      AND
FS0610*3092     WS-COM1-DATA NOT > WS-COM2-DATA
      ***********************************************************
007180D     DISPLAY 'TIT-DAT-EFF-RIM '  TIT-DAT-EFF-RIM
007180      IF TIT-DAT-EFF-RIM NOT = '01.01.0001'
007180*7240    MOVE TIT-DAT-RIM(7:4) TO COMSSAA
007180*7240    MOVE TIT-DAT-RIM(4:2) TO COMMM
007180*7240    MOVE TIT-DAT-RIM(1:2) TO COMGG
007240         MOVE S-ELA-DAT-LAZ(7:4) TO COMSSAA
007240         MOVE S-ELA-DAT-LAZ(4:2) TO COMMM
007240         MOVE S-ELA-DAT-LAZ(1:2) TO COMGG
007180         PERFORM CERCA-DATA-BORSA
007180         THRU    CERCA-DATA-BORSA-EXIT
007180      ELSE
007180         MOVE '01.01.0001' TO WS-DAT-EFF-PIU1
007180      END-IF
3092  *5456 IF WS-PERS-R-COD-OK = 'S' OR
005456*6280GIF WS-PERS-C10-COD-OK = 'S' OR
3092  *7180   (TIT-DAT-RIM  NOT = '01.01.0001' AND
3092  *7180    WS-COM1-DATA NOT > WS-COM2-DATA)
3092  *3321    WS-COM1-DATA NOT > WS-COM2-DATA AND
3092  *3321     TIT-DAT-EFF-RIM = '01.01.0001')
007180*6280G  ( (TIT-DAT-RIM  NOT = '01.01.0001' AND
007180*6280G     WS-COM1-DATA NOT > WS-COM2-DATA)   AND
007180*6280G    (TIT-DAT-EFF-RIM = '01.01.0001' OR
007180*6280G     TIT-DAT-EFF-RIM = WS-DAT-EFF-PIU1) )
06280G* SE DATA RIMBORSO <= DATA LAVORAZIONE E
06280G* SE DATA RIMBORSO > ULTIMA DATA ELABORATA EFFETTUO IL RIMBORSO
06280GD      DISPLAY 'DATA-RIMBORSO ' WS-COM1-DATA
06280GD      DISPLAY 'DATA LAVORAZIONE ' WS-COM2-DATA
06280GD      DISPLAY 'ULTIMA ELABORATA ' WS-DAT-ULT-ELAB-8
06280G       IF WS-COM1-DATA <= WS-COM2-DATA
06280G       AND WS-COM1-DATA >  WS-DAT-ULT-ELAB-8
                MOVE TAB-PSA-QTA-TOT (PGM-IND4) TO VALORE-NOMINALE
                MOVE TIT-DAT-RIM OF DCLTBTIT TO COM-DATA

      D         DISPLAY 'CALCOLO-VALUTA'
014696D         DISPLAY 'TITOLO RIMBORSATO =  ' TIT-COD-TIT
                PERFORM CALCOLO-VALUTA
                THRU    CALCOLO-VALUTA-EXIT
002483          PERFORM VERIFICA-LAVORATIVO
002483          THRU    VERIFICA-LAVORATIVO-EXIT
                PERFORM CALCOLO-RIMBORSO-TOTALE
                THRU    CALCOLO-RIMBORSO-TOTALE-EXIT
081199          IF SW-USC-X-BLOCCO = 'SI'
081199              GO TO RIMBORSO-TOTALE-EXIT
081199          END-IF
002040*         IF FND-TIP-FON OF DCLTBFND = 'C'
002040*10122    IF (FND-TIP-FON = 'C' AND FND-FLG-FND-IMM NOT = 'S')
010122          IF  FND-TIP-FON = 'C'
001053             OR (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 > 20001231)
201099* FS         MOVE VALORE-RIMBORSO TO COM-QTA-TOTALE
FS                 MOVE VALORE-NOMINALE TO COM-QTA-TOTALE
201099                                     COMODO-QTA-TOTALE
07433G             MOVE ZEROES TO PGM-AGGI-DISAG
                   PERFORM U-GF12-STAMPA-TOTALI-FC
                      THRU U-GF12-STAMPA-TOTALI-FC-EXIT
FS                 IF PGM-AGGI-DISAG NOT = ZEROES
FS                    PERFORM INSERIMENTO-SCARTO-IN-LIQ
FS                    THRU    INSERIMENTO-SCARTO-IN-LIQ-EXIT
FS                    IF SW-USC-X-BLOCCO = 'SI'
FS                       GO TO RIMBORSO-TOTALE-EXIT
FS                    END-IF
FS                 END-IF
FS0510             IF COM-QTA-TOTALE > 0
FS0510                PERFORM STAMPA-ESENZIONE-1
FS0510                THRU STAMPA-ESENZIONE-1-EXIT
FS0510             END-IF
                END-IF
            END-IF
           END-IF.
      *
       RIMBORSO-TOTALE-EXIT.
           EXIT.
      ******************************************************************
002483* VERIFICA CHE LA DATA VALUTA SIA UNA GIORNATA LAVORATIVA        *
002483******************************************************************
002483 VERIFICA-LAVORATIVO.
002483*
006664*002483     DISPLAY 'PRIMA DI VERF. WS-DATA-VLT = ' WS-DATA-VLT.
002483     MOVE WS-DATA-VLT(1:2)    TO GDATE-DIN1 (1:2).
002483     MOVE WS-DATA-VLT(4:2)    TO GDATE-DIN1 (3:2).
002483     MOVE WS-DATA-VLT(7:4)    TO GDATE-DIN1 (5:4).
002483     MOVE '1'                 TO GDATE-SIN1OTT.
002483     MOVE '0'                 TO GDATE-SIN1ROV.
002483     MOVE 'CO'                TO GDATE-CFUN.
002483     PERFORM U-X01-GEST-BOPGDATE
002483     THRU    U-X01-GEST-BOPGDATE-EXIT.
002483     IF GDATE-SGIOEFF NOT = 'L'
006664*002483     DISPLAY 'DOPO     VERF. WS-DATA-VLT = ' WS-DATA-VLT
002483        MOVE WS-DATA-VLT(1:2) TO GDATE-DIN1 (1:2)
002483        MOVE WS-DATA-VLT(4:2) TO GDATE-DIN1 (3:2)
002483        MOVE WS-DATA-VLT(7:4) TO GDATE-DIN1 (5:4)
002483        MOVE '1'              TO GDATE-NGIO-N
002483        MOVE '1'              TO GDATE-SIN1OTT
002483        MOVE '0'              TO GDATE-SIN1ROV
003092        MOVE '1'              TO GDATE-SIN2OTT
003092        MOVE '0'              TO GDATE-SIN2ROV
002483        MOVE 'IN'             TO GDATE-CFUN
002483        PERFORM U-X01-GEST-BOPGDATE
002483        THRU    U-X01-GEST-BOPGDATE-EXIT
002483*2483   MOVE GDATE-DLAV       TO  WS-DATA-VLT
      *
002483        MOVE GDATE-DLAV  (1:2)    TO WS-DATA-VLT (1:2)
002483        MOVE '.'                  TO WS-DATA-VLT (3:1)
002483        MOVE GDATE-DLAV  (3:2)    TO WS-DATA-VLT (4:2)
002483        MOVE '.'                  TO WS-DATA-VLT (6:1)
002483        MOVE GDATE-DLAV  (5:4)    TO WS-DATA-VLT (7:4)
006664*002483     DISPLAY 'DOPO + 1     WS-DATA-VLT = ' WS-DATA-VLT
002483     END-IF.
      *
       VERIFICA-LAVORATIVO-EXIT.
           EXIT.
      **************************************************************
      *         ROUTINE CALCOLO RIMBORSO TOTALE                    *
      ***************************************************************
       CALCOLO-RIMBORSO-TOTALE.
      *
      D    DISPLAY 'CALCOLO-RIMBORSO-TOTALE'.
      D    DISPLAY 'TIT-COD-TIT'  TIT-COD-TIT
270599     MOVE ZEROES           TO VALORE-NOMINALE-GES
270599                              VALORE-RIMBORSO-GES.
MODTP *014696  PERFORM
MODTP *014696  VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000
221298*014696       OR TAB-PSA-GES-COD-TIT (PGM-IND1) = SPACES
014696     PERFORM
014696     VARYING PGM-IND1 FROM PGM-IND4 BY 1
014696                                  UNTIL PGM-IND1 > PGM-GES-ELE
014696          OR TAB-PSA-GES-COD-TIT (PGM-IND1) >
014696                            TAB-PSA-COD-TIT(PGM-IND4)
014696*
MODTP      IF TAB-PSA-GES-COD-TIT(PGM-IND1) = TAB-PSA-COD-TIT(PGM-IND4)
MODTP        COMPUTE VALORE-NOMINALE-GES =
MODTP                              TAB-PSA-GES-QTA-TOT(PGM-IND1)
MODTP        COMPUTE VALORE-RIMBORSO-GES =
MODTP                VALORE-NOMINALE-GES *
MODTP                TIT-PRZ-RIM OF DCLTBTIT / 100
     *
24417G       IF VALORE-RIMBORSO-GES NOT = ZERO
              MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
              MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
              MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
              MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
070199        MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
                                        LGS-COD-GES OF DCLTBLGS

      * ----------------- SELECT SU  TBLGS ----------------------*
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
              MOVE 'TBLGSL1'       TO WSN-SKB-COPY
              MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
              MOVE 'TBLGS'         TO WSN-SKB-TABELLA
              MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
014696*       INITIALIZE WS-IMPO-FONDO
              MOVE LGS-COD-GES         TO WS-COD-GESN
014696*       MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
014696*       MOVE LGS-COD-FON         TO WS-COD-FONN
014696*       MOVE LGS-COD-LIN         TO WS-COD-LINN
014696*       PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696        MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
014696*       STRING WS-KEY-SOC-IST   WS-KEY-FONDO
014696        STRING WS-KEY-BANCA
014696               WS-KEY-SOC-IST   WS-KEY-FONDO
                     WS-KEY-LINEA     WS-KEY-GESTORE
              DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

              PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT

              IF ENGIRC-NOTF-ENDFILE
                    MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
                    MOVE 'SELECT'        TO CG-BLOCFON-NOTE
                    MOVE 'CALCOLO RIMBORSO TOTALE         '
                                      TO CG-BLOCFON-FASE
                    MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
                    MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
                    MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
                    MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
                    MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
                    MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146              MOVE 'GFUWM300' TO WSN-SKB-PGM
                    PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
                    MOVE 'SI' TO SW-USC-X-BLOCCO
                    GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
              END-IF
24417G       END-IF
291099*        IF COM-LGS-FLG-RIM-DVS = 'F'
081199*          MOVE COM-TIT-DIV-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-PNZ
291099*          MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*          MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
081199*          MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
081199*          MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
081199*          MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199*          MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199*          MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199*          MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199*          MOVE VALORE-RIMBORSO-GES TO CG-CONEUR-IMP-INP
081199*          MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
081199*          MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*          MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
081199*          MOVE 0                   TO CG-CONEUR-TAS-UNO
081199*          MOVE 0                   TO CG-CONEUR-TAS-DUE
081199*          PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT
081199*          IF CG-CONEUR-CODERR NOT = SPACE
081199*                PERFORM X01-BLOCCO-IMEU
081199*                THRU    X01-BLOCCO-IMEU-EXIT
081199*                GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
081199*          END-IF
081199*
081199*      MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO-GES
291099*     END-IF
      *
MODTP       IF VALORE-RIMBORSO-GES NOT = 0
FS             MOVE COM-LGS-FLG-RIM-DVS TO COM-LGS-FLG-DVS
000717         MOVE 'G' TO COM-LIV-CCC

291099         PERFORM CONTO-CORRENTE-LINEA
291099         THRU    CONTO-CORRENTE-LINEA-EXIT
291099         IF SW-USC-X-BLOCCO = 'SI'
291099             GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
291099         END-IF
      *
000961         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
000961                                       CCC-COD-GES     OF DCLTBCCC
000961         MOVE COM-CCC-COD-DVS     TO WS-COD-DVS

000961         MOVE LGS-FLG-RIM-DVS     TO COM-LGS-FLG-DVS
000961         PERFORM CONTO-CORRENTE-GESTORE
000961         THRU    CONTO-CORRENTE-GESTORE-EXIT
000961         MOVE WS-COD-DVS       TO COM-CCC-COD-DVS

000961         IF SW-USC-X-BLOCCO = 'SI'
000961            GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
000961         END-IF
      *
      *
081199         MOVE COM-TIT-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-PNZ
081199         MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
081199         MOVE WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
081199         MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199         MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199         MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199         MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199         MOVE VALORE-RIMBORSO-GES TO CG-CONEUR-IMP-INP
081199         MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
081199         MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
081199         MOVE 0                   TO CG-CONEUR-TAS-UNO
081199         MOVE 0                   TO CG-CONEUR-TAS-DUE
081199         PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

081199         IF CG-CONEUR-CODERR NOT = SPACE
014146            MOVE 'GFUWM300' TO WSN-SKB-PGM
081199            PERFORM X01-BLOCCO-IMEU
081199            THRU    X01-BLOCCO-IMEU-EXIT
081199            GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
081199         END-IF
081199         MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO-GES
      *
000961*        MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
000961*                                      CCC-COD-GES     OF DCLTBCCC
000961*        MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
000961*        MOVE LGS-FLG-RIM-DVS     TO COM-LGS-FLG-DVS
000961*        PERFORM CONTO-CORRENTE-GESTORE
000961*        THRU    CONTO-CORRENTE-GESTORE-EXIT
000961*        MOVE WS-COD-DVS       TO COM-CCC-COD-DVS
000961*        IF SW-USC-X-BLOCCO = 'SI'
000961*           GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
000961*        END-IF
      *
008106*        RICHIAMO IL MODULO PER IL CALCOLO DEL PESO
008106         MOVE 'T'   TO  WS-TIPO-OPE
008106         PERFORM CALL-GFUWMC35
008106            THRU CALL-GFUWMC35-EXIT

MODTP          PERFORM SCRITTURA-RIMBORSO-TOTALE
MODTP          THRU   SCRITTURA-RIMBORSO-TOTALE-EXIT
MODTP          IF SW-USC-X-BLOCCO = 'SI'
MODTP              GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
MODTP          END-IF
270599         MOVE ZEROES           TO VALORE-NOMINALE-GES
270599                                  VALORE-RIMBORSO-GES
MODTP       END-IF
MODTP      END-IF
MODTP      END-PERFORM.
      *
           IF TIT-PRZ-RIM  OF DCLTBTIT NOT = ZERO
             COMPUTE VALORE-RIMBORSO = VALORE-NOMINALE *
                  TIT-PRZ-RIM OF DCLTBTIT / 100
MODMI * IL PREZZO RIMBORSO PER LE OBBLIGAZIONI E' OBBLIGATORIO PER
MODMI * CUI L'ELSE NON VERRA' MAI EFFETTUATO
MODMI *    ELSE
MODMI *      COMPUTE VALORE-RIMBORSO = VALORE-NOMINALE *
MODMI *           TIT-QTA-VAL-NMN OF DCLTBTIT  / 100
           END-IF.
MODMI
291099*    IF COM-LGS-FLG-RIM-DVS  = 'F'
081199*      MOVE COM-TIT-DIV-FLG-DVS-IN    TO CG-CONEUR-FLG-DVS-PNZ
MODMI
291099*      MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*      MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
081199*      MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
081199*      MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
081199*
081199*      MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199*      MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199*      MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199*      MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199*      MOVE VALORE-RIMBORSO     TO CG-CONEUR-IMP-INP
081199*      MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
081199*      MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*      MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
081199*      MOVE 0                   TO CG-CONEUR-TAS-UNO
081199*      MOVE 0                   TO CG-CONEUR-TAS-DUE
081199*          DISPLAY 'TITOLO ' TIT-COD-TIT
081199*          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
081199*      PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT
081199*      IF CG-CONEUR-CODERR NOT = SPACE
081199*        PERFORM X01-BLOCCO-IMEU
081199*        THRU    X01-BLOCCO-IMEU-EXIT
081199*        GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
081199*      END-IF
081199*
081199*      MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO.
MODMI *      MOVE CG-CONEUR-TAS-EUR-DVS TO WS-CAMBIO
MODMI
291099*    END-IF.
MODMI D    DISPLAY 'VALORE-RIMBORSO ' VALORE-RIMBORSO
MODMI      IF VALORE-RIMBORSO NOT = 0
      D       DISPLAY 'SCRITTURA RIMBORSO TOTALE LINEA'
FS            MOVE COM-LGS-FLG-RIM-DVS TO COM-LGS-FLG-DVS
007521        IF LGS-FLG-CCC = 'S'
000717           MOVE 'L' TO COM-LIV-CCC
291099           PERFORM CONTO-CORRENTE-LINEA
291099           THRU    CONTO-CORRENTE-LINEA-EXIT
007521        END-IF
******************
MODMI         MOVE COM-TIT-DIV-FLG-DVS-IN    TO CG-CONEUR-FLG-DVS-PNZ
MODMI
291099*       MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*       MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
291099        MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
291099        MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
MODMI
MODMI         MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
MODMI         MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
MODMI         MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
MODMI         MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
MODMI         MOVE VALORE-RIMBORSO     TO CG-CONEUR-IMP-INP
MODMI         MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
291099        MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*       MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
MODMI         MOVE 0                   TO CG-CONEUR-TAS-UNO
MODMI         MOVE 0                   TO CG-CONEUR-TAS-DUE
      D       DISPLAY 'TITOLO ' TIT-COD-TIT
      D       DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
MODMI         PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

MODMI         IF CG-CONEUR-CODERR NOT = SPACE
014146            MOVE 'GFUWM300' TO WSN-SKB-PGM
MODMI            PERFORM X01-BLOCCO-IMEU
MODMI            THRU    X01-BLOCCO-IMEU-EXIT
MODMI            GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
MODMI         END-IF
MODMI
MODMI         MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO
      *
291099        IF SW-USC-X-BLOCCO = 'SI'
291099           GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
291099        END-IF
MODMI         PERFORM SCRITT-RIMB-TOT-LINEA
MODMI         THRU   SCRITT-RIMB-TOT-LINEA-EXIT
MODMI         IF SW-USC-X-BLOCCO = 'SI'
MODMI            GO TO CALCOLO-RIMBORSO-TOTALE-EXIT
MODMI         END-IF
MODMI       END-IF.
      *
       CALCOLO-RIMBORSO-TOTALE-EXIT .
           EXIT.
      ***************************************************************
      *      ROUTINE SCRITTURA RIMBORSO TOTALE
      *****************************************************************
       SCRITTURA-RIMBORSO-TOTALE .
      *
      D    DISPLAY 'SCRITTURA-RIMBORSO-TOTALE' .

      D    DISPLAY 'VALORE-NOMINALE-GES ' VALORE-NOMINALE-GES.
      D    DISPLAY 'VALORE-RIMBORSO-GES ' VALORE-RIMBORSO-GES.
      D    DISPLAY 'TITOLO RIM-TOT      ' TAB-PSA-GES-COD-TIT(PGM-IND1).
      D    DISPLAY 'CAUSALE RTE RTI     ' .
           IF WS-NAZ-TITOLO = 'E'
            MOVE 'RTE' TO WS-COD-CAU
           ELSE
            MOVE 'RTI' TO WS-COD-CAU
           END-IF.

MODTP *    MOVE VALORE-NOMINALE TO WS-VAL-NMN.
MODTP
MODTP      COMPUTE WS-VAL-NMN =   VALORE-NOMINALE-GES.
MODTP *    MOVE VALORE-RIMBORSO TO WS-IMP.
MODTP      MOVE VALORE-RIMBORSO-GES TO WS-IMP.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106        COMPUTE WS-IMP     = WS-IMP *  MC35-PESO
008106        COMPUTE WS-VAL-NMN = WS-VAL-NMN * MC35-PESO
008106     END-IF.

05258G*    APPLICAZIONE DEL COEFFICIENTE DI INFLAZIONE
05258G     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
05258G        COMPUTE WS-IMP = WS-IMP * WS-P-I-FACTOR
05258G     END-IF.

MODTP      MOVE TAB-PSA-GES-COD-GES (PGM-IND1)  TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
               GO TO  SCRITTURA-RIMBORSO-TOTALE-EXIT
           END-IF.
MODTP      MOVE TAB-PSA-GES-COD-GES(PGM-IND1)    TO S-MLQ0-COD-GES.
MODTP *14696 MOVE TAB-PSA-GES-COD-GES(PGM-IND1)    TO S-MLQ1-COD-GES.
000717     IF LGS-FLG-CCC = 'S'
MODTP?        MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC
MODTP?        MOVE COM-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE COM-CCC-CAT         TO WS-CAT-CCC
MODTP?        MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC
MODTP?        MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
000717     ELSE
000717        MOVE GES-CCC-NUM-CCC     TO WS-NUM-CCC
000717        MOVE GES-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE GES-CCC-CAT         TO WS-CAT-CCC
000717        MOVE GES-CCC-TIP-CCC     TO WS-TIP-CCC
000717        MOVE GES-CCC-COD-DVS     TO WS-COD-DVS
000717     END-IF.

070199      IF LGS-FLG-CCC = 'S'
070199        MOVE ZERO TO S-MLQ0-COD-GES
070199*14696               S-MLQ1-COD-GES
070199      END-IF.
014696*    PERFORM VAL-LIQUIDITA-SMLQ0 THRU
014696*         VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1 THRU
014696*         VAL-LIQUIDITA-SMLQ1-EXIT.

           IF CAU-FLG-LIQ OF DCLTBCAU = 'S'
000870       AND TIT-INI-RIM NOT = 'S'
MODTP *      ADD 1 TO WS-PRG-MOV
270599D      DISPLAY 'SCRITTURA LIQ RIMB TOT '
014696       PERFORM VAL-LIQUIDITA-SMLQ0
014696          THRU VAL-LIQUIDITA-SMLQ0-EXIT
             WRITE REC-SMLQ0
018605       INITIALIZE              REC-SMLQ0
018796     ELSE
018796        ADD 1 TO WS-PRG-MOV
014696*    ELSE
014696*      PERFORM VAL-LIQUIDITA-SMLQ1
014696*         THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*      WRITE REC-SMLQ1
           END-IF.
MODTP      COMPUTE TAB-PSA-GES-QTA-TOT (PGM-IND1) = 0
MODTP      PERFORM VALORIZZAZIONE-MOVIMENTI
MODTP      THRU    VALORIZZAZIONE-MOVIMENTI-EXIT.
250599*    ADD 1 TO WS-PRG-MOV.
MODTP      WRITE REC-SMO0.
018605     INITIALIZE              REC-SMO0
      *  AGGIORNAMENTO PORTAFOGLIO ROUTINE UPDD-TBPSA
           INITIALIZE DCLTBPSA.
MODTP *
MODTP * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           INITIALIZE DCLTBPSA.
MODTP      MOVE S-ELA-COD-IST      TO PSA-COD-IST      OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-SOC-IST  TO PSA-COD-SOC-IST  OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-FON      TO PSA-COD-FON      OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-LIN      TO PSA-COD-LIN      OF DCLTBPSA.
MODTP      MOVE TAB-PSA-GES-COD-GES (PGM-IND1)
MODTP                              TO PSA-COD-GES      OF DCLTBPSA.
MODTP      MOVE TAB-PSA-GES-COD-TIT (PGM-IND1)
MODTP                              TO PSA-COD-TIT      OF DCLTBPSA.
      *- GESTIONE ERRORE -*
           MOVE 'TBPSASL1'          TO WSN-SKB-COPY
           MOVE 'Y01-SEL-TBPSA'     TO WSN-SKB-LABEL
           MOVE 'SELECT'            TO WSN-SKB-FUNZIONE
           MOVE 'TBPSA'             TO WSN-SKB-TABELLA
014696*    INITIALIZE WS-IMPO-FONDO
014696*    MOVE PSA-COD-IST         TO WS-COD-ISTX
014696*    MOVE PSA-COD-SOC-IST     TO WS-COD-SOC-ISTX
014696*    MOVE PSA-COD-FON         TO WS-COD-FONX
014696*    MOVE PSA-COD-LIN         TO WS-COD-LINX
           MOVE PSA-COD-GES         TO WS-COD-GESX
           MOVE PSA-COD-TIT         TO WS-COD-TITX
014696*    PERFORM ZZZ-FORMA-CHIAVE
014696*    THRU    ZZZ-FORMA-CHIAVE-EXIT
014696     MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA
                  WS-KEY-SOC-IST
                  WS-KEY-FONDO
                  WS-KEY-LINEA
                  WS-KEY-GESTORE
                  WS-KEY-TITOLO
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
      *- FINE GESTIONE ERRORE -*
           PERFORM Y01-SEL-TBPSA
           THRU    Y01-SEL-TBPSA-EXIT.
           MOVE ZEROES             TO PSA-QTA-TOT      OF DCLTBPSA
002483                                PSA-CTV-QTA-EFF  OF DCLTBPSA
                                      PSA-CTV-QTA      OF DCLTBPSA.
130499     MOVE PSA-QTA-TOT  OF DCLTBPSA  TO   PSA-QTA-COP OF DCLTBPSA.
      D    DISPLAY ' GESTORE = ' PSA-COD-GES.
      D    DISPLAY ' TITOLO = ' PSA-COD-TIT.
MODTP      MOVE 'TBPSAUP1'         TO WSN-SKB-COPY.
MODTP      MOVE 'Y02-UPD-TBPSA'    TO WSN-SKB-LABEL.
MODTP      MOVE 'TBPSA'            TO WSN-SKB-TABELLA.
MODTP      MOVE 'UPDATE'           TO WSN-SKB-FUNZIONE.
MODTP *14696INITIALIZE WS-IMPO-FONDO.
MODTP *14696MOVE  PSA-COD-IST       TO WS-COD-ISTX.
MODTP *14696MOVE  PSA-COD-SOC-IST   TO WS-COD-SOC-ISTN
MODTP *14696MOVE  PSA-COD-FON       TO WS-COD-FONN
MODTP *14696MOVE  PSA-COD-LIN       TO WS-COD-LINN
MODTP *14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
MODTP *14696STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
MODTP *14696WS-KEY-LINEA
MODTP *14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
MODTP
006664*MODTPD     DISPLAY 'UPDATE SU TBPSA'
MODTP      PERFORM Y02-UPD-TBPSA THRU Y02-UPD-TBPSA-EXIT.
MODTP      IF ENGIRC-NOTF-ENDFILE
MODTP            PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
MODTP      END-IF.
      *
       SCRITTURA-RIMBORSO-TOTALE-EXIT.
           EXIT.
      ***************************************************************
      *        ROUTINE  CONVERTI EURO                               *
      ***************************************************************
       CONVERTI-EURO.
      *
      D     DISPLAY 'CONVERTI IN EURO DA ' COM-COD-DVS.
            MOVE S-ELA-COD-IST        TO CG-CONEUR-COD-IST.
            MOVE S-ELA-COD-SOC-IST    TO CG-CONEUR-COD-SOC-IST .
            MOVE S-ELA-COD-FON        TO CG-CONEUR-COD-FON .
            MOVE S-ELA-DAT-LAZ        TO CG-CONEUR-DAT-RIL-CAM .
            MOVE COM-COD-DVS          TO CG-CONEUR-COD-DVS-PNZ .
            MOVE CG-CONEUR-COD-EUR    TO CG-CONEUR-COD-DVS-ARR .
            MOVE COM-FLG-DVS-IN       TO CG-CONEUR-FLG-DVS-PNZ .
            MOVE 'E'                  TO CG-CONEUR-FLG-DVS-ARR .
            MOVE 'N'                  TO CG-CONEUR-FLG-LIT-ARR .
            MOVE 0                    TO CG-CONEUR-TAS-UNO .
            MOVE 0                    TO CG-CONEUR-TAS-DUE .

      D     DISPLAY '----- DENTRO  CONVERTI-EURO  --------'
      D     DISPLAY 'CG-CONEUR-INPUT  '      CG-CONEUR-INPUT
      D     DISPLAY '----- DENTRO  CONVERTI-EURO  --------'
            PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.

            IF CG-CONEUR-CODERR NOT = SPACE
014146        MOVE 'GFUWM300' TO WSN-SKB-PGM
              PERFORM X01-BLOCCO-IMEU
              THRU    X01-BLOCCO-IMEU-EXIT
            END-IF.
      *
      D     DISPLAY 'FINE CONVERTI-EURO'.
       CONVERTI-EURO-EXIT.
           EXIT.
      ***************************************************************
      *           ROUTINE INSERIMENTO SCARTO IN LIQUIDITA           *
      ****************************************************************
       INSERIMENTO-SCARTO-IN-LIQ.
      *
      D    DISPLAY 'INSERIM-IN-LIQUIDITA'.
FS         IF FND-COD-DVS NOT = FND-COD-DVS-IPS
FS            MOVE COM-FND-DIV-FLG-DVS-IN      TO CG-CONEUR-FLG-DVS-PNZ
FS            MOVE COM-FND-DIV-IPS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
FS            MOVE COM-FND-DIV-IPS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
FS            MOVE S-ELA-COD-IST               TO CG-CONEUR-COD-IST
FS            MOVE S-ELA-COD-SOC-IST           TO CG-CONEUR-COD-SOC-IST
FS            MOVE S-ELA-COD-FON               TO CG-CONEUR-COD-FON
FS            MOVE S-ELA-DAT-LAZ               TO CG-CONEUR-DAT-RIL-CAM
FS            MOVE PGM-AGGI-DISAG              TO CG-CONEUR-IMP-INP
FS    D       DISPLAY 'IMP. AGG/DIS DA CONV. ' PGM-AGGI-DISAG
FS            MOVE FND-COD-DVS                 TO CG-CONEUR-COD-DVS-PNZ
FS            MOVE FND-COD-DVS-IPS             TO CG-CONEUR-COD-DVS-ARR
FS            MOVE 0                           TO CG-CONEUR-TAS-UNO
FS            MOVE 0                           TO CG-CONEUR-TAS-DUE
FS    D       DISPLAY 'TITOLO ' TIT-COD-TIT
FS    D       DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
FS            PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

FS            IF CG-CONEUR-CODERR NOT = SPACE
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
FS               PERFORM X01-BLOCCO-IMEU
FS                  THRU    X01-BLOCCO-IMEU-EXIT
FS               GO TO INSERIMENTO-SCARTO-IN-LIQ-EXIT
FS            END-IF
FS            MOVE CG-CONEUR-IMP-OUT TO PGM-AGGI-DISAG
FS    D       DISPLAY 'IMP. AGG/DISAD CONVERTITO ' PGM-AGGI-DISAG
FS         END-IF.
           COMPUTE WS-IMP = PGM-AGGI-DISAG * (-1) .
           MOVE 'SET' TO WS-COD-CAU.
           MOVE VALORE-NOMINALE TO WS-VAL-NMN.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106        COMPUTE WS-IMP     = WS-IMP *  MC35-PESO
008106        COMPUTE WS-VAL-NMN = WS-VAL-NMN * MC35-PESO
008106     END-IF.

MODTP      MOVE ZEROES                        TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
            GO TO INSERIMENTO-SCARTO-IN-LIQ-EXIT
           END-IF.

MODTP      MOVE ZEROES                  TO S-MLQ0-COD-GES.
MODTP *14696 MOVE ZEROES                  TO S-MLQ1-COD-GES.
MODTP      MOVE COM-CCC-IPS-NUM-CCC     TO WS-NUM-CCC.
MODTP      MOVE COM-CCC-IPS-COD-FIL     TO WS-COD-FIL.
17302G*24391G     MOVE COM-CCC-CAT             TO WS-CAT-CCC.
24391G     MOVE COM-CCC-IPS-CAT         TO WS-CAT-CCC.
MODTP      MOVE COM-CCC-IPS-TIP-CCC     TO WS-TIP-CCC.
MODTP      MOVE COM-CCC-IPS-COD-DVS     TO WS-COD-DVS.

000762     MOVE S-ELA-DAT-LAZ (1: 2)    TO WS-DAT-COM3 (7: 2).
000762     MOVE S-ELA-DAT-LAZ (4: 2)    TO WS-DAT-COM3 (5: 2).
000762     MOVE S-ELA-DAT-LAZ (7: 4)    TO WS-DAT-COM3 (1: 4).
310100* SE IL TITOLO E' ITALIANO LA VALUTA DEVE ESSERE POSTA PARI
310100* ALL'ULTIMO GIORNO LAVORATIVO DEL MESE.
000762* (NUOVA NORMATIVA: DAL 01/07/2000 ANCHE I TITOLI ESTERI)
310100     IF WS-NAZ-TITOLO = 'I'
000762        OR WS-DAT-COM3 > 20000630
      D    DISPLAY 'TITOLO ITALIANO, VALUTA A FINE MESE '
      D    DISPLAY 'VALUTA ATTUALE ' WS-DATA-VLT
310100        MOVE WS-DATA-VLT(1:2) TO GDATE-DIN1 (1:2)
310100        MOVE WS-DATA-VLT(4:2) TO GDATE-DIN1 (3:2)
310100        MOVE WS-DATA-VLT(7:4) TO GDATE-DIN1 (5:4)
310100        MOVE '1'     TO GDATE-SIN1OTT
310100        MOVE '0'     TO GDATE-SIN1ROV
310100        MOVE 'UM'    TO GDATE-CFUN
310100        PERFORM U-X01-GEST-BOPGDATE
310100        THRU    U-X01-GEST-BOPGDATE-EXIT
      D    DISPLAY 'VALUTA FINE MESE ' GDATE-DEFF
310100        IF GDATE-STC NOT = '0'
310100           MOVE 'B0037'        TO CG-BLOCFON-MOTIVO
310100           MOVE 'INSERIM.SCA'  TO CG-BLOCFON-NOTE
310100           MOVE 'VALUTA PER TITOLI ITALIANI'
310100                                  TO CG-BLOCFON-FASE
310100           MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
310100           MOVE S-ELA-COD-IST  TO CG-BLOCFON-COD-IST
310100           MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
310100           MOVE S-ELA-COD-FON  TO CG-BLOCFON-COD-FON
310100           MOVE S-ELA-COD-LIN  TO CG-BLOCFON-COD-LIN
310100           MOVE S-ELA-DAT-LAZ  TO CG-BLOCFON-DAT-LAZ
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
310100           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
310100           MOVE 'SI' TO SW-USC-X-BLOCCO
310100           GO TO INSERIMENTO-SCARTO-IN-LIQ-EXIT
310100        ELSE
310100           MOVE GDATE-DEFF(1:2) TO WS-DATA-VLT(1:2)
310100           MOVE GDATE-DEFF(3:2) TO WS-DATA-VLT(4:2)
310100           MOVE GDATE-DEFF(5:4) TO WS-DATA-VLT(7:4)
310100       END-IF
310100     END-IF
014696*    PERFORM VAL-LIQUIDITA-SMLQ0
014696*    THRU    VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1 THRU
014696*         VAL-LIQUIDITA-SMLQ1-EXIT.

           IF CAU-FLG-LIQ OF DCLTBCAU = 'S'
250599*        ADD 1 TO WS-PRG-MOV
270599D        DISPLAY 'SCRITTURA LIQ SCARTO   '
014696         PERFORM VAL-LIQUIDITA-SMLQ0
014696            THRU VAL-LIQUIDITA-SMLQ0-EXIT
               WRITE REC-SMLQ0
018605         INITIALIZE              REC-SMLQ0
014696*    ELSE
014696*        PERFORM VAL-LIQUIDITA-SMLQ1
014696*           THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*        WRITE REC-SMLQ1
           END-IF.
      *
       INSERIMENTO-SCARTO-IN-LIQ-EXIT.
           EXIT .
      *************************************************************
      *               ROUTINE RIMBORSO PARZIALE                   *
      **************************************************************
       RIMBORSO-PARZIALE.
      *
06280GD    DISPLAY 'RIMBORSO PARZIALE'
06280GD    DISPLAY 'TIT-COD-TIT ' TIT-COD-TIT
003263*5456 MOVE SPACES TO WS-PERS-R-COD-OK.
005456*6280GMOVE SPACES TO WS-PERS-C10-COD-OK.
      D    DISPLAY 'TIT-FLG-TIP-RIM ' TIT-FLG-TIP-RIM
           IF TIT-FLG-TIP-RIM  = 'P'
              MOVE TIT-DAT-SUC-RIM (7:4) TO WS-COM1-DATA (1:4)
              MOVE TIT-DAT-SUC-RIM (4:2) TO WS-COM1-DATA (5:2)
              MOVE TIT-DAT-SUC-RIM (1:2) TO WS-COM1-DATA (7:2)
              MOVE TIT-DAT-EFF-RIM (7:4) TO WS-COM3-DATA (1:4)
              MOVE TIT-DAT-EFF-RIM (4:2) TO WS-COM3-DATA (5:2)
              MOVE TIT-DAT-EFF-RIM (1:2) TO WS-COM3-DATA (7:2)
              MOVE S-ELA-DAT-LAZ (7:4)   TO WS-COM2-DATA (1:4)
              MOVE S-ELA-DAT-LAZ (4:2)   TO WS-COM2-DATA (5:2)
              MOVE S-ELA-DAT-LAZ (1:2)   TO WS-COM2-DATA (7:2)

      D     DISPLAY 'WS-COM1-DATA  ' WS-COM1-DATA
      D     DISPLAY 'WS-COM2-DATA  ' WS-COM2-DATA
      D     DISPLAY 'WS-COM3-DATA  ' WS-COM3-DATA

3092  *6280GIF TIT-DAT-SUC-RIM NOT = '01.01.0001' AND
3092  *6280G   WS-COM1-DATA NOT > WS-COM2-DATA
3092  *6280G   IF TIT-DAT-EFF-RIM NOT = '01.01.0001'
3092  *5456       MOVE TIT-DAT-EFF-RIM  TO WS-PERS-R-DAT-EVE
005456*14696      MOVE TIT-DAT-EFF-RIM  TO WS-PERS-C10-DAT-EVE
014696*D           DISPLAY 'WS-PERS-C10-DAT-EVE' WS-PERS-C10-DAT-EVE
3092  *14696      PERFORM U-GFC10-CALL-TBELA
3092  *14696      THRU    U-GFC10-CALL-TBELA-EXIT
014696*       CALL GFC10 SOSTITUITA CON CONTROLLO DATE
014696*6280G      IF (WS-COM3-DATA > WS-DAT-ULT-ELAB-8 AND
014696*6280G          WS-COM3-DATA NOT > WS-COM2-DATA)
014696*6280G          MOVE 'S' TO WS-PERS-C10-COD-OK
014696*6280G      END-IF
014696*6280G   DISPLAY 'WS-PERS-C10-COD-OK  ' WS-PERS-C10-COD-OK
014696*6280G   DISPLAY 'TIT-DAT-EFF-RIM     ' WS-COM3-DATA
014696*6280G   DISPLAY 'S-ELA-DAT-LAZ       ' WS-COM2-DATA
014696*6280G   DISPLAY 'WS-DAT-ULT-ELAB-8   ' WS-DAT-ULT-ELAB-8
003291*6280G   ELSE
003291*03321      MOVE 'N' TO WS-PERS-R-COD-OK
003321*5456       MOVE 'S' TO WS-PERS-R-COD-OK
005456*6280G      MOVE 'S' TO WS-PERS-C10-COD-OK
3092  *6280G   END-IF
3092  *6280GEND-IF

      ****************************************************************
      * CONTROLLO ASTERISCATO CON SEGN.3092
      ****************************************************************
?     *3092 IF TIT-DAT-SUC-RIM NOT = '01.01.0001' AND
?     *3092    WS-COM1-DATA NOT > WS-COM2-DATA
?     *3092   IF TIT-DAT-EFF-RIM = '01.01.0001' OR
?     *3092      TIT-DAT-EFF-RIM = S-ELA-DAT-LAZ
      ****************************************************************

3092  *3291 IF WS-PERS-R-COD-OK = 'S' OR
3092  *3291    TIT-DAT-EFF-RIM = '01.01.0001'
003291*5456 IF WS-PERS-R-COD-OK = 'S'
005456*6280GIF WS-PERS-C10-COD-OK = 'S'
06280G*SE DATA SUCCESSIVO RIMBORSO VALORIZZATA
06280G* E DATA SUCCESSIVO RIMBORSO <= DATA LAVORAZIONE
06280G* E DATA SUCCESSIVO RIMBORSO > ULTIMA ELABORATA
06280GD     DISPLAY 'DATA SUC RIMBORSO ' TIT-DAT-SUC-RIM
06280GD     DISPLAY 'WS-COM1-DATA ' WS-COM1-DATA
06280GD     DISPLAY 'WS-COM2-DATA ' WS-COM2-DATA
06280GD     DISPLAY 'WS-DAT-ULT-ELAB-8 ' WS-DAT-ULT-ELAB-8
06280G      IF TIT-DAT-SUC-RIM NOT = '01.01.0001' AND
06280G         WS-COM1-DATA <= WS-COM2-DATA
06280G         AND WS-COM1-DATA > WS-DAT-ULT-ELAB-8
                MOVE TIT-DAT-SUC-RIM   TO SMO-VLT OF DCLTBSMO
                PERFORM COMPRAVENDITA THRU COMPRAVENDITA-EXIT
                MOVE TIT-DAT-SUC-RIM OF DCLTBTIT TO COM-DATA

                PERFORM CALCOLO-VALUTA
                THRU    CALCOLO-VALUTA-EXIT
002483          PERFORM VERIFICA-LAVORATIVO
002483          THRU    VERIFICA-LAVORATIVO-EXIT
                PERFORM CALCOLO-RIMBORSO-PARZIALE
                THRU    CALCOLO-RIMBORSO-PARZIALE-EXIT
002040*         IF FND-TIP-FON OF DCLTBFND = 'C'
002040*10122    IF (FND-TIP-FON = 'C' AND FND-FLG-FND-IMM NOT = 'S')
010122          IF  FND-TIP-FON = 'C'
001053             OR (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 > 20001231)
201099             MOVE VALORE-RIMBORSO TO COM-QTA-TOTALE
201099                                     COMODO-QTA-TOTALE
                   PERFORM U-GF12-STAMPA-TOTALI-FC
                      THRU U-GF12-STAMPA-TOTALI-FC-EXIT
                END-IF
              END-IF
      *     END-IF
           END-IF.
      *
       RIMBORSO-PARZIALE-EXIT.
           EXIT .
      *****************************************************************
      *       ROUTINE SCRITTURA IN LIQUIDITA' DI RIMBORSO PARIALE    *
      *****************************************************************
       SCRITTURA-RIMB-PARZIALE.
      *
06280GD    DISPLAY 'SCRITTURA-RIMB-PARZIALE'
06280GD    DISPLAY 'TITOLO '  TIT-COD-TIT
           IF WS-NAZ-TITOLO = 'E'
            MOVE 'RPE' TO WS-COD-CAU
           ELSE
            MOVE 'RPI' TO WS-COD-CAU
           END-IF.
009006*016226 IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
009006*016226  COMPUTE VALORE-NOMINALE-GES = (VALORE-NOMINALE-GES * 100)
009006*016226                              / TIT-TAS-RIM
009006*016226  COMPUTE VALORE-RIMBORSO-GES = (VALORE-NOMINALE-GES *
009006*016226                                 TIT-PRZ-RIM ) / 100
009006*016226 END-IF

MODTP *    MOVE VALORE-NOMINALE TO WS-VAL-NMN.
MODTP
MODTP      COMPUTE WS-VAL-NMN =   VALORE-NOMINALE-GES.
MODTP *    MOVE VALORE-RIMBORSO TO WS-IMP.
MODTP      MOVE VALORE-RIMBORSO-GES TO WS-IMP.

008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106        COMPUTE WS-IMP     = WS-IMP *  MC35-PESO
008106        COMPUTE WS-VAL-NMN = WS-VAL-NMN * MC35-PESO
008106     END-IF.

MODTP      MOVE TAB-PSA-GES-COD-GES (PGM-IND1)  TO CG-LETCAU-COD-GES.
           PERFORM LETTURA-CAUSALE THRU LETTURA-CAUSALE-EXIT.
           IF SW-USC-X-BLOCCO = 'SI'
               GO TO  SCRITTURA-RIMB-PARZIALE-EXIT
           END-IF.

MODTP      MOVE TAB-PSA-GES-COD-GES(PGM-IND1)    TO S-MLQ0-COD-GES.
MODTP *14696 MOVE TAB-PSA-GES-COD-GES(PGM-IND1)    TO S-MLQ1-COD-GES.
000717     IF LGS-FLG-CCC = 'S'
MODTP?        MOVE COM-CCC-NUM-CCC     TO WS-NUM-CCC
MODTP?        MOVE COM-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE COM-CCC-CAT         TO WS-CAT-CCC
MODTP?        MOVE COM-CCC-TIP-CCC     TO WS-TIP-CCC
MODTP?        MOVE COM-CCC-COD-DVS     TO WS-COD-DVS
000717     ELSE
000717        MOVE GES-CCC-NUM-CCC     TO WS-NUM-CCC
000717        MOVE GES-CCC-COD-FIL     TO WS-COD-FIL
17302G        MOVE GES-CCC-CAT         TO WS-CAT-CCC
000717        MOVE GES-CCC-TIP-CCC     TO WS-TIP-CCC
000717        MOVE GES-CCC-COD-DVS     TO WS-COD-DVS
000717     END-IF.

070199      IF LGS-FLG-CCC = 'S'
070199        MOVE ZERO TO S-MLQ0-COD-GES
070199*14696               S-MLQ1-COD-GES
070199      END-IF.
014696*    PERFORM VAL-LIQUIDITA-SMLQ0 THRU
014696*         VAL-LIQUIDITA-SMLQ0-EXIT.
014696*    PERFORM VAL-LIQUIDITA-SMLQ1 THRU
014696*         VAL-LIQUIDITA-SMLQ1-EXIT.

           IF CAU-FLG-LIQ OF DCLTBCAU = 'S'
000870       AND TIT-INI-RIM NOT = 'S'
MODTP *      ADD 1 TO WS-PRG-MOV
270599D      DISPLAY 'SCRITTURA LIQ RIMBORSI PAR '
014696       PERFORM VAL-LIQUIDITA-SMLQ0
014696          THRU VAL-LIQUIDITA-SMLQ0-EXIT
             WRITE REC-SMLQ0
018605       INITIALIZE              REC-SMLQ0
018796     ELSE
018796        ADD 1 TO WS-PRG-MOV
014696*    ELSE
014696*      PERFORM VAL-LIQUIDITA-SMLQ1
014696*         THRU VAL-LIQUIDITA-SMLQ1-EXIT
014696*      WRITE REC-SMLQ1
           END-IF.
MODTP      COMPUTE TAB-PSA-GES-QTA-TOT (PGM-IND1) =
MODTP                                  TAB-PSA-GES-QTA-TOT (PGM-IND1) -
MODTP                                  VALORE-NOMINALE-GES.
008106*    SE ESISTE UN PIANO DI RIMBORSO IL NMN IN TAVBELLA NON VA RIDO
008106*    RIDOTTO
008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106        GO TO SCRITTURA-RIMB-PARZIALE-EXIT
008106     END-IF.

MODTP      PERFORM VALORIZZAZIONE-MOVIMENTI
MODTP      THRU    VALORIZZAZIONE-MOVIMENTI-EXIT.
250599*    ADD 1 TO WS-PRG-MOV.
MODTP      WRITE REC-SMO0.
018605     INITIALIZE              REC-SMO0.
      *  AGGIORNAMENTO PORTAFOGLIO ROUTINE UPDD-TBPSA
MODTP *
MODTP * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
           INITIALIZE DCLTBPSA.
MODTP      MOVE S-ELA-COD-IST      TO PSA-COD-IST      OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-SOC-IST  TO PSA-COD-SOC-IST  OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-FON      TO PSA-COD-FON      OF DCLTBPSA.
MODTP      MOVE S-ELA-COD-LIN      TO PSA-COD-LIN      OF DCLTBPSA.
MODTP      MOVE TAB-PSA-GES-COD-GES (PGM-IND1)
MODTP                              TO PSA-COD-GES      OF DCLTBPSA.
MODTP      MOVE TAB-PSA-GES-COD-TIT (PGM-IND1)
MODTP                              TO PSA-COD-TIT      OF DCLTBPSA.
      *- GESTIONE ERRORE -*
           MOVE 'TBPSASL1'          TO WSN-SKB-COPY
           MOVE 'Y01-SEL-TBPSA'     TO WSN-SKB-LABEL
           MOVE 'SELECT'            TO WSN-SKB-FUNZIONE
           MOVE 'TBPSA'             TO WSN-SKB-TABELLA
014696*    INITIALIZE WS-IMPO-FONDO
014696*    MOVE PSA-COD-IST         TO WS-COD-ISTX
014696*    MOVE PSA-COD-SOC-IST     TO WS-COD-SOC-ISTX
014696*    MOVE PSA-COD-FON         TO WS-COD-FONX
014696*    MOVE PSA-COD-LIN         TO WS-COD-LINX
           MOVE PSA-COD-GES         TO WS-COD-GESX
           MOVE PSA-COD-TIT         TO WS-COD-TITX
014696*    PERFORM ZZZ-FORMA-CHIAVE
014696*    THRU    ZZZ-FORMA-CHIAVE-EXIT
014696     MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
           STRING WS-KEY-BANCA
                  WS-KEY-SOC-IST
                  WS-KEY-FONDO
                  WS-KEY-LINEA
                  WS-KEY-GESTORE
                  WS-KEY-TITOLO
           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
      *- FINE GESTIONE ERRORE -*
           PERFORM Y01-SEL-TBPSA
           THRU    Y01-SEL-TBPSA-EXIT.
MODTP      MOVE TAB-PSA-GES-QTA-TOT (PGM-IND1)
MODTP                              TO PSA-QTA-TOT      OF DCLTBPSA.
130499     MOVE PSA-QTA-TOT  OF DCLTBPSA  TO   PSA-QTA-COP OF DCLTBPSA.
MODTP      MOVE 'TBPSAUP1'         TO WSN-SKB-COPY.
MODTP      MOVE 'Y02-UPD-TBPSA'    TO WSN-SKB-LABEL.
MODTP      MOVE 'TBPSA'            TO WSN-SKB-TABELLA.
MODTP      MOVE 'UPDATE'           TO WSN-SKB-FUNZIONE.
MODTP *14696INITIALIZE WS-IMPO-FONDO.
MODTP *14696MOVE  PSA-COD-IST       TO WS-COD-ISTX.
MODTP *14696MOVE  PSA-COD-SOC-IST   TO WS-COD-SOC-ISTN
MODTP *14696MOVE  PSA-COD-FON       TO WS-COD-FONN
MODTP *14696MOVE  PSA-COD-LIN       TO WS-COD-LINN
MODTP *14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
MODTP *14696STRING WS-KEY-BANCA WS-KEY-SOC-IST  WS-KEY-FONDO
MODTP *14696WS-KEY-LINEA
MODTP *14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
MODTP
006664D    DISPLAY 'UPDATE SU TBPSA'
MODTP      PERFORM Y02-UPD-TBPSA THRU Y02-UPD-TBPSA-EXIT.
MODTP      IF ENGIRC-NOTF-ENDFILE
MODTP            PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
MODTP      END-IF.
      *
       SCRITTURA-RIMB-PARZIALE-EXIT.
           EXIT.
MODTP *****************************************************************
MODTP *       ROUTINE SCRITTURA IN LIQUIDITA' DI RIMBORSO PARZIALE   *
MODTP *****************************************************************
MODTP  SCRITT-RIMB-PARZ-LINEA.
06280GD    DISPLAY ' SCRITT-RIMB-PARZ-LINEA'.
008106* L'AGGIORNAMENTO DELLA DATA EFFETTIVO RIMBORSO VA EFFETTUATA
008106* SOLO SE LA PERS. 105   DISABILITATA OPPURE NON ESISTE UN
008106* PIANO DI RIMBORSO PER IL TITOLO.
008106*8730IF WS-ABIL-PERS-105 = 'N' OR
008106*8730  (WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 100)
008730     IF MC36-ABIL-TIT = 'N' OR
008730       (MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 100)

MODTP         MOVE TIT-DAT-EFF-RIM (7:4) TO WS-COM3-DATA (1:4)
MODTP         MOVE TIT-DAT-EFF-RIM (4:2) TO WS-COM3-DATA (5:2)
MODTP         MOVE TIT-DAT-EFF-RIM (1:2) TO WS-COM3-DATA (7:2)
MODTP
MODTP         IF TIT-DAT-EFF-RIM = '01.01.0001'
005717*     LEGGO LA RIGA SU TBTIT
005717         PERFORM LEGGI-TBTIT
005717         THRU    LEGGI-TBTIT-EXIT
MODTP          MOVE S-ELA-DAT-LAZ TO TIT-DAT-EFF-RIM OF DCLTBTIT
MODTP * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
MODTP          MOVE ' TBTITUP1 '  TO WSN-SKB-COPY
MODTP          MOVE ' Y02-UPD-TBTIT ' TO WSN-SKB-LABEL
MODTP          MOVE ' TBTIT' TO WSN-SKB-TABELLA
MODTP          MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
MODTP *14696   INITIALIZE WS-IMPO-FONDO
MODTP *14696   MOVE  TIT-COD-IST         TO    WS-COD-ISTX
MODTP *14696   MOVE  TIT-COD-TIT         TO    WS-COD-TITX
MODTP *14696   PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
MODTP *14696   STRING WS-KEY-BANCA WS-KEY-TITOLO
MODTP *14696   DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
MODTP          PERFORM  Y02-UPD-TBTIT THRU Y02-UPD-TBTIT-EXIT
005717* SE DATA DECORRENZA LETTA SU TBTIT E' < DI DATA ELABORAZIONE
005717* DEVO AGGIORNARE LA DATA EFFETTIVO RIMBORSO ANCHE SU TBSVM
006664*005717      DISPLAY ' WS-DAT-LAZ-8  ' WS-DAT-LAZ-8
006664*005717      DISPLAY ' WS-DAT-DEC    ' WS-DAT-DEC
005717         IF WS-DAT-LAZ-8 < WS-DAT-DEC
005717            PERFORM LEGGI-TBSVM
005717            THRU    LEGGI-TBSVM-EXIT
005717            IF ENGIRC-NORMAL
006664*005717              DISPLAY 'AGGIORNO TBSVM ' SVM-DAT-EFF-RIM
005717               MOVE S-ELA-DAT-LAZ TO SVM-DAT-EFF-RIM
005717               PERFORM AGGIORNA-TBSVM
005717               THRU    AGGIORNA-TBSVM-EXIT
005717            END-IF
005717            PERFORM CLOSE-TBSVM
005717            THRU    CLOSE-TBSVM-EXIT
005717         END-IF
MODTP *8106END-IF.
008106        END-IF
008106     END-IF.
MODTP *
MODTP *    COMPUTE WS-COM1-QNT-VAL-NMN = VALORE-NOMINALE * (-1).
MODTP *    COMPUTE WS-COM2-QNT-VAL-NMN = WS-COM1-QNT-VAL-NMN +
MODTP *                      TAB-PSA-QTA-TOT (PGM-IND4) .
MODTP *
MODTP      COMPUTE TAB-PSA-QTA-TOT (PGM-IND4) =
MODTP         TAB-PSA-QTA-TOT (PGM-IND4) -  VALORE-NOMINALE.
MODTP *    MOVE WS-PRG-MOV TO SMO-PRG-MOV OF DCLTBSMO.
MODTP *    MOVE VALORE-NOMINALE     TO SMO-QTA-VAL-NMN OF DCLTBSMO.
MODTP      MOVE TIT-DAT-SUC-RIM OF DCLTBTIT TO MLQ-VLT OF DCLTBMLQ.
MODTP      MOVE ZEROES                      TO PGM-AGGI-DISAG.
FS    D    DISPLAY '1 PGM-AGGI-DISAG ---> ' PGM-AGGI-DISAG.
MODTP      IF ((VALORE-NOMINALE NOT = ZERO) AND
MODTP         (TIT-PRZ-RIM OF DCLTBTIT > TIT-PRZ-EMS OF DCLTBTIT))
MODTP
MODTP       MOVE TIT-DAT-SUC-RIM OF DCLTBTIT TO DATA-RIMBORSO
MODTP       PERFORM AGGI-DISAGGI THRU AGGI-DISAGGI-EXIT
MODTP       IF SW-USC-X-BLOCCO = 'SI'
MODTP        GO TO SCRITT-RIMB-PARZ-LINEA-EXIT
MODTP       END-IF
MODTP
MODTP       IF PGM-AGGI-DISAG NOT = ZEROES
MODTP            PERFORM INSERIMENTO-SCARTO-IN-LIQ
MODTP            THRU    INSERIMENTO-SCARTO-IN-LIQ-EXIT
MODTP            IF SW-USC-X-BLOCCO = 'SI'
MODTP                     GO TO SCRITT-RIMB-PARZ-LINEA-EXIT
MODTP            END-IF
MODTP       END-IF
MODTP      END-IF.
MODTP *
MODTP  SCRITT-RIMB-PARZ-LINEA-EXIT.
MODTP      EXIT.
MODTP *****************************************************************
MODTP *       ROUTINE SCRITTURA IN LIQUIDITA' DI RIMBORSO TOTALE     *
MODTP *****************************************************************
MODTP  SCRITT-RIMB-TOT-LINEA.
      *
      D    DISPLAY 'SCRITT-RIMB-TOT-LINEA'

MODTP      MOVE TIT-DAT-EFF-RIM (7:4) TO WS-COM3-DATA (1:4)
MODTP      MOVE TIT-DAT-EFF-RIM (4:2) TO WS-COM3-DATA (5:2)
MODTP      MOVE TIT-DAT-EFF-RIM (1:2) TO WS-COM3-DATA (7:2)
MODTP
MODTP      IF TIT-DAT-EFF-RIM = '01.01.0001'
3092          MOVE TIT-DAT-RIM(7:4) TO COMSSAA
3092          MOVE TIT-DAT-RIM(4:2) TO COMMM
3092          MOVE TIT-DAT-RIM(1:2) TO COMGG
3092          PERFORM CERCA-DATA-BORSA
3092          THRU CERCA-DATA-BORSA-EXIT
      D     DISPLAY ' TORNO DA CERCA-DATA-BORSA DI SCRITT-RIMB'
3092  ***************************************************************
      *  MUOVI LA DATA DI BORSA E I CAMPI NELLA CHIAVE PRIMA DELLA
      *  UPDATE
      ***************************************************************
3092           MOVE TIT-COD-IST     TO TIT-COD-IST OF DCLTBTIT
      D        DISPLAY 'TIT-COD-IST' TIT-COD-IST
3092           MOVE TIT-COD-TIT     TO TIT-COD-TIT OF DCLTBTIT
      D        DISPLAY 'TIT-COD-TIT' TIT-COD-TIT
005717         PERFORM LEGGI-TBTIT
005717         THRU    LEGGI-TBTIT-EXIT

3092           MOVE WS-DAT-EFF-PIU1 TO TIT-DAT-EFF-RIM OF DCLTBTIT

      D     DISPLAY 'TIT-DAT-EFF-RIM' TIT-DAT-EFF-RIM OF DCLTBTIT
MODTP
MODTP *3092 MOVE S-ELA-DAT-LAZ TO TIT-DAT-EFF-RIM OF DCLTBTIT
MODTP * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
MODTP       MOVE ' TBTITUP1 '  TO WSN-SKB-COPY
MODTP       MOVE ' Y02-UPD-TBTIT ' TO WSN-SKB-LABEL
MODTP       MOVE ' TBTIT' TO WSN-SKB-TABELLA
MODTP       MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE
MODTP *14696INITIALIZE WS-IMPO-FONDO
MODTP *14696MOVE  TIT-COD-IST         TO    WS-COD-ISTX
MODTP *14696MOVE  TIT-COD-TIT         TO    WS-COD-TITX
MODTP *14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
MODTP *14696STRING WS-KEY-BANCA WS-KEY-TITOLO
MODTP *14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
MODTP       PERFORM  Y02-UPD-TBTIT THRU Y02-UPD-TBTIT-EXIT
      D     DISPLAY 'TORNO DA UPD TIT'
            MOVE ENGIDB-RC TO W-ENGIDB-RC
      D     DISPLAY 'W-ENGIDB-RC' W-ENGIDB-RC
005717* SE DATA DECORRENZA LETTA SU TBTIT E' < DI DATA ELABORAZIONE
005717* DEVO AGGIORNARE LA DATA EFFETTIVO RIMBORSO ANCHE SU TBSVM
006664*005717      DISPLAY 'WS-DAT-LAZ-8  ' WS-DAT-LAZ-8
006664*005717      DISPLAY ' WS-DAT-DEC '   WS-DAT-DEC
005717      IF WS-DAT-LAZ-8 < WS-DAT-DEC
005717
005717         PERFORM LEGGI-TBSVM
005717         THRU    LEGGI-TBSVM-EXIT
005717         IF ENGIRC-NORMAL
006664D           DISPLAY 'AGGIORNO TBSVM ' SVM-DAT-EFF-RIM
005717            MOVE WS-DAT-EFF-PIU1 TO SVM-DAT-EFF-RIM
005717            PERFORM AGGIORNA-TBSVM
005717            THRU    AGGIORNA-TBSVM-EXIT
005717         END-IF
005717         PERFORM CLOSE-TBSVM
005717         THRU    CLOSE-TBSVM-EXIT
005717      END-IF
MODTP      END-IF.
MODTP      COMPUTE TAB-PSA-QTA-TOT (PGM-IND4) = 0.
MODTP      MOVE TIT-DAT-RIM OF DCLTBTIT TO MLQ-VLT OF DCLTBMLQ.
FS    D    DISPLAY '0 PGM-AGGI-DISAG ---> ' PGM-AGGI-DISAG.
           MOVE ZEROES                      TO PGM-AGGI-DISAG.
FS    D    DISPLAY '2 PGM-AGGI-DISAG ---> ' PGM-AGGI-DISAG.
      D    DISPLAY '* INSERIMENTO SCARTO IN LIQUIDITA'.
      D    DISPLAY '* VALORE NOMINALE  = ' VALORE-NOMINALE.
      D    DISPLAY '* PREZZO RIMBORSO  = ' TIT-PRZ-RIM.
      D    DISPLAY '* PREZZO EMISSIONE = ' TIT-PRZ-EMS.
MODTP      IF ((VALORE-NOMINALE NOT = ZERO) AND
MODTP       (TIT-PRZ-RIM OF DCLTBTIT > TIT-PRZ-EMS OF DCLTBTIT))
MODTP
MODTP       MOVE TIT-DAT-RIM OF DCLTBTIT TO DATA-RIMBORSO
MODTP       PERFORM AGGI-DISAGGI THRU AGGI-DISAGGI-EXIT
      D     DISPLAY '* AGGI DISAGGI = ' PGM-AGGI-DISAG
MODTP       IF SW-USC-X-BLOCCO = 'SI'
MODTP             GO TO SCRITT-RIMB-TOT-LINEA-EXIT
MODTP       END-IF
MODTP
MODTP       IF PGM-AGGI-DISAG NOT = ZEROES
MODTP            PERFORM INSERIMENTO-SCARTO-IN-LIQ
MODTP            THRU    INSERIMENTO-SCARTO-IN-LIQ-EXIT
MODTP            IF SW-USC-X-BLOCCO = 'SI'
MODTP                     GO TO SCRITT-RIMB-TOT-LINEA-EXIT
MODTP            END-IF
MODTP       END-IF
MODTP      END-IF.
MODTP *
MODTP  SCRITT-RIMB-TOT-LINEA-EXIT.
MODTP      EXIT.
      ****************************************************************
      *       ROUTINE CALCOLO RIMBORSO PARZIALE                      *
      ****************************************************************
       CALCOLO-RIMBORSO-PARZIALE.
      D    DISPLAY 'CALCOLO-RIMBORSO-PARZIALE'.
MODTP * LIQUIDITA' PER GESTORE
270599     MOVE ZEROES                TO VALORE-NOMINALE-GES
270599                                   VALORE-RIMBORSO-GES.
MODTP *14696  PERFORM
MODTP *14696  VARYING PGM-IND1 FROM 1 BY 1 UNTIL PGM-IND1 > 30000
221298*14696  OR TAB-PSA-GES-COD-TIT(PGM-IND1) = SPACES
014696     PERFORM
014696     VARYING PGM-IND1 FROM PGM-IND4 BY 1
014696                                  UNTIL PGM-IND1 > PGM-GES-ELE
014696     OR TAB-PSA-GES-COD-TIT(PGM-IND1) >
014696                             TAB-PSA-COD-TIT(PGM-IND4)
270599D       DISPLAY 'CALCOLO RIMBORSO PARZIALE '
270599D       DISPLAY 'TITOLO ' TAB-PSA-GES-COD-TIT(PGM-IND1)
270599D       DISPLAY 'GESTOR.' TAB-PSA-GES-COD-GES(PGM-IND1)
MODTP      IF TAB-PSA-GES-COD-TIT(PGM-IND1) = TAB-PSA-COD-TIT(PGM-IND4)
016226        IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
016226          COMPUTE VALORE-NOMINALE-GES =
016226                        (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
016226                         TAB-PSA-GES-QTA-DEP(PGM-IND1))
016226
016226        ELSE
MODTP           COMPUTE VALORE-NOMINALE-GES =
MODTP                         (TAB-PSA-GES-QTA-TOT(PGM-IND1) +
MODTP                          TAB-PSA-GES-QTA-DEP(PGM-IND1)) *
MODTP                          TIT-TAS-RIM OF DCLTBTIT / 100
016226        END-IF
MODTP         COMPUTE  VALORE-RIMBORSO-GES =
MODTP                            VALORE-NOMINALE-GES *
MODTP                            TIT-PRZ-RIM OF DCLTBTIT / 100
MODTP         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
MODTP                                        CCC-COD-GES OF DCLTBCCC
MODTP         MOVE COM-CCC-COD-DVS   TO WS-COD-DVS
     *
24417G        IF VALORE-RIMBORSO-GES NOT = ZERO
               MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
               MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
               MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
               MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
070199         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
                                         LGS-COD-GES OF DCLTBLGS
      * ----------------- SELECT SU  TBLGS ----------------------*
      * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
               MOVE 'TBLGSL1'       TO WSN-SKB-COPY
               MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
               MOVE 'TBLGS'         TO WSN-SKB-TABELLA
               MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
014696*        INITIALIZE WS-IMPO-FONDO
               MOVE LGS-COD-GES         TO WS-COD-GESN
014696*        MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
014696*        MOVE LGS-COD-FON         TO WS-COD-FONN
014696*        MOVE LGS-COD-LIN         TO WS-COD-LINN
014696*        PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696         MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
014696*        STRING WS-KEY-SOC-IST   WS-KEY-FONDO
014696         STRING WS-KEY-BANCA
014696                WS-KEY-SOC-IST   WS-KEY-FONDO
                      WS-KEY-LINEA     WS-KEY-GESTORE
               DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

               PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT

               IF ENGIRC-NOTF-ENDFILE
                    MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
                    MOVE 'SELECT'        TO CG-BLOCFON-NOTE
                    MOVE 'CALCOLO RIMBORSO PARZIALE       '
                                      TO CG-BLOCFON-FASE
                    MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
                    MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
                    MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
                    MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
                    MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
                    MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146              MOVE 'GFUWM300' TO WSN-SKB-PGM
                    PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
                    MOVE 'SI' TO SW-USC-X-BLOCCO
                    GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
               END-IF
24417G        END-IF
291099*        IF COM-LGS-FLG-RIM-DVS = 'F'
081199*          MOVE COM-TIT-DIV-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-PNZ
MODTP
291099*          MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*          MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
081199*          MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
081199*          MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR
081199*
081199*          MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199*          MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199*          MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199*          MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199*          MOVE VALORE-RIMBORSO-GES TO CG-CONEUR-IMP-INP
081199*          MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
081199*          MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
081199*          MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
081199*          MOVE 0                   TO CG-CONEUR-TAS-UNO
081199*          MOVE 0                   TO CG-CONEUR-TAS-DUE
081199*          DISPLAY 'TITOLO ' TIT-COD-TIT
081199*          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
081199*          PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT
081199*          IF CG-CONEUR-CODERR NOT = SPACE
081199*                PERFORM X01-BLOCCO-IMEU
081199*                THRU    X01-BLOCCO-IMEU-EXIT
081199*                GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
081199*          END-IF
081199*
081199*      MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO-GES
MODTP
291099*     END-IF
MODTP       END-IF
MODTP       IF VALORE-RIMBORSO-GES NOT = 0
FS             MOVE COM-LGS-FLG-RIM-DVS TO COM-LGS-FLG-DVS
000717         MOVE 'G' TO COM-LIV-CCC

291099         PERFORM CONTO-CORRENTE-LINEA
291099         THRU    CONTO-CORRENTE-LINEA-EXIT
291099         IF SW-USC-X-BLOCCO = 'SI'
MODTP             GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
291099         END-IF
      *
000961*
000961         MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
000961                                       CCC-COD-GES     OF DCLTBCCC
000961         MOVE COM-CCC-COD-DVS     TO  WS-COD-DVS

000961         MOVE LGS-FLG-RIM-DVS     TO  COM-LGS-FLG-DVS
000961         PERFORM CONTO-CORRENTE-GESTORE
000961         THRU    CONTO-CORRENTE-GESTORE-EXIT
000961         MOVE WS-COD-DVS       TO COM-CCC-COD-DVS

000961         IF SW-USC-X-BLOCCO = 'SI'
000961            GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
000961         END-IF
000961*
081199         MOVE COM-TIT-DIV-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-PNZ
081199         MOVE WS-COD-DVS-FLG-DVS-IN   TO CG-CONEUR-FLG-DVS-ARR
081199         MOVE WS-COD-DVS-FLG-LIT      TO CG-CONEUR-FLG-LIT-ARR
081199         MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199         MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199         MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199         MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199         MOVE VALORE-RIMBORSO-GES TO CG-CONEUR-IMP-INP
081199         MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
081199         MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
081199         MOVE 0                   TO CG-CONEUR-TAS-UNO
081199         MOVE 0                   TO CG-CONEUR-TAS-DUE
081199         PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

081199         IF CG-CONEUR-CODERR NOT = SPACE
014146            MOVE 'GFUWM300' TO WSN-SKB-PGM
081199            PERFORM X01-BLOCCO-IMEU
081199            THRU    X01-BLOCCO-IMEU-EXIT
081199            GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
081199         END-IF
081199
081199         MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO-GES
000961*
000961*        MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
000961*                                      CCC-COD-GES     OF DCLTBCCC
000961*        MOVE COM-CCC-COD-DVS     TO  WS-COD-DVS
000961*        MOVE LGS-FLG-RIM-DVS     TO  COM-LGS-FLG-DVS
000961*        PERFORM CONTO-CORRENTE-GESTORE
000961*        THRU    CONTO-CORRENTE-GESTORE-EXIT
000961*        MOVE WS-COD-DVS       TO COM-CCC-COD-DVS
000961*        IF SW-USC-X-BLOCCO = 'SI'
000961*           GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
000961*        END-IF
000961*
008106*        RICHIAMO IL MODULO PER IL CALCOLO DEL PESO
008106         MOVE 'P'   TO  WS-TIPO-OPE
008106         PERFORM CALL-GFUWMC35
008106            THRU CALL-GFUWMC35-EXIT

MODTP          PERFORM SCRITTURA-RIMB-PARZIALE
MODTP          THRU   SCRITTURA-RIMB-PARZIALE-EXIT
MODTP          IF SW-USC-X-BLOCCO = 'SI'
MODTP             GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
MODTP          END-IF
300699*     END-IF
300699*
270599         MOVE ZEROES                TO VALORE-NOMINALE-GES
270599                                       VALORE-RIMBORSO-GES
MODTP *     PERFORM VAL-FLAGS-TBSMO
MODTP *     THRU    VAL-FLAGS-TBSMO-EXIT
300699      END-IF
MODTP      END-PERFORM.
           COMPUTE VALORE-NOMINALE = VALORE-NOMINALE *
                     ((TIT-TAS-RIM OF DCLTBTIT) / 100 ) .
           COMPUTE  VALORE-RIMBORSO = VALORE-NOMINALE *
                               ((TIT-PRZ-RIM OF DCLTBTIT) / 100 ) .

291099*    IF COM-LGS-FLG-RIM-DVS = 'F'
081199*      MOVE COM-TIT-DIV-FLG-DVS-IN    TO CG-CONEUR-FLG-DVS-PNZ

291099*      MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*      MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
291099*      MOVE WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
291099*      MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR

081199*      MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
081199*      MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
081199*      MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
081199*      MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
081199*      MOVE VALORE-RIMBORSO     TO CG-CONEUR-IMP-INP
081199*      MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
291099*      MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*      MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
081199*      MOVE 0                   TO CG-CONEUR-TAS-UNO
081199*      MOVE 0                   TO CG-CONEUR-TAS-DUE
081199*          DISPLAY 'TITOLO ' TIT-COD-TIT
081199*          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
081199*      PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT
081199*      IF CG-CONEUR-CODERR NOT = SPACE
081199*        PERFORM X01-BLOCCO-IMEU
081199*        THRU    X01-BLOCCO-IMEU-EXIT
081199*        GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
081199*      END-IF
081199*
081199*      MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO.
MODTP *      MOVE CG-CONEUR-TAS-EUR-DVS TO WS-CAMBIO

291099*    END-IF.
MODTP      IF VALORE-RIMBORSO NOT = 0

FS            MOVE COM-LGS-FLG-RIM-DVS TO COM-LGS-FLG-DVS
007521        IF LGS-FLG-CCC = 'S'
000717           MOVE 'L' TO COM-LIV-CCC
291099           PERFORM CONTO-CORRENTE-LINEA
291099           THRU    CONTO-CORRENTE-LINEA-EXIT
291099           IF SW-USC-X-BLOCCO = 'SI'
MODTP               GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
291099           END-IF
007521        END-IF
******************************
              MOVE COM-TIT-DIV-FLG-DVS-IN    TO CG-CONEUR-FLG-DVS-PNZ

291099*       MOVE  COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
291099*       MOVE  COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
291099        MOVE  WS-COD-DVS-FLG-DVS-IN  TO CG-CONEUR-FLG-DVS-ARR
291099        MOVE  WS-COD-DVS-FLG-LIT     TO CG-CONEUR-FLG-LIT-ARR

              MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST
              MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST
              MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON
              MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM
              MOVE VALORE-RIMBORSO     TO CG-CONEUR-IMP-INP
              MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ
291099        MOVE WS-COD-DVS          TO CG-CONEUR-COD-DVS-ARR
291099*       MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR
              MOVE 0                   TO CG-CONEUR-TAS-UNO
              MOVE 0                   TO CG-CONEUR-TAS-DUE
      D       DISPLAY 'TITOLO ' TIT-COD-TIT
      D       DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT


              PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

              IF CG-CONEUR-CODERR NOT = SPACE
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
                 PERFORM X01-BLOCCO-IMEU
                 THRU    X01-BLOCCO-IMEU-EXIT
                 GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
              END-IF

              MOVE CG-CONEUR-IMP-OUT TO VALORE-RIMBORSO
******************************
MODTP         PERFORM SCRITT-RIMB-PARZ-LINEA
MODTP         THRU   SCRITT-RIMB-PARZ-LINEA-EXIT
MODTP         IF SW-USC-X-BLOCCO = 'SI'
MODTP            GO TO CALCOLO-RIMBORSO-PARZIALE-EXIT
MODTP         END-IF
MODTP      END-IF.
      *
       CALCOLO-RIMBORSO-PARZIALE-EXIT.
           EXIT .
      ***************************************************************
      *          ROUTINE VALORIZZAZIONE MOVIMENTI                   *
      ***************************************************************
       VALORIZZAZIONE-MOVIMENTI.
      *
      D    DISPLAY 'VALORIZZAZIONE-MOVIMENTI'.
           MOVE S-ELA-COD-IST      TO S-SMO0-COD-IST OF REC-SMO0.
           MOVE S-ELA-COD-SOC-IST  TO S-SMO0-COD-SOC-IST OF REC-SMO0.
           MOVE S-ELA-COD-FON      TO S-SMO0-COD-FON OF REC-SMO0.
           MOVE S-ELA-COD-LIN      TO S-SMO0-COD-LIN OF REC-SMO0.
MODTP *    MOVE PSA-COD-GES OF DCLTBPSA TO S-SMO0-COD-GES OF REC-SMO0.
MODTP      MOVE TAB-PSA-GES-COD-GES (PGM-IND1)
MODTP                                  TO S-SMO0-COD-GES OF REC-SMO0.
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                        TO S-SMO0-COD-TIT OF REC-SMO0.
           MOVE WS-PRG-MOV              TO S-SMO0-PRG-MOV OF REC-SMO0.
           MOVE CCC-COD-CTP OF DCLTBCCC TO S-SMO0-COD-CTP OF REC-SMO0.
           MOVE WS-DATA-VLT             TO S-SMO0-VLT     OF REC-SMO0.
           MOVE 'V'                     TO S-SMO0-TIP-MOV OF REC-SMO0.
           MOVE 'R'                     TO S-SMO0-STI-MOV OF REC-SMO0.
MODTP *    MOVE VALORE-NOMINALE         TO S-SMO0-IMP-TOT OF REC-SMO0.
MODTP      MOVE VALORE-RIMBORSO-GES     TO S-SMO0-IMP-TOT OF REC-SMO0.
008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106        COMPUTE S-SMO0-IMP-TOT = S-SMO0-IMP-TOT * MC35-PESO
008106     END-IF.
           MOVE S-ELA-DAT-LAZ           TO S-SMO0-DAT-OPE OF REC-SMO0.
           MOVE WS-COD-DVS              TO S-SMO0-COD-DVS-REG
                                                          OF REC-SMO0.
012740     MOVE WS-COD-DVS    TO S-SMO0-COD-DVS-MOV
           MOVE 'N'                     TO S-SMO0-FLG-COL OF REC-SMO0.
MODTP *    MOVE WS-COM-IMP1             TO S-SMO0-IMP-RAT OF REC-SMO0.
MODTP      MOVE ZEROES                  TO S-SMO0-IMP-RAT OF REC-SMO0.
MODTP *    MOVE PSA-QTA-TOT OF DCLTBPSA TO S-SMO0-SLD-ATT OF REC-SMO0.
MODTP      MOVE TAB-PSA-GES-QTA-TOT (PGM-IND1)
MODTP                                   TO S-SMO0-SLD-ATT OF REC-SMO0.
MODTP      MOVE VALORE-NOMINALE-GES
MODTP                               TO S-SMO0-QTA-VAL-NMN OF REC-SMO0.
           MOVE 0                   TO S-SMO0-SLD-MAG     OF REC-SMO0
221099                                 S-SMO0-PRM         OF REC-SMO0
221099                                 S-SMO0-COD-PAE-NGZ OF REC-SMO0.
           MOVE CG-LETCAM-CAM           TO S-SMO0-CAM     OF REC-SMO0.
           MOVE 'T'                     TO S-SMO0-FLG-TIT-CTT
                                                          OF REC-SMO0.
000870     MOVE SPACE                   TO S-SMO0-NON-COP
000870                                                    OF REC-SMO0.
000870     MOVE TIT-COD-MER             TO S-SMO0-COD-MER
000870                                                    OF REC-SMO0.

009120*----------------------------------------------------------------*
009120* IN CASO DI RIMBORSO PARZIALE, IL PAESE DEL MOVIMENTO DI COMPRA-*
009120* VENDITA CHE DECURTA LA POSIZIONE CON LA QUANTITA' RIMBORSATA,  *
009120* DEV'ESSERE VALORIZZATO CON QUELLO DEL MOVIMENTO PIU' RECENTE   *
009120*----------------------------------------------------------------*
009120* PREPARAZIONE DELLA CHIAVE PER EVENTUALE ERRORE BLOCCANTE
009120     MOVE S-ELA-COD-IST                TO SMO-COD-IST.
009120     MOVE S-ELA-COD-SOC-IST            TO SMO-COD-SOC-IST.
009120     MOVE S-ELA-COD-FON                TO SMO-COD-FON.
009120     MOVE S-ELA-COD-LIN                TO SMO-COD-LIN.
009120     MOVE TAB-PSA-COD-TIT (PGM-IND4)   TO SMO-COD-TIT.
009120     MOVE DATA-RIMBORSO                TO SMO-VLT.
009120     MOVE 'T'                          TO SMO-FLG-TIT-CTT.
018541*18605MOVE TAB-PSA-GES-QTA-TOT (PGM-IND1) TO SMO-COD-GES
018605     MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO SMO-COD-GES
009120     MOVE ZEROES    TO WS-S-SMO0-COD-PAE-NGZ.
009120
009120D    DISPLAY 'SMO-COD-IST     ' SMO-COD-IST.
009120D    DISPLAY 'SMO-COD-SOC-IST ' SMO-COD-SOC-IST.
009120D    DISPLAY 'SMO-COD-FON     ' SMO-COD-FON.
009120D    DISPLAY 'SMO-COD-LIN     ' SMO-COD-LIN.
009120D    DISPLAY 'SMO-COD-GES     ' SMO-COD-GES.
009120D    DISPLAY 'SMO-COD-TIT     ' SMO-COD-TIT.
009120D    DISPLAY 'SMO-FLG-TIT-CTT ' SMO-FLG-TIT-CTT.
009120D    DISPLAY 'SMO-VLT         ' SMO-VLT.
009120D    DISPLAY 'CED-DAT-SCD     ' CED-DAT-SCD.
009120
009120*14696INITIALIZE WS-IMPO-FONDO.
009120     MOVE 'GFSMOACD'             TO WSN-SKB-COPY.
009120     MOVE 'Y05-OPEN-CURD-TBSMO'  TO WSN-SKB-LABEL.
009120     MOVE 'OPEN CURSOR'          TO WSN-SKB-FUNZIONE.
009120     MOVE 'TBSMO'                TO WSN-SKB-TABELLA.
009120*14696MOVE  SMO-COD-IST           TO WS-COD-ISTX.
009120*14696MOVE  SMO-COD-SOC-IST       TO WS-COD-SOC-ISTN.
009120*14696MOVE  SMO-COD-FON           TO WS-COD-FONN.
009120*14696MOVE  SMO-COD-LIN           TO WS-COD-LINN.
009120     MOVE  SMO-COD-GES           TO WS-COD-GESN.
009120     MOVE  SMO-COD-TIT           TO WS-COD-TITX.
009120*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES                 TO WSN-SKB-CHIAVE-DATI.
009120     STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
009120            WS-KEY-LINEA  WS-KEY-GESTORE  WS-KEY-TITOLO
009120     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.
009120
009120     PERFORM Y05-OPEN-CURD-TBSMO THRU Y05-OPEN-CURD-TBSMO-EXIT.
009120
009120     MOVE 'Y06-FETCH-CURD-TBSMO'  TO WSN-SKB-LABEL.
009120     MOVE 'FETCH CURSOR'          TO WSN-SKB-FUNZIONE.
009120
009120     PERFORM Y06-FETCH-CURD-TBSMO THRU Y06-FETCH-CURD-TBSMO-EXIT.
009120
009120     PERFORM UNTIL ( ENGIRC-NOTF-ENDFILE )
009120       MOVE SMO-COD-PAE-NGZ      TO WS-S-SMO0-COD-PAE-NGZ
009120       PERFORM Y06-FETCH-CURD-TBSMO THRU Y06-FETCH-CURD-TBSMO-EXIT
009120     END-PERFORM.
009120
009120     MOVE 'Y06-CLOSE-CURD-TBSMO'  TO WSN-SKB-LABEL.
009120     MOVE 'CLOSE CURSOR'          TO WSN-SKB-FUNZIONE.
009120
009120     PERFORM Y07-CLOSE-CURD-TBSMO THRU Y07-CLOSE-CURD-TBSMO-EXIT.
009120
009120* VALORIZZAZIONE DEL CAMPO CONTENENTE LA DESCRIZIONE DEL PAESE
009120     MOVE WS-S-SMO0-COD-PAE-NGZ TO S-SMO0-COD-PAE-NGZ OF REC-SMO0.
21575G     MOVE SPACES                TO S-SMO0-COD-FIS-IDE.
21575G     MOVE ZEROES                TO S-SMO0-COD-PAE.
      *
       VALORIZZAZIONE-MOVIMENTI-EXIT.
           EXIT.
      **************************************************************
      *          ROUTINE   CALCOLO AGGI DISAGGI                    *
      *************************************************************
       AGGI-DISAGGI.
      *
      D    DISPLAY 'AGGI DISAGGI' DATA-RIMBORSO.

050399     MOVE DATA-RIMBORSO        TO DATA-RIMBO.
050399     PERFORM VERIFICA-ESEN-TITOLO THRU VERIFICA-ESEN-TITOLO-EXIT.
050399*    IF WS-ESENTE-1 = ZERO
140499*    IF WS-ESENTE-1 = ZERO

050399            PERFORM GEST-CALCOLO
050399            THRU    GEST-CALCOLO-EXIT.
140499*    END-IF.
      *
       AGGI-DISAGGI-EXIT.
           EXIT.
      *************************************************************
      *           ROUTINE GEST-CALCOLO                            *
      *************************************************************
       GEST-CALCOLO.
      *
      D     DISPLAY 'GEST-CALCOLO '.
007518     MOVE ZERO TO PGM-IND-CA.
050399*    PERFORM STAMPA-SCARTO-S3000
050399*    THRU    STAMPA-SCARTO-S3000-EXIT.
050399     PERFORM U-ST21-GEST-DETTAGLIO-1
050399     THRU    U-ST21-GEST-DETTAGLIO-1-EXIT.

           MOVE S-ELA-COD-IST     TO SMO-COD-IST     OF DCLTBSMO.
           MOVE S-ELA-COD-SOC-IST TO SMO-COD-SOC-IST OF DCLTBSMO.
           MOVE S-ELA-COD-FON     TO SMO-COD-FON     OF DCLTBSMO.
           MOVE S-ELA-COD-LIN     TO SMO-COD-LIN     OF DCLTBSMO.
           MOVE TAB-PSA-COD-TIT (PGM-IND4)
                                  TO SMO-COD-TIT      OF DCLTBSMO.
           MOVE DATA-RIMBORSO     TO SMO-VLT          OF DCLTBSMO.
200100     MOVE 'T'               TO SMO-FLG-TIT-CTT  OF DCLTBSMO.
      *     APR0 IL CURSORE SU TBSMO
      * *   IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
            MOVE ' TBSMOOC1 '            TO WSN-SKB-COPY.
            MOVE ' Y05-OPEN-CUR1-TBSMO ' TO WSN-SKB-LABEL.
            MOVE ' TBSMO '               TO WSN-SKB-TABELLA.
            MOVE ' OPEN CURSOR '         TO WSN-SKB-FUNZIONE.
014696*     INITIALIZE WS-IMPO-FONDO.
014696*     MOVE  SMO-COD-IST            TO WS-COD-ISTX.
014696*     MOVE  SMO-COD-SOC-IST        TO WS-COD-SOC-ISTN.
014696*     MOVE  SMO-COD-FON            TO WS-COD-FONN.
014696*     MOVE  SMO-COD-LIN            TO WS-COD-LINN.
            MOVE  SMO-COD-GES            TO WS-COD-GESN.
            MOVE  SMO-COD-TIT            TO WS-COD-TITX.
014696*     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
            MOVE SPACES                  TO WSN-SKB-CHIAVE-DATI.
            STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
            WS-KEY-LINEA  WS-KEY-GESTORE WS-KEY-TITOLO
            DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

            PERFORM Y05-OPEN-CUR1-TBSMO
            THRU    Y05-OPEN-CUR1-TBSMO-EXIT.

      *    IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
            MOVE 'TBSMOFC1'              TO WSN-SKB-COPY.
            MOVE 'Y06-FETCH-CUR1-TBSMO ' TO WSN-SKB-LABEL.
            MOVE 'TBSMO'                 TO WSN-SKB-TABELLA.
            MOVE 'FETCH CURSOR '         TO WSN-SKB-FUNZIONE.
014696*     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*     STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA  WS-KEY-GESTORE WS-KEY-TITOLO
014696*     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

            PERFORM Y06-FETCH-CUR1-TBSMO
            THRU    Y06-FETCH-CUR1-TBSMO-EXIT.


      *     SE NON HA TROVATO CLOSE CUR E BLOCCO IL CICLO

            IF ENGIRC-NOTF-ENDFILE
              MOVE ' TBSMOCL1 '             TO WSN-SKB-COPY
              MOVE ' Y07-CLOSE-CUR1-TBSMO ' TO WSN-SKB-LABEL
              MOVE ' TBSMO '                TO WSN-SKB-TABELLA
              MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE
014696*       PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696*       STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
014696*       WS-KEY-LINEA  WS-KEY-GESTORE WS-KEY-TITOLO
014696*       DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI

              PERFORM Y07-CLOSE-CUR1-TBSMO
              THRU    Y07-CLOSE-CUR1-TBSMO-EXIT
              GO TO GEST-CALCOLO-EXIT

            END-IF.

050399      ADD 1 TO NUM-RIG-STM-1.
            MOVE SPACES       TO RIGA-ST1-132.
            MOVE INT1-1       TO RIGA-ST1-132.
            MOVE WK-TXT-STM-1 TO TXT-ST1.
            WRITE TABULATO-1 AFTER 2.
050399      SUBTRACT 2 FROM CTR-RIGHE-1.
      *
      D     DISPLAY ' ELABORA-MOV-AGGI'.
            PERFORM ELABORA-MOV-AGGI
            THRU    ELABORA-MOV-AGGI-EXIT
            UNTIL ENGIRC-NOTF-ENDFILE.

      *     IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
            MOVE ' TBSMOCL1 '             TO WSN-SKB-COPY .
            MOVE ' Y07-CLOSE-CUR1-TBSMO ' TO WSN-SKB-LABEL.
            MOVE ' TBSMO '                TO WSN-SKB-TABELLA.
            MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE.
014696*     PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*     STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
014696*     WS-KEY-LINEA  WS-KEY-GESTORE WS-KEY-TITOLO
014696*     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

            PERFORM Y07-CLOSE-CUR1-TBSMO
            THRU    Y07-CLOSE-CUR1-TBSMO-EXIT.

050399*     MOVE TAB-PSA-QTA-TOT(PGM-IND4) TO  WS-QTA-TOT-PTF.
291099*002040IF FND-TIP-FON = 'P'
001053*002040AND WS-DAT-LAZ-8 < 20010101
002040*10122IF (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 < 20010101) OR
010122      IF (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 < 20010101)
002040*10122   (FND-TIP-FON = 'C' AND FND-FLG-FND-IMM = 'S')
               PERFORM U-GF03-RIGA-TOTALI
               THRU    U-GF03-RIGA-TOTALI-EXIT
291099      END-IF.
      *
       GEST-CALCOLO-EXIT.
           EXIT.
      *************************************************************
      *     ROUTINE ELABORA MOV-AGGI                              *
      *************************************************************
       ELABORA-MOV-AGGI.
      *
101298     IF SMO-STI-MOV NOT = ('T' AND 'P')
101298         PERFORM U-A19-TRATTA-MOV
101298         THRU    U-A19-TRATTA-MOV
101298     END-IF.
      *    IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696*      MOVE 'TBSMOFC1'              TO WSN-SKB-COPY.
014696*      MOVE 'Y06-FETCH-CUR1-TBSMO ' TO WSN-SKB-LABEL.
014696*      MOVE 'TBSMO'                 TO WSN-SKB-TABELLA.
014696*      MOVE 'FETCH CURSOR '         TO WSN-SKB-FUNZIONE.
014696*      PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696*      STRING WS-KEY-BANCA  WS-KEY-SOC-IST  WS-KEY-FONDO
014696*      WS-KEY-LINEA  WS-KEY-GESTORE WS-KEY-TITOLO
014696*      DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

             PERFORM Y06-FETCH-CUR1-TBSMO
             THRU    Y06-FETCH-CUR1-TBSMO-EXIT.
      *
       ELABORA-MOV-AGGI-EXIT.
           EXIT.
      *
101298 U-A19-TRATTA-MOV.
      *
           MOVE S-ELA-DAT-LAZ (1: 2)           TO WS-DAT-COM3 (7: 2).
           MOVE S-ELA-DAT-LAZ (4: 2)           TO WS-DAT-COM3 (5: 2).
           MOVE S-ELA-DAT-LAZ (7: 4)           TO WS-DAT-COM3 (1: 4).
           MOVE TIT-DAT-REC OF DCLTBTIT (1: 2) TO WS-DAT-COM4 (7: 2).
           MOVE TIT-DAT-REC OF DCLTBTIT (4: 2) TO WS-DAT-COM4 (5: 2).
           MOVE TIT-DAT-REC OF DCLTBTIT (7: 4) TO WS-DAT-COM4 (1: 4).
291298     MOVE SMO-VLT OF DCLTBSMO (1:2) TO WS-DAT-COM (7:2).
291298     MOVE SMO-VLT OF DCLTBSMO (4:2) TO WS-DAT-COM (5:2).
291298     MOVE SMO-VLT OF DCLTBSMO (7:4) TO WS-DAT-COM (1:4).

           PERFORM U-GF07-DISCIP-TRANSIT
           THRU    U-GF07-DISCIP-TRANSIT-EXIT.

050399     PERFORM U-ST61-GEST-INTERESSI-1
050399     THRU    U-ST61-GEST-INTERESSI-1-EXIT.
      *
       U-A19-TRATTA-MOV-EXIT.
           EXIT.
      *
      ************************************************************
      *    ROUTINE PRIORITA' DI STAMPA S3001                     *
      *************************************************************
       PRIORITA-S3001.
      *
           MOVE S-ELA-COD-IST         TO CG-LETSTM-COD-IST .
           MOVE 'GFUS3001'            TO CG-LETSTM-COD-STM.
           PERFORM X01-LETT-STMS THRU X01-LETT-STMS-EXIT.
050399     MOVE TXT-STM               TO WK-TXT-STM-0.
           MOVE STM-DSC OF DCLTBSTM   TO WK-STM-DSC-0.
      *
       PRIORITA-S3001-EXIT.
           EXIT.
      ************************************************************
      *    ROUTINE PRIORITA' DI STAMPA S3000                     *
      *************************************************************
       PRIORITA-S3000.
      *
           MOVE S-ELA-COD-IST         TO CG-LETSTM-COD-IST .
           MOVE 'GFUS3000'            TO CG-LETSTM-COD-STM.
           PERFORM X01-LETT-STMS THRU X01-LETT-STMS-EXIT.
050399     MOVE TXT-STM               TO WK-TXT-STM-1.
           MOVE STM-DSC OF DCLTBSTM   TO WK-STM-DSC-1.
      *
       PRIORITA-S3000-EXIT.
           EXIT.
21720G************************************************************
21720G*    ROUTINE PRIORITA' DI STAMPA S3003                     *
21720G*************************************************************
21720G PRIORITA-S3003.
21720GD     DISPLAY 'PRIORITA-S3003'.
21720G*
21720G     MOVE S-ELA-COD-IST         TO CG-LETSTM-COD-IST .
21720G     MOVE 'GFUS3003'            TO CG-LETSTM-COD-STM.
21720G     PERFORM X01-LETT-STMS THRU X01-LETT-STMS-EXIT.
21720G     MOVE TXT-STM               TO WK-TXT-STM3.
21720G     MOVE STM-DSC OF DCLTBSTM   TO WK-STM-DSC-3.
21720G*
21720G PRIORITA-S3003-EXIT.
21720G     EXIT.
050399************************************************************
050399* INTESTAZIONE DEL FILE S3000 DA STAMPARE PER OGNI ROTTURA*
050399* TITOLO
050399* ELIMINARE (U-ST40-DETTAGLIO-0)
050399****************************************************************
050399*INTESTAZIONE-S3001.

050399**************************************************************
      * STAMPA DEL DETTAGLIO DEL TABULATO S3000:CALCOLO IMPOSTA    *
      * PER RITENUTA SU STACCO CEDOLA                              *
      **************************************************************
      * VEDI U-ST70-INTERESSI-0
      **************************************************************
      *DETTAGLIO-S3001.
      *DETTAGLIO-S3001-EXIT.
      *    EXIT .

      ***************************************************************
      * RATEO2 PER WS-COD-CAU = 'RFT'                               *
      * DETTAGLIO DEL TABULATO S3001 RIFERITO AL RATEO
      ***************************************************************
       STAMPA-RATEO-S3001.
      D     DISPLAY 'STAMPA-RATEO-S3001'.

050399*     VEDI COSA BISOGNA FARE PER RICHIAMARE AL POSTO
      *     U-ST80-TOTALE-INTERESSI-0

050399*    IF CTR-RIGHE-1 < 4
050399*
050399*       MOVE RIGO-FINALE        TO RIGA-ST1-132
050399*       ADD 1                   TO NUM-RIG-STM-1
050399*       MOVE WK-TXT-STM-1        TO TXT-ST1
050399*       WRITE TABULATO-1       AFTER 1
050399*
050399*       PERFORM STAMPA-TESTATA-S3001
050399*       PERFORM STAMPA-TESTATA-S3001-EXIT
050399*
050399*       PERFORM INTESTAZIONE-S3001
050399*       THRU INTESTAZIONE-S3001-EXIT
050399*
050399*    END-IF.

050399*    PERFORM U-ST20-GEST-DETTAGLIO-0
050399*    THRU    U-ST20-GEST-DETTAGLIO-0-EXIT.

           MOVE COM-TIT-DIV-FLG-DVS-IN       TO CG-CONEUR-FLG-DVS-PNZ.

FS    *    MOVE COM-FND-DIV-IPS-FLG-DVS-IN   TO CG-CONEUR-FLG-DVS-ARR
FS    *                                         COM-FLG-DVS-IN.
FS    *    MOVE COM-FND-DIV-IPS-FLG-LIT      TO CG-CONEUR-FLG-LIT-ARR
FS    *                                         COM-FLG-LIT.
FS         MOVE COM-FND-DIV-FLG-DVS-IN       TO CG-CONEUR-FLG-DVS-ARR.
FS         MOVE COM-FND-DIV-FLG-LIT          TO CG-CONEUR-FLG-LIT-ARR.
FS         MOVE COM-FND-DIV-IPS-FLG-DVS-IN   TO COM-FLG-DVS-IN.
FS         MOVE COM-FND-DIV-IPS-FLG-LIT      TO COM-FLG-LIT.
FS    *    MOVE FND-COD-DVS-IPS              TO COM-COD-DVS.

           MOVE S-ELA-COD-IST       TO CG-CONEUR-COD-IST.
           MOVE S-ELA-COD-SOC-IST   TO CG-CONEUR-COD-SOC-IST .
           MOVE S-ELA-COD-FON       TO CG-CONEUR-COD-FON .
           MOVE S-ELA-DAT-LAZ       TO CG-CONEUR-DAT-RIL-CAM .
           MOVE WS-IMP-CED-EST      TO CG-CONEUR-IMP-INP.
000512D    DISPLAY 'IMP. RATEO DA CONV. IN DIV. TITOLO' WS-IMP-CED-EST.
           MOVE TIT-COD-DVS         TO CG-CONEUR-COD-DVS-PNZ .
FS    *    MOVE FND-COD-DVS-IPS     TO CG-CONEUR-COD-DVS-ARR .
FS         MOVE FND-COD-DVS         TO CG-CONEUR-COD-DVS-ARR .
           MOVE 0                   TO CG-CONEUR-TAS-UNO .
           MOVE 0                   TO CG-CONEUR-TAS-DUE .
      D          DISPLAY 'TITOLO ' TIT-COD-TIT
      D          DISPLAY 'AREA CAMBI ' CG-CONEUR-INPUT
           PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.

           IF CG-CONEUR-CODERR NOT = SPACE
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
               PERFORM X01-BLOCCO-IMEU
               THRU    X01-BLOCCO-IMEU-EXIT
               GO TO STAMPA-RATEO-S3001-EXIT
           END-IF.
           MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST.
000512D    DISPLAY 'IMP. RATEO CONV.TO IN DIVISA FONDO' WS-IMP-CED-EST.
000512D    DISPLAY 'PGM-RIT-FIS                       ' PGM-RIT-FIS.
FS    *    CALCOLA RITENUTA IN DIVISA FONDO
FS         MOVE COM-FND-DIV-IPS-FLG-DVS-IN   TO CG-CONEUR-FLG-DVS-PNZ.
FS         MOVE COM-FND-DIV-FLG-DVS-IN       TO CG-CONEUR-FLG-DVS-ARR.
FS         MOVE COM-FND-DIV-FLG-LIT          TO CG-CONEUR-FLG-LIT-ARR.
FS         MOVE PGM-RIT-FIS                  TO CG-CONEUR-IMP-INP.
FS         MOVE FND-COD-DVS-IPS              TO CG-CONEUR-COD-DVS-PNZ .
FS         MOVE FND-COD-DVS                  TO CG-CONEUR-COD-DVS-ARR .
FS         PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT.

FS         IF CG-CONEUR-CODERR NOT = SPACE
014146         MOVE 'GFUWM300' TO WSN-SKB-PGM
FS             PERFORM X01-BLOCCO-IMEU
FS             THRU    X01-BLOCCO-IMEU-EXIT
FS             GO TO STAMPA-RATEO-S3001-EXIT
FS         END-IF.
FS    *6390MOVE CG-CONEUR-IMP-OUT TO WST-RIT-FIS.

           ADD 1                         TO NUM-RIG-STM-0.
           MOVE  SPACE                   TO RIGA-ST0-132.
002040*10122IF FND-FLG-FND-IMM = 'S'
002040*10122  MOVE TIT-RIT-FIS-PRE       TO WST-IMP OF INT2-0
002040*10122ELSE
000540        IF FND-TIP-FON = 'C'
001053          OR (FND-TIP-FON = 'P' AND WS-DAT-LAZ-8 > 20003112)
000540           MOVE TIT-RIT-FIS-POS       TO WST-IMP OF INT2-0
000540        ELSE
                 MOVE TIT-TAS-RIT-FIS       TO WST-IMP  OF INT2-0
002040        END-IF
000540*10122END-IF.
"          MOVE INT2-0                   TO RIGA-ST0-132.
           MOVE WK-TXT-STM-0             TO TXT-ST0.
           WRITE TABULATO-0              AFTER 1.

000512D    DISPLAY 'PGM-RIT-FIS    CONV:' CG-CONEUR-IMP-OUT.
RIGA2      MOVE  SPACE             TO RIGA-ST0-132.
006390     IF WS-ABIL-PERS-91 = 'N' OR
006390       (WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'N')
006390        MOVE CG-CONEUR-IMP-OUT TO WST-RIT-FIS
006390     ELSE
006390        MOVE SPACES          TO WST-RIT-FIS-X
006390     END-IF.
      D    DISPLAY ' RIDUCO LA RITENUTA '
008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE = 0
008106        COMPUTE WS-RIT-FIS-P ROUNDED =
008559                 CG-CONEUR-IMP-OUT *  MC35-PESO
008106*8559            CG-CONEUR-IMP-OUT/ MC35-PESO
008106D        DISPLAY 'WS-RIT-FIS-P ' WS-RIT-FIS-P
008106         MOVE WS-RIT-FIS-P   TO WST-RIT-FIS
008106     END-IF.
050399     MOVE VALORE-NOMINALE    TO WST-NOM-TRA.
           MOVE WS-IMPORTO-CEDOLA  TO WST-QTA-TOT.
           MOVE WS-TOT-DEDUC       TO WST-TOT-DED.
           MOVE WK-IMP-CED-EST     TO WST-COM-IMP1.
           MOVE CG-CONEUR-TAS-EUR-DVS TO WST-CAM.
           MOVE WS-IMP-CED-EST        TO WST-IMPONIB.
FS    *    MOVE PGM-RIT-FIS           TO WST-RIT-FIS.
"          MOVE RIGA3-0               TO RIGA-ST0-132.
           ADD 1                         TO NUM-RIG-STM-0.
           MOVE WK-TXT-STM-0             TO TXT-ST0.
           WRITE TABULATO-0.

006390*-- SE E' PRESENTE L'ABIL. 91 E SE HA TROVATO UN RECORD SULLA
006390*-- TBFPI STAMPA UN'ALTRA RIGA DI DETTAGLIO CON I VALORI CORRETTI
006390*-- DAL POOL-INFLACTION FACTOR
006390     IF WS-ABIL-PERS-91 = 'S' AND WS-TROVA-FPI = 'S'
006390        MOVE  SPACE             TO RIGA-ST0-132

006390        COMPUTE WS-IMPORTO-CEDOLA =
006390                               WS-IMPORTO-CEDOLA * WS-P-I-FACTOR
006390        COMPUTE WS-RIT-FIS     =  WS-RIT-FIS     * WS-P-I-FACTOR
006390        COMPUTE WS-TOT-DEDUC   =  WS-TOT-DEDUC   * WS-P-I-FACTOR
006390        COMPUTE WK-IMP-CED-EST =  WK-IMP-CED-EST * WS-P-I-FACTOR
006390        COMPUTE WS-IMP-CED-EST =  WS-IMP-CED-EST * WS-P-I-FACTOR

006390        MOVE WS-P-I-FACTOR         TO WST-P-I-FACTOR
006390        MOVE WS-IMPORTO-CEDOLA     TO WST-QTA-TOT-F
006390        MOVE WS-TOT-DEDUC          TO WST-TOT-DED-F
006390        MOVE WK-IMP-CED-EST        TO WST-COM-IMP1-F
006390        MOVE CG-CONEUR-TAS-EUR-DVS TO WST-CAM-F
006390        MOVE WS-IMP-CED-EST        TO WST-IMPONIB-F
006390        MOVE CG-CONEUR-IMP-OUT     TO WST-RIT-FIS-F

006390        MOVE RIGA3-0-F          TO RIGA-ST0-132
006390        ADD 1                   TO NUM-RIG-STM-0
006390        MOVE WK-TXT-STM-0       TO TXT-ST0
006390        WRITE TABULATO-0
008106        MOVE 'S'                TO WS-FLG-PRIMA-TST-0
006390     END-IF.

008106*-- SE E' PRESENTE L'ABIL.105 ED ESISTE UN PIAN DI RIMBORSO
008106*-- STAMPA  UN'ALTRA RIGA DI DETTAGLIO CON I VALORI CORRETTI
008106*-- DAL FATTORE DI RIDUZIONE
008106*8730IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730     IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106*       STAMPO LA RIGA NOTA
008106        MOVE  SPACE             TO RIGA-ST0-132
008106        MOVE  MC35-PESO         TO WST-PESO
008106        MOVE  RIGA-NOTA-P       TO RIGA-ST0-132
008106        ADD 1                   TO NUM-RIG-STM-0
008106        MOVE WK-TXT-STM-0       TO TXT-ST0
008106        WRITE TABULATO-0

008106*       STAMPO LA RIGA DI DETTAGLIO
008106        MOVE  SPACE             TO RIGA-ST0-132
008106        COMPUTE VALORE-NOMINALE  =
008106                        VALORE-NOMINALE * MC35-PESO
008106        COMPUTE WS-IMPORTO-CEDOLA =
008106                               WS-IMPORTO-CEDOLA * MC35-PESO
008106        COMPUTE WS-TOT-DEDUC   =  WS-TOT-DEDUC   * MC35-PESO
008106        COMPUTE WK-IMP-CED-EST =  WK-IMP-CED-EST * MC35-PESO
008106        COMPUTE WS-IMP-CED-EST =  WS-IMP-CED-EST * MC35-PESO
008106        COMPUTE WS-RIT-FIS     =  WS-RIT-FIS * MC35-PESO

008106        MOVE VALORE-NOMINALE        TO WST-NOM-TRA-P
008106        MOVE WS-IMPORTO-CEDOLA      TO WST-QTA-TOT-P
008106        MOVE WS-TOT-DEDUC           TO WST-TOT-DED-P
008106        MOVE WK-IMP-CED-EST         TO WST-COM-IMP1-P
008106        MOVE WS-IMP-CED-EST         TO WST-IMPONIB-P
008106        MOVE CG-CONEUR-IMP-OUT      TO WST-RIT-FIS-P
008106        MOVE CG-CONEUR-TAS-EUR-DVS  TO WST-CAM-P


008106        MOVE RIGA3-0-P          TO RIGA-ST0-132
008106        ADD 1                   TO NUM-RIG-STM-0
008106        MOVE WK-TXT-STM-0       TO TXT-ST0
008106        WRITE TABULATO-0
008106     END-IF.

000512* TOTALIZZA IMPORTO CEDOLA SU TOTALIZZATORE RATEO (STACCO CEDOLA)
000512D    DISPLAY 'IMPORTO CEDOLA IN DVS FONDO ' WS-IMP-CED-EST.
      D    DISPLAY 'ALIQUOTA RITENUTA FISCALE ' WST-IMP OF INT2-0.
      D    DISPLAY 'FLAG ESENTE 0 ' WS-ESENTE-0.
000690*FS1606    IF WST-IMP OF INT2-0 NOT= ZEROES  OR
FS1606*002040IF (FND-TIP-FON = 'C' AND TIT-RIT-FIS-POS > 0) OR
002040*10122IF (FND-TIP-FON = 'C' AND TIT-RIT-FIS-POS > 0  AND
010122     IF (FND-TIP-FON = 'C' AND TIT-RIT-FIS-POS > 0) OR
002040*10122   FND-FLG-FND-IMM NOT = 'S')                     OR
002040*10122  (FND-TIP-FON = 'C' AND TIT-RIT-FIS-PRE > 0  AND
002040*10122   FND-FLG-FND-IMM = 'S')                         OR

FS1606*002248 (FND-TIP-FON = 'P' AND TIT-TAS-RIT-FIS > 0)     OR
002248        (FND-TIP-FON = 'P' AND TIT-TAS-RIT-FIS > 0 AND
002248         WS-DAT-LAZ-8 < 20010101)                       OR
001053        (FND-TIP-FON = 'P' AND TIT-RIT-FIS-POS > 0 AND
001053         WS-DAT-LAZ-8 > 20001231)     OR
000714        WS-ESENTE-0 > 0

000512        ADD WS-IMP-CED-EST    TO PGM-RATEO-IMP-TOT
002214*************************************************************
002214*** SCRITTURA DEI RECORD 1 SUL FLUSSO SDME ******************
002214*************************************************************
002214           IF WS-IMP-CED-EST NOT = ZERO
002214              PERFORM SDME-RECORD-TIPO-1
002214                 THRU SDME-RECORD-TIPO-1-EXIT
002214           END-IF
002214*************************************************************
000690     END-IF.
000512D    DISPLAY 'PGM-RATEO-IMP-TOT ' PGM-RATEO-IMP-TOT.

050399*    MOVE 'S' TO TOTALI-ST1.
050399     MOVE 'S' TO TOTALI-ST0.
           COMPUTE CTR-RIGHE-0 = CTR-RIGHE-0 - 2.

FS    *    IF COM-FND-DIV-IPS-FLG-DVS-IN = 'S'
FS         IF COM-FND-DIV-FLG-DVS-IN = 'S'
FS            MOVE COM-FND-DIV-FLG-DVS-IN TO COM-FLG-DVS-IN
FS            MOVE FND-COD-DVS        TO COM-COD-DVS
              MOVE WS-IMP-CED-EST     TO CG-CONEUR-IMP-INP
              PERFORM CONVERTI-EURO THRU CONVERTI-EURO-EXIT
              IF SW-USC-X-BLOCCO = 'SI'
                 GO TO STAMPA-RATEO-S3001-EXIT
              END-IF
              MOVE CG-CONEUR-IMP-OUT TO WS-IMP-CED-EST-CNV
FS            MOVE COM-FND-DIV-IPS-FLG-DVS-IN TO COM-FLG-DVS-IN
FS            MOVE FND-COD-DVS-IPS  TO COM-COD-DVS
              MOVE PGM-RIT-FIS TO CG-CONEUR-IMP-INP
              PERFORM CONVERTI-EURO THRU CONVERTI-EURO-EXIT
              IF SW-USC-X-BLOCCO = 'SI'
                 GO TO STAMPA-RATEO-S3001-EXIT
              END-IF
              MOVE CG-CONEUR-IMP-OUT TO PGM-RITENUTA-FISCALE-CNV
              MOVE  SPACE                   TO  RIGA-ST0-132
              MOVE WS-IMP-CED-EST-CNV  TO WST-IMPONIB-CNV
              MOVE PGM-RITENUTA-FISCALE-CNV
                               TO WST-RIT-FIS-CNV
              MOVE RIGA4-0                  TO RIGA-ST0-132
              ADD 1                         TO NUM-RIG-STM-0
              MOVE WK-TXT-STM-0             TO TXT-ST0
              WRITE TABULATO-0   AFTER 1

              COMPUTE CTR-RIGHE-0 = CTR-RIGHE-0 - 1
            END-IF.

000704*  SE ESENTE, STAMPA MOTIVO DI ESENZIONE
000704      IF WS-ESENTE-0 > 0
000704         PERFORM STAMPA-ESENZIONE THRU STAMPA-ESENZIONE-EXIT
000704      END-IF.
      *
       STAMPA-RATEO-S3001-EXIT.
           EXIT .
      ************************************************************
      *         ROUTINE DECREMENTA GIORNI                        *
      ************************************************************
       DECREMENTA-DATA-1.
      *
           MOVE COMODO-DATA-ROV    TO GDATE-DIN1
           MOVE 1                  TO GDATE-NGIO-N
           MOVE '1'                TO GDATE-SIN1OTT
230699     MOVE '0'            TO GDATE-SIN1ROV
           MOVE 'DE'               TO GDATE-CFUN

           PERFORM U-X01-GEST-BOPGDATE THRU
                   U-X01-GEST-BOPGDATE-EXIT
           IF GDATE-STC  = '0'
                 MOVE GDATE-DEFF      TO COMODO-DATA-ROV
           END-IF.
      *
       DECREMENTA-DATA-1-EXIT.
           EXIT.
      ***************************************************************
      *   ROUTINE     QTA-RIMANENTE                                 *
      ***************************************************************
       QTA-RIMANENTE.
      *
090499* CALCOLO I GIORNI INTERCORRENTI TRA TIT-DAT-EMS E WS-DATA-LIMITE
090499*
251198*    IF TIT-BAS-CLC OF DCLTBTIT = 'C'
251198*      MOVE 'DC'           TO GDATE-CFUN
251198*    ELSE
251198*      MOVE 'DI'           TO GDATE-CFUN
251198*    END-IF.
090499*
090499*    MOVE TIT-DAT-EMS (1:2)  TO GDATE-DIN2 (1:2).
090499*    MOVE TIT-DAT-EMS (4:2)  TO GDATE-DIN2 (3:2).
090499*    MOVE TIT-DAT-EMS (7:4)  TO GDATE-DIN2 (5:4).
090499*    MOVE '1'                TO GDATE-SIN2OTT.
090499*
090499*    MOVE WS-DATA-LIMITE (7:2)  TO GDATE-DIN1 (1:2).
090499*    MOVE WS-DATA-LIMITE (5:2)  TO GDATE-DIN1 (3:2).
090499*    MOVE WS-DATA-LIMITE (1:4)  TO GDATE-DIN1 (5:4).
090499*    MOVE '1'                   TO GDATE-SIN1OTT.
090499*
090499*    INITIALIZE    WSN-SKB-CAMPI.
090499*    MOVE 'BOXGDATE'           TO WSN-SKB-COPY.
090499*    MOVE 'U-X01-GEST-BOPG'     TO WSN-SKB-LABEL.
090499*    MOVE SPACE                 TO WSN-SKB-TABELLA.
090499*    MOVE 'QTA-RIMANENTE'       TO WSN-SKB-FUNZIONE.
090499*     RICHIAMO LA ROUTINE GENERALIZZATA
090499*    IF TIT-BAS-CLC OF DCLTBTIT = 'C'
090499*      MOVE 'DC'           TO GDATE-CFUN
090499*    ELSE
090499*      MOVE 'DI'           TO GDATE-CFUN
090499*    END-IF.
090499*    PERFORM U-X01-GEST-BOPGDATE
090499*    THRU    U-X01-GEST-BOPGDATE-EXIT.
090499*
090499*      MI CONSERVO LA VAR. DI RITORNO IN NUM-GG
090499*    IF GDATE-STC = '0'
090499*     MOVE GDATE-NGIOEFF  TO NUM-GG
090499*    ELSE
090499*     PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
090499*    END-IF.
130199*    IF WS-NAZ-TITOLO = 'I'
130199*       ADD 1 TO NUM-GG
130199*    END-IF.

090499     MOVE TIT-DAT-EMS           TO CG-CLGG-DAT-INI.
090499     MOVE WS-DATA-LIMITE (7:2)  TO CG-CLGG-DAT-RIF (1:2).
090499     MOVE WS-DATA-LIMITE (5:2)  TO CG-CLGG-DAT-RIF (4:2).
090499     MOVE WS-DATA-LIMITE (1:4)  TO CG-CLGG-DAT-RIF (7:4).
090499     MOVE CG-CLGG-DAT-RIF       TO CG-CLGG-DAT-FIN.
090499     MOVE TIT-FRQ-GOD-CED   TO CG-CLGG-FRQ-GOD-CED.
280999     MOVE TIT-DAT-EMS       TO CG-CLGG-DAT-EMS.
      D    DISPLAY 'CG-CLGG-FRQ-GOD-CED 2 ' CG-CLGG-FRQ-GOD-CED
090499     MOVE TIT-BAS-CLC       TO CG-CLGG-BAS-CLC.
090499     MOVE 0                 TO CG-CLGG-IMP-NOM.
090499     MOVE 0                 TO CG-CLGG-RIT-FON.
090499     MOVE 0                 TO CG-CLGG-TAS.
090499     PERFORM X01-CLGG
090499     THRU    X01-CLGG-EXIT.

090499     IF CG-CLGG-STS = '0'
090499           MOVE CG-CLGG-GG-MAT      TO NUM-GG
090499     ELSE
090499           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
090499     END-IF.


           IF TIT-PRZ-RIM < TIT-PRZ-EMS
            MOVE 0 TO PGM-RATEO-VEND-PARZ
           ELSE
            COMPUTE PGM-RATEO-VEND-PARZ = PGM-QTA-VENDITA *
                                          PGM-DIETIMO * NUM-GG / 100
           END-IF.

           COMPUTE PGM-DISAG = PGM-DISAG + PGM-RATEO-VEND-PARZ.
      *
       QTA-RIMANENTE-EXIT.
           EXIT.
      ***************************************************************
       U-GF03-RIGA-TOTALI.
      *
      D    DISPLAY 'U-GF03-RIGA-TOTALI'.
280100     MOVE VALORE-NOMINALE     TO VALORE-RIMBORSO
           MOVE S-ELA-DAT-LAZ (1: 2)           TO WS-DAT-COM3 (7: 2).
           MOVE S-ELA-DAT-LAZ (4: 2)           TO WS-DAT-COM3 (5: 2).
           MOVE S-ELA-DAT-LAZ (7: 4)           TO WS-DAT-COM3 (1: 4).
           MOVE TIT-DAT-REC OF DCLTBTIT (1: 2) TO WS-DAT-COM4 (7: 2).
           MOVE TIT-DAT-REC OF DCLTBTIT (4: 2) TO WS-DAT-COM4 (5: 2).
           MOVE TIT-DAT-REC OF DCLTBTIT (7: 4) TO WS-DAT-COM4 (1: 4).

           IF PGM-GG-MAT-OLD > ZEROES
              COMPUTE PGM-COM-IMP-OLD =
                VALORE-RIMBORSO * PGM-GG-MAT-OLD * PGM-DIETIMO / 100
           END-IF.

           COMPUTE PGM-GG-MAT-NEW = PGM-GG-MAT - PGM-GG-MAT-OLD.

           IF PGM-GG-MAT-NEW > ZEROES
              COMPUTE PGM-COM-IMP =
                VALORE-RIMBORSO * PGM-GG-MAT-NEW * PGM-DIETIMO-NEW / 100
           END-IF.

      D    DISPLAY '** PGM-GG-MAT           ' PGM-GG-MAT.
      D    DISPLAY '** PGM-GG-MAT-OLD       ' PGM-GG-MAT-OLD.
      D    DISPLAY '** VALORE-NOMINALE      ' VALORE-NOMINALE.
      D    DISPLAY '** TIT-PRZ-RIM          ' TIT-PRZ-RIM
      D    DISPLAY '** TIT-PRZ-EMS          ' TIT-PRZ-EMS
           IF PGM-GG-MAT-OLD NOT = PGM-GG-MAT
000688        AND VALORE-NOMINALE > 0
000689        AND TIT-PRZ-RIM OF DCLTBTIT > TIT-PRZ-EMS OF DCLTBTIT
050399          PERFORM U-ST94-TOTALI-1
050399          THRU    U-ST94-TOTALI-1-EXIT
           END-IF.
      D    DISPLAY 'POST-U-ST94'.
           ADD PGM-COM-IMP-OLD  TO PGM-COM-IMP.
           COMPUTE PGM-COM-IMP1 = PGM-COM-IMP  -
                                  PGM-TOT-DISAG.
           MOVE PGM-COM-IMP1            TO PGM-IMPONIB1.
050399*    MOVE 1                       TO WST-CAMBIO.
050399     MOVE 1                       TO WKS-CAMBIO.

      D    DISPLAY 'COM-FND-DIV-COD-DVS  '
      D    DISPLAY  COM-FND-DIV-COD-DVS.
      D    DISPLAY 'COM-TIT-DIV-COD-DVS  '
      D    DISPLAY  COM-TIT-DIV-COD-DVS.
           IF COM-FND-DIV-COD-DVS NOT = COM-TIT-DIV-COD-DVS
                 MOVE S-ELA-COD-IST          TO CG-CONEUR-COD-IST
                 MOVE S-ELA-COD-SOC-IST      TO CG-CONEUR-COD-SOC-IST
                 MOVE S-ELA-COD-FON          TO CG-CONEUR-COD-FON
                 MOVE IST-DAT-RIF-CNV        TO CG-CONEUR-DAT-RIF-CNV
                 MOVE S-ELA-DAT-LAZ          TO CG-CONEUR-DAT-RIL-CAM
                 MOVE PGM-COM-IMP1           TO CG-CONEUR-IMP-INP
                 MOVE FND-COD-DVS            TO CG-CONEUR-COD-DVS-ARR
                 MOVE COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
                 MOVE COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR
                 MOVE 0                      TO CG-CONEUR-TAS-UNO
                 MOVE 0                      TO CG-CONEUR-TAS-DUE

                 MOVE COM-TIT-DIV-COD-DVS    TO CG-CONEUR-COD-DVS-PNZ
                 MOVE COM-TIT-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-PNZ
      D          DISPLAY 'CG-CONEUR-INPUT  '      CG-CONEUR-INPUT
                 PERFORM  X01-CONV-EURO THRU X01-CONV-EURO-EXIT

                 IF CG-CONEUR-CODERR NOT = SPACE
014146              MOVE 'GFUWM300' TO WSN-SKB-PGM
                    PERFORM X01-BLOCCO-IMEU
                    THRU    X01-BLOCCO-IMEU-EXIT
                    GO TO U-GF03-RIGA-TOTALI-EXIT
                 END-IF
      D          DISPLAY '1'
                 MOVE CG-CONEUR-IMP-OUT TO PGM-IMPONIB1
                 MOVE CG-CONEUR-TAS-EUR-DVS TO WS-CAMBIO
                 MOVE CG-CONEUR-COD-DVS-ARR TO COM-COD-DVS
                 MOVE CG-CONEUR-FLG-DVS-ARR  TO COM-FLG-DVS
           END-IF.

           MOVE COM-TIT-DIV-COD-DVS    TO CG-CONEUR-COD-DVS-PNZ
           MOVE COM-TIT-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-PNZ.

           MOVE COM-FND-DIV-COD-DVS    TO CG-CONEUR-COD-DVS-ARR
           MOVE COM-FND-DIV-FLG-DVS-IN TO CG-CONEUR-FLG-DVS-ARR
           MOVE COM-FND-DIV-FLG-LIT    TO CG-CONEUR-FLG-LIT-ARR.

           COMPUTE PGM-AGGI-DISAG = (PGM-IMPONIB1 *
                              TIT-TAS-RIT-FIS OF DCLTBTIT) / 100.
FS    D    DISPLAY '3 PGM-AGGI-DISAG ---> ' PGM-AGGI-DISAG.

           IF WS-CAMBIO = ZEROES
                  MOVE 1                TO WKS-CAMBIO
           ELSE
                  MOVE WS-CAMBIO        TO WKS-CAMBIO
           END-IF.

           IF COM-FND-DIV-FLG-DVS-IN = 'S'
                  MOVE 1 TO WS-CAMBIO
                  MOVE COM-FND-DIV-FLG-DVS-IN TO COM-FLG-DVS
050399                                           COM-FLG-DVS-IN
 1111             MOVE COM-FND-DIV-COD-DVS    TO COM-COD-DVS
                  MOVE  PGM-IMPONIB1 TO CG-CONEUR-IMP-INP
                  PERFORM CONVERTI-EURO THRU CONVERTI-EURO-EXIT
                  IF SW-USC-X-BLOCCO = 'SI'
                     GO TO U-GF03-RIGA-TOTALI-EXIT
                  END-IF
      D           DISPLAY '2'
                  MOVE CG-CONEUR-IMP-OUT TO PGM-IMPONIB1-CNV
                  MOVE PGM-AGGI-DISAG TO CG-CONEUR-IMP-INP
                  PERFORM CONVERTI-EURO THRU CONVERTI-EURO-EXIT
                  IF SW-USC-X-BLOCCO = 'SI'
                     GO TO U-GF03-RIGA-TOTALI-EXIT
                  END-IF
      D           DISPLAY '3'
                  MOVE CG-CONEUR-IMP-OUT TO PGM-AGGI-DISAG-CNV
           END-IF.
           ADD PGM-AGGI-DISAG         TO PGM-TOT-DISAG-LINEA.

      *---    STAMPA RIGHE DEI TOTALI
050399     MOVE 'GFUWM300'     TO CG-STPTES-NOM-PGM.
050399*-----> (X PERFORM 'U-ST81-TOTALE-INTERESSI-1')
      D    DISPLAY 'U-ST81-TOTALE-INT'.
050399     MOVE VALORE-RIMBORSO  TO COMODO-QTA-TOTALE.
050399     PERFORM U-ST81-TOTALE-INTERESSI-1
050399     THRU    U-ST81-TOTALE-INTERESSI-1-EXIT.
      D    DISPLAY 'U-ST81-TOTALE-INT-EXIT'.
      *
       U-GF03-RIGA-TOTALI-EXIT.
           EXIT.
030699*****************************************************************
030699***             AGGIORNAMENTO TOTALIZZATORI                   ***
030699*****************************************************************
030699 U-GF01-AGG-TOTALIZ.
030699*
000512*--> TOTALIZZAZIONE SCARTO EMISSIONE
030699D    DISPLAY '** TOT SCART = ' PGM-SCART-IMP-TOT.
030699     IF PGM-SCART-IMP-TOT  NOT = ZERO
030699
030699        MOVE    COM-FND-DIV-FLG-DVS-IN      TO
030699                COMODO-FND-DIV-FLG-DVS-IN
030699        IF      COM-FND-DIV-FLG-DVS-IN = 'S'
030699                MOVE    COM-FND-DIV-FLG-DVS-IN      TO
030699                        COM-FLG-DVS
030699                MOVE    COM-FND-DIV-COD-DVS         TO
030699                        COM-COD-DVS
030699        END-IF
030699
008106*8730   IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730        IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106          COMPUTE PGM-SCART-IMP-TOT =
008106                  PGM-SCART-IMP-TOT * MC35-PESO
008106        END-IF

030699        MOVE PGM-SCART-IMP-TOT       TO S-TOT0-IMP-DVS
030699        MOVE PGM-SCART-IMP-TOT       TO S-TOT0-IMP-DVS-FND
FS            MOVE FND-COD-DVS OF DCLTBFND TO S-TOT0-COD-DVS
000512        MOVE 569 TO S-TOT0-COD-TOT
030699        PERFORM U-A14-SCRIVE-TOTALIZ
030699        THRU    U-A14-SCRIVE-TOTALIZ-EXIT
030699
030699     END-IF.
000512*--> TOTALIZZAZIONE RATEO STACCO CEDOLA
030699D    DISPLAY '** TOT RATEO = ' PGM-RATEO-IMP-TOT.
030699     IF PGM-RATEO-IMP-TOT  NOT = ZERO
030699
030699        MOVE    COM-FND-DIV-FLG-DVS-IN      TO
030699                COMODO-FND-DIV-FLG-DVS-IN
030699        IF      COM-FND-DIV-FLG-DVS-IN = 'S'
030699                MOVE    COM-FND-DIV-FLG-DVS-IN      TO
030699                        COM-FLG-DVS
030699                MOVE    COM-FND-DIV-COD-DVS         TO
030699                        COM-COD-DVS
030699        END-IF
030699

030699        MOVE PGM-RATEO-IMP-TOT       TO S-TOT0-IMP-DVS
030699        MOVE PGM-RATEO-IMP-TOT       TO S-TOT0-IMP-DVS-FND
FS            MOVE FND-COD-DVS OF DCLTBFND TO S-TOT0-COD-DVS
000512        MOVE 568 TO S-TOT0-COD-TOT
030699        PERFORM U-A14-SCRIVE-TOTALIZ
030699        THRU    U-A14-SCRIVE-TOTALIZ-EXIT
030699     END-IF.
030699
000512*--> TOTALIZZAZIONE RITENUTA SCARTI EMISSIONE
030699D    DISPLAY '** TOT RIT. SCART = ' PGM-SCART-IMP-RIT.
030699     IF PGM-SCART-IMP-RIT  NOT = ZERO
030699
008106*8730   IF WS-ABIL-PERS-105 = 'S' AND MC35-SQLCODE  = 0
008730        IF MC36-ABIL-TIT = 'S' AND MC35-SQLCODE  = 0
008106          COMPUTE PGM-SCART-IMP-RIT ROUNDED =
008106                  PGM-SCART-IMP-RIT * MC35-PESO
008106        END-IF
030699        MOVE PGM-SCART-IMP-RIT     TO S-TOT0-IMP-DVS
030699        MOVE PGM-SCART-IMP-RIT     TO S-TOT0-IMP-DVS-FND
FS            MOVE FND-COD-DVS     OF DCLTBFND TO S-TOT0-COD-DVS
000512        COMPUTE S-TOT0-IMP-DVS     = S-TOT0-IMP-DVS  / 100
000512        COMPUTE S-TOT0-IMP-DVS-FND = S-TOT0-IMP-DVS-FND / 100
      D       DISPLAY '** TOT-572 ' S-TOT0-IMP-DVS-FND
000512        MOVE 572 TO S-TOT0-COD-TOT
030699        PERFORM U-A14-SCRIVE-TOTALIZ
030699        THRU    U-A14-SCRIVE-TOTALIZ-EXIT
030699
030699     END-IF.
030699*
000512*--> TOTALIZZAZIONE RITENUTA RATEO STACCO CEDOLA
030699D    DISPLAY '** TOT RIT. RATEO = ' PGM-RATEO-IMP-RIT.
030699     IF PGM-RATEO-IMP-RIT  NOT = ZERO
030699
030699        MOVE PGM-RATEO-IMP-RIT     TO S-TOT0-IMP-DVS
030699        MOVE PGM-RATEO-IMP-RIT     TO S-TOT0-IMP-DVS-FND
FS            MOVE FND-COD-DVS-IPS OF DCLTBFND TO S-TOT0-COD-DVS
000512        MOVE 571 TO S-TOT0-COD-TOT
030699        PERFORM U-A14-SCRIVE-TOTALIZ
030699        THRU    U-A14-SCRIVE-TOTALIZ-EXIT
030699     END-IF.
030699*
030699 U-GF01-AGG-TOTALIZ-EXIT.
030699     EXIT.
030699******************************************************************
030699***                SCRITTURA TOTALIZZATORI                     ***
030699******************************************************************
030699 U-A14-SCRIVE-TOTALIZ.
030699*
030699     MOVE S-ELA-COD-IST               TO S-TOT0-COD-IST.
030699     MOVE S-ELA-COD-SOC-IST           TO S-TOT0-COD-SOC-IST.
030699     MOVE S-ELA-COD-FON               TO S-TOT0-COD-FON.
030699     MOVE S-ELA-COD-LIN               TO S-TOT0-COD-LIN.
030699     MOVE ZEROES                      TO S-TOT0-COD-GES.
030699* FS MOVE FND-COD-DVS     OF DCLTBFND TO S-TOT0-COD-DVS.
030699     MOVE S-ELA-DAT-LAZ               TO S-TOT0-DAT-RIF.
030699
030699     WRITE REC-STOT0.
030699*
030699 U-A14-SCRIVE-TOTALIZ-EXIT.
030699     EXIT.
      **********************************************************
      *            CERCA DATA BORSA
      **********************************************************
3092   CERCA-DATA-BORSA.
      *
3092  **VERIFICA CHE LA DATA SCADENZA DELLA CEDOLA SIA UN GIORNO DI
3092  **BORSA APERTO
3092
3092       MOVE 'I' TO CG-DATBOR-FLG-INCR-DECR.
3092       MOVE  1  TO CG-DATBOR-NUM-GIO.


3092       MOVE COM-DATA-BORSA TO CG-DATBOR-DAT-INP.
3092       MOVE S-ELA-COD-IST  TO CG-DATBOR-IST.
3092       MOVE 86             TO CG-DATBOR-PAE.

      D    DISPLAY 'CG-DATBOR-DAT-INP    ' CG-DATBOR-DAT-INP
      D    DISPLAY 'CG-DATBOR-IST  ' CG-DATBOR-IST
      D    DISPLAY 'CG-DATBOR-PAE  ' CG-DATBOR-PAE

3092  * IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
3092       MOVE ' GFUSDTBO '         TO WSN-SKB-COPY.
3092       MOVE  'X01-DATA-BORSA'    TO WSN-SKB-LABEL.
3092       MOVE 'TBCAL'              TO WSN-SKB-TABELLA.
3092       MOVE '      '             TO WSN-SKB-FUNZIONE.
3092  *14696INITIALIZE WS-IMPO-FONDO.
3092  *14696MOVE IST-COD-IST TO WS-COD-ISTX.
3092  *14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT.
014696     MOVE SPACES               TO WSN-SKB-CHIAVE-DATI.
3092       STRING WS-KEY-BANCA
3092       DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI.

3092       PERFORM  X01-DATA-BORSA THRU X01-DATA-BORSA-EXIT.

009560     IF CG-DATBOR-CODERR NOT = SPACE
009560        MOVE 'GFUWM300' TO WSN-SKB-PGM
009560        MOVE 'E122'         TO CG-BLOCFON-MOTIVO
009560        MOVE 'X01-DATA-BORSA  '
009560                             TO CG-BLOCFON-NOTE
009560        MOVE 'CALCOLO E TOT. RIMBORSI , CEDOLE'
009560                             TO CG-BLOCFON-FASE
009560        MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
009560        MOVE PSA-COD-IST     TO CG-BLOCFON-COD-IST
009560        MOVE PSA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
009560        MOVE PSA-COD-FON     TO CG-BLOCFON-COD-FON
009560        MOVE PSA-COD-LIN     TO CG-BLOCFON-COD-LIN
009560        MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146        MOVE 'GFUWM300' TO WSN-SKB-PGM
009560        PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
009560     END-IF

3092       MOVE CG-DATBOR-DAT-OUT(1:2) TO GG-P.
3092       MOVE CG-DATBOR-DAT-OUT(3:2) TO MM-P.
3092       MOVE CG-DATBOR-DAT-OUT(5:4) TO SSAA-P.
      D    DISPLAY 'DATA CAL DI BORSA ' WS-DAT-EFF-PIU1.
      D    DISPLAY 'FINE DATA BORSA'.
      *
3092   CERCA-DATA-BORSA-EXIT.
3092       EXIT.
      ****************************************************************
      *                  CHIUSURA DEI FILES UTILIZZATI             *
      ***************************************************************
       CHIUSURA-ARCHIVI.
      *
           CLOSE SELAO.
           CLOSE SMLQ0.
014696*    CLOSE SMLQ1.
           CLOSE SMO0.
           CLOSE S3000.
           CLOSE S3001.
002214     CLOSE SDME.
005177*    PERFORM X01-CLOSE-LOGER
005177*    THRU    X01-CLOSE-LOGER-EX.
      *
       CHIUSURA-ARCHIVI-EXIT.
           EXIT.
3092  *****************************************************************
3092  ***   CALL ESTERNA PER LA VERIFICA DELLA DATA DI ELABORAZIONE  **
3092  ***               CON LA DATA DELL'EVENTO                      **
3092  *****************************************************************
3092   U-GFC10-CALL-TBELA.
      *
      D    DISPLAY 'U-GFC10-CALL-TBELA'.
3092       MOVE 'GFUWMC10'           TO CHMO-NOM-MOD
3092       MOVE 'B'                  TO CHMO-FLG-CHI
3092       MOVE S-ELA-COD-IST          TO CHMO-COD-IST
3092  *5456                              WS-PERS-R-COD-IST
005456                                   WS-PERS-C10-COD-IST
      D    DISPLAY 'WS-PERS-C10-COD-IST ' WS-PERS-C10-COD-IST

3092  *5456MOVE S-ELA-COD-SOC-IST      TO WS-PERS-R-COD-SOC-IST
005456     MOVE S-ELA-COD-SOC-IST      TO WS-PERS-C10-COD-SOC-IST

      D    DISPLAY 'WS-PERS-C10-COD-SOC-IST ' WS-PERS-C10-COD-SOC-IST

3092  *5456MOVE S-ELA-COD-FON          TO WS-PERS-R-COD-FON
005456     MOVE S-ELA-COD-FON          TO WS-PERS-C10-COD-FON
      D    DISPLAY 'WS-PERS-C10-COD-FON ' WS-PERS-C10-COD-FON

3092  *5456MOVE S-ELA-COD-LIN          TO WS-PERS-R-COD-LIN
005456     MOVE S-ELA-COD-LIN          TO WS-PERS-C10-COD-LIN

      D    DISPLAY 'WS-PERS-C10-COD-LIN ' WS-PERS-C10-COD-LIN


3092  *5456MOVE S-ELA-DAT-LAZ        TO WS-PERS-R-DAT-ELA
005456     MOVE S-ELA-DAT-LAZ        TO WS-PERS-C10-DAT-ELA
      D    DISPLAY 'WS-PERS-C10-LAZ ' WS-PERS-C10-DAT-ELA

3092  *5456MOVE WS-PERS-R            TO CHMO-DATI-INP-PRS
005456     MOVE WS-PERS-C10          TO CHMO-DATI-INP-PRS
3092       MOVE SPACES               TO CHMO-DATI-INP-VAR

3092       PERFORM U-X01-GEST-CALL-MOD
3092       THRU    U-X01-GEST-CALL-MOD-EXIT.

      D    DISPLAY 'RITORNO DA ROUTINE'
      D    DISPLAY 'DATI DA ROUTINE  ' CHMO-DATI-OUT-PRS
3092       IF CHMO-RET-COD = '00'
      D    DISPLAY 'TUTTO OK          '
3092  *5456    MOVE CHMO-DATI-OUT-PRS    TO WS-PERS-R
005456         MOVE CHMO-DATI-OUT-PRS    TO WS-PERS-C10
           ELSE
3092           IF CHMO-RET-COD = '99'
3092           OR CHMO-RET-COD = '01'
      D    DISPLAY 'KO - CHMO-RET-COD' CHMO-RET-COD
3092              MOVE 'GFUWMC10'       TO WSN-SKB-COPY
3092              MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
3092              MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
3092              MOVE '     '          TO WSN-SKB-TABELLA
3092              STRING '+B' IST-COD-IST OF DCLTBIST ' RET-COD CALL '
3092                      CHMO-RET-COD
3092              DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
3092              PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
3092           END-IF
3092       END-IF.
      *
3092   U-GFC10-CALL-TBELA-EXIT.
3092       EXIT.
      *
005717* LETTURA DELLA TABELLA TITOLI             **********************
005717 LEGGI-TBTIT.
006664D    DISPLAY 'LEGGI-TBTIT' TIT-COD-TIT.
005717     MOVE S-ELA-COD-IST TO TIT-COD-IST.
005717     MOVE TIT-COD-TIT   TO TIT-COD-TIT.
005717* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
005717     MOVE 'TBTITSL1'           TO WSN-SKB-COPY
005717     MOVE  'Y01-SEL-TBTIT'     TO WSN-SKB-LABEL
005717     MOVE 'TBTIT'              TO WSN-SKB-TABELLA
005717     MOVE 'SELECT'             TO WSN-SKB-FUNZIONE
005717*14696INITIALIZE WS-IMPO-FONDO
005717*14696MOVE IST-COD-IST TO WS-COD-ISTX
005717     MOVE TIT-COD-TIT TO WS-COD-TITX
005717*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696     MOVE SPACES               TO WSN-SKB-CHIAVE-DATI
005717     STRING WS-KEY-BANCA
005717            WS-KEY-TITOLO
005717     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005717     PERFORM Y01-SEL-TBTIT THRU Y01-SEL-TBTIT-EXIT
005717
005717     IF ENGIRC-NOTF-ENDFILE
005717            PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
005717     END-IF.
006664*005717     DISPLAY 'TIT-DAT-DEC ' TIT-DAT-DEC.
005717     MOVE TIT-DAT-DEC (1:2) TO WS-DAT-DEC (7:2).
005717     MOVE TIT-DAT-DEC (4:2) TO WS-DAT-DEC (5:2).
005717     MOVE TIT-DAT-DEC (7:4) TO WS-DAT-DEC (1:4).
006664*005717     DISPLAY ' WS-DAT-DEC  ' WS-DAT-DEC.
005717*
005717 LEGGI-TBTIT-EXIT.
005717     EXIT.
005717**************************************************************
005717* SE DATA DECORRENZA LETTA SU TBTIT E' < DI DATA ELABORAZIONE
005717* DEVO AGGIORNARE LA DATA EFFETTIVO RIMBORSO ANCHE SU TBSVM
005717**************************************************************
005717  LEGGI-TBSVM.
006664D    DISPLAY 'LEGGI-TBSVM'.
005717*--- SCORRE L'ARCHIVIO PORTAFOGLIO MOVIMENTI
005717
005717     MOVE S-ELA-COD-IST     TO SVM-COD-IST OF DCLTBSVM.
005717     MOVE TIT-COD-TIT       TO SVM-COD-TIT OF DCLTBSVM.
005717     MOVE S-ELA-DAT-LAZ     TO SVM-DAT-DEC OF DCLTBSVM.
005717
005717*-- IMPOSTA CAMPI PER EVENTUALE ERRORE BLOCCANTE   --*
005717*--          NELL'ACCESSO AL DB2                   --*
005717     MOVE 'TBSVMOC1'                  TO WSN-SKB-COPY
005717     MOVE 'Y05-OPEN-CUR1-TBSVM'      TO WSN-SKB-LABEL
005717     MOVE 'OPEN '                     TO WSN-SKB-FUNZIONE
005717     MOVE 'TBSVM'                     TO WSN-SKB-TABELLA
005717*14696INITIALIZE WS-IMPO-FONDO
005717*14696MOVE  TIT-COD-IST            TO WS-COD-ISTX
005717     MOVE  TIT-COD-TIT            TO WS-COD-TITX
005717*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
014696     MOVE SPACES                  TO WSN-SKB-CHIAVE-DATI
005717     STRING WS-KEY-BANCA  WS-KEY-TITOLO
005717     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005717
005717     PERFORM Y05-OPEN-CUR1-TBSVM
005717     THRU    Y05-OPEN-CUR1-TBSVM-EXIT
005717
005717*---- IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
005717     MOVE 'TBSVMFC1'              TO WSN-SKB-COPY
005717     MOVE 'Y06-FETCH-CUR1-TBSVM ' TO WSN-SKB-LABEL
005717     MOVE 'TBSVM'                 TO WSN-SKB-TABELLA
005717     MOVE 'FETCH CURSOR '         TO WSN-SKB-FUNZIONE
005717*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
005717*14696STRING WS-KEY-BANCA    WS-KEY-TITOLO
005717*14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005717
005717     PERFORM Y06-FETCH-CUR1-TBSVM
005717     THRU    Y06-FETCH-CUR1-TBSVM-EXIT.
005717  LEGGI-TBSVM-EXIT.
005717     EXIT.
005717*
005717  AGGIORNA-TBSVM.
006664D    DISPLAY 'AGGIORNA-TBSVM '.
005717*---- IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
005717     MOVE ' TBSVMUP1 '  TO WSN-SKB-COPY.
005717     MOVE ' Y02-UPD-TBSVM ' TO WSN-SKB-LABEL.
005717     MOVE ' TBSVM' TO WSN-SKB-TABELLA.
005717     MOVE ' UPDATE ' TO WSN-SKB-FUNZIONE.
005717*14696INITIALIZE WS-IMPO-FONDO.
005717*14696MOVE  SVM-COD-IST      TO    WS-COD-ISTX.
005717*14696MOVE  SVM-COD-TIT      TO    WS-COD-TITX.
005717*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
005717*14696STRING WS-KEY-BANCA WS-KEY-TITOLO
005717*14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005717     PERFORM Y02-UPD-TBSVM THRU Y02-UPD-TBSVM-EXIT.
005717  AGGIORNA-TBSVM-EXIT.
005717     EXIT.
005717*
005717  CLOSE-TBSVM.
006664*005717     DISPLAY 'CLOSE-TBSVM'.
005717*---CHIUDO IL CURSORE
005717     MOVE ' TBSVMCL1 '             TO WSN-SKB-COPY
005717     MOVE ' Y07-CLOSE-CUR1-TBSVM ' TO WSN-SKB-LABEL
005717     MOVE ' TBSVM '                TO WSN-SKB-TABELLA
005717     MOVE ' CLOSE CURSOR '         TO WSN-SKB-FUNZIONE
005717*14696INITIALIZE WS-IMPO-FONDO
005717*14696MOVE  TIT-COD-IST            TO WS-COD-ISTX
005717*14696MOVE  TIT-COD-TIT            TO WS-COD-TITX
005717*14696MOVE  PSA-COD-FON            TO WS-COD-FONN
005717*14696MOVE  PSA-COD-LIN            TO WS-COD-LINN
005717*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
005717*14696STRING WS-KEY-BANCA  WS-KEY-TITOLO
005717*14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005717
005717     PERFORM Y07-CLOSE-CUR1-TBSVM
005717        THRU Y07-CLOSE-CUR1-TBSVM-EXIT.
005717*
005717 CLOSE-TBSVM-EXIT.
005717     EXIT.
005717*
005456******************************************************************
005456* VERIFICA ABILITAZIONE PERS. 84 VENDITE ALLO SCOPERTO
005456******************************************************************
005456 VERIFICA-ABILITAZIONE-84.
      *
005456        MOVE 'GFUWMC01'           TO CHMO-NOM-MOD
005456        MOVE 'B'                  TO CHMO-FLG-CHI
005456        MOVE S-ELA-COD-IST        TO CHMO-COD-IST
005456                                     WS-PERS-COD-IST
005456        MOVE S-ELA-COD-SOC-IST    TO WS-PERS-COD-SOC-IST
005456        MOVE S-ELA-COD-FON        TO WS-PERS-COD-FON
005456        MOVE ZEROES               TO WS-PERS-COD-LIN
005456        MOVE ZEROES               TO WS-PERS-COD-SGE
005456        MOVE 84                   TO WS-PERS-COD-PRS-N
005456
005456        MOVE WS-PERS              TO CHMO-DATI-INP-PRS
005456        MOVE SPACES               TO CHMO-DATI-INP-VAR
005456        PERFORM U-X01-GEST-CALL-MOD
005456        THRU    U-X01-GEST-CALL-MOD-EXIT.
005456        IF CHMO-RET-COD NOT = '99'
005456           MOVE CHMO-DATI-OUT-PRS    TO WS-PERS
005456           IF WS-PERS-FLG-OPE = 'S' AND
005456              WS-PERS-PRS-APP = 'S'
005456              MOVE WS-PERS-CMP-DST TO CG-SPEC-AREA-INP
005456           END-IF
005456        ELSE
005456           MOVE 'GFUWMC01'       TO WSN-SKB-COPY
005456           MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
005456           MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
005456           MOVE '     '          TO WSN-SKB-TABELLA
005456           STRING '+B' CHMO-COD-IST ' RET-COD CALL '
005456                       CHMO-RET-COD
005456           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005456           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
005456        END-IF.
      *
005456 VERIFICA-ABILITAZIONE-84-EXIT.
005456     EXIT.
009725******************************************************************
009725* VERIFICA ABILITAZIONE PERS. 116 VENDITE ALLO SCOPERTO
009725******************************************************************
009725 VERIFICA-ABILITAZIONE-116.
009725        MOVE 'GFUWMC01'           TO CHMO-NOM-MOD
009725        MOVE 'B'                  TO CHMO-FLG-CHI
009725        MOVE S-ELA-COD-IST        TO CHMO-COD-IST
009725                                     WS-PERS-COD-IST
009725        MOVE S-ELA-COD-SOC-IST    TO WS-PERS-COD-SOC-IST
009725        MOVE S-ELA-COD-FON        TO WS-PERS-COD-FON
009725        MOVE ZEROES               TO WS-PERS-COD-LIN
009725        MOVE ZEROES               TO WS-PERS-COD-SGE
009725        MOVE 116                  TO WS-PERS-COD-PRS-N
009725
009725        MOVE WS-PERS              TO CHMO-DATI-INP-PRS
009725        MOVE SPACES               TO CHMO-DATI-INP-VAR
009725        PERFORM U-X01-GEST-CALL-MOD
009725        THRU    U-X01-GEST-CALL-MOD-EXIT.
009725        IF CHMO-RET-COD NOT = '99'
009725           MOVE CHMO-DATI-OUT-PRS    TO WS-PERS
009725           IF WS-PERS-FLG-OPE = 'S' AND
009725              WS-PERS-PRS-APP = 'S'
009725              MOVE 'S' TO WS-ABIL-PERS-116
009725           END-IF
009725        ELSE
009725           MOVE 'GFUWMC01'       TO WSN-SKB-COPY
009725           MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
009725           MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
009725           MOVE '     '          TO WSN-SKB-TABELLA
009725           STRING '+B' CHMO-COD-IST ' RET-COD CALL '
009725                       CHMO-RET-COD
009725           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
009725           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
009725        END-IF.
009725 VERIFICA-ABILITAZIONE-116-EXIT.
009725     EXIT.
005456*****************************************************************
005456**  PREPARA AREA TABELLA TBPSE, ESTENZIONE DELLA TBPSA          *
005456*****************************************************************
005456 PREPARA-AREA-PSE.
006664D    DISPLAY 'PREPARA-AREA-PSE'.
005456     INITIALIZE WS-PERS-R-INP.
005456     MOVE HIGH-VALUE TO WS-PERS-R1-INP
005456     MOVE S-ELA-COD-IST         TO WS-PERS-R-COD-IST.
005456     MOVE S-ELA-COD-SOC-IST     TO WS-PERS-R-COD-SOC-IST.
005456     MOVE S-ELA-COD-FON         TO WS-PERS-R-COD-FON.
005456     MOVE S-ELA-COD-LIN         TO WS-PERS-R-COD-LIN.
005456     MOVE PSA-COD-GES           TO WS-PERS-R-COD-GES.
005456     MOVE PSA-COD-TIT           TO WS-PERS-R-COD-TIT.
005456     MOVE 'S'                   TO WS-PERS-R-OPE.
      *
005456 PREPARA-AREA-PSE-EXIT.
005456     EXIT.
005456*****************************************************************
005456**               CHIAMATA A ROUTINE ESTERNA                    **
005456*****************************************************************
005456 CALL-C016.
006664*005456     DISPLAY 'SONO DENTRO ROUTINE C016 CALL '
005456     MOVE 'GFUWMC16'              TO CHMO-NOM-MOD
005456     MOVE 'B'                     TO CHMO-FLG-CHI
005456
005456     MOVE WS-PERS-R               TO CHMO-DATI-INP-PRS
005456     MOVE SPACES                  TO CHMO-DATI-INP-VAR
005456
005456     PERFORM U-X01-GEST-CALL-MOD
005456     THRU    U-X01-GEST-CALL-MOD-EXIT.
005456
006664*005456     DISPLAY 'DATI DA ROUTINE  ' CHMO-DATI-OUT-PRS.
005456     IF CHMO-RET-COD = '00'
006664*005456     DISPLAY 'TUTTO OK          '
005456         MOVE CHMO-DATI-OUT-PRS   TO WS-PERS-R
005456     ELSE
005456         IF CHMO-RET-COD = '99'
005456         OR CHMO-RET-COD = '01'
005456     DISPLAY 'KO - CHMO-RET-COD' CHMO-RET-COD
005456            MOVE 'GFUWMC16'       TO WSN-SKB-COPY
005456            MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
005456            MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
005456            MOVE '     '          TO WSN-SKB-TABELLA
005456            STRING '+B' IST-COD-IST OF DCLTBIST ' RET-COD CALL '
005456                    CHMO-RET-COD
005456            DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
005456            PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
005456         END-IF
005456     END-IF.
      *
005456 CALL-C016-EXIT.
005456     EXIT.
006044*****************************************************************
006044*-----  INCREMENTA LA SCADENZA CEDOLA DI 1 GIORNO
006044*****************************************************************
006044 INCREMENTA-SCD-1G.
006044*
006044        MOVE COM-DATA(1:2)             TO GDATE-DIN1 (1:2)
006044        MOVE COM-DATA(4:2)             TO GDATE-DIN1 (3:2)
006044        MOVE COM-DATA(7:4)             TO GDATE-DIN1 (5:4)
006044        MOVE '1'                       TO GDATE-SIN1OTT
006044        MOVE '0'                       TO GDATE-SIN1ROV
006044        MOVE 'IN'                      TO GDATE-CFUN
006044        MOVE 1                         TO GDATE-NGIO-N
006044        PERFORM  U-X01-GEST-BOPGDATE
006044           THRU  U-X01-GEST-BOPGDATE-EXIT
006044        IF GDATE-STC NOT = '0'
006044           MOVE 'B0037'           TO CG-BLOCFON-MOTIVO
006044           MOVE 'INCREM.SCAD'     TO CG-BLOCFON-NOTE
006044           MOVE 'CALCOLO VALUTA STACCO CEDOLA'
006044                                  TO CG-BLOCFON-FASE
006044           MOVE WSD-DATA-SOLARE   TO CG-BLOCFON-DATA
006044           MOVE S-ELA-COD-IST     TO CG-BLOCFON-COD-IST
006044           MOVE S-ELA-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
006044           MOVE S-ELA-COD-FON     TO CG-BLOCFON-COD-FON
006044           MOVE S-ELA-COD-LIN     TO CG-BLOCFON-COD-LIN
006044           MOVE S-ELA-DAT-LAZ     TO CG-BLOCFON-DAT-LAZ
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
006044           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
006044           MOVE 'SI' TO SW-USC-X-BLOCCO
006044*14696     GO TO CALCOLO-IMPORTO-CEDOLA-EXIT
014696           GO TO INCREMENTA-SCD-1G-EXIT
006044        ELSE
006044           MOVE GDATE-DEFF(1:2)   TO COM-DATA(1:2)
006044           MOVE GDATE-DEFF(3:2)   TO COM-DATA(4:2)
006044           MOVE GDATE-DEFF(5:4)   TO COM-DATA(7:4)
006044        END-IF.
006044*
006044 INCREMENTA-SCD-1G-EXIT.
006044     EXIT.
011326*****************************************************************
011326*-----  CERCA IL PRIMO GIORNO DI BORSA APERTA
011326*****************************************************************
011326 CERCA-PRIMO-GIORNO-BORSA.
      *
011326D    DISPLAY 'CERCA-PRIMO-GIORNO-BORSA '.
011326     MOVE CED-COD-IST         TO CAL-COD-IST.
011326     MOVE 86                  TO CAL-COD-PAE.
011326     MOVE COM-DATA(7:4)       TO CAL-ANN.
011326     MOVE COM-DATA(4:2)       TO CAL-MES.
011326
011326     PERFORM Y01-SEL-TBCAL THRU Y01-SEL-TBCAL-EXIT .
011326
011326     IF ENGIRC-NOTF-ENDFILE
011326*** IMPOSTO VARIABILI PER GESTIRE ERRORE BLOCCANTE SU DB2
011326        MOVE ' TBCALSL1 '          TO WSN-SKB-COPY
011326        MOVE 'Y01-SEL-TBCAL '      TO WSN-SKB-LABEL
011326        MOVE 'TBCAL'               TO WSN-SKB-TABELLA
011326        MOVE 'SELECT  '            TO WSN-SKB-FUNZIONE
011326        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
011326     ELSE
011326        MOVE CAL-GRN OF DCLTBCAL TO WK-GIORNI-BORSA
011326        MOVE COM-DATA(1:2)       TO IND-BORSA
011326        IF WK-GIORNI(IND-BORSA) = 'C'
011326           MOVE CED-DAT-SCD(7:4) TO COMSSAA
011326           MOVE CED-DAT-SCD(4:2) TO COMMM
011326           MOVE CED-DAT-SCD(1:2) TO COMGG
011326           PERFORM CERCA-DATA-BORSA
011326              THRU CERCA-DATA-BORSA-EXIT
011326           MOVE WS-DAT-EFF-PIU1  TO COM-DATA
011326        END-IF
011326     END-IF.
      *
011326 CERCA-PRIMO-GIORNO-BORSA-EXIT.
011326     EXIT.
      *
006026 CERCA-LINEA-GESTORE.
006026*
016938D       DISPLAY 'CERCA-LINEA-GESTORE'
006026        MOVE S-ELA-COD-IST     TO LGS-COD-IST   OF DCLTBLGS
006026        MOVE S-ELA-COD-SOC-IST TO LGS-COD-SOC-IST OF DCLTBLGS
006026        MOVE S-ELA-COD-FON     TO LGS-COD-FON OF DCLTBLGS
006026        MOVE S-ELA-COD-LIN     TO LGS-COD-LIN OF DCLTBLGS
006026*8615   MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
008615*16938  MOVE TAB-PSA-GES-COD-GES (PGM-IND4) TO
016938        MOVE TAB-PSA-GES-COD-GES (PGM-IND1) TO
006026                                  LGS-COD-GES OF DCLTBLGS
006026
016938D        DISPLAY 'LGS-COD-IST         ' LGS-COD-IST
016938D        DISPLAY 'LGS-COD-SOC-IST     ' LGS-COD-SOC-IST
016938D        DISPLAY 'LGS-COD-FON         ' LGS-COD-FON
016938D        DISPLAY 'LGS-COD-LIN         ' LGS-COD-LIN
016938D        DISPLAY 'LGS-COD-GES         ' LGS-COD-GES
006026* ----------------- SELECT SU  TBLGS ----------------------*
006026* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2***
006026        MOVE 'TBLGSL1'       TO WSN-SKB-COPY
006026        MOVE 'Y01-SEL-TBLGS' TO WSN-SKB-LABEL
006026        MOVE 'TBLGS'         TO WSN-SKB-TABELLA
006026        MOVE 'SELECT'        TO WSN-SKB-FUNZIONE
006026*14696   INITIALIZE WS-IMPO-FONDO
006026        MOVE LGS-COD-GES         TO WS-COD-GESN
006026*14696   MOVE LGS-COD-SOC-IST     TO WS-COD-SOC-ISTN
006026*14696   MOVE LGS-COD-FON         TO WS-COD-FONN
006026*14696   MOVE LGS-COD-LIN         TO WS-COD-LINN
006026*14696   PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
006026*14696   STRING WS-KEY-SOC-IST   WS-KEY-FONDO
014696        MOVE SPACES              TO WSN-SKB-CHIAVE-DATI
014696        STRING WS-KEY-BANCA
014696               WS-KEY-SOC-IST   WS-KEY-FONDO
006026               WS-KEY-LINEA     WS-KEY-GESTORE
006026        DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
006026
006026        PERFORM Y01-SEL-TBLGS THRU Y01-SEL-TBLGS-EXIT
006026
006026        IF ENGIRC-NOTF-ENDFILE
016938           DISPLAY 'RELAZIONE LINEA GESTORE NON TROVATA X GEST:'
016938                   WS-COD-GESX
006026           MOVE 'B0007'         TO CG-BLOCFON-MOTIVO
006026           MOVE 'SELECT'        TO CG-BLOCFON-NOTE
006026           MOVE 'CALCOLO CEDOLA                  '
006026                             TO CG-BLOCFON-FASE
006026           MOVE WSD-DATA-SOLARE TO CG-BLOCFON-DATA
006026           MOVE LGS-COD-IST     TO CG-BLOCFON-COD-IST
006026           MOVE LGS-COD-SOC-IST TO CG-BLOCFON-COD-SOC-IST
006026           MOVE LGS-COD-FON     TO CG-BLOCFON-COD-FON
006026           MOVE LGS-COD-LIN     TO CG-BLOCFON-COD-LIN
006026           MOVE S-ELA-DAT-LAZ   TO CG-BLOCFON-DAT-LAZ
014146           MOVE 'GFUWM300' TO WSN-SKB-PGM
006026           PERFORM X01-BLOC-FON THRU X01-BLOC-FON-EXIT
006026           MOVE 'SI' TO SW-USC-X-BLOCCO
006026        END-IF.
      *
006026 CERCA-LINEA-GESTORE-EXIT.
006026     EXIT.
006390******************************************************************
006390* VERIFICA ABILITAZIONE PERS. 91 GESTIONE POOL/INFLACTION
006390******************************************************************
006390 VERIFICA-ABILITAZIONE-91.
006390        MOVE 'GFUWMC01'           TO CHMO-NOM-MOD
006390        MOVE 'B'                  TO CHMO-FLG-CHI
006390        MOVE S-ELA-COD-IST        TO CHMO-COD-IST
006390                                     WS-PERS-COD-IST
006390        MOVE S-ELA-COD-SOC-IST    TO WS-PERS-COD-SOC-IST
006390        MOVE S-ELA-COD-FON        TO WS-PERS-COD-FON
006390        MOVE S-ELA-COD-LIN        TO WS-PERS-COD-LIN
006390        MOVE ZEROES               TO WS-PERS-COD-SGE
006390        MOVE 91                   TO WS-PERS-COD-PRS-N
006390
006390        MOVE WS-PERS              TO CHMO-DATI-INP-PRS
006390        MOVE SPACES               TO CHMO-DATI-INP-VAR
006390        PERFORM U-X01-GEST-CALL-MOD
006390        THRU    U-X01-GEST-CALL-MOD-EXIT.
006390        IF CHMO-RET-COD NOT = '99'
006390           MOVE CHMO-DATI-OUT-PRS    TO WS-PERS
006390           IF WS-PERS-FLG-OPE = 'S' AND
006390              WS-PERS-PRS-APP = 'S'
006390              MOVE 'S'             TO WS-ABIL-PERS-91
006390           ELSE
006390              MOVE 'N'             TO WS-ABIL-PERS-91
006390           END-IF
006390        ELSE
006390           MOVE 'GFUWMC01'       TO WSN-SKB-COPY
006390           MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
006390           MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
006390           MOVE '     '          TO WSN-SKB-TABELLA
014696           MOVE SPACES           TO WSN-SKB-CHIAVE-DATI
006390           STRING '+B' CHMO-COD-IST ' RET-COD CALL '
006390                       CHMO-RET-COD
006390           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
006390           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
006390        END-IF.
006390 VERIFICA-ABILITAZIONE-91-EXIT.
006390     EXIT.
006390*****************************************************************
006390*                        LETTURA TBFPI                          *
006390*****************************************************************
006390 LETTURA-TBFPI.
006390*14696INITIALIZE DCLTBFPI.
006390
006390     MOVE CG-LETAVM-COD-IST    TO FPI-COD-IST
006390     MOVE CG-LETAVM-COD-TIT    TO FPI-COD-TIT
006390     MOVE CED-DAT-DEC          TO FPI-DAT-DEC
CLTESTD    DISPLAY 'FPI-DAT-DEC  = ' FPI-DAT-DEC
006390     MOVE 'GFUWMFPI'           TO CHMO-NOM-MOD
006390     MOVE 'B'                  TO CHMO-FLG-CHI
006390
006390     MOVE DCLTBFPI             TO CHMO-DATI-INP-VAR
006390
006390     MOVE 'S1'                 TO CHMO-COD-OPE
006390     MOVE 'TBFPI S1'           TO WSN-SKB-FUNZIONE
006390     PERFORM U-X01-GEST-CALL-MOD
006390        THRU U-X01-GEST-CALL-MOD-EXIT
006390
CLTESTD    DISPLAY 'SQLCODE          = ' SQLCODE
CLTESTD    DISPLAY 'ENGIDB-RC        = ' ENGIDB-RC
CLTESTD    DISPLAY 'CHMO-DB2-COD     = ' CHMO-DB2-COD
CLTESTD    DISPLAY 'CHMO-OUT-ERR-DB2 = ' CHMO-OUT-ERR-DB2
006390     IF CHMO-RET-COD NOT = '99' AND
006390        CHMO-RET-COD NOT = '01'
006390        MOVE CHMO-DATI-OUT-VAR TO DCLTBFPI
CLTESTD    DISPLAY 'FPI-COD-IST  = ' FPI-COD-IST
CLTESTD    DISPLAY 'FPI-COD-TIT  = ' FPI-COD-TIT
CLTESTD    DISPLAY 'FPI-DAT-DEC  = ' FPI-DAT-DEC
CLTESTD    DISPLAY 'FPI_TIP_VLD  = ' FPI-TIP-VLD
CLTESTD    DISPLAY 'FPI-FAT-COR  = ' FPI-FAT-COR
CLTESTD    DISPLAY 'FPI          = ' DCLTBFPI
006390     ELSE
006390        MOVE CHMO-COD-OPE TO WSN-SKB-FUNZIONE
006390        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
006390     END-IF
006390
CLTEST*5258G     MOVE 'N'                    TO WS-TROVA-FPI
CLTEST*5258G     MOVE 0                      TO WS-P-I-FACTOR
CLTEST     IF ENGIRC-NORMAL
CLTESTD    DISPLAY 'CHMO-RET-COD     = ' CHMO-RET-COD
006390     IF FPI-FAT-COR NOT = ZEROES
006390        AND (FPI-TIP-VLD = 'C' OR FPI-TIP-VLD = 'E')
006390        MOVE 'S'         TO WS-TROVA-FPI
006390        MOVE FPI-FAT-COR TO WS-P-I-FACTOR
CLTESTD    DISPLAY 'FPI-FAT-COR N= ' FPI-FAT-COR
006390*CLTEST ELSE
CLTESTD    DISPLAY 'FPI-FAT-COR S= ' FPI-FAT-COR
006390*CLTEST MOVE 'N'     TO WS-TROVA-FPI
CLTEST     END-IF
006390     END-IF.
      *
006390 LETTURA-TBFPI-EXIT.
006390     EXIT.
008601*************************************************************
008601* VERIFICA ABILITAZIONE PERS.105 GESTIONE RIMB. PARZIALI    *
008601*************************************************************
008601 VERIFICA-ABILITAZIONE-105.
008601        MOVE 'N'                  TO WS-ABIL-PERS-105.
008601        MOVE 'GFUWMC01'           TO CHMO-NOM-MOD
008601        MOVE 'B'                  TO CHMO-FLG-CHI
008601        MOVE S-ELA-COD-IST        TO CHMO-COD-IST
008601                                     WS-PERS-COD-IST
008601        MOVE S-ELA-COD-SOC-IST    TO WS-PERS-COD-SOC-IST
008601        MOVE S-ELA-COD-FON        TO WS-PERS-COD-FON
008601        MOVE S-ELA-COD-LIN        TO WS-PERS-COD-LIN
008601        MOVE ZEROES               TO WS-PERS-COD-SGE
008601        MOVE 105                  TO WS-PERS-COD-PRS-N
008601
008601        MOVE WS-PERS              TO CHMO-DATI-INP-PRS
008601        MOVE SPACES               TO CHMO-DATI-INP-VAR
008601        PERFORM U-X01-GEST-CALL-MOD
008601        THRU    U-X01-GEST-CALL-MOD-EXIT.
008601        IF CHMO-RET-COD NOT = '99'
008601           MOVE CHMO-DATI-OUT-PRS    TO WS-PERS
008601           IF WS-PERS-FLG-OPE = 'S' AND
008601              WS-PERS-PRS-APP = 'S'
008601              MOVE 'S'             TO WS-ABIL-PERS-105
05258G              MOVE WS-PERS-CMP-DST  TO CG-P105-AREA-INP
008601* VIENE DISABILITATA LA PERS.91
008601*5258G        MOVE 'N'             TO WS-ABIL-PERS-91
008601*5258G        MOVE 'N'             TO WS-TROVA-FPI
008601           END-IF
008601        ELSE
008601           MOVE 'GFUWMC01'       TO WSN-SKB-COPY
008601           MOVE 'CALL-ESTERNA '  TO WSN-SKB-LABEL
008601           MOVE 'CALL  '         TO WSN-SKB-FUNZIONE
008601           MOVE '     '          TO WSN-SKB-TABELLA
014696           MOVE SPACES           TO WSN-SKB-CHIAVE-DATI
008601           STRING '+B' CHMO-COD-IST ' RET-COD CALL '
008601                       CHMO-RET-COD
008601           DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
008601           PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
008601        END-IF.
008601 VERIFICA-ABILITAZIONE-105-EXIT.
008601     EXIT.
008601*************************************************************
008601* CHIAMATA DINAMICA AL GFUWMC35 :                          *
008601* CALCOLA IL FATTORE DI RIDUZIONE                          *
008601*************************************************************
008601 CALL-GFUWMC35.
008601D    DISPLAY 'CALL-ESTERNA-GFUWMC35    '.
008601*8730IF WS-ABIL-PERS-105 = 'N'
008730     IF MC36-ABIL-TIT = 'N'
008730          MOVE 100 TO MC35-SQLCODE
008601          GO TO CALL-GFUWMC35-EXIT
008601     END-IF.
008601     MOVE 'GFUWMC35'           TO CHMO-NOM-MOD
008601     MOVE 'B'                  TO CHMO-FLG-CHI
008601
008601*14696INITIALIZE AREA-MC35.
008601     MOVE S-ELA-COD-IST        TO CHMO-COD-IST
008601                                  MC35-COD-IST
008730     MOVE S-ELA-COD-SOC-IST    TO MC35-COD-SOC-IST
008730     MOVE S-ELA-COD-FON        TO MC35-COD-FON
008730     MOVE S-ELA-COD-LIN        TO MC35-COD-LIN
008601     MOVE TIT-COD-TIT          TO MC35-COD-TIT
008601     MOVE 'GFUWM300'           TO MC35-NOM-PGM
008601     MOVE S-ELA-DAT-LAZ        TO MC35-DAT-ELA
008601     MOVE TIT-DAT-EMS          TO MC35-DAT-EMS
008601     MOVE WS-TIPO-OPE          TO MC35-TIP-OPE
008601* IMPOSTO CAMPI PER STACCO CEDOLA
008601     IF WS-TIPO-OPE = 'S'
008601        MOVE CED-DAT-DEC         TO MC35-DAT-DEC
008601        MOVE CED-DAT-SCD         TO MC35-DAT-SCD
008601        MOVE TIT-FRQ-GOD-CED     TO MC35-FRQ-GOD-CED
008601        MOVE TIT-BAS-CLC         TO MC35-BAS-CLC
008601        MOVE  1                  TO MC35-VAL-NMN
008601        MOVE TIT-RIT-FON         TO MC35-RIT-FON
008601        MOVE CED-TAS             TO MC35-CED-TAS
008601        MOVE TIT-DAT-RIM         TO MC35-DAT-RIM-I
014696     ELSE
014696        MOVE SPACES              TO MC35-DAT-DEC
014696        MOVE SPACES              TO MC35-DAT-SCD
014696        MOVE ZEROES              TO MC35-FRQ-GOD-CED
014696        MOVE SPACES              TO MC35-BAS-CLC
014696        MOVE ZEROES              TO MC35-VAL-NMN
014696        MOVE ZEROES              TO MC35-RIT-FON
014696        MOVE ZEROES              TO MC35-CED-TAS
014696        MOVE SPACES              TO MC35-DAT-RIM-I
008601     END-IF.
008601     IF WS-TIPO-OPE = 'P'
008601        MOVE TIT-DAT-SUC-RIM     TO  MC35-DAT-RIM-I
008601     END-IF.
008601     IF WS-TIPO-OPE = 'T'
008601        MOVE TIT-DAT-RIM         TO  MC35-DAT-RIM-I
008601     END-IF.
014696     MOVE ZEROES              TO MC35-PESO
014696     MOVE ZEROES              TO MC35-SQLCODE
014696     MOVE SPACES              TO MC35-DAT-RIM-O
014696     MOVE SPACES              TO MC35-DAT-EFF-RIM
014696     MOVE SPACES              TO MC35-AZIONE
008601     MOVE AREA-MC35            TO CHMO-DATI-INP-VAR
008601
008601     PERFORM U-X01-GEST-CALL-MOD
008601     THRU    U-X01-GEST-CALL-MOD-EXIT
008601
008601     IF CHMO-RET-COD NOT = '99'
012093     AND CHMO-RET-COD NOT = '01'
008601        MOVE CHMO-DATI-OUT-VAR    TO AREA-MC35
008601     ELSE
008601        MOVE 'CALLC35 '        TO WSN-SKB-COPY
008601        MOVE 'CALL-ESTERNA-C35'  TO WSN-SKB-LABEL
008601        MOVE '      '          TO WSN-SKB-FUNZIONE
008601        MOVE '     '           TO WSN-SKB-TABELLA
008601*14696  INITIALIZE WS-IMPO-FONDO
014696        MOVE SPACES           TO WSN-SKB-CHIAVE-DATI
008601        STRING 'COD IST ' TIT-COD-IST
008601               'COD PERS ' WS-PERS-COD-PRS
008601        DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
008601        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
008601     END-IF.
008601
008601D    DISPLAY 'AREA-MC35           ' AREA-MC35.
008601D    DISPLAY 'MC35-SQLCODE        ' MC35-SQLCODE.
008601D    DISPLAY 'MC35-PESO           ' MC35-PESO.
008601*
008601 CALL-GFUWMC35-EXIT.
008601     EXIT.
008730***********************************************************
008730* VERIFICO LA TIPOLOGIA D RIMBORSO DA APPLICARE AL TITOLO *
008730***********************************************************
008730 VERIFICA-RIMBORSO.
008730* PRIMA DI RICHIAMARE IL MODULO C35 VERIFICO SE ESISTE LA PERS 105
008730*14696MOVE S-ELA-COD-IST        TO APE-COD-IST     OF DCLTBAPE
008730*8998MOVE '00000000105'        TO APE-COD-PRS     OF DCLTBAPE
008998*14696MOVE '0000000105'         TO APE-COD-PRS     OF DCLTBAPE
008730
008730* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
008730*14696MOVE ' TBAPESL1 '      TO WSN-SKB-COPY
008730*14696MOVE ' Y01-SEL-TBAPE ' TO WSN-SKB-LABEL
008730*14696MOVE ' TBAPE '         TO WSN-SKB-TABELLA
008730*14696MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
008730*14696INITIALIZE WS-IMPO-FONDO
008730*14696MOVE  APE-COD-IST      TO WS-COD-SOC-ISTX
008730*14696PERFORM ZZZ-FORMA-CHIAVE THRU ZZZ-FORMA-CHIAVE-EXIT
008730*14696STRING WS-KEY-BANCA
008730*14696DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
008730
008730*14696PERFORM Y01-SEL-TBAPE THRU  Y01-SEL-TBAPE-EXIT
008730
108730*14696IF ENGIRC-NORMAL
014696     IF WS-PRESENZA-105-APE = 'S'
008730        PERFORM CALL-GFUWMC36
008730        THRU    CALL-GFUWMC36-EXIT
008730     ELSE
008730        MOVE 'N' TO MC36-ABIL-TIT
008730     END-IF.
      *
008730 VERIFICA-RIMBORSO-EXIT.
008730     EXIT.
014696*
014696 VERIFICA-105-APE.
014696*    VERIFICO SE ESISTE LA RIGA DI TBAPE DELLA PERS 105
014696     MOVE S-ELA-COD-IST     TO APE-COD-IST     OF DCLTBAPE
014696     MOVE '0000000105'      TO APE-COD-PRS     OF DCLTBAPE
014696
014696* IMPOSTO VARIABILI PER GESTIRE L'ERRORE BLOCCANTE SU DB2
014696     MOVE ' TBAPESL1 '      TO WSN-SKB-COPY
014696     MOVE ' Y01-SEL-TBAPE ' TO WSN-SKB-LABEL
014696     MOVE ' TBAPE '         TO WSN-SKB-TABELLA
014696     MOVE ' SELECT '        TO WSN-SKB-FUNZIONE
014696     MOVE SPACES            TO WSN-SKB-CHIAVE-DATI
014696     STRING WS-KEY-BANCA
014696     DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
014696
014696     PERFORM Y01-SEL-TBAPE THRU  Y01-SEL-TBAPE-EXIT
014696     IF ENGIRC-NORMAL
014696        MOVE 'S' TO WS-PRESENZA-105-APE
014696     ELSE
014696        MOVE 'N' TO WS-PRESENZA-105-APE
014696     END-IF.
014696 VERIFICA-105-APE-EXIT.
014696     EXIT.
008730*************************************************************
008730* CHIAMATA DINAMICA AL GFUWMC36 :                          *
008730* VERIFICA SE IL TITOLO   ABILITATO ALLA 105 O NO          *
008730*************************************************************
008730 CALL-GFUWMC36.
      *
008730D    DISPLAY 'CALL-ESTERNA-GFUWMC36    '.
008730     MOVE 'GFUWMC36'           TO CHMO-NOM-MOD
008730     MOVE 'B'                  TO CHMO-FLG-CHI
008730
008730*14696INITIALIZE AREA-MC36.
008730     MOVE S-ELA-COD-IST        TO CHMO-COD-IST
008730                                  MC36-COD-IST
008730     MOVE S-ELA-COD-SOC-IST    TO MC36-COD-SOC-IST
008730     MOVE S-ELA-COD-FON        TO MC36-COD-FON
008730     MOVE S-ELA-COD-LIN        TO MC36-COD-LIN
008730     MOVE TIT-COD-TIT          TO MC36-COD-TIT
008730     MOVE WS-ABIL-PERS-105     TO MC36-ABIL-105
014696     MOVE SPACES               TO MC36-ABIL-TIT
008730     MOVE AREA-MC36            TO CHMO-DATI-INP-VAR
008730
008730     PERFORM U-X01-GEST-CALL-MOD
008730     THRU    U-X01-GEST-CALL-MOD-EXIT
008730
008730     IF CHMO-RET-COD NOT = '99'
008730        MOVE CHMO-DATI-OUT-VAR    TO AREA-MC36
008730     ELSE
008730        MOVE 'CALLC36 '        TO WSN-SKB-COPY
008730        MOVE 'CALL-ESTERNA-C36'  TO WSN-SKB-LABEL
008730        MOVE '      '          TO WSN-SKB-FUNZIONE
008730        MOVE '     '           TO WSN-SKB-TABELLA
008730*14696  INITIALIZE WS-IMPO-FONDO
014696        MOVE SPACES            TO WSN-SKB-CHIAVE-DATI
008730        STRING 'COD IST ' TIT-COD-IST
008730               'COD PERS ' WS-PERS-COD-PRS
008730        DELIMITED BY SIZE INTO WSN-SKB-CHIAVE-DATI
008730        PERFORM Z99-ERR-DB2 THRU Z99-ERR-DB2-EX
008730     END-IF.
008730
008730D    DISPLAY 'AREA-MC36           ' AREA-MC36.
008730D    DISPLAY 'MC36-ABIL-TIT       ' MC36-ABIL-TIT.
008730*
008730 CALL-GFUWMC36-EXIT.
008730     EXIT.
05258G*****************************************************************
05258G* LETTURA DELL'INDICE DI INFLAZIONE PRESENTE IN ARCHIVIO QTZ    *
05258G*****************************************************************
05258G LETTURA-TBQTZ.
05258G*
05258G     MOVE S-ELA-COD-IST      TO  CG-LETQTZ-COD-IST    .
05258G     MOVE S-ELA-COD-SOC-IST  TO  CG-LETQTZ-COD-SOC-IST.
05258G     MOVE S-ELA-COD-FON      TO  CG-LETQTZ-COD-FON    .
05258G     MOVE CED-COD-TIT        TO  CG-LETQTZ-COD-TIT    .
05258G     MOVE 'P'                TO  CG-LETQTZ-FLG-VAL    .
05258G     MOVE S-ELA-DAT-LAZ      TO  CG-LETQTZ-DAT-QTZ    .
05258G     MOVE 'G'                TO  CG-LETQTZ-GERARCHICA .
05258G     MOVE 'Q'                TO  CG-LETQTZ-TIP-QTZ    .
05258G*
05258G     MOVE 'GFUWMC04'         TO CHMO-NOM-MOD.
05258G     PERFORM CALL-ESTERNA THRU CALL-ESTERNA-EXIT.
05258G*
05258G     IF CG-LETQTZ-CODERR = SPACES
05258G        MOVE QTZ-QTZ     TO WS-P-I-FACTOR
05258G        MOVE 'S'         TO WS-TROVA-FPI
05258G     END-IF.
05258G*
05258G LETTURA-TBQTZ-EXIT.
05258G     EXIT.
      *
21720G*******************************************
21720G*  GESTIONE STAMPA TABULATO GFUS3003      *
21720G*******************************************
21720G GEST-STAMPA-DEFAULT.
21720GD    DISPLAY 'GEST-STAMPA-DEFAULT'.
21720G*
21720G     IF WS-FLG-TST-3 = 'S'
21720G       MOVE 'N' TO WS-FLG-TST-3
21720G       PERFORM STAMPA-TESTATA-DEF
21720G          THRU STAMPA-TESTATA-DEF-EXIT
21720G       PERFORM STAMPA-DETT-DEF
21720G          THRU STAMPA-DETT-DEF-EXIT
21720G     ELSE
21720G       IF CTR-RIGHE-3 NOT < 4
21720G         PERFORM STAMPA-DETT-DEF
21720G            THRU STAMPA-DETT-DEF-EXIT
21720G       ELSE
21720G         PERFORM STAMPA-TESTATA-DEF
21720G            THRU STAMPA-TESTATA-DEF-EXIT
21720G         PERFORM STAMPA-DETT-DEF
21720G            THRU STAMPA-DETT-DEF-EXIT
21720G       END-IF
21720G     END-IF.
21720G*
21720G GEST-STAMPA-DEFAULT-EXIT.
21720G     EXIT.
21720G*
21720G STAMPA-DETT-DEF.
21720GD    DISPLAY 'STAMPA-DETT-DEF'.
21720G*
21720G     MOVE CG-LETAVM-COD-ABI-UIC     TO COD-ISIN-2.
21720G     MOVE CG-LETAVM-COD-TIT         TO COD-TIT-2.
21720G     MOVE CG-LETAVM-DSC             TO DSC-TIT-2.
21720G     MOVE TAB-PSA-QTA-TOT(PGM-IND4) TO CTV-PSA-2.
21720G*
21720G     MOVE RIGA-DETTAGLIO-2    TO RIGA-ST3-132
21720G     ADD 1                    TO NUM-RIG-STM3
21720G     MOVE WK-TXT-STM3         TO TXT-ST3
21720G     WRITE TABULATO-3 AFTER 1.
21720G*
21720G     COMPUTE CTR-RIGHE-3 = CTR-RIGHE-3 - 1.
21720G*
21720G STAMPA-DETT-DEF-EXIT.
21720G     EXIT.
21720G*
21720G STAMPA-TESTATA-DEF.
21720GD    DISPLAY 'STAMPA-TESTATA-DEF'.
21720G*
21720G     MOVE 'T'         TO FLG-TST-STM3.
21720G     MOVE WK-TXT-STM3 TO TXT-STM.
21720G     MOVE IST-NUM-RIG-PAG OF DCLTBIST TO CTR-RIGHE-3.
21720G*
21720G     MOVE SPACES                   TO COD-MSG-STM3
21720G                                      COD-TOT-RIC-STM3.
21720G     MOVE WK-TXT-STM3              TO TXT-ST3.
21720G     ADD 1                         TO WS-NUM-PAG-3.
21720G     MOVE IST-COD-IST OF DCLTBIST  TO CG-STPTES-COD-IST.
21720G     MOVE IST-DSC OF DCLTBIST      TO CG-STPTES-IST-DSC.
21720G     MOVE S-ELA-DAT-LAZ            TO CG-STPTES-DAT-PRG.
21720G     MOVE WK-STM-DSC-3             TO CG-STPTES-STM-DSC.
21720G     MOVE WS-NUM-PAG-3             TO CG-STPTES-NUM-PAG.
21720G     MOVE FND-COD-FON OF DCLTBFND  TO CG-STPTES-COD-FON.
21720G     MOVE FND-DSC OF DCLTBFND      TO CG-STPTES-FND-DSC.
21720G     MOVE LIN-COD-LIN OF DCLTBLIN  TO CG-STPTES-COD-LIN.
21720G     MOVE LIN-DSC OF DCLTBLIN      TO CG-STPTES-LIN-DSC.
21720G     MOVE ZERO                     TO CG-STPTES-COD-GES.
21720G     MOVE FND-COD-SOC-IST OF DCLTBFND TO CG-STPTES-SOC-IST.
21720G     MOVE 'GFUWM300'               TO CG-STPTES-NOM-PGM.
21720G     MOVE NUM-RIG-STM3             TO CG-STPTES-NUM-RIG.
21720G
21720G* RICHIAMO ORA LA ROUTINE TESTATA
21720G     PERFORM X01-PROD-TEST THRU X01-PROD-TEST-EXIT.
21720G
21720G     MOVE CG-STPTES-OUT-DAT-TST-1  TO RIGA-ST3-132.
21720G     MOVE CG-STPTES-OUT-COD-TST-1  TO TXT-ST3.
21720G     WRITE TABULATO-3  AFTER PAGE.
21720G
21720G     MOVE CG-STPTES-OUT-DAT-TST-2  TO RIGA-ST3-132.
21720G     MOVE CG-STPTES-OUT-COD-TST-2  TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G
21720G     MOVE CG-STPTES-OUT-DAT-TST-3  TO RIGA-ST3-132.
21720G     MOVE CG-STPTES-OUT-COD-TST-3  TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G
21720G     MOVE CG-STPTES-OUT-DAT-TST-4  TO RIGA-ST3-132.
21720G     MOVE CG-STPTES-OUT-COD-TST-4  TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G
21720G     MOVE CG-STPTES-OUT-DAT-TST-5  TO RIGA-ST3-132.
21720G     MOVE CG-STPTES-OUT-COD-TST-5  TO TXT-ST3.
21720G     MOVE TXT-ST3                  TO WK-TXT-STM3.
21720G     WRITE TABULATO-3.
21720G*
21720G     COMPUTE CTR-RIGHE-3 = IST-NUM-RIG-PAG - 5.
21720G     MOVE 1 TO FLG-TST-3.
21720G*
21720G     PERFORM STAMPA-INT-DEF
21720G        THRU STAMPA-INT-DEF-EXIT.
21720G*
21720G     MOVE SPACE            TO FLG-TST-STM3.
21720G*
21720G STAMPA-TESTATA-DEF-EXIT.
21720G     EXIT.
21720G*
21720G STAMPA-INT-DEF.
21720GD    DISPLAY 'STAMPA-INT-DEF'.
21720G*
21720G     MOVE FND-COD-FON      TO COD-FONDO-2.
21720G     MOVE FND-DSC          TO DES-FONDO-2.
21720G     MOVE LIN-COD-LIN      TO COD-LINEA-2.
21720G     MOVE LIN-DSC          TO DES-LINEA-2.
21720G*
21720G     MOVE RIGA-GEN-2       TO RIGA-ST3-132.
21720G     ADD 1                 TO NUM-RIG-STM3.
21720G     MOVE WK-TXT-STM3      TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G*
21720G     MOVE RIGO-FINALE      TO RIGA-ST3-132.
21720G     ADD 1                 TO NUM-RIG-STM3.
21720G     MOVE WK-TXT-STM3      TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G*
21720G     MOVE SPACE               TO RIGA-ST3-132.
21720G     ADD 1                    TO NUM-RIG-STM3.
21720G     MOVE WK-TXT-STM3         TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G*
21720G     MOVE SPACE               TO RIGA-ST3-132.
21720G     MOVE RIGA-INT2           TO RIGA-ST3-132.
21720G     ADD 1                    TO NUM-RIG-STM3.
21720G     MOVE WK-TXT-STM3         TO TXT-ST3.
21720G     WRITE TABULATO-3.
21720G*
21720G     COMPUTE CTR-RIGHE-3 = CTR-RIGHE-3 - 4.
21720G*
21720G STAMPA-INT-DEF-EXIT.
21720G     EXIT.
21720G*
      *****************************************************************
      *EXEC SQL INCLUDE PROCEDURE UTILIZZATE ALL'INTERNO DEL PROGRAMMA*
      *****************************************************************
      *-------------------------------------------------------*
      * --------- MEMBRI SQL----------------------------------*
      *-------------------------------------------------------*
           EXEC SQL INCLUDE GTFNDSL1  END-EXEC.
           EXEC SQL INCLUDE GTELAOC5  END-EXEC.
           EXEC SQL INCLUDE GTELAFC5  END-EXEC.
           EXEC SQL INCLUDE GTELACL5  END-EXEC.
           EXEC SQL INCLUDE GTELAUP2  END-EXEC.
           EXEC SQL INCLUDE GTLGSSL1  END-EXEC.
           EXEC SQL INCLUDE GTTITSL1  END-EXEC.
           EXEC SQL INCLUDE GTISTSL1  END-EXEC.
           EXEC SQL INCLUDE GTLINSL1  END-EXEC.
           EXEC SQL INCLUDE GTISTUP1  END-EXEC.
           EXEC SQL INCLUDE GTCCCSL2  END-EXEC.
050399     EXEC SQL INCLUDE GTCEDSL5  END-EXEC.
           EXEC SQL INCLUDE GTCEDOC4  END-EXEC.
           EXEC SQL INCLUDE GTCEDFC4  END-EXEC.
           EXEC SQL INCLUDE GTCEDCL4  END-EXEC.
           EXEC SQL INCLUDE GTCEDUP1  END-EXEC.
           EXEC SQL INCLUDE GTDIVSL1  END-EXEC.
           EXEC SQL INCLUDE GTDIVOC2  END-EXEC.
           EXEC SQL INCLUDE GTDIVFC2  END-EXEC.
           EXEC SQL INCLUDE GTDIVCL2  END-EXEC.
           EXEC SQL INCLUDE GTSEEOC1  END-EXEC.
           EXEC SQL INCLUDE GTSEEFC1  END-EXEC.
           EXEC SQL INCLUDE GTSEECL1  END-EXEC.
           EXEC SQL INCLUDE GTPSASL1  END-EXEC.
           EXEC SQL INCLUDE GTENTSL1  END-EXEC.
           EXEC SQL INCLUDE GTPAESL1  END-EXEC.
           EXEC SQL INCLUDE GTTITUP1  END-EXEC.
           EXEC SQL INCLUDE GTPSAUP1  END-EXEC.
           EXEC SQL INCLUDE GTSVMOC1  END-EXEC.
           EXEC SQL INCLUDE GTSVMFC1  END-EXEC.
           EXEC SQL INCLUDE GTSVMCL1  END-EXEC.
005717     EXEC SQL INCLUDE GTSVMUP1  END-EXEC.
MODTP *2642EXEC SQL INCLUDE GTPSAOC4  END-EXEC.
MODTP *2642EXEC SQL INCLUDE GTPSAFC4  END-EXEC.
MODTP *2642EXEC SQL INCLUDE GTPSACL4  END-EXEC.
           EXEC SQL INCLUDE GTPSAOC5  END-EXEC.
           EXEC SQL INCLUDE GTPSAFC5  END-EXEC.
           EXEC SQL INCLUDE GTPSACL5  END-EXEC.
           EXEC SQL INCLUDE GTSMOFC6  END-EXEC.
           EXEC SQL INCLUDE GTSMOOC6  END-EXEC.
           EXEC SQL INCLUDE GTSMOCL6  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOOCI  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOOCJ  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOFCI  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOFCJ  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOCLI  END-EXEC.
MODTP *    EXEC SQL INCLUDE GTSMOCLJ  END-EXEC.
           EXEC SQL INCLUDE GTSMOFC1  END-EXEC.
           EXEC SQL INCLUDE GTSMOOC1  END-EXEC.
           EXEC SQL INCLUDE GTSMOCL1  END-EXEC.
           EXEC SQL INCLUDE GTPTIOC1  END-EXEC.
           EXEC SQL INCLUDE GTPTIFC1  END-EXEC.
           EXEC SQL INCLUDE GTPTICL1  END-EXEC.
           EXEC SQL INCLUDE GTCAUSL1  END-EXEC.
           EXEC SQL INCLUDE GTCAMSL1  END-EXEC.
           EXEC SQL INCLUDE GTSTMSL1  END-EXEC.
3092       EXEC SQL INCLUDE GTNMNSL1  END-EXEC.
3092  *14696 EXEC SQL INCLUDE GTUBCHMX  END-EXEC.
014696     EXEC SQL INCLUDE GTUBCHMX  END-EXEC.
3092       EXEC SQL INCLUDE GTCALSL1  END-EXEC.
3092       EXEC SQL INCLUDE GTUSDTBO  END-EXEC.
002642     EXEC SQL INCLUDE GTUSABIL  END-EXEC.
002642     EXEC SQL INCLUDE GTSRSELA  END-EXEC.
002642     EXEC SQL INCLUDE GTELASL1  END-EXEC.
008730     EXEC SQL INCLUDE GTAPESL1  END-EXEC.
           EXEC SQL INCLUDE GTUSERDB  END-EXEC.
           EXEC SQL INCLUDE GTUSABEN  END-EXEC.
014696*    EXEC SQL INCLUDE GTUSKEY   END-EXEC.
014696     EXEC SQL INCLUDE GTUSKSTD  END-EXEC.
           EXEC SQL INCLUDE GTUSCAM2  END-EXEC.
           EXEC SQL INCLUDE GTUSCAUS  END-EXEC.
      *    EXEC SQL INCLUDE GTUSRACE  END-EXEC.
           EXEC SQL INCLUDE GTUSDSOL  END-EXEC.
002642*    EXEC SQL INCLUDE GTUSFSMO  END-EXEC.
           EXEC SQL INCLUDE GTXGDATE  END-EXEC.
           EXEC SQL INCLUDE GTUSPRIO  END-EXEC.
           EXEC SQL INCLUDE GTUSBLOX  END-EXEC.
           EXEC SQL INCLUDE GTUSTEST  END-EXEC.
005177*    EXEC SQL INCLUDE GTUCLOGE  END-EXEC.
005177*    EXEC SQL INCLUDE GTUOLOGE  END-EXEC.
005177*    EXEC SQL INCLUDE GTUPLOGE  END-EXEC.
005177*    EXEC SQL INCLUDE GTUSLOGE  END-EXEC.
           EXEC SQL INCLUDE GTERRSL1  END-EXEC.

      *   ROUTINE GENERALIZZATE PER L' EURO
           EXEC SQL INCLUDE GTUSIME2  END-EXEC.
           EXEC SQL INCLUDE GTUSBLEU  END-EXEC.
           EXEC SQL INCLUDE GTUSCEEU  END-EXEC.
           EXEC SQL INCLUDE GTUSANVM  END-EXEC.
           EXEC SQL INCLUDE GTUSANEE  END-EXEC.

290199     EXEC SQL INCLUDE GTUSSCEM  END-EXEC.
130499     EXEC SQL INCLUDE GTUSCLGG  END-EXEC.

050399     EXEC SQL INCLUDE GTUSNAZT  END-EXEC.
050399     EXEC SQL INCLUDE GTUSVESE  END-EXEC.
050399     EXEC SQL INCLUDE GTUSSTSC  END-EXEC.
050399     EXEC SQL INCLUDE GTUSSTCE  END-EXEC.
050399     EXEC SQL INCLUDE GTUSCASC  END-EXEC.
050399*    EXEC SQL INCLUDE GTUSCACE  END-EXEC.
002099     EXEC SQL INCLUDE GTMERSL1  END-EXEC.
002214     EXEC SQL INCLUDE GTUSSDME  END-EXEC.
009120     EXEC SQL INCLUDE GTSMOOCD  END-EXEC.
009120     EXEC SQL INCLUDE GTSMOFCD  END-EXEC.
009120     EXEC SQL INCLUDE GTSMOCLD  END-EXEC.
018880     EXEC SQL INCLUDE GTSMOAAH  END-EXEC.
014693     EXEC SQL INCLUDE GTSULTMO END-EXEC.
014693     EXEC SQL INCLUDE GTLINSL2  END-EXEC.
014693     EXEC SQL INCLUDE GTLINUP2  END-EXEC.
014693     EXEC SQL INCLUDE GTELASL6  END-EXEC.
05258G     EXEC SQL INCLUDE GTPERQTZ   END-EXEC.
20515G     EXEC SQL INCLUDE GTTITUP2  END-EXEC.
20515G     EXEC SQL INCLUDE GTSVMUP2  END-EXEC.
**************************** FINE  GFUWM300 ***************************

